import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Amplify.
 *
 * @stability stable
 */
export interface AmplifyAppConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#access_token AmplifyApp#access_token}.
     *
     * @stability stable
     */
    readonly accessToken?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#auto_branch_creation_patterns AmplifyApp#auto_branch_creation_patterns}.
     *
     * @stability stable
     */
    readonly autoBranchCreationPatterns?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#basic_auth_credentials AmplifyApp#basic_auth_credentials}.
     *
     * @stability stable
     */
    readonly basicAuthCredentials?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#build_spec AmplifyApp#build_spec}.
     *
     * @stability stable
     */
    readonly buildSpec?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#description AmplifyApp#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#enable_auto_branch_creation AmplifyApp#enable_auto_branch_creation}.
     *
     * @stability stable
     */
    readonly enableAutoBranchCreation?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#enable_basic_auth AmplifyApp#enable_basic_auth}.
     *
     * @stability stable
     */
    readonly enableBasicAuth?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#enable_branch_auto_build AmplifyApp#enable_branch_auto_build}.
     *
     * @stability stable
     */
    readonly enableBranchAutoBuild?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#enable_branch_auto_deletion AmplifyApp#enable_branch_auto_deletion}.
     *
     * @stability stable
     */
    readonly enableBranchAutoDeletion?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#environment_variables AmplifyApp#environment_variables}.
     *
     * @stability stable
     */
    readonly environmentVariables?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#iam_service_role_arn AmplifyApp#iam_service_role_arn}.
     *
     * @stability stable
     */
    readonly iamServiceRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#name AmplifyApp#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#oauth_token AmplifyApp#oauth_token}.
     *
     * @stability stable
     */
    readonly oauthToken?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#platform AmplifyApp#platform}.
     *
     * @stability stable
     */
    readonly platform?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#repository AmplifyApp#repository}.
     *
     * @stability stable
     */
    readonly repository?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#tags AmplifyApp#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#tags_all AmplifyApp#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * auto_branch_creation_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#auto_branch_creation_config AmplifyApp#auto_branch_creation_config}
     *
     * @stability stable
     */
    readonly autoBranchCreationConfig?: AmplifyAppAutoBranchCreationConfig;
    /**
     * custom_rule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#custom_rule AmplifyApp#custom_rule}
     *
     * @stability stable
     */
    readonly customRule?: AmplifyAppCustomRule[];
}
/**
 * @stability stable
 */
export declare class AmplifyAppProductionBranch extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get branchName(): string;
    /**
     * @stability stable
     */
    get lastDeployTime(): string;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    get thumbnailUrl(): string;
}
/**
 * @stability stable
 */
export interface AmplifyAppAutoBranchCreationConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#basic_auth_credentials AmplifyApp#basic_auth_credentials}.
     *
     * @stability stable
     */
    readonly basicAuthCredentials?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#build_spec AmplifyApp#build_spec}.
     *
     * @stability stable
     */
    readonly buildSpec?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#enable_auto_build AmplifyApp#enable_auto_build}.
     *
     * @stability stable
     */
    readonly enableAutoBuild?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#enable_basic_auth AmplifyApp#enable_basic_auth}.
     *
     * @stability stable
     */
    readonly enableBasicAuth?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#enable_performance_mode AmplifyApp#enable_performance_mode}.
     *
     * @stability stable
     */
    readonly enablePerformanceMode?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#enable_pull_request_preview AmplifyApp#enable_pull_request_preview}.
     *
     * @stability stable
     */
    readonly enablePullRequestPreview?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#environment_variables AmplifyApp#environment_variables}.
     *
     * @stability stable
     */
    readonly environmentVariables?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#framework AmplifyApp#framework}.
     *
     * @stability stable
     */
    readonly framework?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#pull_request_environment_name AmplifyApp#pull_request_environment_name}.
     *
     * @stability stable
     */
    readonly pullRequestEnvironmentName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#stage AmplifyApp#stage}.
     *
     * @stability stable
     */
    readonly stage?: string;
}
export declare function amplifyAppAutoBranchCreationConfigToTerraform(struct?: AmplifyAppAutoBranchCreationConfigOutputReference | AmplifyAppAutoBranchCreationConfig): any;
/**
 * @stability stable
 */
export declare class AmplifyAppAutoBranchCreationConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AmplifyAppAutoBranchCreationConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AmplifyAppAutoBranchCreationConfig | undefined);
    private _basicAuthCredentials?;
    /**
     * @stability stable
     */
    get basicAuthCredentials(): string;
    /**
     * @stability stable
     */
    set basicAuthCredentials(value: string);
    /**
     * @stability stable
     */
    resetBasicAuthCredentials(): void;
    /**
     * @stability stable
     */
    get basicAuthCredentialsInput(): string | undefined;
    private _buildSpec?;
    /**
     * @stability stable
     */
    get buildSpec(): string;
    /**
     * @stability stable
     */
    set buildSpec(value: string);
    /**
     * @stability stable
     */
    resetBuildSpec(): void;
    /**
     * @stability stable
     */
    get buildSpecInput(): string | undefined;
    private _enableAutoBuild?;
    /**
     * @stability stable
     */
    get enableAutoBuild(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enableAutoBuild(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnableAutoBuild(): void;
    /**
     * @stability stable
     */
    get enableAutoBuildInput(): boolean | cdktf.IResolvable | undefined;
    private _enableBasicAuth?;
    /**
     * @stability stable
     */
    get enableBasicAuth(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enableBasicAuth(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnableBasicAuth(): void;
    /**
     * @stability stable
     */
    get enableBasicAuthInput(): boolean | cdktf.IResolvable | undefined;
    private _enablePerformanceMode?;
    /**
     * @stability stable
     */
    get enablePerformanceMode(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enablePerformanceMode(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnablePerformanceMode(): void;
    /**
     * @stability stable
     */
    get enablePerformanceModeInput(): boolean | cdktf.IResolvable | undefined;
    private _enablePullRequestPreview?;
    /**
     * @stability stable
     */
    get enablePullRequestPreview(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enablePullRequestPreview(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnablePullRequestPreview(): void;
    /**
     * @stability stable
     */
    get enablePullRequestPreviewInput(): boolean | cdktf.IResolvable | undefined;
    private _environmentVariables?;
    /**
     * @stability stable
     */
    get environmentVariables(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set environmentVariables(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnvironmentVariables(): void;
    /**
     * @stability stable
     */
    get environmentVariablesInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _framework?;
    /**
     * @stability stable
     */
    get framework(): string;
    /**
     * @stability stable
     */
    set framework(value: string);
    /**
     * @stability stable
     */
    resetFramework(): void;
    /**
     * @stability stable
     */
    get frameworkInput(): string | undefined;
    private _pullRequestEnvironmentName?;
    /**
     * @stability stable
     */
    get pullRequestEnvironmentName(): string;
    /**
     * @stability stable
     */
    set pullRequestEnvironmentName(value: string);
    /**
     * @stability stable
     */
    resetPullRequestEnvironmentName(): void;
    /**
     * @stability stable
     */
    get pullRequestEnvironmentNameInput(): string | undefined;
    private _stage?;
    /**
     * @stability stable
     */
    get stage(): string;
    /**
     * @stability stable
     */
    set stage(value: string);
    /**
     * @stability stable
     */
    resetStage(): void;
    /**
     * @stability stable
     */
    get stageInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AmplifyAppCustomRule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#condition AmplifyApp#condition}.
     *
     * @stability stable
     */
    readonly condition?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#source AmplifyApp#source}.
     *
     * @stability stable
     */
    readonly source: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#status AmplifyApp#status}.
     *
     * @stability stable
     */
    readonly status?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_app#target AmplifyApp#target}.
     *
     * @stability stable
     */
    readonly target: string;
}
export declare function amplifyAppCustomRuleToTerraform(struct?: AmplifyAppCustomRule): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/amplify_app aws_amplify_app}.
 *
 * @stability stable
 */
export declare class AmplifyApp extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/amplify_app aws_amplify_app} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AmplifyAppConfig);
    private _accessToken?;
    /**
     * @stability stable
     */
    get accessToken(): string;
    /**
     * @stability stable
     */
    set accessToken(value: string);
    /**
     * @stability stable
     */
    resetAccessToken(): void;
    /**
     * @stability stable
     */
    get accessTokenInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoBranchCreationPatterns?;
    /**
     * @stability stable
     */
    get autoBranchCreationPatterns(): string[];
    /**
     * @stability stable
     */
    set autoBranchCreationPatterns(value: string[]);
    /**
     * @stability stable
     */
    resetAutoBranchCreationPatterns(): void;
    /**
     * @stability stable
     */
    get autoBranchCreationPatternsInput(): string[] | undefined;
    private _basicAuthCredentials?;
    /**
     * @stability stable
     */
    get basicAuthCredentials(): string;
    /**
     * @stability stable
     */
    set basicAuthCredentials(value: string);
    /**
     * @stability stable
     */
    resetBasicAuthCredentials(): void;
    /**
     * @stability stable
     */
    get basicAuthCredentialsInput(): string | undefined;
    private _buildSpec?;
    /**
     * @stability stable
     */
    get buildSpec(): string;
    /**
     * @stability stable
     */
    set buildSpec(value: string);
    /**
     * @stability stable
     */
    resetBuildSpec(): void;
    /**
     * @stability stable
     */
    get buildSpecInput(): string | undefined;
    /**
     * @stability stable
     */
    get defaultDomain(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _enableAutoBranchCreation?;
    /**
     * @stability stable
     */
    get enableAutoBranchCreation(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enableAutoBranchCreation(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnableAutoBranchCreation(): void;
    /**
     * @stability stable
     */
    get enableAutoBranchCreationInput(): boolean | cdktf.IResolvable | undefined;
    private _enableBasicAuth?;
    /**
     * @stability stable
     */
    get enableBasicAuth(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enableBasicAuth(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnableBasicAuth(): void;
    /**
     * @stability stable
     */
    get enableBasicAuthInput(): boolean | cdktf.IResolvable | undefined;
    private _enableBranchAutoBuild?;
    /**
     * @stability stable
     */
    get enableBranchAutoBuild(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enableBranchAutoBuild(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnableBranchAutoBuild(): void;
    /**
     * @stability stable
     */
    get enableBranchAutoBuildInput(): boolean | cdktf.IResolvable | undefined;
    private _enableBranchAutoDeletion?;
    /**
     * @stability stable
     */
    get enableBranchAutoDeletion(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enableBranchAutoDeletion(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnableBranchAutoDeletion(): void;
    /**
     * @stability stable
     */
    get enableBranchAutoDeletionInput(): boolean | cdktf.IResolvable | undefined;
    private _environmentVariables?;
    /**
     * @stability stable
     */
    get environmentVariables(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set environmentVariables(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnvironmentVariables(): void;
    /**
     * @stability stable
     */
    get environmentVariablesInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _iamServiceRoleArn?;
    /**
     * @stability stable
     */
    get iamServiceRoleArn(): string;
    /**
     * @stability stable
     */
    set iamServiceRoleArn(value: string);
    /**
     * @stability stable
     */
    resetIamServiceRoleArn(): void;
    /**
     * @stability stable
     */
    get iamServiceRoleArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _oauthToken?;
    /**
     * @stability stable
     */
    get oauthToken(): string;
    /**
     * @stability stable
     */
    set oauthToken(value: string);
    /**
     * @stability stable
     */
    resetOauthToken(): void;
    /**
     * @stability stable
     */
    get oauthTokenInput(): string | undefined;
    private _platform?;
    /**
     * @stability stable
     */
    get platform(): string;
    /**
     * @stability stable
     */
    set platform(value: string);
    /**
     * @stability stable
     */
    resetPlatform(): void;
    /**
     * @stability stable
     */
    get platformInput(): string | undefined;
    /**
     * @stability stable
     */
    productionBranch(index: string): AmplifyAppProductionBranch;
    private _repository?;
    /**
     * @stability stable
     */
    get repository(): string;
    /**
     * @stability stable
     */
    set repository(value: string);
    /**
     * @stability stable
     */
    resetRepository(): void;
    /**
     * @stability stable
     */
    get repositoryInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _autoBranchCreationConfig;
    /**
     * @stability stable
     */
    get autoBranchCreationConfig(): AmplifyAppAutoBranchCreationConfigOutputReference;
    /**
     * @stability stable
     */
    putAutoBranchCreationConfig(value: AmplifyAppAutoBranchCreationConfig): void;
    /**
     * @stability stable
     */
    resetAutoBranchCreationConfig(): void;
    /**
     * @stability stable
     */
    get autoBranchCreationConfigInput(): AmplifyAppAutoBranchCreationConfig | undefined;
    private _customRule?;
    /**
     * @stability stable
     */
    get customRule(): AmplifyAppCustomRule[];
    /**
     * @stability stable
     */
    set customRule(value: AmplifyAppCustomRule[]);
    /**
     * @stability stable
     */
    resetCustomRule(): void;
    /**
     * @stability stable
     */
    get customRuleInput(): AmplifyAppCustomRule[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
