import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Amplify.
 *
 * @stability stable
 */
export interface AmplifyBranchConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch#app_id AmplifyBranch#app_id}.
     *
     * @stability stable
     */
    readonly appId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch#backend_environment_arn AmplifyBranch#backend_environment_arn}.
     *
     * @stability stable
     */
    readonly backendEnvironmentArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch#basic_auth_credentials AmplifyBranch#basic_auth_credentials}.
     *
     * @stability stable
     */
    readonly basicAuthCredentials?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch#branch_name AmplifyBranch#branch_name}.
     *
     * @stability stable
     */
    readonly branchName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch#description AmplifyBranch#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch#display_name AmplifyBranch#display_name}.
     *
     * @stability stable
     */
    readonly displayName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch#enable_auto_build AmplifyBranch#enable_auto_build}.
     *
     * @stability stable
     */
    readonly enableAutoBuild?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch#enable_basic_auth AmplifyBranch#enable_basic_auth}.
     *
     * @stability stable
     */
    readonly enableBasicAuth?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch#enable_notification AmplifyBranch#enable_notification}.
     *
     * @stability stable
     */
    readonly enableNotification?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch#enable_performance_mode AmplifyBranch#enable_performance_mode}.
     *
     * @stability stable
     */
    readonly enablePerformanceMode?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch#enable_pull_request_preview AmplifyBranch#enable_pull_request_preview}.
     *
     * @stability stable
     */
    readonly enablePullRequestPreview?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch#environment_variables AmplifyBranch#environment_variables}.
     *
     * @stability stable
     */
    readonly environmentVariables?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch#framework AmplifyBranch#framework}.
     *
     * @stability stable
     */
    readonly framework?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch#pull_request_environment_name AmplifyBranch#pull_request_environment_name}.
     *
     * @stability stable
     */
    readonly pullRequestEnvironmentName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch#stage AmplifyBranch#stage}.
     *
     * @stability stable
     */
    readonly stage?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch#tags AmplifyBranch#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch#tags_all AmplifyBranch#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch#ttl AmplifyBranch#ttl}.
     *
     * @stability stable
     */
    readonly ttl?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch aws_amplify_branch}.
 *
 * @stability stable
 */
export declare class AmplifyBranch extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/amplify_branch aws_amplify_branch} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AmplifyBranchConfig);
    private _appId?;
    /**
     * @stability stable
     */
    get appId(): string;
    /**
     * @stability stable
     */
    set appId(value: string);
    /**
     * @stability stable
     */
    get appIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get associatedResources(): string[];
    private _backendEnvironmentArn?;
    /**
     * @stability stable
     */
    get backendEnvironmentArn(): string;
    /**
     * @stability stable
     */
    set backendEnvironmentArn(value: string);
    /**
     * @stability stable
     */
    resetBackendEnvironmentArn(): void;
    /**
     * @stability stable
     */
    get backendEnvironmentArnInput(): string | undefined;
    private _basicAuthCredentials?;
    /**
     * @stability stable
     */
    get basicAuthCredentials(): string;
    /**
     * @stability stable
     */
    set basicAuthCredentials(value: string);
    /**
     * @stability stable
     */
    resetBasicAuthCredentials(): void;
    /**
     * @stability stable
     */
    get basicAuthCredentialsInput(): string | undefined;
    private _branchName?;
    /**
     * @stability stable
     */
    get branchName(): string;
    /**
     * @stability stable
     */
    set branchName(value: string);
    /**
     * @stability stable
     */
    get branchNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get customDomains(): string[];
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get destinationBranch(): string;
    private _displayName?;
    /**
     * @stability stable
     */
    get displayName(): string;
    /**
     * @stability stable
     */
    set displayName(value: string);
    /**
     * @stability stable
     */
    resetDisplayName(): void;
    /**
     * @stability stable
     */
    get displayNameInput(): string | undefined;
    private _enableAutoBuild?;
    /**
     * @stability stable
     */
    get enableAutoBuild(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enableAutoBuild(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnableAutoBuild(): void;
    /**
     * @stability stable
     */
    get enableAutoBuildInput(): boolean | cdktf.IResolvable | undefined;
    private _enableBasicAuth?;
    /**
     * @stability stable
     */
    get enableBasicAuth(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enableBasicAuth(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnableBasicAuth(): void;
    /**
     * @stability stable
     */
    get enableBasicAuthInput(): boolean | cdktf.IResolvable | undefined;
    private _enableNotification?;
    /**
     * @stability stable
     */
    get enableNotification(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enableNotification(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnableNotification(): void;
    /**
     * @stability stable
     */
    get enableNotificationInput(): boolean | cdktf.IResolvable | undefined;
    private _enablePerformanceMode?;
    /**
     * @stability stable
     */
    get enablePerformanceMode(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enablePerformanceMode(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnablePerformanceMode(): void;
    /**
     * @stability stable
     */
    get enablePerformanceModeInput(): boolean | cdktf.IResolvable | undefined;
    private _enablePullRequestPreview?;
    /**
     * @stability stable
     */
    get enablePullRequestPreview(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enablePullRequestPreview(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnablePullRequestPreview(): void;
    /**
     * @stability stable
     */
    get enablePullRequestPreviewInput(): boolean | cdktf.IResolvable | undefined;
    private _environmentVariables?;
    /**
     * @stability stable
     */
    get environmentVariables(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set environmentVariables(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnvironmentVariables(): void;
    /**
     * @stability stable
     */
    get environmentVariablesInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _framework?;
    /**
     * @stability stable
     */
    get framework(): string;
    /**
     * @stability stable
     */
    set framework(value: string);
    /**
     * @stability stable
     */
    resetFramework(): void;
    /**
     * @stability stable
     */
    get frameworkInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _pullRequestEnvironmentName?;
    /**
     * @stability stable
     */
    get pullRequestEnvironmentName(): string;
    /**
     * @stability stable
     */
    set pullRequestEnvironmentName(value: string);
    /**
     * @stability stable
     */
    resetPullRequestEnvironmentName(): void;
    /**
     * @stability stable
     */
    get pullRequestEnvironmentNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get sourceBranch(): string;
    private _stage?;
    /**
     * @stability stable
     */
    get stage(): string;
    /**
     * @stability stable
     */
    set stage(value: string);
    /**
     * @stability stable
     */
    resetStage(): void;
    /**
     * @stability stable
     */
    get stageInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _ttl?;
    /**
     * @stability stable
     */
    get ttl(): string;
    /**
     * @stability stable
     */
    set ttl(value: string);
    /**
     * @stability stable
     */
    resetTtl(): void;
    /**
     * @stability stable
     */
    get ttlInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
