import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * API Gateway.
 *
 * @stability stable
 */
export interface ApiGatewayDomainNameConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_domain_name#certificate_arn ApiGatewayDomainName#certificate_arn}.
     *
     * @stability stable
     */
    readonly certificateArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_domain_name#certificate_body ApiGatewayDomainName#certificate_body}.
     *
     * @stability stable
     */
    readonly certificateBody?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_domain_name#certificate_chain ApiGatewayDomainName#certificate_chain}.
     *
     * @stability stable
     */
    readonly certificateChain?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_domain_name#certificate_name ApiGatewayDomainName#certificate_name}.
     *
     * @stability stable
     */
    readonly certificateName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_domain_name#certificate_private_key ApiGatewayDomainName#certificate_private_key}.
     *
     * @stability stable
     */
    readonly certificatePrivateKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_domain_name#domain_name ApiGatewayDomainName#domain_name}.
     *
     * @stability stable
     */
    readonly domainName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_domain_name#regional_certificate_arn ApiGatewayDomainName#regional_certificate_arn}.
     *
     * @stability stable
     */
    readonly regionalCertificateArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_domain_name#regional_certificate_name ApiGatewayDomainName#regional_certificate_name}.
     *
     * @stability stable
     */
    readonly regionalCertificateName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_domain_name#security_policy ApiGatewayDomainName#security_policy}.
     *
     * @stability stable
     */
    readonly securityPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_domain_name#tags ApiGatewayDomainName#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_domain_name#tags_all ApiGatewayDomainName#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * endpoint_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_domain_name#endpoint_configuration ApiGatewayDomainName#endpoint_configuration}
     *
     * @stability stable
     */
    readonly endpointConfiguration?: ApiGatewayDomainNameEndpointConfiguration;
    /**
     * mutual_tls_authentication block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_domain_name#mutual_tls_authentication ApiGatewayDomainName#mutual_tls_authentication}
     *
     * @stability stable
     */
    readonly mutualTlsAuthentication?: ApiGatewayDomainNameMutualTlsAuthentication;
}
/**
 * @stability stable
 */
export interface ApiGatewayDomainNameEndpointConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_domain_name#types ApiGatewayDomainName#types}.
     *
     * @stability stable
     */
    readonly types: string[];
}
export declare function apiGatewayDomainNameEndpointConfigurationToTerraform(struct?: ApiGatewayDomainNameEndpointConfigurationOutputReference | ApiGatewayDomainNameEndpointConfiguration): any;
/**
 * @stability stable
 */
export declare class ApiGatewayDomainNameEndpointConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): ApiGatewayDomainNameEndpointConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: ApiGatewayDomainNameEndpointConfiguration | undefined);
    private _types?;
    /**
     * @stability stable
     */
    get types(): string[];
    /**
     * @stability stable
     */
    set types(value: string[]);
    /**
     * @stability stable
     */
    get typesInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface ApiGatewayDomainNameMutualTlsAuthentication {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_domain_name#truststore_uri ApiGatewayDomainName#truststore_uri}.
     *
     * @stability stable
     */
    readonly truststoreUri: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_domain_name#truststore_version ApiGatewayDomainName#truststore_version}.
     *
     * @stability stable
     */
    readonly truststoreVersion?: string;
}
export declare function apiGatewayDomainNameMutualTlsAuthenticationToTerraform(struct?: ApiGatewayDomainNameMutualTlsAuthenticationOutputReference | ApiGatewayDomainNameMutualTlsAuthentication): any;
/**
 * @stability stable
 */
export declare class ApiGatewayDomainNameMutualTlsAuthenticationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): ApiGatewayDomainNameMutualTlsAuthentication | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: ApiGatewayDomainNameMutualTlsAuthentication | undefined);
    private _truststoreUri?;
    /**
     * @stability stable
     */
    get truststoreUri(): string;
    /**
     * @stability stable
     */
    set truststoreUri(value: string);
    /**
     * @stability stable
     */
    get truststoreUriInput(): string | undefined;
    private _truststoreVersion?;
    /**
     * @stability stable
     */
    get truststoreVersion(): string;
    /**
     * @stability stable
     */
    set truststoreVersion(value: string);
    /**
     * @stability stable
     */
    resetTruststoreVersion(): void;
    /**
     * @stability stable
     */
    get truststoreVersionInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_domain_name aws_api_gateway_domain_name}.
 *
 * @stability stable
 */
export declare class ApiGatewayDomainName extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_domain_name aws_api_gateway_domain_name} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiGatewayDomainNameConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _certificateArn?;
    /**
     * @stability stable
     */
    get certificateArn(): string;
    /**
     * @stability stable
     */
    set certificateArn(value: string);
    /**
     * @stability stable
     */
    resetCertificateArn(): void;
    /**
     * @stability stable
     */
    get certificateArnInput(): string | undefined;
    private _certificateBody?;
    /**
     * @stability stable
     */
    get certificateBody(): string;
    /**
     * @stability stable
     */
    set certificateBody(value: string);
    /**
     * @stability stable
     */
    resetCertificateBody(): void;
    /**
     * @stability stable
     */
    get certificateBodyInput(): string | undefined;
    private _certificateChain?;
    /**
     * @stability stable
     */
    get certificateChain(): string;
    /**
     * @stability stable
     */
    set certificateChain(value: string);
    /**
     * @stability stable
     */
    resetCertificateChain(): void;
    /**
     * @stability stable
     */
    get certificateChainInput(): string | undefined;
    private _certificateName?;
    /**
     * @stability stable
     */
    get certificateName(): string;
    /**
     * @stability stable
     */
    set certificateName(value: string);
    /**
     * @stability stable
     */
    resetCertificateName(): void;
    /**
     * @stability stable
     */
    get certificateNameInput(): string | undefined;
    private _certificatePrivateKey?;
    /**
     * @stability stable
     */
    get certificatePrivateKey(): string;
    /**
     * @stability stable
     */
    set certificatePrivateKey(value: string);
    /**
     * @stability stable
     */
    resetCertificatePrivateKey(): void;
    /**
     * @stability stable
     */
    get certificatePrivateKeyInput(): string | undefined;
    /**
     * @stability stable
     */
    get certificateUploadDate(): string;
    /**
     * @stability stable
     */
    get cloudfrontDomainName(): string;
    /**
     * @stability stable
     */
    get cloudfrontZoneId(): string;
    private _domainName?;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    get domainNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _regionalCertificateArn?;
    /**
     * @stability stable
     */
    get regionalCertificateArn(): string;
    /**
     * @stability stable
     */
    set regionalCertificateArn(value: string);
    /**
     * @stability stable
     */
    resetRegionalCertificateArn(): void;
    /**
     * @stability stable
     */
    get regionalCertificateArnInput(): string | undefined;
    private _regionalCertificateName?;
    /**
     * @stability stable
     */
    get regionalCertificateName(): string;
    /**
     * @stability stable
     */
    set regionalCertificateName(value: string);
    /**
     * @stability stable
     */
    resetRegionalCertificateName(): void;
    /**
     * @stability stable
     */
    get regionalCertificateNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get regionalDomainName(): string;
    /**
     * @stability stable
     */
    get regionalZoneId(): string;
    private _securityPolicy?;
    /**
     * @stability stable
     */
    get securityPolicy(): string;
    /**
     * @stability stable
     */
    set securityPolicy(value: string);
    /**
     * @stability stable
     */
    resetSecurityPolicy(): void;
    /**
     * @stability stable
     */
    get securityPolicyInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _endpointConfiguration;
    /**
     * @stability stable
     */
    get endpointConfiguration(): ApiGatewayDomainNameEndpointConfigurationOutputReference;
    /**
     * @stability stable
     */
    putEndpointConfiguration(value: ApiGatewayDomainNameEndpointConfiguration): void;
    /**
     * @stability stable
     */
    resetEndpointConfiguration(): void;
    /**
     * @stability stable
     */
    get endpointConfigurationInput(): ApiGatewayDomainNameEndpointConfiguration | undefined;
    private _mutualTlsAuthentication;
    /**
     * @stability stable
     */
    get mutualTlsAuthentication(): ApiGatewayDomainNameMutualTlsAuthenticationOutputReference;
    /**
     * @stability stable
     */
    putMutualTlsAuthentication(value: ApiGatewayDomainNameMutualTlsAuthentication): void;
    /**
     * @stability stable
     */
    resetMutualTlsAuthentication(): void;
    /**
     * @stability stable
     */
    get mutualTlsAuthenticationInput(): ApiGatewayDomainNameMutualTlsAuthentication | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
