import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * Amazon API Gateway Websocket and HTTP APIs.
 *
 * @stability stable
 */
export interface Apigatewayv2IntegrationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#api_id Apigatewayv2Integration#api_id}.
     *
     * @stability stable
     */
    readonly apiId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#connection_id Apigatewayv2Integration#connection_id}.
     *
     * @stability stable
     */
    readonly connectionId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#connection_type Apigatewayv2Integration#connection_type}.
     *
     * @stability stable
     */
    readonly connectionType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#content_handling_strategy Apigatewayv2Integration#content_handling_strategy}.
     *
     * @stability stable
     */
    readonly contentHandlingStrategy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#credentials_arn Apigatewayv2Integration#credentials_arn}.
     *
     * @stability stable
     */
    readonly credentialsArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#description Apigatewayv2Integration#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#integration_method Apigatewayv2Integration#integration_method}.
     *
     * @stability stable
     */
    readonly integrationMethod?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#integration_subtype Apigatewayv2Integration#integration_subtype}.
     *
     * @stability stable
     */
    readonly integrationSubtype?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#integration_type Apigatewayv2Integration#integration_type}.
     *
     * @stability stable
     */
    readonly integrationType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#integration_uri Apigatewayv2Integration#integration_uri}.
     *
     * @stability stable
     */
    readonly integrationUri?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#passthrough_behavior Apigatewayv2Integration#passthrough_behavior}.
     *
     * @stability stable
     */
    readonly passthroughBehavior?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#payload_format_version Apigatewayv2Integration#payload_format_version}.
     *
     * @stability stable
     */
    readonly payloadFormatVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#request_parameters Apigatewayv2Integration#request_parameters}.
     *
     * @stability stable
     */
    readonly requestParameters?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#request_templates Apigatewayv2Integration#request_templates}.
     *
     * @stability stable
     */
    readonly requestTemplates?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#template_selection_expression Apigatewayv2Integration#template_selection_expression}.
     *
     * @stability stable
     */
    readonly templateSelectionExpression?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#timeout_milliseconds Apigatewayv2Integration#timeout_milliseconds}.
     *
     * @stability stable
     */
    readonly timeoutMilliseconds?: number;
    /**
     * response_parameters block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#response_parameters Apigatewayv2Integration#response_parameters}
     *
     * @stability stable
     */
    readonly responseParameters?: Apigatewayv2IntegrationResponseParameters[];
    /**
     * tls_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#tls_config Apigatewayv2Integration#tls_config}
     *
     * @stability stable
     */
    readonly tlsConfig?: Apigatewayv2IntegrationTlsConfig;
}
/**
 * @stability stable
 */
export interface Apigatewayv2IntegrationResponseParameters {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#mappings Apigatewayv2Integration#mappings}.
     *
     * @stability stable
     */
    readonly mappings: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#status_code Apigatewayv2Integration#status_code}.
     *
     * @stability stable
     */
    readonly statusCode: string;
}
export declare function apigatewayv2IntegrationResponseParametersToTerraform(struct?: Apigatewayv2IntegrationResponseParameters): any;
/**
 * @stability stable
 */
export interface Apigatewayv2IntegrationTlsConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration#server_name_to_verify Apigatewayv2Integration#server_name_to_verify}.
     *
     * @stability stable
     */
    readonly serverNameToVerify?: string;
}
export declare function apigatewayv2IntegrationTlsConfigToTerraform(struct?: Apigatewayv2IntegrationTlsConfigOutputReference | Apigatewayv2IntegrationTlsConfig): any;
/**
 * @stability stable
 */
export declare class Apigatewayv2IntegrationTlsConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Apigatewayv2IntegrationTlsConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Apigatewayv2IntegrationTlsConfig | undefined);
    private _serverNameToVerify?;
    /**
     * @stability stable
     */
    get serverNameToVerify(): string;
    /**
     * @stability stable
     */
    set serverNameToVerify(value: string);
    /**
     * @stability stable
     */
    resetServerNameToVerify(): void;
    /**
     * @stability stable
     */
    get serverNameToVerifyInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration aws_apigatewayv2_integration}.
 *
 * @stability stable
 */
export declare class Apigatewayv2Integration extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_integration aws_apigatewayv2_integration} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Apigatewayv2IntegrationConfig);
    private _apiId?;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string | undefined;
    private _connectionId?;
    /**
     * @stability stable
     */
    get connectionId(): string;
    /**
     * @stability stable
     */
    set connectionId(value: string);
    /**
     * @stability stable
     */
    resetConnectionId(): void;
    /**
     * @stability stable
     */
    get connectionIdInput(): string | undefined;
    private _connectionType?;
    /**
     * @stability stable
     */
    get connectionType(): string;
    /**
     * @stability stable
     */
    set connectionType(value: string);
    /**
     * @stability stable
     */
    resetConnectionType(): void;
    /**
     * @stability stable
     */
    get connectionTypeInput(): string | undefined;
    private _contentHandlingStrategy?;
    /**
     * @stability stable
     */
    get contentHandlingStrategy(): string;
    /**
     * @stability stable
     */
    set contentHandlingStrategy(value: string);
    /**
     * @stability stable
     */
    resetContentHandlingStrategy(): void;
    /**
     * @stability stable
     */
    get contentHandlingStrategyInput(): string | undefined;
    private _credentialsArn?;
    /**
     * @stability stable
     */
    get credentialsArn(): string;
    /**
     * @stability stable
     */
    set credentialsArn(value: string);
    /**
     * @stability stable
     */
    resetCredentialsArn(): void;
    /**
     * @stability stable
     */
    get credentialsArnInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _integrationMethod?;
    /**
     * @stability stable
     */
    get integrationMethod(): string;
    /**
     * @stability stable
     */
    set integrationMethod(value: string);
    /**
     * @stability stable
     */
    resetIntegrationMethod(): void;
    /**
     * @stability stable
     */
    get integrationMethodInput(): string | undefined;
    /**
     * @stability stable
     */
    get integrationResponseSelectionExpression(): string;
    private _integrationSubtype?;
    /**
     * @stability stable
     */
    get integrationSubtype(): string;
    /**
     * @stability stable
     */
    set integrationSubtype(value: string);
    /**
     * @stability stable
     */
    resetIntegrationSubtype(): void;
    /**
     * @stability stable
     */
    get integrationSubtypeInput(): string | undefined;
    private _integrationType?;
    /**
     * @stability stable
     */
    get integrationType(): string;
    /**
     * @stability stable
     */
    set integrationType(value: string);
    /**
     * @stability stable
     */
    get integrationTypeInput(): string | undefined;
    private _integrationUri?;
    /**
     * @stability stable
     */
    get integrationUri(): string;
    /**
     * @stability stable
     */
    set integrationUri(value: string);
    /**
     * @stability stable
     */
    resetIntegrationUri(): void;
    /**
     * @stability stable
     */
    get integrationUriInput(): string | undefined;
    private _passthroughBehavior?;
    /**
     * @stability stable
     */
    get passthroughBehavior(): string;
    /**
     * @stability stable
     */
    set passthroughBehavior(value: string);
    /**
     * @stability stable
     */
    resetPassthroughBehavior(): void;
    /**
     * @stability stable
     */
    get passthroughBehaviorInput(): string | undefined;
    private _payloadFormatVersion?;
    /**
     * @stability stable
     */
    get payloadFormatVersion(): string;
    /**
     * @stability stable
     */
    set payloadFormatVersion(value: string);
    /**
     * @stability stable
     */
    resetPayloadFormatVersion(): void;
    /**
     * @stability stable
     */
    get payloadFormatVersionInput(): string | undefined;
    private _requestParameters?;
    /**
     * @stability stable
     */
    get requestParameters(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set requestParameters(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetRequestParameters(): void;
    /**
     * @stability stable
     */
    get requestParametersInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _requestTemplates?;
    /**
     * @stability stable
     */
    get requestTemplates(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set requestTemplates(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetRequestTemplates(): void;
    /**
     * @stability stable
     */
    get requestTemplatesInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _templateSelectionExpression?;
    /**
     * @stability stable
     */
    get templateSelectionExpression(): string;
    /**
     * @stability stable
     */
    set templateSelectionExpression(value: string);
    /**
     * @stability stable
     */
    resetTemplateSelectionExpression(): void;
    /**
     * @stability stable
     */
    get templateSelectionExpressionInput(): string | undefined;
    private _timeoutMilliseconds?;
    /**
     * @stability stable
     */
    get timeoutMilliseconds(): number;
    /**
     * @stability stable
     */
    set timeoutMilliseconds(value: number);
    /**
     * @stability stable
     */
    resetTimeoutMilliseconds(): void;
    /**
     * @stability stable
     */
    get timeoutMillisecondsInput(): number | undefined;
    private _responseParameters?;
    /**
     * @stability stable
     */
    get responseParameters(): Apigatewayv2IntegrationResponseParameters[];
    /**
     * @stability stable
     */
    set responseParameters(value: Apigatewayv2IntegrationResponseParameters[]);
    /**
     * @stability stable
     */
    resetResponseParameters(): void;
    /**
     * @stability stable
     */
    get responseParametersInput(): Apigatewayv2IntegrationResponseParameters[] | undefined;
    private _tlsConfig;
    /**
     * @stability stable
     */
    get tlsConfig(): Apigatewayv2IntegrationTlsConfigOutputReference;
    /**
     * @stability stable
     */
    putTlsConfig(value: Apigatewayv2IntegrationTlsConfig): void;
    /**
     * @stability stable
     */
    resetTlsConfig(): void;
    /**
     * @stability stable
     */
    get tlsConfigInput(): Apigatewayv2IntegrationTlsConfig | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
