import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * Amazon API Gateway Websocket and HTTP APIs.
 *
 * @stability stable
 */
export interface Apigatewayv2RouteConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route#api_id Apigatewayv2Route#api_id}.
     *
     * @stability stable
     */
    readonly apiId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route#api_key_required Apigatewayv2Route#api_key_required}.
     *
     * @stability stable
     */
    readonly apiKeyRequired?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route#authorization_scopes Apigatewayv2Route#authorization_scopes}.
     *
     * @stability stable
     */
    readonly authorizationScopes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route#authorization_type Apigatewayv2Route#authorization_type}.
     *
     * @stability stable
     */
    readonly authorizationType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route#authorizer_id Apigatewayv2Route#authorizer_id}.
     *
     * @stability stable
     */
    readonly authorizerId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route#model_selection_expression Apigatewayv2Route#model_selection_expression}.
     *
     * @stability stable
     */
    readonly modelSelectionExpression?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route#operation_name Apigatewayv2Route#operation_name}.
     *
     * @stability stable
     */
    readonly operationName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route#request_models Apigatewayv2Route#request_models}.
     *
     * @stability stable
     */
    readonly requestModels?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route#route_key Apigatewayv2Route#route_key}.
     *
     * @stability stable
     */
    readonly routeKey: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route#route_response_selection_expression Apigatewayv2Route#route_response_selection_expression}.
     *
     * @stability stable
     */
    readonly routeResponseSelectionExpression?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route#target Apigatewayv2Route#target}.
     *
     * @stability stable
     */
    readonly target?: string;
    /**
     * request_parameter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route#request_parameter Apigatewayv2Route#request_parameter}
     *
     * @stability stable
     */
    readonly requestParameter?: Apigatewayv2RouteRequestParameter[];
}
/**
 * @stability stable
 */
export interface Apigatewayv2RouteRequestParameter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route#request_parameter_key Apigatewayv2Route#request_parameter_key}.
     *
     * @stability stable
     */
    readonly requestParameterKey: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route#required Apigatewayv2Route#required}.
     *
     * @stability stable
     */
    readonly required: boolean | cdktf.IResolvable;
}
export declare function apigatewayv2RouteRequestParameterToTerraform(struct?: Apigatewayv2RouteRequestParameter): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route aws_apigatewayv2_route}.
 *
 * @stability stable
 */
export declare class Apigatewayv2Route extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/apigatewayv2_route aws_apigatewayv2_route} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Apigatewayv2RouteConfig);
    private _apiId?;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string | undefined;
    private _apiKeyRequired?;
    /**
     * @stability stable
     */
    get apiKeyRequired(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set apiKeyRequired(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetApiKeyRequired(): void;
    /**
     * @stability stable
     */
    get apiKeyRequiredInput(): boolean | cdktf.IResolvable | undefined;
    private _authorizationScopes?;
    /**
     * @stability stable
     */
    get authorizationScopes(): string[];
    /**
     * @stability stable
     */
    set authorizationScopes(value: string[]);
    /**
     * @stability stable
     */
    resetAuthorizationScopes(): void;
    /**
     * @stability stable
     */
    get authorizationScopesInput(): string[] | undefined;
    private _authorizationType?;
    /**
     * @stability stable
     */
    get authorizationType(): string;
    /**
     * @stability stable
     */
    set authorizationType(value: string);
    /**
     * @stability stable
     */
    resetAuthorizationType(): void;
    /**
     * @stability stable
     */
    get authorizationTypeInput(): string | undefined;
    private _authorizerId?;
    /**
     * @stability stable
     */
    get authorizerId(): string;
    /**
     * @stability stable
     */
    set authorizerId(value: string);
    /**
     * @stability stable
     */
    resetAuthorizerId(): void;
    /**
     * @stability stable
     */
    get authorizerIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _modelSelectionExpression?;
    /**
     * @stability stable
     */
    get modelSelectionExpression(): string;
    /**
     * @stability stable
     */
    set modelSelectionExpression(value: string);
    /**
     * @stability stable
     */
    resetModelSelectionExpression(): void;
    /**
     * @stability stable
     */
    get modelSelectionExpressionInput(): string | undefined;
    private _operationName?;
    /**
     * @stability stable
     */
    get operationName(): string;
    /**
     * @stability stable
     */
    set operationName(value: string);
    /**
     * @stability stable
     */
    resetOperationName(): void;
    /**
     * @stability stable
     */
    get operationNameInput(): string | undefined;
    private _requestModels?;
    /**
     * @stability stable
     */
    get requestModels(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set requestModels(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetRequestModels(): void;
    /**
     * @stability stable
     */
    get requestModelsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _routeKey?;
    /**
     * @stability stable
     */
    get routeKey(): string;
    /**
     * @stability stable
     */
    set routeKey(value: string);
    /**
     * @stability stable
     */
    get routeKeyInput(): string | undefined;
    private _routeResponseSelectionExpression?;
    /**
     * @stability stable
     */
    get routeResponseSelectionExpression(): string;
    /**
     * @stability stable
     */
    set routeResponseSelectionExpression(value: string);
    /**
     * @stability stable
     */
    resetRouteResponseSelectionExpression(): void;
    /**
     * @stability stable
     */
    get routeResponseSelectionExpressionInput(): string | undefined;
    private _target?;
    /**
     * @stability stable
     */
    get target(): string;
    /**
     * @stability stable
     */
    set target(value: string);
    /**
     * @stability stable
     */
    resetTarget(): void;
    /**
     * @stability stable
     */
    get targetInput(): string | undefined;
    private _requestParameter?;
    /**
     * @stability stable
     */
    get requestParameter(): Apigatewayv2RouteRequestParameter[];
    /**
     * @stability stable
     */
    set requestParameter(value: Apigatewayv2RouteRequestParameter[]);
    /**
     * @stability stable
     */
    resetRequestParameter(): void;
    /**
     * @stability stable
     */
    get requestParameterInput(): Apigatewayv2RouteRequestParameter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
