import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AppConfig.
 *
 * @stability stable
 */
export interface AppconfigDeploymentStrategyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appconfig_deployment_strategy#deployment_duration_in_minutes AppconfigDeploymentStrategy#deployment_duration_in_minutes}.
     *
     * @stability stable
     */
    readonly deploymentDurationInMinutes: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appconfig_deployment_strategy#description AppconfigDeploymentStrategy#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appconfig_deployment_strategy#final_bake_time_in_minutes AppconfigDeploymentStrategy#final_bake_time_in_minutes}.
     *
     * @stability stable
     */
    readonly finalBakeTimeInMinutes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appconfig_deployment_strategy#growth_factor AppconfigDeploymentStrategy#growth_factor}.
     *
     * @stability stable
     */
    readonly growthFactor: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appconfig_deployment_strategy#growth_type AppconfigDeploymentStrategy#growth_type}.
     *
     * @stability stable
     */
    readonly growthType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appconfig_deployment_strategy#name AppconfigDeploymentStrategy#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appconfig_deployment_strategy#replicate_to AppconfigDeploymentStrategy#replicate_to}.
     *
     * @stability stable
     */
    readonly replicateTo: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appconfig_deployment_strategy#tags AppconfigDeploymentStrategy#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appconfig_deployment_strategy#tags_all AppconfigDeploymentStrategy#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appconfig_deployment_strategy aws_appconfig_deployment_strategy}.
 *
 * @stability stable
 */
export declare class AppconfigDeploymentStrategy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appconfig_deployment_strategy aws_appconfig_deployment_strategy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppconfigDeploymentStrategyConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _deploymentDurationInMinutes?;
    /**
     * @stability stable
     */
    get deploymentDurationInMinutes(): number;
    /**
     * @stability stable
     */
    set deploymentDurationInMinutes(value: number);
    /**
     * @stability stable
     */
    get deploymentDurationInMinutesInput(): number | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _finalBakeTimeInMinutes?;
    /**
     * @stability stable
     */
    get finalBakeTimeInMinutes(): number;
    /**
     * @stability stable
     */
    set finalBakeTimeInMinutes(value: number);
    /**
     * @stability stable
     */
    resetFinalBakeTimeInMinutes(): void;
    /**
     * @stability stable
     */
    get finalBakeTimeInMinutesInput(): number | undefined;
    private _growthFactor?;
    /**
     * @stability stable
     */
    get growthFactor(): number;
    /**
     * @stability stable
     */
    set growthFactor(value: number);
    /**
     * @stability stable
     */
    get growthFactorInput(): number | undefined;
    private _growthType?;
    /**
     * @stability stable
     */
    get growthType(): string;
    /**
     * @stability stable
     */
    set growthType(value: string);
    /**
     * @stability stable
     */
    resetGrowthType(): void;
    /**
     * @stability stable
     */
    get growthTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _replicateTo?;
    /**
     * @stability stable
     */
    get replicateTo(): string;
    /**
     * @stability stable
     */
    set replicateTo(value: string);
    /**
     * @stability stable
     */
    get replicateToInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
