import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * App Mesh.
 *
 * @stability stable
 */
export interface AppmeshRouteConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#mesh_name AppmeshRoute#mesh_name}.
     *
     * @stability stable
     */
    readonly meshName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#mesh_owner AppmeshRoute#mesh_owner}.
     *
     * @stability stable
     */
    readonly meshOwner?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#name AppmeshRoute#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#tags AppmeshRoute#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#tags_all AppmeshRoute#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#virtual_router_name AppmeshRoute#virtual_router_name}.
     *
     * @stability stable
     */
    readonly virtualRouterName: string;
    /**
     * spec block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#spec AppmeshRoute#spec}
     *
     * @stability stable
     */
    readonly spec: AppmeshRouteSpec;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteActionWeightedTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#virtual_node AppmeshRoute#virtual_node}.
     *
     * @stability stable
     */
    readonly virtualNode: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#weight AppmeshRoute#weight}.
     *
     * @stability stable
     */
    readonly weight: number;
}
export declare function appmeshRouteSpecGrpcRouteActionWeightedTargetToTerraform(struct?: AppmeshRouteSpecGrpcRouteActionWeightedTarget): any;
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteAction {
    /**
     * weighted_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#weighted_target AppmeshRoute#weighted_target}
     *
     * @stability stable
     */
    readonly weightedTarget: AppmeshRouteSpecGrpcRouteActionWeightedTarget[];
}
export declare function appmeshRouteSpecGrpcRouteActionToTerraform(struct?: AppmeshRouteSpecGrpcRouteActionOutputReference | AppmeshRouteSpecGrpcRouteAction): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecGrpcRouteActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecGrpcRouteAction | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecGrpcRouteAction | undefined);
    private _weightedTarget?;
    /**
     * @stability stable
     */
    get weightedTarget(): AppmeshRouteSpecGrpcRouteActionWeightedTarget[];
    /**
     * @stability stable
     */
    set weightedTarget(value: AppmeshRouteSpecGrpcRouteActionWeightedTarget[]);
    /**
     * @stability stable
     */
    get weightedTargetInput(): AppmeshRouteSpecGrpcRouteActionWeightedTarget[] | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteMatchMetadataMatchRange {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#end AppmeshRoute#end}.
     *
     * @stability stable
     */
    readonly end: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#start AppmeshRoute#start}.
     *
     * @stability stable
     */
    readonly start: number;
}
export declare function appmeshRouteSpecGrpcRouteMatchMetadataMatchRangeToTerraform(struct?: AppmeshRouteSpecGrpcRouteMatchMetadataMatchRangeOutputReference | AppmeshRouteSpecGrpcRouteMatchMetadataMatchRange): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecGrpcRouteMatchMetadataMatchRangeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecGrpcRouteMatchMetadataMatchRange | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecGrpcRouteMatchMetadataMatchRange | undefined);
    private _end?;
    /**
     * @stability stable
     */
    get end(): number;
    /**
     * @stability stable
     */
    set end(value: number);
    /**
     * @stability stable
     */
    get endInput(): number | undefined;
    private _start?;
    /**
     * @stability stable
     */
    get start(): number;
    /**
     * @stability stable
     */
    set start(value: number);
    /**
     * @stability stable
     */
    get startInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteMatchMetadataMatch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#exact AppmeshRoute#exact}.
     *
     * @stability stable
     */
    readonly exact?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#prefix AppmeshRoute#prefix}.
     *
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#regex AppmeshRoute#regex}.
     *
     * @stability stable
     */
    readonly regex?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#suffix AppmeshRoute#suffix}.
     *
     * @stability stable
     */
    readonly suffix?: string;
    /**
     * range block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#range AppmeshRoute#range}
     *
     * @stability stable
     */
    readonly range?: AppmeshRouteSpecGrpcRouteMatchMetadataMatchRange;
}
export declare function appmeshRouteSpecGrpcRouteMatchMetadataMatchToTerraform(struct?: AppmeshRouteSpecGrpcRouteMatchMetadataMatchOutputReference | AppmeshRouteSpecGrpcRouteMatchMetadataMatch): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecGrpcRouteMatchMetadataMatchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecGrpcRouteMatchMetadataMatch | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecGrpcRouteMatchMetadataMatch | undefined);
    private _exact?;
    /**
     * @stability stable
     */
    get exact(): string;
    /**
     * @stability stable
     */
    set exact(value: string);
    /**
     * @stability stable
     */
    resetExact(): void;
    /**
     * @stability stable
     */
    get exactInput(): string | undefined;
    private _prefix?;
    /**
     * @stability stable
     */
    get prefix(): string;
    /**
     * @stability stable
     */
    set prefix(value: string);
    /**
     * @stability stable
     */
    resetPrefix(): void;
    /**
     * @stability stable
     */
    get prefixInput(): string | undefined;
    private _regex?;
    /**
     * @stability stable
     */
    get regex(): string;
    /**
     * @stability stable
     */
    set regex(value: string);
    /**
     * @stability stable
     */
    resetRegex(): void;
    /**
     * @stability stable
     */
    get regexInput(): string | undefined;
    private _suffix?;
    /**
     * @stability stable
     */
    get suffix(): string;
    /**
     * @stability stable
     */
    set suffix(value: string);
    /**
     * @stability stable
     */
    resetSuffix(): void;
    /**
     * @stability stable
     */
    get suffixInput(): string | undefined;
    private _range;
    /**
     * @stability stable
     */
    get range(): AppmeshRouteSpecGrpcRouteMatchMetadataMatchRangeOutputReference;
    /**
     * @stability stable
     */
    putRange(value: AppmeshRouteSpecGrpcRouteMatchMetadataMatchRange): void;
    /**
     * @stability stable
     */
    resetRange(): void;
    /**
     * @stability stable
     */
    get rangeInput(): AppmeshRouteSpecGrpcRouteMatchMetadataMatchRange | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteMatchMetadata {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#invert AppmeshRoute#invert}.
     *
     * @stability stable
     */
    readonly invert?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#name AppmeshRoute#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * match block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#match AppmeshRoute#match}
     *
     * @stability stable
     */
    readonly match?: AppmeshRouteSpecGrpcRouteMatchMetadataMatch;
}
export declare function appmeshRouteSpecGrpcRouteMatchMetadataToTerraform(struct?: AppmeshRouteSpecGrpcRouteMatchMetadata): any;
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteMatch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#method_name AppmeshRoute#method_name}.
     *
     * @stability stable
     */
    readonly methodName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#prefix AppmeshRoute#prefix}.
     *
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#service_name AppmeshRoute#service_name}.
     *
     * @stability stable
     */
    readonly serviceName?: string;
    /**
     * metadata block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#metadata AppmeshRoute#metadata}
     *
     * @stability stable
     */
    readonly metadata?: AppmeshRouteSpecGrpcRouteMatchMetadata[];
}
export declare function appmeshRouteSpecGrpcRouteMatchToTerraform(struct?: AppmeshRouteSpecGrpcRouteMatchOutputReference | AppmeshRouteSpecGrpcRouteMatch): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecGrpcRouteMatchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecGrpcRouteMatch | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecGrpcRouteMatch | undefined);
    private _methodName?;
    /**
     * @stability stable
     */
    get methodName(): string;
    /**
     * @stability stable
     */
    set methodName(value: string);
    /**
     * @stability stable
     */
    resetMethodName(): void;
    /**
     * @stability stable
     */
    get methodNameInput(): string | undefined;
    private _prefix?;
    /**
     * @stability stable
     */
    get prefix(): string;
    /**
     * @stability stable
     */
    set prefix(value: string);
    /**
     * @stability stable
     */
    resetPrefix(): void;
    /**
     * @stability stable
     */
    get prefixInput(): string | undefined;
    private _serviceName?;
    /**
     * @stability stable
     */
    get serviceName(): string;
    /**
     * @stability stable
     */
    set serviceName(value: string);
    /**
     * @stability stable
     */
    resetServiceName(): void;
    /**
     * @stability stable
     */
    get serviceNameInput(): string | undefined;
    private _metadata?;
    /**
     * @stability stable
     */
    get metadata(): AppmeshRouteSpecGrpcRouteMatchMetadata[];
    /**
     * @stability stable
     */
    set metadata(value: AppmeshRouteSpecGrpcRouteMatchMetadata[]);
    /**
     * @stability stable
     */
    resetMetadata(): void;
    /**
     * @stability stable
     */
    get metadataInput(): AppmeshRouteSpecGrpcRouteMatchMetadata[] | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeout {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#unit AppmeshRoute#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#value AppmeshRoute#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function appmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeoutToTerraform(struct?: AppmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeoutOutputReference | AppmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeout): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeoutOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeout | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeout | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteRetryPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#grpc_retry_events AppmeshRoute#grpc_retry_events}.
     *
     * @stability stable
     */
    readonly grpcRetryEvents?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#http_retry_events AppmeshRoute#http_retry_events}.
     *
     * @stability stable
     */
    readonly httpRetryEvents?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#max_retries AppmeshRoute#max_retries}.
     *
     * @stability stable
     */
    readonly maxRetries: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#tcp_retry_events AppmeshRoute#tcp_retry_events}.
     *
     * @stability stable
     */
    readonly tcpRetryEvents?: string[];
    /**
     * per_retry_timeout block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#per_retry_timeout AppmeshRoute#per_retry_timeout}
     *
     * @stability stable
     */
    readonly perRetryTimeout: AppmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeout;
}
export declare function appmeshRouteSpecGrpcRouteRetryPolicyToTerraform(struct?: AppmeshRouteSpecGrpcRouteRetryPolicyOutputReference | AppmeshRouteSpecGrpcRouteRetryPolicy): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecGrpcRouteRetryPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecGrpcRouteRetryPolicy | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecGrpcRouteRetryPolicy | undefined);
    private _grpcRetryEvents?;
    /**
     * @stability stable
     */
    get grpcRetryEvents(): string[];
    /**
     * @stability stable
     */
    set grpcRetryEvents(value: string[]);
    /**
     * @stability stable
     */
    resetGrpcRetryEvents(): void;
    /**
     * @stability stable
     */
    get grpcRetryEventsInput(): string[] | undefined;
    private _httpRetryEvents?;
    /**
     * @stability stable
     */
    get httpRetryEvents(): string[];
    /**
     * @stability stable
     */
    set httpRetryEvents(value: string[]);
    /**
     * @stability stable
     */
    resetHttpRetryEvents(): void;
    /**
     * @stability stable
     */
    get httpRetryEventsInput(): string[] | undefined;
    private _maxRetries?;
    /**
     * @stability stable
     */
    get maxRetries(): number;
    /**
     * @stability stable
     */
    set maxRetries(value: number);
    /**
     * @stability stable
     */
    get maxRetriesInput(): number | undefined;
    private _tcpRetryEvents?;
    /**
     * @stability stable
     */
    get tcpRetryEvents(): string[];
    /**
     * @stability stable
     */
    set tcpRetryEvents(value: string[]);
    /**
     * @stability stable
     */
    resetTcpRetryEvents(): void;
    /**
     * @stability stable
     */
    get tcpRetryEventsInput(): string[] | undefined;
    private _perRetryTimeout;
    /**
     * @stability stable
     */
    get perRetryTimeout(): AppmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeoutOutputReference;
    /**
     * @stability stable
     */
    putPerRetryTimeout(value: AppmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeout): void;
    /**
     * @stability stable
     */
    get perRetryTimeoutInput(): AppmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeout | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteTimeoutIdle {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#unit AppmeshRoute#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#value AppmeshRoute#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function appmeshRouteSpecGrpcRouteTimeoutIdleToTerraform(struct?: AppmeshRouteSpecGrpcRouteTimeoutIdleOutputReference | AppmeshRouteSpecGrpcRouteTimeoutIdle): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecGrpcRouteTimeoutIdleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecGrpcRouteTimeoutIdle | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecGrpcRouteTimeoutIdle | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteTimeoutPerRequest {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#unit AppmeshRoute#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#value AppmeshRoute#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function appmeshRouteSpecGrpcRouteTimeoutPerRequestToTerraform(struct?: AppmeshRouteSpecGrpcRouteTimeoutPerRequestOutputReference | AppmeshRouteSpecGrpcRouteTimeoutPerRequest): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecGrpcRouteTimeoutPerRequestOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecGrpcRouteTimeoutPerRequest | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecGrpcRouteTimeoutPerRequest | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteTimeout {
    /**
     * idle block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#idle AppmeshRoute#idle}
     *
     * @stability stable
     */
    readonly idle?: AppmeshRouteSpecGrpcRouteTimeoutIdle;
    /**
     * per_request block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#per_request AppmeshRoute#per_request}
     *
     * @stability stable
     */
    readonly perRequest?: AppmeshRouteSpecGrpcRouteTimeoutPerRequest;
}
export declare function appmeshRouteSpecGrpcRouteTimeoutToTerraform(struct?: AppmeshRouteSpecGrpcRouteTimeoutOutputReference | AppmeshRouteSpecGrpcRouteTimeout): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecGrpcRouteTimeoutOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecGrpcRouteTimeout | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecGrpcRouteTimeout | undefined);
    private _idle;
    /**
     * @stability stable
     */
    get idle(): AppmeshRouteSpecGrpcRouteTimeoutIdleOutputReference;
    /**
     * @stability stable
     */
    putIdle(value: AppmeshRouteSpecGrpcRouteTimeoutIdle): void;
    /**
     * @stability stable
     */
    resetIdle(): void;
    /**
     * @stability stable
     */
    get idleInput(): AppmeshRouteSpecGrpcRouteTimeoutIdle | undefined;
    private _perRequest;
    /**
     * @stability stable
     */
    get perRequest(): AppmeshRouteSpecGrpcRouteTimeoutPerRequestOutputReference;
    /**
     * @stability stable
     */
    putPerRequest(value: AppmeshRouteSpecGrpcRouteTimeoutPerRequest): void;
    /**
     * @stability stable
     */
    resetPerRequest(): void;
    /**
     * @stability stable
     */
    get perRequestInput(): AppmeshRouteSpecGrpcRouteTimeoutPerRequest | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRoute {
    /**
     * action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#action AppmeshRoute#action}
     *
     * @stability stable
     */
    readonly action: AppmeshRouteSpecGrpcRouteAction;
    /**
     * match block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#match AppmeshRoute#match}
     *
     * @stability stable
     */
    readonly match?: AppmeshRouteSpecGrpcRouteMatch;
    /**
     * retry_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#retry_policy AppmeshRoute#retry_policy}
     *
     * @stability stable
     */
    readonly retryPolicy?: AppmeshRouteSpecGrpcRouteRetryPolicy;
    /**
     * timeout block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#timeout AppmeshRoute#timeout}
     *
     * @stability stable
     */
    readonly timeout?: AppmeshRouteSpecGrpcRouteTimeout;
}
export declare function appmeshRouteSpecGrpcRouteToTerraform(struct?: AppmeshRouteSpecGrpcRouteOutputReference | AppmeshRouteSpecGrpcRoute): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecGrpcRouteOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecGrpcRoute | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecGrpcRoute | undefined);
    private _action;
    /**
     * @stability stable
     */
    get action(): AppmeshRouteSpecGrpcRouteActionOutputReference;
    /**
     * @stability stable
     */
    putAction(value: AppmeshRouteSpecGrpcRouteAction): void;
    /**
     * @stability stable
     */
    get actionInput(): AppmeshRouteSpecGrpcRouteAction | undefined;
    private _match;
    /**
     * @stability stable
     */
    get match(): AppmeshRouteSpecGrpcRouteMatchOutputReference;
    /**
     * @stability stable
     */
    putMatch(value: AppmeshRouteSpecGrpcRouteMatch): void;
    /**
     * @stability stable
     */
    resetMatch(): void;
    /**
     * @stability stable
     */
    get matchInput(): AppmeshRouteSpecGrpcRouteMatch | undefined;
    private _retryPolicy;
    /**
     * @stability stable
     */
    get retryPolicy(): AppmeshRouteSpecGrpcRouteRetryPolicyOutputReference;
    /**
     * @stability stable
     */
    putRetryPolicy(value: AppmeshRouteSpecGrpcRouteRetryPolicy): void;
    /**
     * @stability stable
     */
    resetRetryPolicy(): void;
    /**
     * @stability stable
     */
    get retryPolicyInput(): AppmeshRouteSpecGrpcRouteRetryPolicy | undefined;
    private _timeout;
    /**
     * @stability stable
     */
    get timeout(): AppmeshRouteSpecGrpcRouteTimeoutOutputReference;
    /**
     * @stability stable
     */
    putTimeout(value: AppmeshRouteSpecGrpcRouteTimeout): void;
    /**
     * @stability stable
     */
    resetTimeout(): void;
    /**
     * @stability stable
     */
    get timeoutInput(): AppmeshRouteSpecGrpcRouteTimeout | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteActionWeightedTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#virtual_node AppmeshRoute#virtual_node}.
     *
     * @stability stable
     */
    readonly virtualNode: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#weight AppmeshRoute#weight}.
     *
     * @stability stable
     */
    readonly weight: number;
}
export declare function appmeshRouteSpecHttp2RouteActionWeightedTargetToTerraform(struct?: AppmeshRouteSpecHttp2RouteActionWeightedTarget): any;
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteAction {
    /**
     * weighted_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#weighted_target AppmeshRoute#weighted_target}
     *
     * @stability stable
     */
    readonly weightedTarget: AppmeshRouteSpecHttp2RouteActionWeightedTarget[];
}
export declare function appmeshRouteSpecHttp2RouteActionToTerraform(struct?: AppmeshRouteSpecHttp2RouteActionOutputReference | AppmeshRouteSpecHttp2RouteAction): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecHttp2RouteActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecHttp2RouteAction | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecHttp2RouteAction | undefined);
    private _weightedTarget?;
    /**
     * @stability stable
     */
    get weightedTarget(): AppmeshRouteSpecHttp2RouteActionWeightedTarget[];
    /**
     * @stability stable
     */
    set weightedTarget(value: AppmeshRouteSpecHttp2RouteActionWeightedTarget[]);
    /**
     * @stability stable
     */
    get weightedTargetInput(): AppmeshRouteSpecHttp2RouteActionWeightedTarget[] | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteMatchHeaderMatchRange {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#end AppmeshRoute#end}.
     *
     * @stability stable
     */
    readonly end: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#start AppmeshRoute#start}.
     *
     * @stability stable
     */
    readonly start: number;
}
export declare function appmeshRouteSpecHttp2RouteMatchHeaderMatchRangeToTerraform(struct?: AppmeshRouteSpecHttp2RouteMatchHeaderMatchRangeOutputReference | AppmeshRouteSpecHttp2RouteMatchHeaderMatchRange): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecHttp2RouteMatchHeaderMatchRangeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecHttp2RouteMatchHeaderMatchRange | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecHttp2RouteMatchHeaderMatchRange | undefined);
    private _end?;
    /**
     * @stability stable
     */
    get end(): number;
    /**
     * @stability stable
     */
    set end(value: number);
    /**
     * @stability stable
     */
    get endInput(): number | undefined;
    private _start?;
    /**
     * @stability stable
     */
    get start(): number;
    /**
     * @stability stable
     */
    set start(value: number);
    /**
     * @stability stable
     */
    get startInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteMatchHeaderMatch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#exact AppmeshRoute#exact}.
     *
     * @stability stable
     */
    readonly exact?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#prefix AppmeshRoute#prefix}.
     *
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#regex AppmeshRoute#regex}.
     *
     * @stability stable
     */
    readonly regex?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#suffix AppmeshRoute#suffix}.
     *
     * @stability stable
     */
    readonly suffix?: string;
    /**
     * range block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#range AppmeshRoute#range}
     *
     * @stability stable
     */
    readonly range?: AppmeshRouteSpecHttp2RouteMatchHeaderMatchRange;
}
export declare function appmeshRouteSpecHttp2RouteMatchHeaderMatchToTerraform(struct?: AppmeshRouteSpecHttp2RouteMatchHeaderMatchOutputReference | AppmeshRouteSpecHttp2RouteMatchHeaderMatch): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecHttp2RouteMatchHeaderMatchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecHttp2RouteMatchHeaderMatch | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecHttp2RouteMatchHeaderMatch | undefined);
    private _exact?;
    /**
     * @stability stable
     */
    get exact(): string;
    /**
     * @stability stable
     */
    set exact(value: string);
    /**
     * @stability stable
     */
    resetExact(): void;
    /**
     * @stability stable
     */
    get exactInput(): string | undefined;
    private _prefix?;
    /**
     * @stability stable
     */
    get prefix(): string;
    /**
     * @stability stable
     */
    set prefix(value: string);
    /**
     * @stability stable
     */
    resetPrefix(): void;
    /**
     * @stability stable
     */
    get prefixInput(): string | undefined;
    private _regex?;
    /**
     * @stability stable
     */
    get regex(): string;
    /**
     * @stability stable
     */
    set regex(value: string);
    /**
     * @stability stable
     */
    resetRegex(): void;
    /**
     * @stability stable
     */
    get regexInput(): string | undefined;
    private _suffix?;
    /**
     * @stability stable
     */
    get suffix(): string;
    /**
     * @stability stable
     */
    set suffix(value: string);
    /**
     * @stability stable
     */
    resetSuffix(): void;
    /**
     * @stability stable
     */
    get suffixInput(): string | undefined;
    private _range;
    /**
     * @stability stable
     */
    get range(): AppmeshRouteSpecHttp2RouteMatchHeaderMatchRangeOutputReference;
    /**
     * @stability stable
     */
    putRange(value: AppmeshRouteSpecHttp2RouteMatchHeaderMatchRange): void;
    /**
     * @stability stable
     */
    resetRange(): void;
    /**
     * @stability stable
     */
    get rangeInput(): AppmeshRouteSpecHttp2RouteMatchHeaderMatchRange | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteMatchHeader {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#invert AppmeshRoute#invert}.
     *
     * @stability stable
     */
    readonly invert?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#name AppmeshRoute#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * match block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#match AppmeshRoute#match}
     *
     * @stability stable
     */
    readonly match?: AppmeshRouteSpecHttp2RouteMatchHeaderMatch;
}
export declare function appmeshRouteSpecHttp2RouteMatchHeaderToTerraform(struct?: AppmeshRouteSpecHttp2RouteMatchHeader): any;
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteMatch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#method AppmeshRoute#method}.
     *
     * @stability stable
     */
    readonly method?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#prefix AppmeshRoute#prefix}.
     *
     * @stability stable
     */
    readonly prefix: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#scheme AppmeshRoute#scheme}.
     *
     * @stability stable
     */
    readonly scheme?: string;
    /**
     * header block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#header AppmeshRoute#header}
     *
     * @stability stable
     */
    readonly header?: AppmeshRouteSpecHttp2RouteMatchHeader[];
}
export declare function appmeshRouteSpecHttp2RouteMatchToTerraform(struct?: AppmeshRouteSpecHttp2RouteMatchOutputReference | AppmeshRouteSpecHttp2RouteMatch): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecHttp2RouteMatchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecHttp2RouteMatch | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecHttp2RouteMatch | undefined);
    private _method?;
    /**
     * @stability stable
     */
    get method(): string;
    /**
     * @stability stable
     */
    set method(value: string);
    /**
     * @stability stable
     */
    resetMethod(): void;
    /**
     * @stability stable
     */
    get methodInput(): string | undefined;
    private _prefix?;
    /**
     * @stability stable
     */
    get prefix(): string;
    /**
     * @stability stable
     */
    set prefix(value: string);
    /**
     * @stability stable
     */
    get prefixInput(): string | undefined;
    private _scheme?;
    /**
     * @stability stable
     */
    get scheme(): string;
    /**
     * @stability stable
     */
    set scheme(value: string);
    /**
     * @stability stable
     */
    resetScheme(): void;
    /**
     * @stability stable
     */
    get schemeInput(): string | undefined;
    private _header?;
    /**
     * @stability stable
     */
    get header(): AppmeshRouteSpecHttp2RouteMatchHeader[];
    /**
     * @stability stable
     */
    set header(value: AppmeshRouteSpecHttp2RouteMatchHeader[]);
    /**
     * @stability stable
     */
    resetHeader(): void;
    /**
     * @stability stable
     */
    get headerInput(): AppmeshRouteSpecHttp2RouteMatchHeader[] | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeout {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#unit AppmeshRoute#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#value AppmeshRoute#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function appmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeoutToTerraform(struct?: AppmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeoutOutputReference | AppmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeout): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeoutOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeout | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeout | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteRetryPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#http_retry_events AppmeshRoute#http_retry_events}.
     *
     * @stability stable
     */
    readonly httpRetryEvents?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#max_retries AppmeshRoute#max_retries}.
     *
     * @stability stable
     */
    readonly maxRetries: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#tcp_retry_events AppmeshRoute#tcp_retry_events}.
     *
     * @stability stable
     */
    readonly tcpRetryEvents?: string[];
    /**
     * per_retry_timeout block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#per_retry_timeout AppmeshRoute#per_retry_timeout}
     *
     * @stability stable
     */
    readonly perRetryTimeout: AppmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeout;
}
export declare function appmeshRouteSpecHttp2RouteRetryPolicyToTerraform(struct?: AppmeshRouteSpecHttp2RouteRetryPolicyOutputReference | AppmeshRouteSpecHttp2RouteRetryPolicy): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecHttp2RouteRetryPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecHttp2RouteRetryPolicy | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecHttp2RouteRetryPolicy | undefined);
    private _httpRetryEvents?;
    /**
     * @stability stable
     */
    get httpRetryEvents(): string[];
    /**
     * @stability stable
     */
    set httpRetryEvents(value: string[]);
    /**
     * @stability stable
     */
    resetHttpRetryEvents(): void;
    /**
     * @stability stable
     */
    get httpRetryEventsInput(): string[] | undefined;
    private _maxRetries?;
    /**
     * @stability stable
     */
    get maxRetries(): number;
    /**
     * @stability stable
     */
    set maxRetries(value: number);
    /**
     * @stability stable
     */
    get maxRetriesInput(): number | undefined;
    private _tcpRetryEvents?;
    /**
     * @stability stable
     */
    get tcpRetryEvents(): string[];
    /**
     * @stability stable
     */
    set tcpRetryEvents(value: string[]);
    /**
     * @stability stable
     */
    resetTcpRetryEvents(): void;
    /**
     * @stability stable
     */
    get tcpRetryEventsInput(): string[] | undefined;
    private _perRetryTimeout;
    /**
     * @stability stable
     */
    get perRetryTimeout(): AppmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeoutOutputReference;
    /**
     * @stability stable
     */
    putPerRetryTimeout(value: AppmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeout): void;
    /**
     * @stability stable
     */
    get perRetryTimeoutInput(): AppmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeout | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteTimeoutIdle {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#unit AppmeshRoute#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#value AppmeshRoute#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function appmeshRouteSpecHttp2RouteTimeoutIdleToTerraform(struct?: AppmeshRouteSpecHttp2RouteTimeoutIdleOutputReference | AppmeshRouteSpecHttp2RouteTimeoutIdle): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecHttp2RouteTimeoutIdleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecHttp2RouteTimeoutIdle | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecHttp2RouteTimeoutIdle | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteTimeoutPerRequest {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#unit AppmeshRoute#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#value AppmeshRoute#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function appmeshRouteSpecHttp2RouteTimeoutPerRequestToTerraform(struct?: AppmeshRouteSpecHttp2RouteTimeoutPerRequestOutputReference | AppmeshRouteSpecHttp2RouteTimeoutPerRequest): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecHttp2RouteTimeoutPerRequestOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecHttp2RouteTimeoutPerRequest | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecHttp2RouteTimeoutPerRequest | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteTimeout {
    /**
     * idle block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#idle AppmeshRoute#idle}
     *
     * @stability stable
     */
    readonly idle?: AppmeshRouteSpecHttp2RouteTimeoutIdle;
    /**
     * per_request block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#per_request AppmeshRoute#per_request}
     *
     * @stability stable
     */
    readonly perRequest?: AppmeshRouteSpecHttp2RouteTimeoutPerRequest;
}
export declare function appmeshRouteSpecHttp2RouteTimeoutToTerraform(struct?: AppmeshRouteSpecHttp2RouteTimeoutOutputReference | AppmeshRouteSpecHttp2RouteTimeout): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecHttp2RouteTimeoutOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecHttp2RouteTimeout | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecHttp2RouteTimeout | undefined);
    private _idle;
    /**
     * @stability stable
     */
    get idle(): AppmeshRouteSpecHttp2RouteTimeoutIdleOutputReference;
    /**
     * @stability stable
     */
    putIdle(value: AppmeshRouteSpecHttp2RouteTimeoutIdle): void;
    /**
     * @stability stable
     */
    resetIdle(): void;
    /**
     * @stability stable
     */
    get idleInput(): AppmeshRouteSpecHttp2RouteTimeoutIdle | undefined;
    private _perRequest;
    /**
     * @stability stable
     */
    get perRequest(): AppmeshRouteSpecHttp2RouteTimeoutPerRequestOutputReference;
    /**
     * @stability stable
     */
    putPerRequest(value: AppmeshRouteSpecHttp2RouteTimeoutPerRequest): void;
    /**
     * @stability stable
     */
    resetPerRequest(): void;
    /**
     * @stability stable
     */
    get perRequestInput(): AppmeshRouteSpecHttp2RouteTimeoutPerRequest | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2Route {
    /**
     * action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#action AppmeshRoute#action}
     *
     * @stability stable
     */
    readonly action: AppmeshRouteSpecHttp2RouteAction;
    /**
     * match block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#match AppmeshRoute#match}
     *
     * @stability stable
     */
    readonly match: AppmeshRouteSpecHttp2RouteMatch;
    /**
     * retry_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#retry_policy AppmeshRoute#retry_policy}
     *
     * @stability stable
     */
    readonly retryPolicy?: AppmeshRouteSpecHttp2RouteRetryPolicy;
    /**
     * timeout block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#timeout AppmeshRoute#timeout}
     *
     * @stability stable
     */
    readonly timeout?: AppmeshRouteSpecHttp2RouteTimeout;
}
export declare function appmeshRouteSpecHttp2RouteToTerraform(struct?: AppmeshRouteSpecHttp2RouteOutputReference | AppmeshRouteSpecHttp2Route): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecHttp2RouteOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecHttp2Route | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecHttp2Route | undefined);
    private _action;
    /**
     * @stability stable
     */
    get action(): AppmeshRouteSpecHttp2RouteActionOutputReference;
    /**
     * @stability stable
     */
    putAction(value: AppmeshRouteSpecHttp2RouteAction): void;
    /**
     * @stability stable
     */
    get actionInput(): AppmeshRouteSpecHttp2RouteAction | undefined;
    private _match;
    /**
     * @stability stable
     */
    get match(): AppmeshRouteSpecHttp2RouteMatchOutputReference;
    /**
     * @stability stable
     */
    putMatch(value: AppmeshRouteSpecHttp2RouteMatch): void;
    /**
     * @stability stable
     */
    get matchInput(): AppmeshRouteSpecHttp2RouteMatch | undefined;
    private _retryPolicy;
    /**
     * @stability stable
     */
    get retryPolicy(): AppmeshRouteSpecHttp2RouteRetryPolicyOutputReference;
    /**
     * @stability stable
     */
    putRetryPolicy(value: AppmeshRouteSpecHttp2RouteRetryPolicy): void;
    /**
     * @stability stable
     */
    resetRetryPolicy(): void;
    /**
     * @stability stable
     */
    get retryPolicyInput(): AppmeshRouteSpecHttp2RouteRetryPolicy | undefined;
    private _timeout;
    /**
     * @stability stable
     */
    get timeout(): AppmeshRouteSpecHttp2RouteTimeoutOutputReference;
    /**
     * @stability stable
     */
    putTimeout(value: AppmeshRouteSpecHttp2RouteTimeout): void;
    /**
     * @stability stable
     */
    resetTimeout(): void;
    /**
     * @stability stable
     */
    get timeoutInput(): AppmeshRouteSpecHttp2RouteTimeout | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteActionWeightedTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#virtual_node AppmeshRoute#virtual_node}.
     *
     * @stability stable
     */
    readonly virtualNode: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#weight AppmeshRoute#weight}.
     *
     * @stability stable
     */
    readonly weight: number;
}
export declare function appmeshRouteSpecHttpRouteActionWeightedTargetToTerraform(struct?: AppmeshRouteSpecHttpRouteActionWeightedTarget): any;
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteAction {
    /**
     * weighted_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#weighted_target AppmeshRoute#weighted_target}
     *
     * @stability stable
     */
    readonly weightedTarget: AppmeshRouteSpecHttpRouteActionWeightedTarget[];
}
export declare function appmeshRouteSpecHttpRouteActionToTerraform(struct?: AppmeshRouteSpecHttpRouteActionOutputReference | AppmeshRouteSpecHttpRouteAction): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecHttpRouteActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecHttpRouteAction | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecHttpRouteAction | undefined);
    private _weightedTarget?;
    /**
     * @stability stable
     */
    get weightedTarget(): AppmeshRouteSpecHttpRouteActionWeightedTarget[];
    /**
     * @stability stable
     */
    set weightedTarget(value: AppmeshRouteSpecHttpRouteActionWeightedTarget[]);
    /**
     * @stability stable
     */
    get weightedTargetInput(): AppmeshRouteSpecHttpRouteActionWeightedTarget[] | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteMatchHeaderMatchRange {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#end AppmeshRoute#end}.
     *
     * @stability stable
     */
    readonly end: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#start AppmeshRoute#start}.
     *
     * @stability stable
     */
    readonly start: number;
}
export declare function appmeshRouteSpecHttpRouteMatchHeaderMatchRangeToTerraform(struct?: AppmeshRouteSpecHttpRouteMatchHeaderMatchRangeOutputReference | AppmeshRouteSpecHttpRouteMatchHeaderMatchRange): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecHttpRouteMatchHeaderMatchRangeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecHttpRouteMatchHeaderMatchRange | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecHttpRouteMatchHeaderMatchRange | undefined);
    private _end?;
    /**
     * @stability stable
     */
    get end(): number;
    /**
     * @stability stable
     */
    set end(value: number);
    /**
     * @stability stable
     */
    get endInput(): number | undefined;
    private _start?;
    /**
     * @stability stable
     */
    get start(): number;
    /**
     * @stability stable
     */
    set start(value: number);
    /**
     * @stability stable
     */
    get startInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteMatchHeaderMatch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#exact AppmeshRoute#exact}.
     *
     * @stability stable
     */
    readonly exact?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#prefix AppmeshRoute#prefix}.
     *
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#regex AppmeshRoute#regex}.
     *
     * @stability stable
     */
    readonly regex?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#suffix AppmeshRoute#suffix}.
     *
     * @stability stable
     */
    readonly suffix?: string;
    /**
     * range block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#range AppmeshRoute#range}
     *
     * @stability stable
     */
    readonly range?: AppmeshRouteSpecHttpRouteMatchHeaderMatchRange;
}
export declare function appmeshRouteSpecHttpRouteMatchHeaderMatchToTerraform(struct?: AppmeshRouteSpecHttpRouteMatchHeaderMatchOutputReference | AppmeshRouteSpecHttpRouteMatchHeaderMatch): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecHttpRouteMatchHeaderMatchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecHttpRouteMatchHeaderMatch | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecHttpRouteMatchHeaderMatch | undefined);
    private _exact?;
    /**
     * @stability stable
     */
    get exact(): string;
    /**
     * @stability stable
     */
    set exact(value: string);
    /**
     * @stability stable
     */
    resetExact(): void;
    /**
     * @stability stable
     */
    get exactInput(): string | undefined;
    private _prefix?;
    /**
     * @stability stable
     */
    get prefix(): string;
    /**
     * @stability stable
     */
    set prefix(value: string);
    /**
     * @stability stable
     */
    resetPrefix(): void;
    /**
     * @stability stable
     */
    get prefixInput(): string | undefined;
    private _regex?;
    /**
     * @stability stable
     */
    get regex(): string;
    /**
     * @stability stable
     */
    set regex(value: string);
    /**
     * @stability stable
     */
    resetRegex(): void;
    /**
     * @stability stable
     */
    get regexInput(): string | undefined;
    private _suffix?;
    /**
     * @stability stable
     */
    get suffix(): string;
    /**
     * @stability stable
     */
    set suffix(value: string);
    /**
     * @stability stable
     */
    resetSuffix(): void;
    /**
     * @stability stable
     */
    get suffixInput(): string | undefined;
    private _range;
    /**
     * @stability stable
     */
    get range(): AppmeshRouteSpecHttpRouteMatchHeaderMatchRangeOutputReference;
    /**
     * @stability stable
     */
    putRange(value: AppmeshRouteSpecHttpRouteMatchHeaderMatchRange): void;
    /**
     * @stability stable
     */
    resetRange(): void;
    /**
     * @stability stable
     */
    get rangeInput(): AppmeshRouteSpecHttpRouteMatchHeaderMatchRange | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteMatchHeader {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#invert AppmeshRoute#invert}.
     *
     * @stability stable
     */
    readonly invert?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#name AppmeshRoute#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * match block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#match AppmeshRoute#match}
     *
     * @stability stable
     */
    readonly match?: AppmeshRouteSpecHttpRouteMatchHeaderMatch;
}
export declare function appmeshRouteSpecHttpRouteMatchHeaderToTerraform(struct?: AppmeshRouteSpecHttpRouteMatchHeader): any;
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteMatch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#method AppmeshRoute#method}.
     *
     * @stability stable
     */
    readonly method?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#prefix AppmeshRoute#prefix}.
     *
     * @stability stable
     */
    readonly prefix: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#scheme AppmeshRoute#scheme}.
     *
     * @stability stable
     */
    readonly scheme?: string;
    /**
     * header block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#header AppmeshRoute#header}
     *
     * @stability stable
     */
    readonly header?: AppmeshRouteSpecHttpRouteMatchHeader[];
}
export declare function appmeshRouteSpecHttpRouteMatchToTerraform(struct?: AppmeshRouteSpecHttpRouteMatchOutputReference | AppmeshRouteSpecHttpRouteMatch): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecHttpRouteMatchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecHttpRouteMatch | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecHttpRouteMatch | undefined);
    private _method?;
    /**
     * @stability stable
     */
    get method(): string;
    /**
     * @stability stable
     */
    set method(value: string);
    /**
     * @stability stable
     */
    resetMethod(): void;
    /**
     * @stability stable
     */
    get methodInput(): string | undefined;
    private _prefix?;
    /**
     * @stability stable
     */
    get prefix(): string;
    /**
     * @stability stable
     */
    set prefix(value: string);
    /**
     * @stability stable
     */
    get prefixInput(): string | undefined;
    private _scheme?;
    /**
     * @stability stable
     */
    get scheme(): string;
    /**
     * @stability stable
     */
    set scheme(value: string);
    /**
     * @stability stable
     */
    resetScheme(): void;
    /**
     * @stability stable
     */
    get schemeInput(): string | undefined;
    private _header?;
    /**
     * @stability stable
     */
    get header(): AppmeshRouteSpecHttpRouteMatchHeader[];
    /**
     * @stability stable
     */
    set header(value: AppmeshRouteSpecHttpRouteMatchHeader[]);
    /**
     * @stability stable
     */
    resetHeader(): void;
    /**
     * @stability stable
     */
    get headerInput(): AppmeshRouteSpecHttpRouteMatchHeader[] | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeout {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#unit AppmeshRoute#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#value AppmeshRoute#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function appmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeoutToTerraform(struct?: AppmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeoutOutputReference | AppmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeout): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeoutOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeout | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeout | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteRetryPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#http_retry_events AppmeshRoute#http_retry_events}.
     *
     * @stability stable
     */
    readonly httpRetryEvents?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#max_retries AppmeshRoute#max_retries}.
     *
     * @stability stable
     */
    readonly maxRetries: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#tcp_retry_events AppmeshRoute#tcp_retry_events}.
     *
     * @stability stable
     */
    readonly tcpRetryEvents?: string[];
    /**
     * per_retry_timeout block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#per_retry_timeout AppmeshRoute#per_retry_timeout}
     *
     * @stability stable
     */
    readonly perRetryTimeout: AppmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeout;
}
export declare function appmeshRouteSpecHttpRouteRetryPolicyToTerraform(struct?: AppmeshRouteSpecHttpRouteRetryPolicyOutputReference | AppmeshRouteSpecHttpRouteRetryPolicy): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecHttpRouteRetryPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecHttpRouteRetryPolicy | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecHttpRouteRetryPolicy | undefined);
    private _httpRetryEvents?;
    /**
     * @stability stable
     */
    get httpRetryEvents(): string[];
    /**
     * @stability stable
     */
    set httpRetryEvents(value: string[]);
    /**
     * @stability stable
     */
    resetHttpRetryEvents(): void;
    /**
     * @stability stable
     */
    get httpRetryEventsInput(): string[] | undefined;
    private _maxRetries?;
    /**
     * @stability stable
     */
    get maxRetries(): number;
    /**
     * @stability stable
     */
    set maxRetries(value: number);
    /**
     * @stability stable
     */
    get maxRetriesInput(): number | undefined;
    private _tcpRetryEvents?;
    /**
     * @stability stable
     */
    get tcpRetryEvents(): string[];
    /**
     * @stability stable
     */
    set tcpRetryEvents(value: string[]);
    /**
     * @stability stable
     */
    resetTcpRetryEvents(): void;
    /**
     * @stability stable
     */
    get tcpRetryEventsInput(): string[] | undefined;
    private _perRetryTimeout;
    /**
     * @stability stable
     */
    get perRetryTimeout(): AppmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeoutOutputReference;
    /**
     * @stability stable
     */
    putPerRetryTimeout(value: AppmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeout): void;
    /**
     * @stability stable
     */
    get perRetryTimeoutInput(): AppmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeout | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteTimeoutIdle {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#unit AppmeshRoute#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#value AppmeshRoute#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function appmeshRouteSpecHttpRouteTimeoutIdleToTerraform(struct?: AppmeshRouteSpecHttpRouteTimeoutIdleOutputReference | AppmeshRouteSpecHttpRouteTimeoutIdle): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecHttpRouteTimeoutIdleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecHttpRouteTimeoutIdle | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecHttpRouteTimeoutIdle | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteTimeoutPerRequest {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#unit AppmeshRoute#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#value AppmeshRoute#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function appmeshRouteSpecHttpRouteTimeoutPerRequestToTerraform(struct?: AppmeshRouteSpecHttpRouteTimeoutPerRequestOutputReference | AppmeshRouteSpecHttpRouteTimeoutPerRequest): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecHttpRouteTimeoutPerRequestOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecHttpRouteTimeoutPerRequest | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecHttpRouteTimeoutPerRequest | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteTimeout {
    /**
     * idle block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#idle AppmeshRoute#idle}
     *
     * @stability stable
     */
    readonly idle?: AppmeshRouteSpecHttpRouteTimeoutIdle;
    /**
     * per_request block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#per_request AppmeshRoute#per_request}
     *
     * @stability stable
     */
    readonly perRequest?: AppmeshRouteSpecHttpRouteTimeoutPerRequest;
}
export declare function appmeshRouteSpecHttpRouteTimeoutToTerraform(struct?: AppmeshRouteSpecHttpRouteTimeoutOutputReference | AppmeshRouteSpecHttpRouteTimeout): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecHttpRouteTimeoutOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecHttpRouteTimeout | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecHttpRouteTimeout | undefined);
    private _idle;
    /**
     * @stability stable
     */
    get idle(): AppmeshRouteSpecHttpRouteTimeoutIdleOutputReference;
    /**
     * @stability stable
     */
    putIdle(value: AppmeshRouteSpecHttpRouteTimeoutIdle): void;
    /**
     * @stability stable
     */
    resetIdle(): void;
    /**
     * @stability stable
     */
    get idleInput(): AppmeshRouteSpecHttpRouteTimeoutIdle | undefined;
    private _perRequest;
    /**
     * @stability stable
     */
    get perRequest(): AppmeshRouteSpecHttpRouteTimeoutPerRequestOutputReference;
    /**
     * @stability stable
     */
    putPerRequest(value: AppmeshRouteSpecHttpRouteTimeoutPerRequest): void;
    /**
     * @stability stable
     */
    resetPerRequest(): void;
    /**
     * @stability stable
     */
    get perRequestInput(): AppmeshRouteSpecHttpRouteTimeoutPerRequest | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRoute {
    /**
     * action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#action AppmeshRoute#action}
     *
     * @stability stable
     */
    readonly action: AppmeshRouteSpecHttpRouteAction;
    /**
     * match block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#match AppmeshRoute#match}
     *
     * @stability stable
     */
    readonly match: AppmeshRouteSpecHttpRouteMatch;
    /**
     * retry_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#retry_policy AppmeshRoute#retry_policy}
     *
     * @stability stable
     */
    readonly retryPolicy?: AppmeshRouteSpecHttpRouteRetryPolicy;
    /**
     * timeout block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#timeout AppmeshRoute#timeout}
     *
     * @stability stable
     */
    readonly timeout?: AppmeshRouteSpecHttpRouteTimeout;
}
export declare function appmeshRouteSpecHttpRouteToTerraform(struct?: AppmeshRouteSpecHttpRouteOutputReference | AppmeshRouteSpecHttpRoute): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecHttpRouteOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecHttpRoute | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecHttpRoute | undefined);
    private _action;
    /**
     * @stability stable
     */
    get action(): AppmeshRouteSpecHttpRouteActionOutputReference;
    /**
     * @stability stable
     */
    putAction(value: AppmeshRouteSpecHttpRouteAction): void;
    /**
     * @stability stable
     */
    get actionInput(): AppmeshRouteSpecHttpRouteAction | undefined;
    private _match;
    /**
     * @stability stable
     */
    get match(): AppmeshRouteSpecHttpRouteMatchOutputReference;
    /**
     * @stability stable
     */
    putMatch(value: AppmeshRouteSpecHttpRouteMatch): void;
    /**
     * @stability stable
     */
    get matchInput(): AppmeshRouteSpecHttpRouteMatch | undefined;
    private _retryPolicy;
    /**
     * @stability stable
     */
    get retryPolicy(): AppmeshRouteSpecHttpRouteRetryPolicyOutputReference;
    /**
     * @stability stable
     */
    putRetryPolicy(value: AppmeshRouteSpecHttpRouteRetryPolicy): void;
    /**
     * @stability stable
     */
    resetRetryPolicy(): void;
    /**
     * @stability stable
     */
    get retryPolicyInput(): AppmeshRouteSpecHttpRouteRetryPolicy | undefined;
    private _timeout;
    /**
     * @stability stable
     */
    get timeout(): AppmeshRouteSpecHttpRouteTimeoutOutputReference;
    /**
     * @stability stable
     */
    putTimeout(value: AppmeshRouteSpecHttpRouteTimeout): void;
    /**
     * @stability stable
     */
    resetTimeout(): void;
    /**
     * @stability stable
     */
    get timeoutInput(): AppmeshRouteSpecHttpRouteTimeout | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecTcpRouteActionWeightedTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#virtual_node AppmeshRoute#virtual_node}.
     *
     * @stability stable
     */
    readonly virtualNode: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#weight AppmeshRoute#weight}.
     *
     * @stability stable
     */
    readonly weight: number;
}
export declare function appmeshRouteSpecTcpRouteActionWeightedTargetToTerraform(struct?: AppmeshRouteSpecTcpRouteActionWeightedTarget): any;
/**
 * @stability stable
 */
export interface AppmeshRouteSpecTcpRouteAction {
    /**
     * weighted_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#weighted_target AppmeshRoute#weighted_target}
     *
     * @stability stable
     */
    readonly weightedTarget: AppmeshRouteSpecTcpRouteActionWeightedTarget[];
}
export declare function appmeshRouteSpecTcpRouteActionToTerraform(struct?: AppmeshRouteSpecTcpRouteActionOutputReference | AppmeshRouteSpecTcpRouteAction): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecTcpRouteActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecTcpRouteAction | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecTcpRouteAction | undefined);
    private _weightedTarget?;
    /**
     * @stability stable
     */
    get weightedTarget(): AppmeshRouteSpecTcpRouteActionWeightedTarget[];
    /**
     * @stability stable
     */
    set weightedTarget(value: AppmeshRouteSpecTcpRouteActionWeightedTarget[]);
    /**
     * @stability stable
     */
    get weightedTargetInput(): AppmeshRouteSpecTcpRouteActionWeightedTarget[] | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecTcpRouteTimeoutIdle {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#unit AppmeshRoute#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#value AppmeshRoute#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function appmeshRouteSpecTcpRouteTimeoutIdleToTerraform(struct?: AppmeshRouteSpecTcpRouteTimeoutIdleOutputReference | AppmeshRouteSpecTcpRouteTimeoutIdle): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecTcpRouteTimeoutIdleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecTcpRouteTimeoutIdle | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecTcpRouteTimeoutIdle | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecTcpRouteTimeout {
    /**
     * idle block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#idle AppmeshRoute#idle}
     *
     * @stability stable
     */
    readonly idle?: AppmeshRouteSpecTcpRouteTimeoutIdle;
}
export declare function appmeshRouteSpecTcpRouteTimeoutToTerraform(struct?: AppmeshRouteSpecTcpRouteTimeoutOutputReference | AppmeshRouteSpecTcpRouteTimeout): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecTcpRouteTimeoutOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecTcpRouteTimeout | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecTcpRouteTimeout | undefined);
    private _idle;
    /**
     * @stability stable
     */
    get idle(): AppmeshRouteSpecTcpRouteTimeoutIdleOutputReference;
    /**
     * @stability stable
     */
    putIdle(value: AppmeshRouteSpecTcpRouteTimeoutIdle): void;
    /**
     * @stability stable
     */
    resetIdle(): void;
    /**
     * @stability stable
     */
    get idleInput(): AppmeshRouteSpecTcpRouteTimeoutIdle | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecTcpRoute {
    /**
     * action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#action AppmeshRoute#action}
     *
     * @stability stable
     */
    readonly action: AppmeshRouteSpecTcpRouteAction;
    /**
     * timeout block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#timeout AppmeshRoute#timeout}
     *
     * @stability stable
     */
    readonly timeout?: AppmeshRouteSpecTcpRouteTimeout;
}
export declare function appmeshRouteSpecTcpRouteToTerraform(struct?: AppmeshRouteSpecTcpRouteOutputReference | AppmeshRouteSpecTcpRoute): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecTcpRouteOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpecTcpRoute | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpecTcpRoute | undefined);
    private _action;
    /**
     * @stability stable
     */
    get action(): AppmeshRouteSpecTcpRouteActionOutputReference;
    /**
     * @stability stable
     */
    putAction(value: AppmeshRouteSpecTcpRouteAction): void;
    /**
     * @stability stable
     */
    get actionInput(): AppmeshRouteSpecTcpRouteAction | undefined;
    private _timeout;
    /**
     * @stability stable
     */
    get timeout(): AppmeshRouteSpecTcpRouteTimeoutOutputReference;
    /**
     * @stability stable
     */
    putTimeout(value: AppmeshRouteSpecTcpRouteTimeout): void;
    /**
     * @stability stable
     */
    resetTimeout(): void;
    /**
     * @stability stable
     */
    get timeoutInput(): AppmeshRouteSpecTcpRouteTimeout | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpec {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#priority AppmeshRoute#priority}.
     *
     * @stability stable
     */
    readonly priority?: number;
    /**
     * grpc_route block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#grpc_route AppmeshRoute#grpc_route}
     *
     * @stability stable
     */
    readonly grpcRoute?: AppmeshRouteSpecGrpcRoute;
    /**
     * http2_route block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#http2_route AppmeshRoute#http2_route}
     *
     * @stability stable
     */
    readonly http2Route?: AppmeshRouteSpecHttp2Route;
    /**
     * http_route block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#http_route AppmeshRoute#http_route}
     *
     * @stability stable
     */
    readonly httpRoute?: AppmeshRouteSpecHttpRoute;
    /**
     * tcp_route block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route#tcp_route AppmeshRoute#tcp_route}
     *
     * @stability stable
     */
    readonly tcpRoute?: AppmeshRouteSpecTcpRoute;
}
export declare function appmeshRouteSpecToTerraform(struct?: AppmeshRouteSpecOutputReference | AppmeshRouteSpec): any;
/**
 * @stability stable
 */
export declare class AppmeshRouteSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshRouteSpec | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshRouteSpec | undefined);
    private _priority?;
    /**
     * @stability stable
     */
    get priority(): number;
    /**
     * @stability stable
     */
    set priority(value: number);
    /**
     * @stability stable
     */
    resetPriority(): void;
    /**
     * @stability stable
     */
    get priorityInput(): number | undefined;
    private _grpcRoute;
    /**
     * @stability stable
     */
    get grpcRoute(): AppmeshRouteSpecGrpcRouteOutputReference;
    /**
     * @stability stable
     */
    putGrpcRoute(value: AppmeshRouteSpecGrpcRoute): void;
    /**
     * @stability stable
     */
    resetGrpcRoute(): void;
    /**
     * @stability stable
     */
    get grpcRouteInput(): AppmeshRouteSpecGrpcRoute | undefined;
    private _http2Route;
    /**
     * @stability stable
     */
    get http2Route(): AppmeshRouteSpecHttp2RouteOutputReference;
    /**
     * @stability stable
     */
    putHttp2Route(value: AppmeshRouteSpecHttp2Route): void;
    /**
     * @stability stable
     */
    resetHttp2Route(): void;
    /**
     * @stability stable
     */
    get http2RouteInput(): AppmeshRouteSpecHttp2Route | undefined;
    private _httpRoute;
    /**
     * @stability stable
     */
    get httpRoute(): AppmeshRouteSpecHttpRouteOutputReference;
    /**
     * @stability stable
     */
    putHttpRoute(value: AppmeshRouteSpecHttpRoute): void;
    /**
     * @stability stable
     */
    resetHttpRoute(): void;
    /**
     * @stability stable
     */
    get httpRouteInput(): AppmeshRouteSpecHttpRoute | undefined;
    private _tcpRoute;
    /**
     * @stability stable
     */
    get tcpRoute(): AppmeshRouteSpecTcpRouteOutputReference;
    /**
     * @stability stable
     */
    putTcpRoute(value: AppmeshRouteSpecTcpRoute): void;
    /**
     * @stability stable
     */
    resetTcpRoute(): void;
    /**
     * @stability stable
     */
    get tcpRouteInput(): AppmeshRouteSpecTcpRoute | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route aws_appmesh_route}.
 *
 * @stability stable
 */
export declare class AppmeshRoute extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appmesh_route aws_appmesh_route} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppmeshRouteConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get createdDate(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedDate(): string;
    private _meshName?;
    /**
     * @stability stable
     */
    get meshName(): string;
    /**
     * @stability stable
     */
    set meshName(value: string);
    /**
     * @stability stable
     */
    get meshNameInput(): string | undefined;
    private _meshOwner?;
    /**
     * @stability stable
     */
    get meshOwner(): string;
    /**
     * @stability stable
     */
    set meshOwner(value: string);
    /**
     * @stability stable
     */
    resetMeshOwner(): void;
    /**
     * @stability stable
     */
    get meshOwnerInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get resourceOwner(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _virtualRouterName?;
    /**
     * @stability stable
     */
    get virtualRouterName(): string;
    /**
     * @stability stable
     */
    set virtualRouterName(value: string);
    /**
     * @stability stable
     */
    get virtualRouterNameInput(): string | undefined;
    private _spec;
    /**
     * @stability stable
     */
    get spec(): AppmeshRouteSpecOutputReference;
    /**
     * @stability stable
     */
    putSpec(value: AppmeshRouteSpec): void;
    /**
     * @stability stable
     */
    get specInput(): AppmeshRouteSpec | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
