import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * App Mesh.
 *
 * @stability stable
 */
export interface AppmeshVirtualNodeConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#mesh_name AppmeshVirtualNode#mesh_name}.
     *
     * @stability stable
     */
    readonly meshName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#mesh_owner AppmeshVirtualNode#mesh_owner}.
     *
     * @stability stable
     */
    readonly meshOwner?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#name AppmeshVirtualNode#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#tags AppmeshVirtualNode#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#tags_all AppmeshVirtualNode#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * spec block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#spec AppmeshVirtualNode#spec}
     *
     * @stability stable
     */
    readonly spec: AppmeshVirtualNodeSpec;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateFile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#certificate_chain AppmeshVirtualNode#certificate_chain}.
     *
     * @stability stable
     */
    readonly certificateChain: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#private_key AppmeshVirtualNode#private_key}.
     *
     * @stability stable
     */
    readonly privateKey: string;
}
export declare function appmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateFileToTerraform(struct?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateFileOutputReference | AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateFile): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateFileOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateFile | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateFile | undefined);
    private _certificateChain?;
    /**
     * @stability stable
     */
    get certificateChain(): string;
    /**
     * @stability stable
     */
    set certificateChain(value: string);
    /**
     * @stability stable
     */
    get certificateChainInput(): string | undefined;
    private _privateKey?;
    /**
     * @stability stable
     */
    get privateKey(): string;
    /**
     * @stability stable
     */
    set privateKey(value: string);
    /**
     * @stability stable
     */
    get privateKeyInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateSds {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#secret_name AppmeshVirtualNode#secret_name}.
     *
     * @stability stable
     */
    readonly secretName: string;
}
export declare function appmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateSdsToTerraform(struct?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateSdsOutputReference | AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateSds): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateSdsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateSds | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateSds | undefined);
    private _secretName?;
    /**
     * @stability stable
     */
    get secretName(): string;
    /**
     * @stability stable
     */
    set secretName(value: string);
    /**
     * @stability stable
     */
    get secretNameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificate {
    /**
     * file block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#file AppmeshVirtualNode#file}
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateFile;
    /**
     * sds block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#sds AppmeshVirtualNode#sds}
     *
     * @stability stable
     */
    readonly sds?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateSds;
}
export declare function appmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateToTerraform(struct?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateOutputReference | AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificate): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificate | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificate | undefined);
    private _file;
    /**
     * @stability stable
     */
    get file(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateFileOutputReference;
    /**
     * @stability stable
     */
    putFile(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateFile): void;
    /**
     * @stability stable
     */
    resetFile(): void;
    /**
     * @stability stable
     */
    get fileInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateFile | undefined;
    private _sds;
    /**
     * @stability stable
     */
    get sds(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateSdsOutputReference;
    /**
     * @stability stable
     */
    putSds(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateSds): void;
    /**
     * @stability stable
     */
    resetSds(): void;
    /**
     * @stability stable
     */
    get sdsInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateSds | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesMatch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#exact AppmeshVirtualNode#exact}.
     *
     * @stability stable
     */
    readonly exact: string[];
}
export declare function appmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesMatchToTerraform(struct?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesMatchOutputReference | AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesMatch): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesMatchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesMatch | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesMatch | undefined);
    private _exact?;
    /**
     * @stability stable
     */
    get exact(): string[];
    /**
     * @stability stable
     */
    set exact(value: string[]);
    /**
     * @stability stable
     */
    get exactInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNames {
    /**
     * match block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#match AppmeshVirtualNode#match}
     *
     * @stability stable
     */
    readonly match: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesMatch;
}
export declare function appmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesToTerraform(struct?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesOutputReference | AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNames): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNames | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNames | undefined);
    private _match;
    /**
     * @stability stable
     */
    get match(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesMatchOutputReference;
    /**
     * @stability stable
     */
    putMatch(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesMatch): void;
    /**
     * @stability stable
     */
    get matchInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesMatch | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustAcm {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#certificate_authority_arns AppmeshVirtualNode#certificate_authority_arns}.
     *
     * @stability stable
     */
    readonly certificateAuthorityArns: string[];
}
export declare function appmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustAcmToTerraform(struct?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustAcmOutputReference | AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustAcm): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustAcmOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustAcm | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustAcm | undefined);
    private _certificateAuthorityArns?;
    /**
     * @stability stable
     */
    get certificateAuthorityArns(): string[];
    /**
     * @stability stable
     */
    set certificateAuthorityArns(value: string[]);
    /**
     * @stability stable
     */
    get certificateAuthorityArnsInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustFile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#certificate_chain AppmeshVirtualNode#certificate_chain}.
     *
     * @stability stable
     */
    readonly certificateChain: string;
}
export declare function appmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustFileToTerraform(struct?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustFileOutputReference | AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustFile): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustFileOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustFile | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustFile | undefined);
    private _certificateChain?;
    /**
     * @stability stable
     */
    get certificateChain(): string;
    /**
     * @stability stable
     */
    set certificateChain(value: string);
    /**
     * @stability stable
     */
    get certificateChainInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustSds {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#secret_name AppmeshVirtualNode#secret_name}.
     *
     * @stability stable
     */
    readonly secretName: string;
}
export declare function appmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustSdsToTerraform(struct?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustSdsOutputReference | AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustSds): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustSdsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustSds | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustSds | undefined);
    private _secretName?;
    /**
     * @stability stable
     */
    get secretName(): string;
    /**
     * @stability stable
     */
    set secretName(value: string);
    /**
     * @stability stable
     */
    get secretNameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrust {
    /**
     * acm block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#acm AppmeshVirtualNode#acm}
     *
     * @stability stable
     */
    readonly acm?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustAcm;
    /**
     * file block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#file AppmeshVirtualNode#file}
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustFile;
    /**
     * sds block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#sds AppmeshVirtualNode#sds}
     *
     * @stability stable
     */
    readonly sds?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustSds;
}
export declare function appmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustToTerraform(struct?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustOutputReference | AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrust): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrust | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrust | undefined);
    private _acm;
    /**
     * @stability stable
     */
    get acm(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustAcmOutputReference;
    /**
     * @stability stable
     */
    putAcm(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustAcm): void;
    /**
     * @stability stable
     */
    resetAcm(): void;
    /**
     * @stability stable
     */
    get acmInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustAcm | undefined;
    private _file;
    /**
     * @stability stable
     */
    get file(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustFileOutputReference;
    /**
     * @stability stable
     */
    putFile(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustFile): void;
    /**
     * @stability stable
     */
    resetFile(): void;
    /**
     * @stability stable
     */
    get fileInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustFile | undefined;
    private _sds;
    /**
     * @stability stable
     */
    get sds(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustSdsOutputReference;
    /**
     * @stability stable
     */
    putSds(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustSds): void;
    /**
     * @stability stable
     */
    resetSds(): void;
    /**
     * @stability stable
     */
    get sdsInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustSds | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidation {
    /**
     * subject_alternative_names block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#subject_alternative_names AppmeshVirtualNode#subject_alternative_names}
     *
     * @stability stable
     */
    readonly subjectAlternativeNames?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNames;
    /**
     * trust block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#trust AppmeshVirtualNode#trust}
     *
     * @stability stable
     */
    readonly trust: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrust;
}
export declare function appmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationToTerraform(struct?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationOutputReference | AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidation): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidation | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidation | undefined);
    private _subjectAlternativeNames;
    /**
     * @stability stable
     */
    get subjectAlternativeNames(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNamesOutputReference;
    /**
     * @stability stable
     */
    putSubjectAlternativeNames(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNames): void;
    /**
     * @stability stable
     */
    resetSubjectAlternativeNames(): void;
    /**
     * @stability stable
     */
    get subjectAlternativeNamesInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationSubjectAlternativeNames | undefined;
    private _trust;
    /**
     * @stability stable
     */
    get trust(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrustOutputReference;
    /**
     * @stability stable
     */
    putTrust(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrust): void;
    /**
     * @stability stable
     */
    get trustInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationTrust | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTls {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#enforce AppmeshVirtualNode#enforce}.
     *
     * @stability stable
     */
    readonly enforce?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#ports AppmeshVirtualNode#ports}.
     *
     * @stability stable
     */
    readonly ports?: number[];
    /**
     * certificate block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#certificate AppmeshVirtualNode#certificate}
     *
     * @stability stable
     */
    readonly certificate?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificate;
    /**
     * validation block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#validation AppmeshVirtualNode#validation}
     *
     * @stability stable
     */
    readonly validation: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidation;
}
export declare function appmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsToTerraform(struct?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsOutputReference | AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTls): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTls | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTls | undefined);
    private _enforce?;
    /**
     * @stability stable
     */
    get enforce(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enforce(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnforce(): void;
    /**
     * @stability stable
     */
    get enforceInput(): boolean | cdktf.IResolvable | undefined;
    private _ports?;
    /**
     * @stability stable
     */
    get ports(): number[];
    /**
     * @stability stable
     */
    set ports(value: number[]);
    /**
     * @stability stable
     */
    resetPorts(): void;
    /**
     * @stability stable
     */
    get portsInput(): number[] | undefined;
    private _certificate;
    /**
     * @stability stable
     */
    get certificate(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificateOutputReference;
    /**
     * @stability stable
     */
    putCertificate(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificate): void;
    /**
     * @stability stable
     */
    resetCertificate(): void;
    /**
     * @stability stable
     */
    get certificateInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsCertificate | undefined;
    private _validation;
    /**
     * @stability stable
     */
    get validation(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidationOutputReference;
    /**
     * @stability stable
     */
    putValidation(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidation): void;
    /**
     * @stability stable
     */
    get validationInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsValidation | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicy {
    /**
     * tls block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#tls AppmeshVirtualNode#tls}
     *
     * @stability stable
     */
    readonly tls?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTls;
}
export declare function appmeshVirtualNodeSpecBackendVirtualServiceClientPolicyToTerraform(struct?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyOutputReference | AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicy): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicy | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicy | undefined);
    private _tls;
    /**
     * @stability stable
     */
    get tls(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTlsOutputReference;
    /**
     * @stability stable
     */
    putTls(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTls): void;
    /**
     * @stability stable
     */
    resetTls(): void;
    /**
     * @stability stable
     */
    get tlsInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyTls | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendVirtualService {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#virtual_service_name AppmeshVirtualNode#virtual_service_name}.
     *
     * @stability stable
     */
    readonly virtualServiceName: string;
    /**
     * client_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#client_policy AppmeshVirtualNode#client_policy}
     *
     * @stability stable
     */
    readonly clientPolicy?: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicy;
}
export declare function appmeshVirtualNodeSpecBackendVirtualServiceToTerraform(struct?: AppmeshVirtualNodeSpecBackendVirtualServiceOutputReference | AppmeshVirtualNodeSpecBackendVirtualService): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendVirtualServiceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendVirtualService | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendVirtualService | undefined);
    private _virtualServiceName?;
    /**
     * @stability stable
     */
    get virtualServiceName(): string;
    /**
     * @stability stable
     */
    set virtualServiceName(value: string);
    /**
     * @stability stable
     */
    get virtualServiceNameInput(): string | undefined;
    private _clientPolicy;
    /**
     * @stability stable
     */
    get clientPolicy(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicyOutputReference;
    /**
     * @stability stable
     */
    putClientPolicy(value: AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicy): void;
    /**
     * @stability stable
     */
    resetClientPolicy(): void;
    /**
     * @stability stable
     */
    get clientPolicyInput(): AppmeshVirtualNodeSpecBackendVirtualServiceClientPolicy | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackend {
    /**
     * virtual_service block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#virtual_service AppmeshVirtualNode#virtual_service}
     *
     * @stability stable
     */
    readonly virtualService: AppmeshVirtualNodeSpecBackendVirtualService;
}
export declare function appmeshVirtualNodeSpecBackendToTerraform(struct?: AppmeshVirtualNodeSpecBackend): any;
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateFile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#certificate_chain AppmeshVirtualNode#certificate_chain}.
     *
     * @stability stable
     */
    readonly certificateChain: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#private_key AppmeshVirtualNode#private_key}.
     *
     * @stability stable
     */
    readonly privateKey: string;
}
export declare function appmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateFileToTerraform(struct?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateFileOutputReference | AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateFile): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateFileOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateFile | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateFile | undefined);
    private _certificateChain?;
    /**
     * @stability stable
     */
    get certificateChain(): string;
    /**
     * @stability stable
     */
    set certificateChain(value: string);
    /**
     * @stability stable
     */
    get certificateChainInput(): string | undefined;
    private _privateKey?;
    /**
     * @stability stable
     */
    get privateKey(): string;
    /**
     * @stability stable
     */
    set privateKey(value: string);
    /**
     * @stability stable
     */
    get privateKeyInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateSds {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#secret_name AppmeshVirtualNode#secret_name}.
     *
     * @stability stable
     */
    readonly secretName: string;
}
export declare function appmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateSdsToTerraform(struct?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateSdsOutputReference | AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateSds): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateSdsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateSds | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateSds | undefined);
    private _secretName?;
    /**
     * @stability stable
     */
    get secretName(): string;
    /**
     * @stability stable
     */
    set secretName(value: string);
    /**
     * @stability stable
     */
    get secretNameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificate {
    /**
     * file block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#file AppmeshVirtualNode#file}
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateFile;
    /**
     * sds block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#sds AppmeshVirtualNode#sds}
     *
     * @stability stable
     */
    readonly sds?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateSds;
}
export declare function appmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateToTerraform(struct?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateOutputReference | AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificate): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificate | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificate | undefined);
    private _file;
    /**
     * @stability stable
     */
    get file(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateFileOutputReference;
    /**
     * @stability stable
     */
    putFile(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateFile): void;
    /**
     * @stability stable
     */
    resetFile(): void;
    /**
     * @stability stable
     */
    get fileInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateFile | undefined;
    private _sds;
    /**
     * @stability stable
     */
    get sds(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateSdsOutputReference;
    /**
     * @stability stable
     */
    putSds(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateSds): void;
    /**
     * @stability stable
     */
    resetSds(): void;
    /**
     * @stability stable
     */
    get sdsInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateSds | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#exact AppmeshVirtualNode#exact}.
     *
     * @stability stable
     */
    readonly exact: string[];
}
export declare function appmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatchToTerraform(struct?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatchOutputReference | AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatch): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatch | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatch | undefined);
    private _exact?;
    /**
     * @stability stable
     */
    get exact(): string[];
    /**
     * @stability stable
     */
    set exact(value: string[]);
    /**
     * @stability stable
     */
    get exactInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNames {
    /**
     * match block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#match AppmeshVirtualNode#match}
     *
     * @stability stable
     */
    readonly match: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatch;
}
export declare function appmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesToTerraform(struct?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesOutputReference | AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNames): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNames | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNames | undefined);
    private _match;
    /**
     * @stability stable
     */
    get match(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatchOutputReference;
    /**
     * @stability stable
     */
    putMatch(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatch): void;
    /**
     * @stability stable
     */
    get matchInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesMatch | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustAcm {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#certificate_authority_arns AppmeshVirtualNode#certificate_authority_arns}.
     *
     * @stability stable
     */
    readonly certificateAuthorityArns: string[];
}
export declare function appmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustAcmToTerraform(struct?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustAcmOutputReference | AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustAcm): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustAcmOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustAcm | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustAcm | undefined);
    private _certificateAuthorityArns?;
    /**
     * @stability stable
     */
    get certificateAuthorityArns(): string[];
    /**
     * @stability stable
     */
    set certificateAuthorityArns(value: string[]);
    /**
     * @stability stable
     */
    get certificateAuthorityArnsInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustFile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#certificate_chain AppmeshVirtualNode#certificate_chain}.
     *
     * @stability stable
     */
    readonly certificateChain: string;
}
export declare function appmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustFileToTerraform(struct?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustFileOutputReference | AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustFile): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustFileOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustFile | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustFile | undefined);
    private _certificateChain?;
    /**
     * @stability stable
     */
    get certificateChain(): string;
    /**
     * @stability stable
     */
    set certificateChain(value: string);
    /**
     * @stability stable
     */
    get certificateChainInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustSds {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#secret_name AppmeshVirtualNode#secret_name}.
     *
     * @stability stable
     */
    readonly secretName: string;
}
export declare function appmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustSdsToTerraform(struct?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustSdsOutputReference | AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustSds): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustSdsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustSds | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustSds | undefined);
    private _secretName?;
    /**
     * @stability stable
     */
    get secretName(): string;
    /**
     * @stability stable
     */
    set secretName(value: string);
    /**
     * @stability stable
     */
    get secretNameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrust {
    /**
     * acm block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#acm AppmeshVirtualNode#acm}
     *
     * @stability stable
     */
    readonly acm?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustAcm;
    /**
     * file block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#file AppmeshVirtualNode#file}
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustFile;
    /**
     * sds block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#sds AppmeshVirtualNode#sds}
     *
     * @stability stable
     */
    readonly sds?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustSds;
}
export declare function appmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustToTerraform(struct?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustOutputReference | AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrust): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrust | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrust | undefined);
    private _acm;
    /**
     * @stability stable
     */
    get acm(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustAcmOutputReference;
    /**
     * @stability stable
     */
    putAcm(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustAcm): void;
    /**
     * @stability stable
     */
    resetAcm(): void;
    /**
     * @stability stable
     */
    get acmInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustAcm | undefined;
    private _file;
    /**
     * @stability stable
     */
    get file(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustFileOutputReference;
    /**
     * @stability stable
     */
    putFile(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustFile): void;
    /**
     * @stability stable
     */
    resetFile(): void;
    /**
     * @stability stable
     */
    get fileInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustFile | undefined;
    private _sds;
    /**
     * @stability stable
     */
    get sds(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustSdsOutputReference;
    /**
     * @stability stable
     */
    putSds(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustSds): void;
    /**
     * @stability stable
     */
    resetSds(): void;
    /**
     * @stability stable
     */
    get sdsInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustSds | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidation {
    /**
     * subject_alternative_names block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#subject_alternative_names AppmeshVirtualNode#subject_alternative_names}
     *
     * @stability stable
     */
    readonly subjectAlternativeNames?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNames;
    /**
     * trust block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#trust AppmeshVirtualNode#trust}
     *
     * @stability stable
     */
    readonly trust: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrust;
}
export declare function appmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationToTerraform(struct?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationOutputReference | AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidation): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidation | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidation | undefined);
    private _subjectAlternativeNames;
    /**
     * @stability stable
     */
    get subjectAlternativeNames(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNamesOutputReference;
    /**
     * @stability stable
     */
    putSubjectAlternativeNames(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNames): void;
    /**
     * @stability stable
     */
    resetSubjectAlternativeNames(): void;
    /**
     * @stability stable
     */
    get subjectAlternativeNamesInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationSubjectAlternativeNames | undefined;
    private _trust;
    /**
     * @stability stable
     */
    get trust(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrustOutputReference;
    /**
     * @stability stable
     */
    putTrust(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrust): void;
    /**
     * @stability stable
     */
    get trustInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationTrust | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTls {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#enforce AppmeshVirtualNode#enforce}.
     *
     * @stability stable
     */
    readonly enforce?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#ports AppmeshVirtualNode#ports}.
     *
     * @stability stable
     */
    readonly ports?: number[];
    /**
     * certificate block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#certificate AppmeshVirtualNode#certificate}
     *
     * @stability stable
     */
    readonly certificate?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificate;
    /**
     * validation block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#validation AppmeshVirtualNode#validation}
     *
     * @stability stable
     */
    readonly validation: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidation;
}
export declare function appmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsToTerraform(struct?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsOutputReference | AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTls): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTls | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTls | undefined);
    private _enforce?;
    /**
     * @stability stable
     */
    get enforce(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enforce(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnforce(): void;
    /**
     * @stability stable
     */
    get enforceInput(): boolean | cdktf.IResolvable | undefined;
    private _ports?;
    /**
     * @stability stable
     */
    get ports(): number[];
    /**
     * @stability stable
     */
    set ports(value: number[]);
    /**
     * @stability stable
     */
    resetPorts(): void;
    /**
     * @stability stable
     */
    get portsInput(): number[] | undefined;
    private _certificate;
    /**
     * @stability stable
     */
    get certificate(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificateOutputReference;
    /**
     * @stability stable
     */
    putCertificate(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificate): void;
    /**
     * @stability stable
     */
    resetCertificate(): void;
    /**
     * @stability stable
     */
    get certificateInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsCertificate | undefined;
    private _validation;
    /**
     * @stability stable
     */
    get validation(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidationOutputReference;
    /**
     * @stability stable
     */
    putValidation(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidation): void;
    /**
     * @stability stable
     */
    get validationInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsValidation | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaultsClientPolicy {
    /**
     * tls block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#tls AppmeshVirtualNode#tls}
     *
     * @stability stable
     */
    readonly tls?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTls;
}
export declare function appmeshVirtualNodeSpecBackendDefaultsClientPolicyToTerraform(struct?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyOutputReference | AppmeshVirtualNodeSpecBackendDefaultsClientPolicy): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendDefaultsClientPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicy | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicy | undefined);
    private _tls;
    /**
     * @stability stable
     */
    get tls(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTlsOutputReference;
    /**
     * @stability stable
     */
    putTls(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTls): void;
    /**
     * @stability stable
     */
    resetTls(): void;
    /**
     * @stability stable
     */
    get tlsInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyTls | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecBackendDefaults {
    /**
     * client_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#client_policy AppmeshVirtualNode#client_policy}
     *
     * @stability stable
     */
    readonly clientPolicy?: AppmeshVirtualNodeSpecBackendDefaultsClientPolicy;
}
export declare function appmeshVirtualNodeSpecBackendDefaultsToTerraform(struct?: AppmeshVirtualNodeSpecBackendDefaultsOutputReference | AppmeshVirtualNodeSpecBackendDefaults): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecBackendDefaultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecBackendDefaults | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecBackendDefaults | undefined);
    private _clientPolicy;
    /**
     * @stability stable
     */
    get clientPolicy(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicyOutputReference;
    /**
     * @stability stable
     */
    putClientPolicy(value: AppmeshVirtualNodeSpecBackendDefaultsClientPolicy): void;
    /**
     * @stability stable
     */
    resetClientPolicy(): void;
    /**
     * @stability stable
     */
    get clientPolicyInput(): AppmeshVirtualNodeSpecBackendDefaultsClientPolicy | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerConnectionPoolGrpc {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#max_requests AppmeshVirtualNode#max_requests}.
     *
     * @stability stable
     */
    readonly maxRequests: number;
}
export declare function appmeshVirtualNodeSpecListenerConnectionPoolGrpcToTerraform(struct?: AppmeshVirtualNodeSpecListenerConnectionPoolGrpcOutputReference | AppmeshVirtualNodeSpecListenerConnectionPoolGrpc): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerConnectionPoolGrpcOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerConnectionPoolGrpc | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerConnectionPoolGrpc | undefined);
    private _maxRequests?;
    /**
     * @stability stable
     */
    get maxRequests(): number;
    /**
     * @stability stable
     */
    set maxRequests(value: number);
    /**
     * @stability stable
     */
    get maxRequestsInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerConnectionPoolHttp {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#max_connections AppmeshVirtualNode#max_connections}.
     *
     * @stability stable
     */
    readonly maxConnections: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#max_pending_requests AppmeshVirtualNode#max_pending_requests}.
     *
     * @stability stable
     */
    readonly maxPendingRequests?: number;
}
export declare function appmeshVirtualNodeSpecListenerConnectionPoolHttpToTerraform(struct?: AppmeshVirtualNodeSpecListenerConnectionPoolHttpOutputReference | AppmeshVirtualNodeSpecListenerConnectionPoolHttp): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerConnectionPoolHttpOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerConnectionPoolHttp | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerConnectionPoolHttp | undefined);
    private _maxConnections?;
    /**
     * @stability stable
     */
    get maxConnections(): number;
    /**
     * @stability stable
     */
    set maxConnections(value: number);
    /**
     * @stability stable
     */
    get maxConnectionsInput(): number | undefined;
    private _maxPendingRequests?;
    /**
     * @stability stable
     */
    get maxPendingRequests(): number;
    /**
     * @stability stable
     */
    set maxPendingRequests(value: number);
    /**
     * @stability stable
     */
    resetMaxPendingRequests(): void;
    /**
     * @stability stable
     */
    get maxPendingRequestsInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerConnectionPoolHttp2 {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#max_requests AppmeshVirtualNode#max_requests}.
     *
     * @stability stable
     */
    readonly maxRequests: number;
}
export declare function appmeshVirtualNodeSpecListenerConnectionPoolHttp2ToTerraform(struct?: AppmeshVirtualNodeSpecListenerConnectionPoolHttp2OutputReference | AppmeshVirtualNodeSpecListenerConnectionPoolHttp2): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerConnectionPoolHttp2OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerConnectionPoolHttp2 | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerConnectionPoolHttp2 | undefined);
    private _maxRequests?;
    /**
     * @stability stable
     */
    get maxRequests(): number;
    /**
     * @stability stable
     */
    set maxRequests(value: number);
    /**
     * @stability stable
     */
    get maxRequestsInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerConnectionPoolTcp {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#max_connections AppmeshVirtualNode#max_connections}.
     *
     * @stability stable
     */
    readonly maxConnections: number;
}
export declare function appmeshVirtualNodeSpecListenerConnectionPoolTcpToTerraform(struct?: AppmeshVirtualNodeSpecListenerConnectionPoolTcpOutputReference | AppmeshVirtualNodeSpecListenerConnectionPoolTcp): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerConnectionPoolTcpOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerConnectionPoolTcp | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerConnectionPoolTcp | undefined);
    private _maxConnections?;
    /**
     * @stability stable
     */
    get maxConnections(): number;
    /**
     * @stability stable
     */
    set maxConnections(value: number);
    /**
     * @stability stable
     */
    get maxConnectionsInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerConnectionPool {
    /**
     * grpc block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#grpc AppmeshVirtualNode#grpc}
     *
     * @stability stable
     */
    readonly grpc?: AppmeshVirtualNodeSpecListenerConnectionPoolGrpc;
    /**
     * http block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#http AppmeshVirtualNode#http}
     *
     * @stability stable
     */
    readonly http?: AppmeshVirtualNodeSpecListenerConnectionPoolHttp;
    /**
     * http2 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#http2 AppmeshVirtualNode#http2}
     *
     * @stability stable
     */
    readonly http2?: AppmeshVirtualNodeSpecListenerConnectionPoolHttp2;
    /**
     * tcp block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#tcp AppmeshVirtualNode#tcp}
     *
     * @stability stable
     */
    readonly tcp?: AppmeshVirtualNodeSpecListenerConnectionPoolTcp;
}
export declare function appmeshVirtualNodeSpecListenerConnectionPoolToTerraform(struct?: AppmeshVirtualNodeSpecListenerConnectionPoolOutputReference | AppmeshVirtualNodeSpecListenerConnectionPool): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerConnectionPoolOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerConnectionPool | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerConnectionPool | undefined);
    private _grpc;
    /**
     * @stability stable
     */
    get grpc(): AppmeshVirtualNodeSpecListenerConnectionPoolGrpcOutputReference;
    /**
     * @stability stable
     */
    putGrpc(value: AppmeshVirtualNodeSpecListenerConnectionPoolGrpc): void;
    /**
     * @stability stable
     */
    resetGrpc(): void;
    /**
     * @stability stable
     */
    get grpcInput(): AppmeshVirtualNodeSpecListenerConnectionPoolGrpc | undefined;
    private _http;
    /**
     * @stability stable
     */
    get http(): AppmeshVirtualNodeSpecListenerConnectionPoolHttpOutputReference;
    /**
     * @stability stable
     */
    putHttp(value: AppmeshVirtualNodeSpecListenerConnectionPoolHttp): void;
    /**
     * @stability stable
     */
    resetHttp(): void;
    /**
     * @stability stable
     */
    get httpInput(): AppmeshVirtualNodeSpecListenerConnectionPoolHttp | undefined;
    private _http2;
    /**
     * @stability stable
     */
    get http2(): AppmeshVirtualNodeSpecListenerConnectionPoolHttp2OutputReference;
    /**
     * @stability stable
     */
    putHttp2(value: AppmeshVirtualNodeSpecListenerConnectionPoolHttp2): void;
    /**
     * @stability stable
     */
    resetHttp2(): void;
    /**
     * @stability stable
     */
    get http2Input(): AppmeshVirtualNodeSpecListenerConnectionPoolHttp2 | undefined;
    private _tcp;
    /**
     * @stability stable
     */
    get tcp(): AppmeshVirtualNodeSpecListenerConnectionPoolTcpOutputReference;
    /**
     * @stability stable
     */
    putTcp(value: AppmeshVirtualNodeSpecListenerConnectionPoolTcp): void;
    /**
     * @stability stable
     */
    resetTcp(): void;
    /**
     * @stability stable
     */
    get tcpInput(): AppmeshVirtualNodeSpecListenerConnectionPoolTcp | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerHealthCheck {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#healthy_threshold AppmeshVirtualNode#healthy_threshold}.
     *
     * @stability stable
     */
    readonly healthyThreshold: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#interval_millis AppmeshVirtualNode#interval_millis}.
     *
     * @stability stable
     */
    readonly intervalMillis: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#path AppmeshVirtualNode#path}.
     *
     * @stability stable
     */
    readonly path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#port AppmeshVirtualNode#port}.
     *
     * @stability stable
     */
    readonly port?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#protocol AppmeshVirtualNode#protocol}.
     *
     * @stability stable
     */
    readonly protocol: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#timeout_millis AppmeshVirtualNode#timeout_millis}.
     *
     * @stability stable
     */
    readonly timeoutMillis: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#unhealthy_threshold AppmeshVirtualNode#unhealthy_threshold}.
     *
     * @stability stable
     */
    readonly unhealthyThreshold: number;
}
export declare function appmeshVirtualNodeSpecListenerHealthCheckToTerraform(struct?: AppmeshVirtualNodeSpecListenerHealthCheckOutputReference | AppmeshVirtualNodeSpecListenerHealthCheck): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerHealthCheckOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerHealthCheck | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerHealthCheck | undefined);
    private _healthyThreshold?;
    /**
     * @stability stable
     */
    get healthyThreshold(): number;
    /**
     * @stability stable
     */
    set healthyThreshold(value: number);
    /**
     * @stability stable
     */
    get healthyThresholdInput(): number | undefined;
    private _intervalMillis?;
    /**
     * @stability stable
     */
    get intervalMillis(): number;
    /**
     * @stability stable
     */
    set intervalMillis(value: number);
    /**
     * @stability stable
     */
    get intervalMillisInput(): number | undefined;
    private _path?;
    /**
     * @stability stable
     */
    get path(): string;
    /**
     * @stability stable
     */
    set path(value: string);
    /**
     * @stability stable
     */
    resetPath(): void;
    /**
     * @stability stable
     */
    get pathInput(): string | undefined;
    private _port?;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    set port(value: number);
    /**
     * @stability stable
     */
    resetPort(): void;
    /**
     * @stability stable
     */
    get portInput(): number | undefined;
    private _protocol?;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    set protocol(value: string);
    /**
     * @stability stable
     */
    get protocolInput(): string | undefined;
    private _timeoutMillis?;
    /**
     * @stability stable
     */
    get timeoutMillis(): number;
    /**
     * @stability stable
     */
    set timeoutMillis(value: number);
    /**
     * @stability stable
     */
    get timeoutMillisInput(): number | undefined;
    private _unhealthyThreshold?;
    /**
     * @stability stable
     */
    get unhealthyThreshold(): number;
    /**
     * @stability stable
     */
    set unhealthyThreshold(value: number);
    /**
     * @stability stable
     */
    get unhealthyThresholdInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerOutlierDetectionBaseEjectionDuration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#unit AppmeshVirtualNode#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#value AppmeshVirtualNode#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function appmeshVirtualNodeSpecListenerOutlierDetectionBaseEjectionDurationToTerraform(struct?: AppmeshVirtualNodeSpecListenerOutlierDetectionBaseEjectionDurationOutputReference | AppmeshVirtualNodeSpecListenerOutlierDetectionBaseEjectionDuration): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerOutlierDetectionBaseEjectionDurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerOutlierDetectionBaseEjectionDuration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerOutlierDetectionBaseEjectionDuration | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerOutlierDetectionInterval {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#unit AppmeshVirtualNode#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#value AppmeshVirtualNode#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function appmeshVirtualNodeSpecListenerOutlierDetectionIntervalToTerraform(struct?: AppmeshVirtualNodeSpecListenerOutlierDetectionIntervalOutputReference | AppmeshVirtualNodeSpecListenerOutlierDetectionInterval): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerOutlierDetectionIntervalOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerOutlierDetectionInterval | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerOutlierDetectionInterval | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerOutlierDetection {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#max_ejection_percent AppmeshVirtualNode#max_ejection_percent}.
     *
     * @stability stable
     */
    readonly maxEjectionPercent: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#max_server_errors AppmeshVirtualNode#max_server_errors}.
     *
     * @stability stable
     */
    readonly maxServerErrors: number;
    /**
     * base_ejection_duration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#base_ejection_duration AppmeshVirtualNode#base_ejection_duration}
     *
     * @stability stable
     */
    readonly baseEjectionDuration: AppmeshVirtualNodeSpecListenerOutlierDetectionBaseEjectionDuration;
    /**
     * interval block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#interval AppmeshVirtualNode#interval}
     *
     * @stability stable
     */
    readonly interval: AppmeshVirtualNodeSpecListenerOutlierDetectionInterval;
}
export declare function appmeshVirtualNodeSpecListenerOutlierDetectionToTerraform(struct?: AppmeshVirtualNodeSpecListenerOutlierDetectionOutputReference | AppmeshVirtualNodeSpecListenerOutlierDetection): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerOutlierDetectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerOutlierDetection | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerOutlierDetection | undefined);
    private _maxEjectionPercent?;
    /**
     * @stability stable
     */
    get maxEjectionPercent(): number;
    /**
     * @stability stable
     */
    set maxEjectionPercent(value: number);
    /**
     * @stability stable
     */
    get maxEjectionPercentInput(): number | undefined;
    private _maxServerErrors?;
    /**
     * @stability stable
     */
    get maxServerErrors(): number;
    /**
     * @stability stable
     */
    set maxServerErrors(value: number);
    /**
     * @stability stable
     */
    get maxServerErrorsInput(): number | undefined;
    private _baseEjectionDuration;
    /**
     * @stability stable
     */
    get baseEjectionDuration(): AppmeshVirtualNodeSpecListenerOutlierDetectionBaseEjectionDurationOutputReference;
    /**
     * @stability stable
     */
    putBaseEjectionDuration(value: AppmeshVirtualNodeSpecListenerOutlierDetectionBaseEjectionDuration): void;
    /**
     * @stability stable
     */
    get baseEjectionDurationInput(): AppmeshVirtualNodeSpecListenerOutlierDetectionBaseEjectionDuration | undefined;
    private _interval;
    /**
     * @stability stable
     */
    get interval(): AppmeshVirtualNodeSpecListenerOutlierDetectionIntervalOutputReference;
    /**
     * @stability stable
     */
    putInterval(value: AppmeshVirtualNodeSpecListenerOutlierDetectionInterval): void;
    /**
     * @stability stable
     */
    get intervalInput(): AppmeshVirtualNodeSpecListenerOutlierDetectionInterval | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerPortMapping {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#port AppmeshVirtualNode#port}.
     *
     * @stability stable
     */
    readonly port: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#protocol AppmeshVirtualNode#protocol}.
     *
     * @stability stable
     */
    readonly protocol: string;
}
export declare function appmeshVirtualNodeSpecListenerPortMappingToTerraform(struct?: AppmeshVirtualNodeSpecListenerPortMappingOutputReference | AppmeshVirtualNodeSpecListenerPortMapping): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerPortMappingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerPortMapping | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerPortMapping | undefined);
    private _port?;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    set port(value: number);
    /**
     * @stability stable
     */
    get portInput(): number | undefined;
    private _protocol?;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    set protocol(value: string);
    /**
     * @stability stable
     */
    get protocolInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutGrpcIdle {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#unit AppmeshVirtualNode#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#value AppmeshVirtualNode#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function appmeshVirtualNodeSpecListenerTimeoutGrpcIdleToTerraform(struct?: AppmeshVirtualNodeSpecListenerTimeoutGrpcIdleOutputReference | AppmeshVirtualNodeSpecListenerTimeoutGrpcIdle): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTimeoutGrpcIdleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTimeoutGrpcIdle | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTimeoutGrpcIdle | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutGrpcPerRequest {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#unit AppmeshVirtualNode#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#value AppmeshVirtualNode#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function appmeshVirtualNodeSpecListenerTimeoutGrpcPerRequestToTerraform(struct?: AppmeshVirtualNodeSpecListenerTimeoutGrpcPerRequestOutputReference | AppmeshVirtualNodeSpecListenerTimeoutGrpcPerRequest): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTimeoutGrpcPerRequestOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTimeoutGrpcPerRequest | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTimeoutGrpcPerRequest | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutGrpc {
    /**
     * idle block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#idle AppmeshVirtualNode#idle}
     *
     * @stability stable
     */
    readonly idle?: AppmeshVirtualNodeSpecListenerTimeoutGrpcIdle;
    /**
     * per_request block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#per_request AppmeshVirtualNode#per_request}
     *
     * @stability stable
     */
    readonly perRequest?: AppmeshVirtualNodeSpecListenerTimeoutGrpcPerRequest;
}
export declare function appmeshVirtualNodeSpecListenerTimeoutGrpcToTerraform(struct?: AppmeshVirtualNodeSpecListenerTimeoutGrpcOutputReference | AppmeshVirtualNodeSpecListenerTimeoutGrpc): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTimeoutGrpcOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTimeoutGrpc | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTimeoutGrpc | undefined);
    private _idle;
    /**
     * @stability stable
     */
    get idle(): AppmeshVirtualNodeSpecListenerTimeoutGrpcIdleOutputReference;
    /**
     * @stability stable
     */
    putIdle(value: AppmeshVirtualNodeSpecListenerTimeoutGrpcIdle): void;
    /**
     * @stability stable
     */
    resetIdle(): void;
    /**
     * @stability stable
     */
    get idleInput(): AppmeshVirtualNodeSpecListenerTimeoutGrpcIdle | undefined;
    private _perRequest;
    /**
     * @stability stable
     */
    get perRequest(): AppmeshVirtualNodeSpecListenerTimeoutGrpcPerRequestOutputReference;
    /**
     * @stability stable
     */
    putPerRequest(value: AppmeshVirtualNodeSpecListenerTimeoutGrpcPerRequest): void;
    /**
     * @stability stable
     */
    resetPerRequest(): void;
    /**
     * @stability stable
     */
    get perRequestInput(): AppmeshVirtualNodeSpecListenerTimeoutGrpcPerRequest | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutHttpIdle {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#unit AppmeshVirtualNode#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#value AppmeshVirtualNode#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function appmeshVirtualNodeSpecListenerTimeoutHttpIdleToTerraform(struct?: AppmeshVirtualNodeSpecListenerTimeoutHttpIdleOutputReference | AppmeshVirtualNodeSpecListenerTimeoutHttpIdle): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTimeoutHttpIdleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTimeoutHttpIdle | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTimeoutHttpIdle | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutHttpPerRequest {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#unit AppmeshVirtualNode#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#value AppmeshVirtualNode#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function appmeshVirtualNodeSpecListenerTimeoutHttpPerRequestToTerraform(struct?: AppmeshVirtualNodeSpecListenerTimeoutHttpPerRequestOutputReference | AppmeshVirtualNodeSpecListenerTimeoutHttpPerRequest): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTimeoutHttpPerRequestOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTimeoutHttpPerRequest | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTimeoutHttpPerRequest | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutHttp {
    /**
     * idle block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#idle AppmeshVirtualNode#idle}
     *
     * @stability stable
     */
    readonly idle?: AppmeshVirtualNodeSpecListenerTimeoutHttpIdle;
    /**
     * per_request block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#per_request AppmeshVirtualNode#per_request}
     *
     * @stability stable
     */
    readonly perRequest?: AppmeshVirtualNodeSpecListenerTimeoutHttpPerRequest;
}
export declare function appmeshVirtualNodeSpecListenerTimeoutHttpToTerraform(struct?: AppmeshVirtualNodeSpecListenerTimeoutHttpOutputReference | AppmeshVirtualNodeSpecListenerTimeoutHttp): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTimeoutHttpOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTimeoutHttp | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTimeoutHttp | undefined);
    private _idle;
    /**
     * @stability stable
     */
    get idle(): AppmeshVirtualNodeSpecListenerTimeoutHttpIdleOutputReference;
    /**
     * @stability stable
     */
    putIdle(value: AppmeshVirtualNodeSpecListenerTimeoutHttpIdle): void;
    /**
     * @stability stable
     */
    resetIdle(): void;
    /**
     * @stability stable
     */
    get idleInput(): AppmeshVirtualNodeSpecListenerTimeoutHttpIdle | undefined;
    private _perRequest;
    /**
     * @stability stable
     */
    get perRequest(): AppmeshVirtualNodeSpecListenerTimeoutHttpPerRequestOutputReference;
    /**
     * @stability stable
     */
    putPerRequest(value: AppmeshVirtualNodeSpecListenerTimeoutHttpPerRequest): void;
    /**
     * @stability stable
     */
    resetPerRequest(): void;
    /**
     * @stability stable
     */
    get perRequestInput(): AppmeshVirtualNodeSpecListenerTimeoutHttpPerRequest | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutHttp2Idle {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#unit AppmeshVirtualNode#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#value AppmeshVirtualNode#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function appmeshVirtualNodeSpecListenerTimeoutHttp2IdleToTerraform(struct?: AppmeshVirtualNodeSpecListenerTimeoutHttp2IdleOutputReference | AppmeshVirtualNodeSpecListenerTimeoutHttp2Idle): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTimeoutHttp2IdleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTimeoutHttp2Idle | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTimeoutHttp2Idle | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutHttp2PerRequest {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#unit AppmeshVirtualNode#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#value AppmeshVirtualNode#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function appmeshVirtualNodeSpecListenerTimeoutHttp2PerRequestToTerraform(struct?: AppmeshVirtualNodeSpecListenerTimeoutHttp2PerRequestOutputReference | AppmeshVirtualNodeSpecListenerTimeoutHttp2PerRequest): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTimeoutHttp2PerRequestOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTimeoutHttp2PerRequest | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTimeoutHttp2PerRequest | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutHttp2 {
    /**
     * idle block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#idle AppmeshVirtualNode#idle}
     *
     * @stability stable
     */
    readonly idle?: AppmeshVirtualNodeSpecListenerTimeoutHttp2Idle;
    /**
     * per_request block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#per_request AppmeshVirtualNode#per_request}
     *
     * @stability stable
     */
    readonly perRequest?: AppmeshVirtualNodeSpecListenerTimeoutHttp2PerRequest;
}
export declare function appmeshVirtualNodeSpecListenerTimeoutHttp2ToTerraform(struct?: AppmeshVirtualNodeSpecListenerTimeoutHttp2OutputReference | AppmeshVirtualNodeSpecListenerTimeoutHttp2): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTimeoutHttp2OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTimeoutHttp2 | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTimeoutHttp2 | undefined);
    private _idle;
    /**
     * @stability stable
     */
    get idle(): AppmeshVirtualNodeSpecListenerTimeoutHttp2IdleOutputReference;
    /**
     * @stability stable
     */
    putIdle(value: AppmeshVirtualNodeSpecListenerTimeoutHttp2Idle): void;
    /**
     * @stability stable
     */
    resetIdle(): void;
    /**
     * @stability stable
     */
    get idleInput(): AppmeshVirtualNodeSpecListenerTimeoutHttp2Idle | undefined;
    private _perRequest;
    /**
     * @stability stable
     */
    get perRequest(): AppmeshVirtualNodeSpecListenerTimeoutHttp2PerRequestOutputReference;
    /**
     * @stability stable
     */
    putPerRequest(value: AppmeshVirtualNodeSpecListenerTimeoutHttp2PerRequest): void;
    /**
     * @stability stable
     */
    resetPerRequest(): void;
    /**
     * @stability stable
     */
    get perRequestInput(): AppmeshVirtualNodeSpecListenerTimeoutHttp2PerRequest | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutTcpIdle {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#unit AppmeshVirtualNode#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#value AppmeshVirtualNode#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function appmeshVirtualNodeSpecListenerTimeoutTcpIdleToTerraform(struct?: AppmeshVirtualNodeSpecListenerTimeoutTcpIdleOutputReference | AppmeshVirtualNodeSpecListenerTimeoutTcpIdle): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTimeoutTcpIdleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTimeoutTcpIdle | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTimeoutTcpIdle | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeoutTcp {
    /**
     * idle block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#idle AppmeshVirtualNode#idle}
     *
     * @stability stable
     */
    readonly idle?: AppmeshVirtualNodeSpecListenerTimeoutTcpIdle;
}
export declare function appmeshVirtualNodeSpecListenerTimeoutTcpToTerraform(struct?: AppmeshVirtualNodeSpecListenerTimeoutTcpOutputReference | AppmeshVirtualNodeSpecListenerTimeoutTcp): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTimeoutTcpOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTimeoutTcp | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTimeoutTcp | undefined);
    private _idle;
    /**
     * @stability stable
     */
    get idle(): AppmeshVirtualNodeSpecListenerTimeoutTcpIdleOutputReference;
    /**
     * @stability stable
     */
    putIdle(value: AppmeshVirtualNodeSpecListenerTimeoutTcpIdle): void;
    /**
     * @stability stable
     */
    resetIdle(): void;
    /**
     * @stability stable
     */
    get idleInput(): AppmeshVirtualNodeSpecListenerTimeoutTcpIdle | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTimeout {
    /**
     * grpc block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#grpc AppmeshVirtualNode#grpc}
     *
     * @stability stable
     */
    readonly grpc?: AppmeshVirtualNodeSpecListenerTimeoutGrpc;
    /**
     * http block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#http AppmeshVirtualNode#http}
     *
     * @stability stable
     */
    readonly http?: AppmeshVirtualNodeSpecListenerTimeoutHttp;
    /**
     * http2 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#http2 AppmeshVirtualNode#http2}
     *
     * @stability stable
     */
    readonly http2?: AppmeshVirtualNodeSpecListenerTimeoutHttp2;
    /**
     * tcp block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#tcp AppmeshVirtualNode#tcp}
     *
     * @stability stable
     */
    readonly tcp?: AppmeshVirtualNodeSpecListenerTimeoutTcp;
}
export declare function appmeshVirtualNodeSpecListenerTimeoutToTerraform(struct?: AppmeshVirtualNodeSpecListenerTimeoutOutputReference | AppmeshVirtualNodeSpecListenerTimeout): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTimeoutOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTimeout | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTimeout | undefined);
    private _grpc;
    /**
     * @stability stable
     */
    get grpc(): AppmeshVirtualNodeSpecListenerTimeoutGrpcOutputReference;
    /**
     * @stability stable
     */
    putGrpc(value: AppmeshVirtualNodeSpecListenerTimeoutGrpc): void;
    /**
     * @stability stable
     */
    resetGrpc(): void;
    /**
     * @stability stable
     */
    get grpcInput(): AppmeshVirtualNodeSpecListenerTimeoutGrpc | undefined;
    private _http;
    /**
     * @stability stable
     */
    get http(): AppmeshVirtualNodeSpecListenerTimeoutHttpOutputReference;
    /**
     * @stability stable
     */
    putHttp(value: AppmeshVirtualNodeSpecListenerTimeoutHttp): void;
    /**
     * @stability stable
     */
    resetHttp(): void;
    /**
     * @stability stable
     */
    get httpInput(): AppmeshVirtualNodeSpecListenerTimeoutHttp | undefined;
    private _http2;
    /**
     * @stability stable
     */
    get http2(): AppmeshVirtualNodeSpecListenerTimeoutHttp2OutputReference;
    /**
     * @stability stable
     */
    putHttp2(value: AppmeshVirtualNodeSpecListenerTimeoutHttp2): void;
    /**
     * @stability stable
     */
    resetHttp2(): void;
    /**
     * @stability stable
     */
    get http2Input(): AppmeshVirtualNodeSpecListenerTimeoutHttp2 | undefined;
    private _tcp;
    /**
     * @stability stable
     */
    get tcp(): AppmeshVirtualNodeSpecListenerTimeoutTcpOutputReference;
    /**
     * @stability stable
     */
    putTcp(value: AppmeshVirtualNodeSpecListenerTimeoutTcp): void;
    /**
     * @stability stable
     */
    resetTcp(): void;
    /**
     * @stability stable
     */
    get tcpInput(): AppmeshVirtualNodeSpecListenerTimeoutTcp | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTlsCertificateAcm {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#certificate_arn AppmeshVirtualNode#certificate_arn}.
     *
     * @stability stable
     */
    readonly certificateArn: string;
}
export declare function appmeshVirtualNodeSpecListenerTlsCertificateAcmToTerraform(struct?: AppmeshVirtualNodeSpecListenerTlsCertificateAcmOutputReference | AppmeshVirtualNodeSpecListenerTlsCertificateAcm): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTlsCertificateAcmOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTlsCertificateAcm | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTlsCertificateAcm | undefined);
    private _certificateArn?;
    /**
     * @stability stable
     */
    get certificateArn(): string;
    /**
     * @stability stable
     */
    set certificateArn(value: string);
    /**
     * @stability stable
     */
    get certificateArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTlsCertificateFile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#certificate_chain AppmeshVirtualNode#certificate_chain}.
     *
     * @stability stable
     */
    readonly certificateChain: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#private_key AppmeshVirtualNode#private_key}.
     *
     * @stability stable
     */
    readonly privateKey: string;
}
export declare function appmeshVirtualNodeSpecListenerTlsCertificateFileToTerraform(struct?: AppmeshVirtualNodeSpecListenerTlsCertificateFileOutputReference | AppmeshVirtualNodeSpecListenerTlsCertificateFile): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTlsCertificateFileOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTlsCertificateFile | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTlsCertificateFile | undefined);
    private _certificateChain?;
    /**
     * @stability stable
     */
    get certificateChain(): string;
    /**
     * @stability stable
     */
    set certificateChain(value: string);
    /**
     * @stability stable
     */
    get certificateChainInput(): string | undefined;
    private _privateKey?;
    /**
     * @stability stable
     */
    get privateKey(): string;
    /**
     * @stability stable
     */
    set privateKey(value: string);
    /**
     * @stability stable
     */
    get privateKeyInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTlsCertificateSds {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#secret_name AppmeshVirtualNode#secret_name}.
     *
     * @stability stable
     */
    readonly secretName: string;
}
export declare function appmeshVirtualNodeSpecListenerTlsCertificateSdsToTerraform(struct?: AppmeshVirtualNodeSpecListenerTlsCertificateSdsOutputReference | AppmeshVirtualNodeSpecListenerTlsCertificateSds): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTlsCertificateSdsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTlsCertificateSds | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTlsCertificateSds | undefined);
    private _secretName?;
    /**
     * @stability stable
     */
    get secretName(): string;
    /**
     * @stability stable
     */
    set secretName(value: string);
    /**
     * @stability stable
     */
    get secretNameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTlsCertificate {
    /**
     * acm block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#acm AppmeshVirtualNode#acm}
     *
     * @stability stable
     */
    readonly acm?: AppmeshVirtualNodeSpecListenerTlsCertificateAcm;
    /**
     * file block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#file AppmeshVirtualNode#file}
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualNodeSpecListenerTlsCertificateFile;
    /**
     * sds block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#sds AppmeshVirtualNode#sds}
     *
     * @stability stable
     */
    readonly sds?: AppmeshVirtualNodeSpecListenerTlsCertificateSds;
}
export declare function appmeshVirtualNodeSpecListenerTlsCertificateToTerraform(struct?: AppmeshVirtualNodeSpecListenerTlsCertificateOutputReference | AppmeshVirtualNodeSpecListenerTlsCertificate): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTlsCertificateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTlsCertificate | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTlsCertificate | undefined);
    private _acm;
    /**
     * @stability stable
     */
    get acm(): AppmeshVirtualNodeSpecListenerTlsCertificateAcmOutputReference;
    /**
     * @stability stable
     */
    putAcm(value: AppmeshVirtualNodeSpecListenerTlsCertificateAcm): void;
    /**
     * @stability stable
     */
    resetAcm(): void;
    /**
     * @stability stable
     */
    get acmInput(): AppmeshVirtualNodeSpecListenerTlsCertificateAcm | undefined;
    private _file;
    /**
     * @stability stable
     */
    get file(): AppmeshVirtualNodeSpecListenerTlsCertificateFileOutputReference;
    /**
     * @stability stable
     */
    putFile(value: AppmeshVirtualNodeSpecListenerTlsCertificateFile): void;
    /**
     * @stability stable
     */
    resetFile(): void;
    /**
     * @stability stable
     */
    get fileInput(): AppmeshVirtualNodeSpecListenerTlsCertificateFile | undefined;
    private _sds;
    /**
     * @stability stable
     */
    get sds(): AppmeshVirtualNodeSpecListenerTlsCertificateSdsOutputReference;
    /**
     * @stability stable
     */
    putSds(value: AppmeshVirtualNodeSpecListenerTlsCertificateSds): void;
    /**
     * @stability stable
     */
    resetSds(): void;
    /**
     * @stability stable
     */
    get sdsInput(): AppmeshVirtualNodeSpecListenerTlsCertificateSds | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesMatch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#exact AppmeshVirtualNode#exact}.
     *
     * @stability stable
     */
    readonly exact: string[];
}
export declare function appmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesMatchToTerraform(struct?: AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesMatchOutputReference | AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesMatch): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesMatchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesMatch | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesMatch | undefined);
    private _exact?;
    /**
     * @stability stable
     */
    get exact(): string[];
    /**
     * @stability stable
     */
    set exact(value: string[]);
    /**
     * @stability stable
     */
    get exactInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNames {
    /**
     * match block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#match AppmeshVirtualNode#match}
     *
     * @stability stable
     */
    readonly match: AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesMatch;
}
export declare function appmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesToTerraform(struct?: AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesOutputReference | AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNames): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNames | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNames | undefined);
    private _match;
    /**
     * @stability stable
     */
    get match(): AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesMatchOutputReference;
    /**
     * @stability stable
     */
    putMatch(value: AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesMatch): void;
    /**
     * @stability stable
     */
    get matchInput(): AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesMatch | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTlsValidationTrustFile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#certificate_chain AppmeshVirtualNode#certificate_chain}.
     *
     * @stability stable
     */
    readonly certificateChain: string;
}
export declare function appmeshVirtualNodeSpecListenerTlsValidationTrustFileToTerraform(struct?: AppmeshVirtualNodeSpecListenerTlsValidationTrustFileOutputReference | AppmeshVirtualNodeSpecListenerTlsValidationTrustFile): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTlsValidationTrustFileOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTlsValidationTrustFile | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTlsValidationTrustFile | undefined);
    private _certificateChain?;
    /**
     * @stability stable
     */
    get certificateChain(): string;
    /**
     * @stability stable
     */
    set certificateChain(value: string);
    /**
     * @stability stable
     */
    get certificateChainInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTlsValidationTrustSds {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#secret_name AppmeshVirtualNode#secret_name}.
     *
     * @stability stable
     */
    readonly secretName: string;
}
export declare function appmeshVirtualNodeSpecListenerTlsValidationTrustSdsToTerraform(struct?: AppmeshVirtualNodeSpecListenerTlsValidationTrustSdsOutputReference | AppmeshVirtualNodeSpecListenerTlsValidationTrustSds): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTlsValidationTrustSdsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTlsValidationTrustSds | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTlsValidationTrustSds | undefined);
    private _secretName?;
    /**
     * @stability stable
     */
    get secretName(): string;
    /**
     * @stability stable
     */
    set secretName(value: string);
    /**
     * @stability stable
     */
    get secretNameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTlsValidationTrust {
    /**
     * file block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#file AppmeshVirtualNode#file}
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualNodeSpecListenerTlsValidationTrustFile;
    /**
     * sds block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#sds AppmeshVirtualNode#sds}
     *
     * @stability stable
     */
    readonly sds?: AppmeshVirtualNodeSpecListenerTlsValidationTrustSds;
}
export declare function appmeshVirtualNodeSpecListenerTlsValidationTrustToTerraform(struct?: AppmeshVirtualNodeSpecListenerTlsValidationTrustOutputReference | AppmeshVirtualNodeSpecListenerTlsValidationTrust): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTlsValidationTrustOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTlsValidationTrust | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTlsValidationTrust | undefined);
    private _file;
    /**
     * @stability stable
     */
    get file(): AppmeshVirtualNodeSpecListenerTlsValidationTrustFileOutputReference;
    /**
     * @stability stable
     */
    putFile(value: AppmeshVirtualNodeSpecListenerTlsValidationTrustFile): void;
    /**
     * @stability stable
     */
    resetFile(): void;
    /**
     * @stability stable
     */
    get fileInput(): AppmeshVirtualNodeSpecListenerTlsValidationTrustFile | undefined;
    private _sds;
    /**
     * @stability stable
     */
    get sds(): AppmeshVirtualNodeSpecListenerTlsValidationTrustSdsOutputReference;
    /**
     * @stability stable
     */
    putSds(value: AppmeshVirtualNodeSpecListenerTlsValidationTrustSds): void;
    /**
     * @stability stable
     */
    resetSds(): void;
    /**
     * @stability stable
     */
    get sdsInput(): AppmeshVirtualNodeSpecListenerTlsValidationTrustSds | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTlsValidation {
    /**
     * subject_alternative_names block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#subject_alternative_names AppmeshVirtualNode#subject_alternative_names}
     *
     * @stability stable
     */
    readonly subjectAlternativeNames?: AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNames;
    /**
     * trust block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#trust AppmeshVirtualNode#trust}
     *
     * @stability stable
     */
    readonly trust: AppmeshVirtualNodeSpecListenerTlsValidationTrust;
}
export declare function appmeshVirtualNodeSpecListenerTlsValidationToTerraform(struct?: AppmeshVirtualNodeSpecListenerTlsValidationOutputReference | AppmeshVirtualNodeSpecListenerTlsValidation): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTlsValidationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTlsValidation | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTlsValidation | undefined);
    private _subjectAlternativeNames;
    /**
     * @stability stable
     */
    get subjectAlternativeNames(): AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNamesOutputReference;
    /**
     * @stability stable
     */
    putSubjectAlternativeNames(value: AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNames): void;
    /**
     * @stability stable
     */
    resetSubjectAlternativeNames(): void;
    /**
     * @stability stable
     */
    get subjectAlternativeNamesInput(): AppmeshVirtualNodeSpecListenerTlsValidationSubjectAlternativeNames | undefined;
    private _trust;
    /**
     * @stability stable
     */
    get trust(): AppmeshVirtualNodeSpecListenerTlsValidationTrustOutputReference;
    /**
     * @stability stable
     */
    putTrust(value: AppmeshVirtualNodeSpecListenerTlsValidationTrust): void;
    /**
     * @stability stable
     */
    get trustInput(): AppmeshVirtualNodeSpecListenerTlsValidationTrust | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListenerTls {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#mode AppmeshVirtualNode#mode}.
     *
     * @stability stable
     */
    readonly mode: string;
    /**
     * certificate block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#certificate AppmeshVirtualNode#certificate}
     *
     * @stability stable
     */
    readonly certificate: AppmeshVirtualNodeSpecListenerTlsCertificate;
    /**
     * validation block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#validation AppmeshVirtualNode#validation}
     *
     * @stability stable
     */
    readonly validation?: AppmeshVirtualNodeSpecListenerTlsValidation;
}
export declare function appmeshVirtualNodeSpecListenerTlsToTerraform(struct?: AppmeshVirtualNodeSpecListenerTlsOutputReference | AppmeshVirtualNodeSpecListenerTls): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerTlsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListenerTls | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListenerTls | undefined);
    private _mode?;
    /**
     * @stability stable
     */
    get mode(): string;
    /**
     * @stability stable
     */
    set mode(value: string);
    /**
     * @stability stable
     */
    get modeInput(): string | undefined;
    private _certificate;
    /**
     * @stability stable
     */
    get certificate(): AppmeshVirtualNodeSpecListenerTlsCertificateOutputReference;
    /**
     * @stability stable
     */
    putCertificate(value: AppmeshVirtualNodeSpecListenerTlsCertificate): void;
    /**
     * @stability stable
     */
    get certificateInput(): AppmeshVirtualNodeSpecListenerTlsCertificate | undefined;
    private _validation;
    /**
     * @stability stable
     */
    get validation(): AppmeshVirtualNodeSpecListenerTlsValidationOutputReference;
    /**
     * @stability stable
     */
    putValidation(value: AppmeshVirtualNodeSpecListenerTlsValidation): void;
    /**
     * @stability stable
     */
    resetValidation(): void;
    /**
     * @stability stable
     */
    get validationInput(): AppmeshVirtualNodeSpecListenerTlsValidation | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecListener {
    /**
     * connection_pool block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#connection_pool AppmeshVirtualNode#connection_pool}
     *
     * @stability stable
     */
    readonly connectionPool?: AppmeshVirtualNodeSpecListenerConnectionPool;
    /**
     * health_check block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#health_check AppmeshVirtualNode#health_check}
     *
     * @stability stable
     */
    readonly healthCheck?: AppmeshVirtualNodeSpecListenerHealthCheck;
    /**
     * outlier_detection block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#outlier_detection AppmeshVirtualNode#outlier_detection}
     *
     * @stability stable
     */
    readonly outlierDetection?: AppmeshVirtualNodeSpecListenerOutlierDetection;
    /**
     * port_mapping block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#port_mapping AppmeshVirtualNode#port_mapping}
     *
     * @stability stable
     */
    readonly portMapping: AppmeshVirtualNodeSpecListenerPortMapping;
    /**
     * timeout block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#timeout AppmeshVirtualNode#timeout}
     *
     * @stability stable
     */
    readonly timeout?: AppmeshVirtualNodeSpecListenerTimeout;
    /**
     * tls block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#tls AppmeshVirtualNode#tls}
     *
     * @stability stable
     */
    readonly tls?: AppmeshVirtualNodeSpecListenerTls;
}
export declare function appmeshVirtualNodeSpecListenerToTerraform(struct?: AppmeshVirtualNodeSpecListenerOutputReference | AppmeshVirtualNodeSpecListener): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecListenerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecListener | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecListener | undefined);
    private _connectionPool;
    /**
     * @stability stable
     */
    get connectionPool(): AppmeshVirtualNodeSpecListenerConnectionPoolOutputReference;
    /**
     * @stability stable
     */
    putConnectionPool(value: AppmeshVirtualNodeSpecListenerConnectionPool): void;
    /**
     * @stability stable
     */
    resetConnectionPool(): void;
    /**
     * @stability stable
     */
    get connectionPoolInput(): AppmeshVirtualNodeSpecListenerConnectionPool | undefined;
    private _healthCheck;
    /**
     * @stability stable
     */
    get healthCheck(): AppmeshVirtualNodeSpecListenerHealthCheckOutputReference;
    /**
     * @stability stable
     */
    putHealthCheck(value: AppmeshVirtualNodeSpecListenerHealthCheck): void;
    /**
     * @stability stable
     */
    resetHealthCheck(): void;
    /**
     * @stability stable
     */
    get healthCheckInput(): AppmeshVirtualNodeSpecListenerHealthCheck | undefined;
    private _outlierDetection;
    /**
     * @stability stable
     */
    get outlierDetection(): AppmeshVirtualNodeSpecListenerOutlierDetectionOutputReference;
    /**
     * @stability stable
     */
    putOutlierDetection(value: AppmeshVirtualNodeSpecListenerOutlierDetection): void;
    /**
     * @stability stable
     */
    resetOutlierDetection(): void;
    /**
     * @stability stable
     */
    get outlierDetectionInput(): AppmeshVirtualNodeSpecListenerOutlierDetection | undefined;
    private _portMapping;
    /**
     * @stability stable
     */
    get portMapping(): AppmeshVirtualNodeSpecListenerPortMappingOutputReference;
    /**
     * @stability stable
     */
    putPortMapping(value: AppmeshVirtualNodeSpecListenerPortMapping): void;
    /**
     * @stability stable
     */
    get portMappingInput(): AppmeshVirtualNodeSpecListenerPortMapping | undefined;
    private _timeout;
    /**
     * @stability stable
     */
    get timeout(): AppmeshVirtualNodeSpecListenerTimeoutOutputReference;
    /**
     * @stability stable
     */
    putTimeout(value: AppmeshVirtualNodeSpecListenerTimeout): void;
    /**
     * @stability stable
     */
    resetTimeout(): void;
    /**
     * @stability stable
     */
    get timeoutInput(): AppmeshVirtualNodeSpecListenerTimeout | undefined;
    private _tls;
    /**
     * @stability stable
     */
    get tls(): AppmeshVirtualNodeSpecListenerTlsOutputReference;
    /**
     * @stability stable
     */
    putTls(value: AppmeshVirtualNodeSpecListenerTls): void;
    /**
     * @stability stable
     */
    resetTls(): void;
    /**
     * @stability stable
     */
    get tlsInput(): AppmeshVirtualNodeSpecListenerTls | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecLoggingAccessLogFile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#path AppmeshVirtualNode#path}.
     *
     * @stability stable
     */
    readonly path: string;
}
export declare function appmeshVirtualNodeSpecLoggingAccessLogFileToTerraform(struct?: AppmeshVirtualNodeSpecLoggingAccessLogFileOutputReference | AppmeshVirtualNodeSpecLoggingAccessLogFile): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecLoggingAccessLogFileOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecLoggingAccessLogFile | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecLoggingAccessLogFile | undefined);
    private _path?;
    /**
     * @stability stable
     */
    get path(): string;
    /**
     * @stability stable
     */
    set path(value: string);
    /**
     * @stability stable
     */
    get pathInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecLoggingAccessLog {
    /**
     * file block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#file AppmeshVirtualNode#file}
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualNodeSpecLoggingAccessLogFile;
}
export declare function appmeshVirtualNodeSpecLoggingAccessLogToTerraform(struct?: AppmeshVirtualNodeSpecLoggingAccessLogOutputReference | AppmeshVirtualNodeSpecLoggingAccessLog): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecLoggingAccessLogOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecLoggingAccessLog | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecLoggingAccessLog | undefined);
    private _file;
    /**
     * @stability stable
     */
    get file(): AppmeshVirtualNodeSpecLoggingAccessLogFileOutputReference;
    /**
     * @stability stable
     */
    putFile(value: AppmeshVirtualNodeSpecLoggingAccessLogFile): void;
    /**
     * @stability stable
     */
    resetFile(): void;
    /**
     * @stability stable
     */
    get fileInput(): AppmeshVirtualNodeSpecLoggingAccessLogFile | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecLogging {
    /**
     * access_log block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#access_log AppmeshVirtualNode#access_log}
     *
     * @stability stable
     */
    readonly accessLog?: AppmeshVirtualNodeSpecLoggingAccessLog;
}
export declare function appmeshVirtualNodeSpecLoggingToTerraform(struct?: AppmeshVirtualNodeSpecLoggingOutputReference | AppmeshVirtualNodeSpecLogging): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecLoggingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecLogging | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecLogging | undefined);
    private _accessLog;
    /**
     * @stability stable
     */
    get accessLog(): AppmeshVirtualNodeSpecLoggingAccessLogOutputReference;
    /**
     * @stability stable
     */
    putAccessLog(value: AppmeshVirtualNodeSpecLoggingAccessLog): void;
    /**
     * @stability stable
     */
    resetAccessLog(): void;
    /**
     * @stability stable
     */
    get accessLogInput(): AppmeshVirtualNodeSpecLoggingAccessLog | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecServiceDiscoveryAwsCloudMap {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#attributes AppmeshVirtualNode#attributes}.
     *
     * @stability stable
     */
    readonly attributes?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#namespace_name AppmeshVirtualNode#namespace_name}.
     *
     * @stability stable
     */
    readonly namespaceName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#service_name AppmeshVirtualNode#service_name}.
     *
     * @stability stable
     */
    readonly serviceName: string;
}
export declare function appmeshVirtualNodeSpecServiceDiscoveryAwsCloudMapToTerraform(struct?: AppmeshVirtualNodeSpecServiceDiscoveryAwsCloudMapOutputReference | AppmeshVirtualNodeSpecServiceDiscoveryAwsCloudMap): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecServiceDiscoveryAwsCloudMapOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecServiceDiscoveryAwsCloudMap | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecServiceDiscoveryAwsCloudMap | undefined);
    private _attributes?;
    /**
     * @stability stable
     */
    get attributes(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set attributes(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAttributes(): void;
    /**
     * @stability stable
     */
    get attributesInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _namespaceName?;
    /**
     * @stability stable
     */
    get namespaceName(): string;
    /**
     * @stability stable
     */
    set namespaceName(value: string);
    /**
     * @stability stable
     */
    get namespaceNameInput(): string | undefined;
    private _serviceName?;
    /**
     * @stability stable
     */
    get serviceName(): string;
    /**
     * @stability stable
     */
    set serviceName(value: string);
    /**
     * @stability stable
     */
    get serviceNameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecServiceDiscoveryDns {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#hostname AppmeshVirtualNode#hostname}.
     *
     * @stability stable
     */
    readonly hostname: string;
}
export declare function appmeshVirtualNodeSpecServiceDiscoveryDnsToTerraform(struct?: AppmeshVirtualNodeSpecServiceDiscoveryDnsOutputReference | AppmeshVirtualNodeSpecServiceDiscoveryDns): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecServiceDiscoveryDnsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecServiceDiscoveryDns | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecServiceDiscoveryDns | undefined);
    private _hostname?;
    /**
     * @stability stable
     */
    get hostname(): string;
    /**
     * @stability stable
     */
    set hostname(value: string);
    /**
     * @stability stable
     */
    get hostnameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpecServiceDiscovery {
    /**
     * aws_cloud_map block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#aws_cloud_map AppmeshVirtualNode#aws_cloud_map}
     *
     * @stability stable
     */
    readonly awsCloudMap?: AppmeshVirtualNodeSpecServiceDiscoveryAwsCloudMap;
    /**
     * dns block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#dns AppmeshVirtualNode#dns}
     *
     * @stability stable
     */
    readonly dns?: AppmeshVirtualNodeSpecServiceDiscoveryDns;
}
export declare function appmeshVirtualNodeSpecServiceDiscoveryToTerraform(struct?: AppmeshVirtualNodeSpecServiceDiscoveryOutputReference | AppmeshVirtualNodeSpecServiceDiscovery): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecServiceDiscoveryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpecServiceDiscovery | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpecServiceDiscovery | undefined);
    private _awsCloudMap;
    /**
     * @stability stable
     */
    get awsCloudMap(): AppmeshVirtualNodeSpecServiceDiscoveryAwsCloudMapOutputReference;
    /**
     * @stability stable
     */
    putAwsCloudMap(value: AppmeshVirtualNodeSpecServiceDiscoveryAwsCloudMap): void;
    /**
     * @stability stable
     */
    resetAwsCloudMap(): void;
    /**
     * @stability stable
     */
    get awsCloudMapInput(): AppmeshVirtualNodeSpecServiceDiscoveryAwsCloudMap | undefined;
    private _dns;
    /**
     * @stability stable
     */
    get dns(): AppmeshVirtualNodeSpecServiceDiscoveryDnsOutputReference;
    /**
     * @stability stable
     */
    putDns(value: AppmeshVirtualNodeSpecServiceDiscoveryDns): void;
    /**
     * @stability stable
     */
    resetDns(): void;
    /**
     * @stability stable
     */
    get dnsInput(): AppmeshVirtualNodeSpecServiceDiscoveryDns | undefined;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualNodeSpec {
    /**
     * backend block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#backend AppmeshVirtualNode#backend}
     *
     * @stability stable
     */
    readonly backend?: AppmeshVirtualNodeSpecBackend[];
    /**
     * backend_defaults block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#backend_defaults AppmeshVirtualNode#backend_defaults}
     *
     * @stability stable
     */
    readonly backendDefaults?: AppmeshVirtualNodeSpecBackendDefaults;
    /**
     * listener block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#listener AppmeshVirtualNode#listener}
     *
     * @stability stable
     */
    readonly listener?: AppmeshVirtualNodeSpecListener;
    /**
     * logging block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#logging AppmeshVirtualNode#logging}
     *
     * @stability stable
     */
    readonly logging?: AppmeshVirtualNodeSpecLogging;
    /**
     * service_discovery block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node#service_discovery AppmeshVirtualNode#service_discovery}
     *
     * @stability stable
     */
    readonly serviceDiscovery?: AppmeshVirtualNodeSpecServiceDiscovery;
}
export declare function appmeshVirtualNodeSpecToTerraform(struct?: AppmeshVirtualNodeSpecOutputReference | AppmeshVirtualNodeSpec): any;
/**
 * @stability stable
 */
export declare class AppmeshVirtualNodeSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppmeshVirtualNodeSpec | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppmeshVirtualNodeSpec | undefined);
    private _backend?;
    /**
     * @stability stable
     */
    get backend(): AppmeshVirtualNodeSpecBackend[];
    /**
     * @stability stable
     */
    set backend(value: AppmeshVirtualNodeSpecBackend[]);
    /**
     * @stability stable
     */
    resetBackend(): void;
    /**
     * @stability stable
     */
    get backendInput(): AppmeshVirtualNodeSpecBackend[] | undefined;
    private _backendDefaults;
    /**
     * @stability stable
     */
    get backendDefaults(): AppmeshVirtualNodeSpecBackendDefaultsOutputReference;
    /**
     * @stability stable
     */
    putBackendDefaults(value: AppmeshVirtualNodeSpecBackendDefaults): void;
    /**
     * @stability stable
     */
    resetBackendDefaults(): void;
    /**
     * @stability stable
     */
    get backendDefaultsInput(): AppmeshVirtualNodeSpecBackendDefaults | undefined;
    private _listener;
    /**
     * @stability stable
     */
    get listener(): AppmeshVirtualNodeSpecListenerOutputReference;
    /**
     * @stability stable
     */
    putListener(value: AppmeshVirtualNodeSpecListener): void;
    /**
     * @stability stable
     */
    resetListener(): void;
    /**
     * @stability stable
     */
    get listenerInput(): AppmeshVirtualNodeSpecListener | undefined;
    private _logging;
    /**
     * @stability stable
     */
    get logging(): AppmeshVirtualNodeSpecLoggingOutputReference;
    /**
     * @stability stable
     */
    putLogging(value: AppmeshVirtualNodeSpecLogging): void;
    /**
     * @stability stable
     */
    resetLogging(): void;
    /**
     * @stability stable
     */
    get loggingInput(): AppmeshVirtualNodeSpecLogging | undefined;
    private _serviceDiscovery;
    /**
     * @stability stable
     */
    get serviceDiscovery(): AppmeshVirtualNodeSpecServiceDiscoveryOutputReference;
    /**
     * @stability stable
     */
    putServiceDiscovery(value: AppmeshVirtualNodeSpecServiceDiscovery): void;
    /**
     * @stability stable
     */
    resetServiceDiscovery(): void;
    /**
     * @stability stable
     */
    get serviceDiscoveryInput(): AppmeshVirtualNodeSpecServiceDiscovery | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node aws_appmesh_virtual_node}.
 *
 * @stability stable
 */
export declare class AppmeshVirtualNode extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appmesh_virtual_node aws_appmesh_virtual_node} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppmeshVirtualNodeConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get createdDate(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedDate(): string;
    private _meshName?;
    /**
     * @stability stable
     */
    get meshName(): string;
    /**
     * @stability stable
     */
    set meshName(value: string);
    /**
     * @stability stable
     */
    get meshNameInput(): string | undefined;
    private _meshOwner?;
    /**
     * @stability stable
     */
    get meshOwner(): string;
    /**
     * @stability stable
     */
    set meshOwner(value: string);
    /**
     * @stability stable
     */
    resetMeshOwner(): void;
    /**
     * @stability stable
     */
    get meshOwnerInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get resourceOwner(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _spec;
    /**
     * @stability stable
     */
    get spec(): AppmeshVirtualNodeSpecOutputReference;
    /**
     * @stability stable
     */
    putSpec(value: AppmeshVirtualNodeSpec): void;
    /**
     * @stability stable
     */
    get specInput(): AppmeshVirtualNodeSpec | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
