import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AppStream.
 *
 * @stability stable
 */
export interface AppstreamFleetConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#description AppstreamFleet#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#disconnect_timeout_in_seconds AppstreamFleet#disconnect_timeout_in_seconds}.
     *
     * @stability stable
     */
    readonly disconnectTimeoutInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#display_name AppstreamFleet#display_name}.
     *
     * @stability stable
     */
    readonly displayName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#enable_default_internet_access AppstreamFleet#enable_default_internet_access}.
     *
     * @stability stable
     */
    readonly enableDefaultInternetAccess?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#fleet_type AppstreamFleet#fleet_type}.
     *
     * @stability stable
     */
    readonly fleetType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#iam_role_arn AppstreamFleet#iam_role_arn}.
     *
     * @stability stable
     */
    readonly iamRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#idle_disconnect_timeout_in_seconds AppstreamFleet#idle_disconnect_timeout_in_seconds}.
     *
     * @stability stable
     */
    readonly idleDisconnectTimeoutInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#image_arn AppstreamFleet#image_arn}.
     *
     * @stability stable
     */
    readonly imageArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#image_name AppstreamFleet#image_name}.
     *
     * @stability stable
     */
    readonly imageName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#instance_type AppstreamFleet#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#max_user_duration_in_seconds AppstreamFleet#max_user_duration_in_seconds}.
     *
     * @stability stable
     */
    readonly maxUserDurationInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#name AppstreamFleet#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#stream_view AppstreamFleet#stream_view}.
     *
     * @stability stable
     */
    readonly streamView?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#tags AppstreamFleet#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#tags_all AppstreamFleet#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * compute_capacity block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#compute_capacity AppstreamFleet#compute_capacity}
     *
     * @stability stable
     */
    readonly computeCapacity: AppstreamFleetComputeCapacity;
    /**
     * domain_join_info block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#domain_join_info AppstreamFleet#domain_join_info}
     *
     * @stability stable
     */
    readonly domainJoinInfo?: AppstreamFleetDomainJoinInfo;
    /**
     * vpc_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#vpc_config AppstreamFleet#vpc_config}
     *
     * @stability stable
     */
    readonly vpcConfig?: AppstreamFleetVpcConfig;
}
/**
 * @stability stable
 */
export interface AppstreamFleetComputeCapacity {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#desired_instances AppstreamFleet#desired_instances}.
     *
     * @stability stable
     */
    readonly desiredInstances: number;
}
export declare function appstreamFleetComputeCapacityToTerraform(struct?: AppstreamFleetComputeCapacityOutputReference | AppstreamFleetComputeCapacity): any;
/**
 * @stability stable
 */
export declare class AppstreamFleetComputeCapacityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppstreamFleetComputeCapacity | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppstreamFleetComputeCapacity | undefined);
    private _desiredInstances?;
    /**
     * @stability stable
     */
    get desiredInstances(): number;
    /**
     * @stability stable
     */
    set desiredInstances(value: number);
    /**
     * @stability stable
     */
    get desiredInstancesInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppstreamFleetDomainJoinInfo {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#directory_name AppstreamFleet#directory_name}.
     *
     * @stability stable
     */
    readonly directoryName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#organizational_unit_distinguished_name AppstreamFleet#organizational_unit_distinguished_name}.
     *
     * @stability stable
     */
    readonly organizationalUnitDistinguishedName?: string;
}
export declare function appstreamFleetDomainJoinInfoToTerraform(struct?: AppstreamFleetDomainJoinInfoOutputReference | AppstreamFleetDomainJoinInfo): any;
/**
 * @stability stable
 */
export declare class AppstreamFleetDomainJoinInfoOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppstreamFleetDomainJoinInfo | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppstreamFleetDomainJoinInfo | undefined);
    private _directoryName?;
    /**
     * @stability stable
     */
    get directoryName(): string;
    /**
     * @stability stable
     */
    set directoryName(value: string);
    /**
     * @stability stable
     */
    resetDirectoryName(): void;
    /**
     * @stability stable
     */
    get directoryNameInput(): string | undefined;
    private _organizationalUnitDistinguishedName?;
    /**
     * @stability stable
     */
    get organizationalUnitDistinguishedName(): string;
    /**
     * @stability stable
     */
    set organizationalUnitDistinguishedName(value: string);
    /**
     * @stability stable
     */
    resetOrganizationalUnitDistinguishedName(): void;
    /**
     * @stability stable
     */
    get organizationalUnitDistinguishedNameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppstreamFleetVpcConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#security_group_ids AppstreamFleet#security_group_ids}.
     *
     * @stability stable
     */
    readonly securityGroupIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet#subnet_ids AppstreamFleet#subnet_ids}.
     *
     * @stability stable
     */
    readonly subnetIds?: string[];
}
export declare function appstreamFleetVpcConfigToTerraform(struct?: AppstreamFleetVpcConfigOutputReference | AppstreamFleetVpcConfig): any;
/**
 * @stability stable
 */
export declare class AppstreamFleetVpcConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppstreamFleetVpcConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppstreamFleetVpcConfig | undefined);
    private _securityGroupIds?;
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    set securityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get securityGroupIdsInput(): string[] | undefined;
    private _subnetIds?;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    resetSubnetIds(): void;
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[] | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet aws_appstream_fleet}.
 *
 * @stability stable
 */
export declare class AppstreamFleet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appstream_fleet aws_appstream_fleet} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppstreamFleetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get createdTime(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _disconnectTimeoutInSeconds?;
    /**
     * @stability stable
     */
    get disconnectTimeoutInSeconds(): number;
    /**
     * @stability stable
     */
    set disconnectTimeoutInSeconds(value: number);
    /**
     * @stability stable
     */
    resetDisconnectTimeoutInSeconds(): void;
    /**
     * @stability stable
     */
    get disconnectTimeoutInSecondsInput(): number | undefined;
    private _displayName?;
    /**
     * @stability stable
     */
    get displayName(): string;
    /**
     * @stability stable
     */
    set displayName(value: string);
    /**
     * @stability stable
     */
    resetDisplayName(): void;
    /**
     * @stability stable
     */
    get displayNameInput(): string | undefined;
    private _enableDefaultInternetAccess?;
    /**
     * @stability stable
     */
    get enableDefaultInternetAccess(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enableDefaultInternetAccess(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnableDefaultInternetAccess(): void;
    /**
     * @stability stable
     */
    get enableDefaultInternetAccessInput(): boolean | cdktf.IResolvable | undefined;
    private _fleetType?;
    /**
     * @stability stable
     */
    get fleetType(): string;
    /**
     * @stability stable
     */
    set fleetType(value: string);
    /**
     * @stability stable
     */
    resetFleetType(): void;
    /**
     * @stability stable
     */
    get fleetTypeInput(): string | undefined;
    private _iamRoleArn?;
    /**
     * @stability stable
     */
    get iamRoleArn(): string;
    /**
     * @stability stable
     */
    set iamRoleArn(value: string);
    /**
     * @stability stable
     */
    resetIamRoleArn(): void;
    /**
     * @stability stable
     */
    get iamRoleArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _idleDisconnectTimeoutInSeconds?;
    /**
     * @stability stable
     */
    get idleDisconnectTimeoutInSeconds(): number;
    /**
     * @stability stable
     */
    set idleDisconnectTimeoutInSeconds(value: number);
    /**
     * @stability stable
     */
    resetIdleDisconnectTimeoutInSeconds(): void;
    /**
     * @stability stable
     */
    get idleDisconnectTimeoutInSecondsInput(): number | undefined;
    private _imageArn?;
    /**
     * @stability stable
     */
    get imageArn(): string;
    /**
     * @stability stable
     */
    set imageArn(value: string);
    /**
     * @stability stable
     */
    resetImageArn(): void;
    /**
     * @stability stable
     */
    get imageArnInput(): string | undefined;
    private _imageName?;
    /**
     * @stability stable
     */
    get imageName(): string;
    /**
     * @stability stable
     */
    set imageName(value: string);
    /**
     * @stability stable
     */
    resetImageName(): void;
    /**
     * @stability stable
     */
    get imageNameInput(): string | undefined;
    private _instanceType?;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    get instanceTypeInput(): string | undefined;
    private _maxUserDurationInSeconds?;
    /**
     * @stability stable
     */
    get maxUserDurationInSeconds(): number;
    /**
     * @stability stable
     */
    set maxUserDurationInSeconds(value: number);
    /**
     * @stability stable
     */
    resetMaxUserDurationInSeconds(): void;
    /**
     * @stability stable
     */
    get maxUserDurationInSecondsInput(): number | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get state(): string;
    private _streamView?;
    /**
     * @stability stable
     */
    get streamView(): string;
    /**
     * @stability stable
     */
    set streamView(value: string);
    /**
     * @stability stable
     */
    resetStreamView(): void;
    /**
     * @stability stable
     */
    get streamViewInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _computeCapacity;
    /**
     * @stability stable
     */
    get computeCapacity(): AppstreamFleetComputeCapacityOutputReference;
    /**
     * @stability stable
     */
    putComputeCapacity(value: AppstreamFleetComputeCapacity): void;
    /**
     * @stability stable
     */
    get computeCapacityInput(): AppstreamFleetComputeCapacity | undefined;
    private _domainJoinInfo;
    /**
     * @stability stable
     */
    get domainJoinInfo(): AppstreamFleetDomainJoinInfoOutputReference;
    /**
     * @stability stable
     */
    putDomainJoinInfo(value: AppstreamFleetDomainJoinInfo): void;
    /**
     * @stability stable
     */
    resetDomainJoinInfo(): void;
    /**
     * @stability stable
     */
    get domainJoinInfoInput(): AppstreamFleetDomainJoinInfo | undefined;
    private _vpcConfig;
    /**
     * @stability stable
     */
    get vpcConfig(): AppstreamFleetVpcConfigOutputReference;
    /**
     * @stability stable
     */
    putVpcConfig(value: AppstreamFleetVpcConfig): void;
    /**
     * @stability stable
     */
    resetVpcConfig(): void;
    /**
     * @stability stable
     */
    get vpcConfigInput(): AppstreamFleetVpcConfig | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
