import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS AppSync.
 *
 * @stability stable
 */
export interface AppsyncDatasourceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#api_id AppsyncDatasource#api_id}.
     *
     * @stability stable
     */
    readonly apiId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#description AppsyncDatasource#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#name AppsyncDatasource#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#service_role_arn AppsyncDatasource#service_role_arn}.
     *
     * @stability stable
     */
    readonly serviceRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#type AppsyncDatasource#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * dynamodb_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#dynamodb_config AppsyncDatasource#dynamodb_config}
     *
     * @stability stable
     */
    readonly dynamodbConfig?: AppsyncDatasourceDynamodbConfig;
    /**
     * elasticsearch_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#elasticsearch_config AppsyncDatasource#elasticsearch_config}
     *
     * @stability stable
     */
    readonly elasticsearchConfig?: AppsyncDatasourceElasticsearchConfig;
    /**
     * http_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#http_config AppsyncDatasource#http_config}
     *
     * @stability stable
     */
    readonly httpConfig?: AppsyncDatasourceHttpConfig;
    /**
     * lambda_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#lambda_config AppsyncDatasource#lambda_config}
     *
     * @stability stable
     */
    readonly lambdaConfig?: AppsyncDatasourceLambdaConfig;
    /**
     * relational_database_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#relational_database_config AppsyncDatasource#relational_database_config}
     *
     * @stability stable
     */
    readonly relationalDatabaseConfig?: AppsyncDatasourceRelationalDatabaseConfig;
}
/**
 * @stability stable
 */
export interface AppsyncDatasourceDynamodbConfigDeltaSyncConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#base_table_ttl AppsyncDatasource#base_table_ttl}.
     *
     * @stability stable
     */
    readonly baseTableTtl?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#delta_sync_table_name AppsyncDatasource#delta_sync_table_name}.
     *
     * @stability stable
     */
    readonly deltaSyncTableName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#delta_sync_table_ttl AppsyncDatasource#delta_sync_table_ttl}.
     *
     * @stability stable
     */
    readonly deltaSyncTableTtl?: number;
}
export declare function appsyncDatasourceDynamodbConfigDeltaSyncConfigToTerraform(struct?: AppsyncDatasourceDynamodbConfigDeltaSyncConfigOutputReference | AppsyncDatasourceDynamodbConfigDeltaSyncConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncDatasourceDynamodbConfigDeltaSyncConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncDatasourceDynamodbConfigDeltaSyncConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncDatasourceDynamodbConfigDeltaSyncConfig | undefined);
    private _baseTableTtl?;
    /**
     * @stability stable
     */
    get baseTableTtl(): number;
    /**
     * @stability stable
     */
    set baseTableTtl(value: number);
    /**
     * @stability stable
     */
    resetBaseTableTtl(): void;
    /**
     * @stability stable
     */
    get baseTableTtlInput(): number | undefined;
    private _deltaSyncTableName?;
    /**
     * @stability stable
     */
    get deltaSyncTableName(): string;
    /**
     * @stability stable
     */
    set deltaSyncTableName(value: string);
    /**
     * @stability stable
     */
    get deltaSyncTableNameInput(): string | undefined;
    private _deltaSyncTableTtl?;
    /**
     * @stability stable
     */
    get deltaSyncTableTtl(): number;
    /**
     * @stability stable
     */
    set deltaSyncTableTtl(value: number);
    /**
     * @stability stable
     */
    resetDeltaSyncTableTtl(): void;
    /**
     * @stability stable
     */
    get deltaSyncTableTtlInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface AppsyncDatasourceDynamodbConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#region AppsyncDatasource#region}.
     *
     * @stability stable
     */
    readonly region?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#table_name AppsyncDatasource#table_name}.
     *
     * @stability stable
     */
    readonly tableName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#use_caller_credentials AppsyncDatasource#use_caller_credentials}.
     *
     * @stability stable
     */
    readonly useCallerCredentials?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#versioned AppsyncDatasource#versioned}.
     *
     * @stability stable
     */
    readonly versioned?: boolean | cdktf.IResolvable;
    /**
     * delta_sync_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#delta_sync_config AppsyncDatasource#delta_sync_config}
     *
     * @stability stable
     */
    readonly deltaSyncConfig?: AppsyncDatasourceDynamodbConfigDeltaSyncConfig;
}
export declare function appsyncDatasourceDynamodbConfigToTerraform(struct?: AppsyncDatasourceDynamodbConfigOutputReference | AppsyncDatasourceDynamodbConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncDatasourceDynamodbConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncDatasourceDynamodbConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncDatasourceDynamodbConfig | undefined);
    private _region?;
    /**
     * @stability stable
     */
    get region(): string;
    /**
     * @stability stable
     */
    set region(value: string);
    /**
     * @stability stable
     */
    resetRegion(): void;
    /**
     * @stability stable
     */
    get regionInput(): string | undefined;
    private _tableName?;
    /**
     * @stability stable
     */
    get tableName(): string;
    /**
     * @stability stable
     */
    set tableName(value: string);
    /**
     * @stability stable
     */
    get tableNameInput(): string | undefined;
    private _useCallerCredentials?;
    /**
     * @stability stable
     */
    get useCallerCredentials(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set useCallerCredentials(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetUseCallerCredentials(): void;
    /**
     * @stability stable
     */
    get useCallerCredentialsInput(): boolean | cdktf.IResolvable | undefined;
    private _versioned?;
    /**
     * @stability stable
     */
    get versioned(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set versioned(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetVersioned(): void;
    /**
     * @stability stable
     */
    get versionedInput(): boolean | cdktf.IResolvable | undefined;
    private _deltaSyncConfig;
    /**
     * @stability stable
     */
    get deltaSyncConfig(): AppsyncDatasourceDynamodbConfigDeltaSyncConfigOutputReference;
    /**
     * @stability stable
     */
    putDeltaSyncConfig(value: AppsyncDatasourceDynamodbConfigDeltaSyncConfig): void;
    /**
     * @stability stable
     */
    resetDeltaSyncConfig(): void;
    /**
     * @stability stable
     */
    get deltaSyncConfigInput(): AppsyncDatasourceDynamodbConfigDeltaSyncConfig | undefined;
}
/**
 * @stability stable
 */
export interface AppsyncDatasourceElasticsearchConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#endpoint AppsyncDatasource#endpoint}.
     *
     * @stability stable
     */
    readonly endpoint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#region AppsyncDatasource#region}.
     *
     * @stability stable
     */
    readonly region?: string;
}
export declare function appsyncDatasourceElasticsearchConfigToTerraform(struct?: AppsyncDatasourceElasticsearchConfigOutputReference | AppsyncDatasourceElasticsearchConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncDatasourceElasticsearchConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncDatasourceElasticsearchConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncDatasourceElasticsearchConfig | undefined);
    private _endpoint?;
    /**
     * @stability stable
     */
    get endpoint(): string;
    /**
     * @stability stable
     */
    set endpoint(value: string);
    /**
     * @stability stable
     */
    get endpointInput(): string | undefined;
    private _region?;
    /**
     * @stability stable
     */
    get region(): string;
    /**
     * @stability stable
     */
    set region(value: string);
    /**
     * @stability stable
     */
    resetRegion(): void;
    /**
     * @stability stable
     */
    get regionInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppsyncDatasourceHttpConfigAuthorizationConfigAwsIamConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#signing_region AppsyncDatasource#signing_region}.
     *
     * @stability stable
     */
    readonly signingRegion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#signing_service_name AppsyncDatasource#signing_service_name}.
     *
     * @stability stable
     */
    readonly signingServiceName?: string;
}
export declare function appsyncDatasourceHttpConfigAuthorizationConfigAwsIamConfigToTerraform(struct?: AppsyncDatasourceHttpConfigAuthorizationConfigAwsIamConfigOutputReference | AppsyncDatasourceHttpConfigAuthorizationConfigAwsIamConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncDatasourceHttpConfigAuthorizationConfigAwsIamConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncDatasourceHttpConfigAuthorizationConfigAwsIamConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncDatasourceHttpConfigAuthorizationConfigAwsIamConfig | undefined);
    private _signingRegion?;
    /**
     * @stability stable
     */
    get signingRegion(): string;
    /**
     * @stability stable
     */
    set signingRegion(value: string);
    /**
     * @stability stable
     */
    resetSigningRegion(): void;
    /**
     * @stability stable
     */
    get signingRegionInput(): string | undefined;
    private _signingServiceName?;
    /**
     * @stability stable
     */
    get signingServiceName(): string;
    /**
     * @stability stable
     */
    set signingServiceName(value: string);
    /**
     * @stability stable
     */
    resetSigningServiceName(): void;
    /**
     * @stability stable
     */
    get signingServiceNameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppsyncDatasourceHttpConfigAuthorizationConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#authorization_type AppsyncDatasource#authorization_type}.
     *
     * @stability stable
     */
    readonly authorizationType?: string;
    /**
     * aws_iam_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#aws_iam_config AppsyncDatasource#aws_iam_config}
     *
     * @stability stable
     */
    readonly awsIamConfig?: AppsyncDatasourceHttpConfigAuthorizationConfigAwsIamConfig;
}
export declare function appsyncDatasourceHttpConfigAuthorizationConfigToTerraform(struct?: AppsyncDatasourceHttpConfigAuthorizationConfigOutputReference | AppsyncDatasourceHttpConfigAuthorizationConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncDatasourceHttpConfigAuthorizationConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncDatasourceHttpConfigAuthorizationConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncDatasourceHttpConfigAuthorizationConfig | undefined);
    private _authorizationType?;
    /**
     * @stability stable
     */
    get authorizationType(): string;
    /**
     * @stability stable
     */
    set authorizationType(value: string);
    /**
     * @stability stable
     */
    resetAuthorizationType(): void;
    /**
     * @stability stable
     */
    get authorizationTypeInput(): string | undefined;
    private _awsIamConfig;
    /**
     * @stability stable
     */
    get awsIamConfig(): AppsyncDatasourceHttpConfigAuthorizationConfigAwsIamConfigOutputReference;
    /**
     * @stability stable
     */
    putAwsIamConfig(value: AppsyncDatasourceHttpConfigAuthorizationConfigAwsIamConfig): void;
    /**
     * @stability stable
     */
    resetAwsIamConfig(): void;
    /**
     * @stability stable
     */
    get awsIamConfigInput(): AppsyncDatasourceHttpConfigAuthorizationConfigAwsIamConfig | undefined;
}
/**
 * @stability stable
 */
export interface AppsyncDatasourceHttpConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#endpoint AppsyncDatasource#endpoint}.
     *
     * @stability stable
     */
    readonly endpoint: string;
    /**
     * authorization_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#authorization_config AppsyncDatasource#authorization_config}
     *
     * @stability stable
     */
    readonly authorizationConfig?: AppsyncDatasourceHttpConfigAuthorizationConfig;
}
export declare function appsyncDatasourceHttpConfigToTerraform(struct?: AppsyncDatasourceHttpConfigOutputReference | AppsyncDatasourceHttpConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncDatasourceHttpConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncDatasourceHttpConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncDatasourceHttpConfig | undefined);
    private _endpoint?;
    /**
     * @stability stable
     */
    get endpoint(): string;
    /**
     * @stability stable
     */
    set endpoint(value: string);
    /**
     * @stability stable
     */
    get endpointInput(): string | undefined;
    private _authorizationConfig;
    /**
     * @stability stable
     */
    get authorizationConfig(): AppsyncDatasourceHttpConfigAuthorizationConfigOutputReference;
    /**
     * @stability stable
     */
    putAuthorizationConfig(value: AppsyncDatasourceHttpConfigAuthorizationConfig): void;
    /**
     * @stability stable
     */
    resetAuthorizationConfig(): void;
    /**
     * @stability stable
     */
    get authorizationConfigInput(): AppsyncDatasourceHttpConfigAuthorizationConfig | undefined;
}
/**
 * @stability stable
 */
export interface AppsyncDatasourceLambdaConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#function_arn AppsyncDatasource#function_arn}.
     *
     * @stability stable
     */
    readonly functionArn: string;
}
export declare function appsyncDatasourceLambdaConfigToTerraform(struct?: AppsyncDatasourceLambdaConfigOutputReference | AppsyncDatasourceLambdaConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncDatasourceLambdaConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncDatasourceLambdaConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncDatasourceLambdaConfig | undefined);
    private _functionArn?;
    /**
     * @stability stable
     */
    get functionArn(): string;
    /**
     * @stability stable
     */
    set functionArn(value: string);
    /**
     * @stability stable
     */
    get functionArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppsyncDatasourceRelationalDatabaseConfigHttpEndpointConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#aws_secret_store_arn AppsyncDatasource#aws_secret_store_arn}.
     *
     * @stability stable
     */
    readonly awsSecretStoreArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#database_name AppsyncDatasource#database_name}.
     *
     * @stability stable
     */
    readonly databaseName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#db_cluster_identifier AppsyncDatasource#db_cluster_identifier}.
     *
     * @stability stable
     */
    readonly dbClusterIdentifier: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#region AppsyncDatasource#region}.
     *
     * @stability stable
     */
    readonly region?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#schema AppsyncDatasource#schema}.
     *
     * @stability stable
     */
    readonly schema?: string;
}
export declare function appsyncDatasourceRelationalDatabaseConfigHttpEndpointConfigToTerraform(struct?: AppsyncDatasourceRelationalDatabaseConfigHttpEndpointConfigOutputReference | AppsyncDatasourceRelationalDatabaseConfigHttpEndpointConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncDatasourceRelationalDatabaseConfigHttpEndpointConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncDatasourceRelationalDatabaseConfigHttpEndpointConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncDatasourceRelationalDatabaseConfigHttpEndpointConfig | undefined);
    private _awsSecretStoreArn?;
    /**
     * @stability stable
     */
    get awsSecretStoreArn(): string;
    /**
     * @stability stable
     */
    set awsSecretStoreArn(value: string);
    /**
     * @stability stable
     */
    get awsSecretStoreArnInput(): string | undefined;
    private _databaseName?;
    /**
     * @stability stable
     */
    get databaseName(): string;
    /**
     * @stability stable
     */
    set databaseName(value: string);
    /**
     * @stability stable
     */
    resetDatabaseName(): void;
    /**
     * @stability stable
     */
    get databaseNameInput(): string | undefined;
    private _dbClusterIdentifier?;
    /**
     * @stability stable
     */
    get dbClusterIdentifier(): string;
    /**
     * @stability stable
     */
    set dbClusterIdentifier(value: string);
    /**
     * @stability stable
     */
    get dbClusterIdentifierInput(): string | undefined;
    private _region?;
    /**
     * @stability stable
     */
    get region(): string;
    /**
     * @stability stable
     */
    set region(value: string);
    /**
     * @stability stable
     */
    resetRegion(): void;
    /**
     * @stability stable
     */
    get regionInput(): string | undefined;
    private _schema?;
    /**
     * @stability stable
     */
    get schema(): string;
    /**
     * @stability stable
     */
    set schema(value: string);
    /**
     * @stability stable
     */
    resetSchema(): void;
    /**
     * @stability stable
     */
    get schemaInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppsyncDatasourceRelationalDatabaseConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#source_type AppsyncDatasource#source_type}.
     *
     * @stability stable
     */
    readonly sourceType?: string;
    /**
     * http_endpoint_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource#http_endpoint_config AppsyncDatasource#http_endpoint_config}
     *
     * @stability stable
     */
    readonly httpEndpointConfig?: AppsyncDatasourceRelationalDatabaseConfigHttpEndpointConfig;
}
export declare function appsyncDatasourceRelationalDatabaseConfigToTerraform(struct?: AppsyncDatasourceRelationalDatabaseConfigOutputReference | AppsyncDatasourceRelationalDatabaseConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncDatasourceRelationalDatabaseConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncDatasourceRelationalDatabaseConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncDatasourceRelationalDatabaseConfig | undefined);
    private _sourceType?;
    /**
     * @stability stable
     */
    get sourceType(): string;
    /**
     * @stability stable
     */
    set sourceType(value: string);
    /**
     * @stability stable
     */
    resetSourceType(): void;
    /**
     * @stability stable
     */
    get sourceTypeInput(): string | undefined;
    private _httpEndpointConfig;
    /**
     * @stability stable
     */
    get httpEndpointConfig(): AppsyncDatasourceRelationalDatabaseConfigHttpEndpointConfigOutputReference;
    /**
     * @stability stable
     */
    putHttpEndpointConfig(value: AppsyncDatasourceRelationalDatabaseConfigHttpEndpointConfig): void;
    /**
     * @stability stable
     */
    resetHttpEndpointConfig(): void;
    /**
     * @stability stable
     */
    get httpEndpointConfigInput(): AppsyncDatasourceRelationalDatabaseConfigHttpEndpointConfig | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource aws_appsync_datasource}.
 *
 * @stability stable
 */
export declare class AppsyncDatasource extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appsync_datasource aws_appsync_datasource} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppsyncDatasourceConfig);
    private _apiId?;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _serviceRoleArn?;
    /**
     * @stability stable
     */
    get serviceRoleArn(): string;
    /**
     * @stability stable
     */
    set serviceRoleArn(value: string);
    /**
     * @stability stable
     */
    resetServiceRoleArn(): void;
    /**
     * @stability stable
     */
    get serviceRoleArnInput(): string | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _dynamodbConfig;
    /**
     * @stability stable
     */
    get dynamodbConfig(): AppsyncDatasourceDynamodbConfigOutputReference;
    /**
     * @stability stable
     */
    putDynamodbConfig(value: AppsyncDatasourceDynamodbConfig): void;
    /**
     * @stability stable
     */
    resetDynamodbConfig(): void;
    /**
     * @stability stable
     */
    get dynamodbConfigInput(): AppsyncDatasourceDynamodbConfig | undefined;
    private _elasticsearchConfig;
    /**
     * @stability stable
     */
    get elasticsearchConfig(): AppsyncDatasourceElasticsearchConfigOutputReference;
    /**
     * @stability stable
     */
    putElasticsearchConfig(value: AppsyncDatasourceElasticsearchConfig): void;
    /**
     * @stability stable
     */
    resetElasticsearchConfig(): void;
    /**
     * @stability stable
     */
    get elasticsearchConfigInput(): AppsyncDatasourceElasticsearchConfig | undefined;
    private _httpConfig;
    /**
     * @stability stable
     */
    get httpConfig(): AppsyncDatasourceHttpConfigOutputReference;
    /**
     * @stability stable
     */
    putHttpConfig(value: AppsyncDatasourceHttpConfig): void;
    /**
     * @stability stable
     */
    resetHttpConfig(): void;
    /**
     * @stability stable
     */
    get httpConfigInput(): AppsyncDatasourceHttpConfig | undefined;
    private _lambdaConfig;
    /**
     * @stability stable
     */
    get lambdaConfig(): AppsyncDatasourceLambdaConfigOutputReference;
    /**
     * @stability stable
     */
    putLambdaConfig(value: AppsyncDatasourceLambdaConfig): void;
    /**
     * @stability stable
     */
    resetLambdaConfig(): void;
    /**
     * @stability stable
     */
    get lambdaConfigInput(): AppsyncDatasourceLambdaConfig | undefined;
    private _relationalDatabaseConfig;
    /**
     * @stability stable
     */
    get relationalDatabaseConfig(): AppsyncDatasourceRelationalDatabaseConfigOutputReference;
    /**
     * @stability stable
     */
    putRelationalDatabaseConfig(value: AppsyncDatasourceRelationalDatabaseConfig): void;
    /**
     * @stability stable
     */
    resetRelationalDatabaseConfig(): void;
    /**
     * @stability stable
     */
    get relationalDatabaseConfigInput(): AppsyncDatasourceRelationalDatabaseConfig | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
