import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS AppSync.
 *
 * @stability stable
 */
export interface AppsyncFunctionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_function#api_id AppsyncFunction#api_id}.
     *
     * @stability stable
     */
    readonly apiId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_function#data_source AppsyncFunction#data_source}.
     *
     * @stability stable
     */
    readonly dataSource: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_function#description AppsyncFunction#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_function#function_version AppsyncFunction#function_version}.
     *
     * @stability stable
     */
    readonly functionVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_function#max_batch_size AppsyncFunction#max_batch_size}.
     *
     * @stability stable
     */
    readonly maxBatchSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_function#name AppsyncFunction#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_function#request_mapping_template AppsyncFunction#request_mapping_template}.
     *
     * @stability stable
     */
    readonly requestMappingTemplate: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_function#response_mapping_template AppsyncFunction#response_mapping_template}.
     *
     * @stability stable
     */
    readonly responseMappingTemplate: string;
    /**
     * sync_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_function#sync_config AppsyncFunction#sync_config}
     *
     * @stability stable
     */
    readonly syncConfig?: AppsyncFunctionSyncConfig;
}
/**
 * @stability stable
 */
export interface AppsyncFunctionSyncConfigLambdaConflictHandlerConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_function#lambda_conflict_handler_arn AppsyncFunction#lambda_conflict_handler_arn}.
     *
     * @stability stable
     */
    readonly lambdaConflictHandlerArn?: string;
}
export declare function appsyncFunctionSyncConfigLambdaConflictHandlerConfigToTerraform(struct?: AppsyncFunctionSyncConfigLambdaConflictHandlerConfigOutputReference | AppsyncFunctionSyncConfigLambdaConflictHandlerConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncFunctionSyncConfigLambdaConflictHandlerConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncFunctionSyncConfigLambdaConflictHandlerConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncFunctionSyncConfigLambdaConflictHandlerConfig | undefined);
    private _lambdaConflictHandlerArn?;
    /**
     * @stability stable
     */
    get lambdaConflictHandlerArn(): string;
    /**
     * @stability stable
     */
    set lambdaConflictHandlerArn(value: string);
    /**
     * @stability stable
     */
    resetLambdaConflictHandlerArn(): void;
    /**
     * @stability stable
     */
    get lambdaConflictHandlerArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppsyncFunctionSyncConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_function#conflict_detection AppsyncFunction#conflict_detection}.
     *
     * @stability stable
     */
    readonly conflictDetection?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_function#conflict_handler AppsyncFunction#conflict_handler}.
     *
     * @stability stable
     */
    readonly conflictHandler?: string;
    /**
     * lambda_conflict_handler_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_function#lambda_conflict_handler_config AppsyncFunction#lambda_conflict_handler_config}
     *
     * @stability stable
     */
    readonly lambdaConflictHandlerConfig?: AppsyncFunctionSyncConfigLambdaConflictHandlerConfig;
}
export declare function appsyncFunctionSyncConfigToTerraform(struct?: AppsyncFunctionSyncConfigOutputReference | AppsyncFunctionSyncConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncFunctionSyncConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncFunctionSyncConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncFunctionSyncConfig | undefined);
    private _conflictDetection?;
    /**
     * @stability stable
     */
    get conflictDetection(): string;
    /**
     * @stability stable
     */
    set conflictDetection(value: string);
    /**
     * @stability stable
     */
    resetConflictDetection(): void;
    /**
     * @stability stable
     */
    get conflictDetectionInput(): string | undefined;
    private _conflictHandler?;
    /**
     * @stability stable
     */
    get conflictHandler(): string;
    /**
     * @stability stable
     */
    set conflictHandler(value: string);
    /**
     * @stability stable
     */
    resetConflictHandler(): void;
    /**
     * @stability stable
     */
    get conflictHandlerInput(): string | undefined;
    private _lambdaConflictHandlerConfig;
    /**
     * @stability stable
     */
    get lambdaConflictHandlerConfig(): AppsyncFunctionSyncConfigLambdaConflictHandlerConfigOutputReference;
    /**
     * @stability stable
     */
    putLambdaConflictHandlerConfig(value: AppsyncFunctionSyncConfigLambdaConflictHandlerConfig): void;
    /**
     * @stability stable
     */
    resetLambdaConflictHandlerConfig(): void;
    /**
     * @stability stable
     */
    get lambdaConflictHandlerConfigInput(): AppsyncFunctionSyncConfigLambdaConflictHandlerConfig | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appsync_function aws_appsync_function}.
 *
 * @stability stable
 */
export declare class AppsyncFunction extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appsync_function aws_appsync_function} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppsyncFunctionConfig);
    private _apiId?;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _dataSource?;
    /**
     * @stability stable
     */
    get dataSource(): string;
    /**
     * @stability stable
     */
    set dataSource(value: string);
    /**
     * @stability stable
     */
    get dataSourceInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get functionId(): string;
    private _functionVersion?;
    /**
     * @stability stable
     */
    get functionVersion(): string;
    /**
     * @stability stable
     */
    set functionVersion(value: string);
    /**
     * @stability stable
     */
    resetFunctionVersion(): void;
    /**
     * @stability stable
     */
    get functionVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _maxBatchSize?;
    /**
     * @stability stable
     */
    get maxBatchSize(): number;
    /**
     * @stability stable
     */
    set maxBatchSize(value: number);
    /**
     * @stability stable
     */
    resetMaxBatchSize(): void;
    /**
     * @stability stable
     */
    get maxBatchSizeInput(): number | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _requestMappingTemplate?;
    /**
     * @stability stable
     */
    get requestMappingTemplate(): string;
    /**
     * @stability stable
     */
    set requestMappingTemplate(value: string);
    /**
     * @stability stable
     */
    get requestMappingTemplateInput(): string | undefined;
    private _responseMappingTemplate?;
    /**
     * @stability stable
     */
    get responseMappingTemplate(): string;
    /**
     * @stability stable
     */
    set responseMappingTemplate(value: string);
    /**
     * @stability stable
     */
    get responseMappingTemplateInput(): string | undefined;
    private _syncConfig;
    /**
     * @stability stable
     */
    get syncConfig(): AppsyncFunctionSyncConfigOutputReference;
    /**
     * @stability stable
     */
    putSyncConfig(value: AppsyncFunctionSyncConfig): void;
    /**
     * @stability stable
     */
    resetSyncConfig(): void;
    /**
     * @stability stable
     */
    get syncConfigInput(): AppsyncFunctionSyncConfig | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
