import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS AppSync.
 *
 * @stability stable
 */
export interface AppsyncGraphqlApiConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#authentication_type AppsyncGraphqlApi#authentication_type}.
     *
     * @stability stable
     */
    readonly authenticationType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#name AppsyncGraphqlApi#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#schema AppsyncGraphqlApi#schema}.
     *
     * @stability stable
     */
    readonly schema?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#tags AppsyncGraphqlApi#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#tags_all AppsyncGraphqlApi#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#xray_enabled AppsyncGraphqlApi#xray_enabled}.
     *
     * @stability stable
     */
    readonly xrayEnabled?: boolean | cdktf.IResolvable;
    /**
     * additional_authentication_provider block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#additional_authentication_provider AppsyncGraphqlApi#additional_authentication_provider}
     *
     * @stability stable
     */
    readonly additionalAuthenticationProvider?: AppsyncGraphqlApiAdditionalAuthenticationProvider[];
    /**
     * lambda_authorizer_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#lambda_authorizer_config AppsyncGraphqlApi#lambda_authorizer_config}
     *
     * @stability stable
     */
    readonly lambdaAuthorizerConfig?: AppsyncGraphqlApiLambdaAuthorizerConfig;
    /**
     * log_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#log_config AppsyncGraphqlApi#log_config}
     *
     * @stability stable
     */
    readonly logConfig?: AppsyncGraphqlApiLogConfig;
    /**
     * openid_connect_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#openid_connect_config AppsyncGraphqlApi#openid_connect_config}
     *
     * @stability stable
     */
    readonly openidConnectConfig?: AppsyncGraphqlApiOpenidConnectConfig;
    /**
     * user_pool_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#user_pool_config AppsyncGraphqlApi#user_pool_config}
     *
     * @stability stable
     */
    readonly userPoolConfig?: AppsyncGraphqlApiUserPoolConfig;
}
/**
 * @stability stable
 */
export interface AppsyncGraphqlApiAdditionalAuthenticationProviderLambdaAuthorizerConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#authorizer_result_ttl_in_seconds AppsyncGraphqlApi#authorizer_result_ttl_in_seconds}.
     *
     * @stability stable
     */
    readonly authorizerResultTtlInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#authorizer_uri AppsyncGraphqlApi#authorizer_uri}.
     *
     * @stability stable
     */
    readonly authorizerUri: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#identity_validation_expression AppsyncGraphqlApi#identity_validation_expression}.
     *
     * @stability stable
     */
    readonly identityValidationExpression?: string;
}
export declare function appsyncGraphqlApiAdditionalAuthenticationProviderLambdaAuthorizerConfigToTerraform(struct?: AppsyncGraphqlApiAdditionalAuthenticationProviderLambdaAuthorizerConfigOutputReference | AppsyncGraphqlApiAdditionalAuthenticationProviderLambdaAuthorizerConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncGraphqlApiAdditionalAuthenticationProviderLambdaAuthorizerConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncGraphqlApiAdditionalAuthenticationProviderLambdaAuthorizerConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncGraphqlApiAdditionalAuthenticationProviderLambdaAuthorizerConfig | undefined);
    private _authorizerResultTtlInSeconds?;
    /**
     * @stability stable
     */
    get authorizerResultTtlInSeconds(): number;
    /**
     * @stability stable
     */
    set authorizerResultTtlInSeconds(value: number);
    /**
     * @stability stable
     */
    resetAuthorizerResultTtlInSeconds(): void;
    /**
     * @stability stable
     */
    get authorizerResultTtlInSecondsInput(): number | undefined;
    private _authorizerUri?;
    /**
     * @stability stable
     */
    get authorizerUri(): string;
    /**
     * @stability stable
     */
    set authorizerUri(value: string);
    /**
     * @stability stable
     */
    get authorizerUriInput(): string | undefined;
    private _identityValidationExpression?;
    /**
     * @stability stable
     */
    get identityValidationExpression(): string;
    /**
     * @stability stable
     */
    set identityValidationExpression(value: string);
    /**
     * @stability stable
     */
    resetIdentityValidationExpression(): void;
    /**
     * @stability stable
     */
    get identityValidationExpressionInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppsyncGraphqlApiAdditionalAuthenticationProviderOpenidConnectConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#auth_ttl AppsyncGraphqlApi#auth_ttl}.
     *
     * @stability stable
     */
    readonly authTtl?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#client_id AppsyncGraphqlApi#client_id}.
     *
     * @stability stable
     */
    readonly clientId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#iat_ttl AppsyncGraphqlApi#iat_ttl}.
     *
     * @stability stable
     */
    readonly iatTtl?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#issuer AppsyncGraphqlApi#issuer}.
     *
     * @stability stable
     */
    readonly issuer: string;
}
export declare function appsyncGraphqlApiAdditionalAuthenticationProviderOpenidConnectConfigToTerraform(struct?: AppsyncGraphqlApiAdditionalAuthenticationProviderOpenidConnectConfigOutputReference | AppsyncGraphqlApiAdditionalAuthenticationProviderOpenidConnectConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncGraphqlApiAdditionalAuthenticationProviderOpenidConnectConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncGraphqlApiAdditionalAuthenticationProviderOpenidConnectConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncGraphqlApiAdditionalAuthenticationProviderOpenidConnectConfig | undefined);
    private _authTtl?;
    /**
     * @stability stable
     */
    get authTtl(): number;
    /**
     * @stability stable
     */
    set authTtl(value: number);
    /**
     * @stability stable
     */
    resetAuthTtl(): void;
    /**
     * @stability stable
     */
    get authTtlInput(): number | undefined;
    private _clientId?;
    /**
     * @stability stable
     */
    get clientId(): string;
    /**
     * @stability stable
     */
    set clientId(value: string);
    /**
     * @stability stable
     */
    resetClientId(): void;
    /**
     * @stability stable
     */
    get clientIdInput(): string | undefined;
    private _iatTtl?;
    /**
     * @stability stable
     */
    get iatTtl(): number;
    /**
     * @stability stable
     */
    set iatTtl(value: number);
    /**
     * @stability stable
     */
    resetIatTtl(): void;
    /**
     * @stability stable
     */
    get iatTtlInput(): number | undefined;
    private _issuer?;
    /**
     * @stability stable
     */
    get issuer(): string;
    /**
     * @stability stable
     */
    set issuer(value: string);
    /**
     * @stability stable
     */
    get issuerInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppsyncGraphqlApiAdditionalAuthenticationProviderUserPoolConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#app_id_client_regex AppsyncGraphqlApi#app_id_client_regex}.
     *
     * @stability stable
     */
    readonly appIdClientRegex?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#aws_region AppsyncGraphqlApi#aws_region}.
     *
     * @stability stable
     */
    readonly awsRegion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#user_pool_id AppsyncGraphqlApi#user_pool_id}.
     *
     * @stability stable
     */
    readonly userPoolId: string;
}
export declare function appsyncGraphqlApiAdditionalAuthenticationProviderUserPoolConfigToTerraform(struct?: AppsyncGraphqlApiAdditionalAuthenticationProviderUserPoolConfigOutputReference | AppsyncGraphqlApiAdditionalAuthenticationProviderUserPoolConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncGraphqlApiAdditionalAuthenticationProviderUserPoolConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncGraphqlApiAdditionalAuthenticationProviderUserPoolConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncGraphqlApiAdditionalAuthenticationProviderUserPoolConfig | undefined);
    private _appIdClientRegex?;
    /**
     * @stability stable
     */
    get appIdClientRegex(): string;
    /**
     * @stability stable
     */
    set appIdClientRegex(value: string);
    /**
     * @stability stable
     */
    resetAppIdClientRegex(): void;
    /**
     * @stability stable
     */
    get appIdClientRegexInput(): string | undefined;
    private _awsRegion?;
    /**
     * @stability stable
     */
    get awsRegion(): string;
    /**
     * @stability stable
     */
    set awsRegion(value: string);
    /**
     * @stability stable
     */
    resetAwsRegion(): void;
    /**
     * @stability stable
     */
    get awsRegionInput(): string | undefined;
    private _userPoolId?;
    /**
     * @stability stable
     */
    get userPoolId(): string;
    /**
     * @stability stable
     */
    set userPoolId(value: string);
    /**
     * @stability stable
     */
    get userPoolIdInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppsyncGraphqlApiAdditionalAuthenticationProvider {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#authentication_type AppsyncGraphqlApi#authentication_type}.
     *
     * @stability stable
     */
    readonly authenticationType: string;
    /**
     * lambda_authorizer_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#lambda_authorizer_config AppsyncGraphqlApi#lambda_authorizer_config}
     *
     * @stability stable
     */
    readonly lambdaAuthorizerConfig?: AppsyncGraphqlApiAdditionalAuthenticationProviderLambdaAuthorizerConfig;
    /**
     * openid_connect_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#openid_connect_config AppsyncGraphqlApi#openid_connect_config}
     *
     * @stability stable
     */
    readonly openidConnectConfig?: AppsyncGraphqlApiAdditionalAuthenticationProviderOpenidConnectConfig;
    /**
     * user_pool_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#user_pool_config AppsyncGraphqlApi#user_pool_config}
     *
     * @stability stable
     */
    readonly userPoolConfig?: AppsyncGraphqlApiAdditionalAuthenticationProviderUserPoolConfig;
}
export declare function appsyncGraphqlApiAdditionalAuthenticationProviderToTerraform(struct?: AppsyncGraphqlApiAdditionalAuthenticationProvider): any;
/**
 * @stability stable
 */
export interface AppsyncGraphqlApiLambdaAuthorizerConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#authorizer_result_ttl_in_seconds AppsyncGraphqlApi#authorizer_result_ttl_in_seconds}.
     *
     * @stability stable
     */
    readonly authorizerResultTtlInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#authorizer_uri AppsyncGraphqlApi#authorizer_uri}.
     *
     * @stability stable
     */
    readonly authorizerUri: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#identity_validation_expression AppsyncGraphqlApi#identity_validation_expression}.
     *
     * @stability stable
     */
    readonly identityValidationExpression?: string;
}
export declare function appsyncGraphqlApiLambdaAuthorizerConfigToTerraform(struct?: AppsyncGraphqlApiLambdaAuthorizerConfigOutputReference | AppsyncGraphqlApiLambdaAuthorizerConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncGraphqlApiLambdaAuthorizerConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncGraphqlApiLambdaAuthorizerConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncGraphqlApiLambdaAuthorizerConfig | undefined);
    private _authorizerResultTtlInSeconds?;
    /**
     * @stability stable
     */
    get authorizerResultTtlInSeconds(): number;
    /**
     * @stability stable
     */
    set authorizerResultTtlInSeconds(value: number);
    /**
     * @stability stable
     */
    resetAuthorizerResultTtlInSeconds(): void;
    /**
     * @stability stable
     */
    get authorizerResultTtlInSecondsInput(): number | undefined;
    private _authorizerUri?;
    /**
     * @stability stable
     */
    get authorizerUri(): string;
    /**
     * @stability stable
     */
    set authorizerUri(value: string);
    /**
     * @stability stable
     */
    get authorizerUriInput(): string | undefined;
    private _identityValidationExpression?;
    /**
     * @stability stable
     */
    get identityValidationExpression(): string;
    /**
     * @stability stable
     */
    set identityValidationExpression(value: string);
    /**
     * @stability stable
     */
    resetIdentityValidationExpression(): void;
    /**
     * @stability stable
     */
    get identityValidationExpressionInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppsyncGraphqlApiLogConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#cloudwatch_logs_role_arn AppsyncGraphqlApi#cloudwatch_logs_role_arn}.
     *
     * @stability stable
     */
    readonly cloudwatchLogsRoleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#exclude_verbose_content AppsyncGraphqlApi#exclude_verbose_content}.
     *
     * @stability stable
     */
    readonly excludeVerboseContent?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#field_log_level AppsyncGraphqlApi#field_log_level}.
     *
     * @stability stable
     */
    readonly fieldLogLevel: string;
}
export declare function appsyncGraphqlApiLogConfigToTerraform(struct?: AppsyncGraphqlApiLogConfigOutputReference | AppsyncGraphqlApiLogConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncGraphqlApiLogConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncGraphqlApiLogConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncGraphqlApiLogConfig | undefined);
    private _cloudwatchLogsRoleArn?;
    /**
     * @stability stable
     */
    get cloudwatchLogsRoleArn(): string;
    /**
     * @stability stable
     */
    set cloudwatchLogsRoleArn(value: string);
    /**
     * @stability stable
     */
    get cloudwatchLogsRoleArnInput(): string | undefined;
    private _excludeVerboseContent?;
    /**
     * @stability stable
     */
    get excludeVerboseContent(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set excludeVerboseContent(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetExcludeVerboseContent(): void;
    /**
     * @stability stable
     */
    get excludeVerboseContentInput(): boolean | cdktf.IResolvable | undefined;
    private _fieldLogLevel?;
    /**
     * @stability stable
     */
    get fieldLogLevel(): string;
    /**
     * @stability stable
     */
    set fieldLogLevel(value: string);
    /**
     * @stability stable
     */
    get fieldLogLevelInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppsyncGraphqlApiOpenidConnectConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#auth_ttl AppsyncGraphqlApi#auth_ttl}.
     *
     * @stability stable
     */
    readonly authTtl?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#client_id AppsyncGraphqlApi#client_id}.
     *
     * @stability stable
     */
    readonly clientId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#iat_ttl AppsyncGraphqlApi#iat_ttl}.
     *
     * @stability stable
     */
    readonly iatTtl?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#issuer AppsyncGraphqlApi#issuer}.
     *
     * @stability stable
     */
    readonly issuer: string;
}
export declare function appsyncGraphqlApiOpenidConnectConfigToTerraform(struct?: AppsyncGraphqlApiOpenidConnectConfigOutputReference | AppsyncGraphqlApiOpenidConnectConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncGraphqlApiOpenidConnectConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncGraphqlApiOpenidConnectConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncGraphqlApiOpenidConnectConfig | undefined);
    private _authTtl?;
    /**
     * @stability stable
     */
    get authTtl(): number;
    /**
     * @stability stable
     */
    set authTtl(value: number);
    /**
     * @stability stable
     */
    resetAuthTtl(): void;
    /**
     * @stability stable
     */
    get authTtlInput(): number | undefined;
    private _clientId?;
    /**
     * @stability stable
     */
    get clientId(): string;
    /**
     * @stability stable
     */
    set clientId(value: string);
    /**
     * @stability stable
     */
    resetClientId(): void;
    /**
     * @stability stable
     */
    get clientIdInput(): string | undefined;
    private _iatTtl?;
    /**
     * @stability stable
     */
    get iatTtl(): number;
    /**
     * @stability stable
     */
    set iatTtl(value: number);
    /**
     * @stability stable
     */
    resetIatTtl(): void;
    /**
     * @stability stable
     */
    get iatTtlInput(): number | undefined;
    private _issuer?;
    /**
     * @stability stable
     */
    get issuer(): string;
    /**
     * @stability stable
     */
    set issuer(value: string);
    /**
     * @stability stable
     */
    get issuerInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface AppsyncGraphqlApiUserPoolConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#app_id_client_regex AppsyncGraphqlApi#app_id_client_regex}.
     *
     * @stability stable
     */
    readonly appIdClientRegex?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#aws_region AppsyncGraphqlApi#aws_region}.
     *
     * @stability stable
     */
    readonly awsRegion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#default_action AppsyncGraphqlApi#default_action}.
     *
     * @stability stable
     */
    readonly defaultAction: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api#user_pool_id AppsyncGraphqlApi#user_pool_id}.
     *
     * @stability stable
     */
    readonly userPoolId: string;
}
export declare function appsyncGraphqlApiUserPoolConfigToTerraform(struct?: AppsyncGraphqlApiUserPoolConfigOutputReference | AppsyncGraphqlApiUserPoolConfig): any;
/**
 * @stability stable
 */
export declare class AppsyncGraphqlApiUserPoolConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): AppsyncGraphqlApiUserPoolConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: AppsyncGraphqlApiUserPoolConfig | undefined);
    private _appIdClientRegex?;
    /**
     * @stability stable
     */
    get appIdClientRegex(): string;
    /**
     * @stability stable
     */
    set appIdClientRegex(value: string);
    /**
     * @stability stable
     */
    resetAppIdClientRegex(): void;
    /**
     * @stability stable
     */
    get appIdClientRegexInput(): string | undefined;
    private _awsRegion?;
    /**
     * @stability stable
     */
    get awsRegion(): string;
    /**
     * @stability stable
     */
    set awsRegion(value: string);
    /**
     * @stability stable
     */
    resetAwsRegion(): void;
    /**
     * @stability stable
     */
    get awsRegionInput(): string | undefined;
    private _defaultAction?;
    /**
     * @stability stable
     */
    get defaultAction(): string;
    /**
     * @stability stable
     */
    set defaultAction(value: string);
    /**
     * @stability stable
     */
    get defaultActionInput(): string | undefined;
    private _userPoolId?;
    /**
     * @stability stable
     */
    get userPoolId(): string;
    /**
     * @stability stable
     */
    set userPoolId(value: string);
    /**
     * @stability stable
     */
    get userPoolIdInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api aws_appsync_graphql_api}.
 *
 * @stability stable
 */
export declare class AppsyncGraphqlApi extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/appsync_graphql_api aws_appsync_graphql_api} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppsyncGraphqlApiConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _authenticationType?;
    /**
     * @stability stable
     */
    get authenticationType(): string;
    /**
     * @stability stable
     */
    set authenticationType(value: string);
    /**
     * @stability stable
     */
    get authenticationTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _schema?;
    /**
     * @stability stable
     */
    get schema(): string;
    /**
     * @stability stable
     */
    set schema(value: string);
    /**
     * @stability stable
     */
    resetSchema(): void;
    /**
     * @stability stable
     */
    get schemaInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    uris(key: string): string;
    private _xrayEnabled?;
    /**
     * @stability stable
     */
    get xrayEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set xrayEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetXrayEnabled(): void;
    /**
     * @stability stable
     */
    get xrayEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _additionalAuthenticationProvider?;
    /**
     * @stability stable
     */
    get additionalAuthenticationProvider(): AppsyncGraphqlApiAdditionalAuthenticationProvider[];
    /**
     * @stability stable
     */
    set additionalAuthenticationProvider(value: AppsyncGraphqlApiAdditionalAuthenticationProvider[]);
    /**
     * @stability stable
     */
    resetAdditionalAuthenticationProvider(): void;
    /**
     * @stability stable
     */
    get additionalAuthenticationProviderInput(): AppsyncGraphqlApiAdditionalAuthenticationProvider[] | undefined;
    private _lambdaAuthorizerConfig;
    /**
     * @stability stable
     */
    get lambdaAuthorizerConfig(): AppsyncGraphqlApiLambdaAuthorizerConfigOutputReference;
    /**
     * @stability stable
     */
    putLambdaAuthorizerConfig(value: AppsyncGraphqlApiLambdaAuthorizerConfig): void;
    /**
     * @stability stable
     */
    resetLambdaAuthorizerConfig(): void;
    /**
     * @stability stable
     */
    get lambdaAuthorizerConfigInput(): AppsyncGraphqlApiLambdaAuthorizerConfig | undefined;
    private _logConfig;
    /**
     * @stability stable
     */
    get logConfig(): AppsyncGraphqlApiLogConfigOutputReference;
    /**
     * @stability stable
     */
    putLogConfig(value: AppsyncGraphqlApiLogConfig): void;
    /**
     * @stability stable
     */
    resetLogConfig(): void;
    /**
     * @stability stable
     */
    get logConfigInput(): AppsyncGraphqlApiLogConfig | undefined;
    private _openidConnectConfig;
    /**
     * @stability stable
     */
    get openidConnectConfig(): AppsyncGraphqlApiOpenidConnectConfigOutputReference;
    /**
     * @stability stable
     */
    putOpenidConnectConfig(value: AppsyncGraphqlApiOpenidConnectConfig): void;
    /**
     * @stability stable
     */
    resetOpenidConnectConfig(): void;
    /**
     * @stability stable
     */
    get openidConnectConfigInput(): AppsyncGraphqlApiOpenidConnectConfig | undefined;
    private _userPoolConfig;
    /**
     * @stability stable
     */
    get userPoolConfig(): AppsyncGraphqlApiUserPoolConfigOutputReference;
    /**
     * @stability stable
     */
    putUserPoolConfig(value: AppsyncGraphqlApiUserPoolConfig): void;
    /**
     * @stability stable
     */
    resetUserPoolConfig(): void;
    /**
     * @stability stable
     */
    get userPoolConfigInput(): AppsyncGraphqlApiUserPoolConfig | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
