import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Auto Scaling.
 *
 * @stability stable
 */
export interface AutoscalingLifecycleHookConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_lifecycle_hook#autoscaling_group_name AutoscalingLifecycleHook#autoscaling_group_name}.
     *
     * @stability stable
     */
    readonly autoscalingGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_lifecycle_hook#default_result AutoscalingLifecycleHook#default_result}.
     *
     * @stability stable
     */
    readonly defaultResult?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_lifecycle_hook#heartbeat_timeout AutoscalingLifecycleHook#heartbeat_timeout}.
     *
     * @stability stable
     */
    readonly heartbeatTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_lifecycle_hook#lifecycle_transition AutoscalingLifecycleHook#lifecycle_transition}.
     *
     * @stability stable
     */
    readonly lifecycleTransition: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_lifecycle_hook#name AutoscalingLifecycleHook#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_lifecycle_hook#notification_metadata AutoscalingLifecycleHook#notification_metadata}.
     *
     * @stability stable
     */
    readonly notificationMetadata?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_lifecycle_hook#notification_target_arn AutoscalingLifecycleHook#notification_target_arn}.
     *
     * @stability stable
     */
    readonly notificationTargetArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_lifecycle_hook#role_arn AutoscalingLifecycleHook#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_lifecycle_hook aws_autoscaling_lifecycle_hook}.
 *
 * @stability stable
 */
export declare class AutoscalingLifecycleHook extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_lifecycle_hook aws_autoscaling_lifecycle_hook} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AutoscalingLifecycleHookConfig);
    private _autoscalingGroupName?;
    /**
     * @stability stable
     */
    get autoscalingGroupName(): string;
    /**
     * @stability stable
     */
    set autoscalingGroupName(value: string);
    /**
     * @stability stable
     */
    get autoscalingGroupNameInput(): string | undefined;
    private _defaultResult?;
    /**
     * @stability stable
     */
    get defaultResult(): string;
    /**
     * @stability stable
     */
    set defaultResult(value: string);
    /**
     * @stability stable
     */
    resetDefaultResult(): void;
    /**
     * @stability stable
     */
    get defaultResultInput(): string | undefined;
    private _heartbeatTimeout?;
    /**
     * @stability stable
     */
    get heartbeatTimeout(): number;
    /**
     * @stability stable
     */
    set heartbeatTimeout(value: number);
    /**
     * @stability stable
     */
    resetHeartbeatTimeout(): void;
    /**
     * @stability stable
     */
    get heartbeatTimeoutInput(): number | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _lifecycleTransition?;
    /**
     * @stability stable
     */
    get lifecycleTransition(): string;
    /**
     * @stability stable
     */
    set lifecycleTransition(value: string);
    /**
     * @stability stable
     */
    get lifecycleTransitionInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _notificationMetadata?;
    /**
     * @stability stable
     */
    get notificationMetadata(): string;
    /**
     * @stability stable
     */
    set notificationMetadata(value: string);
    /**
     * @stability stable
     */
    resetNotificationMetadata(): void;
    /**
     * @stability stable
     */
    get notificationMetadataInput(): string | undefined;
    private _notificationTargetArn?;
    /**
     * @stability stable
     */
    get notificationTargetArn(): string;
    /**
     * @stability stable
     */
    set notificationTargetArn(value: string);
    /**
     * @stability stable
     */
    resetNotificationTargetArn(): void;
    /**
     * @stability stable
     */
    get notificationTargetArnInput(): string | undefined;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    resetRoleArn(): void;
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
