import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Auto Scaling.
 *
 * @stability stable
 */
export interface AutoscalingScheduleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_schedule#autoscaling_group_name AutoscalingSchedule#autoscaling_group_name}.
     *
     * @stability stable
     */
    readonly autoscalingGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_schedule#desired_capacity AutoscalingSchedule#desired_capacity}.
     *
     * @stability stable
     */
    readonly desiredCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_schedule#end_time AutoscalingSchedule#end_time}.
     *
     * @stability stable
     */
    readonly endTime?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_schedule#max_size AutoscalingSchedule#max_size}.
     *
     * @stability stable
     */
    readonly maxSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_schedule#min_size AutoscalingSchedule#min_size}.
     *
     * @stability stable
     */
    readonly minSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_schedule#recurrence AutoscalingSchedule#recurrence}.
     *
     * @stability stable
     */
    readonly recurrence?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_schedule#scheduled_action_name AutoscalingSchedule#scheduled_action_name}.
     *
     * @stability stable
     */
    readonly scheduledActionName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_schedule#start_time AutoscalingSchedule#start_time}.
     *
     * @stability stable
     */
    readonly startTime?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_schedule#time_zone AutoscalingSchedule#time_zone}.
     *
     * @stability stable
     */
    readonly timeZone?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_schedule aws_autoscaling_schedule}.
 *
 * @stability stable
 */
export declare class AutoscalingSchedule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_schedule aws_autoscaling_schedule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AutoscalingScheduleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoscalingGroupName?;
    /**
     * @stability stable
     */
    get autoscalingGroupName(): string;
    /**
     * @stability stable
     */
    set autoscalingGroupName(value: string);
    /**
     * @stability stable
     */
    get autoscalingGroupNameInput(): string | undefined;
    private _desiredCapacity?;
    /**
     * @stability stable
     */
    get desiredCapacity(): number;
    /**
     * @stability stable
     */
    set desiredCapacity(value: number);
    /**
     * @stability stable
     */
    resetDesiredCapacity(): void;
    /**
     * @stability stable
     */
    get desiredCapacityInput(): number | undefined;
    private _endTime?;
    /**
     * @stability stable
     */
    get endTime(): string;
    /**
     * @stability stable
     */
    set endTime(value: string);
    /**
     * @stability stable
     */
    resetEndTime(): void;
    /**
     * @stability stable
     */
    get endTimeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _maxSize?;
    /**
     * @stability stable
     */
    get maxSize(): number;
    /**
     * @stability stable
     */
    set maxSize(value: number);
    /**
     * @stability stable
     */
    resetMaxSize(): void;
    /**
     * @stability stable
     */
    get maxSizeInput(): number | undefined;
    private _minSize?;
    /**
     * @stability stable
     */
    get minSize(): number;
    /**
     * @stability stable
     */
    set minSize(value: number);
    /**
     * @stability stable
     */
    resetMinSize(): void;
    /**
     * @stability stable
     */
    get minSizeInput(): number | undefined;
    private _recurrence?;
    /**
     * @stability stable
     */
    get recurrence(): string;
    /**
     * @stability stable
     */
    set recurrence(value: string);
    /**
     * @stability stable
     */
    resetRecurrence(): void;
    /**
     * @stability stable
     */
    get recurrenceInput(): string | undefined;
    private _scheduledActionName?;
    /**
     * @stability stable
     */
    get scheduledActionName(): string;
    /**
     * @stability stable
     */
    set scheduledActionName(value: string);
    /**
     * @stability stable
     */
    get scheduledActionNameInput(): string | undefined;
    private _startTime?;
    /**
     * @stability stable
     */
    get startTime(): string;
    /**
     * @stability stable
     */
    set startTime(value: string);
    /**
     * @stability stable
     */
    resetStartTime(): void;
    /**
     * @stability stable
     */
    get startTimeInput(): string | undefined;
    private _timeZone?;
    /**
     * @stability stable
     */
    get timeZone(): string;
    /**
     * @stability stable
     */
    set timeZone(value: string);
    /**
     * @stability stable
     */
    resetTimeZone(): void;
    /**
     * @stability stable
     */
    get timeZoneInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
