import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Budgets.
 *
 * @stability stable
 */
export interface BudgetsBudgetActionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#account_id BudgetsBudgetAction#account_id}.
     *
     * @stability stable
     */
    readonly accountId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#action_type BudgetsBudgetAction#action_type}.
     *
     * @stability stable
     */
    readonly actionType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#approval_model BudgetsBudgetAction#approval_model}.
     *
     * @stability stable
     */
    readonly approvalModel: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#budget_name BudgetsBudgetAction#budget_name}.
     *
     * @stability stable
     */
    readonly budgetName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#execution_role_arn BudgetsBudgetAction#execution_role_arn}.
     *
     * @stability stable
     */
    readonly executionRoleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#notification_type BudgetsBudgetAction#notification_type}.
     *
     * @stability stable
     */
    readonly notificationType: string;
    /**
     * action_threshold block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#action_threshold BudgetsBudgetAction#action_threshold}
     *
     * @stability stable
     */
    readonly actionThreshold: BudgetsBudgetActionActionThreshold;
    /**
     * definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#definition BudgetsBudgetAction#definition}
     *
     * @stability stable
     */
    readonly definition: BudgetsBudgetActionDefinition;
    /**
     * subscriber block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#subscriber BudgetsBudgetAction#subscriber}
     *
     * @stability stable
     */
    readonly subscriber: BudgetsBudgetActionSubscriber[];
}
/**
 * @stability stable
 */
export interface BudgetsBudgetActionActionThreshold {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#action_threshold_type BudgetsBudgetAction#action_threshold_type}.
     *
     * @stability stable
     */
    readonly actionThresholdType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#action_threshold_value BudgetsBudgetAction#action_threshold_value}.
     *
     * @stability stable
     */
    readonly actionThresholdValue: number;
}
export declare function budgetsBudgetActionActionThresholdToTerraform(struct?: BudgetsBudgetActionActionThresholdOutputReference | BudgetsBudgetActionActionThreshold): any;
/**
 * @stability stable
 */
export declare class BudgetsBudgetActionActionThresholdOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): BudgetsBudgetActionActionThreshold | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: BudgetsBudgetActionActionThreshold | undefined);
    private _actionThresholdType?;
    /**
     * @stability stable
     */
    get actionThresholdType(): string;
    /**
     * @stability stable
     */
    set actionThresholdType(value: string);
    /**
     * @stability stable
     */
    get actionThresholdTypeInput(): string | undefined;
    private _actionThresholdValue?;
    /**
     * @stability stable
     */
    get actionThresholdValue(): number;
    /**
     * @stability stable
     */
    set actionThresholdValue(value: number);
    /**
     * @stability stable
     */
    get actionThresholdValueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface BudgetsBudgetActionDefinitionIamActionDefinition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#groups BudgetsBudgetAction#groups}.
     *
     * @stability stable
     */
    readonly groups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#policy_arn BudgetsBudgetAction#policy_arn}.
     *
     * @stability stable
     */
    readonly policyArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#roles BudgetsBudgetAction#roles}.
     *
     * @stability stable
     */
    readonly roles?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#users BudgetsBudgetAction#users}.
     *
     * @stability stable
     */
    readonly users?: string[];
}
export declare function budgetsBudgetActionDefinitionIamActionDefinitionToTerraform(struct?: BudgetsBudgetActionDefinitionIamActionDefinitionOutputReference | BudgetsBudgetActionDefinitionIamActionDefinition): any;
/**
 * @stability stable
 */
export declare class BudgetsBudgetActionDefinitionIamActionDefinitionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): BudgetsBudgetActionDefinitionIamActionDefinition | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: BudgetsBudgetActionDefinitionIamActionDefinition | undefined);
    private _groups?;
    /**
     * @stability stable
     */
    get groups(): string[];
    /**
     * @stability stable
     */
    set groups(value: string[]);
    /**
     * @stability stable
     */
    resetGroups(): void;
    /**
     * @stability stable
     */
    get groupsInput(): string[] | undefined;
    private _policyArn?;
    /**
     * @stability stable
     */
    get policyArn(): string;
    /**
     * @stability stable
     */
    set policyArn(value: string);
    /**
     * @stability stable
     */
    get policyArnInput(): string | undefined;
    private _roles?;
    /**
     * @stability stable
     */
    get roles(): string[];
    /**
     * @stability stable
     */
    set roles(value: string[]);
    /**
     * @stability stable
     */
    resetRoles(): void;
    /**
     * @stability stable
     */
    get rolesInput(): string[] | undefined;
    private _users?;
    /**
     * @stability stable
     */
    get users(): string[];
    /**
     * @stability stable
     */
    set users(value: string[]);
    /**
     * @stability stable
     */
    resetUsers(): void;
    /**
     * @stability stable
     */
    get usersInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface BudgetsBudgetActionDefinitionScpActionDefinition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#policy_id BudgetsBudgetAction#policy_id}.
     *
     * @stability stable
     */
    readonly policyId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#target_ids BudgetsBudgetAction#target_ids}.
     *
     * @stability stable
     */
    readonly targetIds: string[];
}
export declare function budgetsBudgetActionDefinitionScpActionDefinitionToTerraform(struct?: BudgetsBudgetActionDefinitionScpActionDefinitionOutputReference | BudgetsBudgetActionDefinitionScpActionDefinition): any;
/**
 * @stability stable
 */
export declare class BudgetsBudgetActionDefinitionScpActionDefinitionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): BudgetsBudgetActionDefinitionScpActionDefinition | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: BudgetsBudgetActionDefinitionScpActionDefinition | undefined);
    private _policyId?;
    /**
     * @stability stable
     */
    get policyId(): string;
    /**
     * @stability stable
     */
    set policyId(value: string);
    /**
     * @stability stable
     */
    get policyIdInput(): string | undefined;
    private _targetIds?;
    /**
     * @stability stable
     */
    get targetIds(): string[];
    /**
     * @stability stable
     */
    set targetIds(value: string[]);
    /**
     * @stability stable
     */
    get targetIdsInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface BudgetsBudgetActionDefinitionSsmActionDefinition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#action_sub_type BudgetsBudgetAction#action_sub_type}.
     *
     * @stability stable
     */
    readonly actionSubType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#instance_ids BudgetsBudgetAction#instance_ids}.
     *
     * @stability stable
     */
    readonly instanceIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#region BudgetsBudgetAction#region}.
     *
     * @stability stable
     */
    readonly region: string;
}
export declare function budgetsBudgetActionDefinitionSsmActionDefinitionToTerraform(struct?: BudgetsBudgetActionDefinitionSsmActionDefinitionOutputReference | BudgetsBudgetActionDefinitionSsmActionDefinition): any;
/**
 * @stability stable
 */
export declare class BudgetsBudgetActionDefinitionSsmActionDefinitionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): BudgetsBudgetActionDefinitionSsmActionDefinition | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: BudgetsBudgetActionDefinitionSsmActionDefinition | undefined);
    private _actionSubType?;
    /**
     * @stability stable
     */
    get actionSubType(): string;
    /**
     * @stability stable
     */
    set actionSubType(value: string);
    /**
     * @stability stable
     */
    get actionSubTypeInput(): string | undefined;
    private _instanceIds?;
    /**
     * @stability stable
     */
    get instanceIds(): string[];
    /**
     * @stability stable
     */
    set instanceIds(value: string[]);
    /**
     * @stability stable
     */
    get instanceIdsInput(): string[] | undefined;
    private _region?;
    /**
     * @stability stable
     */
    get region(): string;
    /**
     * @stability stable
     */
    set region(value: string);
    /**
     * @stability stable
     */
    get regionInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface BudgetsBudgetActionDefinition {
    /**
     * iam_action_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#iam_action_definition BudgetsBudgetAction#iam_action_definition}
     *
     * @stability stable
     */
    readonly iamActionDefinition?: BudgetsBudgetActionDefinitionIamActionDefinition;
    /**
     * scp_action_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#scp_action_definition BudgetsBudgetAction#scp_action_definition}
     *
     * @stability stable
     */
    readonly scpActionDefinition?: BudgetsBudgetActionDefinitionScpActionDefinition;
    /**
     * ssm_action_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#ssm_action_definition BudgetsBudgetAction#ssm_action_definition}
     *
     * @stability stable
     */
    readonly ssmActionDefinition?: BudgetsBudgetActionDefinitionSsmActionDefinition;
}
export declare function budgetsBudgetActionDefinitionToTerraform(struct?: BudgetsBudgetActionDefinitionOutputReference | BudgetsBudgetActionDefinition): any;
/**
 * @stability stable
 */
export declare class BudgetsBudgetActionDefinitionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): BudgetsBudgetActionDefinition | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: BudgetsBudgetActionDefinition | undefined);
    private _iamActionDefinition;
    /**
     * @stability stable
     */
    get iamActionDefinition(): BudgetsBudgetActionDefinitionIamActionDefinitionOutputReference;
    /**
     * @stability stable
     */
    putIamActionDefinition(value: BudgetsBudgetActionDefinitionIamActionDefinition): void;
    /**
     * @stability stable
     */
    resetIamActionDefinition(): void;
    /**
     * @stability stable
     */
    get iamActionDefinitionInput(): BudgetsBudgetActionDefinitionIamActionDefinition | undefined;
    private _scpActionDefinition;
    /**
     * @stability stable
     */
    get scpActionDefinition(): BudgetsBudgetActionDefinitionScpActionDefinitionOutputReference;
    /**
     * @stability stable
     */
    putScpActionDefinition(value: BudgetsBudgetActionDefinitionScpActionDefinition): void;
    /**
     * @stability stable
     */
    resetScpActionDefinition(): void;
    /**
     * @stability stable
     */
    get scpActionDefinitionInput(): BudgetsBudgetActionDefinitionScpActionDefinition | undefined;
    private _ssmActionDefinition;
    /**
     * @stability stable
     */
    get ssmActionDefinition(): BudgetsBudgetActionDefinitionSsmActionDefinitionOutputReference;
    /**
     * @stability stable
     */
    putSsmActionDefinition(value: BudgetsBudgetActionDefinitionSsmActionDefinition): void;
    /**
     * @stability stable
     */
    resetSsmActionDefinition(): void;
    /**
     * @stability stable
     */
    get ssmActionDefinitionInput(): BudgetsBudgetActionDefinitionSsmActionDefinition | undefined;
}
/**
 * @stability stable
 */
export interface BudgetsBudgetActionSubscriber {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#address BudgetsBudgetAction#address}.
     *
     * @stability stable
     */
    readonly address: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action#subscription_type BudgetsBudgetAction#subscription_type}.
     *
     * @stability stable
     */
    readonly subscriptionType: string;
}
export declare function budgetsBudgetActionSubscriberToTerraform(struct?: BudgetsBudgetActionSubscriber): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action aws_budgets_budget_action}.
 *
 * @stability stable
 */
export declare class BudgetsBudgetAction extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/budgets_budget_action aws_budgets_budget_action} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: BudgetsBudgetActionConfig);
    private _accountId?;
    /**
     * @stability stable
     */
    get accountId(): string;
    /**
     * @stability stable
     */
    set accountId(value: string);
    /**
     * @stability stable
     */
    resetAccountId(): void;
    /**
     * @stability stable
     */
    get accountIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get actionId(): string;
    private _actionType?;
    /**
     * @stability stable
     */
    get actionType(): string;
    /**
     * @stability stable
     */
    set actionType(value: string);
    /**
     * @stability stable
     */
    get actionTypeInput(): string | undefined;
    private _approvalModel?;
    /**
     * @stability stable
     */
    get approvalModel(): string;
    /**
     * @stability stable
     */
    set approvalModel(value: string);
    /**
     * @stability stable
     */
    get approvalModelInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _budgetName?;
    /**
     * @stability stable
     */
    get budgetName(): string;
    /**
     * @stability stable
     */
    set budgetName(value: string);
    /**
     * @stability stable
     */
    get budgetNameInput(): string | undefined;
    private _executionRoleArn?;
    /**
     * @stability stable
     */
    get executionRoleArn(): string;
    /**
     * @stability stable
     */
    set executionRoleArn(value: string);
    /**
     * @stability stable
     */
    get executionRoleArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _notificationType?;
    /**
     * @stability stable
     */
    get notificationType(): string;
    /**
     * @stability stable
     */
    set notificationType(value: string);
    /**
     * @stability stable
     */
    get notificationTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get status(): string;
    private _actionThreshold;
    /**
     * @stability stable
     */
    get actionThreshold(): BudgetsBudgetActionActionThresholdOutputReference;
    /**
     * @stability stable
     */
    putActionThreshold(value: BudgetsBudgetActionActionThreshold): void;
    /**
     * @stability stable
     */
    get actionThresholdInput(): BudgetsBudgetActionActionThreshold | undefined;
    private _definition;
    /**
     * @stability stable
     */
    get definition(): BudgetsBudgetActionDefinitionOutputReference;
    /**
     * @stability stable
     */
    putDefinition(value: BudgetsBudgetActionDefinition): void;
    /**
     * @stability stable
     */
    get definitionInput(): BudgetsBudgetActionDefinition | undefined;
    private _subscriber?;
    /**
     * @stability stable
     */
    get subscriber(): BudgetsBudgetActionSubscriber[];
    /**
     * @stability stable
     */
    set subscriber(value: BudgetsBudgetActionSubscriber[]);
    /**
     * @stability stable
     */
    get subscriberInput(): BudgetsBudgetActionSubscriber[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
