import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * Amazon Chime.
 *
 * @stability stable
 */
export interface ChimeVoiceConnectorGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_group#name ChimeVoiceConnectorGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * connector block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_group#connector ChimeVoiceConnectorGroup#connector}
     *
     * @stability stable
     */
    readonly connector?: ChimeVoiceConnectorGroupConnector[];
}
/**
 * @stability stable
 */
export interface ChimeVoiceConnectorGroupConnector {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_group#priority ChimeVoiceConnectorGroup#priority}.
     *
     * @stability stable
     */
    readonly priority: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_group#voice_connector_id ChimeVoiceConnectorGroup#voice_connector_id}.
     *
     * @stability stable
     */
    readonly voiceConnectorId: string;
}
export declare function chimeVoiceConnectorGroupConnectorToTerraform(struct?: ChimeVoiceConnectorGroupConnector): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_group aws_chime_voice_connector_group}.
 *
 * @stability stable
 */
export declare class ChimeVoiceConnectorGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector_group aws_chime_voice_connector_group} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ChimeVoiceConnectorGroupConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _connector?;
    /**
     * @stability stable
     */
    get connector(): ChimeVoiceConnectorGroupConnector[];
    /**
     * @stability stable
     */
    set connector(value: ChimeVoiceConnectorGroupConnector[]);
    /**
     * @stability stable
     */
    resetConnector(): void;
    /**
     * @stability stable
     */
    get connectorInput(): ChimeVoiceConnectorGroupConnector[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
