import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * Amazon Chime.
 *
 * @stability stable
 */
export interface ChimeVoiceConnectorConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector#aws_region ChimeVoiceConnector#aws_region}.
     *
     * @stability stable
     */
    readonly awsRegion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector#name ChimeVoiceConnector#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector#require_encryption ChimeVoiceConnector#require_encryption}.
     *
     * @stability stable
     */
    readonly requireEncryption: boolean | cdktf.IResolvable;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector aws_chime_voice_connector}.
 *
 * @stability stable
 */
export declare class ChimeVoiceConnector extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/chime_voice_connector aws_chime_voice_connector} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ChimeVoiceConnectorConfig);
    private _awsRegion?;
    /**
     * @stability stable
     */
    get awsRegion(): string;
    /**
     * @stability stable
     */
    set awsRegion(value: string);
    /**
     * @stability stable
     */
    resetAwsRegion(): void;
    /**
     * @stability stable
     */
    get awsRegionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get outboundHostName(): string;
    private _requireEncryption?;
    /**
     * @stability stable
     */
    get requireEncryption(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set requireEncryption(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get requireEncryptionInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
