import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS CloudFormation.
 *
 * @stability stable
 */
export interface DataAwsCloudformationTypeConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudformation_type#type DataAwsCloudformationType#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudformation_type#type_name DataAwsCloudformationType#type_name}.
     *
     * @stability stable
     */
    readonly typeName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudformation_type#version_id DataAwsCloudformationType#version_id}.
     *
     * @stability stable
     */
    readonly versionId?: string;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudformationTypeLoggingConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get logGroupName(): string;
    /**
     * @stability stable
     */
    get logRoleArn(): string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/cloudformation_type aws_cloudformation_type}.
 *
 * @stability stable
 */
export declare class DataAwsCloudformationType extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/cloudformation_type aws_cloudformation_type} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsCloudformationTypeConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get defaultVersionId(): string;
    /**
     * @stability stable
     */
    get deprecatedStatus(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get documentationUrl(): string;
    /**
     * @stability stable
     */
    get executionRoleArn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get isDefaultVersion(): any;
    /**
     * @stability stable
     */
    loggingConfig(index: string): DataAwsCloudformationTypeLoggingConfig;
    /**
     * @stability stable
     */
    get provisioningType(): string;
    /**
     * @stability stable
     */
    get schema(): string;
    /**
     * @stability stable
     */
    get sourceUrl(): string;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    /**
     * @stability stable
     */
    get typeArn(): string;
    private _typeName?;
    /**
     * @stability stable
     */
    get typeName(): string;
    /**
     * @stability stable
     */
    set typeName(value: string);
    /**
     * @stability stable
     */
    resetTypeName(): void;
    /**
     * @stability stable
     */
    get typeNameInput(): string | undefined;
    private _versionId?;
    /**
     * @stability stable
     */
    get versionId(): string;
    /**
     * @stability stable
     */
    set versionId(value: string);
    /**
     * @stability stable
     */
    resetVersionId(): void;
    /**
     * @stability stable
     */
    get versionIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get visibility(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
