import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS CloudFront.
 *
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy#comment CloudfrontOriginRequestPolicy#comment}.
     *
     * @stability stable
     */
    readonly comment?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy#name CloudfrontOriginRequestPolicy#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * cookies_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy#cookies_config CloudfrontOriginRequestPolicy#cookies_config}
     *
     * @stability stable
     */
    readonly cookiesConfig: CloudfrontOriginRequestPolicyCookiesConfig;
    /**
     * headers_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy#headers_config CloudfrontOriginRequestPolicy#headers_config}
     *
     * @stability stable
     */
    readonly headersConfig: CloudfrontOriginRequestPolicyHeadersConfig;
    /**
     * query_strings_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy#query_strings_config CloudfrontOriginRequestPolicy#query_strings_config}
     *
     * @stability stable
     */
    readonly queryStringsConfig: CloudfrontOriginRequestPolicyQueryStringsConfig;
}
/**
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyCookiesConfigCookies {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy#items CloudfrontOriginRequestPolicy#items}.
     *
     * @stability stable
     */
    readonly items?: string[];
}
export declare function cloudfrontOriginRequestPolicyCookiesConfigCookiesToTerraform(struct?: CloudfrontOriginRequestPolicyCookiesConfigCookiesOutputReference | CloudfrontOriginRequestPolicyCookiesConfigCookies): any;
/**
 * @stability stable
 */
export declare class CloudfrontOriginRequestPolicyCookiesConfigCookiesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontOriginRequestPolicyCookiesConfigCookies | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontOriginRequestPolicyCookiesConfigCookies | undefined);
    private _items?;
    /**
     * @stability stable
     */
    get items(): string[];
    /**
     * @stability stable
     */
    set items(value: string[]);
    /**
     * @stability stable
     */
    resetItems(): void;
    /**
     * @stability stable
     */
    get itemsInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyCookiesConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy#cookie_behavior CloudfrontOriginRequestPolicy#cookie_behavior}.
     *
     * @stability stable
     */
    readonly cookieBehavior: string;
    /**
     * cookies block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy#cookies CloudfrontOriginRequestPolicy#cookies}
     *
     * @stability stable
     */
    readonly cookies?: CloudfrontOriginRequestPolicyCookiesConfigCookies;
}
export declare function cloudfrontOriginRequestPolicyCookiesConfigToTerraform(struct?: CloudfrontOriginRequestPolicyCookiesConfigOutputReference | CloudfrontOriginRequestPolicyCookiesConfig): any;
/**
 * @stability stable
 */
export declare class CloudfrontOriginRequestPolicyCookiesConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontOriginRequestPolicyCookiesConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontOriginRequestPolicyCookiesConfig | undefined);
    private _cookieBehavior?;
    /**
     * @stability stable
     */
    get cookieBehavior(): string;
    /**
     * @stability stable
     */
    set cookieBehavior(value: string);
    /**
     * @stability stable
     */
    get cookieBehaviorInput(): string | undefined;
    private _cookies;
    /**
     * @stability stable
     */
    get cookies(): CloudfrontOriginRequestPolicyCookiesConfigCookiesOutputReference;
    /**
     * @stability stable
     */
    putCookies(value: CloudfrontOriginRequestPolicyCookiesConfigCookies): void;
    /**
     * @stability stable
     */
    resetCookies(): void;
    /**
     * @stability stable
     */
    get cookiesInput(): CloudfrontOriginRequestPolicyCookiesConfigCookies | undefined;
}
/**
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyHeadersConfigHeaders {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy#items CloudfrontOriginRequestPolicy#items}.
     *
     * @stability stable
     */
    readonly items?: string[];
}
export declare function cloudfrontOriginRequestPolicyHeadersConfigHeadersToTerraform(struct?: CloudfrontOriginRequestPolicyHeadersConfigHeadersOutputReference | CloudfrontOriginRequestPolicyHeadersConfigHeaders): any;
/**
 * @stability stable
 */
export declare class CloudfrontOriginRequestPolicyHeadersConfigHeadersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontOriginRequestPolicyHeadersConfigHeaders | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontOriginRequestPolicyHeadersConfigHeaders | undefined);
    private _items?;
    /**
     * @stability stable
     */
    get items(): string[];
    /**
     * @stability stable
     */
    set items(value: string[]);
    /**
     * @stability stable
     */
    resetItems(): void;
    /**
     * @stability stable
     */
    get itemsInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyHeadersConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy#header_behavior CloudfrontOriginRequestPolicy#header_behavior}.
     *
     * @stability stable
     */
    readonly headerBehavior?: string;
    /**
     * headers block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy#headers CloudfrontOriginRequestPolicy#headers}
     *
     * @stability stable
     */
    readonly headers?: CloudfrontOriginRequestPolicyHeadersConfigHeaders;
}
export declare function cloudfrontOriginRequestPolicyHeadersConfigToTerraform(struct?: CloudfrontOriginRequestPolicyHeadersConfigOutputReference | CloudfrontOriginRequestPolicyHeadersConfig): any;
/**
 * @stability stable
 */
export declare class CloudfrontOriginRequestPolicyHeadersConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontOriginRequestPolicyHeadersConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontOriginRequestPolicyHeadersConfig | undefined);
    private _headerBehavior?;
    /**
     * @stability stable
     */
    get headerBehavior(): string;
    /**
     * @stability stable
     */
    set headerBehavior(value: string);
    /**
     * @stability stable
     */
    resetHeaderBehavior(): void;
    /**
     * @stability stable
     */
    get headerBehaviorInput(): string | undefined;
    private _headers;
    /**
     * @stability stable
     */
    get headers(): CloudfrontOriginRequestPolicyHeadersConfigHeadersOutputReference;
    /**
     * @stability stable
     */
    putHeaders(value: CloudfrontOriginRequestPolicyHeadersConfigHeaders): void;
    /**
     * @stability stable
     */
    resetHeaders(): void;
    /**
     * @stability stable
     */
    get headersInput(): CloudfrontOriginRequestPolicyHeadersConfigHeaders | undefined;
}
/**
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyQueryStringsConfigQueryStrings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy#items CloudfrontOriginRequestPolicy#items}.
     *
     * @stability stable
     */
    readonly items?: string[];
}
export declare function cloudfrontOriginRequestPolicyQueryStringsConfigQueryStringsToTerraform(struct?: CloudfrontOriginRequestPolicyQueryStringsConfigQueryStringsOutputReference | CloudfrontOriginRequestPolicyQueryStringsConfigQueryStrings): any;
/**
 * @stability stable
 */
export declare class CloudfrontOriginRequestPolicyQueryStringsConfigQueryStringsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontOriginRequestPolicyQueryStringsConfigQueryStrings | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontOriginRequestPolicyQueryStringsConfigQueryStrings | undefined);
    private _items?;
    /**
     * @stability stable
     */
    get items(): string[];
    /**
     * @stability stable
     */
    set items(value: string[]);
    /**
     * @stability stable
     */
    resetItems(): void;
    /**
     * @stability stable
     */
    get itemsInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyQueryStringsConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy#query_string_behavior CloudfrontOriginRequestPolicy#query_string_behavior}.
     *
     * @stability stable
     */
    readonly queryStringBehavior: string;
    /**
     * query_strings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy#query_strings CloudfrontOriginRequestPolicy#query_strings}
     *
     * @stability stable
     */
    readonly queryStrings?: CloudfrontOriginRequestPolicyQueryStringsConfigQueryStrings;
}
export declare function cloudfrontOriginRequestPolicyQueryStringsConfigToTerraform(struct?: CloudfrontOriginRequestPolicyQueryStringsConfigOutputReference | CloudfrontOriginRequestPolicyQueryStringsConfig): any;
/**
 * @stability stable
 */
export declare class CloudfrontOriginRequestPolicyQueryStringsConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontOriginRequestPolicyQueryStringsConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontOriginRequestPolicyQueryStringsConfig | undefined);
    private _queryStringBehavior?;
    /**
     * @stability stable
     */
    get queryStringBehavior(): string;
    /**
     * @stability stable
     */
    set queryStringBehavior(value: string);
    /**
     * @stability stable
     */
    get queryStringBehaviorInput(): string | undefined;
    private _queryStrings;
    /**
     * @stability stable
     */
    get queryStrings(): CloudfrontOriginRequestPolicyQueryStringsConfigQueryStringsOutputReference;
    /**
     * @stability stable
     */
    putQueryStrings(value: CloudfrontOriginRequestPolicyQueryStringsConfigQueryStrings): void;
    /**
     * @stability stable
     */
    resetQueryStrings(): void;
    /**
     * @stability stable
     */
    get queryStringsInput(): CloudfrontOriginRequestPolicyQueryStringsConfigQueryStrings | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy aws_cloudfront_origin_request_policy}.
 *
 * @stability stable
 */
export declare class CloudfrontOriginRequestPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_origin_request_policy aws_cloudfront_origin_request_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudfrontOriginRequestPolicyConfig);
    private _comment?;
    /**
     * @stability stable
     */
    get comment(): string;
    /**
     * @stability stable
     */
    set comment(value: string);
    /**
     * @stability stable
     */
    resetComment(): void;
    /**
     * @stability stable
     */
    get commentInput(): string | undefined;
    /**
     * @stability stable
     */
    get etag(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _cookiesConfig;
    /**
     * @stability stable
     */
    get cookiesConfig(): CloudfrontOriginRequestPolicyCookiesConfigOutputReference;
    /**
     * @stability stable
     */
    putCookiesConfig(value: CloudfrontOriginRequestPolicyCookiesConfig): void;
    /**
     * @stability stable
     */
    get cookiesConfigInput(): CloudfrontOriginRequestPolicyCookiesConfig | undefined;
    private _headersConfig;
    /**
     * @stability stable
     */
    get headersConfig(): CloudfrontOriginRequestPolicyHeadersConfigOutputReference;
    /**
     * @stability stable
     */
    putHeadersConfig(value: CloudfrontOriginRequestPolicyHeadersConfig): void;
    /**
     * @stability stable
     */
    get headersConfigInput(): CloudfrontOriginRequestPolicyHeadersConfig | undefined;
    private _queryStringsConfig;
    /**
     * @stability stable
     */
    get queryStringsConfig(): CloudfrontOriginRequestPolicyQueryStringsConfigOutputReference;
    /**
     * @stability stable
     */
    putQueryStringsConfig(value: CloudfrontOriginRequestPolicyQueryStringsConfig): void;
    /**
     * @stability stable
     */
    get queryStringsConfigInput(): CloudfrontOriginRequestPolicyQueryStringsConfig | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
