import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS CloudFront.
 *
 * @stability stable
 */
export interface CloudfrontResponseHeadersPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#comment CloudfrontResponseHeadersPolicy#comment}.
     *
     * @stability stable
     */
    readonly comment?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#etag CloudfrontResponseHeadersPolicy#etag}.
     *
     * @stability stable
     */
    readonly etag?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#name CloudfrontResponseHeadersPolicy#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * cors_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#cors_config CloudfrontResponseHeadersPolicy#cors_config}
     *
     * @stability stable
     */
    readonly corsConfig?: CloudfrontResponseHeadersPolicyCorsConfig;
    /**
     * custom_headers_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#custom_headers_config CloudfrontResponseHeadersPolicy#custom_headers_config}
     *
     * @stability stable
     */
    readonly customHeadersConfig?: CloudfrontResponseHeadersPolicyCustomHeadersConfig;
    /**
     * security_headers_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#security_headers_config CloudfrontResponseHeadersPolicy#security_headers_config}
     *
     * @stability stable
     */
    readonly securityHeadersConfig?: CloudfrontResponseHeadersPolicySecurityHeadersConfig;
}
/**
 * @stability stable
 */
export interface CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowHeaders {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#items CloudfrontResponseHeadersPolicy#items}.
     *
     * @stability stable
     */
    readonly items?: string[];
}
export declare function cloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowHeadersToTerraform(struct?: CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowHeadersOutputReference | CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowHeaders): any;
/**
 * @stability stable
 */
export declare class CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowHeadersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowHeaders | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowHeaders | undefined);
    private _items?;
    /**
     * @stability stable
     */
    get items(): string[];
    /**
     * @stability stable
     */
    set items(value: string[]);
    /**
     * @stability stable
     */
    resetItems(): void;
    /**
     * @stability stable
     */
    get itemsInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowMethods {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#items CloudfrontResponseHeadersPolicy#items}.
     *
     * @stability stable
     */
    readonly items?: string[];
}
export declare function cloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowMethodsToTerraform(struct?: CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowMethodsOutputReference | CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowMethods): any;
/**
 * @stability stable
 */
export declare class CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowMethodsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowMethods | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowMethods | undefined);
    private _items?;
    /**
     * @stability stable
     */
    get items(): string[];
    /**
     * @stability stable
     */
    set items(value: string[]);
    /**
     * @stability stable
     */
    resetItems(): void;
    /**
     * @stability stable
     */
    get itemsInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowOrigins {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#items CloudfrontResponseHeadersPolicy#items}.
     *
     * @stability stable
     */
    readonly items?: string[];
}
export declare function cloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowOriginsToTerraform(struct?: CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowOriginsOutputReference | CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowOrigins): any;
/**
 * @stability stable
 */
export declare class CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowOriginsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowOrigins | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowOrigins | undefined);
    private _items?;
    /**
     * @stability stable
     */
    get items(): string[];
    /**
     * @stability stable
     */
    set items(value: string[]);
    /**
     * @stability stable
     */
    resetItems(): void;
    /**
     * @stability stable
     */
    get itemsInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface CloudfrontResponseHeadersPolicyCorsConfigAccessControlExposeHeaders {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#items CloudfrontResponseHeadersPolicy#items}.
     *
     * @stability stable
     */
    readonly items?: string[];
}
export declare function cloudfrontResponseHeadersPolicyCorsConfigAccessControlExposeHeadersToTerraform(struct?: CloudfrontResponseHeadersPolicyCorsConfigAccessControlExposeHeadersOutputReference | CloudfrontResponseHeadersPolicyCorsConfigAccessControlExposeHeaders): any;
/**
 * @stability stable
 */
export declare class CloudfrontResponseHeadersPolicyCorsConfigAccessControlExposeHeadersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontResponseHeadersPolicyCorsConfigAccessControlExposeHeaders | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontResponseHeadersPolicyCorsConfigAccessControlExposeHeaders | undefined);
    private _items?;
    /**
     * @stability stable
     */
    get items(): string[];
    /**
     * @stability stable
     */
    set items(value: string[]);
    /**
     * @stability stable
     */
    resetItems(): void;
    /**
     * @stability stable
     */
    get itemsInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface CloudfrontResponseHeadersPolicyCorsConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#access_control_allow_credentials CloudfrontResponseHeadersPolicy#access_control_allow_credentials}.
     *
     * @stability stable
     */
    readonly accessControlAllowCredentials: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#access_control_max_age_sec CloudfrontResponseHeadersPolicy#access_control_max_age_sec}.
     *
     * @stability stable
     */
    readonly accessControlMaxAgeSec?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#origin_override CloudfrontResponseHeadersPolicy#origin_override}.
     *
     * @stability stable
     */
    readonly originOverride: boolean | cdktf.IResolvable;
    /**
     * access_control_allow_headers block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#access_control_allow_headers CloudfrontResponseHeadersPolicy#access_control_allow_headers}
     *
     * @stability stable
     */
    readonly accessControlAllowHeaders: CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowHeaders;
    /**
     * access_control_allow_methods block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#access_control_allow_methods CloudfrontResponseHeadersPolicy#access_control_allow_methods}
     *
     * @stability stable
     */
    readonly accessControlAllowMethods: CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowMethods;
    /**
     * access_control_allow_origins block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#access_control_allow_origins CloudfrontResponseHeadersPolicy#access_control_allow_origins}
     *
     * @stability stable
     */
    readonly accessControlAllowOrigins: CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowOrigins;
    /**
     * access_control_expose_headers block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#access_control_expose_headers CloudfrontResponseHeadersPolicy#access_control_expose_headers}
     *
     * @stability stable
     */
    readonly accessControlExposeHeaders?: CloudfrontResponseHeadersPolicyCorsConfigAccessControlExposeHeaders;
}
export declare function cloudfrontResponseHeadersPolicyCorsConfigToTerraform(struct?: CloudfrontResponseHeadersPolicyCorsConfigOutputReference | CloudfrontResponseHeadersPolicyCorsConfig): any;
/**
 * @stability stable
 */
export declare class CloudfrontResponseHeadersPolicyCorsConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontResponseHeadersPolicyCorsConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontResponseHeadersPolicyCorsConfig | undefined);
    private _accessControlAllowCredentials?;
    /**
     * @stability stable
     */
    get accessControlAllowCredentials(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set accessControlAllowCredentials(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get accessControlAllowCredentialsInput(): boolean | cdktf.IResolvable | undefined;
    private _accessControlMaxAgeSec?;
    /**
     * @stability stable
     */
    get accessControlMaxAgeSec(): number;
    /**
     * @stability stable
     */
    set accessControlMaxAgeSec(value: number);
    /**
     * @stability stable
     */
    resetAccessControlMaxAgeSec(): void;
    /**
     * @stability stable
     */
    get accessControlMaxAgeSecInput(): number | undefined;
    private _originOverride?;
    /**
     * @stability stable
     */
    get originOverride(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set originOverride(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get originOverrideInput(): boolean | cdktf.IResolvable | undefined;
    private _accessControlAllowHeaders;
    /**
     * @stability stable
     */
    get accessControlAllowHeaders(): CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowHeadersOutputReference;
    /**
     * @stability stable
     */
    putAccessControlAllowHeaders(value: CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowHeaders): void;
    /**
     * @stability stable
     */
    get accessControlAllowHeadersInput(): CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowHeaders | undefined;
    private _accessControlAllowMethods;
    /**
     * @stability stable
     */
    get accessControlAllowMethods(): CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowMethodsOutputReference;
    /**
     * @stability stable
     */
    putAccessControlAllowMethods(value: CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowMethods): void;
    /**
     * @stability stable
     */
    get accessControlAllowMethodsInput(): CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowMethods | undefined;
    private _accessControlAllowOrigins;
    /**
     * @stability stable
     */
    get accessControlAllowOrigins(): CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowOriginsOutputReference;
    /**
     * @stability stable
     */
    putAccessControlAllowOrigins(value: CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowOrigins): void;
    /**
     * @stability stable
     */
    get accessControlAllowOriginsInput(): CloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowOrigins | undefined;
    private _accessControlExposeHeaders;
    /**
     * @stability stable
     */
    get accessControlExposeHeaders(): CloudfrontResponseHeadersPolicyCorsConfigAccessControlExposeHeadersOutputReference;
    /**
     * @stability stable
     */
    putAccessControlExposeHeaders(value: CloudfrontResponseHeadersPolicyCorsConfigAccessControlExposeHeaders): void;
    /**
     * @stability stable
     */
    resetAccessControlExposeHeaders(): void;
    /**
     * @stability stable
     */
    get accessControlExposeHeadersInput(): CloudfrontResponseHeadersPolicyCorsConfigAccessControlExposeHeaders | undefined;
}
/**
 * @stability stable
 */
export interface CloudfrontResponseHeadersPolicyCustomHeadersConfigItems {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#header CloudfrontResponseHeadersPolicy#header}.
     *
     * @stability stable
     */
    readonly header: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#override CloudfrontResponseHeadersPolicy#override}.
     *
     * @stability stable
     */
    readonly override: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#value CloudfrontResponseHeadersPolicy#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function cloudfrontResponseHeadersPolicyCustomHeadersConfigItemsToTerraform(struct?: CloudfrontResponseHeadersPolicyCustomHeadersConfigItems): any;
/**
 * @stability stable
 */
export interface CloudfrontResponseHeadersPolicyCustomHeadersConfig {
    /**
     * items block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#items CloudfrontResponseHeadersPolicy#items}
     *
     * @stability stable
     */
    readonly items?: CloudfrontResponseHeadersPolicyCustomHeadersConfigItems[];
}
export declare function cloudfrontResponseHeadersPolicyCustomHeadersConfigToTerraform(struct?: CloudfrontResponseHeadersPolicyCustomHeadersConfigOutputReference | CloudfrontResponseHeadersPolicyCustomHeadersConfig): any;
/**
 * @stability stable
 */
export declare class CloudfrontResponseHeadersPolicyCustomHeadersConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontResponseHeadersPolicyCustomHeadersConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontResponseHeadersPolicyCustomHeadersConfig | undefined);
    private _items?;
    /**
     * @stability stable
     */
    get items(): CloudfrontResponseHeadersPolicyCustomHeadersConfigItems[];
    /**
     * @stability stable
     */
    set items(value: CloudfrontResponseHeadersPolicyCustomHeadersConfigItems[]);
    /**
     * @stability stable
     */
    resetItems(): void;
    /**
     * @stability stable
     */
    get itemsInput(): CloudfrontResponseHeadersPolicyCustomHeadersConfigItems[] | undefined;
}
/**
 * @stability stable
 */
export interface CloudfrontResponseHeadersPolicySecurityHeadersConfigContentSecurityPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#content_security_policy CloudfrontResponseHeadersPolicy#content_security_policy}.
     *
     * @stability stable
     */
    readonly contentSecurityPolicy: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#override CloudfrontResponseHeadersPolicy#override}.
     *
     * @stability stable
     */
    readonly override: boolean | cdktf.IResolvable;
}
export declare function cloudfrontResponseHeadersPolicySecurityHeadersConfigContentSecurityPolicyToTerraform(struct?: CloudfrontResponseHeadersPolicySecurityHeadersConfigContentSecurityPolicyOutputReference | CloudfrontResponseHeadersPolicySecurityHeadersConfigContentSecurityPolicy): any;
/**
 * @stability stable
 */
export declare class CloudfrontResponseHeadersPolicySecurityHeadersConfigContentSecurityPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontResponseHeadersPolicySecurityHeadersConfigContentSecurityPolicy | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontResponseHeadersPolicySecurityHeadersConfigContentSecurityPolicy | undefined);
    private _contentSecurityPolicy?;
    /**
     * @stability stable
     */
    get contentSecurityPolicy(): string;
    /**
     * @stability stable
     */
    set contentSecurityPolicy(value: string);
    /**
     * @stability stable
     */
    get contentSecurityPolicyInput(): string | undefined;
    private _override?;
    /**
     * @stability stable
     */
    get override(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set override(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get overrideInput(): boolean | cdktf.IResolvable | undefined;
}
/**
 * @stability stable
 */
export interface CloudfrontResponseHeadersPolicySecurityHeadersConfigContentTypeOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#override CloudfrontResponseHeadersPolicy#override}.
     *
     * @stability stable
     */
    readonly override: boolean | cdktf.IResolvable;
}
export declare function cloudfrontResponseHeadersPolicySecurityHeadersConfigContentTypeOptionsToTerraform(struct?: CloudfrontResponseHeadersPolicySecurityHeadersConfigContentTypeOptionsOutputReference | CloudfrontResponseHeadersPolicySecurityHeadersConfigContentTypeOptions): any;
/**
 * @stability stable
 */
export declare class CloudfrontResponseHeadersPolicySecurityHeadersConfigContentTypeOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontResponseHeadersPolicySecurityHeadersConfigContentTypeOptions | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontResponseHeadersPolicySecurityHeadersConfigContentTypeOptions | undefined);
    private _override?;
    /**
     * @stability stable
     */
    get override(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set override(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get overrideInput(): boolean | cdktf.IResolvable | undefined;
}
/**
 * @stability stable
 */
export interface CloudfrontResponseHeadersPolicySecurityHeadersConfigFrameOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#frame_option CloudfrontResponseHeadersPolicy#frame_option}.
     *
     * @stability stable
     */
    readonly frameOption: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#override CloudfrontResponseHeadersPolicy#override}.
     *
     * @stability stable
     */
    readonly override: boolean | cdktf.IResolvable;
}
export declare function cloudfrontResponseHeadersPolicySecurityHeadersConfigFrameOptionsToTerraform(struct?: CloudfrontResponseHeadersPolicySecurityHeadersConfigFrameOptionsOutputReference | CloudfrontResponseHeadersPolicySecurityHeadersConfigFrameOptions): any;
/**
 * @stability stable
 */
export declare class CloudfrontResponseHeadersPolicySecurityHeadersConfigFrameOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontResponseHeadersPolicySecurityHeadersConfigFrameOptions | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontResponseHeadersPolicySecurityHeadersConfigFrameOptions | undefined);
    private _frameOption?;
    /**
     * @stability stable
     */
    get frameOption(): string;
    /**
     * @stability stable
     */
    set frameOption(value: string);
    /**
     * @stability stable
     */
    get frameOptionInput(): string | undefined;
    private _override?;
    /**
     * @stability stable
     */
    get override(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set override(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get overrideInput(): boolean | cdktf.IResolvable | undefined;
}
/**
 * @stability stable
 */
export interface CloudfrontResponseHeadersPolicySecurityHeadersConfigReferrerPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#override CloudfrontResponseHeadersPolicy#override}.
     *
     * @stability stable
     */
    readonly override: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#referrer_policy CloudfrontResponseHeadersPolicy#referrer_policy}.
     *
     * @stability stable
     */
    readonly referrerPolicy: string;
}
export declare function cloudfrontResponseHeadersPolicySecurityHeadersConfigReferrerPolicyToTerraform(struct?: CloudfrontResponseHeadersPolicySecurityHeadersConfigReferrerPolicyOutputReference | CloudfrontResponseHeadersPolicySecurityHeadersConfigReferrerPolicy): any;
/**
 * @stability stable
 */
export declare class CloudfrontResponseHeadersPolicySecurityHeadersConfigReferrerPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontResponseHeadersPolicySecurityHeadersConfigReferrerPolicy | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontResponseHeadersPolicySecurityHeadersConfigReferrerPolicy | undefined);
    private _override?;
    /**
     * @stability stable
     */
    get override(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set override(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get overrideInput(): boolean | cdktf.IResolvable | undefined;
    private _referrerPolicy?;
    /**
     * @stability stable
     */
    get referrerPolicy(): string;
    /**
     * @stability stable
     */
    set referrerPolicy(value: string);
    /**
     * @stability stable
     */
    get referrerPolicyInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CloudfrontResponseHeadersPolicySecurityHeadersConfigStrictTransportSecurity {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#access_control_max_age_sec CloudfrontResponseHeadersPolicy#access_control_max_age_sec}.
     *
     * @stability stable
     */
    readonly accessControlMaxAgeSec: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#include_subdomains CloudfrontResponseHeadersPolicy#include_subdomains}.
     *
     * @stability stable
     */
    readonly includeSubdomains?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#override CloudfrontResponseHeadersPolicy#override}.
     *
     * @stability stable
     */
    readonly override: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#preload CloudfrontResponseHeadersPolicy#preload}.
     *
     * @stability stable
     */
    readonly preload?: boolean | cdktf.IResolvable;
}
export declare function cloudfrontResponseHeadersPolicySecurityHeadersConfigStrictTransportSecurityToTerraform(struct?: CloudfrontResponseHeadersPolicySecurityHeadersConfigStrictTransportSecurityOutputReference | CloudfrontResponseHeadersPolicySecurityHeadersConfigStrictTransportSecurity): any;
/**
 * @stability stable
 */
export declare class CloudfrontResponseHeadersPolicySecurityHeadersConfigStrictTransportSecurityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontResponseHeadersPolicySecurityHeadersConfigStrictTransportSecurity | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontResponseHeadersPolicySecurityHeadersConfigStrictTransportSecurity | undefined);
    private _accessControlMaxAgeSec?;
    /**
     * @stability stable
     */
    get accessControlMaxAgeSec(): number;
    /**
     * @stability stable
     */
    set accessControlMaxAgeSec(value: number);
    /**
     * @stability stable
     */
    get accessControlMaxAgeSecInput(): number | undefined;
    private _includeSubdomains?;
    /**
     * @stability stable
     */
    get includeSubdomains(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeSubdomains(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeSubdomains(): void;
    /**
     * @stability stable
     */
    get includeSubdomainsInput(): boolean | cdktf.IResolvable | undefined;
    private _override?;
    /**
     * @stability stable
     */
    get override(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set override(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get overrideInput(): boolean | cdktf.IResolvable | undefined;
    private _preload?;
    /**
     * @stability stable
     */
    get preload(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set preload(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetPreload(): void;
    /**
     * @stability stable
     */
    get preloadInput(): boolean | cdktf.IResolvable | undefined;
}
/**
 * @stability stable
 */
export interface CloudfrontResponseHeadersPolicySecurityHeadersConfigXssProtection {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#mode_block CloudfrontResponseHeadersPolicy#mode_block}.
     *
     * @stability stable
     */
    readonly modeBlock?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#override CloudfrontResponseHeadersPolicy#override}.
     *
     * @stability stable
     */
    readonly override: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#protection CloudfrontResponseHeadersPolicy#protection}.
     *
     * @stability stable
     */
    readonly protection: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#report_uri CloudfrontResponseHeadersPolicy#report_uri}.
     *
     * @stability stable
     */
    readonly reportUri?: string;
}
export declare function cloudfrontResponseHeadersPolicySecurityHeadersConfigXssProtectionToTerraform(struct?: CloudfrontResponseHeadersPolicySecurityHeadersConfigXssProtectionOutputReference | CloudfrontResponseHeadersPolicySecurityHeadersConfigXssProtection): any;
/**
 * @stability stable
 */
export declare class CloudfrontResponseHeadersPolicySecurityHeadersConfigXssProtectionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontResponseHeadersPolicySecurityHeadersConfigXssProtection | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontResponseHeadersPolicySecurityHeadersConfigXssProtection | undefined);
    private _modeBlock?;
    /**
     * @stability stable
     */
    get modeBlock(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set modeBlock(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetModeBlock(): void;
    /**
     * @stability stable
     */
    get modeBlockInput(): boolean | cdktf.IResolvable | undefined;
    private _override?;
    /**
     * @stability stable
     */
    get override(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set override(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get overrideInput(): boolean | cdktf.IResolvable | undefined;
    private _protection?;
    /**
     * @stability stable
     */
    get protection(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set protection(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get protectionInput(): boolean | cdktf.IResolvable | undefined;
    private _reportUri?;
    /**
     * @stability stable
     */
    get reportUri(): string;
    /**
     * @stability stable
     */
    set reportUri(value: string);
    /**
     * @stability stable
     */
    resetReportUri(): void;
    /**
     * @stability stable
     */
    get reportUriInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CloudfrontResponseHeadersPolicySecurityHeadersConfig {
    /**
     * content_security_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#content_security_policy CloudfrontResponseHeadersPolicy#content_security_policy}
     *
     * @stability stable
     */
    readonly contentSecurityPolicy?: CloudfrontResponseHeadersPolicySecurityHeadersConfigContentSecurityPolicy;
    /**
     * content_type_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#content_type_options CloudfrontResponseHeadersPolicy#content_type_options}
     *
     * @stability stable
     */
    readonly contentTypeOptions?: CloudfrontResponseHeadersPolicySecurityHeadersConfigContentTypeOptions;
    /**
     * frame_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#frame_options CloudfrontResponseHeadersPolicy#frame_options}
     *
     * @stability stable
     */
    readonly frameOptions?: CloudfrontResponseHeadersPolicySecurityHeadersConfigFrameOptions;
    /**
     * referrer_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#referrer_policy CloudfrontResponseHeadersPolicy#referrer_policy}
     *
     * @stability stable
     */
    readonly referrerPolicy?: CloudfrontResponseHeadersPolicySecurityHeadersConfigReferrerPolicy;
    /**
     * strict_transport_security block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#strict_transport_security CloudfrontResponseHeadersPolicy#strict_transport_security}
     *
     * @stability stable
     */
    readonly strictTransportSecurity?: CloudfrontResponseHeadersPolicySecurityHeadersConfigStrictTransportSecurity;
    /**
     * xss_protection block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy#xss_protection CloudfrontResponseHeadersPolicy#xss_protection}
     *
     * @stability stable
     */
    readonly xssProtection?: CloudfrontResponseHeadersPolicySecurityHeadersConfigXssProtection;
}
export declare function cloudfrontResponseHeadersPolicySecurityHeadersConfigToTerraform(struct?: CloudfrontResponseHeadersPolicySecurityHeadersConfigOutputReference | CloudfrontResponseHeadersPolicySecurityHeadersConfig): any;
/**
 * @stability stable
 */
export declare class CloudfrontResponseHeadersPolicySecurityHeadersConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CloudfrontResponseHeadersPolicySecurityHeadersConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CloudfrontResponseHeadersPolicySecurityHeadersConfig | undefined);
    private _contentSecurityPolicy;
    /**
     * @stability stable
     */
    get contentSecurityPolicy(): CloudfrontResponseHeadersPolicySecurityHeadersConfigContentSecurityPolicyOutputReference;
    /**
     * @stability stable
     */
    putContentSecurityPolicy(value: CloudfrontResponseHeadersPolicySecurityHeadersConfigContentSecurityPolicy): void;
    /**
     * @stability stable
     */
    resetContentSecurityPolicy(): void;
    /**
     * @stability stable
     */
    get contentSecurityPolicyInput(): CloudfrontResponseHeadersPolicySecurityHeadersConfigContentSecurityPolicy | undefined;
    private _contentTypeOptions;
    /**
     * @stability stable
     */
    get contentTypeOptions(): CloudfrontResponseHeadersPolicySecurityHeadersConfigContentTypeOptionsOutputReference;
    /**
     * @stability stable
     */
    putContentTypeOptions(value: CloudfrontResponseHeadersPolicySecurityHeadersConfigContentTypeOptions): void;
    /**
     * @stability stable
     */
    resetContentTypeOptions(): void;
    /**
     * @stability stable
     */
    get contentTypeOptionsInput(): CloudfrontResponseHeadersPolicySecurityHeadersConfigContentTypeOptions | undefined;
    private _frameOptions;
    /**
     * @stability stable
     */
    get frameOptions(): CloudfrontResponseHeadersPolicySecurityHeadersConfigFrameOptionsOutputReference;
    /**
     * @stability stable
     */
    putFrameOptions(value: CloudfrontResponseHeadersPolicySecurityHeadersConfigFrameOptions): void;
    /**
     * @stability stable
     */
    resetFrameOptions(): void;
    /**
     * @stability stable
     */
    get frameOptionsInput(): CloudfrontResponseHeadersPolicySecurityHeadersConfigFrameOptions | undefined;
    private _referrerPolicy;
    /**
     * @stability stable
     */
    get referrerPolicy(): CloudfrontResponseHeadersPolicySecurityHeadersConfigReferrerPolicyOutputReference;
    /**
     * @stability stable
     */
    putReferrerPolicy(value: CloudfrontResponseHeadersPolicySecurityHeadersConfigReferrerPolicy): void;
    /**
     * @stability stable
     */
    resetReferrerPolicy(): void;
    /**
     * @stability stable
     */
    get referrerPolicyInput(): CloudfrontResponseHeadersPolicySecurityHeadersConfigReferrerPolicy | undefined;
    private _strictTransportSecurity;
    /**
     * @stability stable
     */
    get strictTransportSecurity(): CloudfrontResponseHeadersPolicySecurityHeadersConfigStrictTransportSecurityOutputReference;
    /**
     * @stability stable
     */
    putStrictTransportSecurity(value: CloudfrontResponseHeadersPolicySecurityHeadersConfigStrictTransportSecurity): void;
    /**
     * @stability stable
     */
    resetStrictTransportSecurity(): void;
    /**
     * @stability stable
     */
    get strictTransportSecurityInput(): CloudfrontResponseHeadersPolicySecurityHeadersConfigStrictTransportSecurity | undefined;
    private _xssProtection;
    /**
     * @stability stable
     */
    get xssProtection(): CloudfrontResponseHeadersPolicySecurityHeadersConfigXssProtectionOutputReference;
    /**
     * @stability stable
     */
    putXssProtection(value: CloudfrontResponseHeadersPolicySecurityHeadersConfigXssProtection): void;
    /**
     * @stability stable
     */
    resetXssProtection(): void;
    /**
     * @stability stable
     */
    get xssProtectionInput(): CloudfrontResponseHeadersPolicySecurityHeadersConfigXssProtection | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy aws_cloudfront_response_headers_policy}.
 *
 * @stability stable
 */
export declare class CloudfrontResponseHeadersPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudfront_response_headers_policy aws_cloudfront_response_headers_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudfrontResponseHeadersPolicyConfig);
    private _comment?;
    /**
     * @stability stable
     */
    get comment(): string;
    /**
     * @stability stable
     */
    set comment(value: string);
    /**
     * @stability stable
     */
    resetComment(): void;
    /**
     * @stability stable
     */
    get commentInput(): string | undefined;
    private _etag?;
    /**
     * @stability stable
     */
    get etag(): string;
    /**
     * @stability stable
     */
    set etag(value: string);
    /**
     * @stability stable
     */
    resetEtag(): void;
    /**
     * @stability stable
     */
    get etagInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _corsConfig;
    /**
     * @stability stable
     */
    get corsConfig(): CloudfrontResponseHeadersPolicyCorsConfigOutputReference;
    /**
     * @stability stable
     */
    putCorsConfig(value: CloudfrontResponseHeadersPolicyCorsConfig): void;
    /**
     * @stability stable
     */
    resetCorsConfig(): void;
    /**
     * @stability stable
     */
    get corsConfigInput(): CloudfrontResponseHeadersPolicyCorsConfig | undefined;
    private _customHeadersConfig;
    /**
     * @stability stable
     */
    get customHeadersConfig(): CloudfrontResponseHeadersPolicyCustomHeadersConfigOutputReference;
    /**
     * @stability stable
     */
    putCustomHeadersConfig(value: CloudfrontResponseHeadersPolicyCustomHeadersConfig): void;
    /**
     * @stability stable
     */
    resetCustomHeadersConfig(): void;
    /**
     * @stability stable
     */
    get customHeadersConfigInput(): CloudfrontResponseHeadersPolicyCustomHeadersConfig | undefined;
    private _securityHeadersConfig;
    /**
     * @stability stable
     */
    get securityHeadersConfig(): CloudfrontResponseHeadersPolicySecurityHeadersConfigOutputReference;
    /**
     * @stability stable
     */
    putSecurityHeadersConfig(value: CloudfrontResponseHeadersPolicySecurityHeadersConfig): void;
    /**
     * @stability stable
     */
    resetSecurityHeadersConfig(): void;
    /**
     * @stability stable
     */
    get securityHeadersConfigInput(): CloudfrontResponseHeadersPolicySecurityHeadersConfig | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
