import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS CloudFront.
 *
 * @stability stable
 */
export interface DataAwsCloudfrontResponseHeadersPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_response_headers_policy#name DataAwsCloudfrontResponseHeadersPolicy#name}.
     *
     * @stability stable
     */
    readonly name?: string;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowHeaders extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get items(): string[];
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowMethods extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get items(): string[];
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontResponseHeadersPolicyCorsConfigAccessControlAllowOrigins extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get items(): string[];
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontResponseHeadersPolicyCorsConfigAccessControlExposeHeaders extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get items(): string[];
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontResponseHeadersPolicyCorsConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get accessControlAllowCredentials(): any;
    /**
     * @stability stable
     */
    get accessControlAllowHeaders(): any;
    /**
     * @stability stable
     */
    get accessControlAllowMethods(): any;
    /**
     * @stability stable
     */
    get accessControlAllowOrigins(): any;
    /**
     * @stability stable
     */
    get accessControlExposeHeaders(): any;
    /**
     * @stability stable
     */
    get accessControlMaxAgeSec(): number;
    /**
     * @stability stable
     */
    get originOverride(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontResponseHeadersPolicyCustomHeadersConfigItems extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get header(): string;
    /**
     * @stability stable
     */
    get override(): any;
    /**
     * @stability stable
     */
    get value(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontResponseHeadersPolicyCustomHeadersConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get items(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontResponseHeadersPolicySecurityHeadersConfigContentSecurityPolicy extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get contentSecurityPolicy(): string;
    /**
     * @stability stable
     */
    get override(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontResponseHeadersPolicySecurityHeadersConfigContentTypeOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get override(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontResponseHeadersPolicySecurityHeadersConfigFrameOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get frameOption(): string;
    /**
     * @stability stable
     */
    get override(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontResponseHeadersPolicySecurityHeadersConfigReferrerPolicy extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get override(): any;
    /**
     * @stability stable
     */
    get referrerPolicy(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontResponseHeadersPolicySecurityHeadersConfigStrictTransportSecurity extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get accessControlMaxAgeSec(): number;
    /**
     * @stability stable
     */
    get includeSubdomains(): any;
    /**
     * @stability stable
     */
    get override(): any;
    /**
     * @stability stable
     */
    get preload(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontResponseHeadersPolicySecurityHeadersConfigXssProtection extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get modeBlock(): any;
    /**
     * @stability stable
     */
    get override(): any;
    /**
     * @stability stable
     */
    get protection(): any;
    /**
     * @stability stable
     */
    get reportUri(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontResponseHeadersPolicySecurityHeadersConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get contentSecurityPolicy(): any;
    /**
     * @stability stable
     */
    get contentTypeOptions(): any;
    /**
     * @stability stable
     */
    get frameOptions(): any;
    /**
     * @stability stable
     */
    get referrerPolicy(): any;
    /**
     * @stability stable
     */
    get strictTransportSecurity(): any;
    /**
     * @stability stable
     */
    get xssProtection(): any;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_response_headers_policy aws_cloudfront_response_headers_policy}.
 *
 * @stability stable
 */
export declare class DataAwsCloudfrontResponseHeadersPolicy extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/cloudfront_response_headers_policy aws_cloudfront_response_headers_policy} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsCloudfrontResponseHeadersPolicyConfig);
    /**
     * @stability stable
     */
    get comment(): string;
    /**
     * @stability stable
     */
    corsConfig(index: string): DataAwsCloudfrontResponseHeadersPolicyCorsConfig;
    /**
     * @stability stable
     */
    customHeadersConfig(index: string): DataAwsCloudfrontResponseHeadersPolicyCustomHeadersConfig;
    /**
     * @stability stable
     */
    get etag(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    securityHeadersConfig(index: string): DataAwsCloudfrontResponseHeadersPolicySecurityHeadersConfig;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
