import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS CloudWatch.
 *
 * @stability stable
 */
export interface CloudwatchQueryDefinitionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_query_definition#log_group_names CloudwatchQueryDefinition#log_group_names}.
     *
     * @stability stable
     */
    readonly logGroupNames?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_query_definition#name CloudwatchQueryDefinition#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_query_definition#query_string CloudwatchQueryDefinition#query_string}.
     *
     * @stability stable
     */
    readonly queryString: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_query_definition aws_cloudwatch_query_definition}.
 *
 * @stability stable
 */
export declare class CloudwatchQueryDefinition extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_query_definition aws_cloudwatch_query_definition} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudwatchQueryDefinitionConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _logGroupNames?;
    /**
     * @stability stable
     */
    get logGroupNames(): string[];
    /**
     * @stability stable
     */
    set logGroupNames(value: string[]);
    /**
     * @stability stable
     */
    resetLogGroupNames(): void;
    /**
     * @stability stable
     */
    get logGroupNamesInput(): string[] | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get queryDefinitionId(): string;
    private _queryString?;
    /**
     * @stability stable
     */
    get queryString(): string;
    /**
     * @stability stable
     */
    set queryString(value: string);
    /**
     * @stability stable
     */
    get queryStringInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
