import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS CodeBuild.
 *
 * @stability stable
 */
export interface CodebuildProjectConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#badge_enabled CodebuildProject#badge_enabled}.
     *
     * @stability stable
     */
    readonly badgeEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#build_timeout CodebuildProject#build_timeout}.
     *
     * @stability stable
     */
    readonly buildTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#concurrent_build_limit CodebuildProject#concurrent_build_limit}.
     *
     * @stability stable
     */
    readonly concurrentBuildLimit?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#description CodebuildProject#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#encryption_key CodebuildProject#encryption_key}.
     *
     * @stability stable
     */
    readonly encryptionKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#name CodebuildProject#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#project_visibility CodebuildProject#project_visibility}.
     *
     * @stability stable
     */
    readonly projectVisibility?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#queued_timeout CodebuildProject#queued_timeout}.
     *
     * @stability stable
     */
    readonly queuedTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#resource_access_role CodebuildProject#resource_access_role}.
     *
     * @stability stable
     */
    readonly resourceAccessRole?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#service_role CodebuildProject#service_role}.
     *
     * @stability stable
     */
    readonly serviceRole: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#source_version CodebuildProject#source_version}.
     *
     * @stability stable
     */
    readonly sourceVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#tags CodebuildProject#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#tags_all CodebuildProject#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * artifacts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#artifacts CodebuildProject#artifacts}
     *
     * @stability stable
     */
    readonly artifacts: CodebuildProjectArtifacts;
    /**
     * build_batch_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#build_batch_config CodebuildProject#build_batch_config}
     *
     * @stability stable
     */
    readonly buildBatchConfig?: CodebuildProjectBuildBatchConfig;
    /**
     * cache block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#cache CodebuildProject#cache}
     *
     * @stability stable
     */
    readonly cache?: CodebuildProjectCache;
    /**
     * environment block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#environment CodebuildProject#environment}
     *
     * @stability stable
     */
    readonly environment: CodebuildProjectEnvironment;
    /**
     * file_system_locations block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#file_system_locations CodebuildProject#file_system_locations}
     *
     * @stability stable
     */
    readonly fileSystemLocations?: CodebuildProjectFileSystemLocations[];
    /**
     * logs_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#logs_config CodebuildProject#logs_config}
     *
     * @stability stable
     */
    readonly logsConfig?: CodebuildProjectLogsConfig;
    /**
     * secondary_artifacts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#secondary_artifacts CodebuildProject#secondary_artifacts}
     *
     * @stability stable
     */
    readonly secondaryArtifacts?: CodebuildProjectSecondaryArtifacts[];
    /**
     * secondary_source_version block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#secondary_source_version CodebuildProject#secondary_source_version}
     *
     * @stability stable
     */
    readonly secondarySourceVersion?: CodebuildProjectSecondarySourceVersion[];
    /**
     * secondary_sources block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#secondary_sources CodebuildProject#secondary_sources}
     *
     * @stability stable
     */
    readonly secondarySources?: CodebuildProjectSecondarySources[];
    /**
     * source block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#source CodebuildProject#source}
     *
     * @stability stable
     */
    readonly source: CodebuildProjectSource;
    /**
     * vpc_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#vpc_config CodebuildProject#vpc_config}
     *
     * @stability stable
     */
    readonly vpcConfig?: CodebuildProjectVpcConfig;
}
/**
 * @stability stable
 */
export interface CodebuildProjectArtifacts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#artifact_identifier CodebuildProject#artifact_identifier}.
     *
     * @stability stable
     */
    readonly artifactIdentifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#bucket_owner_access CodebuildProject#bucket_owner_access}.
     *
     * @stability stable
     */
    readonly bucketOwnerAccess?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#encryption_disabled CodebuildProject#encryption_disabled}.
     *
     * @stability stable
     */
    readonly encryptionDisabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#location CodebuildProject#location}.
     *
     * @stability stable
     */
    readonly location?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#name CodebuildProject#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#namespace_type CodebuildProject#namespace_type}.
     *
     * @stability stable
     */
    readonly namespaceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#override_artifact_name CodebuildProject#override_artifact_name}.
     *
     * @stability stable
     */
    readonly overrideArtifactName?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#packaging CodebuildProject#packaging}.
     *
     * @stability stable
     */
    readonly packaging?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#path CodebuildProject#path}.
     *
     * @stability stable
     */
    readonly path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#type CodebuildProject#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
export declare function codebuildProjectArtifactsToTerraform(struct?: CodebuildProjectArtifactsOutputReference | CodebuildProjectArtifacts): any;
/**
 * @stability stable
 */
export declare class CodebuildProjectArtifactsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CodebuildProjectArtifacts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CodebuildProjectArtifacts | undefined);
    private _artifactIdentifier?;
    /**
     * @stability stable
     */
    get artifactIdentifier(): string;
    /**
     * @stability stable
     */
    set artifactIdentifier(value: string);
    /**
     * @stability stable
     */
    resetArtifactIdentifier(): void;
    /**
     * @stability stable
     */
    get artifactIdentifierInput(): string | undefined;
    private _bucketOwnerAccess?;
    /**
     * @stability stable
     */
    get bucketOwnerAccess(): string;
    /**
     * @stability stable
     */
    set bucketOwnerAccess(value: string);
    /**
     * @stability stable
     */
    resetBucketOwnerAccess(): void;
    /**
     * @stability stable
     */
    get bucketOwnerAccessInput(): string | undefined;
    private _encryptionDisabled?;
    /**
     * @stability stable
     */
    get encryptionDisabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set encryptionDisabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEncryptionDisabled(): void;
    /**
     * @stability stable
     */
    get encryptionDisabledInput(): boolean | cdktf.IResolvable | undefined;
    private _location?;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    resetLocation(): void;
    /**
     * @stability stable
     */
    get locationInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namespaceType?;
    /**
     * @stability stable
     */
    get namespaceType(): string;
    /**
     * @stability stable
     */
    set namespaceType(value: string);
    /**
     * @stability stable
     */
    resetNamespaceType(): void;
    /**
     * @stability stable
     */
    get namespaceTypeInput(): string | undefined;
    private _overrideArtifactName?;
    /**
     * @stability stable
     */
    get overrideArtifactName(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set overrideArtifactName(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetOverrideArtifactName(): void;
    /**
     * @stability stable
     */
    get overrideArtifactNameInput(): boolean | cdktf.IResolvable | undefined;
    private _packaging?;
    /**
     * @stability stable
     */
    get packaging(): string;
    /**
     * @stability stable
     */
    set packaging(value: string);
    /**
     * @stability stable
     */
    resetPackaging(): void;
    /**
     * @stability stable
     */
    get packagingInput(): string | undefined;
    private _path?;
    /**
     * @stability stable
     */
    get path(): string;
    /**
     * @stability stable
     */
    set path(value: string);
    /**
     * @stability stable
     */
    resetPath(): void;
    /**
     * @stability stable
     */
    get pathInput(): string | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CodebuildProjectBuildBatchConfigRestrictions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#compute_types_allowed CodebuildProject#compute_types_allowed}.
     *
     * @stability stable
     */
    readonly computeTypesAllowed?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#maximum_builds_allowed CodebuildProject#maximum_builds_allowed}.
     *
     * @stability stable
     */
    readonly maximumBuildsAllowed?: number;
}
export declare function codebuildProjectBuildBatchConfigRestrictionsToTerraform(struct?: CodebuildProjectBuildBatchConfigRestrictionsOutputReference | CodebuildProjectBuildBatchConfigRestrictions): any;
/**
 * @stability stable
 */
export declare class CodebuildProjectBuildBatchConfigRestrictionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CodebuildProjectBuildBatchConfigRestrictions | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CodebuildProjectBuildBatchConfigRestrictions | undefined);
    private _computeTypesAllowed?;
    /**
     * @stability stable
     */
    get computeTypesAllowed(): string[];
    /**
     * @stability stable
     */
    set computeTypesAllowed(value: string[]);
    /**
     * @stability stable
     */
    resetComputeTypesAllowed(): void;
    /**
     * @stability stable
     */
    get computeTypesAllowedInput(): string[] | undefined;
    private _maximumBuildsAllowed?;
    /**
     * @stability stable
     */
    get maximumBuildsAllowed(): number;
    /**
     * @stability stable
     */
    set maximumBuildsAllowed(value: number);
    /**
     * @stability stable
     */
    resetMaximumBuildsAllowed(): void;
    /**
     * @stability stable
     */
    get maximumBuildsAllowedInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface CodebuildProjectBuildBatchConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#combine_artifacts CodebuildProject#combine_artifacts}.
     *
     * @stability stable
     */
    readonly combineArtifacts?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#service_role CodebuildProject#service_role}.
     *
     * @stability stable
     */
    readonly serviceRole: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#timeout_in_mins CodebuildProject#timeout_in_mins}.
     *
     * @stability stable
     */
    readonly timeoutInMins?: number;
    /**
     * restrictions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#restrictions CodebuildProject#restrictions}
     *
     * @stability stable
     */
    readonly restrictions?: CodebuildProjectBuildBatchConfigRestrictions;
}
export declare function codebuildProjectBuildBatchConfigToTerraform(struct?: CodebuildProjectBuildBatchConfigOutputReference | CodebuildProjectBuildBatchConfig): any;
/**
 * @stability stable
 */
export declare class CodebuildProjectBuildBatchConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CodebuildProjectBuildBatchConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CodebuildProjectBuildBatchConfig | undefined);
    private _combineArtifacts?;
    /**
     * @stability stable
     */
    get combineArtifacts(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set combineArtifacts(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetCombineArtifacts(): void;
    /**
     * @stability stable
     */
    get combineArtifactsInput(): boolean | cdktf.IResolvable | undefined;
    private _serviceRole?;
    /**
     * @stability stable
     */
    get serviceRole(): string;
    /**
     * @stability stable
     */
    set serviceRole(value: string);
    /**
     * @stability stable
     */
    get serviceRoleInput(): string | undefined;
    private _timeoutInMins?;
    /**
     * @stability stable
     */
    get timeoutInMins(): number;
    /**
     * @stability stable
     */
    set timeoutInMins(value: number);
    /**
     * @stability stable
     */
    resetTimeoutInMins(): void;
    /**
     * @stability stable
     */
    get timeoutInMinsInput(): number | undefined;
    private _restrictions;
    /**
     * @stability stable
     */
    get restrictions(): CodebuildProjectBuildBatchConfigRestrictionsOutputReference;
    /**
     * @stability stable
     */
    putRestrictions(value: CodebuildProjectBuildBatchConfigRestrictions): void;
    /**
     * @stability stable
     */
    resetRestrictions(): void;
    /**
     * @stability stable
     */
    get restrictionsInput(): CodebuildProjectBuildBatchConfigRestrictions | undefined;
}
/**
 * @stability stable
 */
export interface CodebuildProjectCache {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#location CodebuildProject#location}.
     *
     * @stability stable
     */
    readonly location?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#modes CodebuildProject#modes}.
     *
     * @stability stable
     */
    readonly modes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#type CodebuildProject#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
export declare function codebuildProjectCacheToTerraform(struct?: CodebuildProjectCacheOutputReference | CodebuildProjectCache): any;
/**
 * @stability stable
 */
export declare class CodebuildProjectCacheOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CodebuildProjectCache | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CodebuildProjectCache | undefined);
    private _location?;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    resetLocation(): void;
    /**
     * @stability stable
     */
    get locationInput(): string | undefined;
    private _modes?;
    /**
     * @stability stable
     */
    get modes(): string[];
    /**
     * @stability stable
     */
    set modes(value: string[]);
    /**
     * @stability stable
     */
    resetModes(): void;
    /**
     * @stability stable
     */
    get modesInput(): string[] | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CodebuildProjectEnvironmentEnvironmentVariable {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#name CodebuildProject#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#type CodebuildProject#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#value CodebuildProject#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function codebuildProjectEnvironmentEnvironmentVariableToTerraform(struct?: CodebuildProjectEnvironmentEnvironmentVariable): any;
/**
 * @stability stable
 */
export interface CodebuildProjectEnvironmentRegistryCredential {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#credential CodebuildProject#credential}.
     *
     * @stability stable
     */
    readonly credential: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#credential_provider CodebuildProject#credential_provider}.
     *
     * @stability stable
     */
    readonly credentialProvider: string;
}
export declare function codebuildProjectEnvironmentRegistryCredentialToTerraform(struct?: CodebuildProjectEnvironmentRegistryCredentialOutputReference | CodebuildProjectEnvironmentRegistryCredential): any;
/**
 * @stability stable
 */
export declare class CodebuildProjectEnvironmentRegistryCredentialOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CodebuildProjectEnvironmentRegistryCredential | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CodebuildProjectEnvironmentRegistryCredential | undefined);
    private _credential?;
    /**
     * @stability stable
     */
    get credential(): string;
    /**
     * @stability stable
     */
    set credential(value: string);
    /**
     * @stability stable
     */
    get credentialInput(): string | undefined;
    private _credentialProvider?;
    /**
     * @stability stable
     */
    get credentialProvider(): string;
    /**
     * @stability stable
     */
    set credentialProvider(value: string);
    /**
     * @stability stable
     */
    get credentialProviderInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CodebuildProjectEnvironment {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#certificate CodebuildProject#certificate}.
     *
     * @stability stable
     */
    readonly certificate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#compute_type CodebuildProject#compute_type}.
     *
     * @stability stable
     */
    readonly computeType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#image CodebuildProject#image}.
     *
     * @stability stable
     */
    readonly image: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#image_pull_credentials_type CodebuildProject#image_pull_credentials_type}.
     *
     * @stability stable
     */
    readonly imagePullCredentialsType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#privileged_mode CodebuildProject#privileged_mode}.
     *
     * @stability stable
     */
    readonly privilegedMode?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#type CodebuildProject#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * environment_variable block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#environment_variable CodebuildProject#environment_variable}
     *
     * @stability stable
     */
    readonly environmentVariable?: CodebuildProjectEnvironmentEnvironmentVariable[];
    /**
     * registry_credential block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#registry_credential CodebuildProject#registry_credential}
     *
     * @stability stable
     */
    readonly registryCredential?: CodebuildProjectEnvironmentRegistryCredential;
}
export declare function codebuildProjectEnvironmentToTerraform(struct?: CodebuildProjectEnvironmentOutputReference | CodebuildProjectEnvironment): any;
/**
 * @stability stable
 */
export declare class CodebuildProjectEnvironmentOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CodebuildProjectEnvironment | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CodebuildProjectEnvironment | undefined);
    private _certificate?;
    /**
     * @stability stable
     */
    get certificate(): string;
    /**
     * @stability stable
     */
    set certificate(value: string);
    /**
     * @stability stable
     */
    resetCertificate(): void;
    /**
     * @stability stable
     */
    get certificateInput(): string | undefined;
    private _computeType?;
    /**
     * @stability stable
     */
    get computeType(): string;
    /**
     * @stability stable
     */
    set computeType(value: string);
    /**
     * @stability stable
     */
    get computeTypeInput(): string | undefined;
    private _image?;
    /**
     * @stability stable
     */
    get image(): string;
    /**
     * @stability stable
     */
    set image(value: string);
    /**
     * @stability stable
     */
    get imageInput(): string | undefined;
    private _imagePullCredentialsType?;
    /**
     * @stability stable
     */
    get imagePullCredentialsType(): string;
    /**
     * @stability stable
     */
    set imagePullCredentialsType(value: string);
    /**
     * @stability stable
     */
    resetImagePullCredentialsType(): void;
    /**
     * @stability stable
     */
    get imagePullCredentialsTypeInput(): string | undefined;
    private _privilegedMode?;
    /**
     * @stability stable
     */
    get privilegedMode(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set privilegedMode(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetPrivilegedMode(): void;
    /**
     * @stability stable
     */
    get privilegedModeInput(): boolean | cdktf.IResolvable | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _environmentVariable?;
    /**
     * @stability stable
     */
    get environmentVariable(): CodebuildProjectEnvironmentEnvironmentVariable[];
    /**
     * @stability stable
     */
    set environmentVariable(value: CodebuildProjectEnvironmentEnvironmentVariable[]);
    /**
     * @stability stable
     */
    resetEnvironmentVariable(): void;
    /**
     * @stability stable
     */
    get environmentVariableInput(): CodebuildProjectEnvironmentEnvironmentVariable[] | undefined;
    private _registryCredential;
    /**
     * @stability stable
     */
    get registryCredential(): CodebuildProjectEnvironmentRegistryCredentialOutputReference;
    /**
     * @stability stable
     */
    putRegistryCredential(value: CodebuildProjectEnvironmentRegistryCredential): void;
    /**
     * @stability stable
     */
    resetRegistryCredential(): void;
    /**
     * @stability stable
     */
    get registryCredentialInput(): CodebuildProjectEnvironmentRegistryCredential | undefined;
}
/**
 * @stability stable
 */
export interface CodebuildProjectFileSystemLocations {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#identifier CodebuildProject#identifier}.
     *
     * @stability stable
     */
    readonly identifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#location CodebuildProject#location}.
     *
     * @stability stable
     */
    readonly location?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#mount_options CodebuildProject#mount_options}.
     *
     * @stability stable
     */
    readonly mountOptions?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#mount_point CodebuildProject#mount_point}.
     *
     * @stability stable
     */
    readonly mountPoint?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#type CodebuildProject#type}.
     *
     * @stability stable
     */
    readonly type?: string;
}
export declare function codebuildProjectFileSystemLocationsToTerraform(struct?: CodebuildProjectFileSystemLocations): any;
/**
 * @stability stable
 */
export interface CodebuildProjectLogsConfigCloudwatchLogs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#group_name CodebuildProject#group_name}.
     *
     * @stability stable
     */
    readonly groupName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#status CodebuildProject#status}.
     *
     * @stability stable
     */
    readonly status?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#stream_name CodebuildProject#stream_name}.
     *
     * @stability stable
     */
    readonly streamName?: string;
}
export declare function codebuildProjectLogsConfigCloudwatchLogsToTerraform(struct?: CodebuildProjectLogsConfigCloudwatchLogsOutputReference | CodebuildProjectLogsConfigCloudwatchLogs): any;
/**
 * @stability stable
 */
export declare class CodebuildProjectLogsConfigCloudwatchLogsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CodebuildProjectLogsConfigCloudwatchLogs | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CodebuildProjectLogsConfigCloudwatchLogs | undefined);
    private _groupName?;
    /**
     * @stability stable
     */
    get groupName(): string;
    /**
     * @stability stable
     */
    set groupName(value: string);
    /**
     * @stability stable
     */
    resetGroupName(): void;
    /**
     * @stability stable
     */
    get groupNameInput(): string | undefined;
    private _status?;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    set status(value: string);
    /**
     * @stability stable
     */
    resetStatus(): void;
    /**
     * @stability stable
     */
    get statusInput(): string | undefined;
    private _streamName?;
    /**
     * @stability stable
     */
    get streamName(): string;
    /**
     * @stability stable
     */
    set streamName(value: string);
    /**
     * @stability stable
     */
    resetStreamName(): void;
    /**
     * @stability stable
     */
    get streamNameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CodebuildProjectLogsConfigS3Logs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#bucket_owner_access CodebuildProject#bucket_owner_access}.
     *
     * @stability stable
     */
    readonly bucketOwnerAccess?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#encryption_disabled CodebuildProject#encryption_disabled}.
     *
     * @stability stable
     */
    readonly encryptionDisabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#location CodebuildProject#location}.
     *
     * @stability stable
     */
    readonly location?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#status CodebuildProject#status}.
     *
     * @stability stable
     */
    readonly status?: string;
}
export declare function codebuildProjectLogsConfigS3LogsToTerraform(struct?: CodebuildProjectLogsConfigS3LogsOutputReference | CodebuildProjectLogsConfigS3Logs): any;
/**
 * @stability stable
 */
export declare class CodebuildProjectLogsConfigS3LogsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CodebuildProjectLogsConfigS3Logs | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CodebuildProjectLogsConfigS3Logs | undefined);
    private _bucketOwnerAccess?;
    /**
     * @stability stable
     */
    get bucketOwnerAccess(): string;
    /**
     * @stability stable
     */
    set bucketOwnerAccess(value: string);
    /**
     * @stability stable
     */
    resetBucketOwnerAccess(): void;
    /**
     * @stability stable
     */
    get bucketOwnerAccessInput(): string | undefined;
    private _encryptionDisabled?;
    /**
     * @stability stable
     */
    get encryptionDisabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set encryptionDisabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEncryptionDisabled(): void;
    /**
     * @stability stable
     */
    get encryptionDisabledInput(): boolean | cdktf.IResolvable | undefined;
    private _location?;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    resetLocation(): void;
    /**
     * @stability stable
     */
    get locationInput(): string | undefined;
    private _status?;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    set status(value: string);
    /**
     * @stability stable
     */
    resetStatus(): void;
    /**
     * @stability stable
     */
    get statusInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CodebuildProjectLogsConfig {
    /**
     * cloudwatch_logs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#cloudwatch_logs CodebuildProject#cloudwatch_logs}
     *
     * @stability stable
     */
    readonly cloudwatchLogs?: CodebuildProjectLogsConfigCloudwatchLogs;
    /**
     * s3_logs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#s3_logs CodebuildProject#s3_logs}
     *
     * @stability stable
     */
    readonly s3Logs?: CodebuildProjectLogsConfigS3Logs;
}
export declare function codebuildProjectLogsConfigToTerraform(struct?: CodebuildProjectLogsConfigOutputReference | CodebuildProjectLogsConfig): any;
/**
 * @stability stable
 */
export declare class CodebuildProjectLogsConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CodebuildProjectLogsConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CodebuildProjectLogsConfig | undefined);
    private _cloudwatchLogs;
    /**
     * @stability stable
     */
    get cloudwatchLogs(): CodebuildProjectLogsConfigCloudwatchLogsOutputReference;
    /**
     * @stability stable
     */
    putCloudwatchLogs(value: CodebuildProjectLogsConfigCloudwatchLogs): void;
    /**
     * @stability stable
     */
    resetCloudwatchLogs(): void;
    /**
     * @stability stable
     */
    get cloudwatchLogsInput(): CodebuildProjectLogsConfigCloudwatchLogs | undefined;
    private _s3Logs;
    /**
     * @stability stable
     */
    get s3Logs(): CodebuildProjectLogsConfigS3LogsOutputReference;
    /**
     * @stability stable
     */
    putS3Logs(value: CodebuildProjectLogsConfigS3Logs): void;
    /**
     * @stability stable
     */
    resetS3Logs(): void;
    /**
     * @stability stable
     */
    get s3LogsInput(): CodebuildProjectLogsConfigS3Logs | undefined;
}
/**
 * @stability stable
 */
export interface CodebuildProjectSecondaryArtifacts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#artifact_identifier CodebuildProject#artifact_identifier}.
     *
     * @stability stable
     */
    readonly artifactIdentifier: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#bucket_owner_access CodebuildProject#bucket_owner_access}.
     *
     * @stability stable
     */
    readonly bucketOwnerAccess?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#encryption_disabled CodebuildProject#encryption_disabled}.
     *
     * @stability stable
     */
    readonly encryptionDisabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#location CodebuildProject#location}.
     *
     * @stability stable
     */
    readonly location?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#name CodebuildProject#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#namespace_type CodebuildProject#namespace_type}.
     *
     * @stability stable
     */
    readonly namespaceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#override_artifact_name CodebuildProject#override_artifact_name}.
     *
     * @stability stable
     */
    readonly overrideArtifactName?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#packaging CodebuildProject#packaging}.
     *
     * @stability stable
     */
    readonly packaging?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#path CodebuildProject#path}.
     *
     * @stability stable
     */
    readonly path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#type CodebuildProject#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
export declare function codebuildProjectSecondaryArtifactsToTerraform(struct?: CodebuildProjectSecondaryArtifacts): any;
/**
 * @stability stable
 */
export interface CodebuildProjectSecondarySourceVersion {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#source_identifier CodebuildProject#source_identifier}.
     *
     * @stability stable
     */
    readonly sourceIdentifier: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#source_version CodebuildProject#source_version}.
     *
     * @stability stable
     */
    readonly sourceVersion: string;
}
export declare function codebuildProjectSecondarySourceVersionToTerraform(struct?: CodebuildProjectSecondarySourceVersion): any;
/**
 * @stability stable
 */
export interface CodebuildProjectSecondarySourcesAuth {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#resource CodebuildProject#resource}.
     *
     * @stability stable
     */
    readonly resource?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#type CodebuildProject#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
export declare function codebuildProjectSecondarySourcesAuthToTerraform(struct?: CodebuildProjectSecondarySourcesAuthOutputReference | CodebuildProjectSecondarySourcesAuth): any;
/**
 * @stability stable
 */
export declare class CodebuildProjectSecondarySourcesAuthOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CodebuildProjectSecondarySourcesAuth | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CodebuildProjectSecondarySourcesAuth | undefined);
    private _resource?;
    /**
     * @stability stable
     */
    get resource(): string;
    /**
     * @stability stable
     */
    set resource(value: string);
    /**
     * @stability stable
     */
    resetResource(): void;
    /**
     * @stability stable
     */
    get resourceInput(): string | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CodebuildProjectSecondarySourcesBuildStatusConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#context CodebuildProject#context}.
     *
     * @stability stable
     */
    readonly context?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#target_url CodebuildProject#target_url}.
     *
     * @stability stable
     */
    readonly targetUrl?: string;
}
export declare function codebuildProjectSecondarySourcesBuildStatusConfigToTerraform(struct?: CodebuildProjectSecondarySourcesBuildStatusConfigOutputReference | CodebuildProjectSecondarySourcesBuildStatusConfig): any;
/**
 * @stability stable
 */
export declare class CodebuildProjectSecondarySourcesBuildStatusConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CodebuildProjectSecondarySourcesBuildStatusConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CodebuildProjectSecondarySourcesBuildStatusConfig | undefined);
    private _context?;
    /**
     * @stability stable
     */
    get context(): string;
    /**
     * @stability stable
     */
    set context(value: string);
    /**
     * @stability stable
     */
    resetContext(): void;
    /**
     * @stability stable
     */
    get contextInput(): string | undefined;
    private _targetUrl?;
    /**
     * @stability stable
     */
    get targetUrl(): string;
    /**
     * @stability stable
     */
    set targetUrl(value: string);
    /**
     * @stability stable
     */
    resetTargetUrl(): void;
    /**
     * @stability stable
     */
    get targetUrlInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CodebuildProjectSecondarySourcesGitSubmodulesConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#fetch_submodules CodebuildProject#fetch_submodules}.
     *
     * @stability stable
     */
    readonly fetchSubmodules: boolean | cdktf.IResolvable;
}
export declare function codebuildProjectSecondarySourcesGitSubmodulesConfigToTerraform(struct?: CodebuildProjectSecondarySourcesGitSubmodulesConfigOutputReference | CodebuildProjectSecondarySourcesGitSubmodulesConfig): any;
/**
 * @stability stable
 */
export declare class CodebuildProjectSecondarySourcesGitSubmodulesConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CodebuildProjectSecondarySourcesGitSubmodulesConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CodebuildProjectSecondarySourcesGitSubmodulesConfig | undefined);
    private _fetchSubmodules?;
    /**
     * @stability stable
     */
    get fetchSubmodules(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set fetchSubmodules(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get fetchSubmodulesInput(): boolean | cdktf.IResolvable | undefined;
}
/**
 * @stability stable
 */
export interface CodebuildProjectSecondarySources {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#buildspec CodebuildProject#buildspec}.
     *
     * @stability stable
     */
    readonly buildspec?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#git_clone_depth CodebuildProject#git_clone_depth}.
     *
     * @stability stable
     */
    readonly gitCloneDepth?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#insecure_ssl CodebuildProject#insecure_ssl}.
     *
     * @stability stable
     */
    readonly insecureSsl?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#location CodebuildProject#location}.
     *
     * @stability stable
     */
    readonly location?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#report_build_status CodebuildProject#report_build_status}.
     *
     * @stability stable
     */
    readonly reportBuildStatus?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#source_identifier CodebuildProject#source_identifier}.
     *
     * @stability stable
     */
    readonly sourceIdentifier: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#type CodebuildProject#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * auth block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#auth CodebuildProject#auth}
     *
     * @stability stable
     */
    readonly auth?: CodebuildProjectSecondarySourcesAuth;
    /**
     * build_status_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#build_status_config CodebuildProject#build_status_config}
     *
     * @stability stable
     */
    readonly buildStatusConfig?: CodebuildProjectSecondarySourcesBuildStatusConfig;
    /**
     * git_submodules_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#git_submodules_config CodebuildProject#git_submodules_config}
     *
     * @stability stable
     */
    readonly gitSubmodulesConfig?: CodebuildProjectSecondarySourcesGitSubmodulesConfig;
}
export declare function codebuildProjectSecondarySourcesToTerraform(struct?: CodebuildProjectSecondarySources): any;
/**
 * @stability stable
 */
export interface CodebuildProjectSourceAuth {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#resource CodebuildProject#resource}.
     *
     * @stability stable
     */
    readonly resource?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#type CodebuildProject#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
export declare function codebuildProjectSourceAuthToTerraform(struct?: CodebuildProjectSourceAuthOutputReference | CodebuildProjectSourceAuth): any;
/**
 * @stability stable
 */
export declare class CodebuildProjectSourceAuthOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CodebuildProjectSourceAuth | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CodebuildProjectSourceAuth | undefined);
    private _resource?;
    /**
     * @stability stable
     */
    get resource(): string;
    /**
     * @stability stable
     */
    set resource(value: string);
    /**
     * @stability stable
     */
    resetResource(): void;
    /**
     * @stability stable
     */
    get resourceInput(): string | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CodebuildProjectSourceBuildStatusConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#context CodebuildProject#context}.
     *
     * @stability stable
     */
    readonly context?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#target_url CodebuildProject#target_url}.
     *
     * @stability stable
     */
    readonly targetUrl?: string;
}
export declare function codebuildProjectSourceBuildStatusConfigToTerraform(struct?: CodebuildProjectSourceBuildStatusConfigOutputReference | CodebuildProjectSourceBuildStatusConfig): any;
/**
 * @stability stable
 */
export declare class CodebuildProjectSourceBuildStatusConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CodebuildProjectSourceBuildStatusConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CodebuildProjectSourceBuildStatusConfig | undefined);
    private _context?;
    /**
     * @stability stable
     */
    get context(): string;
    /**
     * @stability stable
     */
    set context(value: string);
    /**
     * @stability stable
     */
    resetContext(): void;
    /**
     * @stability stable
     */
    get contextInput(): string | undefined;
    private _targetUrl?;
    /**
     * @stability stable
     */
    get targetUrl(): string;
    /**
     * @stability stable
     */
    set targetUrl(value: string);
    /**
     * @stability stable
     */
    resetTargetUrl(): void;
    /**
     * @stability stable
     */
    get targetUrlInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CodebuildProjectSourceGitSubmodulesConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#fetch_submodules CodebuildProject#fetch_submodules}.
     *
     * @stability stable
     */
    readonly fetchSubmodules: boolean | cdktf.IResolvable;
}
export declare function codebuildProjectSourceGitSubmodulesConfigToTerraform(struct?: CodebuildProjectSourceGitSubmodulesConfigOutputReference | CodebuildProjectSourceGitSubmodulesConfig): any;
/**
 * @stability stable
 */
export declare class CodebuildProjectSourceGitSubmodulesConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CodebuildProjectSourceGitSubmodulesConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CodebuildProjectSourceGitSubmodulesConfig | undefined);
    private _fetchSubmodules?;
    /**
     * @stability stable
     */
    get fetchSubmodules(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set fetchSubmodules(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get fetchSubmodulesInput(): boolean | cdktf.IResolvable | undefined;
}
/**
 * @stability stable
 */
export interface CodebuildProjectSource {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#buildspec CodebuildProject#buildspec}.
     *
     * @stability stable
     */
    readonly buildspec?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#git_clone_depth CodebuildProject#git_clone_depth}.
     *
     * @stability stable
     */
    readonly gitCloneDepth?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#insecure_ssl CodebuildProject#insecure_ssl}.
     *
     * @stability stable
     */
    readonly insecureSsl?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#location CodebuildProject#location}.
     *
     * @stability stable
     */
    readonly location?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#report_build_status CodebuildProject#report_build_status}.
     *
     * @stability stable
     */
    readonly reportBuildStatus?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#type CodebuildProject#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * auth block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#auth CodebuildProject#auth}
     *
     * @stability stable
     */
    readonly auth?: CodebuildProjectSourceAuth;
    /**
     * build_status_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#build_status_config CodebuildProject#build_status_config}
     *
     * @stability stable
     */
    readonly buildStatusConfig?: CodebuildProjectSourceBuildStatusConfig;
    /**
     * git_submodules_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#git_submodules_config CodebuildProject#git_submodules_config}
     *
     * @stability stable
     */
    readonly gitSubmodulesConfig?: CodebuildProjectSourceGitSubmodulesConfig;
}
export declare function codebuildProjectSourceToTerraform(struct?: CodebuildProjectSourceOutputReference | CodebuildProjectSource): any;
/**
 * @stability stable
 */
export declare class CodebuildProjectSourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CodebuildProjectSource | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CodebuildProjectSource | undefined);
    private _buildspec?;
    /**
     * @stability stable
     */
    get buildspec(): string;
    /**
     * @stability stable
     */
    set buildspec(value: string);
    /**
     * @stability stable
     */
    resetBuildspec(): void;
    /**
     * @stability stable
     */
    get buildspecInput(): string | undefined;
    private _gitCloneDepth?;
    /**
     * @stability stable
     */
    get gitCloneDepth(): number;
    /**
     * @stability stable
     */
    set gitCloneDepth(value: number);
    /**
     * @stability stable
     */
    resetGitCloneDepth(): void;
    /**
     * @stability stable
     */
    get gitCloneDepthInput(): number | undefined;
    private _insecureSsl?;
    /**
     * @stability stable
     */
    get insecureSsl(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set insecureSsl(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetInsecureSsl(): void;
    /**
     * @stability stable
     */
    get insecureSslInput(): boolean | cdktf.IResolvable | undefined;
    private _location?;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    resetLocation(): void;
    /**
     * @stability stable
     */
    get locationInput(): string | undefined;
    private _reportBuildStatus?;
    /**
     * @stability stable
     */
    get reportBuildStatus(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set reportBuildStatus(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetReportBuildStatus(): void;
    /**
     * @stability stable
     */
    get reportBuildStatusInput(): boolean | cdktf.IResolvable | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _auth;
    /**
     * @stability stable
     */
    get auth(): CodebuildProjectSourceAuthOutputReference;
    /**
     * @stability stable
     */
    putAuth(value: CodebuildProjectSourceAuth): void;
    /**
     * @stability stable
     */
    resetAuth(): void;
    /**
     * @stability stable
     */
    get authInput(): CodebuildProjectSourceAuth | undefined;
    private _buildStatusConfig;
    /**
     * @stability stable
     */
    get buildStatusConfig(): CodebuildProjectSourceBuildStatusConfigOutputReference;
    /**
     * @stability stable
     */
    putBuildStatusConfig(value: CodebuildProjectSourceBuildStatusConfig): void;
    /**
     * @stability stable
     */
    resetBuildStatusConfig(): void;
    /**
     * @stability stable
     */
    get buildStatusConfigInput(): CodebuildProjectSourceBuildStatusConfig | undefined;
    private _gitSubmodulesConfig;
    /**
     * @stability stable
     */
    get gitSubmodulesConfig(): CodebuildProjectSourceGitSubmodulesConfigOutputReference;
    /**
     * @stability stable
     */
    putGitSubmodulesConfig(value: CodebuildProjectSourceGitSubmodulesConfig): void;
    /**
     * @stability stable
     */
    resetGitSubmodulesConfig(): void;
    /**
     * @stability stable
     */
    get gitSubmodulesConfigInput(): CodebuildProjectSourceGitSubmodulesConfig | undefined;
}
/**
 * @stability stable
 */
export interface CodebuildProjectVpcConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#security_group_ids CodebuildProject#security_group_ids}.
     *
     * @stability stable
     */
    readonly securityGroupIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#subnets CodebuildProject#subnets}.
     *
     * @stability stable
     */
    readonly subnets: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project#vpc_id CodebuildProject#vpc_id}.
     *
     * @stability stable
     */
    readonly vpcId: string;
}
export declare function codebuildProjectVpcConfigToTerraform(struct?: CodebuildProjectVpcConfigOutputReference | CodebuildProjectVpcConfig): any;
/**
 * @stability stable
 */
export declare class CodebuildProjectVpcConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CodebuildProjectVpcConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CodebuildProjectVpcConfig | undefined);
    private _securityGroupIds?;
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    set securityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    get securityGroupIdsInput(): string[] | undefined;
    private _subnets?;
    /**
     * @stability stable
     */
    get subnets(): string[];
    /**
     * @stability stable
     */
    set subnets(value: string[]);
    /**
     * @stability stable
     */
    get subnetsInput(): string[] | undefined;
    private _vpcId?;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    get vpcIdInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project aws_codebuild_project}.
 *
 * @stability stable
 */
export declare class CodebuildProject extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/codebuild_project aws_codebuild_project} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CodebuildProjectConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _badgeEnabled?;
    /**
     * @stability stable
     */
    get badgeEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set badgeEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetBadgeEnabled(): void;
    /**
     * @stability stable
     */
    get badgeEnabledInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get badgeUrl(): string;
    private _buildTimeout?;
    /**
     * @stability stable
     */
    get buildTimeout(): number;
    /**
     * @stability stable
     */
    set buildTimeout(value: number);
    /**
     * @stability stable
     */
    resetBuildTimeout(): void;
    /**
     * @stability stable
     */
    get buildTimeoutInput(): number | undefined;
    private _concurrentBuildLimit?;
    /**
     * @stability stable
     */
    get concurrentBuildLimit(): number;
    /**
     * @stability stable
     */
    set concurrentBuildLimit(value: number);
    /**
     * @stability stable
     */
    resetConcurrentBuildLimit(): void;
    /**
     * @stability stable
     */
    get concurrentBuildLimitInput(): number | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _encryptionKey?;
    /**
     * @stability stable
     */
    get encryptionKey(): string;
    /**
     * @stability stable
     */
    set encryptionKey(value: string);
    /**
     * @stability stable
     */
    resetEncryptionKey(): void;
    /**
     * @stability stable
     */
    get encryptionKeyInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _projectVisibility?;
    /**
     * @stability stable
     */
    get projectVisibility(): string;
    /**
     * @stability stable
     */
    set projectVisibility(value: string);
    /**
     * @stability stable
     */
    resetProjectVisibility(): void;
    /**
     * @stability stable
     */
    get projectVisibilityInput(): string | undefined;
    /**
     * @stability stable
     */
    get publicProjectAlias(): string;
    private _queuedTimeout?;
    /**
     * @stability stable
     */
    get queuedTimeout(): number;
    /**
     * @stability stable
     */
    set queuedTimeout(value: number);
    /**
     * @stability stable
     */
    resetQueuedTimeout(): void;
    /**
     * @stability stable
     */
    get queuedTimeoutInput(): number | undefined;
    private _resourceAccessRole?;
    /**
     * @stability stable
     */
    get resourceAccessRole(): string;
    /**
     * @stability stable
     */
    set resourceAccessRole(value: string);
    /**
     * @stability stable
     */
    resetResourceAccessRole(): void;
    /**
     * @stability stable
     */
    get resourceAccessRoleInput(): string | undefined;
    private _serviceRole?;
    /**
     * @stability stable
     */
    get serviceRole(): string;
    /**
     * @stability stable
     */
    set serviceRole(value: string);
    /**
     * @stability stable
     */
    get serviceRoleInput(): string | undefined;
    private _sourceVersion?;
    /**
     * @stability stable
     */
    get sourceVersion(): string;
    /**
     * @stability stable
     */
    set sourceVersion(value: string);
    /**
     * @stability stable
     */
    resetSourceVersion(): void;
    /**
     * @stability stable
     */
    get sourceVersionInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _artifacts;
    /**
     * @stability stable
     */
    get artifacts(): CodebuildProjectArtifactsOutputReference;
    /**
     * @stability stable
     */
    putArtifacts(value: CodebuildProjectArtifacts): void;
    /**
     * @stability stable
     */
    get artifactsInput(): CodebuildProjectArtifacts | undefined;
    private _buildBatchConfig;
    /**
     * @stability stable
     */
    get buildBatchConfig(): CodebuildProjectBuildBatchConfigOutputReference;
    /**
     * @stability stable
     */
    putBuildBatchConfig(value: CodebuildProjectBuildBatchConfig): void;
    /**
     * @stability stable
     */
    resetBuildBatchConfig(): void;
    /**
     * @stability stable
     */
    get buildBatchConfigInput(): CodebuildProjectBuildBatchConfig | undefined;
    private _cache;
    /**
     * @stability stable
     */
    get cache(): CodebuildProjectCacheOutputReference;
    /**
     * @stability stable
     */
    putCache(value: CodebuildProjectCache): void;
    /**
     * @stability stable
     */
    resetCache(): void;
    /**
     * @stability stable
     */
    get cacheInput(): CodebuildProjectCache | undefined;
    private _environment;
    /**
     * @stability stable
     */
    get environment(): CodebuildProjectEnvironmentOutputReference;
    /**
     * @stability stable
     */
    putEnvironment(value: CodebuildProjectEnvironment): void;
    /**
     * @stability stable
     */
    get environmentInput(): CodebuildProjectEnvironment | undefined;
    private _fileSystemLocations?;
    /**
     * @stability stable
     */
    get fileSystemLocations(): CodebuildProjectFileSystemLocations[];
    /**
     * @stability stable
     */
    set fileSystemLocations(value: CodebuildProjectFileSystemLocations[]);
    /**
     * @stability stable
     */
    resetFileSystemLocations(): void;
    /**
     * @stability stable
     */
    get fileSystemLocationsInput(): CodebuildProjectFileSystemLocations[] | undefined;
    private _logsConfig;
    /**
     * @stability stable
     */
    get logsConfig(): CodebuildProjectLogsConfigOutputReference;
    /**
     * @stability stable
     */
    putLogsConfig(value: CodebuildProjectLogsConfig): void;
    /**
     * @stability stable
     */
    resetLogsConfig(): void;
    /**
     * @stability stable
     */
    get logsConfigInput(): CodebuildProjectLogsConfig | undefined;
    private _secondaryArtifacts?;
    /**
     * @stability stable
     */
    get secondaryArtifacts(): CodebuildProjectSecondaryArtifacts[];
    /**
     * @stability stable
     */
    set secondaryArtifacts(value: CodebuildProjectSecondaryArtifacts[]);
    /**
     * @stability stable
     */
    resetSecondaryArtifacts(): void;
    /**
     * @stability stable
     */
    get secondaryArtifactsInput(): CodebuildProjectSecondaryArtifacts[] | undefined;
    private _secondarySourceVersion?;
    /**
     * @stability stable
     */
    get secondarySourceVersion(): CodebuildProjectSecondarySourceVersion[];
    /**
     * @stability stable
     */
    set secondarySourceVersion(value: CodebuildProjectSecondarySourceVersion[]);
    /**
     * @stability stable
     */
    resetSecondarySourceVersion(): void;
    /**
     * @stability stable
     */
    get secondarySourceVersionInput(): CodebuildProjectSecondarySourceVersion[] | undefined;
    private _secondarySources?;
    /**
     * @stability stable
     */
    get secondarySources(): CodebuildProjectSecondarySources[];
    /**
     * @stability stable
     */
    set secondarySources(value: CodebuildProjectSecondarySources[]);
    /**
     * @stability stable
     */
    resetSecondarySources(): void;
    /**
     * @stability stable
     */
    get secondarySourcesInput(): CodebuildProjectSecondarySources[] | undefined;
    private _source;
    /**
     * @stability stable
     */
    get source(): CodebuildProjectSourceOutputReference;
    /**
     * @stability stable
     */
    putSource(value: CodebuildProjectSource): void;
    /**
     * @stability stable
     */
    get sourceInput(): CodebuildProjectSource | undefined;
    private _vpcConfig;
    /**
     * @stability stable
     */
    get vpcConfig(): CodebuildProjectVpcConfigOutputReference;
    /**
     * @stability stable
     */
    putVpcConfig(value: CodebuildProjectVpcConfig): void;
    /**
     * @stability stable
     */
    resetVpcConfig(): void;
    /**
     * @stability stable
     */
    get vpcConfigInput(): CodebuildProjectVpcConfig | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
