import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS CodeBuild.
 *
 * @stability stable
 */
export interface CodebuildReportGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group#delete_reports CodebuildReportGroup#delete_reports}.
     *
     * @stability stable
     */
    readonly deleteReports?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group#name CodebuildReportGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group#tags CodebuildReportGroup#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group#tags_all CodebuildReportGroup#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group#type CodebuildReportGroup#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * export_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group#export_config CodebuildReportGroup#export_config}
     *
     * @stability stable
     */
    readonly exportConfig: CodebuildReportGroupExportConfig;
}
/**
 * @stability stable
 */
export interface CodebuildReportGroupExportConfigS3Destination {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group#bucket CodebuildReportGroup#bucket}.
     *
     * @stability stable
     */
    readonly bucket: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group#encryption_disabled CodebuildReportGroup#encryption_disabled}.
     *
     * @stability stable
     */
    readonly encryptionDisabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group#encryption_key CodebuildReportGroup#encryption_key}.
     *
     * @stability stable
     */
    readonly encryptionKey: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group#packaging CodebuildReportGroup#packaging}.
     *
     * @stability stable
     */
    readonly packaging?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group#path CodebuildReportGroup#path}.
     *
     * @stability stable
     */
    readonly path?: string;
}
export declare function codebuildReportGroupExportConfigS3DestinationToTerraform(struct?: CodebuildReportGroupExportConfigS3DestinationOutputReference | CodebuildReportGroupExportConfigS3Destination): any;
/**
 * @stability stable
 */
export declare class CodebuildReportGroupExportConfigS3DestinationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CodebuildReportGroupExportConfigS3Destination | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CodebuildReportGroupExportConfigS3Destination | undefined);
    private _bucket?;
    /**
     * @stability stable
     */
    get bucket(): string;
    /**
     * @stability stable
     */
    set bucket(value: string);
    /**
     * @stability stable
     */
    get bucketInput(): string | undefined;
    private _encryptionDisabled?;
    /**
     * @stability stable
     */
    get encryptionDisabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set encryptionDisabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEncryptionDisabled(): void;
    /**
     * @stability stable
     */
    get encryptionDisabledInput(): boolean | cdktf.IResolvable | undefined;
    private _encryptionKey?;
    /**
     * @stability stable
     */
    get encryptionKey(): string;
    /**
     * @stability stable
     */
    set encryptionKey(value: string);
    /**
     * @stability stable
     */
    get encryptionKeyInput(): string | undefined;
    private _packaging?;
    /**
     * @stability stable
     */
    get packaging(): string;
    /**
     * @stability stable
     */
    set packaging(value: string);
    /**
     * @stability stable
     */
    resetPackaging(): void;
    /**
     * @stability stable
     */
    get packagingInput(): string | undefined;
    private _path?;
    /**
     * @stability stable
     */
    get path(): string;
    /**
     * @stability stable
     */
    set path(value: string);
    /**
     * @stability stable
     */
    resetPath(): void;
    /**
     * @stability stable
     */
    get pathInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface CodebuildReportGroupExportConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group#type CodebuildReportGroup#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * s3_destination block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group#s3_destination CodebuildReportGroup#s3_destination}
     *
     * @stability stable
     */
    readonly s3Destination?: CodebuildReportGroupExportConfigS3Destination;
}
export declare function codebuildReportGroupExportConfigToTerraform(struct?: CodebuildReportGroupExportConfigOutputReference | CodebuildReportGroupExportConfig): any;
/**
 * @stability stable
 */
export declare class CodebuildReportGroupExportConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CodebuildReportGroupExportConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CodebuildReportGroupExportConfig | undefined);
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _s3Destination;
    /**
     * @stability stable
     */
    get s3Destination(): CodebuildReportGroupExportConfigS3DestinationOutputReference;
    /**
     * @stability stable
     */
    putS3Destination(value: CodebuildReportGroupExportConfigS3Destination): void;
    /**
     * @stability stable
     */
    resetS3Destination(): void;
    /**
     * @stability stable
     */
    get s3DestinationInput(): CodebuildReportGroupExportConfigS3Destination | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group aws_codebuild_report_group}.
 *
 * @stability stable
 */
export declare class CodebuildReportGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/codebuild_report_group aws_codebuild_report_group} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CodebuildReportGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get created(): string;
    private _deleteReports?;
    /**
     * @stability stable
     */
    get deleteReports(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set deleteReports(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDeleteReports(): void;
    /**
     * @stability stable
     */
    get deleteReportsInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _exportConfig;
    /**
     * @stability stable
     */
    get exportConfig(): CodebuildReportGroupExportConfigOutputReference;
    /**
     * @stability stable
     */
    putExportConfig(value: CodebuildReportGroupExportConfig): void;
    /**
     * @stability stable
     */
    get exportConfigInput(): CodebuildReportGroupExportConfig | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
