import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS CodeStar.
 *
 * @stability stable
 */
export interface CodestarconnectionsHostConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codestarconnections_host#name CodestarconnectionsHost#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codestarconnections_host#provider_endpoint CodestarconnectionsHost#provider_endpoint}.
     *
     * @stability stable
     */
    readonly providerEndpoint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codestarconnections_host#provider_type CodestarconnectionsHost#provider_type}.
     *
     * @stability stable
     */
    readonly providerType: string;
    /**
     * vpc_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codestarconnections_host#vpc_configuration CodestarconnectionsHost#vpc_configuration}
     *
     * @stability stable
     */
    readonly vpcConfiguration?: CodestarconnectionsHostVpcConfiguration;
}
/**
 * @stability stable
 */
export interface CodestarconnectionsHostVpcConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codestarconnections_host#security_group_ids CodestarconnectionsHost#security_group_ids}.
     *
     * @stability stable
     */
    readonly securityGroupIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codestarconnections_host#subnet_ids CodestarconnectionsHost#subnet_ids}.
     *
     * @stability stable
     */
    readonly subnetIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codestarconnections_host#tls_certificate CodestarconnectionsHost#tls_certificate}.
     *
     * @stability stable
     */
    readonly tlsCertificate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/codestarconnections_host#vpc_id CodestarconnectionsHost#vpc_id}.
     *
     * @stability stable
     */
    readonly vpcId: string;
}
export declare function codestarconnectionsHostVpcConfigurationToTerraform(struct?: CodestarconnectionsHostVpcConfigurationOutputReference | CodestarconnectionsHostVpcConfiguration): any;
/**
 * @stability stable
 */
export declare class CodestarconnectionsHostVpcConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): CodestarconnectionsHostVpcConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: CodestarconnectionsHostVpcConfiguration | undefined);
    private _securityGroupIds?;
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    set securityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    get securityGroupIdsInput(): string[] | undefined;
    private _subnetIds?;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[] | undefined;
    private _tlsCertificate?;
    /**
     * @stability stable
     */
    get tlsCertificate(): string;
    /**
     * @stability stable
     */
    set tlsCertificate(value: string);
    /**
     * @stability stable
     */
    resetTlsCertificate(): void;
    /**
     * @stability stable
     */
    get tlsCertificateInput(): string | undefined;
    private _vpcId?;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    get vpcIdInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/codestarconnections_host aws_codestarconnections_host}.
 *
 * @stability stable
 */
export declare class CodestarconnectionsHost extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/codestarconnections_host aws_codestarconnections_host} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CodestarconnectionsHostConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _providerEndpoint?;
    /**
     * @stability stable
     */
    get providerEndpoint(): string;
    /**
     * @stability stable
     */
    set providerEndpoint(value: string);
    /**
     * @stability stable
     */
    get providerEndpointInput(): string | undefined;
    private _providerType?;
    /**
     * @stability stable
     */
    get providerType(): string;
    /**
     * @stability stable
     */
    set providerType(value: string);
    /**
     * @stability stable
     */
    get providerTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get status(): string;
    private _vpcConfiguration;
    /**
     * @stability stable
     */
    get vpcConfiguration(): CodestarconnectionsHostVpcConfigurationOutputReference;
    /**
     * @stability stable
     */
    putVpcConfiguration(value: CodestarconnectionsHostVpcConfiguration): void;
    /**
     * @stability stable
     */
    resetVpcConfiguration(): void;
    /**
     * @stability stable
     */
    get vpcConfigurationInput(): CodestarconnectionsHostVpcConfiguration | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
