import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Config.
 *
 * @stability stable
 */
export interface ConfigConformancePackConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_conformance_pack#delivery_s3_bucket ConfigConformancePack#delivery_s3_bucket}.
     *
     * @stability stable
     */
    readonly deliveryS3Bucket?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_conformance_pack#delivery_s3_key_prefix ConfigConformancePack#delivery_s3_key_prefix}.
     *
     * @stability stable
     */
    readonly deliveryS3KeyPrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_conformance_pack#name ConfigConformancePack#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_conformance_pack#template_body ConfigConformancePack#template_body}.
     *
     * @stability stable
     */
    readonly templateBody?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_conformance_pack#template_s3_uri ConfigConformancePack#template_s3_uri}.
     *
     * @stability stable
     */
    readonly templateS3Uri?: string;
    /**
     * input_parameter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_conformance_pack#input_parameter ConfigConformancePack#input_parameter}
     *
     * @stability stable
     */
    readonly inputParameter?: ConfigConformancePackInputParameter[];
}
/**
 * @stability stable
 */
export interface ConfigConformancePackInputParameter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_conformance_pack#parameter_name ConfigConformancePack#parameter_name}.
     *
     * @stability stable
     */
    readonly parameterName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/config_conformance_pack#parameter_value ConfigConformancePack#parameter_value}.
     *
     * @stability stable
     */
    readonly parameterValue: string;
}
export declare function configConformancePackInputParameterToTerraform(struct?: ConfigConformancePackInputParameter): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/config_conformance_pack aws_config_conformance_pack}.
 *
 * @stability stable
 */
export declare class ConfigConformancePack extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/config_conformance_pack aws_config_conformance_pack} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ConfigConformancePackConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _deliveryS3Bucket?;
    /**
     * @stability stable
     */
    get deliveryS3Bucket(): string;
    /**
     * @stability stable
     */
    set deliveryS3Bucket(value: string);
    /**
     * @stability stable
     */
    resetDeliveryS3Bucket(): void;
    /**
     * @stability stable
     */
    get deliveryS3BucketInput(): string | undefined;
    private _deliveryS3KeyPrefix?;
    /**
     * @stability stable
     */
    get deliveryS3KeyPrefix(): string;
    /**
     * @stability stable
     */
    set deliveryS3KeyPrefix(value: string);
    /**
     * @stability stable
     */
    resetDeliveryS3KeyPrefix(): void;
    /**
     * @stability stable
     */
    get deliveryS3KeyPrefixInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _templateBody?;
    /**
     * @stability stable
     */
    get templateBody(): string;
    /**
     * @stability stable
     */
    set templateBody(value: string);
    /**
     * @stability stable
     */
    resetTemplateBody(): void;
    /**
     * @stability stable
     */
    get templateBodyInput(): string | undefined;
    private _templateS3Uri?;
    /**
     * @stability stable
     */
    get templateS3Uri(): string;
    /**
     * @stability stable
     */
    set templateS3Uri(value: string);
    /**
     * @stability stable
     */
    resetTemplateS3Uri(): void;
    /**
     * @stability stable
     */
    get templateS3UriInput(): string | undefined;
    private _inputParameter?;
    /**
     * @stability stable
     */
    get inputParameter(): ConfigConformancePackInputParameter[];
    /**
     * @stability stable
     */
    set inputParameter(value: ConfigConformancePackInputParameter[]);
    /**
     * @stability stable
     */
    resetInputParameter(): void;
    /**
     * @stability stable
     */
    get inputParameterInput(): ConfigConformancePackInputParameter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
