import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Connect.
 *
 * @stability stable
 */
export interface DataAwsConnectBotAssociationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_bot_association#instance_id DataAwsConnectBotAssociation#instance_id}.
     *
     * @stability stable
     */
    readonly instanceId: string;
    /**
     * lex_bot block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_bot_association#lex_bot DataAwsConnectBotAssociation#lex_bot}
     *
     * @stability stable
     */
    readonly lexBot: DataAwsConnectBotAssociationLexBot;
}
/**
 * @stability stable
 */
export interface DataAwsConnectBotAssociationLexBot {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_bot_association#lex_region DataAwsConnectBotAssociation#lex_region}.
     *
     * @stability stable
     */
    readonly lexRegion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_bot_association#name DataAwsConnectBotAssociation#name}.
     *
     * @stability stable
     */
    readonly name: string;
}
export declare function dataAwsConnectBotAssociationLexBotToTerraform(struct?: DataAwsConnectBotAssociationLexBotOutputReference | DataAwsConnectBotAssociationLexBot): any;
/**
 * @stability stable
 */
export declare class DataAwsConnectBotAssociationLexBotOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DataAwsConnectBotAssociationLexBot | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DataAwsConnectBotAssociationLexBot | undefined);
    private _lexRegion?;
    /**
     * @stability stable
     */
    get lexRegion(): string;
    /**
     * @stability stable
     */
    set lexRegion(value: string);
    /**
     * @stability stable
     */
    resetLexRegion(): void;
    /**
     * @stability stable
     */
    get lexRegionInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/connect_bot_association aws_connect_bot_association}.
 *
 * @stability stable
 */
export declare class DataAwsConnectBotAssociation extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/connect_bot_association aws_connect_bot_association} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsConnectBotAssociationConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceId?;
    /**
     * @stability stable
     */
    get instanceId(): string;
    /**
     * @stability stable
     */
    set instanceId(value: string);
    /**
     * @stability stable
     */
    get instanceIdInput(): string | undefined;
    private _lexBot;
    /**
     * @stability stable
     */
    get lexBot(): DataAwsConnectBotAssociationLexBotOutputReference;
    /**
     * @stability stable
     */
    putLexBot(value: DataAwsConnectBotAssociationLexBot): void;
    /**
     * @stability stable
     */
    get lexBotInput(): DataAwsConnectBotAssociationLexBot | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
