import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Connect.
 *
 * @stability stable
 */
export interface DataAwsConnectInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_instance#instance_alias DataAwsConnectInstance#instance_alias}.
     *
     * @stability stable
     */
    readonly instanceAlias?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/connect_instance#instance_id DataAwsConnectInstance#instance_id}.
     *
     * @stability stable
     */
    readonly instanceId?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/connect_instance aws_connect_instance}.
 *
 * @stability stable
 */
export declare class DataAwsConnectInstance extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/connect_instance aws_connect_instance} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsConnectInstanceConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get autoResolveBestVoicesEnabled(): any;
    /**
     * @stability stable
     */
    get contactFlowLogsEnabled(): any;
    /**
     * @stability stable
     */
    get contactLensEnabled(): any;
    /**
     * @stability stable
     */
    get createdTime(): string;
    /**
     * @stability stable
     */
    get earlyMediaEnabled(): any;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get identityManagementType(): string;
    /**
     * @stability stable
     */
    get inboundCallsEnabled(): any;
    private _instanceAlias?;
    /**
     * @stability stable
     */
    get instanceAlias(): string;
    /**
     * @stability stable
     */
    set instanceAlias(value: string);
    /**
     * @stability stable
     */
    resetInstanceAlias(): void;
    /**
     * @stability stable
     */
    get instanceAliasInput(): string | undefined;
    private _instanceId?;
    /**
     * @stability stable
     */
    get instanceId(): string;
    /**
     * @stability stable
     */
    set instanceId(value: string);
    /**
     * @stability stable
     */
    resetInstanceId(): void;
    /**
     * @stability stable
     */
    get instanceIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get outboundCallsEnabled(): any;
    /**
     * @stability stable
     */
    get serviceRole(): string;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
