import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsCloudcontrolapiResourceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudcontrolapi_resource#identifier DataAwsCloudcontrolapiResource#identifier}.
     *
     * @stability stable
     */
    readonly identifier: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudcontrolapi_resource#role_arn DataAwsCloudcontrolapiResource#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudcontrolapi_resource#type_name DataAwsCloudcontrolapiResource#type_name}.
     *
     * @stability stable
     */
    readonly typeName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/cloudcontrolapi_resource#type_version_id DataAwsCloudcontrolapiResource#type_version_id}.
     *
     * @stability stable
     */
    readonly typeVersionId?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/cloudcontrolapi_resource aws_cloudcontrolapi_resource}.
 *
 * @stability stable
 */
export declare class DataAwsCloudcontrolapiResource extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/cloudcontrolapi_resource aws_cloudcontrolapi_resource} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsCloudcontrolapiResourceConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _identifier?;
    /**
     * @stability stable
     */
    get identifier(): string;
    /**
     * @stability stable
     */
    set identifier(value: string);
    /**
     * @stability stable
     */
    get identifierInput(): string | undefined;
    /**
     * @stability stable
     */
    get properties(): string;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    resetRoleArn(): void;
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    private _typeName?;
    /**
     * @stability stable
     */
    get typeName(): string;
    /**
     * @stability stable
     */
    set typeName(value: string);
    /**
     * @stability stable
     */
    get typeNameInput(): string | undefined;
    private _typeVersionId?;
    /**
     * @stability stable
     */
    get typeVersionId(): string;
    /**
     * @stability stable
     */
    set typeVersionId(value: string);
    /**
     * @stability stable
     */
    resetTypeVersionId(): void;
    /**
     * @stability stable
     */
    get typeVersionIdInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
