import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Device Farm.
 *
 * @stability stable
 */
export interface DevicefarmNetworkProfileConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/devicefarm_network_profile#description DevicefarmNetworkProfile#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/devicefarm_network_profile#downlink_bandwidth_bits DevicefarmNetworkProfile#downlink_bandwidth_bits}.
     *
     * @stability stable
     */
    readonly downlinkBandwidthBits?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/devicefarm_network_profile#downlink_delay_ms DevicefarmNetworkProfile#downlink_delay_ms}.
     *
     * @stability stable
     */
    readonly downlinkDelayMs?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/devicefarm_network_profile#downlink_jitter_ms DevicefarmNetworkProfile#downlink_jitter_ms}.
     *
     * @stability stable
     */
    readonly downlinkJitterMs?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/devicefarm_network_profile#downlink_loss_percent DevicefarmNetworkProfile#downlink_loss_percent}.
     *
     * @stability stable
     */
    readonly downlinkLossPercent?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/devicefarm_network_profile#name DevicefarmNetworkProfile#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/devicefarm_network_profile#project_arn DevicefarmNetworkProfile#project_arn}.
     *
     * @stability stable
     */
    readonly projectArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/devicefarm_network_profile#tags DevicefarmNetworkProfile#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/devicefarm_network_profile#tags_all DevicefarmNetworkProfile#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/devicefarm_network_profile#type DevicefarmNetworkProfile#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/devicefarm_network_profile#uplink_bandwidth_bits DevicefarmNetworkProfile#uplink_bandwidth_bits}.
     *
     * @stability stable
     */
    readonly uplinkBandwidthBits?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/devicefarm_network_profile#uplink_delay_ms DevicefarmNetworkProfile#uplink_delay_ms}.
     *
     * @stability stable
     */
    readonly uplinkDelayMs?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/devicefarm_network_profile#uplink_jitter_ms DevicefarmNetworkProfile#uplink_jitter_ms}.
     *
     * @stability stable
     */
    readonly uplinkJitterMs?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/devicefarm_network_profile#uplink_loss_percent DevicefarmNetworkProfile#uplink_loss_percent}.
     *
     * @stability stable
     */
    readonly uplinkLossPercent?: number;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/devicefarm_network_profile aws_devicefarm_network_profile}.
 *
 * @stability stable
 */
export declare class DevicefarmNetworkProfile extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/devicefarm_network_profile aws_devicefarm_network_profile} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DevicefarmNetworkProfileConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _downlinkBandwidthBits?;
    /**
     * @stability stable
     */
    get downlinkBandwidthBits(): number;
    /**
     * @stability stable
     */
    set downlinkBandwidthBits(value: number);
    /**
     * @stability stable
     */
    resetDownlinkBandwidthBits(): void;
    /**
     * @stability stable
     */
    get downlinkBandwidthBitsInput(): number | undefined;
    private _downlinkDelayMs?;
    /**
     * @stability stable
     */
    get downlinkDelayMs(): number;
    /**
     * @stability stable
     */
    set downlinkDelayMs(value: number);
    /**
     * @stability stable
     */
    resetDownlinkDelayMs(): void;
    /**
     * @stability stable
     */
    get downlinkDelayMsInput(): number | undefined;
    private _downlinkJitterMs?;
    /**
     * @stability stable
     */
    get downlinkJitterMs(): number;
    /**
     * @stability stable
     */
    set downlinkJitterMs(value: number);
    /**
     * @stability stable
     */
    resetDownlinkJitterMs(): void;
    /**
     * @stability stable
     */
    get downlinkJitterMsInput(): number | undefined;
    private _downlinkLossPercent?;
    /**
     * @stability stable
     */
    get downlinkLossPercent(): number;
    /**
     * @stability stable
     */
    set downlinkLossPercent(value: number);
    /**
     * @stability stable
     */
    resetDownlinkLossPercent(): void;
    /**
     * @stability stable
     */
    get downlinkLossPercentInput(): number | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _projectArn?;
    /**
     * @stability stable
     */
    get projectArn(): string;
    /**
     * @stability stable
     */
    set projectArn(value: string);
    /**
     * @stability stable
     */
    get projectArnInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _uplinkBandwidthBits?;
    /**
     * @stability stable
     */
    get uplinkBandwidthBits(): number;
    /**
     * @stability stable
     */
    set uplinkBandwidthBits(value: number);
    /**
     * @stability stable
     */
    resetUplinkBandwidthBits(): void;
    /**
     * @stability stable
     */
    get uplinkBandwidthBitsInput(): number | undefined;
    private _uplinkDelayMs?;
    /**
     * @stability stable
     */
    get uplinkDelayMs(): number;
    /**
     * @stability stable
     */
    set uplinkDelayMs(value: number);
    /**
     * @stability stable
     */
    resetUplinkDelayMs(): void;
    /**
     * @stability stable
     */
    get uplinkDelayMsInput(): number | undefined;
    private _uplinkJitterMs?;
    /**
     * @stability stable
     */
    get uplinkJitterMs(): number;
    /**
     * @stability stable
     */
    set uplinkJitterMs(value: number);
    /**
     * @stability stable
     */
    resetUplinkJitterMs(): void;
    /**
     * @stability stable
     */
    get uplinkJitterMsInput(): number | undefined;
    private _uplinkLossPercent?;
    /**
     * @stability stable
     */
    get uplinkLossPercent(): number;
    /**
     * @stability stable
     */
    set uplinkLossPercent(value: number);
    /**
     * @stability stable
     */
    resetUplinkLossPercent(): void;
    /**
     * @stability stable
     */
    get uplinkLossPercentInput(): number | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
