import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS DynamoDB.
 *
 * @stability stable
 */
export interface DynamodbTableItemConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table_item#hash_key DynamodbTableItem#hash_key}.
     *
     * @stability stable
     */
    readonly hashKey: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table_item#item DynamodbTableItem#item}.
     *
     * @stability stable
     */
    readonly item: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table_item#range_key DynamodbTableItem#range_key}.
     *
     * @stability stable
     */
    readonly rangeKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table_item#table_name DynamodbTableItem#table_name}.
     *
     * @stability stable
     */
    readonly tableName: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table_item aws_dynamodb_table_item}.
 *
 * @stability stable
 */
export declare class DynamodbTableItem extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/dynamodb_table_item aws_dynamodb_table_item} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DynamodbTableItemConfig);
    private _hashKey?;
    /**
     * @stability stable
     */
    get hashKey(): string;
    /**
     * @stability stable
     */
    set hashKey(value: string);
    /**
     * @stability stable
     */
    get hashKeyInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _item?;
    /**
     * @stability stable
     */
    get item(): string;
    /**
     * @stability stable
     */
    set item(value: string);
    /**
     * @stability stable
     */
    get itemInput(): string | undefined;
    private _rangeKey?;
    /**
     * @stability stable
     */
    get rangeKey(): string;
    /**
     * @stability stable
     */
    set rangeKey(value: string);
    /**
     * @stability stable
     */
    resetRangeKey(): void;
    /**
     * @stability stable
     */
    get rangeKeyInput(): string | undefined;
    private _tableName?;
    /**
     * @stability stable
     */
    get tableName(): string;
    /**
     * @stability stable
     */
    set tableName(value: string);
    /**
     * @stability stable
     */
    get tableNameInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
