import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS EC2.
 *
 * @stability stable
 */
export interface DataAwsAmiConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami#executable_users DataAwsAmi#executable_users}.
     *
     * @stability stable
     */
    readonly executableUsers?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami#most_recent DataAwsAmi#most_recent}.
     *
     * @stability stable
     */
    readonly mostRecent?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami#name_regex DataAwsAmi#name_regex}.
     *
     * @stability stable
     */
    readonly nameRegex?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami#owners DataAwsAmi#owners}.
     *
     * @stability stable
     */
    readonly owners: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami#tags DataAwsAmi#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami#filter DataAwsAmi#filter}
     *
     * @stability stable
     */
    readonly filter?: DataAwsAmiFilter[];
}
/**
 * @stability stable
 */
export declare class DataAwsAmiBlockDeviceMappings extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get deviceName(): string;
    /**
     * @stability stable
     */
    get ebs(): any;
    /**
     * @stability stable
     */
    get noDevice(): string;
    /**
     * @stability stable
     */
    get virtualName(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsAmiProductCodes extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get productCodeId(): string;
    /**
     * @stability stable
     */
    get productCodeType(): string;
}
/**
 * @stability stable
 */
export interface DataAwsAmiFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami#name DataAwsAmi#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ami#values DataAwsAmi#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
export declare function dataAwsAmiFilterToTerraform(struct?: DataAwsAmiFilter): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ami aws_ami}.
 *
 * @stability stable
 */
export declare class DataAwsAmi extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ami aws_ami} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsAmiConfig);
    /**
     * @stability stable
     */
    get architecture(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    blockDeviceMappings(index: string): DataAwsAmiBlockDeviceMappings;
    /**
     * @stability stable
     */
    get creationDate(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get enaSupport(): any;
    private _executableUsers?;
    /**
     * @stability stable
     */
    get executableUsers(): string[];
    /**
     * @stability stable
     */
    set executableUsers(value: string[]);
    /**
     * @stability stable
     */
    resetExecutableUsers(): void;
    /**
     * @stability stable
     */
    get executableUsersInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get hypervisor(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get imageId(): string;
    /**
     * @stability stable
     */
    get imageLocation(): string;
    /**
     * @stability stable
     */
    get imageOwnerAlias(): string;
    /**
     * @stability stable
     */
    get imageType(): string;
    /**
     * @stability stable
     */
    get kernelId(): string;
    private _mostRecent?;
    /**
     * @stability stable
     */
    get mostRecent(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set mostRecent(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetMostRecent(): void;
    /**
     * @stability stable
     */
    get mostRecentInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get name(): string;
    private _nameRegex?;
    /**
     * @stability stable
     */
    get nameRegex(): string;
    /**
     * @stability stable
     */
    set nameRegex(value: string);
    /**
     * @stability stable
     */
    resetNameRegex(): void;
    /**
     * @stability stable
     */
    get nameRegexInput(): string | undefined;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _owners?;
    /**
     * @stability stable
     */
    get owners(): string[];
    /**
     * @stability stable
     */
    set owners(value: string[]);
    /**
     * @stability stable
     */
    get ownersInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get platform(): string;
    /**
     * @stability stable
     */
    get platformDetails(): string;
    /**
     * @stability stable
     */
    productCodes(index: string): DataAwsAmiProductCodes;
    /**
     * @stability stable
     */
    get public(): any;
    /**
     * @stability stable
     */
    get ramdiskId(): string;
    /**
     * @stability stable
     */
    get rootDeviceName(): string;
    /**
     * @stability stable
     */
    get rootDeviceType(): string;
    /**
     * @stability stable
     */
    get rootSnapshotId(): string;
    /**
     * @stability stable
     */
    get sriovNetSupport(): string;
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    stateReason(key: string): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get usageOperation(): string;
    /**
     * @stability stable
     */
    get virtualizationType(): string;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsAmiFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsAmiFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsAmiFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
