import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS EC2.
 *
 * @stability stable
 */
export interface DataAwsInstancesConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/instances#instance_state_names DataAwsInstances#instance_state_names}.
     *
     * @stability stable
     */
    readonly instanceStateNames?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/instances#instance_tags DataAwsInstances#instance_tags}.
     *
     * @stability stable
     */
    readonly instanceTags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/instances#filter DataAwsInstances#filter}
     *
     * @stability stable
     */
    readonly filter?: DataAwsInstancesFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsInstancesFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/instances#name DataAwsInstances#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/instances#values DataAwsInstances#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
export declare function dataAwsInstancesFilterToTerraform(struct?: DataAwsInstancesFilter): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/instances aws_instances}.
 *
 * @stability stable
 */
export declare class DataAwsInstances extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/instances aws_instances} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsInstancesConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ids(): string[];
    private _instanceStateNames?;
    /**
     * @stability stable
     */
    get instanceStateNames(): string[];
    /**
     * @stability stable
     */
    set instanceStateNames(value: string[]);
    /**
     * @stability stable
     */
    resetInstanceStateNames(): void;
    /**
     * @stability stable
     */
    get instanceStateNamesInput(): string[] | undefined;
    private _instanceTags?;
    /**
     * @stability stable
     */
    get instanceTags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set instanceTags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetInstanceTags(): void;
    /**
     * @stability stable
     */
    get instanceTagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get privateIps(): string[];
    /**
     * @stability stable
     */
    get publicIps(): string[];
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsInstancesFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsInstancesFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsInstancesFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
