import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS EC2.
 *
 * @stability stable
 */
export interface EbsSnapshotImportConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#description EbsSnapshotImport#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#encrypted EbsSnapshotImport#encrypted}.
     *
     * @stability stable
     */
    readonly encrypted?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#kms_key_id EbsSnapshotImport#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#permanent_restore EbsSnapshotImport#permanent_restore}.
     *
     * @stability stable
     */
    readonly permanentRestore?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#role_name EbsSnapshotImport#role_name}.
     *
     * @stability stable
     */
    readonly roleName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#storage_tier EbsSnapshotImport#storage_tier}.
     *
     * @stability stable
     */
    readonly storageTier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#tags EbsSnapshotImport#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#tags_all EbsSnapshotImport#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#temporary_restore_days EbsSnapshotImport#temporary_restore_days}.
     *
     * @stability stable
     */
    readonly temporaryRestoreDays?: number;
    /**
     * client_data block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#client_data EbsSnapshotImport#client_data}
     *
     * @stability stable
     */
    readonly clientData?: EbsSnapshotImportClientData;
    /**
     * disk_container block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#disk_container EbsSnapshotImport#disk_container}
     *
     * @stability stable
     */
    readonly diskContainer: EbsSnapshotImportDiskContainer;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#timeouts EbsSnapshotImport#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: EbsSnapshotImportTimeouts;
}
/**
 * @stability stable
 */
export interface EbsSnapshotImportClientData {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#comment EbsSnapshotImport#comment}.
     *
     * @stability stable
     */
    readonly comment?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#upload_end EbsSnapshotImport#upload_end}.
     *
     * @stability stable
     */
    readonly uploadEnd?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#upload_size EbsSnapshotImport#upload_size}.
     *
     * @stability stable
     */
    readonly uploadSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#upload_start EbsSnapshotImport#upload_start}.
     *
     * @stability stable
     */
    readonly uploadStart?: string;
}
export declare function ebsSnapshotImportClientDataToTerraform(struct?: EbsSnapshotImportClientDataOutputReference | EbsSnapshotImportClientData): any;
/**
 * @stability stable
 */
export declare class EbsSnapshotImportClientDataOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): EbsSnapshotImportClientData | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: EbsSnapshotImportClientData | undefined);
    private _comment?;
    /**
     * @stability stable
     */
    get comment(): string;
    /**
     * @stability stable
     */
    set comment(value: string);
    /**
     * @stability stable
     */
    resetComment(): void;
    /**
     * @stability stable
     */
    get commentInput(): string | undefined;
    private _uploadEnd?;
    /**
     * @stability stable
     */
    get uploadEnd(): string;
    /**
     * @stability stable
     */
    set uploadEnd(value: string);
    /**
     * @stability stable
     */
    resetUploadEnd(): void;
    /**
     * @stability stable
     */
    get uploadEndInput(): string | undefined;
    private _uploadSize?;
    /**
     * @stability stable
     */
    get uploadSize(): number;
    /**
     * @stability stable
     */
    set uploadSize(value: number);
    /**
     * @stability stable
     */
    resetUploadSize(): void;
    /**
     * @stability stable
     */
    get uploadSizeInput(): number | undefined;
    private _uploadStart?;
    /**
     * @stability stable
     */
    get uploadStart(): string;
    /**
     * @stability stable
     */
    set uploadStart(value: string);
    /**
     * @stability stable
     */
    resetUploadStart(): void;
    /**
     * @stability stable
     */
    get uploadStartInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface EbsSnapshotImportDiskContainerUserBucket {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#s3_bucket EbsSnapshotImport#s3_bucket}.
     *
     * @stability stable
     */
    readonly s3Bucket: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#s3_key EbsSnapshotImport#s3_key}.
     *
     * @stability stable
     */
    readonly s3Key: string;
}
export declare function ebsSnapshotImportDiskContainerUserBucketToTerraform(struct?: EbsSnapshotImportDiskContainerUserBucketOutputReference | EbsSnapshotImportDiskContainerUserBucket): any;
/**
 * @stability stable
 */
export declare class EbsSnapshotImportDiskContainerUserBucketOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): EbsSnapshotImportDiskContainerUserBucket | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: EbsSnapshotImportDiskContainerUserBucket | undefined);
    private _s3Bucket?;
    /**
     * @stability stable
     */
    get s3Bucket(): string;
    /**
     * @stability stable
     */
    set s3Bucket(value: string);
    /**
     * @stability stable
     */
    get s3BucketInput(): string | undefined;
    private _s3Key?;
    /**
     * @stability stable
     */
    get s3Key(): string;
    /**
     * @stability stable
     */
    set s3Key(value: string);
    /**
     * @stability stable
     */
    get s3KeyInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface EbsSnapshotImportDiskContainer {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#description EbsSnapshotImport#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#format EbsSnapshotImport#format}.
     *
     * @stability stable
     */
    readonly format: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#url EbsSnapshotImport#url}.
     *
     * @stability stable
     */
    readonly url?: string;
    /**
     * user_bucket block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#user_bucket EbsSnapshotImport#user_bucket}
     *
     * @stability stable
     */
    readonly userBucket?: EbsSnapshotImportDiskContainerUserBucket;
}
export declare function ebsSnapshotImportDiskContainerToTerraform(struct?: EbsSnapshotImportDiskContainerOutputReference | EbsSnapshotImportDiskContainer): any;
/**
 * @stability stable
 */
export declare class EbsSnapshotImportDiskContainerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): EbsSnapshotImportDiskContainer | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: EbsSnapshotImportDiskContainer | undefined);
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _format?;
    /**
     * @stability stable
     */
    get format(): string;
    /**
     * @stability stable
     */
    set format(value: string);
    /**
     * @stability stable
     */
    get formatInput(): string | undefined;
    private _url?;
    /**
     * @stability stable
     */
    get url(): string;
    /**
     * @stability stable
     */
    set url(value: string);
    /**
     * @stability stable
     */
    resetUrl(): void;
    /**
     * @stability stable
     */
    get urlInput(): string | undefined;
    private _userBucket;
    /**
     * @stability stable
     */
    get userBucket(): EbsSnapshotImportDiskContainerUserBucketOutputReference;
    /**
     * @stability stable
     */
    putUserBucket(value: EbsSnapshotImportDiskContainerUserBucket): void;
    /**
     * @stability stable
     */
    resetUserBucket(): void;
    /**
     * @stability stable
     */
    get userBucketInput(): EbsSnapshotImportDiskContainerUserBucket | undefined;
}
/**
 * @stability stable
 */
export interface EbsSnapshotImportTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#create EbsSnapshotImport#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import#delete EbsSnapshotImport#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
}
export declare function ebsSnapshotImportTimeoutsToTerraform(struct?: EbsSnapshotImportTimeoutsOutputReference | EbsSnapshotImportTimeouts): any;
/**
 * @stability stable
 */
export declare class EbsSnapshotImportTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): EbsSnapshotImportTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: EbsSnapshotImportTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import aws_ebs_snapshot_import}.
 *
 * @stability stable
 */
export declare class EbsSnapshotImport extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ebs_snapshot_import aws_ebs_snapshot_import} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EbsSnapshotImportConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get dataEncryptionKeyId(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _encrypted?;
    /**
     * @stability stable
     */
    get encrypted(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set encrypted(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEncrypted(): void;
    /**
     * @stability stable
     */
    get encryptedInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get outpostArn(): string;
    /**
     * @stability stable
     */
    get ownerAlias(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _permanentRestore?;
    /**
     * @stability stable
     */
    get permanentRestore(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set permanentRestore(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetPermanentRestore(): void;
    /**
     * @stability stable
     */
    get permanentRestoreInput(): boolean | cdktf.IResolvable | undefined;
    private _roleName?;
    /**
     * @stability stable
     */
    get roleName(): string;
    /**
     * @stability stable
     */
    set roleName(value: string);
    /**
     * @stability stable
     */
    resetRoleName(): void;
    /**
     * @stability stable
     */
    get roleNameInput(): string | undefined;
    private _storageTier?;
    /**
     * @stability stable
     */
    get storageTier(): string;
    /**
     * @stability stable
     */
    set storageTier(value: string);
    /**
     * @stability stable
     */
    resetStorageTier(): void;
    /**
     * @stability stable
     */
    get storageTierInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _temporaryRestoreDays?;
    /**
     * @stability stable
     */
    get temporaryRestoreDays(): number;
    /**
     * @stability stable
     */
    set temporaryRestoreDays(value: number);
    /**
     * @stability stable
     */
    resetTemporaryRestoreDays(): void;
    /**
     * @stability stable
     */
    get temporaryRestoreDaysInput(): number | undefined;
    /**
     * @stability stable
     */
    get volumeId(): string;
    /**
     * @stability stable
     */
    get volumeSize(): number;
    private _clientData;
    /**
     * @stability stable
     */
    get clientData(): EbsSnapshotImportClientDataOutputReference;
    /**
     * @stability stable
     */
    putClientData(value: EbsSnapshotImportClientData): void;
    /**
     * @stability stable
     */
    resetClientData(): void;
    /**
     * @stability stable
     */
    get clientDataInput(): EbsSnapshotImportClientData | undefined;
    private _diskContainer;
    /**
     * @stability stable
     */
    get diskContainer(): EbsSnapshotImportDiskContainerOutputReference;
    /**
     * @stability stable
     */
    putDiskContainer(value: EbsSnapshotImportDiskContainer): void;
    /**
     * @stability stable
     */
    get diskContainerInput(): EbsSnapshotImportDiskContainer | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): EbsSnapshotImportTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: EbsSnapshotImportTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): EbsSnapshotImportTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
