import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS EC2.
 *
 * @stability stable
 */
export interface Ec2FleetConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#excess_capacity_termination_policy Ec2Fleet#excess_capacity_termination_policy}.
     *
     * @stability stable
     */
    readonly excessCapacityTerminationPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#replace_unhealthy_instances Ec2Fleet#replace_unhealthy_instances}.
     *
     * @stability stable
     */
    readonly replaceUnhealthyInstances?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#tags Ec2Fleet#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#tags_all Ec2Fleet#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#terminate_instances Ec2Fleet#terminate_instances}.
     *
     * @stability stable
     */
    readonly terminateInstances?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#terminate_instances_with_expiration Ec2Fleet#terminate_instances_with_expiration}.
     *
     * @stability stable
     */
    readonly terminateInstancesWithExpiration?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#type Ec2Fleet#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * launch_template_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#launch_template_config Ec2Fleet#launch_template_config}
     *
     * @stability stable
     */
    readonly launchTemplateConfig: Ec2FleetLaunchTemplateConfig;
    /**
     * on_demand_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#on_demand_options Ec2Fleet#on_demand_options}
     *
     * @stability stable
     */
    readonly onDemandOptions?: Ec2FleetOnDemandOptions;
    /**
     * spot_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#spot_options Ec2Fleet#spot_options}
     *
     * @stability stable
     */
    readonly spotOptions?: Ec2FleetSpotOptions;
    /**
     * target_capacity_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#target_capacity_specification Ec2Fleet#target_capacity_specification}
     *
     * @stability stable
     */
    readonly targetCapacitySpecification: Ec2FleetTargetCapacitySpecification;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#timeouts Ec2Fleet#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: Ec2FleetTimeouts;
}
/**
 * @stability stable
 */
export interface Ec2FleetLaunchTemplateConfigLaunchTemplateSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#launch_template_id Ec2Fleet#launch_template_id}.
     *
     * @stability stable
     */
    readonly launchTemplateId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#launch_template_name Ec2Fleet#launch_template_name}.
     *
     * @stability stable
     */
    readonly launchTemplateName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#version Ec2Fleet#version}.
     *
     * @stability stable
     */
    readonly version: string;
}
export declare function ec2FleetLaunchTemplateConfigLaunchTemplateSpecificationToTerraform(struct?: Ec2FleetLaunchTemplateConfigLaunchTemplateSpecificationOutputReference | Ec2FleetLaunchTemplateConfigLaunchTemplateSpecification): any;
/**
 * @stability stable
 */
export declare class Ec2FleetLaunchTemplateConfigLaunchTemplateSpecificationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Ec2FleetLaunchTemplateConfigLaunchTemplateSpecification | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Ec2FleetLaunchTemplateConfigLaunchTemplateSpecification | undefined);
    private _launchTemplateId?;
    /**
     * @stability stable
     */
    get launchTemplateId(): string;
    /**
     * @stability stable
     */
    set launchTemplateId(value: string);
    /**
     * @stability stable
     */
    resetLaunchTemplateId(): void;
    /**
     * @stability stable
     */
    get launchTemplateIdInput(): string | undefined;
    private _launchTemplateName?;
    /**
     * @stability stable
     */
    get launchTemplateName(): string;
    /**
     * @stability stable
     */
    set launchTemplateName(value: string);
    /**
     * @stability stable
     */
    resetLaunchTemplateName(): void;
    /**
     * @stability stable
     */
    get launchTemplateNameInput(): string | undefined;
    private _version?;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    set version(value: string);
    /**
     * @stability stable
     */
    get versionInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface Ec2FleetLaunchTemplateConfigOverride {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#availability_zone Ec2Fleet#availability_zone}.
     *
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#instance_type Ec2Fleet#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#max_price Ec2Fleet#max_price}.
     *
     * @stability stable
     */
    readonly maxPrice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#priority Ec2Fleet#priority}.
     *
     * @stability stable
     */
    readonly priority?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#subnet_id Ec2Fleet#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#weighted_capacity Ec2Fleet#weighted_capacity}.
     *
     * @stability stable
     */
    readonly weightedCapacity?: number;
}
export declare function ec2FleetLaunchTemplateConfigOverrideToTerraform(struct?: Ec2FleetLaunchTemplateConfigOverride): any;
/**
 * @stability stable
 */
export interface Ec2FleetLaunchTemplateConfig {
    /**
     * launch_template_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#launch_template_specification Ec2Fleet#launch_template_specification}
     *
     * @stability stable
     */
    readonly launchTemplateSpecification: Ec2FleetLaunchTemplateConfigLaunchTemplateSpecification;
    /**
     * override block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#override Ec2Fleet#override}
     *
     * @stability stable
     */
    readonly override?: Ec2FleetLaunchTemplateConfigOverride[];
}
export declare function ec2FleetLaunchTemplateConfigToTerraform(struct?: Ec2FleetLaunchTemplateConfigOutputReference | Ec2FleetLaunchTemplateConfig): any;
/**
 * @stability stable
 */
export declare class Ec2FleetLaunchTemplateConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Ec2FleetLaunchTemplateConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Ec2FleetLaunchTemplateConfig | undefined);
    private _launchTemplateSpecification;
    /**
     * @stability stable
     */
    get launchTemplateSpecification(): Ec2FleetLaunchTemplateConfigLaunchTemplateSpecificationOutputReference;
    /**
     * @stability stable
     */
    putLaunchTemplateSpecification(value: Ec2FleetLaunchTemplateConfigLaunchTemplateSpecification): void;
    /**
     * @stability stable
     */
    get launchTemplateSpecificationInput(): Ec2FleetLaunchTemplateConfigLaunchTemplateSpecification | undefined;
    private _override?;
    /**
     * @stability stable
     */
    get override(): Ec2FleetLaunchTemplateConfigOverride[];
    /**
     * @stability stable
     */
    set override(value: Ec2FleetLaunchTemplateConfigOverride[]);
    /**
     * @stability stable
     */
    resetOverride(): void;
    /**
     * @stability stable
     */
    get overrideInput(): Ec2FleetLaunchTemplateConfigOverride[] | undefined;
}
/**
 * @stability stable
 */
export interface Ec2FleetOnDemandOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#allocation_strategy Ec2Fleet#allocation_strategy}.
     *
     * @stability stable
     */
    readonly allocationStrategy?: string;
}
export declare function ec2FleetOnDemandOptionsToTerraform(struct?: Ec2FleetOnDemandOptionsOutputReference | Ec2FleetOnDemandOptions): any;
/**
 * @stability stable
 */
export declare class Ec2FleetOnDemandOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Ec2FleetOnDemandOptions | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Ec2FleetOnDemandOptions | undefined);
    private _allocationStrategy?;
    /**
     * @stability stable
     */
    get allocationStrategy(): string;
    /**
     * @stability stable
     */
    set allocationStrategy(value: string);
    /**
     * @stability stable
     */
    resetAllocationStrategy(): void;
    /**
     * @stability stable
     */
    get allocationStrategyInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface Ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalance {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#replacement_strategy Ec2Fleet#replacement_strategy}.
     *
     * @stability stable
     */
    readonly replacementStrategy?: string;
}
export declare function ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalanceToTerraform(struct?: Ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalanceOutputReference | Ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalance): any;
/**
 * @stability stable
 */
export declare class Ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalanceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalance | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalance | undefined);
    private _replacementStrategy?;
    /**
     * @stability stable
     */
    get replacementStrategy(): string;
    /**
     * @stability stable
     */
    set replacementStrategy(value: string);
    /**
     * @stability stable
     */
    resetReplacementStrategy(): void;
    /**
     * @stability stable
     */
    get replacementStrategyInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface Ec2FleetSpotOptionsMaintenanceStrategies {
    /**
     * capacity_rebalance block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#capacity_rebalance Ec2Fleet#capacity_rebalance}
     *
     * @stability stable
     */
    readonly capacityRebalance?: Ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalance;
}
export declare function ec2FleetSpotOptionsMaintenanceStrategiesToTerraform(struct?: Ec2FleetSpotOptionsMaintenanceStrategiesOutputReference | Ec2FleetSpotOptionsMaintenanceStrategies): any;
/**
 * @stability stable
 */
export declare class Ec2FleetSpotOptionsMaintenanceStrategiesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Ec2FleetSpotOptionsMaintenanceStrategies | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Ec2FleetSpotOptionsMaintenanceStrategies | undefined);
    private _capacityRebalance;
    /**
     * @stability stable
     */
    get capacityRebalance(): Ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalanceOutputReference;
    /**
     * @stability stable
     */
    putCapacityRebalance(value: Ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalance): void;
    /**
     * @stability stable
     */
    resetCapacityRebalance(): void;
    /**
     * @stability stable
     */
    get capacityRebalanceInput(): Ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalance | undefined;
}
/**
 * @stability stable
 */
export interface Ec2FleetSpotOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#allocation_strategy Ec2Fleet#allocation_strategy}.
     *
     * @stability stable
     */
    readonly allocationStrategy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#instance_interruption_behavior Ec2Fleet#instance_interruption_behavior}.
     *
     * @stability stable
     */
    readonly instanceInterruptionBehavior?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#instance_pools_to_use_count Ec2Fleet#instance_pools_to_use_count}.
     *
     * @stability stable
     */
    readonly instancePoolsToUseCount?: number;
    /**
     * maintenance_strategies block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#maintenance_strategies Ec2Fleet#maintenance_strategies}
     *
     * @stability stable
     */
    readonly maintenanceStrategies?: Ec2FleetSpotOptionsMaintenanceStrategies;
}
export declare function ec2FleetSpotOptionsToTerraform(struct?: Ec2FleetSpotOptionsOutputReference | Ec2FleetSpotOptions): any;
/**
 * @stability stable
 */
export declare class Ec2FleetSpotOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Ec2FleetSpotOptions | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Ec2FleetSpotOptions | undefined);
    private _allocationStrategy?;
    /**
     * @stability stable
     */
    get allocationStrategy(): string;
    /**
     * @stability stable
     */
    set allocationStrategy(value: string);
    /**
     * @stability stable
     */
    resetAllocationStrategy(): void;
    /**
     * @stability stable
     */
    get allocationStrategyInput(): string | undefined;
    private _instanceInterruptionBehavior?;
    /**
     * @stability stable
     */
    get instanceInterruptionBehavior(): string;
    /**
     * @stability stable
     */
    set instanceInterruptionBehavior(value: string);
    /**
     * @stability stable
     */
    resetInstanceInterruptionBehavior(): void;
    /**
     * @stability stable
     */
    get instanceInterruptionBehaviorInput(): string | undefined;
    private _instancePoolsToUseCount?;
    /**
     * @stability stable
     */
    get instancePoolsToUseCount(): number;
    /**
     * @stability stable
     */
    set instancePoolsToUseCount(value: number);
    /**
     * @stability stable
     */
    resetInstancePoolsToUseCount(): void;
    /**
     * @stability stable
     */
    get instancePoolsToUseCountInput(): number | undefined;
    private _maintenanceStrategies;
    /**
     * @stability stable
     */
    get maintenanceStrategies(): Ec2FleetSpotOptionsMaintenanceStrategiesOutputReference;
    /**
     * @stability stable
     */
    putMaintenanceStrategies(value: Ec2FleetSpotOptionsMaintenanceStrategies): void;
    /**
     * @stability stable
     */
    resetMaintenanceStrategies(): void;
    /**
     * @stability stable
     */
    get maintenanceStrategiesInput(): Ec2FleetSpotOptionsMaintenanceStrategies | undefined;
}
/**
 * @stability stable
 */
export interface Ec2FleetTargetCapacitySpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#default_target_capacity_type Ec2Fleet#default_target_capacity_type}.
     *
     * @stability stable
     */
    readonly defaultTargetCapacityType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#on_demand_target_capacity Ec2Fleet#on_demand_target_capacity}.
     *
     * @stability stable
     */
    readonly onDemandTargetCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#spot_target_capacity Ec2Fleet#spot_target_capacity}.
     *
     * @stability stable
     */
    readonly spotTargetCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#total_target_capacity Ec2Fleet#total_target_capacity}.
     *
     * @stability stable
     */
    readonly totalTargetCapacity: number;
}
export declare function ec2FleetTargetCapacitySpecificationToTerraform(struct?: Ec2FleetTargetCapacitySpecificationOutputReference | Ec2FleetTargetCapacitySpecification): any;
/**
 * @stability stable
 */
export declare class Ec2FleetTargetCapacitySpecificationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Ec2FleetTargetCapacitySpecification | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Ec2FleetTargetCapacitySpecification | undefined);
    private _defaultTargetCapacityType?;
    /**
     * @stability stable
     */
    get defaultTargetCapacityType(): string;
    /**
     * @stability stable
     */
    set defaultTargetCapacityType(value: string);
    /**
     * @stability stable
     */
    get defaultTargetCapacityTypeInput(): string | undefined;
    private _onDemandTargetCapacity?;
    /**
     * @stability stable
     */
    get onDemandTargetCapacity(): number;
    /**
     * @stability stable
     */
    set onDemandTargetCapacity(value: number);
    /**
     * @stability stable
     */
    resetOnDemandTargetCapacity(): void;
    /**
     * @stability stable
     */
    get onDemandTargetCapacityInput(): number | undefined;
    private _spotTargetCapacity?;
    /**
     * @stability stable
     */
    get spotTargetCapacity(): number;
    /**
     * @stability stable
     */
    set spotTargetCapacity(value: number);
    /**
     * @stability stable
     */
    resetSpotTargetCapacity(): void;
    /**
     * @stability stable
     */
    get spotTargetCapacityInput(): number | undefined;
    private _totalTargetCapacity?;
    /**
     * @stability stable
     */
    get totalTargetCapacity(): number;
    /**
     * @stability stable
     */
    set totalTargetCapacity(value: number);
    /**
     * @stability stable
     */
    get totalTargetCapacityInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface Ec2FleetTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#create Ec2Fleet#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#delete Ec2Fleet#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet#update Ec2Fleet#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function ec2FleetTimeoutsToTerraform(struct?: Ec2FleetTimeoutsOutputReference | Ec2FleetTimeouts): any;
/**
 * @stability stable
 */
export declare class Ec2FleetTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Ec2FleetTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Ec2FleetTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet aws_ec2_fleet}.
 *
 * @stability stable
 */
export declare class Ec2Fleet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet aws_ec2_fleet} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2FleetConfig);
    private _excessCapacityTerminationPolicy?;
    /**
     * @stability stable
     */
    get excessCapacityTerminationPolicy(): string;
    /**
     * @stability stable
     */
    set excessCapacityTerminationPolicy(value: string);
    /**
     * @stability stable
     */
    resetExcessCapacityTerminationPolicy(): void;
    /**
     * @stability stable
     */
    get excessCapacityTerminationPolicyInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _replaceUnhealthyInstances?;
    /**
     * @stability stable
     */
    get replaceUnhealthyInstances(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set replaceUnhealthyInstances(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetReplaceUnhealthyInstances(): void;
    /**
     * @stability stable
     */
    get replaceUnhealthyInstancesInput(): boolean | cdktf.IResolvable | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _terminateInstances?;
    /**
     * @stability stable
     */
    get terminateInstances(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set terminateInstances(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTerminateInstances(): void;
    /**
     * @stability stable
     */
    get terminateInstancesInput(): boolean | cdktf.IResolvable | undefined;
    private _terminateInstancesWithExpiration?;
    /**
     * @stability stable
     */
    get terminateInstancesWithExpiration(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set terminateInstancesWithExpiration(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTerminateInstancesWithExpiration(): void;
    /**
     * @stability stable
     */
    get terminateInstancesWithExpirationInput(): boolean | cdktf.IResolvable | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _launchTemplateConfig;
    /**
     * @stability stable
     */
    get launchTemplateConfig(): Ec2FleetLaunchTemplateConfigOutputReference;
    /**
     * @stability stable
     */
    putLaunchTemplateConfig(value: Ec2FleetLaunchTemplateConfig): void;
    /**
     * @stability stable
     */
    get launchTemplateConfigInput(): Ec2FleetLaunchTemplateConfig | undefined;
    private _onDemandOptions;
    /**
     * @stability stable
     */
    get onDemandOptions(): Ec2FleetOnDemandOptionsOutputReference;
    /**
     * @stability stable
     */
    putOnDemandOptions(value: Ec2FleetOnDemandOptions): void;
    /**
     * @stability stable
     */
    resetOnDemandOptions(): void;
    /**
     * @stability stable
     */
    get onDemandOptionsInput(): Ec2FleetOnDemandOptions | undefined;
    private _spotOptions;
    /**
     * @stability stable
     */
    get spotOptions(): Ec2FleetSpotOptionsOutputReference;
    /**
     * @stability stable
     */
    putSpotOptions(value: Ec2FleetSpotOptions): void;
    /**
     * @stability stable
     */
    resetSpotOptions(): void;
    /**
     * @stability stable
     */
    get spotOptionsInput(): Ec2FleetSpotOptions | undefined;
    private _targetCapacitySpecification;
    /**
     * @stability stable
     */
    get targetCapacitySpecification(): Ec2FleetTargetCapacitySpecificationOutputReference;
    /**
     * @stability stable
     */
    putTargetCapacitySpecification(value: Ec2FleetTargetCapacitySpecification): void;
    /**
     * @stability stable
     */
    get targetCapacitySpecificationInput(): Ec2FleetTargetCapacitySpecification | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): Ec2FleetTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: Ec2FleetTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): Ec2FleetTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
