import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS EC2.
 *
 * @stability stable
 */
export interface Ec2LocalGatewayRouteConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_local_gateway_route#destination_cidr_block Ec2LocalGatewayRoute#destination_cidr_block}.
     *
     * @stability stable
     */
    readonly destinationCidrBlock: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_local_gateway_route#local_gateway_route_table_id Ec2LocalGatewayRoute#local_gateway_route_table_id}.
     *
     * @stability stable
     */
    readonly localGatewayRouteTableId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_local_gateway_route#local_gateway_virtual_interface_group_id Ec2LocalGatewayRoute#local_gateway_virtual_interface_group_id}.
     *
     * @stability stable
     */
    readonly localGatewayVirtualInterfaceGroupId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_local_gateway_route aws_ec2_local_gateway_route}.
 *
 * @stability stable
 */
export declare class Ec2LocalGatewayRoute extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_local_gateway_route aws_ec2_local_gateway_route} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2LocalGatewayRouteConfig);
    private _destinationCidrBlock?;
    /**
     * @stability stable
     */
    get destinationCidrBlock(): string;
    /**
     * @stability stable
     */
    set destinationCidrBlock(value: string);
    /**
     * @stability stable
     */
    get destinationCidrBlockInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _localGatewayRouteTableId?;
    /**
     * @stability stable
     */
    get localGatewayRouteTableId(): string;
    /**
     * @stability stable
     */
    set localGatewayRouteTableId(value: string);
    /**
     * @stability stable
     */
    get localGatewayRouteTableIdInput(): string | undefined;
    private _localGatewayVirtualInterfaceGroupId?;
    /**
     * @stability stable
     */
    get localGatewayVirtualInterfaceGroupId(): string;
    /**
     * @stability stable
     */
    set localGatewayVirtualInterfaceGroupId(value: string);
    /**
     * @stability stable
     */
    get localGatewayVirtualInterfaceGroupIdInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
