import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS EC2.
 *
 * @stability stable
 */
export interface LaunchTemplateConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#default_version LaunchTemplate#default_version}.
     *
     * @stability stable
     */
    readonly defaultVersion?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#description LaunchTemplate#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#disable_api_termination LaunchTemplate#disable_api_termination}.
     *
     * @stability stable
     */
    readonly disableApiTermination?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#ebs_optimized LaunchTemplate#ebs_optimized}.
     *
     * @stability stable
     */
    readonly ebsOptimized?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#image_id LaunchTemplate#image_id}.
     *
     * @stability stable
     */
    readonly imageId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#instance_initiated_shutdown_behavior LaunchTemplate#instance_initiated_shutdown_behavior}.
     *
     * @stability stable
     */
    readonly instanceInitiatedShutdownBehavior?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#instance_type LaunchTemplate#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#kernel_id LaunchTemplate#kernel_id}.
     *
     * @stability stable
     */
    readonly kernelId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#key_name LaunchTemplate#key_name}.
     *
     * @stability stable
     */
    readonly keyName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#name LaunchTemplate#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#name_prefix LaunchTemplate#name_prefix}.
     *
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#ram_disk_id LaunchTemplate#ram_disk_id}.
     *
     * @stability stable
     */
    readonly ramDiskId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#security_group_names LaunchTemplate#security_group_names}.
     *
     * @stability stable
     */
    readonly securityGroupNames?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#tags LaunchTemplate#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#tags_all LaunchTemplate#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#update_default_version LaunchTemplate#update_default_version}.
     *
     * @stability stable
     */
    readonly updateDefaultVersion?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#user_data LaunchTemplate#user_data}.
     *
     * @stability stable
     */
    readonly userData?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#vpc_security_group_ids LaunchTemplate#vpc_security_group_ids}.
     *
     * @stability stable
     */
    readonly vpcSecurityGroupIds?: string[];
    /**
     * block_device_mappings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#block_device_mappings LaunchTemplate#block_device_mappings}
     *
     * @stability stable
     */
    readonly blockDeviceMappings?: LaunchTemplateBlockDeviceMappings[];
    /**
     * capacity_reservation_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#capacity_reservation_specification LaunchTemplate#capacity_reservation_specification}
     *
     * @stability stable
     */
    readonly capacityReservationSpecification?: LaunchTemplateCapacityReservationSpecification;
    /**
     * cpu_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#cpu_options LaunchTemplate#cpu_options}
     *
     * @stability stable
     */
    readonly cpuOptions?: LaunchTemplateCpuOptions;
    /**
     * credit_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#credit_specification LaunchTemplate#credit_specification}
     *
     * @stability stable
     */
    readonly creditSpecification?: LaunchTemplateCreditSpecification;
    /**
     * elastic_gpu_specifications block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#elastic_gpu_specifications LaunchTemplate#elastic_gpu_specifications}
     *
     * @stability stable
     */
    readonly elasticGpuSpecifications?: LaunchTemplateElasticGpuSpecifications[];
    /**
     * elastic_inference_accelerator block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#elastic_inference_accelerator LaunchTemplate#elastic_inference_accelerator}
     *
     * @stability stable
     */
    readonly elasticInferenceAccelerator?: LaunchTemplateElasticInferenceAccelerator;
    /**
     * enclave_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#enclave_options LaunchTemplate#enclave_options}
     *
     * @stability stable
     */
    readonly enclaveOptions?: LaunchTemplateEnclaveOptions;
    /**
     * hibernation_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#hibernation_options LaunchTemplate#hibernation_options}
     *
     * @stability stable
     */
    readonly hibernationOptions?: LaunchTemplateHibernationOptions;
    /**
     * iam_instance_profile block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#iam_instance_profile LaunchTemplate#iam_instance_profile}
     *
     * @stability stable
     */
    readonly iamInstanceProfile?: LaunchTemplateIamInstanceProfile;
    /**
     * instance_market_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#instance_market_options LaunchTemplate#instance_market_options}
     *
     * @stability stable
     */
    readonly instanceMarketOptions?: LaunchTemplateInstanceMarketOptions;
    /**
     * license_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#license_specification LaunchTemplate#license_specification}
     *
     * @stability stable
     */
    readonly licenseSpecification?: LaunchTemplateLicenseSpecification[];
    /**
     * metadata_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#metadata_options LaunchTemplate#metadata_options}
     *
     * @stability stable
     */
    readonly metadataOptions?: LaunchTemplateMetadataOptions;
    /**
     * monitoring block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#monitoring LaunchTemplate#monitoring}
     *
     * @stability stable
     */
    readonly monitoring?: LaunchTemplateMonitoring;
    /**
     * network_interfaces block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#network_interfaces LaunchTemplate#network_interfaces}
     *
     * @stability stable
     */
    readonly networkInterfaces?: LaunchTemplateNetworkInterfaces[];
    /**
     * placement block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#placement LaunchTemplate#placement}
     *
     * @stability stable
     */
    readonly placement?: LaunchTemplatePlacement;
    /**
     * tag_specifications block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#tag_specifications LaunchTemplate#tag_specifications}
     *
     * @stability stable
     */
    readonly tagSpecifications?: LaunchTemplateTagSpecifications[];
}
/**
 * @stability stable
 */
export interface LaunchTemplateBlockDeviceMappingsEbs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#delete_on_termination LaunchTemplate#delete_on_termination}.
     *
     * @stability stable
     */
    readonly deleteOnTermination?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#encrypted LaunchTemplate#encrypted}.
     *
     * @stability stable
     */
    readonly encrypted?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#iops LaunchTemplate#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#kms_key_id LaunchTemplate#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#snapshot_id LaunchTemplate#snapshot_id}.
     *
     * @stability stable
     */
    readonly snapshotId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#throughput LaunchTemplate#throughput}.
     *
     * @stability stable
     */
    readonly throughput?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#volume_size LaunchTemplate#volume_size}.
     *
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#volume_type LaunchTemplate#volume_type}.
     *
     * @stability stable
     */
    readonly volumeType?: string;
}
export declare function launchTemplateBlockDeviceMappingsEbsToTerraform(struct?: LaunchTemplateBlockDeviceMappingsEbsOutputReference | LaunchTemplateBlockDeviceMappingsEbs): any;
/**
 * @stability stable
 */
export declare class LaunchTemplateBlockDeviceMappingsEbsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LaunchTemplateBlockDeviceMappingsEbs | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LaunchTemplateBlockDeviceMappingsEbs | undefined);
    private _deleteOnTermination?;
    /**
     * @stability stable
     */
    get deleteOnTermination(): string;
    /**
     * @stability stable
     */
    set deleteOnTermination(value: string);
    /**
     * @stability stable
     */
    resetDeleteOnTermination(): void;
    /**
     * @stability stable
     */
    get deleteOnTerminationInput(): string | undefined;
    private _encrypted?;
    /**
     * @stability stable
     */
    get encrypted(): string;
    /**
     * @stability stable
     */
    set encrypted(value: string);
    /**
     * @stability stable
     */
    resetEncrypted(): void;
    /**
     * @stability stable
     */
    get encryptedInput(): string | undefined;
    private _iops?;
    /**
     * @stability stable
     */
    get iops(): number;
    /**
     * @stability stable
     */
    set iops(value: number);
    /**
     * @stability stable
     */
    resetIops(): void;
    /**
     * @stability stable
     */
    get iopsInput(): number | undefined;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    private _snapshotId?;
    /**
     * @stability stable
     */
    get snapshotId(): string;
    /**
     * @stability stable
     */
    set snapshotId(value: string);
    /**
     * @stability stable
     */
    resetSnapshotId(): void;
    /**
     * @stability stable
     */
    get snapshotIdInput(): string | undefined;
    private _throughput?;
    /**
     * @stability stable
     */
    get throughput(): number;
    /**
     * @stability stable
     */
    set throughput(value: number);
    /**
     * @stability stable
     */
    resetThroughput(): void;
    /**
     * @stability stable
     */
    get throughputInput(): number | undefined;
    private _volumeSize?;
    /**
     * @stability stable
     */
    get volumeSize(): number;
    /**
     * @stability stable
     */
    set volumeSize(value: number);
    /**
     * @stability stable
     */
    resetVolumeSize(): void;
    /**
     * @stability stable
     */
    get volumeSizeInput(): number | undefined;
    private _volumeType?;
    /**
     * @stability stable
     */
    get volumeType(): string;
    /**
     * @stability stable
     */
    set volumeType(value: string);
    /**
     * @stability stable
     */
    resetVolumeType(): void;
    /**
     * @stability stable
     */
    get volumeTypeInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface LaunchTemplateBlockDeviceMappings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#device_name LaunchTemplate#device_name}.
     *
     * @stability stable
     */
    readonly deviceName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#no_device LaunchTemplate#no_device}.
     *
     * @stability stable
     */
    readonly noDevice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#virtual_name LaunchTemplate#virtual_name}.
     *
     * @stability stable
     */
    readonly virtualName?: string;
    /**
     * ebs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#ebs LaunchTemplate#ebs}
     *
     * @stability stable
     */
    readonly ebs?: LaunchTemplateBlockDeviceMappingsEbs;
}
export declare function launchTemplateBlockDeviceMappingsToTerraform(struct?: LaunchTemplateBlockDeviceMappings): any;
/**
 * @stability stable
 */
export interface LaunchTemplateCapacityReservationSpecificationCapacityReservationTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#capacity_reservation_id LaunchTemplate#capacity_reservation_id}.
     *
     * @stability stable
     */
    readonly capacityReservationId?: string;
}
export declare function launchTemplateCapacityReservationSpecificationCapacityReservationTargetToTerraform(struct?: LaunchTemplateCapacityReservationSpecificationCapacityReservationTargetOutputReference | LaunchTemplateCapacityReservationSpecificationCapacityReservationTarget): any;
/**
 * @stability stable
 */
export declare class LaunchTemplateCapacityReservationSpecificationCapacityReservationTargetOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LaunchTemplateCapacityReservationSpecificationCapacityReservationTarget | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LaunchTemplateCapacityReservationSpecificationCapacityReservationTarget | undefined);
    private _capacityReservationId?;
    /**
     * @stability stable
     */
    get capacityReservationId(): string;
    /**
     * @stability stable
     */
    set capacityReservationId(value: string);
    /**
     * @stability stable
     */
    resetCapacityReservationId(): void;
    /**
     * @stability stable
     */
    get capacityReservationIdInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface LaunchTemplateCapacityReservationSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#capacity_reservation_preference LaunchTemplate#capacity_reservation_preference}.
     *
     * @stability stable
     */
    readonly capacityReservationPreference?: string;
    /**
     * capacity_reservation_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#capacity_reservation_target LaunchTemplate#capacity_reservation_target}
     *
     * @stability stable
     */
    readonly capacityReservationTarget?: LaunchTemplateCapacityReservationSpecificationCapacityReservationTarget;
}
export declare function launchTemplateCapacityReservationSpecificationToTerraform(struct?: LaunchTemplateCapacityReservationSpecificationOutputReference | LaunchTemplateCapacityReservationSpecification): any;
/**
 * @stability stable
 */
export declare class LaunchTemplateCapacityReservationSpecificationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LaunchTemplateCapacityReservationSpecification | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LaunchTemplateCapacityReservationSpecification | undefined);
    private _capacityReservationPreference?;
    /**
     * @stability stable
     */
    get capacityReservationPreference(): string;
    /**
     * @stability stable
     */
    set capacityReservationPreference(value: string);
    /**
     * @stability stable
     */
    resetCapacityReservationPreference(): void;
    /**
     * @stability stable
     */
    get capacityReservationPreferenceInput(): string | undefined;
    private _capacityReservationTarget;
    /**
     * @stability stable
     */
    get capacityReservationTarget(): LaunchTemplateCapacityReservationSpecificationCapacityReservationTargetOutputReference;
    /**
     * @stability stable
     */
    putCapacityReservationTarget(value: LaunchTemplateCapacityReservationSpecificationCapacityReservationTarget): void;
    /**
     * @stability stable
     */
    resetCapacityReservationTarget(): void;
    /**
     * @stability stable
     */
    get capacityReservationTargetInput(): LaunchTemplateCapacityReservationSpecificationCapacityReservationTarget | undefined;
}
/**
 * @stability stable
 */
export interface LaunchTemplateCpuOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#core_count LaunchTemplate#core_count}.
     *
     * @stability stable
     */
    readonly coreCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#threads_per_core LaunchTemplate#threads_per_core}.
     *
     * @stability stable
     */
    readonly threadsPerCore?: number;
}
export declare function launchTemplateCpuOptionsToTerraform(struct?: LaunchTemplateCpuOptionsOutputReference | LaunchTemplateCpuOptions): any;
/**
 * @stability stable
 */
export declare class LaunchTemplateCpuOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LaunchTemplateCpuOptions | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LaunchTemplateCpuOptions | undefined);
    private _coreCount?;
    /**
     * @stability stable
     */
    get coreCount(): number;
    /**
     * @stability stable
     */
    set coreCount(value: number);
    /**
     * @stability stable
     */
    resetCoreCount(): void;
    /**
     * @stability stable
     */
    get coreCountInput(): number | undefined;
    private _threadsPerCore?;
    /**
     * @stability stable
     */
    get threadsPerCore(): number;
    /**
     * @stability stable
     */
    set threadsPerCore(value: number);
    /**
     * @stability stable
     */
    resetThreadsPerCore(): void;
    /**
     * @stability stable
     */
    get threadsPerCoreInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface LaunchTemplateCreditSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#cpu_credits LaunchTemplate#cpu_credits}.
     *
     * @stability stable
     */
    readonly cpuCredits?: string;
}
export declare function launchTemplateCreditSpecificationToTerraform(struct?: LaunchTemplateCreditSpecificationOutputReference | LaunchTemplateCreditSpecification): any;
/**
 * @stability stable
 */
export declare class LaunchTemplateCreditSpecificationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LaunchTemplateCreditSpecification | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LaunchTemplateCreditSpecification | undefined);
    private _cpuCredits?;
    /**
     * @stability stable
     */
    get cpuCredits(): string;
    /**
     * @stability stable
     */
    set cpuCredits(value: string);
    /**
     * @stability stable
     */
    resetCpuCredits(): void;
    /**
     * @stability stable
     */
    get cpuCreditsInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface LaunchTemplateElasticGpuSpecifications {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#type LaunchTemplate#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
export declare function launchTemplateElasticGpuSpecificationsToTerraform(struct?: LaunchTemplateElasticGpuSpecifications): any;
/**
 * @stability stable
 */
export interface LaunchTemplateElasticInferenceAccelerator {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#type LaunchTemplate#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
export declare function launchTemplateElasticInferenceAcceleratorToTerraform(struct?: LaunchTemplateElasticInferenceAcceleratorOutputReference | LaunchTemplateElasticInferenceAccelerator): any;
/**
 * @stability stable
 */
export declare class LaunchTemplateElasticInferenceAcceleratorOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LaunchTemplateElasticInferenceAccelerator | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LaunchTemplateElasticInferenceAccelerator | undefined);
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface LaunchTemplateEnclaveOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#enabled LaunchTemplate#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
}
export declare function launchTemplateEnclaveOptionsToTerraform(struct?: LaunchTemplateEnclaveOptionsOutputReference | LaunchTemplateEnclaveOptions): any;
/**
 * @stability stable
 */
export declare class LaunchTemplateEnclaveOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LaunchTemplateEnclaveOptions | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LaunchTemplateEnclaveOptions | undefined);
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
}
/**
 * @stability stable
 */
export interface LaunchTemplateHibernationOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#configured LaunchTemplate#configured}.
     *
     * @stability stable
     */
    readonly configured: boolean | cdktf.IResolvable;
}
export declare function launchTemplateHibernationOptionsToTerraform(struct?: LaunchTemplateHibernationOptionsOutputReference | LaunchTemplateHibernationOptions): any;
/**
 * @stability stable
 */
export declare class LaunchTemplateHibernationOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LaunchTemplateHibernationOptions | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LaunchTemplateHibernationOptions | undefined);
    private _configured?;
    /**
     * @stability stable
     */
    get configured(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set configured(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get configuredInput(): boolean | cdktf.IResolvable | undefined;
}
/**
 * @stability stable
 */
export interface LaunchTemplateIamInstanceProfile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#arn LaunchTemplate#arn}.
     *
     * @stability stable
     */
    readonly arn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#name LaunchTemplate#name}.
     *
     * @stability stable
     */
    readonly name?: string;
}
export declare function launchTemplateIamInstanceProfileToTerraform(struct?: LaunchTemplateIamInstanceProfileOutputReference | LaunchTemplateIamInstanceProfile): any;
/**
 * @stability stable
 */
export declare class LaunchTemplateIamInstanceProfileOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LaunchTemplateIamInstanceProfile | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LaunchTemplateIamInstanceProfile | undefined);
    private _arn?;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    set arn(value: string);
    /**
     * @stability stable
     */
    resetArn(): void;
    /**
     * @stability stable
     */
    get arnInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface LaunchTemplateInstanceMarketOptionsSpotOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#block_duration_minutes LaunchTemplate#block_duration_minutes}.
     *
     * @stability stable
     */
    readonly blockDurationMinutes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#instance_interruption_behavior LaunchTemplate#instance_interruption_behavior}.
     *
     * @stability stable
     */
    readonly instanceInterruptionBehavior?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#max_price LaunchTemplate#max_price}.
     *
     * @stability stable
     */
    readonly maxPrice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#spot_instance_type LaunchTemplate#spot_instance_type}.
     *
     * @stability stable
     */
    readonly spotInstanceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#valid_until LaunchTemplate#valid_until}.
     *
     * @stability stable
     */
    readonly validUntil?: string;
}
export declare function launchTemplateInstanceMarketOptionsSpotOptionsToTerraform(struct?: LaunchTemplateInstanceMarketOptionsSpotOptionsOutputReference | LaunchTemplateInstanceMarketOptionsSpotOptions): any;
/**
 * @stability stable
 */
export declare class LaunchTemplateInstanceMarketOptionsSpotOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LaunchTemplateInstanceMarketOptionsSpotOptions | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LaunchTemplateInstanceMarketOptionsSpotOptions | undefined);
    private _blockDurationMinutes?;
    /**
     * @stability stable
     */
    get blockDurationMinutes(): number;
    /**
     * @stability stable
     */
    set blockDurationMinutes(value: number);
    /**
     * @stability stable
     */
    resetBlockDurationMinutes(): void;
    /**
     * @stability stable
     */
    get blockDurationMinutesInput(): number | undefined;
    private _instanceInterruptionBehavior?;
    /**
     * @stability stable
     */
    get instanceInterruptionBehavior(): string;
    /**
     * @stability stable
     */
    set instanceInterruptionBehavior(value: string);
    /**
     * @stability stable
     */
    resetInstanceInterruptionBehavior(): void;
    /**
     * @stability stable
     */
    get instanceInterruptionBehaviorInput(): string | undefined;
    private _maxPrice?;
    /**
     * @stability stable
     */
    get maxPrice(): string;
    /**
     * @stability stable
     */
    set maxPrice(value: string);
    /**
     * @stability stable
     */
    resetMaxPrice(): void;
    /**
     * @stability stable
     */
    get maxPriceInput(): string | undefined;
    private _spotInstanceType?;
    /**
     * @stability stable
     */
    get spotInstanceType(): string;
    /**
     * @stability stable
     */
    set spotInstanceType(value: string);
    /**
     * @stability stable
     */
    resetSpotInstanceType(): void;
    /**
     * @stability stable
     */
    get spotInstanceTypeInput(): string | undefined;
    private _validUntil?;
    /**
     * @stability stable
     */
    get validUntil(): string;
    /**
     * @stability stable
     */
    set validUntil(value: string);
    /**
     * @stability stable
     */
    resetValidUntil(): void;
    /**
     * @stability stable
     */
    get validUntilInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface LaunchTemplateInstanceMarketOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#market_type LaunchTemplate#market_type}.
     *
     * @stability stable
     */
    readonly marketType?: string;
    /**
     * spot_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#spot_options LaunchTemplate#spot_options}
     *
     * @stability stable
     */
    readonly spotOptions?: LaunchTemplateInstanceMarketOptionsSpotOptions;
}
export declare function launchTemplateInstanceMarketOptionsToTerraform(struct?: LaunchTemplateInstanceMarketOptionsOutputReference | LaunchTemplateInstanceMarketOptions): any;
/**
 * @stability stable
 */
export declare class LaunchTemplateInstanceMarketOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LaunchTemplateInstanceMarketOptions | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LaunchTemplateInstanceMarketOptions | undefined);
    private _marketType?;
    /**
     * @stability stable
     */
    get marketType(): string;
    /**
     * @stability stable
     */
    set marketType(value: string);
    /**
     * @stability stable
     */
    resetMarketType(): void;
    /**
     * @stability stable
     */
    get marketTypeInput(): string | undefined;
    private _spotOptions;
    /**
     * @stability stable
     */
    get spotOptions(): LaunchTemplateInstanceMarketOptionsSpotOptionsOutputReference;
    /**
     * @stability stable
     */
    putSpotOptions(value: LaunchTemplateInstanceMarketOptionsSpotOptions): void;
    /**
     * @stability stable
     */
    resetSpotOptions(): void;
    /**
     * @stability stable
     */
    get spotOptionsInput(): LaunchTemplateInstanceMarketOptionsSpotOptions | undefined;
}
/**
 * @stability stable
 */
export interface LaunchTemplateLicenseSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#license_configuration_arn LaunchTemplate#license_configuration_arn}.
     *
     * @stability stable
     */
    readonly licenseConfigurationArn: string;
}
export declare function launchTemplateLicenseSpecificationToTerraform(struct?: LaunchTemplateLicenseSpecification): any;
/**
 * @stability stable
 */
export interface LaunchTemplateMetadataOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#http_endpoint LaunchTemplate#http_endpoint}.
     *
     * @stability stable
     */
    readonly httpEndpoint?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#http_protocol_ipv6 LaunchTemplate#http_protocol_ipv6}.
     *
     * @stability stable
     */
    readonly httpProtocolIpv6?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#http_put_response_hop_limit LaunchTemplate#http_put_response_hop_limit}.
     *
     * @stability stable
     */
    readonly httpPutResponseHopLimit?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#http_tokens LaunchTemplate#http_tokens}.
     *
     * @stability stable
     */
    readonly httpTokens?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#instance_metadata_tags LaunchTemplate#instance_metadata_tags}.
     *
     * @stability stable
     */
    readonly instanceMetadataTags?: string;
}
export declare function launchTemplateMetadataOptionsToTerraform(struct?: LaunchTemplateMetadataOptionsOutputReference | LaunchTemplateMetadataOptions): any;
/**
 * @stability stable
 */
export declare class LaunchTemplateMetadataOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LaunchTemplateMetadataOptions | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LaunchTemplateMetadataOptions | undefined);
    private _httpEndpoint?;
    /**
     * @stability stable
     */
    get httpEndpoint(): string;
    /**
     * @stability stable
     */
    set httpEndpoint(value: string);
    /**
     * @stability stable
     */
    resetHttpEndpoint(): void;
    /**
     * @stability stable
     */
    get httpEndpointInput(): string | undefined;
    private _httpProtocolIpv6?;
    /**
     * @stability stable
     */
    get httpProtocolIpv6(): string;
    /**
     * @stability stable
     */
    set httpProtocolIpv6(value: string);
    /**
     * @stability stable
     */
    resetHttpProtocolIpv6(): void;
    /**
     * @stability stable
     */
    get httpProtocolIpv6Input(): string | undefined;
    private _httpPutResponseHopLimit?;
    /**
     * @stability stable
     */
    get httpPutResponseHopLimit(): number;
    /**
     * @stability stable
     */
    set httpPutResponseHopLimit(value: number);
    /**
     * @stability stable
     */
    resetHttpPutResponseHopLimit(): void;
    /**
     * @stability stable
     */
    get httpPutResponseHopLimitInput(): number | undefined;
    private _httpTokens?;
    /**
     * @stability stable
     */
    get httpTokens(): string;
    /**
     * @stability stable
     */
    set httpTokens(value: string);
    /**
     * @stability stable
     */
    resetHttpTokens(): void;
    /**
     * @stability stable
     */
    get httpTokensInput(): string | undefined;
    private _instanceMetadataTags?;
    /**
     * @stability stable
     */
    get instanceMetadataTags(): string;
    /**
     * @stability stable
     */
    set instanceMetadataTags(value: string);
    /**
     * @stability stable
     */
    resetInstanceMetadataTags(): void;
    /**
     * @stability stable
     */
    get instanceMetadataTagsInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface LaunchTemplateMonitoring {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#enabled LaunchTemplate#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
}
export declare function launchTemplateMonitoringToTerraform(struct?: LaunchTemplateMonitoringOutputReference | LaunchTemplateMonitoring): any;
/**
 * @stability stable
 */
export declare class LaunchTemplateMonitoringOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LaunchTemplateMonitoring | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LaunchTemplateMonitoring | undefined);
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
}
/**
 * @stability stable
 */
export interface LaunchTemplateNetworkInterfaces {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#associate_carrier_ip_address LaunchTemplate#associate_carrier_ip_address}.
     *
     * @stability stable
     */
    readonly associateCarrierIpAddress?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#associate_public_ip_address LaunchTemplate#associate_public_ip_address}.
     *
     * @stability stable
     */
    readonly associatePublicIpAddress?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#delete_on_termination LaunchTemplate#delete_on_termination}.
     *
     * @stability stable
     */
    readonly deleteOnTermination?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#description LaunchTemplate#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#device_index LaunchTemplate#device_index}.
     *
     * @stability stable
     */
    readonly deviceIndex?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#interface_type LaunchTemplate#interface_type}.
     *
     * @stability stable
     */
    readonly interfaceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#ipv4_address_count LaunchTemplate#ipv4_address_count}.
     *
     * @stability stable
     */
    readonly ipv4AddressCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#ipv4_addresses LaunchTemplate#ipv4_addresses}.
     *
     * @stability stable
     */
    readonly ipv4Addresses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#ipv6_address_count LaunchTemplate#ipv6_address_count}.
     *
     * @stability stable
     */
    readonly ipv6AddressCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#ipv6_addresses LaunchTemplate#ipv6_addresses}.
     *
     * @stability stable
     */
    readonly ipv6Addresses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#network_card_index LaunchTemplate#network_card_index}.
     *
     * @stability stable
     */
    readonly networkCardIndex?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#network_interface_id LaunchTemplate#network_interface_id}.
     *
     * @stability stable
     */
    readonly networkInterfaceId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#private_ip_address LaunchTemplate#private_ip_address}.
     *
     * @stability stable
     */
    readonly privateIpAddress?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#security_groups LaunchTemplate#security_groups}.
     *
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#subnet_id LaunchTemplate#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId?: string;
}
export declare function launchTemplateNetworkInterfacesToTerraform(struct?: LaunchTemplateNetworkInterfaces): any;
/**
 * @stability stable
 */
export interface LaunchTemplatePlacement {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#affinity LaunchTemplate#affinity}.
     *
     * @stability stable
     */
    readonly affinity?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#availability_zone LaunchTemplate#availability_zone}.
     *
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#group_name LaunchTemplate#group_name}.
     *
     * @stability stable
     */
    readonly groupName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#host_id LaunchTemplate#host_id}.
     *
     * @stability stable
     */
    readonly hostId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#host_resource_group_arn LaunchTemplate#host_resource_group_arn}.
     *
     * @stability stable
     */
    readonly hostResourceGroupArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#partition_number LaunchTemplate#partition_number}.
     *
     * @stability stable
     */
    readonly partitionNumber?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#spread_domain LaunchTemplate#spread_domain}.
     *
     * @stability stable
     */
    readonly spreadDomain?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#tenancy LaunchTemplate#tenancy}.
     *
     * @stability stable
     */
    readonly tenancy?: string;
}
export declare function launchTemplatePlacementToTerraform(struct?: LaunchTemplatePlacementOutputReference | LaunchTemplatePlacement): any;
/**
 * @stability stable
 */
export declare class LaunchTemplatePlacementOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): LaunchTemplatePlacement | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: LaunchTemplatePlacement | undefined);
    private _affinity?;
    /**
     * @stability stable
     */
    get affinity(): string;
    /**
     * @stability stable
     */
    set affinity(value: string);
    /**
     * @stability stable
     */
    resetAffinity(): void;
    /**
     * @stability stable
     */
    get affinityInput(): string | undefined;
    private _availabilityZone?;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    set availabilityZone(value: string);
    /**
     * @stability stable
     */
    resetAvailabilityZone(): void;
    /**
     * @stability stable
     */
    get availabilityZoneInput(): string | undefined;
    private _groupName?;
    /**
     * @stability stable
     */
    get groupName(): string;
    /**
     * @stability stable
     */
    set groupName(value: string);
    /**
     * @stability stable
     */
    resetGroupName(): void;
    /**
     * @stability stable
     */
    get groupNameInput(): string | undefined;
    private _hostId?;
    /**
     * @stability stable
     */
    get hostId(): string;
    /**
     * @stability stable
     */
    set hostId(value: string);
    /**
     * @stability stable
     */
    resetHostId(): void;
    /**
     * @stability stable
     */
    get hostIdInput(): string | undefined;
    private _hostResourceGroupArn?;
    /**
     * @stability stable
     */
    get hostResourceGroupArn(): string;
    /**
     * @stability stable
     */
    set hostResourceGroupArn(value: string);
    /**
     * @stability stable
     */
    resetHostResourceGroupArn(): void;
    /**
     * @stability stable
     */
    get hostResourceGroupArnInput(): string | undefined;
    private _partitionNumber?;
    /**
     * @stability stable
     */
    get partitionNumber(): number;
    /**
     * @stability stable
     */
    set partitionNumber(value: number);
    /**
     * @stability stable
     */
    resetPartitionNumber(): void;
    /**
     * @stability stable
     */
    get partitionNumberInput(): number | undefined;
    private _spreadDomain?;
    /**
     * @stability stable
     */
    get spreadDomain(): string;
    /**
     * @stability stable
     */
    set spreadDomain(value: string);
    /**
     * @stability stable
     */
    resetSpreadDomain(): void;
    /**
     * @stability stable
     */
    get spreadDomainInput(): string | undefined;
    private _tenancy?;
    /**
     * @stability stable
     */
    get tenancy(): string;
    /**
     * @stability stable
     */
    set tenancy(value: string);
    /**
     * @stability stable
     */
    resetTenancy(): void;
    /**
     * @stability stable
     */
    get tenancyInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface LaunchTemplateTagSpecifications {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#resource_type LaunchTemplate#resource_type}.
     *
     * @stability stable
     */
    readonly resourceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template#tags LaunchTemplate#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
}
export declare function launchTemplateTagSpecificationsToTerraform(struct?: LaunchTemplateTagSpecifications): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/launch_template aws_launch_template}.
 *
 * @stability stable
 */
export declare class LaunchTemplate extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/launch_template aws_launch_template} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: LaunchTemplateConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _defaultVersion?;
    /**
     * @stability stable
     */
    get defaultVersion(): number;
    /**
     * @stability stable
     */
    set defaultVersion(value: number);
    /**
     * @stability stable
     */
    resetDefaultVersion(): void;
    /**
     * @stability stable
     */
    get defaultVersionInput(): number | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _disableApiTermination?;
    /**
     * @stability stable
     */
    get disableApiTermination(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set disableApiTermination(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDisableApiTermination(): void;
    /**
     * @stability stable
     */
    get disableApiTerminationInput(): boolean | cdktf.IResolvable | undefined;
    private _ebsOptimized?;
    /**
     * @stability stable
     */
    get ebsOptimized(): string;
    /**
     * @stability stable
     */
    set ebsOptimized(value: string);
    /**
     * @stability stable
     */
    resetEbsOptimized(): void;
    /**
     * @stability stable
     */
    get ebsOptimizedInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _imageId?;
    /**
     * @stability stable
     */
    get imageId(): string;
    /**
     * @stability stable
     */
    set imageId(value: string);
    /**
     * @stability stable
     */
    resetImageId(): void;
    /**
     * @stability stable
     */
    get imageIdInput(): string | undefined;
    private _instanceInitiatedShutdownBehavior?;
    /**
     * @stability stable
     */
    get instanceInitiatedShutdownBehavior(): string;
    /**
     * @stability stable
     */
    set instanceInitiatedShutdownBehavior(value: string);
    /**
     * @stability stable
     */
    resetInstanceInitiatedShutdownBehavior(): void;
    /**
     * @stability stable
     */
    get instanceInitiatedShutdownBehaviorInput(): string | undefined;
    private _instanceType?;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    resetInstanceType(): void;
    /**
     * @stability stable
     */
    get instanceTypeInput(): string | undefined;
    private _kernelId?;
    /**
     * @stability stable
     */
    get kernelId(): string;
    /**
     * @stability stable
     */
    set kernelId(value: string);
    /**
     * @stability stable
     */
    resetKernelId(): void;
    /**
     * @stability stable
     */
    get kernelIdInput(): string | undefined;
    private _keyName?;
    /**
     * @stability stable
     */
    get keyName(): string;
    /**
     * @stability stable
     */
    set keyName(value: string);
    /**
     * @stability stable
     */
    resetKeyName(): void;
    /**
     * @stability stable
     */
    get keyNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get latestVersion(): number;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _ramDiskId?;
    /**
     * @stability stable
     */
    get ramDiskId(): string;
    /**
     * @stability stable
     */
    set ramDiskId(value: string);
    /**
     * @stability stable
     */
    resetRamDiskId(): void;
    /**
     * @stability stable
     */
    get ramDiskIdInput(): string | undefined;
    private _securityGroupNames?;
    /**
     * @stability stable
     */
    get securityGroupNames(): string[];
    /**
     * @stability stable
     */
    set securityGroupNames(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroupNames(): void;
    /**
     * @stability stable
     */
    get securityGroupNamesInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _updateDefaultVersion?;
    /**
     * @stability stable
     */
    get updateDefaultVersion(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set updateDefaultVersion(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetUpdateDefaultVersion(): void;
    /**
     * @stability stable
     */
    get updateDefaultVersionInput(): boolean | cdktf.IResolvable | undefined;
    private _userData?;
    /**
     * @stability stable
     */
    get userData(): string;
    /**
     * @stability stable
     */
    set userData(value: string);
    /**
     * @stability stable
     */
    resetUserData(): void;
    /**
     * @stability stable
     */
    get userDataInput(): string | undefined;
    private _vpcSecurityGroupIds?;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIds(): string[];
    /**
     * @stability stable
     */
    set vpcSecurityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetVpcSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIdsInput(): string[] | undefined;
    private _blockDeviceMappings?;
    /**
     * @stability stable
     */
    get blockDeviceMappings(): LaunchTemplateBlockDeviceMappings[];
    /**
     * @stability stable
     */
    set blockDeviceMappings(value: LaunchTemplateBlockDeviceMappings[]);
    /**
     * @stability stable
     */
    resetBlockDeviceMappings(): void;
    /**
     * @stability stable
     */
    get blockDeviceMappingsInput(): LaunchTemplateBlockDeviceMappings[] | undefined;
    private _capacityReservationSpecification;
    /**
     * @stability stable
     */
    get capacityReservationSpecification(): LaunchTemplateCapacityReservationSpecificationOutputReference;
    /**
     * @stability stable
     */
    putCapacityReservationSpecification(value: LaunchTemplateCapacityReservationSpecification): void;
    /**
     * @stability stable
     */
    resetCapacityReservationSpecification(): void;
    /**
     * @stability stable
     */
    get capacityReservationSpecificationInput(): LaunchTemplateCapacityReservationSpecification | undefined;
    private _cpuOptions;
    /**
     * @stability stable
     */
    get cpuOptions(): LaunchTemplateCpuOptionsOutputReference;
    /**
     * @stability stable
     */
    putCpuOptions(value: LaunchTemplateCpuOptions): void;
    /**
     * @stability stable
     */
    resetCpuOptions(): void;
    /**
     * @stability stable
     */
    get cpuOptionsInput(): LaunchTemplateCpuOptions | undefined;
    private _creditSpecification;
    /**
     * @stability stable
     */
    get creditSpecification(): LaunchTemplateCreditSpecificationOutputReference;
    /**
     * @stability stable
     */
    putCreditSpecification(value: LaunchTemplateCreditSpecification): void;
    /**
     * @stability stable
     */
    resetCreditSpecification(): void;
    /**
     * @stability stable
     */
    get creditSpecificationInput(): LaunchTemplateCreditSpecification | undefined;
    private _elasticGpuSpecifications?;
    /**
     * @stability stable
     */
    get elasticGpuSpecifications(): LaunchTemplateElasticGpuSpecifications[];
    /**
     * @stability stable
     */
    set elasticGpuSpecifications(value: LaunchTemplateElasticGpuSpecifications[]);
    /**
     * @stability stable
     */
    resetElasticGpuSpecifications(): void;
    /**
     * @stability stable
     */
    get elasticGpuSpecificationsInput(): LaunchTemplateElasticGpuSpecifications[] | undefined;
    private _elasticInferenceAccelerator;
    /**
     * @stability stable
     */
    get elasticInferenceAccelerator(): LaunchTemplateElasticInferenceAcceleratorOutputReference;
    /**
     * @stability stable
     */
    putElasticInferenceAccelerator(value: LaunchTemplateElasticInferenceAccelerator): void;
    /**
     * @stability stable
     */
    resetElasticInferenceAccelerator(): void;
    /**
     * @stability stable
     */
    get elasticInferenceAcceleratorInput(): LaunchTemplateElasticInferenceAccelerator | undefined;
    private _enclaveOptions;
    /**
     * @stability stable
     */
    get enclaveOptions(): LaunchTemplateEnclaveOptionsOutputReference;
    /**
     * @stability stable
     */
    putEnclaveOptions(value: LaunchTemplateEnclaveOptions): void;
    /**
     * @stability stable
     */
    resetEnclaveOptions(): void;
    /**
     * @stability stable
     */
    get enclaveOptionsInput(): LaunchTemplateEnclaveOptions | undefined;
    private _hibernationOptions;
    /**
     * @stability stable
     */
    get hibernationOptions(): LaunchTemplateHibernationOptionsOutputReference;
    /**
     * @stability stable
     */
    putHibernationOptions(value: LaunchTemplateHibernationOptions): void;
    /**
     * @stability stable
     */
    resetHibernationOptions(): void;
    /**
     * @stability stable
     */
    get hibernationOptionsInput(): LaunchTemplateHibernationOptions | undefined;
    private _iamInstanceProfile;
    /**
     * @stability stable
     */
    get iamInstanceProfile(): LaunchTemplateIamInstanceProfileOutputReference;
    /**
     * @stability stable
     */
    putIamInstanceProfile(value: LaunchTemplateIamInstanceProfile): void;
    /**
     * @stability stable
     */
    resetIamInstanceProfile(): void;
    /**
     * @stability stable
     */
    get iamInstanceProfileInput(): LaunchTemplateIamInstanceProfile | undefined;
    private _instanceMarketOptions;
    /**
     * @stability stable
     */
    get instanceMarketOptions(): LaunchTemplateInstanceMarketOptionsOutputReference;
    /**
     * @stability stable
     */
    putInstanceMarketOptions(value: LaunchTemplateInstanceMarketOptions): void;
    /**
     * @stability stable
     */
    resetInstanceMarketOptions(): void;
    /**
     * @stability stable
     */
    get instanceMarketOptionsInput(): LaunchTemplateInstanceMarketOptions | undefined;
    private _licenseSpecification?;
    /**
     * @stability stable
     */
    get licenseSpecification(): LaunchTemplateLicenseSpecification[];
    /**
     * @stability stable
     */
    set licenseSpecification(value: LaunchTemplateLicenseSpecification[]);
    /**
     * @stability stable
     */
    resetLicenseSpecification(): void;
    /**
     * @stability stable
     */
    get licenseSpecificationInput(): LaunchTemplateLicenseSpecification[] | undefined;
    private _metadataOptions;
    /**
     * @stability stable
     */
    get metadataOptions(): LaunchTemplateMetadataOptionsOutputReference;
    /**
     * @stability stable
     */
    putMetadataOptions(value: LaunchTemplateMetadataOptions): void;
    /**
     * @stability stable
     */
    resetMetadataOptions(): void;
    /**
     * @stability stable
     */
    get metadataOptionsInput(): LaunchTemplateMetadataOptions | undefined;
    private _monitoring;
    /**
     * @stability stable
     */
    get monitoring(): LaunchTemplateMonitoringOutputReference;
    /**
     * @stability stable
     */
    putMonitoring(value: LaunchTemplateMonitoring): void;
    /**
     * @stability stable
     */
    resetMonitoring(): void;
    /**
     * @stability stable
     */
    get monitoringInput(): LaunchTemplateMonitoring | undefined;
    private _networkInterfaces?;
    /**
     * @stability stable
     */
    get networkInterfaces(): LaunchTemplateNetworkInterfaces[];
    /**
     * @stability stable
     */
    set networkInterfaces(value: LaunchTemplateNetworkInterfaces[]);
    /**
     * @stability stable
     */
    resetNetworkInterfaces(): void;
    /**
     * @stability stable
     */
    get networkInterfacesInput(): LaunchTemplateNetworkInterfaces[] | undefined;
    private _placement;
    /**
     * @stability stable
     */
    get placement(): LaunchTemplatePlacementOutputReference;
    /**
     * @stability stable
     */
    putPlacement(value: LaunchTemplatePlacement): void;
    /**
     * @stability stable
     */
    resetPlacement(): void;
    /**
     * @stability stable
     */
    get placementInput(): LaunchTemplatePlacement | undefined;
    private _tagSpecifications?;
    /**
     * @stability stable
     */
    get tagSpecifications(): LaunchTemplateTagSpecifications[];
    /**
     * @stability stable
     */
    set tagSpecifications(value: LaunchTemplateTagSpecifications[]);
    /**
     * @stability stable
     */
    resetTagSpecifications(): void;
    /**
     * @stability stable
     */
    get tagSpecificationsInput(): LaunchTemplateTagSpecifications[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
