import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS EC2 Container Registry.
 *
 * @stability stable
 */
export interface DataAwsEcrImageConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ecr_image#image_digest DataAwsEcrImage#image_digest}.
     *
     * @stability stable
     */
    readonly imageDigest?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ecr_image#image_tag DataAwsEcrImage#image_tag}.
     *
     * @stability stable
     */
    readonly imageTag?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ecr_image#registry_id DataAwsEcrImage#registry_id}.
     *
     * @stability stable
     */
    readonly registryId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/ecr_image#repository_name DataAwsEcrImage#repository_name}.
     *
     * @stability stable
     */
    readonly repositoryName: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/ecr_image aws_ecr_image}.
 *
 * @stability stable
 */
export declare class DataAwsEcrImage extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/ecr_image aws_ecr_image} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsEcrImageConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _imageDigest?;
    /**
     * @stability stable
     */
    get imageDigest(): string;
    /**
     * @stability stable
     */
    set imageDigest(value: string);
    /**
     * @stability stable
     */
    resetImageDigest(): void;
    /**
     * @stability stable
     */
    get imageDigestInput(): string | undefined;
    /**
     * @stability stable
     */
    get imagePushedAt(): number;
    /**
     * @stability stable
     */
    get imageSizeInBytes(): number;
    private _imageTag?;
    /**
     * @stability stable
     */
    get imageTag(): string;
    /**
     * @stability stable
     */
    set imageTag(value: string);
    /**
     * @stability stable
     */
    resetImageTag(): void;
    /**
     * @stability stable
     */
    get imageTagInput(): string | undefined;
    /**
     * @stability stable
     */
    get imageTags(): string[];
    private _registryId?;
    /**
     * @stability stable
     */
    get registryId(): string;
    /**
     * @stability stable
     */
    set registryId(value: string);
    /**
     * @stability stable
     */
    resetRegistryId(): void;
    /**
     * @stability stable
     */
    get registryIdInput(): string | undefined;
    private _repositoryName?;
    /**
     * @stability stable
     */
    get repositoryName(): string;
    /**
     * @stability stable
     */
    set repositoryName(value: string);
    /**
     * @stability stable
     */
    get repositoryNameInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
