import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS EFS.
 *
 * @stability stable
 */
export interface DataAwsEfsAccessPointConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/efs_access_point#access_point_id DataAwsEfsAccessPoint#access_point_id}.
     *
     * @stability stable
     */
    readonly accessPointId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/efs_access_point#tags DataAwsEfsAccessPoint#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export declare class DataAwsEfsAccessPointPosixUser extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get gid(): number;
    /**
     * @stability stable
     */
    get secondaryGids(): any;
    /**
     * @stability stable
     */
    get uid(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsEfsAccessPointRootDirectoryCreationInfo extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get ownerGid(): number;
    /**
     * @stability stable
     */
    get ownerUid(): number;
    /**
     * @stability stable
     */
    get permissions(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsEfsAccessPointRootDirectory extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get creationInfo(): any;
    /**
     * @stability stable
     */
    get path(): string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/efs_access_point aws_efs_access_point}.
 *
 * @stability stable
 */
export declare class DataAwsEfsAccessPoint extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/efs_access_point aws_efs_access_point} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsEfsAccessPointConfig);
    private _accessPointId?;
    /**
     * @stability stable
     */
    get accessPointId(): string;
    /**
     * @stability stable
     */
    set accessPointId(value: string);
    /**
     * @stability stable
     */
    get accessPointIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get fileSystemArn(): string;
    /**
     * @stability stable
     */
    get fileSystemId(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    /**
     * @stability stable
     */
    posixUser(index: string): DataAwsEfsAccessPointPosixUser;
    /**
     * @stability stable
     */
    rootDirectory(index: string): DataAwsEfsAccessPointRootDirectory;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
