import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS EFS.
 *
 * @stability stable
 */
export interface DataAwsEfsFileSystemConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/efs_file_system#creation_token DataAwsEfsFileSystem#creation_token}.
     *
     * @stability stable
     */
    readonly creationToken?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/efs_file_system#file_system_id DataAwsEfsFileSystem#file_system_id}.
     *
     * @stability stable
     */
    readonly fileSystemId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/efs_file_system#tags DataAwsEfsFileSystem#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export declare class DataAwsEfsFileSystemLifecyclePolicy extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get transitionToIa(): string;
    /**
     * @stability stable
     */
    get transitionToPrimaryStorageClass(): string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/efs_file_system aws_efs_file_system}.
 *
 * @stability stable
 */
export declare class DataAwsEfsFileSystem extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/efs_file_system aws_efs_file_system} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEfsFileSystemConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get availabilityZoneId(): string;
    /**
     * @stability stable
     */
    get availabilityZoneName(): string;
    private _creationToken?;
    /**
     * @stability stable
     */
    get creationToken(): string;
    /**
     * @stability stable
     */
    set creationToken(value: string);
    /**
     * @stability stable
     */
    resetCreationToken(): void;
    /**
     * @stability stable
     */
    get creationTokenInput(): string | undefined;
    /**
     * @stability stable
     */
    get dnsName(): string;
    /**
     * @stability stable
     */
    get encrypted(): any;
    private _fileSystemId?;
    /**
     * @stability stable
     */
    get fileSystemId(): string;
    /**
     * @stability stable
     */
    set fileSystemId(value: string);
    /**
     * @stability stable
     */
    resetFileSystemId(): void;
    /**
     * @stability stable
     */
    get fileSystemIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    lifecyclePolicy(index: string): DataAwsEfsFileSystemLifecyclePolicy;
    /**
     * @stability stable
     */
    get performanceMode(): string;
    /**
     * @stability stable
     */
    get provisionedThroughputInMibps(): number;
    /**
     * @stability stable
     */
    get sizeInBytes(): number;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get throughputMode(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
