import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Elastic Kubernetes Service.
 *
 * @stability stable
 */
export interface DataAwsEksClusterConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/eks_cluster#name DataAwsEksCluster#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/eks_cluster#tags DataAwsEksCluster#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export declare class DataAwsEksClusterCertificateAuthority extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get data(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsEksClusterIdentityOidc extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get issuer(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsEksClusterIdentity extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get oidc(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsEksClusterKubernetesNetworkConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get ipFamily(): string;
    /**
     * @stability stable
     */
    get serviceIpv4Cidr(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsEksClusterVpcConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get clusterSecurityGroupId(): string;
    /**
     * @stability stable
     */
    get endpointPrivateAccess(): any;
    /**
     * @stability stable
     */
    get endpointPublicAccess(): any;
    /**
     * @stability stable
     */
    get publicAccessCidrs(): string[];
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    get vpcId(): string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/eks_cluster aws_eks_cluster}.
 *
 * @stability stable
 */
export declare class DataAwsEksCluster extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/eks_cluster aws_eks_cluster} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsEksClusterConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    certificateAuthority(index: string): DataAwsEksClusterCertificateAuthority;
    /**
     * @stability stable
     */
    get createdAt(): string;
    /**
     * @stability stable
     */
    get enabledClusterLogTypes(): string[];
    /**
     * @stability stable
     */
    get endpoint(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    identity(index: string): DataAwsEksClusterIdentity;
    /**
     * @stability stable
     */
    kubernetesNetworkConfig(index: string): DataAwsEksClusterKubernetesNetworkConfig;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get platformVersion(): string;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    get status(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    vpcConfig(index: string): DataAwsEksClusterVpcConfig;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
