import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS ElasticSearch Service.
 *
 * @stability stable
 */
export interface ElasticsearchDomainSamlOptionsConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain_saml_options#domain_name ElasticsearchDomainSamlOptions#domain_name}.
     *
     * @stability stable
     */
    readonly domainName: string;
    /**
     * saml_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain_saml_options#saml_options ElasticsearchDomainSamlOptions#saml_options}
     *
     * @stability stable
     */
    readonly samlOptions?: ElasticsearchDomainSamlOptionsSamlOptions;
}
/**
 * @stability stable
 */
export interface ElasticsearchDomainSamlOptionsSamlOptionsIdp {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain_saml_options#entity_id ElasticsearchDomainSamlOptions#entity_id}.
     *
     * @stability stable
     */
    readonly entityId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain_saml_options#metadata_content ElasticsearchDomainSamlOptions#metadata_content}.
     *
     * @stability stable
     */
    readonly metadataContent: string;
}
export declare function elasticsearchDomainSamlOptionsSamlOptionsIdpToTerraform(struct?: ElasticsearchDomainSamlOptionsSamlOptionsIdpOutputReference | ElasticsearchDomainSamlOptionsSamlOptionsIdp): any;
/**
 * @stability stable
 */
export declare class ElasticsearchDomainSamlOptionsSamlOptionsIdpOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): ElasticsearchDomainSamlOptionsSamlOptionsIdp | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: ElasticsearchDomainSamlOptionsSamlOptionsIdp | undefined);
    private _entityId?;
    /**
     * @stability stable
     */
    get entityId(): string;
    /**
     * @stability stable
     */
    set entityId(value: string);
    /**
     * @stability stable
     */
    get entityIdInput(): string | undefined;
    private _metadataContent?;
    /**
     * @stability stable
     */
    get metadataContent(): string;
    /**
     * @stability stable
     */
    set metadataContent(value: string);
    /**
     * @stability stable
     */
    get metadataContentInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface ElasticsearchDomainSamlOptionsSamlOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain_saml_options#enabled ElasticsearchDomainSamlOptions#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain_saml_options#master_backend_role ElasticsearchDomainSamlOptions#master_backend_role}.
     *
     * @stability stable
     */
    readonly masterBackendRole?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain_saml_options#master_user_name ElasticsearchDomainSamlOptions#master_user_name}.
     *
     * @stability stable
     */
    readonly masterUserName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain_saml_options#roles_key ElasticsearchDomainSamlOptions#roles_key}.
     *
     * @stability stable
     */
    readonly rolesKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain_saml_options#session_timeout_minutes ElasticsearchDomainSamlOptions#session_timeout_minutes}.
     *
     * @stability stable
     */
    readonly sessionTimeoutMinutes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain_saml_options#subject_key ElasticsearchDomainSamlOptions#subject_key}.
     *
     * @stability stable
     */
    readonly subjectKey?: string;
    /**
     * idp block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain_saml_options#idp ElasticsearchDomainSamlOptions#idp}
     *
     * @stability stable
     */
    readonly idp?: ElasticsearchDomainSamlOptionsSamlOptionsIdp;
}
export declare function elasticsearchDomainSamlOptionsSamlOptionsToTerraform(struct?: ElasticsearchDomainSamlOptionsSamlOptionsOutputReference | ElasticsearchDomainSamlOptionsSamlOptions): any;
/**
 * @stability stable
 */
export declare class ElasticsearchDomainSamlOptionsSamlOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): ElasticsearchDomainSamlOptionsSamlOptions | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: ElasticsearchDomainSamlOptionsSamlOptions | undefined);
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _masterBackendRole?;
    /**
     * @stability stable
     */
    get masterBackendRole(): string;
    /**
     * @stability stable
     */
    set masterBackendRole(value: string);
    /**
     * @stability stable
     */
    resetMasterBackendRole(): void;
    /**
     * @stability stable
     */
    get masterBackendRoleInput(): string | undefined;
    private _masterUserName?;
    /**
     * @stability stable
     */
    get masterUserName(): string;
    /**
     * @stability stable
     */
    set masterUserName(value: string);
    /**
     * @stability stable
     */
    resetMasterUserName(): void;
    /**
     * @stability stable
     */
    get masterUserNameInput(): string | undefined;
    private _rolesKey?;
    /**
     * @stability stable
     */
    get rolesKey(): string;
    /**
     * @stability stable
     */
    set rolesKey(value: string);
    /**
     * @stability stable
     */
    resetRolesKey(): void;
    /**
     * @stability stable
     */
    get rolesKeyInput(): string | undefined;
    private _sessionTimeoutMinutes?;
    /**
     * @stability stable
     */
    get sessionTimeoutMinutes(): number;
    /**
     * @stability stable
     */
    set sessionTimeoutMinutes(value: number);
    /**
     * @stability stable
     */
    resetSessionTimeoutMinutes(): void;
    /**
     * @stability stable
     */
    get sessionTimeoutMinutesInput(): number | undefined;
    private _subjectKey?;
    /**
     * @stability stable
     */
    get subjectKey(): string;
    /**
     * @stability stable
     */
    set subjectKey(value: string);
    /**
     * @stability stable
     */
    resetSubjectKey(): void;
    /**
     * @stability stable
     */
    get subjectKeyInput(): string | undefined;
    private _idp;
    /**
     * @stability stable
     */
    get idp(): ElasticsearchDomainSamlOptionsSamlOptionsIdpOutputReference;
    /**
     * @stability stable
     */
    putIdp(value: ElasticsearchDomainSamlOptionsSamlOptionsIdp): void;
    /**
     * @stability stable
     */
    resetIdp(): void;
    /**
     * @stability stable
     */
    get idpInput(): ElasticsearchDomainSamlOptionsSamlOptionsIdp | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain_saml_options aws_elasticsearch_domain_saml_options}.
 *
 * @stability stable
 */
export declare class ElasticsearchDomainSamlOptions extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/elasticsearch_domain_saml_options aws_elasticsearch_domain_saml_options} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ElasticsearchDomainSamlOptionsConfig);
    private _domainName?;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    get domainNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _samlOptions;
    /**
     * @stability stable
     */
    get samlOptions(): ElasticsearchDomainSamlOptionsSamlOptionsOutputReference;
    /**
     * @stability stable
     */
    putSamlOptions(value: ElasticsearchDomainSamlOptionsSamlOptions): void;
    /**
     * @stability stable
     */
    resetSamlOptions(): void;
    /**
     * @stability stable
     */
    get samlOptionsInput(): ElasticsearchDomainSamlOptionsSamlOptions | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
