import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Elastic Transcoder.
 *
 * @stability stable
 */
export interface ElastictranscoderPresetConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#container ElastictranscoderPreset#container}.
     *
     * @stability stable
     */
    readonly container: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#description ElastictranscoderPreset#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#name ElastictranscoderPreset#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#type ElastictranscoderPreset#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#video_codec_options ElastictranscoderPreset#video_codec_options}.
     *
     * @stability stable
     */
    readonly videoCodecOptions?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * audio block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#audio ElastictranscoderPreset#audio}
     *
     * @stability stable
     */
    readonly audio?: ElastictranscoderPresetAudio;
    /**
     * audio_codec_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#audio_codec_options ElastictranscoderPreset#audio_codec_options}
     *
     * @stability stable
     */
    readonly audioCodecOptions?: ElastictranscoderPresetAudioCodecOptions;
    /**
     * thumbnails block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#thumbnails ElastictranscoderPreset#thumbnails}
     *
     * @stability stable
     */
    readonly thumbnails?: ElastictranscoderPresetThumbnails;
    /**
     * video block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#video ElastictranscoderPreset#video}
     *
     * @stability stable
     */
    readonly video?: ElastictranscoderPresetVideo;
    /**
     * video_watermarks block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#video_watermarks ElastictranscoderPreset#video_watermarks}
     *
     * @stability stable
     */
    readonly videoWatermarks?: ElastictranscoderPresetVideoWatermarks[];
}
/**
 * @stability stable
 */
export interface ElastictranscoderPresetAudio {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#audio_packing_mode ElastictranscoderPreset#audio_packing_mode}.
     *
     * @stability stable
     */
    readonly audioPackingMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#bit_rate ElastictranscoderPreset#bit_rate}.
     *
     * @stability stable
     */
    readonly bitRate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#channels ElastictranscoderPreset#channels}.
     *
     * @stability stable
     */
    readonly channels?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#codec ElastictranscoderPreset#codec}.
     *
     * @stability stable
     */
    readonly codec?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#sample_rate ElastictranscoderPreset#sample_rate}.
     *
     * @stability stable
     */
    readonly sampleRate?: string;
}
export declare function elastictranscoderPresetAudioToTerraform(struct?: ElastictranscoderPresetAudioOutputReference | ElastictranscoderPresetAudio): any;
/**
 * @stability stable
 */
export declare class ElastictranscoderPresetAudioOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): ElastictranscoderPresetAudio | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: ElastictranscoderPresetAudio | undefined);
    private _audioPackingMode?;
    /**
     * @stability stable
     */
    get audioPackingMode(): string;
    /**
     * @stability stable
     */
    set audioPackingMode(value: string);
    /**
     * @stability stable
     */
    resetAudioPackingMode(): void;
    /**
     * @stability stable
     */
    get audioPackingModeInput(): string | undefined;
    private _bitRate?;
    /**
     * @stability stable
     */
    get bitRate(): string;
    /**
     * @stability stable
     */
    set bitRate(value: string);
    /**
     * @stability stable
     */
    resetBitRate(): void;
    /**
     * @stability stable
     */
    get bitRateInput(): string | undefined;
    private _channels?;
    /**
     * @stability stable
     */
    get channels(): string;
    /**
     * @stability stable
     */
    set channels(value: string);
    /**
     * @stability stable
     */
    resetChannels(): void;
    /**
     * @stability stable
     */
    get channelsInput(): string | undefined;
    private _codec?;
    /**
     * @stability stable
     */
    get codec(): string;
    /**
     * @stability stable
     */
    set codec(value: string);
    /**
     * @stability stable
     */
    resetCodec(): void;
    /**
     * @stability stable
     */
    get codecInput(): string | undefined;
    private _sampleRate?;
    /**
     * @stability stable
     */
    get sampleRate(): string;
    /**
     * @stability stable
     */
    set sampleRate(value: string);
    /**
     * @stability stable
     */
    resetSampleRate(): void;
    /**
     * @stability stable
     */
    get sampleRateInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface ElastictranscoderPresetAudioCodecOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#bit_depth ElastictranscoderPreset#bit_depth}.
     *
     * @stability stable
     */
    readonly bitDepth?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#bit_order ElastictranscoderPreset#bit_order}.
     *
     * @stability stable
     */
    readonly bitOrder?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#profile ElastictranscoderPreset#profile}.
     *
     * @stability stable
     */
    readonly profile?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#signed ElastictranscoderPreset#signed}.
     *
     * @stability stable
     */
    readonly signed?: string;
}
export declare function elastictranscoderPresetAudioCodecOptionsToTerraform(struct?: ElastictranscoderPresetAudioCodecOptionsOutputReference | ElastictranscoderPresetAudioCodecOptions): any;
/**
 * @stability stable
 */
export declare class ElastictranscoderPresetAudioCodecOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): ElastictranscoderPresetAudioCodecOptions | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: ElastictranscoderPresetAudioCodecOptions | undefined);
    private _bitDepth?;
    /**
     * @stability stable
     */
    get bitDepth(): string;
    /**
     * @stability stable
     */
    set bitDepth(value: string);
    /**
     * @stability stable
     */
    resetBitDepth(): void;
    /**
     * @stability stable
     */
    get bitDepthInput(): string | undefined;
    private _bitOrder?;
    /**
     * @stability stable
     */
    get bitOrder(): string;
    /**
     * @stability stable
     */
    set bitOrder(value: string);
    /**
     * @stability stable
     */
    resetBitOrder(): void;
    /**
     * @stability stable
     */
    get bitOrderInput(): string | undefined;
    private _profile?;
    /**
     * @stability stable
     */
    get profile(): string;
    /**
     * @stability stable
     */
    set profile(value: string);
    /**
     * @stability stable
     */
    resetProfile(): void;
    /**
     * @stability stable
     */
    get profileInput(): string | undefined;
    private _signed?;
    /**
     * @stability stable
     */
    get signed(): string;
    /**
     * @stability stable
     */
    set signed(value: string);
    /**
     * @stability stable
     */
    resetSigned(): void;
    /**
     * @stability stable
     */
    get signedInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface ElastictranscoderPresetThumbnails {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#aspect_ratio ElastictranscoderPreset#aspect_ratio}.
     *
     * @stability stable
     */
    readonly aspectRatio?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#format ElastictranscoderPreset#format}.
     *
     * @stability stable
     */
    readonly format?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#interval ElastictranscoderPreset#interval}.
     *
     * @stability stable
     */
    readonly interval?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#max_height ElastictranscoderPreset#max_height}.
     *
     * @stability stable
     */
    readonly maxHeight?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#max_width ElastictranscoderPreset#max_width}.
     *
     * @stability stable
     */
    readonly maxWidth?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#padding_policy ElastictranscoderPreset#padding_policy}.
     *
     * @stability stable
     */
    readonly paddingPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#resolution ElastictranscoderPreset#resolution}.
     *
     * @stability stable
     */
    readonly resolution?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#sizing_policy ElastictranscoderPreset#sizing_policy}.
     *
     * @stability stable
     */
    readonly sizingPolicy?: string;
}
export declare function elastictranscoderPresetThumbnailsToTerraform(struct?: ElastictranscoderPresetThumbnailsOutputReference | ElastictranscoderPresetThumbnails): any;
/**
 * @stability stable
 */
export declare class ElastictranscoderPresetThumbnailsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): ElastictranscoderPresetThumbnails | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: ElastictranscoderPresetThumbnails | undefined);
    private _aspectRatio?;
    /**
     * @stability stable
     */
    get aspectRatio(): string;
    /**
     * @stability stable
     */
    set aspectRatio(value: string);
    /**
     * @stability stable
     */
    resetAspectRatio(): void;
    /**
     * @stability stable
     */
    get aspectRatioInput(): string | undefined;
    private _format?;
    /**
     * @stability stable
     */
    get format(): string;
    /**
     * @stability stable
     */
    set format(value: string);
    /**
     * @stability stable
     */
    resetFormat(): void;
    /**
     * @stability stable
     */
    get formatInput(): string | undefined;
    private _interval?;
    /**
     * @stability stable
     */
    get interval(): string;
    /**
     * @stability stable
     */
    set interval(value: string);
    /**
     * @stability stable
     */
    resetInterval(): void;
    /**
     * @stability stable
     */
    get intervalInput(): string | undefined;
    private _maxHeight?;
    /**
     * @stability stable
     */
    get maxHeight(): string;
    /**
     * @stability stable
     */
    set maxHeight(value: string);
    /**
     * @stability stable
     */
    resetMaxHeight(): void;
    /**
     * @stability stable
     */
    get maxHeightInput(): string | undefined;
    private _maxWidth?;
    /**
     * @stability stable
     */
    get maxWidth(): string;
    /**
     * @stability stable
     */
    set maxWidth(value: string);
    /**
     * @stability stable
     */
    resetMaxWidth(): void;
    /**
     * @stability stable
     */
    get maxWidthInput(): string | undefined;
    private _paddingPolicy?;
    /**
     * @stability stable
     */
    get paddingPolicy(): string;
    /**
     * @stability stable
     */
    set paddingPolicy(value: string);
    /**
     * @stability stable
     */
    resetPaddingPolicy(): void;
    /**
     * @stability stable
     */
    get paddingPolicyInput(): string | undefined;
    private _resolution?;
    /**
     * @stability stable
     */
    get resolution(): string;
    /**
     * @stability stable
     */
    set resolution(value: string);
    /**
     * @stability stable
     */
    resetResolution(): void;
    /**
     * @stability stable
     */
    get resolutionInput(): string | undefined;
    private _sizingPolicy?;
    /**
     * @stability stable
     */
    get sizingPolicy(): string;
    /**
     * @stability stable
     */
    set sizingPolicy(value: string);
    /**
     * @stability stable
     */
    resetSizingPolicy(): void;
    /**
     * @stability stable
     */
    get sizingPolicyInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface ElastictranscoderPresetVideo {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#aspect_ratio ElastictranscoderPreset#aspect_ratio}.
     *
     * @stability stable
     */
    readonly aspectRatio?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#bit_rate ElastictranscoderPreset#bit_rate}.
     *
     * @stability stable
     */
    readonly bitRate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#codec ElastictranscoderPreset#codec}.
     *
     * @stability stable
     */
    readonly codec?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#display_aspect_ratio ElastictranscoderPreset#display_aspect_ratio}.
     *
     * @stability stable
     */
    readonly displayAspectRatio?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#fixed_gop ElastictranscoderPreset#fixed_gop}.
     *
     * @stability stable
     */
    readonly fixedGop?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#frame_rate ElastictranscoderPreset#frame_rate}.
     *
     * @stability stable
     */
    readonly frameRate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#keyframes_max_dist ElastictranscoderPreset#keyframes_max_dist}.
     *
     * @stability stable
     */
    readonly keyframesMaxDist?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#max_frame_rate ElastictranscoderPreset#max_frame_rate}.
     *
     * @stability stable
     */
    readonly maxFrameRate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#max_height ElastictranscoderPreset#max_height}.
     *
     * @stability stable
     */
    readonly maxHeight?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#max_width ElastictranscoderPreset#max_width}.
     *
     * @stability stable
     */
    readonly maxWidth?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#padding_policy ElastictranscoderPreset#padding_policy}.
     *
     * @stability stable
     */
    readonly paddingPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#resolution ElastictranscoderPreset#resolution}.
     *
     * @stability stable
     */
    readonly resolution?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#sizing_policy ElastictranscoderPreset#sizing_policy}.
     *
     * @stability stable
     */
    readonly sizingPolicy?: string;
}
export declare function elastictranscoderPresetVideoToTerraform(struct?: ElastictranscoderPresetVideoOutputReference | ElastictranscoderPresetVideo): any;
/**
 * @stability stable
 */
export declare class ElastictranscoderPresetVideoOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): ElastictranscoderPresetVideo | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: ElastictranscoderPresetVideo | undefined);
    private _aspectRatio?;
    /**
     * @stability stable
     */
    get aspectRatio(): string;
    /**
     * @stability stable
     */
    set aspectRatio(value: string);
    /**
     * @stability stable
     */
    resetAspectRatio(): void;
    /**
     * @stability stable
     */
    get aspectRatioInput(): string | undefined;
    private _bitRate?;
    /**
     * @stability stable
     */
    get bitRate(): string;
    /**
     * @stability stable
     */
    set bitRate(value: string);
    /**
     * @stability stable
     */
    resetBitRate(): void;
    /**
     * @stability stable
     */
    get bitRateInput(): string | undefined;
    private _codec?;
    /**
     * @stability stable
     */
    get codec(): string;
    /**
     * @stability stable
     */
    set codec(value: string);
    /**
     * @stability stable
     */
    resetCodec(): void;
    /**
     * @stability stable
     */
    get codecInput(): string | undefined;
    private _displayAspectRatio?;
    /**
     * @stability stable
     */
    get displayAspectRatio(): string;
    /**
     * @stability stable
     */
    set displayAspectRatio(value: string);
    /**
     * @stability stable
     */
    resetDisplayAspectRatio(): void;
    /**
     * @stability stable
     */
    get displayAspectRatioInput(): string | undefined;
    private _fixedGop?;
    /**
     * @stability stable
     */
    get fixedGop(): string;
    /**
     * @stability stable
     */
    set fixedGop(value: string);
    /**
     * @stability stable
     */
    resetFixedGop(): void;
    /**
     * @stability stable
     */
    get fixedGopInput(): string | undefined;
    private _frameRate?;
    /**
     * @stability stable
     */
    get frameRate(): string;
    /**
     * @stability stable
     */
    set frameRate(value: string);
    /**
     * @stability stable
     */
    resetFrameRate(): void;
    /**
     * @stability stable
     */
    get frameRateInput(): string | undefined;
    private _keyframesMaxDist?;
    /**
     * @stability stable
     */
    get keyframesMaxDist(): string;
    /**
     * @stability stable
     */
    set keyframesMaxDist(value: string);
    /**
     * @stability stable
     */
    resetKeyframesMaxDist(): void;
    /**
     * @stability stable
     */
    get keyframesMaxDistInput(): string | undefined;
    private _maxFrameRate?;
    /**
     * @stability stable
     */
    get maxFrameRate(): string;
    /**
     * @stability stable
     */
    set maxFrameRate(value: string);
    /**
     * @stability stable
     */
    resetMaxFrameRate(): void;
    /**
     * @stability stable
     */
    get maxFrameRateInput(): string | undefined;
    private _maxHeight?;
    /**
     * @stability stable
     */
    get maxHeight(): string;
    /**
     * @stability stable
     */
    set maxHeight(value: string);
    /**
     * @stability stable
     */
    resetMaxHeight(): void;
    /**
     * @stability stable
     */
    get maxHeightInput(): string | undefined;
    private _maxWidth?;
    /**
     * @stability stable
     */
    get maxWidth(): string;
    /**
     * @stability stable
     */
    set maxWidth(value: string);
    /**
     * @stability stable
     */
    resetMaxWidth(): void;
    /**
     * @stability stable
     */
    get maxWidthInput(): string | undefined;
    private _paddingPolicy?;
    /**
     * @stability stable
     */
    get paddingPolicy(): string;
    /**
     * @stability stable
     */
    set paddingPolicy(value: string);
    /**
     * @stability stable
     */
    resetPaddingPolicy(): void;
    /**
     * @stability stable
     */
    get paddingPolicyInput(): string | undefined;
    private _resolution?;
    /**
     * @stability stable
     */
    get resolution(): string;
    /**
     * @stability stable
     */
    set resolution(value: string);
    /**
     * @stability stable
     */
    resetResolution(): void;
    /**
     * @stability stable
     */
    get resolutionInput(): string | undefined;
    private _sizingPolicy?;
    /**
     * @stability stable
     */
    get sizingPolicy(): string;
    /**
     * @stability stable
     */
    set sizingPolicy(value: string);
    /**
     * @stability stable
     */
    resetSizingPolicy(): void;
    /**
     * @stability stable
     */
    get sizingPolicyInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface ElastictranscoderPresetVideoWatermarks {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#horizontal_align ElastictranscoderPreset#horizontal_align}.
     *
     * @stability stable
     */
    readonly horizontalAlign?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#horizontal_offset ElastictranscoderPreset#horizontal_offset}.
     *
     * @stability stable
     */
    readonly horizontalOffset?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#id ElastictranscoderPreset#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#max_height ElastictranscoderPreset#max_height}.
     *
     * @stability stable
     */
    readonly maxHeight?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#max_width ElastictranscoderPreset#max_width}.
     *
     * @stability stable
     */
    readonly maxWidth?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#opacity ElastictranscoderPreset#opacity}.
     *
     * @stability stable
     */
    readonly opacity?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#sizing_policy ElastictranscoderPreset#sizing_policy}.
     *
     * @stability stable
     */
    readonly sizingPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#target ElastictranscoderPreset#target}.
     *
     * @stability stable
     */
    readonly target?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#vertical_align ElastictranscoderPreset#vertical_align}.
     *
     * @stability stable
     */
    readonly verticalAlign?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset#vertical_offset ElastictranscoderPreset#vertical_offset}.
     *
     * @stability stable
     */
    readonly verticalOffset?: string;
}
export declare function elastictranscoderPresetVideoWatermarksToTerraform(struct?: ElastictranscoderPresetVideoWatermarks): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset aws_elastictranscoder_preset}.
 *
 * @stability stable
 */
export declare class ElastictranscoderPreset extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset aws_elastictranscoder_preset} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ElastictranscoderPresetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _container?;
    /**
     * @stability stable
     */
    get container(): string;
    /**
     * @stability stable
     */
    set container(value: string);
    /**
     * @stability stable
     */
    get containerInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _videoCodecOptions?;
    /**
     * @stability stable
     */
    get videoCodecOptions(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set videoCodecOptions(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetVideoCodecOptions(): void;
    /**
     * @stability stable
     */
    get videoCodecOptionsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _audio;
    /**
     * @stability stable
     */
    get audio(): ElastictranscoderPresetAudioOutputReference;
    /**
     * @stability stable
     */
    putAudio(value: ElastictranscoderPresetAudio): void;
    /**
     * @stability stable
     */
    resetAudio(): void;
    /**
     * @stability stable
     */
    get audioInput(): ElastictranscoderPresetAudio | undefined;
    private _audioCodecOptions;
    /**
     * @stability stable
     */
    get audioCodecOptions(): ElastictranscoderPresetAudioCodecOptionsOutputReference;
    /**
     * @stability stable
     */
    putAudioCodecOptions(value: ElastictranscoderPresetAudioCodecOptions): void;
    /**
     * @stability stable
     */
    resetAudioCodecOptions(): void;
    /**
     * @stability stable
     */
    get audioCodecOptionsInput(): ElastictranscoderPresetAudioCodecOptions | undefined;
    private _thumbnails;
    /**
     * @stability stable
     */
    get thumbnails(): ElastictranscoderPresetThumbnailsOutputReference;
    /**
     * @stability stable
     */
    putThumbnails(value: ElastictranscoderPresetThumbnails): void;
    /**
     * @stability stable
     */
    resetThumbnails(): void;
    /**
     * @stability stable
     */
    get thumbnailsInput(): ElastictranscoderPresetThumbnails | undefined;
    private _video;
    /**
     * @stability stable
     */
    get video(): ElastictranscoderPresetVideoOutputReference;
    /**
     * @stability stable
     */
    putVideo(value: ElastictranscoderPresetVideo): void;
    /**
     * @stability stable
     */
    resetVideo(): void;
    /**
     * @stability stable
     */
    get videoInput(): ElastictranscoderPresetVideo | undefined;
    private _videoWatermarks?;
    /**
     * @stability stable
     */
    get videoWatermarks(): ElastictranscoderPresetVideoWatermarks[];
    /**
     * @stability stable
     */
    set videoWatermarks(value: ElastictranscoderPresetVideoWatermarks[]);
    /**
     * @stability stable
     */
    resetVideoWatermarks(): void;
    /**
     * @stability stable
     */
    get videoWatermarksInput(): ElastictranscoderPresetVideoWatermarks[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
