import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Elastic Load Balancer.
 *
 * @stability stable
 */
export interface DataAwsAlbConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/alb#name DataAwsAlb#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/alb#tags DataAwsAlb#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export declare class DataAwsAlbAccessLogs extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get bucket(): string;
    /**
     * @stability stable
     */
    get enabled(): any;
    /**
     * @stability stable
     */
    get prefix(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsAlbSubnetMapping extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get allocationId(): string;
    /**
     * @stability stable
     */
    get ipv6Address(): string;
    /**
     * @stability stable
     */
    get outpostId(): string;
    /**
     * @stability stable
     */
    get privateIpv4Address(): string;
    /**
     * @stability stable
     */
    get subnetId(): string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/alb aws_alb}.
 *
 * @stability stable
 */
export declare class DataAwsAlb extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/alb aws_alb} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsAlbConfig);
    /**
     * @stability stable
     */
    accessLogs(index: string): DataAwsAlbAccessLogs;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get arnSuffix(): string;
    /**
     * @stability stable
     */
    get customerOwnedIpv4Pool(): string;
    /**
     * @stability stable
     */
    get desyncMitigationMode(): string;
    /**
     * @stability stable
     */
    get dnsName(): string;
    /**
     * @stability stable
     */
    get dropInvalidHeaderFields(): any;
    /**
     * @stability stable
     */
    get enableDeletionProtection(): any;
    /**
     * @stability stable
     */
    get enableHttp2(): any;
    /**
     * @stability stable
     */
    get enableWafFailOpen(): any;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get idleTimeout(): number;
    /**
     * @stability stable
     */
    get internal(): any;
    /**
     * @stability stable
     */
    get ipAddressType(): string;
    /**
     * @stability stable
     */
    get loadBalancerType(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get securityGroups(): string[];
    /**
     * @stability stable
     */
    subnetMapping(index: string): DataAwsAlbSubnetMapping;
    /**
     * @stability stable
     */
    get subnets(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    get zoneId(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
