import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Elastic Load Balancer.
 *
 * @stability stable
 */
export interface LbSslNegotiationPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_ssl_negotiation_policy#lb_port LbSslNegotiationPolicy#lb_port}.
     *
     * @stability stable
     */
    readonly lbPort: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_ssl_negotiation_policy#load_balancer LbSslNegotiationPolicy#load_balancer}.
     *
     * @stability stable
     */
    readonly loadBalancer: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_ssl_negotiation_policy#name LbSslNegotiationPolicy#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * attribute block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_ssl_negotiation_policy#attribute LbSslNegotiationPolicy#attribute}
     *
     * @stability stable
     */
    readonly attribute?: LbSslNegotiationPolicyAttribute[];
}
/**
 * @stability stable
 */
export interface LbSslNegotiationPolicyAttribute {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_ssl_negotiation_policy#name LbSslNegotiationPolicy#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_ssl_negotiation_policy#value LbSslNegotiationPolicy#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function lbSslNegotiationPolicyAttributeToTerraform(struct?: LbSslNegotiationPolicyAttribute): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/lb_ssl_negotiation_policy aws_lb_ssl_negotiation_policy}.
 *
 * @stability stable
 */
export declare class LbSslNegotiationPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/lb_ssl_negotiation_policy aws_lb_ssl_negotiation_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LbSslNegotiationPolicyConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _lbPort?;
    /**
     * @stability stable
     */
    get lbPort(): number;
    /**
     * @stability stable
     */
    set lbPort(value: number);
    /**
     * @stability stable
     */
    get lbPortInput(): number | undefined;
    private _loadBalancer?;
    /**
     * @stability stable
     */
    get loadBalancer(): string;
    /**
     * @stability stable
     */
    set loadBalancer(value: string);
    /**
     * @stability stable
     */
    get loadBalancerInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _attribute?;
    /**
     * @stability stable
     */
    get attribute(): LbSslNegotiationPolicyAttribute[];
    /**
     * @stability stable
     */
    set attribute(value: LbSslNegotiationPolicyAttribute[]);
    /**
     * @stability stable
     */
    resetAttribute(): void;
    /**
     * @stability stable
     */
    get attributeInput(): LbSslNegotiationPolicyAttribute[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
