import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Elastic Load Balancer.
 *
 * @stability stable
 */
export interface LoadBalancerPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/load_balancer_policy#load_balancer_name LoadBalancerPolicy#load_balancer_name}.
     *
     * @stability stable
     */
    readonly loadBalancerName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/load_balancer_policy#policy_name LoadBalancerPolicy#policy_name}.
     *
     * @stability stable
     */
    readonly policyName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/load_balancer_policy#policy_type_name LoadBalancerPolicy#policy_type_name}.
     *
     * @stability stable
     */
    readonly policyTypeName: string;
    /**
     * policy_attribute block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/load_balancer_policy#policy_attribute LoadBalancerPolicy#policy_attribute}
     *
     * @stability stable
     */
    readonly policyAttribute?: LoadBalancerPolicyPolicyAttribute[];
}
/**
 * @stability stable
 */
export interface LoadBalancerPolicyPolicyAttribute {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/load_balancer_policy#name LoadBalancerPolicy#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/load_balancer_policy#value LoadBalancerPolicy#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
export declare function loadBalancerPolicyPolicyAttributeToTerraform(struct?: LoadBalancerPolicyPolicyAttribute): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/load_balancer_policy aws_load_balancer_policy}.
 *
 * @stability stable
 */
export declare class LoadBalancerPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/load_balancer_policy aws_load_balancer_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LoadBalancerPolicyConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _loadBalancerName?;
    /**
     * @stability stable
     */
    get loadBalancerName(): string;
    /**
     * @stability stable
     */
    set loadBalancerName(value: string);
    /**
     * @stability stable
     */
    get loadBalancerNameInput(): string | undefined;
    private _policyName?;
    /**
     * @stability stable
     */
    get policyName(): string;
    /**
     * @stability stable
     */
    set policyName(value: string);
    /**
     * @stability stable
     */
    get policyNameInput(): string | undefined;
    private _policyTypeName?;
    /**
     * @stability stable
     */
    get policyTypeName(): string;
    /**
     * @stability stable
     */
    set policyTypeName(value: string);
    /**
     * @stability stable
     */
    get policyTypeNameInput(): string | undefined;
    private _policyAttribute?;
    /**
     * @stability stable
     */
    get policyAttribute(): LoadBalancerPolicyPolicyAttribute[];
    /**
     * @stability stable
     */
    set policyAttribute(value: LoadBalancerPolicyPolicyAttribute[]);
    /**
     * @stability stable
     */
    resetPolicyAttribute(): void;
    /**
     * @stability stable
     */
    get policyAttributeInput(): LoadBalancerPolicyPolicyAttribute[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
