import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Elastic MapReduce.
 *
 * @stability stable
 */
export interface EmrStudioSessionMappingConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_studio_session_mapping#identity_id EmrStudioSessionMapping#identity_id}.
     *
     * @stability stable
     */
    readonly identityId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_studio_session_mapping#identity_name EmrStudioSessionMapping#identity_name}.
     *
     * @stability stable
     */
    readonly identityName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_studio_session_mapping#identity_type EmrStudioSessionMapping#identity_type}.
     *
     * @stability stable
     */
    readonly identityType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_studio_session_mapping#session_policy_arn EmrStudioSessionMapping#session_policy_arn}.
     *
     * @stability stable
     */
    readonly sessionPolicyArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/emr_studio_session_mapping#studio_id EmrStudioSessionMapping#studio_id}.
     *
     * @stability stable
     */
    readonly studioId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/emr_studio_session_mapping aws_emr_studio_session_mapping}.
 *
 * @stability stable
 */
export declare class EmrStudioSessionMapping extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/emr_studio_session_mapping aws_emr_studio_session_mapping} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EmrStudioSessionMappingConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _identityId?;
    /**
     * @stability stable
     */
    get identityId(): string;
    /**
     * @stability stable
     */
    set identityId(value: string);
    /**
     * @stability stable
     */
    resetIdentityId(): void;
    /**
     * @stability stable
     */
    get identityIdInput(): string | undefined;
    private _identityName?;
    /**
     * @stability stable
     */
    get identityName(): string;
    /**
     * @stability stable
     */
    set identityName(value: string);
    /**
     * @stability stable
     */
    resetIdentityName(): void;
    /**
     * @stability stable
     */
    get identityNameInput(): string | undefined;
    private _identityType?;
    /**
     * @stability stable
     */
    get identityType(): string;
    /**
     * @stability stable
     */
    set identityType(value: string);
    /**
     * @stability stable
     */
    get identityTypeInput(): string | undefined;
    private _sessionPolicyArn?;
    /**
     * @stability stable
     */
    get sessionPolicyArn(): string;
    /**
     * @stability stable
     */
    set sessionPolicyArn(value: string);
    /**
     * @stability stable
     */
    get sessionPolicyArnInput(): string | undefined;
    private _studioId?;
    /**
     * @stability stable
     */
    get studioId(): string;
    /**
     * @stability stable
     */
    set studioId(value: string);
    /**
     * @stability stable
     */
    get studioIdInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
