import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS File System FSx.
 *
 * @stability stable
 */
export interface FsxOpenzfsVolumeConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#copy_tags_to_snapshots FsxOpenzfsVolume#copy_tags_to_snapshots}.
     *
     * @stability stable
     */
    readonly copyTagsToSnapshots?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#data_compression_type FsxOpenzfsVolume#data_compression_type}.
     *
     * @stability stable
     */
    readonly dataCompressionType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#name FsxOpenzfsVolume#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#parent_volume_id FsxOpenzfsVolume#parent_volume_id}.
     *
     * @stability stable
     */
    readonly parentVolumeId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#read_only FsxOpenzfsVolume#read_only}.
     *
     * @stability stable
     */
    readonly readOnly?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#storage_capacity_quota_gib FsxOpenzfsVolume#storage_capacity_quota_gib}.
     *
     * @stability stable
     */
    readonly storageCapacityQuotaGib?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#storage_capacity_reservation_gib FsxOpenzfsVolume#storage_capacity_reservation_gib}.
     *
     * @stability stable
     */
    readonly storageCapacityReservationGib?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#tags FsxOpenzfsVolume#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#tags_all FsxOpenzfsVolume#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#volume_type FsxOpenzfsVolume#volume_type}.
     *
     * @stability stable
     */
    readonly volumeType?: string;
    /**
     * nfs_exports block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#nfs_exports FsxOpenzfsVolume#nfs_exports}
     *
     * @stability stable
     */
    readonly nfsExports?: FsxOpenzfsVolumeNfsExports;
    /**
     * origin_snapshot block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#origin_snapshot FsxOpenzfsVolume#origin_snapshot}
     *
     * @stability stable
     */
    readonly originSnapshot?: FsxOpenzfsVolumeOriginSnapshot;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#timeouts FsxOpenzfsVolume#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: FsxOpenzfsVolumeTimeouts;
    /**
     * user_and_group_quotas block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#user_and_group_quotas FsxOpenzfsVolume#user_and_group_quotas}
     *
     * @stability stable
     */
    readonly userAndGroupQuotas?: FsxOpenzfsVolumeUserAndGroupQuotas[];
}
/**
 * @stability stable
 */
export interface FsxOpenzfsVolumeNfsExportsClientConfigurations {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#clients FsxOpenzfsVolume#clients}.
     *
     * @stability stable
     */
    readonly clients: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#options FsxOpenzfsVolume#options}.
     *
     * @stability stable
     */
    readonly options: string[];
}
export declare function fsxOpenzfsVolumeNfsExportsClientConfigurationsToTerraform(struct?: FsxOpenzfsVolumeNfsExportsClientConfigurations): any;
/**
 * @stability stable
 */
export interface FsxOpenzfsVolumeNfsExports {
    /**
     * client_configurations block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#client_configurations FsxOpenzfsVolume#client_configurations}
     *
     * @stability stable
     */
    readonly clientConfigurations: FsxOpenzfsVolumeNfsExportsClientConfigurations[];
}
export declare function fsxOpenzfsVolumeNfsExportsToTerraform(struct?: FsxOpenzfsVolumeNfsExportsOutputReference | FsxOpenzfsVolumeNfsExports): any;
/**
 * @stability stable
 */
export declare class FsxOpenzfsVolumeNfsExportsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): FsxOpenzfsVolumeNfsExports | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: FsxOpenzfsVolumeNfsExports | undefined);
    private _clientConfigurations?;
    /**
     * @stability stable
     */
    get clientConfigurations(): FsxOpenzfsVolumeNfsExportsClientConfigurations[];
    /**
     * @stability stable
     */
    set clientConfigurations(value: FsxOpenzfsVolumeNfsExportsClientConfigurations[]);
    /**
     * @stability stable
     */
    get clientConfigurationsInput(): FsxOpenzfsVolumeNfsExportsClientConfigurations[] | undefined;
}
/**
 * @stability stable
 */
export interface FsxOpenzfsVolumeOriginSnapshot {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#copy_strategy FsxOpenzfsVolume#copy_strategy}.
     *
     * @stability stable
     */
    readonly copyStrategy: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#snapshot_arn FsxOpenzfsVolume#snapshot_arn}.
     *
     * @stability stable
     */
    readonly snapshotArn: string;
}
export declare function fsxOpenzfsVolumeOriginSnapshotToTerraform(struct?: FsxOpenzfsVolumeOriginSnapshotOutputReference | FsxOpenzfsVolumeOriginSnapshot): any;
/**
 * @stability stable
 */
export declare class FsxOpenzfsVolumeOriginSnapshotOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): FsxOpenzfsVolumeOriginSnapshot | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: FsxOpenzfsVolumeOriginSnapshot | undefined);
    private _copyStrategy?;
    /**
     * @stability stable
     */
    get copyStrategy(): string;
    /**
     * @stability stable
     */
    set copyStrategy(value: string);
    /**
     * @stability stable
     */
    get copyStrategyInput(): string | undefined;
    private _snapshotArn?;
    /**
     * @stability stable
     */
    get snapshotArn(): string;
    /**
     * @stability stable
     */
    set snapshotArn(value: string);
    /**
     * @stability stable
     */
    get snapshotArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface FsxOpenzfsVolumeTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#create FsxOpenzfsVolume#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#delete FsxOpenzfsVolume#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#update FsxOpenzfsVolume#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function fsxOpenzfsVolumeTimeoutsToTerraform(struct?: FsxOpenzfsVolumeTimeoutsOutputReference | FsxOpenzfsVolumeTimeouts): any;
/**
 * @stability stable
 */
export declare class FsxOpenzfsVolumeTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): FsxOpenzfsVolumeTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: FsxOpenzfsVolumeTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface FsxOpenzfsVolumeUserAndGroupQuotas {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#id FsxOpenzfsVolume#id}.
     *
     * @stability stable
     */
    readonly id: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#storage_capacity_quota_gib FsxOpenzfsVolume#storage_capacity_quota_gib}.
     *
     * @stability stable
     */
    readonly storageCapacityQuotaGib: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume#type FsxOpenzfsVolume#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
export declare function fsxOpenzfsVolumeUserAndGroupQuotasToTerraform(struct?: FsxOpenzfsVolumeUserAndGroupQuotas): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume aws_fsx_openzfs_volume}.
 *
 * @stability stable
 */
export declare class FsxOpenzfsVolume extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/fsx_openzfs_volume aws_fsx_openzfs_volume} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: FsxOpenzfsVolumeConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _copyTagsToSnapshots?;
    /**
     * @stability stable
     */
    get copyTagsToSnapshots(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set copyTagsToSnapshots(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetCopyTagsToSnapshots(): void;
    /**
     * @stability stable
     */
    get copyTagsToSnapshotsInput(): boolean | cdktf.IResolvable | undefined;
    private _dataCompressionType?;
    /**
     * @stability stable
     */
    get dataCompressionType(): string;
    /**
     * @stability stable
     */
    set dataCompressionType(value: string);
    /**
     * @stability stable
     */
    resetDataCompressionType(): void;
    /**
     * @stability stable
     */
    get dataCompressionTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _parentVolumeId?;
    /**
     * @stability stable
     */
    get parentVolumeId(): string;
    /**
     * @stability stable
     */
    set parentVolumeId(value: string);
    /**
     * @stability stable
     */
    get parentVolumeIdInput(): string | undefined;
    private _readOnly?;
    /**
     * @stability stable
     */
    get readOnly(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set readOnly(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetReadOnly(): void;
    /**
     * @stability stable
     */
    get readOnlyInput(): boolean | cdktf.IResolvable | undefined;
    private _storageCapacityQuotaGib?;
    /**
     * @stability stable
     */
    get storageCapacityQuotaGib(): number;
    /**
     * @stability stable
     */
    set storageCapacityQuotaGib(value: number);
    /**
     * @stability stable
     */
    resetStorageCapacityQuotaGib(): void;
    /**
     * @stability stable
     */
    get storageCapacityQuotaGibInput(): number | undefined;
    private _storageCapacityReservationGib?;
    /**
     * @stability stable
     */
    get storageCapacityReservationGib(): number;
    /**
     * @stability stable
     */
    set storageCapacityReservationGib(value: number);
    /**
     * @stability stable
     */
    resetStorageCapacityReservationGib(): void;
    /**
     * @stability stable
     */
    get storageCapacityReservationGibInput(): number | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _volumeType?;
    /**
     * @stability stable
     */
    get volumeType(): string;
    /**
     * @stability stable
     */
    set volumeType(value: string);
    /**
     * @stability stable
     */
    resetVolumeType(): void;
    /**
     * @stability stable
     */
    get volumeTypeInput(): string | undefined;
    private _nfsExports;
    /**
     * @stability stable
     */
    get nfsExports(): FsxOpenzfsVolumeNfsExportsOutputReference;
    /**
     * @stability stable
     */
    putNfsExports(value: FsxOpenzfsVolumeNfsExports): void;
    /**
     * @stability stable
     */
    resetNfsExports(): void;
    /**
     * @stability stable
     */
    get nfsExportsInput(): FsxOpenzfsVolumeNfsExports | undefined;
    private _originSnapshot;
    /**
     * @stability stable
     */
    get originSnapshot(): FsxOpenzfsVolumeOriginSnapshotOutputReference;
    /**
     * @stability stable
     */
    putOriginSnapshot(value: FsxOpenzfsVolumeOriginSnapshot): void;
    /**
     * @stability stable
     */
    resetOriginSnapshot(): void;
    /**
     * @stability stable
     */
    get originSnapshotInput(): FsxOpenzfsVolumeOriginSnapshot | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): FsxOpenzfsVolumeTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: FsxOpenzfsVolumeTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): FsxOpenzfsVolumeTimeouts | undefined;
    private _userAndGroupQuotas?;
    /**
     * @stability stable
     */
    get userAndGroupQuotas(): FsxOpenzfsVolumeUserAndGroupQuotas[];
    /**
     * @stability stable
     */
    set userAndGroupQuotas(value: FsxOpenzfsVolumeUserAndGroupQuotas[]);
    /**
     * @stability stable
     */
    resetUserAndGroupQuotas(): void;
    /**
     * @stability stable
     */
    get userAndGroupQuotasInput(): FsxOpenzfsVolumeUserAndGroupQuotas[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
