import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS File System FSx.
 *
 * @stability stable
 */
export interface FsxWindowsFileSystemConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#active_directory_id FsxWindowsFileSystem#active_directory_id}.
     *
     * @stability stable
     */
    readonly activeDirectoryId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#aliases FsxWindowsFileSystem#aliases}.
     *
     * @stability stable
     */
    readonly aliases?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#automatic_backup_retention_days FsxWindowsFileSystem#automatic_backup_retention_days}.
     *
     * @stability stable
     */
    readonly automaticBackupRetentionDays?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#backup_id FsxWindowsFileSystem#backup_id}.
     *
     * @stability stable
     */
    readonly backupId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#copy_tags_to_backups FsxWindowsFileSystem#copy_tags_to_backups}.
     *
     * @stability stable
     */
    readonly copyTagsToBackups?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#daily_automatic_backup_start_time FsxWindowsFileSystem#daily_automatic_backup_start_time}.
     *
     * @stability stable
     */
    readonly dailyAutomaticBackupStartTime?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#deployment_type FsxWindowsFileSystem#deployment_type}.
     *
     * @stability stable
     */
    readonly deploymentType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#kms_key_id FsxWindowsFileSystem#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#preferred_subnet_id FsxWindowsFileSystem#preferred_subnet_id}.
     *
     * @stability stable
     */
    readonly preferredSubnetId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#security_group_ids FsxWindowsFileSystem#security_group_ids}.
     *
     * @stability stable
     */
    readonly securityGroupIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#skip_final_backup FsxWindowsFileSystem#skip_final_backup}.
     *
     * @stability stable
     */
    readonly skipFinalBackup?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#storage_capacity FsxWindowsFileSystem#storage_capacity}.
     *
     * @stability stable
     */
    readonly storageCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#storage_type FsxWindowsFileSystem#storage_type}.
     *
     * @stability stable
     */
    readonly storageType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#subnet_ids FsxWindowsFileSystem#subnet_ids}.
     *
     * @stability stable
     */
    readonly subnetIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#tags FsxWindowsFileSystem#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#tags_all FsxWindowsFileSystem#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#throughput_capacity FsxWindowsFileSystem#throughput_capacity}.
     *
     * @stability stable
     */
    readonly throughputCapacity: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#weekly_maintenance_start_time FsxWindowsFileSystem#weekly_maintenance_start_time}.
     *
     * @stability stable
     */
    readonly weeklyMaintenanceStartTime?: string;
    /**
     * audit_log_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#audit_log_configuration FsxWindowsFileSystem#audit_log_configuration}
     *
     * @stability stable
     */
    readonly auditLogConfiguration?: FsxWindowsFileSystemAuditLogConfiguration;
    /**
     * self_managed_active_directory block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#self_managed_active_directory FsxWindowsFileSystem#self_managed_active_directory}
     *
     * @stability stable
     */
    readonly selfManagedActiveDirectory?: FsxWindowsFileSystemSelfManagedActiveDirectory;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#timeouts FsxWindowsFileSystem#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: FsxWindowsFileSystemTimeouts;
}
/**
 * @stability stable
 */
export interface FsxWindowsFileSystemAuditLogConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#audit_log_destination FsxWindowsFileSystem#audit_log_destination}.
     *
     * @stability stable
     */
    readonly auditLogDestination?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#file_access_audit_log_level FsxWindowsFileSystem#file_access_audit_log_level}.
     *
     * @stability stable
     */
    readonly fileAccessAuditLogLevel?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#file_share_access_audit_log_level FsxWindowsFileSystem#file_share_access_audit_log_level}.
     *
     * @stability stable
     */
    readonly fileShareAccessAuditLogLevel?: string;
}
export declare function fsxWindowsFileSystemAuditLogConfigurationToTerraform(struct?: FsxWindowsFileSystemAuditLogConfigurationOutputReference | FsxWindowsFileSystemAuditLogConfiguration): any;
/**
 * @stability stable
 */
export declare class FsxWindowsFileSystemAuditLogConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): FsxWindowsFileSystemAuditLogConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: FsxWindowsFileSystemAuditLogConfiguration | undefined);
    private _auditLogDestination?;
    /**
     * @stability stable
     */
    get auditLogDestination(): string;
    /**
     * @stability stable
     */
    set auditLogDestination(value: string);
    /**
     * @stability stable
     */
    resetAuditLogDestination(): void;
    /**
     * @stability stable
     */
    get auditLogDestinationInput(): string | undefined;
    private _fileAccessAuditLogLevel?;
    /**
     * @stability stable
     */
    get fileAccessAuditLogLevel(): string;
    /**
     * @stability stable
     */
    set fileAccessAuditLogLevel(value: string);
    /**
     * @stability stable
     */
    resetFileAccessAuditLogLevel(): void;
    /**
     * @stability stable
     */
    get fileAccessAuditLogLevelInput(): string | undefined;
    private _fileShareAccessAuditLogLevel?;
    /**
     * @stability stable
     */
    get fileShareAccessAuditLogLevel(): string;
    /**
     * @stability stable
     */
    set fileShareAccessAuditLogLevel(value: string);
    /**
     * @stability stable
     */
    resetFileShareAccessAuditLogLevel(): void;
    /**
     * @stability stable
     */
    get fileShareAccessAuditLogLevelInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface FsxWindowsFileSystemSelfManagedActiveDirectory {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#dns_ips FsxWindowsFileSystem#dns_ips}.
     *
     * @stability stable
     */
    readonly dnsIps: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#domain_name FsxWindowsFileSystem#domain_name}.
     *
     * @stability stable
     */
    readonly domainName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#file_system_administrators_group FsxWindowsFileSystem#file_system_administrators_group}.
     *
     * @stability stable
     */
    readonly fileSystemAdministratorsGroup?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#organizational_unit_distinguished_name FsxWindowsFileSystem#organizational_unit_distinguished_name}.
     *
     * @stability stable
     */
    readonly organizationalUnitDistinguishedName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#password FsxWindowsFileSystem#password}.
     *
     * @stability stable
     */
    readonly password: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#username FsxWindowsFileSystem#username}.
     *
     * @stability stable
     */
    readonly username: string;
}
export declare function fsxWindowsFileSystemSelfManagedActiveDirectoryToTerraform(struct?: FsxWindowsFileSystemSelfManagedActiveDirectoryOutputReference | FsxWindowsFileSystemSelfManagedActiveDirectory): any;
/**
 * @stability stable
 */
export declare class FsxWindowsFileSystemSelfManagedActiveDirectoryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): FsxWindowsFileSystemSelfManagedActiveDirectory | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: FsxWindowsFileSystemSelfManagedActiveDirectory | undefined);
    private _dnsIps?;
    /**
     * @stability stable
     */
    get dnsIps(): string[];
    /**
     * @stability stable
     */
    set dnsIps(value: string[]);
    /**
     * @stability stable
     */
    get dnsIpsInput(): string[] | undefined;
    private _domainName?;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    get domainNameInput(): string | undefined;
    private _fileSystemAdministratorsGroup?;
    /**
     * @stability stable
     */
    get fileSystemAdministratorsGroup(): string;
    /**
     * @stability stable
     */
    set fileSystemAdministratorsGroup(value: string);
    /**
     * @stability stable
     */
    resetFileSystemAdministratorsGroup(): void;
    /**
     * @stability stable
     */
    get fileSystemAdministratorsGroupInput(): string | undefined;
    private _organizationalUnitDistinguishedName?;
    /**
     * @stability stable
     */
    get organizationalUnitDistinguishedName(): string;
    /**
     * @stability stable
     */
    set organizationalUnitDistinguishedName(value: string);
    /**
     * @stability stable
     */
    resetOrganizationalUnitDistinguishedName(): void;
    /**
     * @stability stable
     */
    get organizationalUnitDistinguishedNameInput(): string | undefined;
    private _password?;
    /**
     * @stability stable
     */
    get password(): string;
    /**
     * @stability stable
     */
    set password(value: string);
    /**
     * @stability stable
     */
    get passwordInput(): string | undefined;
    private _username?;
    /**
     * @stability stable
     */
    get username(): string;
    /**
     * @stability stable
     */
    set username(value: string);
    /**
     * @stability stable
     */
    get usernameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface FsxWindowsFileSystemTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#create FsxWindowsFileSystem#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#delete FsxWindowsFileSystem#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system#update FsxWindowsFileSystem#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function fsxWindowsFileSystemTimeoutsToTerraform(struct?: FsxWindowsFileSystemTimeoutsOutputReference | FsxWindowsFileSystemTimeouts): any;
/**
 * @stability stable
 */
export declare class FsxWindowsFileSystemTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): FsxWindowsFileSystemTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: FsxWindowsFileSystemTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system aws_fsx_windows_file_system}.
 *
 * @stability stable
 */
export declare class FsxWindowsFileSystem extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/fsx_windows_file_system aws_fsx_windows_file_system} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: FsxWindowsFileSystemConfig);
    private _activeDirectoryId?;
    /**
     * @stability stable
     */
    get activeDirectoryId(): string;
    /**
     * @stability stable
     */
    set activeDirectoryId(value: string);
    /**
     * @stability stable
     */
    resetActiveDirectoryId(): void;
    /**
     * @stability stable
     */
    get activeDirectoryIdInput(): string | undefined;
    private _aliases?;
    /**
     * @stability stable
     */
    get aliases(): string[];
    /**
     * @stability stable
     */
    set aliases(value: string[]);
    /**
     * @stability stable
     */
    resetAliases(): void;
    /**
     * @stability stable
     */
    get aliasesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _automaticBackupRetentionDays?;
    /**
     * @stability stable
     */
    get automaticBackupRetentionDays(): number;
    /**
     * @stability stable
     */
    set automaticBackupRetentionDays(value: number);
    /**
     * @stability stable
     */
    resetAutomaticBackupRetentionDays(): void;
    /**
     * @stability stable
     */
    get automaticBackupRetentionDaysInput(): number | undefined;
    private _backupId?;
    /**
     * @stability stable
     */
    get backupId(): string;
    /**
     * @stability stable
     */
    set backupId(value: string);
    /**
     * @stability stable
     */
    resetBackupId(): void;
    /**
     * @stability stable
     */
    get backupIdInput(): string | undefined;
    private _copyTagsToBackups?;
    /**
     * @stability stable
     */
    get copyTagsToBackups(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set copyTagsToBackups(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetCopyTagsToBackups(): void;
    /**
     * @stability stable
     */
    get copyTagsToBackupsInput(): boolean | cdktf.IResolvable | undefined;
    private _dailyAutomaticBackupStartTime?;
    /**
     * @stability stable
     */
    get dailyAutomaticBackupStartTime(): string;
    /**
     * @stability stable
     */
    set dailyAutomaticBackupStartTime(value: string);
    /**
     * @stability stable
     */
    resetDailyAutomaticBackupStartTime(): void;
    /**
     * @stability stable
     */
    get dailyAutomaticBackupStartTimeInput(): string | undefined;
    private _deploymentType?;
    /**
     * @stability stable
     */
    get deploymentType(): string;
    /**
     * @stability stable
     */
    set deploymentType(value: string);
    /**
     * @stability stable
     */
    resetDeploymentType(): void;
    /**
     * @stability stable
     */
    get deploymentTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get dnsName(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get networkInterfaceIds(): string[];
    /**
     * @stability stable
     */
    get ownerId(): string;
    /**
     * @stability stable
     */
    get preferredFileServerIp(): string;
    private _preferredSubnetId?;
    /**
     * @stability stable
     */
    get preferredSubnetId(): string;
    /**
     * @stability stable
     */
    set preferredSubnetId(value: string);
    /**
     * @stability stable
     */
    resetPreferredSubnetId(): void;
    /**
     * @stability stable
     */
    get preferredSubnetIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get remoteAdministrationEndpoint(): string;
    private _securityGroupIds?;
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    set securityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get securityGroupIdsInput(): string[] | undefined;
    private _skipFinalBackup?;
    /**
     * @stability stable
     */
    get skipFinalBackup(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set skipFinalBackup(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSkipFinalBackup(): void;
    /**
     * @stability stable
     */
    get skipFinalBackupInput(): boolean | cdktf.IResolvable | undefined;
    private _storageCapacity?;
    /**
     * @stability stable
     */
    get storageCapacity(): number;
    /**
     * @stability stable
     */
    set storageCapacity(value: number);
    /**
     * @stability stable
     */
    resetStorageCapacity(): void;
    /**
     * @stability stable
     */
    get storageCapacityInput(): number | undefined;
    private _storageType?;
    /**
     * @stability stable
     */
    get storageType(): string;
    /**
     * @stability stable
     */
    set storageType(value: string);
    /**
     * @stability stable
     */
    resetStorageType(): void;
    /**
     * @stability stable
     */
    get storageTypeInput(): string | undefined;
    private _subnetIds?;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _throughputCapacity?;
    /**
     * @stability stable
     */
    get throughputCapacity(): number;
    /**
     * @stability stable
     */
    set throughputCapacity(value: number);
    /**
     * @stability stable
     */
    get throughputCapacityInput(): number | undefined;
    /**
     * @stability stable
     */
    get vpcId(): string;
    private _weeklyMaintenanceStartTime?;
    /**
     * @stability stable
     */
    get weeklyMaintenanceStartTime(): string;
    /**
     * @stability stable
     */
    set weeklyMaintenanceStartTime(value: string);
    /**
     * @stability stable
     */
    resetWeeklyMaintenanceStartTime(): void;
    /**
     * @stability stable
     */
    get weeklyMaintenanceStartTimeInput(): string | undefined;
    private _auditLogConfiguration;
    /**
     * @stability stable
     */
    get auditLogConfiguration(): FsxWindowsFileSystemAuditLogConfigurationOutputReference;
    /**
     * @stability stable
     */
    putAuditLogConfiguration(value: FsxWindowsFileSystemAuditLogConfiguration): void;
    /**
     * @stability stable
     */
    resetAuditLogConfiguration(): void;
    /**
     * @stability stable
     */
    get auditLogConfigurationInput(): FsxWindowsFileSystemAuditLogConfiguration | undefined;
    private _selfManagedActiveDirectory;
    /**
     * @stability stable
     */
    get selfManagedActiveDirectory(): FsxWindowsFileSystemSelfManagedActiveDirectoryOutputReference;
    /**
     * @stability stable
     */
    putSelfManagedActiveDirectory(value: FsxWindowsFileSystemSelfManagedActiveDirectory): void;
    /**
     * @stability stable
     */
    resetSelfManagedActiveDirectory(): void;
    /**
     * @stability stable
     */
    get selfManagedActiveDirectoryInput(): FsxWindowsFileSystemSelfManagedActiveDirectory | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): FsxWindowsFileSystemTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: FsxWindowsFileSystemTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): FsxWindowsFileSystemTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
