import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Glacier.
 *
 * @stability stable
 */
export interface GlacierVaultLockConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glacier_vault_lock#complete_lock GlacierVaultLock#complete_lock}.
     *
     * @stability stable
     */
    readonly completeLock: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glacier_vault_lock#ignore_deletion_error GlacierVaultLock#ignore_deletion_error}.
     *
     * @stability stable
     */
    readonly ignoreDeletionError?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glacier_vault_lock#policy GlacierVaultLock#policy}.
     *
     * @stability stable
     */
    readonly policy: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/glacier_vault_lock#vault_name GlacierVaultLock#vault_name}.
     *
     * @stability stable
     */
    readonly vaultName: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/glacier_vault_lock aws_glacier_vault_lock}.
 *
 * @stability stable
 */
export declare class GlacierVaultLock extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/glacier_vault_lock aws_glacier_vault_lock} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlacierVaultLockConfig);
    private _completeLock?;
    /**
     * @stability stable
     */
    get completeLock(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set completeLock(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get completeLockInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _ignoreDeletionError?;
    /**
     * @stability stable
     */
    get ignoreDeletionError(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set ignoreDeletionError(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIgnoreDeletionError(): void;
    /**
     * @stability stable
     */
    get ignoreDeletionErrorInput(): boolean | cdktf.IResolvable | undefined;
    private _policy?;
    /**
     * @stability stable
     */
    get policy(): string;
    /**
     * @stability stable
     */
    set policy(value: string);
    /**
     * @stability stable
     */
    get policyInput(): string | undefined;
    private _vaultName?;
    /**
     * @stability stable
     */
    get vaultName(): string;
    /**
     * @stability stable
     */
    set vaultName(value: string);
    /**
     * @stability stable
     */
    get vaultNameInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
