import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Global Accelerator.
 *
 * @stability stable
 */
export interface GlobalacceleratorAcceleratorConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator#enabled GlobalacceleratorAccelerator#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator#ip_address_type GlobalacceleratorAccelerator#ip_address_type}.
     *
     * @stability stable
     */
    readonly ipAddressType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator#name GlobalacceleratorAccelerator#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator#tags GlobalacceleratorAccelerator#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator#tags_all GlobalacceleratorAccelerator#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * attributes block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator#attributes GlobalacceleratorAccelerator#attributes}
     *
     * @stability stable
     */
    readonly attributes?: GlobalacceleratorAcceleratorAttributes;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator#timeouts GlobalacceleratorAccelerator#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: GlobalacceleratorAcceleratorTimeouts;
}
/**
 * @stability stable
 */
export declare class GlobalacceleratorAcceleratorIpSets extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get ipAddresses(): string[];
    /**
     * @stability stable
     */
    get ipFamily(): string;
}
/**
 * @stability stable
 */
export interface GlobalacceleratorAcceleratorAttributes {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator#flow_logs_enabled GlobalacceleratorAccelerator#flow_logs_enabled}.
     *
     * @stability stable
     */
    readonly flowLogsEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator#flow_logs_s3_bucket GlobalacceleratorAccelerator#flow_logs_s3_bucket}.
     *
     * @stability stable
     */
    readonly flowLogsS3Bucket?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator#flow_logs_s3_prefix GlobalacceleratorAccelerator#flow_logs_s3_prefix}.
     *
     * @stability stable
     */
    readonly flowLogsS3Prefix?: string;
}
export declare function globalacceleratorAcceleratorAttributesToTerraform(struct?: GlobalacceleratorAcceleratorAttributesOutputReference | GlobalacceleratorAcceleratorAttributes): any;
/**
 * @stability stable
 */
export declare class GlobalacceleratorAcceleratorAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): GlobalacceleratorAcceleratorAttributes | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: GlobalacceleratorAcceleratorAttributes | undefined);
    private _flowLogsEnabled?;
    /**
     * @stability stable
     */
    get flowLogsEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set flowLogsEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetFlowLogsEnabled(): void;
    /**
     * @stability stable
     */
    get flowLogsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _flowLogsS3Bucket?;
    /**
     * @stability stable
     */
    get flowLogsS3Bucket(): string;
    /**
     * @stability stable
     */
    set flowLogsS3Bucket(value: string);
    /**
     * @stability stable
     */
    resetFlowLogsS3Bucket(): void;
    /**
     * @stability stable
     */
    get flowLogsS3BucketInput(): string | undefined;
    private _flowLogsS3Prefix?;
    /**
     * @stability stable
     */
    get flowLogsS3Prefix(): string;
    /**
     * @stability stable
     */
    set flowLogsS3Prefix(value: string);
    /**
     * @stability stable
     */
    resetFlowLogsS3Prefix(): void;
    /**
     * @stability stable
     */
    get flowLogsS3PrefixInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface GlobalacceleratorAcceleratorTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator#create GlobalacceleratorAccelerator#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator#update GlobalacceleratorAccelerator#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function globalacceleratorAcceleratorTimeoutsToTerraform(struct?: GlobalacceleratorAcceleratorTimeoutsOutputReference | GlobalacceleratorAcceleratorTimeouts): any;
/**
 * @stability stable
 */
export declare class GlobalacceleratorAcceleratorTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): GlobalacceleratorAcceleratorTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: GlobalacceleratorAcceleratorTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator aws_globalaccelerator_accelerator}.
 *
 * @stability stable
 */
export declare class GlobalacceleratorAccelerator extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/globalaccelerator_accelerator aws_globalaccelerator_accelerator} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlobalacceleratorAcceleratorConfig);
    /**
     * @stability stable
     */
    get dnsName(): string;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get hostedZoneId(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _ipAddressType?;
    /**
     * @stability stable
     */
    get ipAddressType(): string;
    /**
     * @stability stable
     */
    set ipAddressType(value: string);
    /**
     * @stability stable
     */
    resetIpAddressType(): void;
    /**
     * @stability stable
     */
    get ipAddressTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    ipSets(index: string): GlobalacceleratorAcceleratorIpSets;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _attributes;
    /**
     * @stability stable
     */
    get attributes(): GlobalacceleratorAcceleratorAttributesOutputReference;
    /**
     * @stability stable
     */
    putAttributes(value: GlobalacceleratorAcceleratorAttributes): void;
    /**
     * @stability stable
     */
    resetAttributes(): void;
    /**
     * @stability stable
     */
    get attributesInput(): GlobalacceleratorAcceleratorAttributes | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): GlobalacceleratorAcceleratorTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: GlobalacceleratorAcceleratorTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): GlobalacceleratorAcceleratorTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
