import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Image Builder.
 *
 * @stability stable
 */
export interface DataAwsImagebuilderImageConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_image#arn DataAwsImagebuilderImage#arn}.
     *
     * @stability stable
     */
    readonly arn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_image#tags DataAwsImagebuilderImage#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export declare class DataAwsImagebuilderImageImageTestsConfiguration extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get imageTestsEnabled(): any;
    /**
     * @stability stable
     */
    get timeoutMinutes(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsImagebuilderImageOutputResourcesAmis extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get accountId(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get image(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get region(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsImagebuilderImageOutputResources extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get amis(): any;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_image aws_imagebuilder_image}.
 *
 * @stability stable
 */
export declare class DataAwsImagebuilderImage extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/imagebuilder_image aws_imagebuilder_image} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsImagebuilderImageConfig);
    private _arn?;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    set arn(value: string);
    /**
     * @stability stable
     */
    get arnInput(): string | undefined;
    /**
     * @stability stable
     */
    get buildVersionArn(): string;
    /**
     * @stability stable
     */
    get dateCreated(): string;
    /**
     * @stability stable
     */
    get distributionConfigurationArn(): string;
    /**
     * @stability stable
     */
    get enhancedImageMetadataEnabled(): any;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get imageRecipeArn(): string;
    /**
     * @stability stable
     */
    imageTestsConfiguration(index: string): DataAwsImagebuilderImageImageTestsConfiguration;
    /**
     * @stability stable
     */
    get infrastructureConfigurationArn(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get osVersion(): string;
    /**
     * @stability stable
     */
    outputResources(index: string): DataAwsImagebuilderImageOutputResources;
    /**
     * @stability stable
     */
    get platform(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
