import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS IoT.
 *
 * @stability stable
 */
export interface IotThingGroupMembershipConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_group_membership#override_dynamic_group IotThingGroupMembership#override_dynamic_group}.
     *
     * @stability stable
     */
    readonly overrideDynamicGroup?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_group_membership#thing_group_name IotThingGroupMembership#thing_group_name}.
     *
     * @stability stable
     */
    readonly thingGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_group_membership#thing_name IotThingGroupMembership#thing_name}.
     *
     * @stability stable
     */
    readonly thingName: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_group_membership aws_iot_thing_group_membership}.
 *
 * @stability stable
 */
export declare class IotThingGroupMembership extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_group_membership aws_iot_thing_group_membership} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IotThingGroupMembershipConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _overrideDynamicGroup?;
    /**
     * @stability stable
     */
    get overrideDynamicGroup(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set overrideDynamicGroup(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetOverrideDynamicGroup(): void;
    /**
     * @stability stable
     */
    get overrideDynamicGroupInput(): boolean | cdktf.IResolvable | undefined;
    private _thingGroupName?;
    /**
     * @stability stable
     */
    get thingGroupName(): string;
    /**
     * @stability stable
     */
    set thingGroupName(value: string);
    /**
     * @stability stable
     */
    get thingGroupNameInput(): string | undefined;
    private _thingName?;
    /**
     * @stability stable
     */
    get thingName(): string;
    /**
     * @stability stable
     */
    set thingName(value: string);
    /**
     * @stability stable
     */
    get thingNameInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
