import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS IoT.
 *
 * @stability stable
 */
export interface IotThingGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_group#name IotThingGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_group#parent_group_name IotThingGroup#parent_group_name}.
     *
     * @stability stable
     */
    readonly parentGroupName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_group#tags IotThingGroup#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_group#tags_all IotThingGroup#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * properties block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_group#properties IotThingGroup#properties}
     *
     * @stability stable
     */
    readonly properties?: IotThingGroupProperties;
}
/**
 * @stability stable
 */
export declare class IotThingGroupMetadataRootToParentGroups extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get groupArn(): string;
    /**
     * @stability stable
     */
    get groupName(): string;
}
/**
 * @stability stable
 */
export declare class IotThingGroupMetadata extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get creationDate(): string;
    /**
     * @stability stable
     */
    get parentGroupName(): string;
    /**
     * @stability stable
     */
    get rootToParentGroups(): any;
}
/**
 * @stability stable
 */
export interface IotThingGroupPropertiesAttributePayload {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_group#attributes IotThingGroup#attributes}.
     *
     * @stability stable
     */
    readonly attributes?: {
        [key: string]: string;
    } | cdktf.IResolvable;
}
export declare function iotThingGroupPropertiesAttributePayloadToTerraform(struct?: IotThingGroupPropertiesAttributePayloadOutputReference | IotThingGroupPropertiesAttributePayload): any;
/**
 * @stability stable
 */
export declare class IotThingGroupPropertiesAttributePayloadOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): IotThingGroupPropertiesAttributePayload | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: IotThingGroupPropertiesAttributePayload | undefined);
    private _attributes?;
    /**
     * @stability stable
     */
    get attributes(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set attributes(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAttributes(): void;
    /**
     * @stability stable
     */
    get attributesInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
}
/**
 * @stability stable
 */
export interface IotThingGroupProperties {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_group#description IotThingGroup#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * attribute_payload block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_group#attribute_payload IotThingGroup#attribute_payload}
     *
     * @stability stable
     */
    readonly attributePayload?: IotThingGroupPropertiesAttributePayload;
}
export declare function iotThingGroupPropertiesToTerraform(struct?: IotThingGroupPropertiesOutputReference | IotThingGroupProperties): any;
/**
 * @stability stable
 */
export declare class IotThingGroupPropertiesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): IotThingGroupProperties | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: IotThingGroupProperties | undefined);
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _attributePayload;
    /**
     * @stability stable
     */
    get attributePayload(): IotThingGroupPropertiesAttributePayloadOutputReference;
    /**
     * @stability stable
     */
    putAttributePayload(value: IotThingGroupPropertiesAttributePayload): void;
    /**
     * @stability stable
     */
    resetAttributePayload(): void;
    /**
     * @stability stable
     */
    get attributePayloadInput(): IotThingGroupPropertiesAttributePayload | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_group aws_iot_thing_group}.
 *
 * @stability stable
 */
export declare class IotThingGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_group aws_iot_thing_group} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IotThingGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    metadata(index: string): IotThingGroupMetadata;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _parentGroupName?;
    /**
     * @stability stable
     */
    get parentGroupName(): string;
    /**
     * @stability stable
     */
    set parentGroupName(value: string);
    /**
     * @stability stable
     */
    resetParentGroupName(): void;
    /**
     * @stability stable
     */
    get parentGroupNameInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get version(): number;
    private _properties;
    /**
     * @stability stable
     */
    get properties(): IotThingGroupPropertiesOutputReference;
    /**
     * @stability stable
     */
    putProperties(value: IotThingGroupProperties): void;
    /**
     * @stability stable
     */
    resetProperties(): void;
    /**
     * @stability stable
     */
    get propertiesInput(): IotThingGroupProperties | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
