import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS IoT.
 *
 * @stability stable
 */
export interface IotTopicRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#description IotTopicRule#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#enabled IotTopicRule#enabled}.
     *
     * @stability stable
     */
    readonly enabled: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#name IotTopicRule#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#sql IotTopicRule#sql}.
     *
     * @stability stable
     */
    readonly sql: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#sql_version IotTopicRule#sql_version}.
     *
     * @stability stable
     */
    readonly sqlVersion: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#tags IotTopicRule#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#tags_all IotTopicRule#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * cloudwatch_alarm block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#cloudwatch_alarm IotTopicRule#cloudwatch_alarm}
     *
     * @stability stable
     */
    readonly cloudwatchAlarm?: IotTopicRuleCloudwatchAlarm[];
    /**
     * cloudwatch_metric block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#cloudwatch_metric IotTopicRule#cloudwatch_metric}
     *
     * @stability stable
     */
    readonly cloudwatchMetric?: IotTopicRuleCloudwatchMetric[];
    /**
     * dynamodb block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#dynamodb IotTopicRule#dynamodb}
     *
     * @stability stable
     */
    readonly dynamodb?: IotTopicRuleDynamodb[];
    /**
     * dynamodbv2 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#dynamodbv2 IotTopicRule#dynamodbv2}
     *
     * @stability stable
     */
    readonly dynamodbv2?: IotTopicRuleDynamodbv2[];
    /**
     * elasticsearch block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#elasticsearch IotTopicRule#elasticsearch}
     *
     * @stability stable
     */
    readonly elasticsearch?: IotTopicRuleElasticsearch[];
    /**
     * error_action block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#error_action IotTopicRule#error_action}
     *
     * @stability stable
     */
    readonly errorAction?: IotTopicRuleErrorAction;
    /**
     * firehose block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#firehose IotTopicRule#firehose}
     *
     * @stability stable
     */
    readonly firehose?: IotTopicRuleFirehose[];
    /**
     * iot_analytics block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#iot_analytics IotTopicRule#iot_analytics}
     *
     * @stability stable
     */
    readonly iotAnalytics?: IotTopicRuleIotAnalytics[];
    /**
     * iot_events block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#iot_events IotTopicRule#iot_events}
     *
     * @stability stable
     */
    readonly iotEvents?: IotTopicRuleIotEvents[];
    /**
     * kinesis block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#kinesis IotTopicRule#kinesis}
     *
     * @stability stable
     */
    readonly kinesis?: IotTopicRuleKinesis[];
    /**
     * lambda block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#lambda IotTopicRule#lambda}
     *
     * @stability stable
     */
    readonly lambda?: IotTopicRuleLambda[];
    /**
     * republish block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#republish IotTopicRule#republish}
     *
     * @stability stable
     */
    readonly republish?: IotTopicRuleRepublish[];
    /**
     * s3 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#s3 IotTopicRule#s3}
     *
     * @stability stable
     */
    readonly s3?: IotTopicRuleS3[];
    /**
     * sns block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#sns IotTopicRule#sns}
     *
     * @stability stable
     */
    readonly sns?: IotTopicRuleSns[];
    /**
     * sqs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#sqs IotTopicRule#sqs}
     *
     * @stability stable
     */
    readonly sqs?: IotTopicRuleSqs[];
    /**
     * step_functions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#step_functions IotTopicRule#step_functions}
     *
     * @stability stable
     */
    readonly stepFunctions?: IotTopicRuleStepFunctions[];
}
/**
 * @stability stable
 */
export interface IotTopicRuleCloudwatchAlarm {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#alarm_name IotTopicRule#alarm_name}.
     *
     * @stability stable
     */
    readonly alarmName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#state_reason IotTopicRule#state_reason}.
     *
     * @stability stable
     */
    readonly stateReason: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#state_value IotTopicRule#state_value}.
     *
     * @stability stable
     */
    readonly stateValue: string;
}
export declare function iotTopicRuleCloudwatchAlarmToTerraform(struct?: IotTopicRuleCloudwatchAlarm): any;
/**
 * @stability stable
 */
export interface IotTopicRuleCloudwatchMetric {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#metric_name IotTopicRule#metric_name}.
     *
     * @stability stable
     */
    readonly metricName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#metric_namespace IotTopicRule#metric_namespace}.
     *
     * @stability stable
     */
    readonly metricNamespace: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#metric_timestamp IotTopicRule#metric_timestamp}.
     *
     * @stability stable
     */
    readonly metricTimestamp?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#metric_unit IotTopicRule#metric_unit}.
     *
     * @stability stable
     */
    readonly metricUnit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#metric_value IotTopicRule#metric_value}.
     *
     * @stability stable
     */
    readonly metricValue: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
}
export declare function iotTopicRuleCloudwatchMetricToTerraform(struct?: IotTopicRuleCloudwatchMetric): any;
/**
 * @stability stable
 */
export interface IotTopicRuleDynamodb {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#hash_key_field IotTopicRule#hash_key_field}.
     *
     * @stability stable
     */
    readonly hashKeyField: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#hash_key_type IotTopicRule#hash_key_type}.
     *
     * @stability stable
     */
    readonly hashKeyType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#hash_key_value IotTopicRule#hash_key_value}.
     *
     * @stability stable
     */
    readonly hashKeyValue: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#operation IotTopicRule#operation}.
     *
     * @stability stable
     */
    readonly operation?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#payload_field IotTopicRule#payload_field}.
     *
     * @stability stable
     */
    readonly payloadField?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#range_key_field IotTopicRule#range_key_field}.
     *
     * @stability stable
     */
    readonly rangeKeyField?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#range_key_type IotTopicRule#range_key_type}.
     *
     * @stability stable
     */
    readonly rangeKeyType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#range_key_value IotTopicRule#range_key_value}.
     *
     * @stability stable
     */
    readonly rangeKeyValue?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#table_name IotTopicRule#table_name}.
     *
     * @stability stable
     */
    readonly tableName: string;
}
export declare function iotTopicRuleDynamodbToTerraform(struct?: IotTopicRuleDynamodb): any;
/**
 * @stability stable
 */
export interface IotTopicRuleDynamodbv2PutItem {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#table_name IotTopicRule#table_name}.
     *
     * @stability stable
     */
    readonly tableName: string;
}
export declare function iotTopicRuleDynamodbv2PutItemToTerraform(struct?: IotTopicRuleDynamodbv2PutItemOutputReference | IotTopicRuleDynamodbv2PutItem): any;
/**
 * @stability stable
 */
export declare class IotTopicRuleDynamodbv2PutItemOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): IotTopicRuleDynamodbv2PutItem | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: IotTopicRuleDynamodbv2PutItem | undefined);
    private _tableName?;
    /**
     * @stability stable
     */
    get tableName(): string;
    /**
     * @stability stable
     */
    set tableName(value: string);
    /**
     * @stability stable
     */
    get tableNameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface IotTopicRuleDynamodbv2 {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * put_item block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#put_item IotTopicRule#put_item}
     *
     * @stability stable
     */
    readonly putItem?: IotTopicRuleDynamodbv2PutItem;
}
export declare function iotTopicRuleDynamodbv2ToTerraform(struct?: IotTopicRuleDynamodbv2): any;
/**
 * @stability stable
 */
export interface IotTopicRuleElasticsearch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#endpoint IotTopicRule#endpoint}.
     *
     * @stability stable
     */
    readonly endpoint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#id IotTopicRule#id}.
     *
     * @stability stable
     */
    readonly id: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#index IotTopicRule#index}.
     *
     * @stability stable
     */
    readonly index: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#type IotTopicRule#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
export declare function iotTopicRuleElasticsearchToTerraform(struct?: IotTopicRuleElasticsearch): any;
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionCloudwatchAlarm {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#alarm_name IotTopicRule#alarm_name}.
     *
     * @stability stable
     */
    readonly alarmName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#state_reason IotTopicRule#state_reason}.
     *
     * @stability stable
     */
    readonly stateReason: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#state_value IotTopicRule#state_value}.
     *
     * @stability stable
     */
    readonly stateValue: string;
}
export declare function iotTopicRuleErrorActionCloudwatchAlarmToTerraform(struct?: IotTopicRuleErrorActionCloudwatchAlarmOutputReference | IotTopicRuleErrorActionCloudwatchAlarm): any;
/**
 * @stability stable
 */
export declare class IotTopicRuleErrorActionCloudwatchAlarmOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): IotTopicRuleErrorActionCloudwatchAlarm | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: IotTopicRuleErrorActionCloudwatchAlarm | undefined);
    private _alarmName?;
    /**
     * @stability stable
     */
    get alarmName(): string;
    /**
     * @stability stable
     */
    set alarmName(value: string);
    /**
     * @stability stable
     */
    get alarmNameInput(): string | undefined;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    private _stateReason?;
    /**
     * @stability stable
     */
    get stateReason(): string;
    /**
     * @stability stable
     */
    set stateReason(value: string);
    /**
     * @stability stable
     */
    get stateReasonInput(): string | undefined;
    private _stateValue?;
    /**
     * @stability stable
     */
    get stateValue(): string;
    /**
     * @stability stable
     */
    set stateValue(value: string);
    /**
     * @stability stable
     */
    get stateValueInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionCloudwatchMetric {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#metric_name IotTopicRule#metric_name}.
     *
     * @stability stable
     */
    readonly metricName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#metric_namespace IotTopicRule#metric_namespace}.
     *
     * @stability stable
     */
    readonly metricNamespace: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#metric_timestamp IotTopicRule#metric_timestamp}.
     *
     * @stability stable
     */
    readonly metricTimestamp?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#metric_unit IotTopicRule#metric_unit}.
     *
     * @stability stable
     */
    readonly metricUnit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#metric_value IotTopicRule#metric_value}.
     *
     * @stability stable
     */
    readonly metricValue: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
}
export declare function iotTopicRuleErrorActionCloudwatchMetricToTerraform(struct?: IotTopicRuleErrorActionCloudwatchMetricOutputReference | IotTopicRuleErrorActionCloudwatchMetric): any;
/**
 * @stability stable
 */
export declare class IotTopicRuleErrorActionCloudwatchMetricOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): IotTopicRuleErrorActionCloudwatchMetric | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: IotTopicRuleErrorActionCloudwatchMetric | undefined);
    private _metricName?;
    /**
     * @stability stable
     */
    get metricName(): string;
    /**
     * @stability stable
     */
    set metricName(value: string);
    /**
     * @stability stable
     */
    get metricNameInput(): string | undefined;
    private _metricNamespace?;
    /**
     * @stability stable
     */
    get metricNamespace(): string;
    /**
     * @stability stable
     */
    set metricNamespace(value: string);
    /**
     * @stability stable
     */
    get metricNamespaceInput(): string | undefined;
    private _metricTimestamp?;
    /**
     * @stability stable
     */
    get metricTimestamp(): string;
    /**
     * @stability stable
     */
    set metricTimestamp(value: string);
    /**
     * @stability stable
     */
    resetMetricTimestamp(): void;
    /**
     * @stability stable
     */
    get metricTimestampInput(): string | undefined;
    private _metricUnit?;
    /**
     * @stability stable
     */
    get metricUnit(): string;
    /**
     * @stability stable
     */
    set metricUnit(value: string);
    /**
     * @stability stable
     */
    get metricUnitInput(): string | undefined;
    private _metricValue?;
    /**
     * @stability stable
     */
    get metricValue(): string;
    /**
     * @stability stable
     */
    set metricValue(value: string);
    /**
     * @stability stable
     */
    get metricValueInput(): string | undefined;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionDynamodb {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#hash_key_field IotTopicRule#hash_key_field}.
     *
     * @stability stable
     */
    readonly hashKeyField: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#hash_key_type IotTopicRule#hash_key_type}.
     *
     * @stability stable
     */
    readonly hashKeyType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#hash_key_value IotTopicRule#hash_key_value}.
     *
     * @stability stable
     */
    readonly hashKeyValue: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#operation IotTopicRule#operation}.
     *
     * @stability stable
     */
    readonly operation?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#payload_field IotTopicRule#payload_field}.
     *
     * @stability stable
     */
    readonly payloadField?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#range_key_field IotTopicRule#range_key_field}.
     *
     * @stability stable
     */
    readonly rangeKeyField?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#range_key_type IotTopicRule#range_key_type}.
     *
     * @stability stable
     */
    readonly rangeKeyType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#range_key_value IotTopicRule#range_key_value}.
     *
     * @stability stable
     */
    readonly rangeKeyValue?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#table_name IotTopicRule#table_name}.
     *
     * @stability stable
     */
    readonly tableName: string;
}
export declare function iotTopicRuleErrorActionDynamodbToTerraform(struct?: IotTopicRuleErrorActionDynamodbOutputReference | IotTopicRuleErrorActionDynamodb): any;
/**
 * @stability stable
 */
export declare class IotTopicRuleErrorActionDynamodbOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): IotTopicRuleErrorActionDynamodb | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: IotTopicRuleErrorActionDynamodb | undefined);
    private _hashKeyField?;
    /**
     * @stability stable
     */
    get hashKeyField(): string;
    /**
     * @stability stable
     */
    set hashKeyField(value: string);
    /**
     * @stability stable
     */
    get hashKeyFieldInput(): string | undefined;
    private _hashKeyType?;
    /**
     * @stability stable
     */
    get hashKeyType(): string;
    /**
     * @stability stable
     */
    set hashKeyType(value: string);
    /**
     * @stability stable
     */
    resetHashKeyType(): void;
    /**
     * @stability stable
     */
    get hashKeyTypeInput(): string | undefined;
    private _hashKeyValue?;
    /**
     * @stability stable
     */
    get hashKeyValue(): string;
    /**
     * @stability stable
     */
    set hashKeyValue(value: string);
    /**
     * @stability stable
     */
    get hashKeyValueInput(): string | undefined;
    private _operation?;
    /**
     * @stability stable
     */
    get operation(): string;
    /**
     * @stability stable
     */
    set operation(value: string);
    /**
     * @stability stable
     */
    resetOperation(): void;
    /**
     * @stability stable
     */
    get operationInput(): string | undefined;
    private _payloadField?;
    /**
     * @stability stable
     */
    get payloadField(): string;
    /**
     * @stability stable
     */
    set payloadField(value: string);
    /**
     * @stability stable
     */
    resetPayloadField(): void;
    /**
     * @stability stable
     */
    get payloadFieldInput(): string | undefined;
    private _rangeKeyField?;
    /**
     * @stability stable
     */
    get rangeKeyField(): string;
    /**
     * @stability stable
     */
    set rangeKeyField(value: string);
    /**
     * @stability stable
     */
    resetRangeKeyField(): void;
    /**
     * @stability stable
     */
    get rangeKeyFieldInput(): string | undefined;
    private _rangeKeyType?;
    /**
     * @stability stable
     */
    get rangeKeyType(): string;
    /**
     * @stability stable
     */
    set rangeKeyType(value: string);
    /**
     * @stability stable
     */
    resetRangeKeyType(): void;
    /**
     * @stability stable
     */
    get rangeKeyTypeInput(): string | undefined;
    private _rangeKeyValue?;
    /**
     * @stability stable
     */
    get rangeKeyValue(): string;
    /**
     * @stability stable
     */
    set rangeKeyValue(value: string);
    /**
     * @stability stable
     */
    resetRangeKeyValue(): void;
    /**
     * @stability stable
     */
    get rangeKeyValueInput(): string | undefined;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    private _tableName?;
    /**
     * @stability stable
     */
    get tableName(): string;
    /**
     * @stability stable
     */
    set tableName(value: string);
    /**
     * @stability stable
     */
    get tableNameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionDynamodbv2PutItem {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#table_name IotTopicRule#table_name}.
     *
     * @stability stable
     */
    readonly tableName: string;
}
export declare function iotTopicRuleErrorActionDynamodbv2PutItemToTerraform(struct?: IotTopicRuleErrorActionDynamodbv2PutItemOutputReference | IotTopicRuleErrorActionDynamodbv2PutItem): any;
/**
 * @stability stable
 */
export declare class IotTopicRuleErrorActionDynamodbv2PutItemOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): IotTopicRuleErrorActionDynamodbv2PutItem | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: IotTopicRuleErrorActionDynamodbv2PutItem | undefined);
    private _tableName?;
    /**
     * @stability stable
     */
    get tableName(): string;
    /**
     * @stability stable
     */
    set tableName(value: string);
    /**
     * @stability stable
     */
    get tableNameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionDynamodbv2 {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * put_item block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#put_item IotTopicRule#put_item}
     *
     * @stability stable
     */
    readonly putItem?: IotTopicRuleErrorActionDynamodbv2PutItem;
}
export declare function iotTopicRuleErrorActionDynamodbv2ToTerraform(struct?: IotTopicRuleErrorActionDynamodbv2OutputReference | IotTopicRuleErrorActionDynamodbv2): any;
/**
 * @stability stable
 */
export declare class IotTopicRuleErrorActionDynamodbv2OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): IotTopicRuleErrorActionDynamodbv2 | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: IotTopicRuleErrorActionDynamodbv2 | undefined);
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    private _putItem;
    /**
     * @stability stable
     */
    get putItem(): IotTopicRuleErrorActionDynamodbv2PutItemOutputReference;
    /**
     * @stability stable
     */
    putPutItem(value: IotTopicRuleErrorActionDynamodbv2PutItem): void;
    /**
     * @stability stable
     */
    resetPutItem(): void;
    /**
     * @stability stable
     */
    get putItemInput(): IotTopicRuleErrorActionDynamodbv2PutItem | undefined;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionElasticsearch {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#endpoint IotTopicRule#endpoint}.
     *
     * @stability stable
     */
    readonly endpoint: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#id IotTopicRule#id}.
     *
     * @stability stable
     */
    readonly id: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#index IotTopicRule#index}.
     *
     * @stability stable
     */
    readonly index: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#type IotTopicRule#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
export declare function iotTopicRuleErrorActionElasticsearchToTerraform(struct?: IotTopicRuleErrorActionElasticsearchOutputReference | IotTopicRuleErrorActionElasticsearch): any;
/**
 * @stability stable
 */
export declare class IotTopicRuleErrorActionElasticsearchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): IotTopicRuleErrorActionElasticsearch | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: IotTopicRuleErrorActionElasticsearch | undefined);
    private _endpoint?;
    /**
     * @stability stable
     */
    get endpoint(): string;
    /**
     * @stability stable
     */
    set endpoint(value: string);
    /**
     * @stability stable
     */
    get endpointInput(): string | undefined;
    private _id?;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    set id(value: string);
    /**
     * @stability stable
     */
    get idInput(): string | undefined;
    private _index?;
    /**
     * @stability stable
     */
    get index(): string;
    /**
     * @stability stable
     */
    set index(value: string);
    /**
     * @stability stable
     */
    get indexInput(): string | undefined;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionFirehose {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#delivery_stream_name IotTopicRule#delivery_stream_name}.
     *
     * @stability stable
     */
    readonly deliveryStreamName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#separator IotTopicRule#separator}.
     *
     * @stability stable
     */
    readonly separator?: string;
}
export declare function iotTopicRuleErrorActionFirehoseToTerraform(struct?: IotTopicRuleErrorActionFirehoseOutputReference | IotTopicRuleErrorActionFirehose): any;
/**
 * @stability stable
 */
export declare class IotTopicRuleErrorActionFirehoseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): IotTopicRuleErrorActionFirehose | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: IotTopicRuleErrorActionFirehose | undefined);
    private _deliveryStreamName?;
    /**
     * @stability stable
     */
    get deliveryStreamName(): string;
    /**
     * @stability stable
     */
    set deliveryStreamName(value: string);
    /**
     * @stability stable
     */
    get deliveryStreamNameInput(): string | undefined;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    private _separator?;
    /**
     * @stability stable
     */
    get separator(): string;
    /**
     * @stability stable
     */
    set separator(value: string);
    /**
     * @stability stable
     */
    resetSeparator(): void;
    /**
     * @stability stable
     */
    get separatorInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionIotAnalytics {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#channel_name IotTopicRule#channel_name}.
     *
     * @stability stable
     */
    readonly channelName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
}
export declare function iotTopicRuleErrorActionIotAnalyticsToTerraform(struct?: IotTopicRuleErrorActionIotAnalyticsOutputReference | IotTopicRuleErrorActionIotAnalytics): any;
/**
 * @stability stable
 */
export declare class IotTopicRuleErrorActionIotAnalyticsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): IotTopicRuleErrorActionIotAnalytics | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: IotTopicRuleErrorActionIotAnalytics | undefined);
    private _channelName?;
    /**
     * @stability stable
     */
    get channelName(): string;
    /**
     * @stability stable
     */
    set channelName(value: string);
    /**
     * @stability stable
     */
    get channelNameInput(): string | undefined;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionIotEvents {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#input_name IotTopicRule#input_name}.
     *
     * @stability stable
     */
    readonly inputName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#message_id IotTopicRule#message_id}.
     *
     * @stability stable
     */
    readonly messageId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
}
export declare function iotTopicRuleErrorActionIotEventsToTerraform(struct?: IotTopicRuleErrorActionIotEventsOutputReference | IotTopicRuleErrorActionIotEvents): any;
/**
 * @stability stable
 */
export declare class IotTopicRuleErrorActionIotEventsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): IotTopicRuleErrorActionIotEvents | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: IotTopicRuleErrorActionIotEvents | undefined);
    private _inputName?;
    /**
     * @stability stable
     */
    get inputName(): string;
    /**
     * @stability stable
     */
    set inputName(value: string);
    /**
     * @stability stable
     */
    get inputNameInput(): string | undefined;
    private _messageId?;
    /**
     * @stability stable
     */
    get messageId(): string;
    /**
     * @stability stable
     */
    set messageId(value: string);
    /**
     * @stability stable
     */
    resetMessageId(): void;
    /**
     * @stability stable
     */
    get messageIdInput(): string | undefined;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionKinesis {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#partition_key IotTopicRule#partition_key}.
     *
     * @stability stable
     */
    readonly partitionKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#stream_name IotTopicRule#stream_name}.
     *
     * @stability stable
     */
    readonly streamName: string;
}
export declare function iotTopicRuleErrorActionKinesisToTerraform(struct?: IotTopicRuleErrorActionKinesisOutputReference | IotTopicRuleErrorActionKinesis): any;
/**
 * @stability stable
 */
export declare class IotTopicRuleErrorActionKinesisOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): IotTopicRuleErrorActionKinesis | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: IotTopicRuleErrorActionKinesis | undefined);
    private _partitionKey?;
    /**
     * @stability stable
     */
    get partitionKey(): string;
    /**
     * @stability stable
     */
    set partitionKey(value: string);
    /**
     * @stability stable
     */
    resetPartitionKey(): void;
    /**
     * @stability stable
     */
    get partitionKeyInput(): string | undefined;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    private _streamName?;
    /**
     * @stability stable
     */
    get streamName(): string;
    /**
     * @stability stable
     */
    set streamName(value: string);
    /**
     * @stability stable
     */
    get streamNameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionLambda {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#function_arn IotTopicRule#function_arn}.
     *
     * @stability stable
     */
    readonly functionArn: string;
}
export declare function iotTopicRuleErrorActionLambdaToTerraform(struct?: IotTopicRuleErrorActionLambdaOutputReference | IotTopicRuleErrorActionLambda): any;
/**
 * @stability stable
 */
export declare class IotTopicRuleErrorActionLambdaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): IotTopicRuleErrorActionLambda | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: IotTopicRuleErrorActionLambda | undefined);
    private _functionArn?;
    /**
     * @stability stable
     */
    get functionArn(): string;
    /**
     * @stability stable
     */
    set functionArn(value: string);
    /**
     * @stability stable
     */
    get functionArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionRepublish {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#qos IotTopicRule#qos}.
     *
     * @stability stable
     */
    readonly qos?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#topic IotTopicRule#topic}.
     *
     * @stability stable
     */
    readonly topic: string;
}
export declare function iotTopicRuleErrorActionRepublishToTerraform(struct?: IotTopicRuleErrorActionRepublishOutputReference | IotTopicRuleErrorActionRepublish): any;
/**
 * @stability stable
 */
export declare class IotTopicRuleErrorActionRepublishOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): IotTopicRuleErrorActionRepublish | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: IotTopicRuleErrorActionRepublish | undefined);
    private _qos?;
    /**
     * @stability stable
     */
    get qos(): number;
    /**
     * @stability stable
     */
    set qos(value: number);
    /**
     * @stability stable
     */
    resetQos(): void;
    /**
     * @stability stable
     */
    get qosInput(): number | undefined;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    private _topic?;
    /**
     * @stability stable
     */
    get topic(): string;
    /**
     * @stability stable
     */
    set topic(value: string);
    /**
     * @stability stable
     */
    get topicInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionS3 {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#bucket_name IotTopicRule#bucket_name}.
     *
     * @stability stable
     */
    readonly bucketName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#key IotTopicRule#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
}
export declare function iotTopicRuleErrorActionS3ToTerraform(struct?: IotTopicRuleErrorActionS3OutputReference | IotTopicRuleErrorActionS3): any;
/**
 * @stability stable
 */
export declare class IotTopicRuleErrorActionS3OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): IotTopicRuleErrorActionS3 | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: IotTopicRuleErrorActionS3 | undefined);
    private _bucketName?;
    /**
     * @stability stable
     */
    get bucketName(): string;
    /**
     * @stability stable
     */
    set bucketName(value: string);
    /**
     * @stability stable
     */
    get bucketNameInput(): string | undefined;
    private _key?;
    /**
     * @stability stable
     */
    get key(): string;
    /**
     * @stability stable
     */
    set key(value: string);
    /**
     * @stability stable
     */
    get keyInput(): string | undefined;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionSns {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#message_format IotTopicRule#message_format}.
     *
     * @stability stable
     */
    readonly messageFormat?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#target_arn IotTopicRule#target_arn}.
     *
     * @stability stable
     */
    readonly targetArn: string;
}
export declare function iotTopicRuleErrorActionSnsToTerraform(struct?: IotTopicRuleErrorActionSnsOutputReference | IotTopicRuleErrorActionSns): any;
/**
 * @stability stable
 */
export declare class IotTopicRuleErrorActionSnsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): IotTopicRuleErrorActionSns | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: IotTopicRuleErrorActionSns | undefined);
    private _messageFormat?;
    /**
     * @stability stable
     */
    get messageFormat(): string;
    /**
     * @stability stable
     */
    set messageFormat(value: string);
    /**
     * @stability stable
     */
    resetMessageFormat(): void;
    /**
     * @stability stable
     */
    get messageFormatInput(): string | undefined;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    private _targetArn?;
    /**
     * @stability stable
     */
    get targetArn(): string;
    /**
     * @stability stable
     */
    set targetArn(value: string);
    /**
     * @stability stable
     */
    get targetArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionSqs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#queue_url IotTopicRule#queue_url}.
     *
     * @stability stable
     */
    readonly queueUrl: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#use_base64 IotTopicRule#use_base64}.
     *
     * @stability stable
     */
    readonly useBase64: boolean | cdktf.IResolvable;
}
export declare function iotTopicRuleErrorActionSqsToTerraform(struct?: IotTopicRuleErrorActionSqsOutputReference | IotTopicRuleErrorActionSqs): any;
/**
 * @stability stable
 */
export declare class IotTopicRuleErrorActionSqsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): IotTopicRuleErrorActionSqs | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: IotTopicRuleErrorActionSqs | undefined);
    private _queueUrl?;
    /**
     * @stability stable
     */
    get queueUrl(): string;
    /**
     * @stability stable
     */
    set queueUrl(value: string);
    /**
     * @stability stable
     */
    get queueUrlInput(): string | undefined;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    private _useBase64?;
    /**
     * @stability stable
     */
    get useBase64(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set useBase64(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get useBase64Input(): boolean | cdktf.IResolvable | undefined;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionStepFunctions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#execution_name_prefix IotTopicRule#execution_name_prefix}.
     *
     * @stability stable
     */
    readonly executionNamePrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#state_machine_name IotTopicRule#state_machine_name}.
     *
     * @stability stable
     */
    readonly stateMachineName: string;
}
export declare function iotTopicRuleErrorActionStepFunctionsToTerraform(struct?: IotTopicRuleErrorActionStepFunctionsOutputReference | IotTopicRuleErrorActionStepFunctions): any;
/**
 * @stability stable
 */
export declare class IotTopicRuleErrorActionStepFunctionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): IotTopicRuleErrorActionStepFunctions | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: IotTopicRuleErrorActionStepFunctions | undefined);
    private _executionNamePrefix?;
    /**
     * @stability stable
     */
    get executionNamePrefix(): string;
    /**
     * @stability stable
     */
    set executionNamePrefix(value: string);
    /**
     * @stability stable
     */
    resetExecutionNamePrefix(): void;
    /**
     * @stability stable
     */
    get executionNamePrefixInput(): string | undefined;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    private _stateMachineName?;
    /**
     * @stability stable
     */
    get stateMachineName(): string;
    /**
     * @stability stable
     */
    set stateMachineName(value: string);
    /**
     * @stability stable
     */
    get stateMachineNameInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorAction {
    /**
     * cloudwatch_alarm block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#cloudwatch_alarm IotTopicRule#cloudwatch_alarm}
     *
     * @stability stable
     */
    readonly cloudwatchAlarm?: IotTopicRuleErrorActionCloudwatchAlarm;
    /**
     * cloudwatch_metric block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#cloudwatch_metric IotTopicRule#cloudwatch_metric}
     *
     * @stability stable
     */
    readonly cloudwatchMetric?: IotTopicRuleErrorActionCloudwatchMetric;
    /**
     * dynamodb block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#dynamodb IotTopicRule#dynamodb}
     *
     * @stability stable
     */
    readonly dynamodb?: IotTopicRuleErrorActionDynamodb;
    /**
     * dynamodbv2 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#dynamodbv2 IotTopicRule#dynamodbv2}
     *
     * @stability stable
     */
    readonly dynamodbv2?: IotTopicRuleErrorActionDynamodbv2;
    /**
     * elasticsearch block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#elasticsearch IotTopicRule#elasticsearch}
     *
     * @stability stable
     */
    readonly elasticsearch?: IotTopicRuleErrorActionElasticsearch;
    /**
     * firehose block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#firehose IotTopicRule#firehose}
     *
     * @stability stable
     */
    readonly firehose?: IotTopicRuleErrorActionFirehose;
    /**
     * iot_analytics block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#iot_analytics IotTopicRule#iot_analytics}
     *
     * @stability stable
     */
    readonly iotAnalytics?: IotTopicRuleErrorActionIotAnalytics;
    /**
     * iot_events block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#iot_events IotTopicRule#iot_events}
     *
     * @stability stable
     */
    readonly iotEvents?: IotTopicRuleErrorActionIotEvents;
    /**
     * kinesis block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#kinesis IotTopicRule#kinesis}
     *
     * @stability stable
     */
    readonly kinesis?: IotTopicRuleErrorActionKinesis;
    /**
     * lambda block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#lambda IotTopicRule#lambda}
     *
     * @stability stable
     */
    readonly lambda?: IotTopicRuleErrorActionLambda;
    /**
     * republish block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#republish IotTopicRule#republish}
     *
     * @stability stable
     */
    readonly republish?: IotTopicRuleErrorActionRepublish;
    /**
     * s3 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#s3 IotTopicRule#s3}
     *
     * @stability stable
     */
    readonly s3?: IotTopicRuleErrorActionS3;
    /**
     * sns block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#sns IotTopicRule#sns}
     *
     * @stability stable
     */
    readonly sns?: IotTopicRuleErrorActionSns;
    /**
     * sqs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#sqs IotTopicRule#sqs}
     *
     * @stability stable
     */
    readonly sqs?: IotTopicRuleErrorActionSqs;
    /**
     * step_functions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#step_functions IotTopicRule#step_functions}
     *
     * @stability stable
     */
    readonly stepFunctions?: IotTopicRuleErrorActionStepFunctions;
}
export declare function iotTopicRuleErrorActionToTerraform(struct?: IotTopicRuleErrorActionOutputReference | IotTopicRuleErrorAction): any;
/**
 * @stability stable
 */
export declare class IotTopicRuleErrorActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): IotTopicRuleErrorAction | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: IotTopicRuleErrorAction | undefined);
    private _cloudwatchAlarm;
    /**
     * @stability stable
     */
    get cloudwatchAlarm(): IotTopicRuleErrorActionCloudwatchAlarmOutputReference;
    /**
     * @stability stable
     */
    putCloudwatchAlarm(value: IotTopicRuleErrorActionCloudwatchAlarm): void;
    /**
     * @stability stable
     */
    resetCloudwatchAlarm(): void;
    /**
     * @stability stable
     */
    get cloudwatchAlarmInput(): IotTopicRuleErrorActionCloudwatchAlarm | undefined;
    private _cloudwatchMetric;
    /**
     * @stability stable
     */
    get cloudwatchMetric(): IotTopicRuleErrorActionCloudwatchMetricOutputReference;
    /**
     * @stability stable
     */
    putCloudwatchMetric(value: IotTopicRuleErrorActionCloudwatchMetric): void;
    /**
     * @stability stable
     */
    resetCloudwatchMetric(): void;
    /**
     * @stability stable
     */
    get cloudwatchMetricInput(): IotTopicRuleErrorActionCloudwatchMetric | undefined;
    private _dynamodb;
    /**
     * @stability stable
     */
    get dynamodb(): IotTopicRuleErrorActionDynamodbOutputReference;
    /**
     * @stability stable
     */
    putDynamodb(value: IotTopicRuleErrorActionDynamodb): void;
    /**
     * @stability stable
     */
    resetDynamodb(): void;
    /**
     * @stability stable
     */
    get dynamodbInput(): IotTopicRuleErrorActionDynamodb | undefined;
    private _dynamodbv2;
    /**
     * @stability stable
     */
    get dynamodbv2(): IotTopicRuleErrorActionDynamodbv2OutputReference;
    /**
     * @stability stable
     */
    putDynamodbv2(value: IotTopicRuleErrorActionDynamodbv2): void;
    /**
     * @stability stable
     */
    resetDynamodbv2(): void;
    /**
     * @stability stable
     */
    get dynamodbv2Input(): IotTopicRuleErrorActionDynamodbv2 | undefined;
    private _elasticsearch;
    /**
     * @stability stable
     */
    get elasticsearch(): IotTopicRuleErrorActionElasticsearchOutputReference;
    /**
     * @stability stable
     */
    putElasticsearch(value: IotTopicRuleErrorActionElasticsearch): void;
    /**
     * @stability stable
     */
    resetElasticsearch(): void;
    /**
     * @stability stable
     */
    get elasticsearchInput(): IotTopicRuleErrorActionElasticsearch | undefined;
    private _firehose;
    /**
     * @stability stable
     */
    get firehose(): IotTopicRuleErrorActionFirehoseOutputReference;
    /**
     * @stability stable
     */
    putFirehose(value: IotTopicRuleErrorActionFirehose): void;
    /**
     * @stability stable
     */
    resetFirehose(): void;
    /**
     * @stability stable
     */
    get firehoseInput(): IotTopicRuleErrorActionFirehose | undefined;
    private _iotAnalytics;
    /**
     * @stability stable
     */
    get iotAnalytics(): IotTopicRuleErrorActionIotAnalyticsOutputReference;
    /**
     * @stability stable
     */
    putIotAnalytics(value: IotTopicRuleErrorActionIotAnalytics): void;
    /**
     * @stability stable
     */
    resetIotAnalytics(): void;
    /**
     * @stability stable
     */
    get iotAnalyticsInput(): IotTopicRuleErrorActionIotAnalytics | undefined;
    private _iotEvents;
    /**
     * @stability stable
     */
    get iotEvents(): IotTopicRuleErrorActionIotEventsOutputReference;
    /**
     * @stability stable
     */
    putIotEvents(value: IotTopicRuleErrorActionIotEvents): void;
    /**
     * @stability stable
     */
    resetIotEvents(): void;
    /**
     * @stability stable
     */
    get iotEventsInput(): IotTopicRuleErrorActionIotEvents | undefined;
    private _kinesis;
    /**
     * @stability stable
     */
    get kinesis(): IotTopicRuleErrorActionKinesisOutputReference;
    /**
     * @stability stable
     */
    putKinesis(value: IotTopicRuleErrorActionKinesis): void;
    /**
     * @stability stable
     */
    resetKinesis(): void;
    /**
     * @stability stable
     */
    get kinesisInput(): IotTopicRuleErrorActionKinesis | undefined;
    private _lambda;
    /**
     * @stability stable
     */
    get lambda(): IotTopicRuleErrorActionLambdaOutputReference;
    /**
     * @stability stable
     */
    putLambda(value: IotTopicRuleErrorActionLambda): void;
    /**
     * @stability stable
     */
    resetLambda(): void;
    /**
     * @stability stable
     */
    get lambdaInput(): IotTopicRuleErrorActionLambda | undefined;
    private _republish;
    /**
     * @stability stable
     */
    get republish(): IotTopicRuleErrorActionRepublishOutputReference;
    /**
     * @stability stable
     */
    putRepublish(value: IotTopicRuleErrorActionRepublish): void;
    /**
     * @stability stable
     */
    resetRepublish(): void;
    /**
     * @stability stable
     */
    get republishInput(): IotTopicRuleErrorActionRepublish | undefined;
    private _s3;
    /**
     * @stability stable
     */
    get s3(): IotTopicRuleErrorActionS3OutputReference;
    /**
     * @stability stable
     */
    putS3(value: IotTopicRuleErrorActionS3): void;
    /**
     * @stability stable
     */
    resetS3(): void;
    /**
     * @stability stable
     */
    get s3Input(): IotTopicRuleErrorActionS3 | undefined;
    private _sns;
    /**
     * @stability stable
     */
    get sns(): IotTopicRuleErrorActionSnsOutputReference;
    /**
     * @stability stable
     */
    putSns(value: IotTopicRuleErrorActionSns): void;
    /**
     * @stability stable
     */
    resetSns(): void;
    /**
     * @stability stable
     */
    get snsInput(): IotTopicRuleErrorActionSns | undefined;
    private _sqs;
    /**
     * @stability stable
     */
    get sqs(): IotTopicRuleErrorActionSqsOutputReference;
    /**
     * @stability stable
     */
    putSqs(value: IotTopicRuleErrorActionSqs): void;
    /**
     * @stability stable
     */
    resetSqs(): void;
    /**
     * @stability stable
     */
    get sqsInput(): IotTopicRuleErrorActionSqs | undefined;
    private _stepFunctions;
    /**
     * @stability stable
     */
    get stepFunctions(): IotTopicRuleErrorActionStepFunctionsOutputReference;
    /**
     * @stability stable
     */
    putStepFunctions(value: IotTopicRuleErrorActionStepFunctions): void;
    /**
     * @stability stable
     */
    resetStepFunctions(): void;
    /**
     * @stability stable
     */
    get stepFunctionsInput(): IotTopicRuleErrorActionStepFunctions | undefined;
}
/**
 * @stability stable
 */
export interface IotTopicRuleFirehose {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#delivery_stream_name IotTopicRule#delivery_stream_name}.
     *
     * @stability stable
     */
    readonly deliveryStreamName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#separator IotTopicRule#separator}.
     *
     * @stability stable
     */
    readonly separator?: string;
}
export declare function iotTopicRuleFirehoseToTerraform(struct?: IotTopicRuleFirehose): any;
/**
 * @stability stable
 */
export interface IotTopicRuleIotAnalytics {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#channel_name IotTopicRule#channel_name}.
     *
     * @stability stable
     */
    readonly channelName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
}
export declare function iotTopicRuleIotAnalyticsToTerraform(struct?: IotTopicRuleIotAnalytics): any;
/**
 * @stability stable
 */
export interface IotTopicRuleIotEvents {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#input_name IotTopicRule#input_name}.
     *
     * @stability stable
     */
    readonly inputName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#message_id IotTopicRule#message_id}.
     *
     * @stability stable
     */
    readonly messageId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
}
export declare function iotTopicRuleIotEventsToTerraform(struct?: IotTopicRuleIotEvents): any;
/**
 * @stability stable
 */
export interface IotTopicRuleKinesis {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#partition_key IotTopicRule#partition_key}.
     *
     * @stability stable
     */
    readonly partitionKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#stream_name IotTopicRule#stream_name}.
     *
     * @stability stable
     */
    readonly streamName: string;
}
export declare function iotTopicRuleKinesisToTerraform(struct?: IotTopicRuleKinesis): any;
/**
 * @stability stable
 */
export interface IotTopicRuleLambda {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#function_arn IotTopicRule#function_arn}.
     *
     * @stability stable
     */
    readonly functionArn: string;
}
export declare function iotTopicRuleLambdaToTerraform(struct?: IotTopicRuleLambda): any;
/**
 * @stability stable
 */
export interface IotTopicRuleRepublish {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#qos IotTopicRule#qos}.
     *
     * @stability stable
     */
    readonly qos?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#topic IotTopicRule#topic}.
     *
     * @stability stable
     */
    readonly topic: string;
}
export declare function iotTopicRuleRepublishToTerraform(struct?: IotTopicRuleRepublish): any;
/**
 * @stability stable
 */
export interface IotTopicRuleS3 {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#bucket_name IotTopicRule#bucket_name}.
     *
     * @stability stable
     */
    readonly bucketName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#key IotTopicRule#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
}
export declare function iotTopicRuleS3ToTerraform(struct?: IotTopicRuleS3): any;
/**
 * @stability stable
 */
export interface IotTopicRuleSns {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#message_format IotTopicRule#message_format}.
     *
     * @stability stable
     */
    readonly messageFormat?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#target_arn IotTopicRule#target_arn}.
     *
     * @stability stable
     */
    readonly targetArn: string;
}
export declare function iotTopicRuleSnsToTerraform(struct?: IotTopicRuleSns): any;
/**
 * @stability stable
 */
export interface IotTopicRuleSqs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#queue_url IotTopicRule#queue_url}.
     *
     * @stability stable
     */
    readonly queueUrl: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#use_base64 IotTopicRule#use_base64}.
     *
     * @stability stable
     */
    readonly useBase64: boolean | cdktf.IResolvable;
}
export declare function iotTopicRuleSqsToTerraform(struct?: IotTopicRuleSqs): any;
/**
 * @stability stable
 */
export interface IotTopicRuleStepFunctions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#execution_name_prefix IotTopicRule#execution_name_prefix}.
     *
     * @stability stable
     */
    readonly executionNamePrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#role_arn IotTopicRule#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule#state_machine_name IotTopicRule#state_machine_name}.
     *
     * @stability stable
     */
    readonly stateMachineName: string;
}
export declare function iotTopicRuleStepFunctionsToTerraform(struct?: IotTopicRuleStepFunctions): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule aws_iot_topic_rule}.
 *
 * @stability stable
 */
export declare class IotTopicRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/iot_topic_rule aws_iot_topic_rule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IotTopicRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _sql?;
    /**
     * @stability stable
     */
    get sql(): string;
    /**
     * @stability stable
     */
    set sql(value: string);
    /**
     * @stability stable
     */
    get sqlInput(): string | undefined;
    private _sqlVersion?;
    /**
     * @stability stable
     */
    get sqlVersion(): string;
    /**
     * @stability stable
     */
    set sqlVersion(value: string);
    /**
     * @stability stable
     */
    get sqlVersionInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _cloudwatchAlarm?;
    /**
     * @stability stable
     */
    get cloudwatchAlarm(): IotTopicRuleCloudwatchAlarm[];
    /**
     * @stability stable
     */
    set cloudwatchAlarm(value: IotTopicRuleCloudwatchAlarm[]);
    /**
     * @stability stable
     */
    resetCloudwatchAlarm(): void;
    /**
     * @stability stable
     */
    get cloudwatchAlarmInput(): IotTopicRuleCloudwatchAlarm[] | undefined;
    private _cloudwatchMetric?;
    /**
     * @stability stable
     */
    get cloudwatchMetric(): IotTopicRuleCloudwatchMetric[];
    /**
     * @stability stable
     */
    set cloudwatchMetric(value: IotTopicRuleCloudwatchMetric[]);
    /**
     * @stability stable
     */
    resetCloudwatchMetric(): void;
    /**
     * @stability stable
     */
    get cloudwatchMetricInput(): IotTopicRuleCloudwatchMetric[] | undefined;
    private _dynamodb?;
    /**
     * @stability stable
     */
    get dynamodb(): IotTopicRuleDynamodb[];
    /**
     * @stability stable
     */
    set dynamodb(value: IotTopicRuleDynamodb[]);
    /**
     * @stability stable
     */
    resetDynamodb(): void;
    /**
     * @stability stable
     */
    get dynamodbInput(): IotTopicRuleDynamodb[] | undefined;
    private _dynamodbv2?;
    /**
     * @stability stable
     */
    get dynamodbv2(): IotTopicRuleDynamodbv2[];
    /**
     * @stability stable
     */
    set dynamodbv2(value: IotTopicRuleDynamodbv2[]);
    /**
     * @stability stable
     */
    resetDynamodbv2(): void;
    /**
     * @stability stable
     */
    get dynamodbv2Input(): IotTopicRuleDynamodbv2[] | undefined;
    private _elasticsearch?;
    /**
     * @stability stable
     */
    get elasticsearch(): IotTopicRuleElasticsearch[];
    /**
     * @stability stable
     */
    set elasticsearch(value: IotTopicRuleElasticsearch[]);
    /**
     * @stability stable
     */
    resetElasticsearch(): void;
    /**
     * @stability stable
     */
    get elasticsearchInput(): IotTopicRuleElasticsearch[] | undefined;
    private _errorAction;
    /**
     * @stability stable
     */
    get errorAction(): IotTopicRuleErrorActionOutputReference;
    /**
     * @stability stable
     */
    putErrorAction(value: IotTopicRuleErrorAction): void;
    /**
     * @stability stable
     */
    resetErrorAction(): void;
    /**
     * @stability stable
     */
    get errorActionInput(): IotTopicRuleErrorAction | undefined;
    private _firehose?;
    /**
     * @stability stable
     */
    get firehose(): IotTopicRuleFirehose[];
    /**
     * @stability stable
     */
    set firehose(value: IotTopicRuleFirehose[]);
    /**
     * @stability stable
     */
    resetFirehose(): void;
    /**
     * @stability stable
     */
    get firehoseInput(): IotTopicRuleFirehose[] | undefined;
    private _iotAnalytics?;
    /**
     * @stability stable
     */
    get iotAnalytics(): IotTopicRuleIotAnalytics[];
    /**
     * @stability stable
     */
    set iotAnalytics(value: IotTopicRuleIotAnalytics[]);
    /**
     * @stability stable
     */
    resetIotAnalytics(): void;
    /**
     * @stability stable
     */
    get iotAnalyticsInput(): IotTopicRuleIotAnalytics[] | undefined;
    private _iotEvents?;
    /**
     * @stability stable
     */
    get iotEvents(): IotTopicRuleIotEvents[];
    /**
     * @stability stable
     */
    set iotEvents(value: IotTopicRuleIotEvents[]);
    /**
     * @stability stable
     */
    resetIotEvents(): void;
    /**
     * @stability stable
     */
    get iotEventsInput(): IotTopicRuleIotEvents[] | undefined;
    private _kinesis?;
    /**
     * @stability stable
     */
    get kinesis(): IotTopicRuleKinesis[];
    /**
     * @stability stable
     */
    set kinesis(value: IotTopicRuleKinesis[]);
    /**
     * @stability stable
     */
    resetKinesis(): void;
    /**
     * @stability stable
     */
    get kinesisInput(): IotTopicRuleKinesis[] | undefined;
    private _lambda?;
    /**
     * @stability stable
     */
    get lambda(): IotTopicRuleLambda[];
    /**
     * @stability stable
     */
    set lambda(value: IotTopicRuleLambda[]);
    /**
     * @stability stable
     */
    resetLambda(): void;
    /**
     * @stability stable
     */
    get lambdaInput(): IotTopicRuleLambda[] | undefined;
    private _republish?;
    /**
     * @stability stable
     */
    get republish(): IotTopicRuleRepublish[];
    /**
     * @stability stable
     */
    set republish(value: IotTopicRuleRepublish[]);
    /**
     * @stability stable
     */
    resetRepublish(): void;
    /**
     * @stability stable
     */
    get republishInput(): IotTopicRuleRepublish[] | undefined;
    private _s3?;
    /**
     * @stability stable
     */
    get s3(): IotTopicRuleS3[];
    /**
     * @stability stable
     */
    set s3(value: IotTopicRuleS3[]);
    /**
     * @stability stable
     */
    resetS3(): void;
    /**
     * @stability stable
     */
    get s3Input(): IotTopicRuleS3[] | undefined;
    private _sns?;
    /**
     * @stability stable
     */
    get sns(): IotTopicRuleSns[];
    /**
     * @stability stable
     */
    set sns(value: IotTopicRuleSns[]);
    /**
     * @stability stable
     */
    resetSns(): void;
    /**
     * @stability stable
     */
    get snsInput(): IotTopicRuleSns[] | undefined;
    private _sqs?;
    /**
     * @stability stable
     */
    get sqs(): IotTopicRuleSqs[];
    /**
     * @stability stable
     */
    set sqs(value: IotTopicRuleSqs[]);
    /**
     * @stability stable
     */
    resetSqs(): void;
    /**
     * @stability stable
     */
    get sqsInput(): IotTopicRuleSqs[] | undefined;
    private _stepFunctions?;
    /**
     * @stability stable
     */
    get stepFunctions(): IotTopicRuleStepFunctions[];
    /**
     * @stability stable
     */
    set stepFunctions(value: IotTopicRuleStepFunctions[]);
    /**
     * @stability stable
     */
    resetStepFunctions(): void;
    /**
     * @stability stable
     */
    get stepFunctionsInput(): IotTopicRuleStepFunctions[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
