import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Key Management Service.
 *
 * @stability stable
 */
export interface DataAwsKmsSecretConfig extends cdktf.TerraformMetaArguments {
    /**
     * secret block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/kms_secret#secret DataAwsKmsSecret#secret}
     *
     * @stability stable
     */
    readonly secret: DataAwsKmsSecretSecret[];
}
/**
 * @stability stable
 */
export interface DataAwsKmsSecretSecret {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/kms_secret#context DataAwsKmsSecret#context}.
     *
     * @stability stable
     */
    readonly context?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/kms_secret#grant_tokens DataAwsKmsSecret#grant_tokens}.
     *
     * @stability stable
     */
    readonly grantTokens?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/kms_secret#name DataAwsKmsSecret#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/kms_secret#payload DataAwsKmsSecret#payload}.
     *
     * @stability stable
     */
    readonly payload: string;
}
export declare function dataAwsKmsSecretSecretToTerraform(struct?: DataAwsKmsSecretSecret): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/kms_secret aws_kms_secret}.
 *
 * @stability stable
 */
export declare class DataAwsKmsSecret extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/kms_secret aws_kms_secret} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsKmsSecretConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _secret?;
    /**
     * @stability stable
     */
    get secret(): DataAwsKmsSecretSecret[];
    /**
     * @stability stable
     */
    set secret(value: DataAwsKmsSecretSecret[]);
    /**
     * @stability stable
     */
    get secretInput(): DataAwsKmsSecretSecret[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
