import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Lake Formation.
 *
 * @stability stable
 */
export interface LakeformationDataLakeSettingsConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_data_lake_settings#admins LakeformationDataLakeSettings#admins}.
     *
     * @stability stable
     */
    readonly admins?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_data_lake_settings#catalog_id LakeformationDataLakeSettings#catalog_id}.
     *
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_data_lake_settings#trusted_resource_owners LakeformationDataLakeSettings#trusted_resource_owners}.
     *
     * @stability stable
     */
    readonly trustedResourceOwners?: string[];
    /**
     * create_database_default_permissions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_data_lake_settings#create_database_default_permissions LakeformationDataLakeSettings#create_database_default_permissions}
     *
     * @stability stable
     */
    readonly createDatabaseDefaultPermissions?: LakeformationDataLakeSettingsCreateDatabaseDefaultPermissions[];
    /**
     * create_table_default_permissions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_data_lake_settings#create_table_default_permissions LakeformationDataLakeSettings#create_table_default_permissions}
     *
     * @stability stable
     */
    readonly createTableDefaultPermissions?: LakeformationDataLakeSettingsCreateTableDefaultPermissions[];
}
/**
 * @stability stable
 */
export interface LakeformationDataLakeSettingsCreateDatabaseDefaultPermissions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_data_lake_settings#permissions LakeformationDataLakeSettings#permissions}.
     *
     * @stability stable
     */
    readonly permissions?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_data_lake_settings#principal LakeformationDataLakeSettings#principal}.
     *
     * @stability stable
     */
    readonly principal?: string;
}
export declare function lakeformationDataLakeSettingsCreateDatabaseDefaultPermissionsToTerraform(struct?: LakeformationDataLakeSettingsCreateDatabaseDefaultPermissions): any;
/**
 * @stability stable
 */
export interface LakeformationDataLakeSettingsCreateTableDefaultPermissions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_data_lake_settings#permissions LakeformationDataLakeSettings#permissions}.
     *
     * @stability stable
     */
    readonly permissions?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_data_lake_settings#principal LakeformationDataLakeSettings#principal}.
     *
     * @stability stable
     */
    readonly principal?: string;
}
export declare function lakeformationDataLakeSettingsCreateTableDefaultPermissionsToTerraform(struct?: LakeformationDataLakeSettingsCreateTableDefaultPermissions): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_data_lake_settings aws_lakeformation_data_lake_settings}.
 *
 * @stability stable
 */
export declare class LakeformationDataLakeSettings extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/lakeformation_data_lake_settings aws_lakeformation_data_lake_settings} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: LakeformationDataLakeSettingsConfig);
    private _admins?;
    /**
     * @stability stable
     */
    get admins(): string[];
    /**
     * @stability stable
     */
    set admins(value: string[]);
    /**
     * @stability stable
     */
    resetAdmins(): void;
    /**
     * @stability stable
     */
    get adminsInput(): string[] | undefined;
    private _catalogId?;
    /**
     * @stability stable
     */
    get catalogId(): string;
    /**
     * @stability stable
     */
    set catalogId(value: string);
    /**
     * @stability stable
     */
    resetCatalogId(): void;
    /**
     * @stability stable
     */
    get catalogIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _trustedResourceOwners?;
    /**
     * @stability stable
     */
    get trustedResourceOwners(): string[];
    /**
     * @stability stable
     */
    set trustedResourceOwners(value: string[]);
    /**
     * @stability stable
     */
    resetTrustedResourceOwners(): void;
    /**
     * @stability stable
     */
    get trustedResourceOwnersInput(): string[] | undefined;
    private _createDatabaseDefaultPermissions?;
    /**
     * @stability stable
     */
    get createDatabaseDefaultPermissions(): LakeformationDataLakeSettingsCreateDatabaseDefaultPermissions[];
    /**
     * @stability stable
     */
    set createDatabaseDefaultPermissions(value: LakeformationDataLakeSettingsCreateDatabaseDefaultPermissions[]);
    /**
     * @stability stable
     */
    resetCreateDatabaseDefaultPermissions(): void;
    /**
     * @stability stable
     */
    get createDatabaseDefaultPermissionsInput(): LakeformationDataLakeSettingsCreateDatabaseDefaultPermissions[] | undefined;
    private _createTableDefaultPermissions?;
    /**
     * @stability stable
     */
    get createTableDefaultPermissions(): LakeformationDataLakeSettingsCreateTableDefaultPermissions[];
    /**
     * @stability stable
     */
    set createTableDefaultPermissions(value: LakeformationDataLakeSettingsCreateTableDefaultPermissions[]);
    /**
     * @stability stable
     */
    resetCreateTableDefaultPermissions(): void;
    /**
     * @stability stable
     */
    get createTableDefaultPermissionsInput(): LakeformationDataLakeSettingsCreateTableDefaultPermissions[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
