import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Lambda.
 *
 * @stability stable
 */
export interface DataAwsLambdaCodeSigningConfigConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/lambda_code_signing_config#arn DataAwsLambdaCodeSigningConfig#arn}.
     *
     * @stability stable
     */
    readonly arn: string;
}
/**
 * @stability stable
 */
export declare class DataAwsLambdaCodeSigningConfigAllowedPublishers extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get signingProfileVersionArns(): string[];
}
/**
 * @stability stable
 */
export declare class DataAwsLambdaCodeSigningConfigPolicies extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get untrustedArtifactOnDeployment(): string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/lambda_code_signing_config aws_lambda_code_signing_config}.
 *
 * @stability stable
 */
export declare class DataAwsLambdaCodeSigningConfig extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/lambda_code_signing_config aws_lambda_code_signing_config} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsLambdaCodeSigningConfigConfig);
    /**
     * @stability stable
     */
    allowedPublishers(index: string): DataAwsLambdaCodeSigningConfigAllowedPublishers;
    private _arn?;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    set arn(value: string);
    /**
     * @stability stable
     */
    get arnInput(): string | undefined;
    /**
     * @stability stable
     */
    get configId(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastModified(): string;
    /**
     * @stability stable
     */
    policies(index: string): DataAwsLambdaCodeSigningConfigPolicies;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
