import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Lambda.
 *
 * @stability stable
 */
export interface LambdaPermissionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_permission#action LambdaPermission#action}.
     *
     * @stability stable
     */
    readonly action: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_permission#event_source_token LambdaPermission#event_source_token}.
     *
     * @stability stable
     */
    readonly eventSourceToken?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_permission#function_name LambdaPermission#function_name}.
     *
     * @stability stable
     */
    readonly functionName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_permission#principal LambdaPermission#principal}.
     *
     * @stability stable
     */
    readonly principal: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_permission#qualifier LambdaPermission#qualifier}.
     *
     * @stability stable
     */
    readonly qualifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_permission#source_account LambdaPermission#source_account}.
     *
     * @stability stable
     */
    readonly sourceAccount?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_permission#source_arn LambdaPermission#source_arn}.
     *
     * @stability stable
     */
    readonly sourceArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_permission#statement_id LambdaPermission#statement_id}.
     *
     * @stability stable
     */
    readonly statementId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lambda_permission#statement_id_prefix LambdaPermission#statement_id_prefix}.
     *
     * @stability stable
     */
    readonly statementIdPrefix?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/lambda_permission aws_lambda_permission}.
 *
 * @stability stable
 */
export declare class LambdaPermission extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/lambda_permission aws_lambda_permission} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LambdaPermissionConfig);
    private _action?;
    /**
     * @stability stable
     */
    get action(): string;
    /**
     * @stability stable
     */
    set action(value: string);
    /**
     * @stability stable
     */
    get actionInput(): string | undefined;
    private _eventSourceToken?;
    /**
     * @stability stable
     */
    get eventSourceToken(): string;
    /**
     * @stability stable
     */
    set eventSourceToken(value: string);
    /**
     * @stability stable
     */
    resetEventSourceToken(): void;
    /**
     * @stability stable
     */
    get eventSourceTokenInput(): string | undefined;
    private _functionName?;
    /**
     * @stability stable
     */
    get functionName(): string;
    /**
     * @stability stable
     */
    set functionName(value: string);
    /**
     * @stability stable
     */
    get functionNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _principal?;
    /**
     * @stability stable
     */
    get principal(): string;
    /**
     * @stability stable
     */
    set principal(value: string);
    /**
     * @stability stable
     */
    get principalInput(): string | undefined;
    private _qualifier?;
    /**
     * @stability stable
     */
    get qualifier(): string;
    /**
     * @stability stable
     */
    set qualifier(value: string);
    /**
     * @stability stable
     */
    resetQualifier(): void;
    /**
     * @stability stable
     */
    get qualifierInput(): string | undefined;
    private _sourceAccount?;
    /**
     * @stability stable
     */
    get sourceAccount(): string;
    /**
     * @stability stable
     */
    set sourceAccount(value: string);
    /**
     * @stability stable
     */
    resetSourceAccount(): void;
    /**
     * @stability stable
     */
    get sourceAccountInput(): string | undefined;
    private _sourceArn?;
    /**
     * @stability stable
     */
    get sourceArn(): string;
    /**
     * @stability stable
     */
    set sourceArn(value: string);
    /**
     * @stability stable
     */
    resetSourceArn(): void;
    /**
     * @stability stable
     */
    get sourceArnInput(): string | undefined;
    private _statementId?;
    /**
     * @stability stable
     */
    get statementId(): string;
    /**
     * @stability stable
     */
    set statementId(value: string);
    /**
     * @stability stable
     */
    resetStatementId(): void;
    /**
     * @stability stable
     */
    get statementIdInput(): string | undefined;
    private _statementIdPrefix?;
    /**
     * @stability stable
     */
    get statementIdPrefix(): string;
    /**
     * @stability stable
     */
    set statementIdPrefix(value: string);
    /**
     * @stability stable
     */
    resetStatementIdPrefix(): void;
    /**
     * @stability stable
     */
    get statementIdPrefixInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
