import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS License Manager.
 *
 * @stability stable
 */
export interface LicensemanagerAssociationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/licensemanager_association#license_configuration_arn LicensemanagerAssociation#license_configuration_arn}.
     *
     * @stability stable
     */
    readonly licenseConfigurationArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/licensemanager_association#resource_arn LicensemanagerAssociation#resource_arn}.
     *
     * @stability stable
     */
    readonly resourceArn: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/licensemanager_association aws_licensemanager_association}.
 *
 * @stability stable
 */
export declare class LicensemanagerAssociation extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/licensemanager_association aws_licensemanager_association} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LicensemanagerAssociationConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _licenseConfigurationArn?;
    /**
     * @stability stable
     */
    get licenseConfigurationArn(): string;
    /**
     * @stability stable
     */
    set licenseConfigurationArn(value: string);
    /**
     * @stability stable
     */
    get licenseConfigurationArnInput(): string | undefined;
    private _resourceArn?;
    /**
     * @stability stable
     */
    get resourceArn(): string;
    /**
     * @stability stable
     */
    set resourceArn(value: string);
    /**
     * @stability stable
     */
    get resourceArnInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
