import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Macie 2.
 *
 * @stability stable
 */
export interface Macie2ClassificationJobConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#custom_data_identifier_ids Macie2ClassificationJob#custom_data_identifier_ids}.
     *
     * @stability stable
     */
    readonly customDataIdentifierIds?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#description Macie2ClassificationJob#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#initial_run Macie2ClassificationJob#initial_run}.
     *
     * @stability stable
     */
    readonly initialRun?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#job_status Macie2ClassificationJob#job_status}.
     *
     * @stability stable
     */
    readonly jobStatus?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#job_type Macie2ClassificationJob#job_type}.
     *
     * @stability stable
     */
    readonly jobType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#name Macie2ClassificationJob#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#name_prefix Macie2ClassificationJob#name_prefix}.
     *
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#sampling_percentage Macie2ClassificationJob#sampling_percentage}.
     *
     * @stability stable
     */
    readonly samplingPercentage?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#tags Macie2ClassificationJob#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#tags_all Macie2ClassificationJob#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * s3_job_definition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#s3_job_definition Macie2ClassificationJob#s3_job_definition}
     *
     * @stability stable
     */
    readonly s3JobDefinition: Macie2ClassificationJobS3JobDefinition;
    /**
     * schedule_frequency block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#schedule_frequency Macie2ClassificationJob#schedule_frequency}
     *
     * @stability stable
     */
    readonly scheduleFrequency?: Macie2ClassificationJobScheduleFrequency;
}
/**
 * @stability stable
 */
export declare class Macie2ClassificationJobUserPausedDetails extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get jobExpiresAt(): string;
    /**
     * @stability stable
     */
    get jobImminentExpirationHealthEventArn(): string;
    /**
     * @stability stable
     */
    get jobPausedAt(): string;
}
/**
 * @stability stable
 */
export interface Macie2ClassificationJobS3JobDefinitionBucketDefinitions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#account_id Macie2ClassificationJob#account_id}.
     *
     * @stability stable
     */
    readonly accountId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#buckets Macie2ClassificationJob#buckets}.
     *
     * @stability stable
     */
    readonly buckets: string[];
}
export declare function macie2ClassificationJobS3JobDefinitionBucketDefinitionsToTerraform(struct?: Macie2ClassificationJobS3JobDefinitionBucketDefinitions): any;
/**
 * @stability stable
 */
export interface Macie2ClassificationJobS3JobDefinitionScopingExcludesAndSimpleScopeTerm {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#comparator Macie2ClassificationJob#comparator}.
     *
     * @stability stable
     */
    readonly comparator?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#key Macie2ClassificationJob#key}.
     *
     * @stability stable
     */
    readonly key?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#values Macie2ClassificationJob#values}.
     *
     * @stability stable
     */
    readonly values?: string[];
}
export declare function macie2ClassificationJobS3JobDefinitionScopingExcludesAndSimpleScopeTermToTerraform(struct?: Macie2ClassificationJobS3JobDefinitionScopingExcludesAndSimpleScopeTermOutputReference | Macie2ClassificationJobS3JobDefinitionScopingExcludesAndSimpleScopeTerm): any;
/**
 * @stability stable
 */
export declare class Macie2ClassificationJobS3JobDefinitionScopingExcludesAndSimpleScopeTermOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Macie2ClassificationJobS3JobDefinitionScopingExcludesAndSimpleScopeTerm | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Macie2ClassificationJobS3JobDefinitionScopingExcludesAndSimpleScopeTerm | undefined);
    private _comparator?;
    /**
     * @stability stable
     */
    get comparator(): string;
    /**
     * @stability stable
     */
    set comparator(value: string);
    /**
     * @stability stable
     */
    resetComparator(): void;
    /**
     * @stability stable
     */
    get comparatorInput(): string | undefined;
    private _key?;
    /**
     * @stability stable
     */
    get key(): string;
    /**
     * @stability stable
     */
    set key(value: string);
    /**
     * @stability stable
     */
    resetKey(): void;
    /**
     * @stability stable
     */
    get keyInput(): string | undefined;
    private _values?;
    /**
     * @stability stable
     */
    get values(): string[];
    /**
     * @stability stable
     */
    set values(value: string[]);
    /**
     * @stability stable
     */
    resetValues(): void;
    /**
     * @stability stable
     */
    get valuesInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface Macie2ClassificationJobS3JobDefinitionScopingExcludesAndTagScopeTermTagValues {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#key Macie2ClassificationJob#key}.
     *
     * @stability stable
     */
    readonly key?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#value Macie2ClassificationJob#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
export declare function macie2ClassificationJobS3JobDefinitionScopingExcludesAndTagScopeTermTagValuesToTerraform(struct?: Macie2ClassificationJobS3JobDefinitionScopingExcludesAndTagScopeTermTagValues): any;
/**
 * @stability stable
 */
export interface Macie2ClassificationJobS3JobDefinitionScopingExcludesAndTagScopeTerm {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#comparator Macie2ClassificationJob#comparator}.
     *
     * @stability stable
     */
    readonly comparator?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#key Macie2ClassificationJob#key}.
     *
     * @stability stable
     */
    readonly key?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#target Macie2ClassificationJob#target}.
     *
     * @stability stable
     */
    readonly target?: string;
    /**
     * tag_values block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#tag_values Macie2ClassificationJob#tag_values}
     *
     * @stability stable
     */
    readonly tagValues?: Macie2ClassificationJobS3JobDefinitionScopingExcludesAndTagScopeTermTagValues[];
}
export declare function macie2ClassificationJobS3JobDefinitionScopingExcludesAndTagScopeTermToTerraform(struct?: Macie2ClassificationJobS3JobDefinitionScopingExcludesAndTagScopeTermOutputReference | Macie2ClassificationJobS3JobDefinitionScopingExcludesAndTagScopeTerm): any;
/**
 * @stability stable
 */
export declare class Macie2ClassificationJobS3JobDefinitionScopingExcludesAndTagScopeTermOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Macie2ClassificationJobS3JobDefinitionScopingExcludesAndTagScopeTerm | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Macie2ClassificationJobS3JobDefinitionScopingExcludesAndTagScopeTerm | undefined);
    private _comparator?;
    /**
     * @stability stable
     */
    get comparator(): string;
    /**
     * @stability stable
     */
    set comparator(value: string);
    /**
     * @stability stable
     */
    resetComparator(): void;
    /**
     * @stability stable
     */
    get comparatorInput(): string | undefined;
    private _key?;
    /**
     * @stability stable
     */
    get key(): string;
    /**
     * @stability stable
     */
    set key(value: string);
    /**
     * @stability stable
     */
    resetKey(): void;
    /**
     * @stability stable
     */
    get keyInput(): string | undefined;
    private _target?;
    /**
     * @stability stable
     */
    get target(): string;
    /**
     * @stability stable
     */
    set target(value: string);
    /**
     * @stability stable
     */
    resetTarget(): void;
    /**
     * @stability stable
     */
    get targetInput(): string | undefined;
    private _tagValues?;
    /**
     * @stability stable
     */
    get tagValues(): Macie2ClassificationJobS3JobDefinitionScopingExcludesAndTagScopeTermTagValues[];
    /**
     * @stability stable
     */
    set tagValues(value: Macie2ClassificationJobS3JobDefinitionScopingExcludesAndTagScopeTermTagValues[]);
    /**
     * @stability stable
     */
    resetTagValues(): void;
    /**
     * @stability stable
     */
    get tagValuesInput(): Macie2ClassificationJobS3JobDefinitionScopingExcludesAndTagScopeTermTagValues[] | undefined;
}
/**
 * @stability stable
 */
export interface Macie2ClassificationJobS3JobDefinitionScopingExcludesAnd {
    /**
     * simple_scope_term block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#simple_scope_term Macie2ClassificationJob#simple_scope_term}
     *
     * @stability stable
     */
    readonly simpleScopeTerm?: Macie2ClassificationJobS3JobDefinitionScopingExcludesAndSimpleScopeTerm;
    /**
     * tag_scope_term block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#tag_scope_term Macie2ClassificationJob#tag_scope_term}
     *
     * @stability stable
     */
    readonly tagScopeTerm?: Macie2ClassificationJobS3JobDefinitionScopingExcludesAndTagScopeTerm;
}
export declare function macie2ClassificationJobS3JobDefinitionScopingExcludesAndToTerraform(struct?: Macie2ClassificationJobS3JobDefinitionScopingExcludesAnd): any;
/**
 * @stability stable
 */
export interface Macie2ClassificationJobS3JobDefinitionScopingExcludes {
    /**
     * and block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#and Macie2ClassificationJob#and}
     *
     * @stability stable
     */
    readonly and?: Macie2ClassificationJobS3JobDefinitionScopingExcludesAnd[];
}
export declare function macie2ClassificationJobS3JobDefinitionScopingExcludesToTerraform(struct?: Macie2ClassificationJobS3JobDefinitionScopingExcludesOutputReference | Macie2ClassificationJobS3JobDefinitionScopingExcludes): any;
/**
 * @stability stable
 */
export declare class Macie2ClassificationJobS3JobDefinitionScopingExcludesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Macie2ClassificationJobS3JobDefinitionScopingExcludes | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Macie2ClassificationJobS3JobDefinitionScopingExcludes | undefined);
    private _and?;
    /**
     * @stability stable
     */
    get and(): Macie2ClassificationJobS3JobDefinitionScopingExcludesAnd[];
    /**
     * @stability stable
     */
    set and(value: Macie2ClassificationJobS3JobDefinitionScopingExcludesAnd[]);
    /**
     * @stability stable
     */
    resetAnd(): void;
    /**
     * @stability stable
     */
    get andInput(): Macie2ClassificationJobS3JobDefinitionScopingExcludesAnd[] | undefined;
}
/**
 * @stability stable
 */
export interface Macie2ClassificationJobS3JobDefinitionScopingIncludesAndSimpleScopeTerm {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#comparator Macie2ClassificationJob#comparator}.
     *
     * @stability stable
     */
    readonly comparator?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#key Macie2ClassificationJob#key}.
     *
     * @stability stable
     */
    readonly key?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#values Macie2ClassificationJob#values}.
     *
     * @stability stable
     */
    readonly values?: string[];
}
export declare function macie2ClassificationJobS3JobDefinitionScopingIncludesAndSimpleScopeTermToTerraform(struct?: Macie2ClassificationJobS3JobDefinitionScopingIncludesAndSimpleScopeTermOutputReference | Macie2ClassificationJobS3JobDefinitionScopingIncludesAndSimpleScopeTerm): any;
/**
 * @stability stable
 */
export declare class Macie2ClassificationJobS3JobDefinitionScopingIncludesAndSimpleScopeTermOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Macie2ClassificationJobS3JobDefinitionScopingIncludesAndSimpleScopeTerm | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Macie2ClassificationJobS3JobDefinitionScopingIncludesAndSimpleScopeTerm | undefined);
    private _comparator?;
    /**
     * @stability stable
     */
    get comparator(): string;
    /**
     * @stability stable
     */
    set comparator(value: string);
    /**
     * @stability stable
     */
    resetComparator(): void;
    /**
     * @stability stable
     */
    get comparatorInput(): string | undefined;
    private _key?;
    /**
     * @stability stable
     */
    get key(): string;
    /**
     * @stability stable
     */
    set key(value: string);
    /**
     * @stability stable
     */
    resetKey(): void;
    /**
     * @stability stable
     */
    get keyInput(): string | undefined;
    private _values?;
    /**
     * @stability stable
     */
    get values(): string[];
    /**
     * @stability stable
     */
    set values(value: string[]);
    /**
     * @stability stable
     */
    resetValues(): void;
    /**
     * @stability stable
     */
    get valuesInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface Macie2ClassificationJobS3JobDefinitionScopingIncludesAndTagScopeTermTagValues {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#key Macie2ClassificationJob#key}.
     *
     * @stability stable
     */
    readonly key?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#value Macie2ClassificationJob#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
export declare function macie2ClassificationJobS3JobDefinitionScopingIncludesAndTagScopeTermTagValuesToTerraform(struct?: Macie2ClassificationJobS3JobDefinitionScopingIncludesAndTagScopeTermTagValues): any;
/**
 * @stability stable
 */
export interface Macie2ClassificationJobS3JobDefinitionScopingIncludesAndTagScopeTerm {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#comparator Macie2ClassificationJob#comparator}.
     *
     * @stability stable
     */
    readonly comparator?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#key Macie2ClassificationJob#key}.
     *
     * @stability stable
     */
    readonly key?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#target Macie2ClassificationJob#target}.
     *
     * @stability stable
     */
    readonly target?: string;
    /**
     * tag_values block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#tag_values Macie2ClassificationJob#tag_values}
     *
     * @stability stable
     */
    readonly tagValues?: Macie2ClassificationJobS3JobDefinitionScopingIncludesAndTagScopeTermTagValues[];
}
export declare function macie2ClassificationJobS3JobDefinitionScopingIncludesAndTagScopeTermToTerraform(struct?: Macie2ClassificationJobS3JobDefinitionScopingIncludesAndTagScopeTermOutputReference | Macie2ClassificationJobS3JobDefinitionScopingIncludesAndTagScopeTerm): any;
/**
 * @stability stable
 */
export declare class Macie2ClassificationJobS3JobDefinitionScopingIncludesAndTagScopeTermOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Macie2ClassificationJobS3JobDefinitionScopingIncludesAndTagScopeTerm | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Macie2ClassificationJobS3JobDefinitionScopingIncludesAndTagScopeTerm | undefined);
    private _comparator?;
    /**
     * @stability stable
     */
    get comparator(): string;
    /**
     * @stability stable
     */
    set comparator(value: string);
    /**
     * @stability stable
     */
    resetComparator(): void;
    /**
     * @stability stable
     */
    get comparatorInput(): string | undefined;
    private _key?;
    /**
     * @stability stable
     */
    get key(): string;
    /**
     * @stability stable
     */
    set key(value: string);
    /**
     * @stability stable
     */
    resetKey(): void;
    /**
     * @stability stable
     */
    get keyInput(): string | undefined;
    private _target?;
    /**
     * @stability stable
     */
    get target(): string;
    /**
     * @stability stable
     */
    set target(value: string);
    /**
     * @stability stable
     */
    resetTarget(): void;
    /**
     * @stability stable
     */
    get targetInput(): string | undefined;
    private _tagValues?;
    /**
     * @stability stable
     */
    get tagValues(): Macie2ClassificationJobS3JobDefinitionScopingIncludesAndTagScopeTermTagValues[];
    /**
     * @stability stable
     */
    set tagValues(value: Macie2ClassificationJobS3JobDefinitionScopingIncludesAndTagScopeTermTagValues[]);
    /**
     * @stability stable
     */
    resetTagValues(): void;
    /**
     * @stability stable
     */
    get tagValuesInput(): Macie2ClassificationJobS3JobDefinitionScopingIncludesAndTagScopeTermTagValues[] | undefined;
}
/**
 * @stability stable
 */
export interface Macie2ClassificationJobS3JobDefinitionScopingIncludesAnd {
    /**
     * simple_scope_term block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#simple_scope_term Macie2ClassificationJob#simple_scope_term}
     *
     * @stability stable
     */
    readonly simpleScopeTerm?: Macie2ClassificationJobS3JobDefinitionScopingIncludesAndSimpleScopeTerm;
    /**
     * tag_scope_term block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#tag_scope_term Macie2ClassificationJob#tag_scope_term}
     *
     * @stability stable
     */
    readonly tagScopeTerm?: Macie2ClassificationJobS3JobDefinitionScopingIncludesAndTagScopeTerm;
}
export declare function macie2ClassificationJobS3JobDefinitionScopingIncludesAndToTerraform(struct?: Macie2ClassificationJobS3JobDefinitionScopingIncludesAnd): any;
/**
 * @stability stable
 */
export interface Macie2ClassificationJobS3JobDefinitionScopingIncludes {
    /**
     * and block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#and Macie2ClassificationJob#and}
     *
     * @stability stable
     */
    readonly and?: Macie2ClassificationJobS3JobDefinitionScopingIncludesAnd[];
}
export declare function macie2ClassificationJobS3JobDefinitionScopingIncludesToTerraform(struct?: Macie2ClassificationJobS3JobDefinitionScopingIncludesOutputReference | Macie2ClassificationJobS3JobDefinitionScopingIncludes): any;
/**
 * @stability stable
 */
export declare class Macie2ClassificationJobS3JobDefinitionScopingIncludesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Macie2ClassificationJobS3JobDefinitionScopingIncludes | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Macie2ClassificationJobS3JobDefinitionScopingIncludes | undefined);
    private _and?;
    /**
     * @stability stable
     */
    get and(): Macie2ClassificationJobS3JobDefinitionScopingIncludesAnd[];
    /**
     * @stability stable
     */
    set and(value: Macie2ClassificationJobS3JobDefinitionScopingIncludesAnd[]);
    /**
     * @stability stable
     */
    resetAnd(): void;
    /**
     * @stability stable
     */
    get andInput(): Macie2ClassificationJobS3JobDefinitionScopingIncludesAnd[] | undefined;
}
/**
 * @stability stable
 */
export interface Macie2ClassificationJobS3JobDefinitionScoping {
    /**
     * excludes block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#excludes Macie2ClassificationJob#excludes}
     *
     * @stability stable
     */
    readonly excludes?: Macie2ClassificationJobS3JobDefinitionScopingExcludes;
    /**
     * includes block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#includes Macie2ClassificationJob#includes}
     *
     * @stability stable
     */
    readonly includes?: Macie2ClassificationJobS3JobDefinitionScopingIncludes;
}
export declare function macie2ClassificationJobS3JobDefinitionScopingToTerraform(struct?: Macie2ClassificationJobS3JobDefinitionScopingOutputReference | Macie2ClassificationJobS3JobDefinitionScoping): any;
/**
 * @stability stable
 */
export declare class Macie2ClassificationJobS3JobDefinitionScopingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Macie2ClassificationJobS3JobDefinitionScoping | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Macie2ClassificationJobS3JobDefinitionScoping | undefined);
    private _excludes;
    /**
     * @stability stable
     */
    get excludes(): Macie2ClassificationJobS3JobDefinitionScopingExcludesOutputReference;
    /**
     * @stability stable
     */
    putExcludes(value: Macie2ClassificationJobS3JobDefinitionScopingExcludes): void;
    /**
     * @stability stable
     */
    resetExcludes(): void;
    /**
     * @stability stable
     */
    get excludesInput(): Macie2ClassificationJobS3JobDefinitionScopingExcludes | undefined;
    private _includes;
    /**
     * @stability stable
     */
    get includes(): Macie2ClassificationJobS3JobDefinitionScopingIncludesOutputReference;
    /**
     * @stability stable
     */
    putIncludes(value: Macie2ClassificationJobS3JobDefinitionScopingIncludes): void;
    /**
     * @stability stable
     */
    resetIncludes(): void;
    /**
     * @stability stable
     */
    get includesInput(): Macie2ClassificationJobS3JobDefinitionScopingIncludes | undefined;
}
/**
 * @stability stable
 */
export interface Macie2ClassificationJobS3JobDefinition {
    /**
     * bucket_definitions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#bucket_definitions Macie2ClassificationJob#bucket_definitions}
     *
     * @stability stable
     */
    readonly bucketDefinitions?: Macie2ClassificationJobS3JobDefinitionBucketDefinitions[];
    /**
     * scoping block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#scoping Macie2ClassificationJob#scoping}
     *
     * @stability stable
     */
    readonly scoping?: Macie2ClassificationJobS3JobDefinitionScoping;
}
export declare function macie2ClassificationJobS3JobDefinitionToTerraform(struct?: Macie2ClassificationJobS3JobDefinitionOutputReference | Macie2ClassificationJobS3JobDefinition): any;
/**
 * @stability stable
 */
export declare class Macie2ClassificationJobS3JobDefinitionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Macie2ClassificationJobS3JobDefinition | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Macie2ClassificationJobS3JobDefinition | undefined);
    private _bucketDefinitions?;
    /**
     * @stability stable
     */
    get bucketDefinitions(): Macie2ClassificationJobS3JobDefinitionBucketDefinitions[];
    /**
     * @stability stable
     */
    set bucketDefinitions(value: Macie2ClassificationJobS3JobDefinitionBucketDefinitions[]);
    /**
     * @stability stable
     */
    resetBucketDefinitions(): void;
    /**
     * @stability stable
     */
    get bucketDefinitionsInput(): Macie2ClassificationJobS3JobDefinitionBucketDefinitions[] | undefined;
    private _scoping;
    /**
     * @stability stable
     */
    get scoping(): Macie2ClassificationJobS3JobDefinitionScopingOutputReference;
    /**
     * @stability stable
     */
    putScoping(value: Macie2ClassificationJobS3JobDefinitionScoping): void;
    /**
     * @stability stable
     */
    resetScoping(): void;
    /**
     * @stability stable
     */
    get scopingInput(): Macie2ClassificationJobS3JobDefinitionScoping | undefined;
}
/**
 * @stability stable
 */
export interface Macie2ClassificationJobScheduleFrequency {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#daily_schedule Macie2ClassificationJob#daily_schedule}.
     *
     * @stability stable
     */
    readonly dailySchedule?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#monthly_schedule Macie2ClassificationJob#monthly_schedule}.
     *
     * @stability stable
     */
    readonly monthlySchedule?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job#weekly_schedule Macie2ClassificationJob#weekly_schedule}.
     *
     * @stability stable
     */
    readonly weeklySchedule?: string;
}
export declare function macie2ClassificationJobScheduleFrequencyToTerraform(struct?: Macie2ClassificationJobScheduleFrequencyOutputReference | Macie2ClassificationJobScheduleFrequency): any;
/**
 * @stability stable
 */
export declare class Macie2ClassificationJobScheduleFrequencyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Macie2ClassificationJobScheduleFrequency | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Macie2ClassificationJobScheduleFrequency | undefined);
    private _dailySchedule?;
    /**
     * @stability stable
     */
    get dailySchedule(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set dailySchedule(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetDailySchedule(): void;
    /**
     * @stability stable
     */
    get dailyScheduleInput(): boolean | cdktf.IResolvable | undefined;
    private _monthlySchedule?;
    /**
     * @stability stable
     */
    get monthlySchedule(): number;
    /**
     * @stability stable
     */
    set monthlySchedule(value: number);
    /**
     * @stability stable
     */
    resetMonthlySchedule(): void;
    /**
     * @stability stable
     */
    get monthlyScheduleInput(): number | undefined;
    private _weeklySchedule?;
    /**
     * @stability stable
     */
    get weeklySchedule(): string;
    /**
     * @stability stable
     */
    set weeklySchedule(value: string);
    /**
     * @stability stable
     */
    resetWeeklySchedule(): void;
    /**
     * @stability stable
     */
    get weeklyScheduleInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job aws_macie2_classification_job}.
 *
 * @stability stable
 */
export declare class Macie2ClassificationJob extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/macie2_classification_job aws_macie2_classification_job} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Macie2ClassificationJobConfig);
    /**
     * @stability stable
     */
    get createdAt(): string;
    private _customDataIdentifierIds?;
    /**
     * @stability stable
     */
    get customDataIdentifierIds(): string[];
    /**
     * @stability stable
     */
    set customDataIdentifierIds(value: string[]);
    /**
     * @stability stable
     */
    resetCustomDataIdentifierIds(): void;
    /**
     * @stability stable
     */
    get customDataIdentifierIdsInput(): string[] | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _initialRun?;
    /**
     * @stability stable
     */
    get initialRun(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set initialRun(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetInitialRun(): void;
    /**
     * @stability stable
     */
    get initialRunInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get jobArn(): string;
    /**
     * @stability stable
     */
    get jobId(): string;
    private _jobStatus?;
    /**
     * @stability stable
     */
    get jobStatus(): string;
    /**
     * @stability stable
     */
    set jobStatus(value: string);
    /**
     * @stability stable
     */
    resetJobStatus(): void;
    /**
     * @stability stable
     */
    get jobStatusInput(): string | undefined;
    private _jobType?;
    /**
     * @stability stable
     */
    get jobType(): string;
    /**
     * @stability stable
     */
    set jobType(value: string);
    /**
     * @stability stable
     */
    get jobTypeInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _samplingPercentage?;
    /**
     * @stability stable
     */
    get samplingPercentage(): number;
    /**
     * @stability stable
     */
    set samplingPercentage(value: number);
    /**
     * @stability stable
     */
    resetSamplingPercentage(): void;
    /**
     * @stability stable
     */
    get samplingPercentageInput(): number | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    userPausedDetails(index: string): Macie2ClassificationJobUserPausedDetails;
    private _s3JobDefinition;
    /**
     * @stability stable
     */
    get s3JobDefinition(): Macie2ClassificationJobS3JobDefinitionOutputReference;
    /**
     * @stability stable
     */
    putS3JobDefinition(value: Macie2ClassificationJobS3JobDefinition): void;
    /**
     * @stability stable
     */
    get s3JobDefinitionInput(): Macie2ClassificationJobS3JobDefinition | undefined;
    private _scheduleFrequency;
    /**
     * @stability stable
     */
    get scheduleFrequency(): Macie2ClassificationJobScheduleFrequencyOutputReference;
    /**
     * @stability stable
     */
    putScheduleFrequency(value: Macie2ClassificationJobScheduleFrequency): void;
    /**
     * @stability stable
     */
    resetScheduleFrequency(): void;
    /**
     * @stability stable
     */
    get scheduleFrequencyInput(): Macie2ClassificationJobScheduleFrequency | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
