import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Macie 2.
 *
 * @stability stable
 */
export interface Macie2InvitationAccepterConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_invitation_accepter#administrator_account_id Macie2InvitationAccepter#administrator_account_id}.
     *
     * @stability stable
     */
    readonly administratorAccountId: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_invitation_accepter#timeouts Macie2InvitationAccepter#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: Macie2InvitationAccepterTimeouts;
}
/**
 * @stability stable
 */
export interface Macie2InvitationAccepterTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/macie2_invitation_accepter#create Macie2InvitationAccepter#create}.
     *
     * @stability stable
     */
    readonly create?: string;
}
export declare function macie2InvitationAccepterTimeoutsToTerraform(struct?: Macie2InvitationAccepterTimeoutsOutputReference | Macie2InvitationAccepterTimeouts): any;
/**
 * @stability stable
 */
export declare class Macie2InvitationAccepterTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Macie2InvitationAccepterTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Macie2InvitationAccepterTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/macie2_invitation_accepter aws_macie2_invitation_accepter}.
 *
 * @stability stable
 */
export declare class Macie2InvitationAccepter extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/macie2_invitation_accepter aws_macie2_invitation_accepter} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Macie2InvitationAccepterConfig);
    private _administratorAccountId?;
    /**
     * @stability stable
     */
    get administratorAccountId(): string;
    /**
     * @stability stable
     */
    set administratorAccountId(value: string);
    /**
     * @stability stable
     */
    get administratorAccountIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get invitationId(): string;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): Macie2InvitationAccepterTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: Macie2InvitationAccepterTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): Macie2InvitationAccepterTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
