import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Managed Streaming for Kafka.
 *
 * @stability stable
 */
export interface MskconnectCustomPluginConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mskconnect_custom_plugin#content_type MskconnectCustomPlugin#content_type}.
     *
     * @stability stable
     */
    readonly contentType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mskconnect_custom_plugin#description MskconnectCustomPlugin#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mskconnect_custom_plugin#name MskconnectCustomPlugin#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * location block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mskconnect_custom_plugin#location MskconnectCustomPlugin#location}
     *
     * @stability stable
     */
    readonly location: MskconnectCustomPluginLocation;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mskconnect_custom_plugin#timeouts MskconnectCustomPlugin#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: MskconnectCustomPluginTimeouts;
}
/**
 * @stability stable
 */
export interface MskconnectCustomPluginLocationS3 {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mskconnect_custom_plugin#bucket_arn MskconnectCustomPlugin#bucket_arn}.
     *
     * @stability stable
     */
    readonly bucketArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mskconnect_custom_plugin#file_key MskconnectCustomPlugin#file_key}.
     *
     * @stability stable
     */
    readonly fileKey: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mskconnect_custom_plugin#object_version MskconnectCustomPlugin#object_version}.
     *
     * @stability stable
     */
    readonly objectVersion?: string;
}
export declare function mskconnectCustomPluginLocationS3ToTerraform(struct?: MskconnectCustomPluginLocationS3OutputReference | MskconnectCustomPluginLocationS3): any;
/**
 * @stability stable
 */
export declare class MskconnectCustomPluginLocationS3OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): MskconnectCustomPluginLocationS3 | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: MskconnectCustomPluginLocationS3 | undefined);
    private _bucketArn?;
    /**
     * @stability stable
     */
    get bucketArn(): string;
    /**
     * @stability stable
     */
    set bucketArn(value: string);
    /**
     * @stability stable
     */
    get bucketArnInput(): string | undefined;
    private _fileKey?;
    /**
     * @stability stable
     */
    get fileKey(): string;
    /**
     * @stability stable
     */
    set fileKey(value: string);
    /**
     * @stability stable
     */
    get fileKeyInput(): string | undefined;
    private _objectVersion?;
    /**
     * @stability stable
     */
    get objectVersion(): string;
    /**
     * @stability stable
     */
    set objectVersion(value: string);
    /**
     * @stability stable
     */
    resetObjectVersion(): void;
    /**
     * @stability stable
     */
    get objectVersionInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface MskconnectCustomPluginLocation {
    /**
     * s3 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mskconnect_custom_plugin#s3 MskconnectCustomPlugin#s3}
     *
     * @stability stable
     */
    readonly s3: MskconnectCustomPluginLocationS3;
}
export declare function mskconnectCustomPluginLocationToTerraform(struct?: MskconnectCustomPluginLocationOutputReference | MskconnectCustomPluginLocation): any;
/**
 * @stability stable
 */
export declare class MskconnectCustomPluginLocationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): MskconnectCustomPluginLocation | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: MskconnectCustomPluginLocation | undefined);
    private _s3;
    /**
     * @stability stable
     */
    get s3(): MskconnectCustomPluginLocationS3OutputReference;
    /**
     * @stability stable
     */
    putS3(value: MskconnectCustomPluginLocationS3): void;
    /**
     * @stability stable
     */
    get s3Input(): MskconnectCustomPluginLocationS3 | undefined;
}
/**
 * @stability stable
 */
export interface MskconnectCustomPluginTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/mskconnect_custom_plugin#create MskconnectCustomPlugin#create}.
     *
     * @stability stable
     */
    readonly create?: string;
}
export declare function mskconnectCustomPluginTimeoutsToTerraform(struct?: MskconnectCustomPluginTimeoutsOutputReference | MskconnectCustomPluginTimeouts): any;
/**
 * @stability stable
 */
export declare class MskconnectCustomPluginTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): MskconnectCustomPluginTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: MskconnectCustomPluginTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/mskconnect_custom_plugin aws_mskconnect_custom_plugin}.
 *
 * @stability stable
 */
export declare class MskconnectCustomPlugin extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/mskconnect_custom_plugin aws_mskconnect_custom_plugin} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: MskconnectCustomPluginConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _contentType?;
    /**
     * @stability stable
     */
    get contentType(): string;
    /**
     * @stability stable
     */
    set contentType(value: string);
    /**
     * @stability stable
     */
    get contentTypeInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get latestRevision(): number;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get state(): string;
    private _location;
    /**
     * @stability stable
     */
    get location(): MskconnectCustomPluginLocationOutputReference;
    /**
     * @stability stable
     */
    putLocation(value: MskconnectCustomPluginLocation): void;
    /**
     * @stability stable
     */
    get locationInput(): MskconnectCustomPluginLocation | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): MskconnectCustomPluginTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: MskconnectCustomPluginTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): MskconnectCustomPluginTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
