import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Neptune.
 *
 * @stability stable
 */
export interface DataAwsNeptuneOrderableDbInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/neptune_orderable_db_instance#engine DataAwsNeptuneOrderableDbInstance#engine}.
     *
     * @stability stable
     */
    readonly engine?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/neptune_orderable_db_instance#engine_version DataAwsNeptuneOrderableDbInstance#engine_version}.
     *
     * @stability stable
     */
    readonly engineVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/neptune_orderable_db_instance#instance_class DataAwsNeptuneOrderableDbInstance#instance_class}.
     *
     * @stability stable
     */
    readonly instanceClass?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/neptune_orderable_db_instance#license_model DataAwsNeptuneOrderableDbInstance#license_model}.
     *
     * @stability stable
     */
    readonly licenseModel?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/neptune_orderable_db_instance#preferred_instance_classes DataAwsNeptuneOrderableDbInstance#preferred_instance_classes}.
     *
     * @stability stable
     */
    readonly preferredInstanceClasses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/neptune_orderable_db_instance#vpc DataAwsNeptuneOrderableDbInstance#vpc}.
     *
     * @stability stable
     */
    readonly vpc?: boolean | cdktf.IResolvable;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/neptune_orderable_db_instance aws_neptune_orderable_db_instance}.
 *
 * @stability stable
 */
export declare class DataAwsNeptuneOrderableDbInstance extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/neptune_orderable_db_instance aws_neptune_orderable_db_instance} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsNeptuneOrderableDbInstanceConfig);
    /**
     * @stability stable
     */
    get availabilityZones(): string[];
    private _engine?;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    set engine(value: string);
    /**
     * @stability stable
     */
    resetEngine(): void;
    /**
     * @stability stable
     */
    get engineInput(): string | undefined;
    private _engineVersion?;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    set engineVersion(value: string);
    /**
     * @stability stable
     */
    resetEngineVersion(): void;
    /**
     * @stability stable
     */
    get engineVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceClass?;
    /**
     * @stability stable
     */
    get instanceClass(): string;
    /**
     * @stability stable
     */
    set instanceClass(value: string);
    /**
     * @stability stable
     */
    resetInstanceClass(): void;
    /**
     * @stability stable
     */
    get instanceClassInput(): string | undefined;
    private _licenseModel?;
    /**
     * @stability stable
     */
    get licenseModel(): string;
    /**
     * @stability stable
     */
    set licenseModel(value: string);
    /**
     * @stability stable
     */
    resetLicenseModel(): void;
    /**
     * @stability stable
     */
    get licenseModelInput(): string | undefined;
    /**
     * @stability stable
     */
    get maxIopsPerDbInstance(): number;
    /**
     * @stability stable
     */
    get maxIopsPerGib(): number;
    /**
     * @stability stable
     */
    get maxStorageSize(): number;
    /**
     * @stability stable
     */
    get minIopsPerDbInstance(): number;
    /**
     * @stability stable
     */
    get minIopsPerGib(): number;
    /**
     * @stability stable
     */
    get minStorageSize(): number;
    /**
     * @stability stable
     */
    get multiAzCapable(): any;
    private _preferredInstanceClasses?;
    /**
     * @stability stable
     */
    get preferredInstanceClasses(): string[];
    /**
     * @stability stable
     */
    set preferredInstanceClasses(value: string[]);
    /**
     * @stability stable
     */
    resetPreferredInstanceClasses(): void;
    /**
     * @stability stable
     */
    get preferredInstanceClassesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get readReplicaCapable(): any;
    /**
     * @stability stable
     */
    get storageType(): string;
    /**
     * @stability stable
     */
    get supportsEnhancedMonitoring(): any;
    /**
     * @stability stable
     */
    get supportsIamDatabaseAuthentication(): any;
    /**
     * @stability stable
     */
    get supportsIops(): any;
    /**
     * @stability stable
     */
    get supportsPerformanceInsights(): any;
    /**
     * @stability stable
     */
    get supportsStorageEncryption(): any;
    private _vpc?;
    /**
     * @stability stable
     */
    get vpc(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set vpc(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetVpc(): void;
    /**
     * @stability stable
     */
    get vpcInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
