import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS OpsWorks.
 *
 * @stability stable
 */
export interface OpsworksRdsDbInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rds_db_instance#db_password OpsworksRdsDbInstance#db_password}.
     *
     * @stability stable
     */
    readonly dbPassword: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rds_db_instance#db_user OpsworksRdsDbInstance#db_user}.
     *
     * @stability stable
     */
    readonly dbUser: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rds_db_instance#rds_db_instance_arn OpsworksRdsDbInstance#rds_db_instance_arn}.
     *
     * @stability stable
     */
    readonly rdsDbInstanceArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rds_db_instance#stack_id OpsworksRdsDbInstance#stack_id}.
     *
     * @stability stable
     */
    readonly stackId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rds_db_instance aws_opsworks_rds_db_instance}.
 *
 * @stability stable
 */
export declare class OpsworksRdsDbInstance extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/opsworks_rds_db_instance aws_opsworks_rds_db_instance} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: OpsworksRdsDbInstanceConfig);
    private _dbPassword?;
    /**
     * @stability stable
     */
    get dbPassword(): string;
    /**
     * @stability stable
     */
    set dbPassword(value: string);
    /**
     * @stability stable
     */
    get dbPasswordInput(): string | undefined;
    private _dbUser?;
    /**
     * @stability stable
     */
    get dbUser(): string;
    /**
     * @stability stable
     */
    set dbUser(value: string);
    /**
     * @stability stable
     */
    get dbUserInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _rdsDbInstanceArn?;
    /**
     * @stability stable
     */
    get rdsDbInstanceArn(): string;
    /**
     * @stability stable
     */
    set rdsDbInstanceArn(value: string);
    /**
     * @stability stable
     */
    get rdsDbInstanceArnInput(): string | undefined;
    private _stackId?;
    /**
     * @stability stable
     */
    get stackId(): string;
    /**
     * @stability stable
     */
    set stackId(value: string);
    /**
     * @stability stable
     */
    get stackIdInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
