import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Organizations.
 *
 * @stability stable
 */
export interface DataAwsOrganizationsOrganizationalUnitsConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/organizations_organizational_units#parent_id DataAwsOrganizationsOrganizationalUnits#parent_id}.
     *
     * @stability stable
     */
    readonly parentId: string;
}
/**
 * @stability stable
 */
export declare class DataAwsOrganizationsOrganizationalUnitsChildren extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get name(): string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/organizations_organizational_units aws_organizations_organizational_units}.
 *
 * @stability stable
 */
export declare class DataAwsOrganizationsOrganizationalUnits extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/organizations_organizational_units aws_organizations_organizational_units} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsOrganizationsOrganizationalUnitsConfig);
    /**
     * @stability stable
     */
    children(index: string): DataAwsOrganizationsOrganizationalUnitsChildren;
    /**
     * @stability stable
     */
    get id(): string;
    private _parentId?;
    /**
     * @stability stable
     */
    get parentId(): string;
    /**
     * @stability stable
     */
    set parentId(value: string);
    /**
     * @stability stable
     */
    get parentIdInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
