import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Pinpoint.
 *
 * @stability stable
 */
export interface PinpointEmailChannelConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_email_channel#application_id PinpointEmailChannel#application_id}.
     *
     * @stability stable
     */
    readonly applicationId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_email_channel#configuration_set PinpointEmailChannel#configuration_set}.
     *
     * @stability stable
     */
    readonly configurationSet?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_email_channel#enabled PinpointEmailChannel#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_email_channel#from_address PinpointEmailChannel#from_address}.
     *
     * @stability stable
     */
    readonly fromAddress: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_email_channel#identity PinpointEmailChannel#identity}.
     *
     * @stability stable
     */
    readonly identity: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_email_channel#role_arn PinpointEmailChannel#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_email_channel aws_pinpoint_email_channel}.
 *
 * @stability stable
 */
export declare class PinpointEmailChannel extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/pinpoint_email_channel aws_pinpoint_email_channel} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: PinpointEmailChannelConfig);
    private _applicationId?;
    /**
     * @stability stable
     */
    get applicationId(): string;
    /**
     * @stability stable
     */
    set applicationId(value: string);
    /**
     * @stability stable
     */
    get applicationIdInput(): string | undefined;
    private _configurationSet?;
    /**
     * @stability stable
     */
    get configurationSet(): string;
    /**
     * @stability stable
     */
    set configurationSet(value: string);
    /**
     * @stability stable
     */
    resetConfigurationSet(): void;
    /**
     * @stability stable
     */
    get configurationSetInput(): string | undefined;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    private _fromAddress?;
    /**
     * @stability stable
     */
    get fromAddress(): string;
    /**
     * @stability stable
     */
    set fromAddress(value: string);
    /**
     * @stability stable
     */
    get fromAddressInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _identity?;
    /**
     * @stability stable
     */
    get identity(): string;
    /**
     * @stability stable
     */
    set identity(value: string);
    /**
     * @stability stable
     */
    get identityInput(): string | undefined;
    /**
     * @stability stable
     */
    get messagesPerSecond(): number;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    resetRoleArn(): void;
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
