import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Resource Access Manager.
 *
 * @stability stable
 */
export interface RamResourceShareAccepterConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ram_resource_share_accepter#share_arn RamResourceShareAccepter#share_arn}.
     *
     * @stability stable
     */
    readonly shareArn: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ram_resource_share_accepter#timeouts RamResourceShareAccepter#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: RamResourceShareAccepterTimeouts;
}
/**
 * @stability stable
 */
export interface RamResourceShareAccepterTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ram_resource_share_accepter#create RamResourceShareAccepter#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ram_resource_share_accepter#delete RamResourceShareAccepter#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
}
export declare function ramResourceShareAccepterTimeoutsToTerraform(struct?: RamResourceShareAccepterTimeoutsOutputReference | RamResourceShareAccepterTimeouts): any;
/**
 * @stability stable
 */
export declare class RamResourceShareAccepterTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): RamResourceShareAccepterTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: RamResourceShareAccepterTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ram_resource_share_accepter aws_ram_resource_share_accepter}.
 *
 * @stability stable
 */
export declare class RamResourceShareAccepter extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ram_resource_share_accepter aws_ram_resource_share_accepter} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: RamResourceShareAccepterConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get invitationArn(): string;
    /**
     * @stability stable
     */
    get receiverAccountId(): string;
    /**
     * @stability stable
     */
    get resources(): string[];
    /**
     * @stability stable
     */
    get senderAccountId(): string;
    private _shareArn?;
    /**
     * @stability stable
     */
    get shareArn(): string;
    /**
     * @stability stable
     */
    set shareArn(value: string);
    /**
     * @stability stable
     */
    get shareArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get shareId(): string;
    /**
     * @stability stable
     */
    get shareName(): string;
    /**
     * @stability stable
     */
    get status(): string;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): RamResourceShareAccepterTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: RamResourceShareAccepterTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): RamResourceShareAccepterTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
