import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Relational Database Service.
 *
 * @stability stable
 */
export interface DataAwsDbSnapshotConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/db_snapshot#db_instance_identifier DataAwsDbSnapshot#db_instance_identifier}.
     *
     * @stability stable
     */
    readonly dbInstanceIdentifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/db_snapshot#db_snapshot_identifier DataAwsDbSnapshot#db_snapshot_identifier}.
     *
     * @stability stable
     */
    readonly dbSnapshotIdentifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/db_snapshot#include_public DataAwsDbSnapshot#include_public}.
     *
     * @stability stable
     */
    readonly includePublic?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/db_snapshot#include_shared DataAwsDbSnapshot#include_shared}.
     *
     * @stability stable
     */
    readonly includeShared?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/db_snapshot#most_recent DataAwsDbSnapshot#most_recent}.
     *
     * @stability stable
     */
    readonly mostRecent?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/db_snapshot#snapshot_type DataAwsDbSnapshot#snapshot_type}.
     *
     * @stability stable
     */
    readonly snapshotType?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/db_snapshot aws_db_snapshot}.
 *
 * @stability stable
 */
export declare class DataAwsDbSnapshot extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/db_snapshot aws_db_snapshot} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsDbSnapshotConfig);
    /**
     * @stability stable
     */
    get allocatedStorage(): number;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    private _dbInstanceIdentifier?;
    /**
     * @stability stable
     */
    get dbInstanceIdentifier(): string;
    /**
     * @stability stable
     */
    set dbInstanceIdentifier(value: string);
    /**
     * @stability stable
     */
    resetDbInstanceIdentifier(): void;
    /**
     * @stability stable
     */
    get dbInstanceIdentifierInput(): string | undefined;
    /**
     * @stability stable
     */
    get dbSnapshotArn(): string;
    private _dbSnapshotIdentifier?;
    /**
     * @stability stable
     */
    get dbSnapshotIdentifier(): string;
    /**
     * @stability stable
     */
    set dbSnapshotIdentifier(value: string);
    /**
     * @stability stable
     */
    resetDbSnapshotIdentifier(): void;
    /**
     * @stability stable
     */
    get dbSnapshotIdentifierInput(): string | undefined;
    /**
     * @stability stable
     */
    get encrypted(): any;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _includePublic?;
    /**
     * @stability stable
     */
    get includePublic(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includePublic(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludePublic(): void;
    /**
     * @stability stable
     */
    get includePublicInput(): boolean | cdktf.IResolvable | undefined;
    private _includeShared?;
    /**
     * @stability stable
     */
    get includeShared(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set includeShared(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIncludeShared(): void;
    /**
     * @stability stable
     */
    get includeSharedInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get iops(): number;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    get licenseModel(): string;
    private _mostRecent?;
    /**
     * @stability stable
     */
    get mostRecent(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set mostRecent(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetMostRecent(): void;
    /**
     * @stability stable
     */
    get mostRecentInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get optionGroupName(): string;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    get snapshotCreateTime(): string;
    private _snapshotType?;
    /**
     * @stability stable
     */
    get snapshotType(): string;
    /**
     * @stability stable
     */
    set snapshotType(value: string);
    /**
     * @stability stable
     */
    resetSnapshotType(): void;
    /**
     * @stability stable
     */
    get snapshotTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get sourceDbSnapshotIdentifier(): string;
    /**
     * @stability stable
     */
    get sourceRegion(): string;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    get storageType(): string;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
