import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Relational Database Service.
 *
 * @stability stable
 */
export interface DataAwsRdsOrderableDbInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_orderable_db_instance#availability_zone_group DataAwsRdsOrderableDbInstance#availability_zone_group}.
     *
     * @stability stable
     */
    readonly availabilityZoneGroup?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_orderable_db_instance#engine DataAwsRdsOrderableDbInstance#engine}.
     *
     * @stability stable
     */
    readonly engine: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_orderable_db_instance#engine_version DataAwsRdsOrderableDbInstance#engine_version}.
     *
     * @stability stable
     */
    readonly engineVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_orderable_db_instance#instance_class DataAwsRdsOrderableDbInstance#instance_class}.
     *
     * @stability stable
     */
    readonly instanceClass?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_orderable_db_instance#license_model DataAwsRdsOrderableDbInstance#license_model}.
     *
     * @stability stable
     */
    readonly licenseModel?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_orderable_db_instance#preferred_engine_versions DataAwsRdsOrderableDbInstance#preferred_engine_versions}.
     *
     * @stability stable
     */
    readonly preferredEngineVersions?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_orderable_db_instance#preferred_instance_classes DataAwsRdsOrderableDbInstance#preferred_instance_classes}.
     *
     * @stability stable
     */
    readonly preferredInstanceClasses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_orderable_db_instance#storage_type DataAwsRdsOrderableDbInstance#storage_type}.
     *
     * @stability stable
     */
    readonly storageType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_orderable_db_instance#supports_enhanced_monitoring DataAwsRdsOrderableDbInstance#supports_enhanced_monitoring}.
     *
     * @stability stable
     */
    readonly supportsEnhancedMonitoring?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_orderable_db_instance#supports_global_databases DataAwsRdsOrderableDbInstance#supports_global_databases}.
     *
     * @stability stable
     */
    readonly supportsGlobalDatabases?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_orderable_db_instance#supports_iam_database_authentication DataAwsRdsOrderableDbInstance#supports_iam_database_authentication}.
     *
     * @stability stable
     */
    readonly supportsIamDatabaseAuthentication?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_orderable_db_instance#supports_iops DataAwsRdsOrderableDbInstance#supports_iops}.
     *
     * @stability stable
     */
    readonly supportsIops?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_orderable_db_instance#supports_kerberos_authentication DataAwsRdsOrderableDbInstance#supports_kerberos_authentication}.
     *
     * @stability stable
     */
    readonly supportsKerberosAuthentication?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_orderable_db_instance#supports_performance_insights DataAwsRdsOrderableDbInstance#supports_performance_insights}.
     *
     * @stability stable
     */
    readonly supportsPerformanceInsights?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_orderable_db_instance#supports_storage_autoscaling DataAwsRdsOrderableDbInstance#supports_storage_autoscaling}.
     *
     * @stability stable
     */
    readonly supportsStorageAutoscaling?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_orderable_db_instance#supports_storage_encryption DataAwsRdsOrderableDbInstance#supports_storage_encryption}.
     *
     * @stability stable
     */
    readonly supportsStorageEncryption?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/rds_orderable_db_instance#vpc DataAwsRdsOrderableDbInstance#vpc}.
     *
     * @stability stable
     */
    readonly vpc?: boolean | cdktf.IResolvable;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/rds_orderable_db_instance aws_rds_orderable_db_instance}.
 *
 * @stability stable
 */
export declare class DataAwsRdsOrderableDbInstance extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/rds_orderable_db_instance aws_rds_orderable_db_instance} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsRdsOrderableDbInstanceConfig);
    private _availabilityZoneGroup?;
    /**
     * @stability stable
     */
    get availabilityZoneGroup(): string;
    /**
     * @stability stable
     */
    set availabilityZoneGroup(value: string);
    /**
     * @stability stable
     */
    resetAvailabilityZoneGroup(): void;
    /**
     * @stability stable
     */
    get availabilityZoneGroupInput(): string | undefined;
    /**
     * @stability stable
     */
    get availabilityZones(): string[];
    private _engine?;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    set engine(value: string);
    /**
     * @stability stable
     */
    get engineInput(): string | undefined;
    private _engineVersion?;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    set engineVersion(value: string);
    /**
     * @stability stable
     */
    resetEngineVersion(): void;
    /**
     * @stability stable
     */
    get engineVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceClass?;
    /**
     * @stability stable
     */
    get instanceClass(): string;
    /**
     * @stability stable
     */
    set instanceClass(value: string);
    /**
     * @stability stable
     */
    resetInstanceClass(): void;
    /**
     * @stability stable
     */
    get instanceClassInput(): string | undefined;
    private _licenseModel?;
    /**
     * @stability stable
     */
    get licenseModel(): string;
    /**
     * @stability stable
     */
    set licenseModel(value: string);
    /**
     * @stability stable
     */
    resetLicenseModel(): void;
    /**
     * @stability stable
     */
    get licenseModelInput(): string | undefined;
    /**
     * @stability stable
     */
    get maxIopsPerDbInstance(): number;
    /**
     * @stability stable
     */
    get maxIopsPerGib(): number;
    /**
     * @stability stable
     */
    get maxStorageSize(): number;
    /**
     * @stability stable
     */
    get minIopsPerDbInstance(): number;
    /**
     * @stability stable
     */
    get minIopsPerGib(): number;
    /**
     * @stability stable
     */
    get minStorageSize(): number;
    /**
     * @stability stable
     */
    get multiAzCapable(): any;
    /**
     * @stability stable
     */
    get outpostCapable(): any;
    private _preferredEngineVersions?;
    /**
     * @stability stable
     */
    get preferredEngineVersions(): string[];
    /**
     * @stability stable
     */
    set preferredEngineVersions(value: string[]);
    /**
     * @stability stable
     */
    resetPreferredEngineVersions(): void;
    /**
     * @stability stable
     */
    get preferredEngineVersionsInput(): string[] | undefined;
    private _preferredInstanceClasses?;
    /**
     * @stability stable
     */
    get preferredInstanceClasses(): string[];
    /**
     * @stability stable
     */
    set preferredInstanceClasses(value: string[]);
    /**
     * @stability stable
     */
    resetPreferredInstanceClasses(): void;
    /**
     * @stability stable
     */
    get preferredInstanceClassesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get readReplicaCapable(): any;
    private _storageType?;
    /**
     * @stability stable
     */
    get storageType(): string;
    /**
     * @stability stable
     */
    set storageType(value: string);
    /**
     * @stability stable
     */
    resetStorageType(): void;
    /**
     * @stability stable
     */
    get storageTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get supportedEngineModes(): string[];
    private _supportsEnhancedMonitoring?;
    /**
     * @stability stable
     */
    get supportsEnhancedMonitoring(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set supportsEnhancedMonitoring(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSupportsEnhancedMonitoring(): void;
    /**
     * @stability stable
     */
    get supportsEnhancedMonitoringInput(): boolean | cdktf.IResolvable | undefined;
    private _supportsGlobalDatabases?;
    /**
     * @stability stable
     */
    get supportsGlobalDatabases(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set supportsGlobalDatabases(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSupportsGlobalDatabases(): void;
    /**
     * @stability stable
     */
    get supportsGlobalDatabasesInput(): boolean | cdktf.IResolvable | undefined;
    private _supportsIamDatabaseAuthentication?;
    /**
     * @stability stable
     */
    get supportsIamDatabaseAuthentication(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set supportsIamDatabaseAuthentication(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSupportsIamDatabaseAuthentication(): void;
    /**
     * @stability stable
     */
    get supportsIamDatabaseAuthenticationInput(): boolean | cdktf.IResolvable | undefined;
    private _supportsIops?;
    /**
     * @stability stable
     */
    get supportsIops(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set supportsIops(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSupportsIops(): void;
    /**
     * @stability stable
     */
    get supportsIopsInput(): boolean | cdktf.IResolvable | undefined;
    private _supportsKerberosAuthentication?;
    /**
     * @stability stable
     */
    get supportsKerberosAuthentication(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set supportsKerberosAuthentication(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSupportsKerberosAuthentication(): void;
    /**
     * @stability stable
     */
    get supportsKerberosAuthenticationInput(): boolean | cdktf.IResolvable | undefined;
    private _supportsPerformanceInsights?;
    /**
     * @stability stable
     */
    get supportsPerformanceInsights(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set supportsPerformanceInsights(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSupportsPerformanceInsights(): void;
    /**
     * @stability stable
     */
    get supportsPerformanceInsightsInput(): boolean | cdktf.IResolvable | undefined;
    private _supportsStorageAutoscaling?;
    /**
     * @stability stable
     */
    get supportsStorageAutoscaling(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set supportsStorageAutoscaling(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSupportsStorageAutoscaling(): void;
    /**
     * @stability stable
     */
    get supportsStorageAutoscalingInput(): boolean | cdktf.IResolvable | undefined;
    private _supportsStorageEncryption?;
    /**
     * @stability stable
     */
    get supportsStorageEncryption(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set supportsStorageEncryption(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSupportsStorageEncryption(): void;
    /**
     * @stability stable
     */
    get supportsStorageEncryptionInput(): boolean | cdktf.IResolvable | undefined;
    private _vpc?;
    /**
     * @stability stable
     */
    get vpc(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set vpc(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetVpc(): void;
    /**
     * @stability stable
     */
    get vpcInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
