import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Relational Database Service.
 *
 * @stability stable
 */
export interface DbProxyDefaultTargetGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group#db_proxy_name DbProxyDefaultTargetGroup#db_proxy_name}.
     *
     * @stability stable
     */
    readonly dbProxyName: string;
    /**
     * connection_pool_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group#connection_pool_config DbProxyDefaultTargetGroup#connection_pool_config}
     *
     * @stability stable
     */
    readonly connectionPoolConfig?: DbProxyDefaultTargetGroupConnectionPoolConfig;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group#timeouts DbProxyDefaultTargetGroup#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: DbProxyDefaultTargetGroupTimeouts;
}
/**
 * @stability stable
 */
export interface DbProxyDefaultTargetGroupConnectionPoolConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group#connection_borrow_timeout DbProxyDefaultTargetGroup#connection_borrow_timeout}.
     *
     * @stability stable
     */
    readonly connectionBorrowTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group#init_query DbProxyDefaultTargetGroup#init_query}.
     *
     * @stability stable
     */
    readonly initQuery?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group#max_connections_percent DbProxyDefaultTargetGroup#max_connections_percent}.
     *
     * @stability stable
     */
    readonly maxConnectionsPercent?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group#max_idle_connections_percent DbProxyDefaultTargetGroup#max_idle_connections_percent}.
     *
     * @stability stable
     */
    readonly maxIdleConnectionsPercent?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group#session_pinning_filters DbProxyDefaultTargetGroup#session_pinning_filters}.
     *
     * @stability stable
     */
    readonly sessionPinningFilters?: string[];
}
export declare function dbProxyDefaultTargetGroupConnectionPoolConfigToTerraform(struct?: DbProxyDefaultTargetGroupConnectionPoolConfigOutputReference | DbProxyDefaultTargetGroupConnectionPoolConfig): any;
/**
 * @stability stable
 */
export declare class DbProxyDefaultTargetGroupConnectionPoolConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DbProxyDefaultTargetGroupConnectionPoolConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DbProxyDefaultTargetGroupConnectionPoolConfig | undefined);
    private _connectionBorrowTimeout?;
    /**
     * @stability stable
     */
    get connectionBorrowTimeout(): number;
    /**
     * @stability stable
     */
    set connectionBorrowTimeout(value: number);
    /**
     * @stability stable
     */
    resetConnectionBorrowTimeout(): void;
    /**
     * @stability stable
     */
    get connectionBorrowTimeoutInput(): number | undefined;
    private _initQuery?;
    /**
     * @stability stable
     */
    get initQuery(): string;
    /**
     * @stability stable
     */
    set initQuery(value: string);
    /**
     * @stability stable
     */
    resetInitQuery(): void;
    /**
     * @stability stable
     */
    get initQueryInput(): string | undefined;
    private _maxConnectionsPercent?;
    /**
     * @stability stable
     */
    get maxConnectionsPercent(): number;
    /**
     * @stability stable
     */
    set maxConnectionsPercent(value: number);
    /**
     * @stability stable
     */
    resetMaxConnectionsPercent(): void;
    /**
     * @stability stable
     */
    get maxConnectionsPercentInput(): number | undefined;
    private _maxIdleConnectionsPercent?;
    /**
     * @stability stable
     */
    get maxIdleConnectionsPercent(): number;
    /**
     * @stability stable
     */
    set maxIdleConnectionsPercent(value: number);
    /**
     * @stability stable
     */
    resetMaxIdleConnectionsPercent(): void;
    /**
     * @stability stable
     */
    get maxIdleConnectionsPercentInput(): number | undefined;
    private _sessionPinningFilters?;
    /**
     * @stability stable
     */
    get sessionPinningFilters(): string[];
    /**
     * @stability stable
     */
    set sessionPinningFilters(value: string[]);
    /**
     * @stability stable
     */
    resetSessionPinningFilters(): void;
    /**
     * @stability stable
     */
    get sessionPinningFiltersInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface DbProxyDefaultTargetGroupTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group#create DbProxyDefaultTargetGroup#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group#update DbProxyDefaultTargetGroup#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function dbProxyDefaultTargetGroupTimeoutsToTerraform(struct?: DbProxyDefaultTargetGroupTimeoutsOutputReference | DbProxyDefaultTargetGroupTimeouts): any;
/**
 * @stability stable
 */
export declare class DbProxyDefaultTargetGroupTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DbProxyDefaultTargetGroupTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DbProxyDefaultTargetGroupTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group aws_db_proxy_default_target_group}.
 *
 * @stability stable
 */
export declare class DbProxyDefaultTargetGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/db_proxy_default_target_group aws_db_proxy_default_target_group} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DbProxyDefaultTargetGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _dbProxyName?;
    /**
     * @stability stable
     */
    get dbProxyName(): string;
    /**
     * @stability stable
     */
    set dbProxyName(value: string);
    /**
     * @stability stable
     */
    get dbProxyNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get name(): string;
    private _connectionPoolConfig;
    /**
     * @stability stable
     */
    get connectionPoolConfig(): DbProxyDefaultTargetGroupConnectionPoolConfigOutputReference;
    /**
     * @stability stable
     */
    putConnectionPoolConfig(value: DbProxyDefaultTargetGroupConnectionPoolConfig): void;
    /**
     * @stability stable
     */
    resetConnectionPoolConfig(): void;
    /**
     * @stability stable
     */
    get connectionPoolConfigInput(): DbProxyDefaultTargetGroupConnectionPoolConfig | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): DbProxyDefaultTargetGroupTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: DbProxyDefaultTargetGroupTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DbProxyDefaultTargetGroupTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
