import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Route 53.
 *
 * @stability stable
 */
export interface Route53RecoverycontrolconfigSafetyRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule#asserted_controls Route53RecoverycontrolconfigSafetyRule#asserted_controls}.
     *
     * @stability stable
     */
    readonly assertedControls?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule#control_panel_arn Route53RecoverycontrolconfigSafetyRule#control_panel_arn}.
     *
     * @stability stable
     */
    readonly controlPanelArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule#gating_controls Route53RecoverycontrolconfigSafetyRule#gating_controls}.
     *
     * @stability stable
     */
    readonly gatingControls?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule#name Route53RecoverycontrolconfigSafetyRule#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule#target_controls Route53RecoverycontrolconfigSafetyRule#target_controls}.
     *
     * @stability stable
     */
    readonly targetControls?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule#wait_period_ms Route53RecoverycontrolconfigSafetyRule#wait_period_ms}.
     *
     * @stability stable
     */
    readonly waitPeriodMs: number;
    /**
     * rule_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule#rule_config Route53RecoverycontrolconfigSafetyRule#rule_config}
     *
     * @stability stable
     */
    readonly ruleConfig: Route53RecoverycontrolconfigSafetyRuleRuleConfig;
}
/**
 * @stability stable
 */
export interface Route53RecoverycontrolconfigSafetyRuleRuleConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule#inverted Route53RecoverycontrolconfigSafetyRule#inverted}.
     *
     * @stability stable
     */
    readonly inverted: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule#threshold Route53RecoverycontrolconfigSafetyRule#threshold}.
     *
     * @stability stable
     */
    readonly threshold: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule#type Route53RecoverycontrolconfigSafetyRule#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
export declare function route53RecoverycontrolconfigSafetyRuleRuleConfigToTerraform(struct?: Route53RecoverycontrolconfigSafetyRuleRuleConfigOutputReference | Route53RecoverycontrolconfigSafetyRuleRuleConfig): any;
/**
 * @stability stable
 */
export declare class Route53RecoverycontrolconfigSafetyRuleRuleConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Route53RecoverycontrolconfigSafetyRuleRuleConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Route53RecoverycontrolconfigSafetyRuleRuleConfig | undefined);
    private _inverted?;
    /**
     * @stability stable
     */
    get inverted(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set inverted(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    get invertedInput(): boolean | cdktf.IResolvable | undefined;
    private _threshold?;
    /**
     * @stability stable
     */
    get threshold(): number;
    /**
     * @stability stable
     */
    set threshold(value: number);
    /**
     * @stability stable
     */
    get thresholdInput(): number | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule aws_route53recoverycontrolconfig_safety_rule}.
 *
 * @stability stable
 */
export declare class Route53RecoverycontrolconfigSafetyRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53recoverycontrolconfig_safety_rule aws_route53recoverycontrolconfig_safety_rule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Route53RecoverycontrolconfigSafetyRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _assertedControls?;
    /**
     * @stability stable
     */
    get assertedControls(): string[];
    /**
     * @stability stable
     */
    set assertedControls(value: string[]);
    /**
     * @stability stable
     */
    resetAssertedControls(): void;
    /**
     * @stability stable
     */
    get assertedControlsInput(): string[] | undefined;
    private _controlPanelArn?;
    /**
     * @stability stable
     */
    get controlPanelArn(): string;
    /**
     * @stability stable
     */
    set controlPanelArn(value: string);
    /**
     * @stability stable
     */
    get controlPanelArnInput(): string | undefined;
    private _gatingControls?;
    /**
     * @stability stable
     */
    get gatingControls(): string[];
    /**
     * @stability stable
     */
    set gatingControls(value: string[]);
    /**
     * @stability stable
     */
    resetGatingControls(): void;
    /**
     * @stability stable
     */
    get gatingControlsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get status(): string;
    private _targetControls?;
    /**
     * @stability stable
     */
    get targetControls(): string[];
    /**
     * @stability stable
     */
    set targetControls(value: string[]);
    /**
     * @stability stable
     */
    resetTargetControls(): void;
    /**
     * @stability stable
     */
    get targetControlsInput(): string[] | undefined;
    private _waitPeriodMs?;
    /**
     * @stability stable
     */
    get waitPeriodMs(): number;
    /**
     * @stability stable
     */
    set waitPeriodMs(value: number);
    /**
     * @stability stable
     */
    get waitPeriodMsInput(): number | undefined;
    private _ruleConfig;
    /**
     * @stability stable
     */
    get ruleConfig(): Route53RecoverycontrolconfigSafetyRuleRuleConfigOutputReference;
    /**
     * @stability stable
     */
    putRuleConfig(value: Route53RecoverycontrolconfigSafetyRuleRuleConfig): void;
    /**
     * @stability stable
     */
    get ruleConfigInput(): Route53RecoverycontrolconfigSafetyRuleRuleConfig | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
