import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Route 53.
 *
 * @stability stable
 */
export interface Route53RecoveryreadinessResourceSetConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set#resource_set_name Route53RecoveryreadinessResourceSet#resource_set_name}.
     *
     * @stability stable
     */
    readonly resourceSetName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set#resource_set_type Route53RecoveryreadinessResourceSet#resource_set_type}.
     *
     * @stability stable
     */
    readonly resourceSetType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set#tags Route53RecoveryreadinessResourceSet#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set#tags_all Route53RecoveryreadinessResourceSet#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * resources block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set#resources Route53RecoveryreadinessResourceSet#resources}
     *
     * @stability stable
     */
    readonly resources: Route53RecoveryreadinessResourceSetResources[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set#timeouts Route53RecoveryreadinessResourceSet#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: Route53RecoveryreadinessResourceSetTimeouts;
}
/**
 * @stability stable
 */
export interface Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceNlbResource {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set#arn Route53RecoveryreadinessResourceSet#arn}.
     *
     * @stability stable
     */
    readonly arn?: string;
}
export declare function route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceNlbResourceToTerraform(struct?: Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceNlbResourceOutputReference | Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceNlbResource): any;
/**
 * @stability stable
 */
export declare class Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceNlbResourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceNlbResource | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceNlbResource | undefined);
    private _arn?;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    set arn(value: string);
    /**
     * @stability stable
     */
    resetArn(): void;
    /**
     * @stability stable
     */
    get arnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceR53Resource {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set#domain_name Route53RecoveryreadinessResourceSet#domain_name}.
     *
     * @stability stable
     */
    readonly domainName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set#record_set_id Route53RecoveryreadinessResourceSet#record_set_id}.
     *
     * @stability stable
     */
    readonly recordSetId?: string;
}
export declare function route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceR53ResourceToTerraform(struct?: Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceR53ResourceOutputReference | Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceR53Resource): any;
/**
 * @stability stable
 */
export declare class Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceR53ResourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceR53Resource | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceR53Resource | undefined);
    private _domainName?;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    resetDomainName(): void;
    /**
     * @stability stable
     */
    get domainNameInput(): string | undefined;
    private _recordSetId?;
    /**
     * @stability stable
     */
    get recordSetId(): string;
    /**
     * @stability stable
     */
    set recordSetId(value: string);
    /**
     * @stability stable
     */
    resetRecordSetId(): void;
    /**
     * @stability stable
     */
    get recordSetIdInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResource {
    /**
     * nlb_resource block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set#nlb_resource Route53RecoveryreadinessResourceSet#nlb_resource}
     *
     * @stability stable
     */
    readonly nlbResource?: Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceNlbResource;
    /**
     * r53_resource block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set#r53_resource Route53RecoveryreadinessResourceSet#r53_resource}
     *
     * @stability stable
     */
    readonly r53Resource?: Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceR53Resource;
}
export declare function route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceToTerraform(struct?: Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceOutputReference | Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResource): any;
/**
 * @stability stable
 */
export declare class Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResource | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResource | undefined);
    private _nlbResource;
    /**
     * @stability stable
     */
    get nlbResource(): Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceNlbResourceOutputReference;
    /**
     * @stability stable
     */
    putNlbResource(value: Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceNlbResource): void;
    /**
     * @stability stable
     */
    resetNlbResource(): void;
    /**
     * @stability stable
     */
    get nlbResourceInput(): Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceNlbResource | undefined;
    private _r53Resource;
    /**
     * @stability stable
     */
    get r53Resource(): Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceR53ResourceOutputReference;
    /**
     * @stability stable
     */
    putR53Resource(value: Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceR53Resource): void;
    /**
     * @stability stable
     */
    resetR53Resource(): void;
    /**
     * @stability stable
     */
    get r53ResourceInput(): Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceR53Resource | undefined;
}
/**
 * @stability stable
 */
export interface Route53RecoveryreadinessResourceSetResourcesDnsTargetResource {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set#domain_name Route53RecoveryreadinessResourceSet#domain_name}.
     *
     * @stability stable
     */
    readonly domainName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set#hosted_zone_arn Route53RecoveryreadinessResourceSet#hosted_zone_arn}.
     *
     * @stability stable
     */
    readonly hostedZoneArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set#record_set_id Route53RecoveryreadinessResourceSet#record_set_id}.
     *
     * @stability stable
     */
    readonly recordSetId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set#record_type Route53RecoveryreadinessResourceSet#record_type}.
     *
     * @stability stable
     */
    readonly recordType?: string;
    /**
     * target_resource block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set#target_resource Route53RecoveryreadinessResourceSet#target_resource}
     *
     * @stability stable
     */
    readonly targetResource?: Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResource;
}
export declare function route53RecoveryreadinessResourceSetResourcesDnsTargetResourceToTerraform(struct?: Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceOutputReference | Route53RecoveryreadinessResourceSetResourcesDnsTargetResource): any;
/**
 * @stability stable
 */
export declare class Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Route53RecoveryreadinessResourceSetResourcesDnsTargetResource | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Route53RecoveryreadinessResourceSetResourcesDnsTargetResource | undefined);
    private _domainName?;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    get domainNameInput(): string | undefined;
    private _hostedZoneArn?;
    /**
     * @stability stable
     */
    get hostedZoneArn(): string;
    /**
     * @stability stable
     */
    set hostedZoneArn(value: string);
    /**
     * @stability stable
     */
    resetHostedZoneArn(): void;
    /**
     * @stability stable
     */
    get hostedZoneArnInput(): string | undefined;
    private _recordSetId?;
    /**
     * @stability stable
     */
    get recordSetId(): string;
    /**
     * @stability stable
     */
    set recordSetId(value: string);
    /**
     * @stability stable
     */
    resetRecordSetId(): void;
    /**
     * @stability stable
     */
    get recordSetIdInput(): string | undefined;
    private _recordType?;
    /**
     * @stability stable
     */
    get recordType(): string;
    /**
     * @stability stable
     */
    set recordType(value: string);
    /**
     * @stability stable
     */
    resetRecordType(): void;
    /**
     * @stability stable
     */
    get recordTypeInput(): string | undefined;
    private _targetResource;
    /**
     * @stability stable
     */
    get targetResource(): Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResourceOutputReference;
    /**
     * @stability stable
     */
    putTargetResource(value: Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResource): void;
    /**
     * @stability stable
     */
    resetTargetResource(): void;
    /**
     * @stability stable
     */
    get targetResourceInput(): Route53RecoveryreadinessResourceSetResourcesDnsTargetResourceTargetResource | undefined;
}
/**
 * @stability stable
 */
export interface Route53RecoveryreadinessResourceSetResources {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set#readiness_scopes Route53RecoveryreadinessResourceSet#readiness_scopes}.
     *
     * @stability stable
     */
    readonly readinessScopes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set#resource_arn Route53RecoveryreadinessResourceSet#resource_arn}.
     *
     * @stability stable
     */
    readonly resourceArn?: string;
    /**
     * dns_target_resource block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set#dns_target_resource Route53RecoveryreadinessResourceSet#dns_target_resource}
     *
     * @stability stable
     */
    readonly dnsTargetResource?: Route53RecoveryreadinessResourceSetResourcesDnsTargetResource;
}
export declare function route53RecoveryreadinessResourceSetResourcesToTerraform(struct?: Route53RecoveryreadinessResourceSetResources): any;
/**
 * @stability stable
 */
export interface Route53RecoveryreadinessResourceSetTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set#delete Route53RecoveryreadinessResourceSet#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
}
export declare function route53RecoveryreadinessResourceSetTimeoutsToTerraform(struct?: Route53RecoveryreadinessResourceSetTimeoutsOutputReference | Route53RecoveryreadinessResourceSetTimeouts): any;
/**
 * @stability stable
 */
export declare class Route53RecoveryreadinessResourceSetTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): Route53RecoveryreadinessResourceSetTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: Route53RecoveryreadinessResourceSetTimeouts | undefined);
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set aws_route53recoveryreadiness_resource_set}.
 *
 * @stability stable
 */
export declare class Route53RecoveryreadinessResourceSet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53recoveryreadiness_resource_set aws_route53recoveryreadiness_resource_set} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Route53RecoveryreadinessResourceSetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _resourceSetName?;
    /**
     * @stability stable
     */
    get resourceSetName(): string;
    /**
     * @stability stable
     */
    set resourceSetName(value: string);
    /**
     * @stability stable
     */
    get resourceSetNameInput(): string | undefined;
    private _resourceSetType?;
    /**
     * @stability stable
     */
    get resourceSetType(): string;
    /**
     * @stability stable
     */
    set resourceSetType(value: string);
    /**
     * @stability stable
     */
    get resourceSetTypeInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _resources?;
    /**
     * @stability stable
     */
    get resources(): Route53RecoveryreadinessResourceSetResources[];
    /**
     * @stability stable
     */
    set resources(value: Route53RecoveryreadinessResourceSetResources[]);
    /**
     * @stability stable
     */
    get resourcesInput(): Route53RecoveryreadinessResourceSetResources[] | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): Route53RecoveryreadinessResourceSetTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: Route53RecoveryreadinessResourceSetTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): Route53RecoveryreadinessResourceSetTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
