import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Simple Storage Service.
 *
 * @stability stable
 */
export interface DataAwsS3BucketObjectsConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/s3_bucket_objects#bucket DataAwsS3BucketObjects#bucket}.
     *
     * @stability stable
     */
    readonly bucket: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/s3_bucket_objects#delimiter DataAwsS3BucketObjects#delimiter}.
     *
     * @stability stable
     */
    readonly delimiter?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/s3_bucket_objects#encoding_type DataAwsS3BucketObjects#encoding_type}.
     *
     * @stability stable
     */
    readonly encodingType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/s3_bucket_objects#fetch_owner DataAwsS3BucketObjects#fetch_owner}.
     *
     * @stability stable
     */
    readonly fetchOwner?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/s3_bucket_objects#max_keys DataAwsS3BucketObjects#max_keys}.
     *
     * @stability stable
     */
    readonly maxKeys?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/s3_bucket_objects#prefix DataAwsS3BucketObjects#prefix}.
     *
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/s3_bucket_objects#start_after DataAwsS3BucketObjects#start_after}.
     *
     * @stability stable
     */
    readonly startAfter?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/s3_bucket_objects aws_s3_bucket_objects}.
 *
 * @stability stable
 */
export declare class DataAwsS3BucketObjects extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/s3_bucket_objects aws_s3_bucket_objects} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsS3BucketObjectsConfig);
    private _bucket?;
    /**
     * @stability stable
     */
    get bucket(): string;
    /**
     * @stability stable
     */
    set bucket(value: string);
    /**
     * @stability stable
     */
    get bucketInput(): string | undefined;
    /**
     * @stability stable
     */
    get commonPrefixes(): string[];
    private _delimiter?;
    /**
     * @stability stable
     */
    get delimiter(): string;
    /**
     * @stability stable
     */
    set delimiter(value: string);
    /**
     * @stability stable
     */
    resetDelimiter(): void;
    /**
     * @stability stable
     */
    get delimiterInput(): string | undefined;
    private _encodingType?;
    /**
     * @stability stable
     */
    get encodingType(): string;
    /**
     * @stability stable
     */
    set encodingType(value: string);
    /**
     * @stability stable
     */
    resetEncodingType(): void;
    /**
     * @stability stable
     */
    get encodingTypeInput(): string | undefined;
    private _fetchOwner?;
    /**
     * @stability stable
     */
    get fetchOwner(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set fetchOwner(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetFetchOwner(): void;
    /**
     * @stability stable
     */
    get fetchOwnerInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get keys(): string[];
    private _maxKeys?;
    /**
     * @stability stable
     */
    get maxKeys(): number;
    /**
     * @stability stable
     */
    set maxKeys(value: number);
    /**
     * @stability stable
     */
    resetMaxKeys(): void;
    /**
     * @stability stable
     */
    get maxKeysInput(): number | undefined;
    /**
     * @stability stable
     */
    get owners(): string[];
    private _prefix?;
    /**
     * @stability stable
     */
    get prefix(): string;
    /**
     * @stability stable
     */
    set prefix(value: string);
    /**
     * @stability stable
     */
    resetPrefix(): void;
    /**
     * @stability stable
     */
    get prefixInput(): string | undefined;
    private _startAfter?;
    /**
     * @stability stable
     */
    get startAfter(): string;
    /**
     * @stability stable
     */
    set startAfter(value: string);
    /**
     * @stability stable
     */
    resetStartAfter(): void;
    /**
     * @stability stable
     */
    get startAfterInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
