import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Simple Storage Service.
 *
 * @stability stable
 */
export interface S3BucketAnalyticsConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_analytics_configuration#bucket S3BucketAnalyticsConfiguration#bucket}.
     *
     * @stability stable
     */
    readonly bucket: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_analytics_configuration#name S3BucketAnalyticsConfiguration#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_analytics_configuration#filter S3BucketAnalyticsConfiguration#filter}
     *
     * @stability stable
     */
    readonly filter?: S3BucketAnalyticsConfigurationFilter;
    /**
     * storage_class_analysis block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_analytics_configuration#storage_class_analysis S3BucketAnalyticsConfiguration#storage_class_analysis}
     *
     * @stability stable
     */
    readonly storageClassAnalysis?: S3BucketAnalyticsConfigurationStorageClassAnalysis;
}
/**
 * @stability stable
 */
export interface S3BucketAnalyticsConfigurationFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_analytics_configuration#prefix S3BucketAnalyticsConfiguration#prefix}.
     *
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_analytics_configuration#tags S3BucketAnalyticsConfiguration#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
}
export declare function s3BucketAnalyticsConfigurationFilterToTerraform(struct?: S3BucketAnalyticsConfigurationFilterOutputReference | S3BucketAnalyticsConfigurationFilter): any;
/**
 * @stability stable
 */
export declare class S3BucketAnalyticsConfigurationFilterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): S3BucketAnalyticsConfigurationFilter | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: S3BucketAnalyticsConfigurationFilter | undefined);
    private _prefix?;
    /**
     * @stability stable
     */
    get prefix(): string;
    /**
     * @stability stable
     */
    set prefix(value: string);
    /**
     * @stability stable
     */
    resetPrefix(): void;
    /**
     * @stability stable
     */
    get prefixInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
}
/**
 * @stability stable
 */
export interface S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestinationS3BucketDestination {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_analytics_configuration#bucket_account_id S3BucketAnalyticsConfiguration#bucket_account_id}.
     *
     * @stability stable
     */
    readonly bucketAccountId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_analytics_configuration#bucket_arn S3BucketAnalyticsConfiguration#bucket_arn}.
     *
     * @stability stable
     */
    readonly bucketArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_analytics_configuration#format S3BucketAnalyticsConfiguration#format}.
     *
     * @stability stable
     */
    readonly format?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_analytics_configuration#prefix S3BucketAnalyticsConfiguration#prefix}.
     *
     * @stability stable
     */
    readonly prefix?: string;
}
export declare function s3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestinationS3BucketDestinationToTerraform(struct?: S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestinationS3BucketDestinationOutputReference | S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestinationS3BucketDestination): any;
/**
 * @stability stable
 */
export declare class S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestinationS3BucketDestinationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestinationS3BucketDestination | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestinationS3BucketDestination | undefined);
    private _bucketAccountId?;
    /**
     * @stability stable
     */
    get bucketAccountId(): string;
    /**
     * @stability stable
     */
    set bucketAccountId(value: string);
    /**
     * @stability stable
     */
    resetBucketAccountId(): void;
    /**
     * @stability stable
     */
    get bucketAccountIdInput(): string | undefined;
    private _bucketArn?;
    /**
     * @stability stable
     */
    get bucketArn(): string;
    /**
     * @stability stable
     */
    set bucketArn(value: string);
    /**
     * @stability stable
     */
    get bucketArnInput(): string | undefined;
    private _format?;
    /**
     * @stability stable
     */
    get format(): string;
    /**
     * @stability stable
     */
    set format(value: string);
    /**
     * @stability stable
     */
    resetFormat(): void;
    /**
     * @stability stable
     */
    get formatInput(): string | undefined;
    private _prefix?;
    /**
     * @stability stable
     */
    get prefix(): string;
    /**
     * @stability stable
     */
    set prefix(value: string);
    /**
     * @stability stable
     */
    resetPrefix(): void;
    /**
     * @stability stable
     */
    get prefixInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestination {
    /**
     * s3_bucket_destination block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_analytics_configuration#s3_bucket_destination S3BucketAnalyticsConfiguration#s3_bucket_destination}
     *
     * @stability stable
     */
    readonly s3BucketDestination: S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestinationS3BucketDestination;
}
export declare function s3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestinationToTerraform(struct?: S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestinationOutputReference | S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestination): any;
/**
 * @stability stable
 */
export declare class S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestinationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestination | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestination | undefined);
    private _s3BucketDestination;
    /**
     * @stability stable
     */
    get s3BucketDestination(): S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestinationS3BucketDestinationOutputReference;
    /**
     * @stability stable
     */
    putS3BucketDestination(value: S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestinationS3BucketDestination): void;
    /**
     * @stability stable
     */
    get s3BucketDestinationInput(): S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestinationS3BucketDestination | undefined;
}
/**
 * @stability stable
 */
export interface S3BucketAnalyticsConfigurationStorageClassAnalysisDataExport {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_analytics_configuration#output_schema_version S3BucketAnalyticsConfiguration#output_schema_version}.
     *
     * @stability stable
     */
    readonly outputSchemaVersion?: string;
    /**
     * destination block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_analytics_configuration#destination S3BucketAnalyticsConfiguration#destination}
     *
     * @stability stable
     */
    readonly destination: S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestination;
}
export declare function s3BucketAnalyticsConfigurationStorageClassAnalysisDataExportToTerraform(struct?: S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportOutputReference | S3BucketAnalyticsConfigurationStorageClassAnalysisDataExport): any;
/**
 * @stability stable
 */
export declare class S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): S3BucketAnalyticsConfigurationStorageClassAnalysisDataExport | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: S3BucketAnalyticsConfigurationStorageClassAnalysisDataExport | undefined);
    private _outputSchemaVersion?;
    /**
     * @stability stable
     */
    get outputSchemaVersion(): string;
    /**
     * @stability stable
     */
    set outputSchemaVersion(value: string);
    /**
     * @stability stable
     */
    resetOutputSchemaVersion(): void;
    /**
     * @stability stable
     */
    get outputSchemaVersionInput(): string | undefined;
    private _destination;
    /**
     * @stability stable
     */
    get destination(): S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestinationOutputReference;
    /**
     * @stability stable
     */
    putDestination(value: S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestination): void;
    /**
     * @stability stable
     */
    get destinationInput(): S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestination | undefined;
}
/**
 * @stability stable
 */
export interface S3BucketAnalyticsConfigurationStorageClassAnalysis {
    /**
     * data_export block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_analytics_configuration#data_export S3BucketAnalyticsConfiguration#data_export}
     *
     * @stability stable
     */
    readonly dataExport: S3BucketAnalyticsConfigurationStorageClassAnalysisDataExport;
}
export declare function s3BucketAnalyticsConfigurationStorageClassAnalysisToTerraform(struct?: S3BucketAnalyticsConfigurationStorageClassAnalysisOutputReference | S3BucketAnalyticsConfigurationStorageClassAnalysis): any;
/**
 * @stability stable
 */
export declare class S3BucketAnalyticsConfigurationStorageClassAnalysisOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): S3BucketAnalyticsConfigurationStorageClassAnalysis | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: S3BucketAnalyticsConfigurationStorageClassAnalysis | undefined);
    private _dataExport;
    /**
     * @stability stable
     */
    get dataExport(): S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportOutputReference;
    /**
     * @stability stable
     */
    putDataExport(value: S3BucketAnalyticsConfigurationStorageClassAnalysisDataExport): void;
    /**
     * @stability stable
     */
    get dataExportInput(): S3BucketAnalyticsConfigurationStorageClassAnalysisDataExport | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_analytics_configuration aws_s3_bucket_analytics_configuration}.
 *
 * @stability stable
 */
export declare class S3BucketAnalyticsConfiguration extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_analytics_configuration aws_s3_bucket_analytics_configuration} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: S3BucketAnalyticsConfigurationConfig);
    private _bucket?;
    /**
     * @stability stable
     */
    get bucket(): string;
    /**
     * @stability stable
     */
    set bucket(value: string);
    /**
     * @stability stable
     */
    get bucketInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _filter;
    /**
     * @stability stable
     */
    get filter(): S3BucketAnalyticsConfigurationFilterOutputReference;
    /**
     * @stability stable
     */
    putFilter(value: S3BucketAnalyticsConfigurationFilter): void;
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): S3BucketAnalyticsConfigurationFilter | undefined;
    private _storageClassAnalysis;
    /**
     * @stability stable
     */
    get storageClassAnalysis(): S3BucketAnalyticsConfigurationStorageClassAnalysisOutputReference;
    /**
     * @stability stable
     */
    putStorageClassAnalysis(value: S3BucketAnalyticsConfigurationStorageClassAnalysis): void;
    /**
     * @stability stable
     */
    resetStorageClassAnalysis(): void;
    /**
     * @stability stable
     */
    get storageClassAnalysisInput(): S3BucketAnalyticsConfigurationStorageClassAnalysis | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
