import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Simple Storage Service.
 *
 * @stability stable
 */
export interface S3BucketInventoryConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory#bucket S3BucketInventory#bucket}.
     *
     * @stability stable
     */
    readonly bucket: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory#enabled S3BucketInventory#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory#included_object_versions S3BucketInventory#included_object_versions}.
     *
     * @stability stable
     */
    readonly includedObjectVersions: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory#name S3BucketInventory#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory#optional_fields S3BucketInventory#optional_fields}.
     *
     * @stability stable
     */
    readonly optionalFields?: string[];
    /**
     * destination block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory#destination S3BucketInventory#destination}
     *
     * @stability stable
     */
    readonly destination: S3BucketInventoryDestination;
    /**
     * filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory#filter S3BucketInventory#filter}
     *
     * @stability stable
     */
    readonly filter?: S3BucketInventoryFilter;
    /**
     * schedule block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory#schedule S3BucketInventory#schedule}
     *
     * @stability stable
     */
    readonly schedule: S3BucketInventorySchedule;
}
/**
 * @stability stable
 */
export interface S3BucketInventoryDestinationBucketEncryptionSseKms {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory#key_id S3BucketInventory#key_id}.
     *
     * @stability stable
     */
    readonly keyId: string;
}
export declare function s3BucketInventoryDestinationBucketEncryptionSseKmsToTerraform(struct?: S3BucketInventoryDestinationBucketEncryptionSseKmsOutputReference | S3BucketInventoryDestinationBucketEncryptionSseKms): any;
/**
 * @stability stable
 */
export declare class S3BucketInventoryDestinationBucketEncryptionSseKmsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): S3BucketInventoryDestinationBucketEncryptionSseKms | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: S3BucketInventoryDestinationBucketEncryptionSseKms | undefined);
    private _keyId?;
    /**
     * @stability stable
     */
    get keyId(): string;
    /**
     * @stability stable
     */
    set keyId(value: string);
    /**
     * @stability stable
     */
    get keyIdInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface S3BucketInventoryDestinationBucketEncryptionSseS3 {
}
export declare function s3BucketInventoryDestinationBucketEncryptionSseS3ToTerraform(struct?: S3BucketInventoryDestinationBucketEncryptionSseS3OutputReference | S3BucketInventoryDestinationBucketEncryptionSseS3): any;
/**
 * @stability stable
 */
export declare class S3BucketInventoryDestinationBucketEncryptionSseS3OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): S3BucketInventoryDestinationBucketEncryptionSseS3 | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: S3BucketInventoryDestinationBucketEncryptionSseS3 | undefined);
}
/**
 * @stability stable
 */
export interface S3BucketInventoryDestinationBucketEncryption {
    /**
     * sse_kms block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory#sse_kms S3BucketInventory#sse_kms}
     *
     * @stability stable
     */
    readonly sseKms?: S3BucketInventoryDestinationBucketEncryptionSseKms;
    /**
     * sse_s3 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory#sse_s3 S3BucketInventory#sse_s3}
     *
     * @stability stable
     */
    readonly sseS3?: S3BucketInventoryDestinationBucketEncryptionSseS3;
}
export declare function s3BucketInventoryDestinationBucketEncryptionToTerraform(struct?: S3BucketInventoryDestinationBucketEncryptionOutputReference | S3BucketInventoryDestinationBucketEncryption): any;
/**
 * @stability stable
 */
export declare class S3BucketInventoryDestinationBucketEncryptionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): S3BucketInventoryDestinationBucketEncryption | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: S3BucketInventoryDestinationBucketEncryption | undefined);
    private _sseKms;
    /**
     * @stability stable
     */
    get sseKms(): S3BucketInventoryDestinationBucketEncryptionSseKmsOutputReference;
    /**
     * @stability stable
     */
    putSseKms(value: S3BucketInventoryDestinationBucketEncryptionSseKms): void;
    /**
     * @stability stable
     */
    resetSseKms(): void;
    /**
     * @stability stable
     */
    get sseKmsInput(): S3BucketInventoryDestinationBucketEncryptionSseKms | undefined;
    private _sseS3;
    /**
     * @stability stable
     */
    get sseS3(): S3BucketInventoryDestinationBucketEncryptionSseS3OutputReference;
    /**
     * @stability stable
     */
    putSseS3(value: S3BucketInventoryDestinationBucketEncryptionSseS3): void;
    /**
     * @stability stable
     */
    resetSseS3(): void;
    /**
     * @stability stable
     */
    get sseS3Input(): S3BucketInventoryDestinationBucketEncryptionSseS3 | undefined;
}
/**
 * @stability stable
 */
export interface S3BucketInventoryDestinationBucket {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory#account_id S3BucketInventory#account_id}.
     *
     * @stability stable
     */
    readonly accountId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory#bucket_arn S3BucketInventory#bucket_arn}.
     *
     * @stability stable
     */
    readonly bucketArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory#format S3BucketInventory#format}.
     *
     * @stability stable
     */
    readonly format: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory#prefix S3BucketInventory#prefix}.
     *
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * encryption block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory#encryption S3BucketInventory#encryption}
     *
     * @stability stable
     */
    readonly encryption?: S3BucketInventoryDestinationBucketEncryption;
}
export declare function s3BucketInventoryDestinationBucketToTerraform(struct?: S3BucketInventoryDestinationBucketOutputReference | S3BucketInventoryDestinationBucket): any;
/**
 * @stability stable
 */
export declare class S3BucketInventoryDestinationBucketOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): S3BucketInventoryDestinationBucket | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: S3BucketInventoryDestinationBucket | undefined);
    private _accountId?;
    /**
     * @stability stable
     */
    get accountId(): string;
    /**
     * @stability stable
     */
    set accountId(value: string);
    /**
     * @stability stable
     */
    resetAccountId(): void;
    /**
     * @stability stable
     */
    get accountIdInput(): string | undefined;
    private _bucketArn?;
    /**
     * @stability stable
     */
    get bucketArn(): string;
    /**
     * @stability stable
     */
    set bucketArn(value: string);
    /**
     * @stability stable
     */
    get bucketArnInput(): string | undefined;
    private _format?;
    /**
     * @stability stable
     */
    get format(): string;
    /**
     * @stability stable
     */
    set format(value: string);
    /**
     * @stability stable
     */
    get formatInput(): string | undefined;
    private _prefix?;
    /**
     * @stability stable
     */
    get prefix(): string;
    /**
     * @stability stable
     */
    set prefix(value: string);
    /**
     * @stability stable
     */
    resetPrefix(): void;
    /**
     * @stability stable
     */
    get prefixInput(): string | undefined;
    private _encryption;
    /**
     * @stability stable
     */
    get encryption(): S3BucketInventoryDestinationBucketEncryptionOutputReference;
    /**
     * @stability stable
     */
    putEncryption(value: S3BucketInventoryDestinationBucketEncryption): void;
    /**
     * @stability stable
     */
    resetEncryption(): void;
    /**
     * @stability stable
     */
    get encryptionInput(): S3BucketInventoryDestinationBucketEncryption | undefined;
}
/**
 * @stability stable
 */
export interface S3BucketInventoryDestination {
    /**
     * bucket block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory#bucket S3BucketInventory#bucket}
     *
     * @stability stable
     */
    readonly bucket: S3BucketInventoryDestinationBucket;
}
export declare function s3BucketInventoryDestinationToTerraform(struct?: S3BucketInventoryDestinationOutputReference | S3BucketInventoryDestination): any;
/**
 * @stability stable
 */
export declare class S3BucketInventoryDestinationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): S3BucketInventoryDestination | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: S3BucketInventoryDestination | undefined);
    private _bucket;
    /**
     * @stability stable
     */
    get bucket(): S3BucketInventoryDestinationBucketOutputReference;
    /**
     * @stability stable
     */
    putBucket(value: S3BucketInventoryDestinationBucket): void;
    /**
     * @stability stable
     */
    get bucketInput(): S3BucketInventoryDestinationBucket | undefined;
}
/**
 * @stability stable
 */
export interface S3BucketInventoryFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory#prefix S3BucketInventory#prefix}.
     *
     * @stability stable
     */
    readonly prefix?: string;
}
export declare function s3BucketInventoryFilterToTerraform(struct?: S3BucketInventoryFilterOutputReference | S3BucketInventoryFilter): any;
/**
 * @stability stable
 */
export declare class S3BucketInventoryFilterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): S3BucketInventoryFilter | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: S3BucketInventoryFilter | undefined);
    private _prefix?;
    /**
     * @stability stable
     */
    get prefix(): string;
    /**
     * @stability stable
     */
    set prefix(value: string);
    /**
     * @stability stable
     */
    resetPrefix(): void;
    /**
     * @stability stable
     */
    get prefixInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface S3BucketInventorySchedule {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory#frequency S3BucketInventory#frequency}.
     *
     * @stability stable
     */
    readonly frequency: string;
}
export declare function s3BucketInventoryScheduleToTerraform(struct?: S3BucketInventoryScheduleOutputReference | S3BucketInventorySchedule): any;
/**
 * @stability stable
 */
export declare class S3BucketInventoryScheduleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): S3BucketInventorySchedule | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: S3BucketInventorySchedule | undefined);
    private _frequency?;
    /**
     * @stability stable
     */
    get frequency(): string;
    /**
     * @stability stable
     */
    set frequency(value: string);
    /**
     * @stability stable
     */
    get frequencyInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory aws_s3_bucket_inventory}.
 *
 * @stability stable
 */
export declare class S3BucketInventory extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/s3_bucket_inventory aws_s3_bucket_inventory} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: S3BucketInventoryConfig);
    private _bucket?;
    /**
     * @stability stable
     */
    get bucket(): string;
    /**
     * @stability stable
     */
    set bucket(value: string);
    /**
     * @stability stable
     */
    get bucketInput(): string | undefined;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _includedObjectVersions?;
    /**
     * @stability stable
     */
    get includedObjectVersions(): string;
    /**
     * @stability stable
     */
    set includedObjectVersions(value: string);
    /**
     * @stability stable
     */
    get includedObjectVersionsInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _optionalFields?;
    /**
     * @stability stable
     */
    get optionalFields(): string[];
    /**
     * @stability stable
     */
    set optionalFields(value: string[]);
    /**
     * @stability stable
     */
    resetOptionalFields(): void;
    /**
     * @stability stable
     */
    get optionalFieldsInput(): string[] | undefined;
    private _destination;
    /**
     * @stability stable
     */
    get destination(): S3BucketInventoryDestinationOutputReference;
    /**
     * @stability stable
     */
    putDestination(value: S3BucketInventoryDestination): void;
    /**
     * @stability stable
     */
    get destinationInput(): S3BucketInventoryDestination | undefined;
    private _filter;
    /**
     * @stability stable
     */
    get filter(): S3BucketInventoryFilterOutputReference;
    /**
     * @stability stable
     */
    putFilter(value: S3BucketInventoryFilter): void;
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): S3BucketInventoryFilter | undefined;
    private _schedule;
    /**
     * @stability stable
     */
    get schedule(): S3BucketInventoryScheduleOutputReference;
    /**
     * @stability stable
     */
    putSchedule(value: S3BucketInventorySchedule): void;
    /**
     * @stability stable
     */
    get scheduleInput(): S3BucketInventorySchedule | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
