import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Simple Storage Service.
 *
 * @stability stable
 */
export interface S3ObjectCopyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#acl S3ObjectCopy#acl}.
     *
     * @stability stable
     */
    readonly acl?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#bucket S3ObjectCopy#bucket}.
     *
     * @stability stable
     */
    readonly bucket: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#bucket_key_enabled S3ObjectCopy#bucket_key_enabled}.
     *
     * @stability stable
     */
    readonly bucketKeyEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#cache_control S3ObjectCopy#cache_control}.
     *
     * @stability stable
     */
    readonly cacheControl?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#content_disposition S3ObjectCopy#content_disposition}.
     *
     * @stability stable
     */
    readonly contentDisposition?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#content_encoding S3ObjectCopy#content_encoding}.
     *
     * @stability stable
     */
    readonly contentEncoding?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#content_language S3ObjectCopy#content_language}.
     *
     * @stability stable
     */
    readonly contentLanguage?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#content_type S3ObjectCopy#content_type}.
     *
     * @stability stable
     */
    readonly contentType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#copy_if_match S3ObjectCopy#copy_if_match}.
     *
     * @stability stable
     */
    readonly copyIfMatch?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#copy_if_modified_since S3ObjectCopy#copy_if_modified_since}.
     *
     * @stability stable
     */
    readonly copyIfModifiedSince?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#copy_if_none_match S3ObjectCopy#copy_if_none_match}.
     *
     * @stability stable
     */
    readonly copyIfNoneMatch?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#copy_if_unmodified_since S3ObjectCopy#copy_if_unmodified_since}.
     *
     * @stability stable
     */
    readonly copyIfUnmodifiedSince?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#customer_algorithm S3ObjectCopy#customer_algorithm}.
     *
     * @stability stable
     */
    readonly customerAlgorithm?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#customer_key S3ObjectCopy#customer_key}.
     *
     * @stability stable
     */
    readonly customerKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#customer_key_md5 S3ObjectCopy#customer_key_md5}.
     *
     * @stability stable
     */
    readonly customerKeyMd5?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#expected_bucket_owner S3ObjectCopy#expected_bucket_owner}.
     *
     * @stability stable
     */
    readonly expectedBucketOwner?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#expected_source_bucket_owner S3ObjectCopy#expected_source_bucket_owner}.
     *
     * @stability stable
     */
    readonly expectedSourceBucketOwner?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#expires S3ObjectCopy#expires}.
     *
     * @stability stable
     */
    readonly expires?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#force_destroy S3ObjectCopy#force_destroy}.
     *
     * @stability stable
     */
    readonly forceDestroy?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#key S3ObjectCopy#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#kms_encryption_context S3ObjectCopy#kms_encryption_context}.
     *
     * @stability stable
     */
    readonly kmsEncryptionContext?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#kms_key_id S3ObjectCopy#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#metadata S3ObjectCopy#metadata}.
     *
     * @stability stable
     */
    readonly metadata?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#metadata_directive S3ObjectCopy#metadata_directive}.
     *
     * @stability stable
     */
    readonly metadataDirective?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#object_lock_legal_hold_status S3ObjectCopy#object_lock_legal_hold_status}.
     *
     * @stability stable
     */
    readonly objectLockLegalHoldStatus?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#object_lock_mode S3ObjectCopy#object_lock_mode}.
     *
     * @stability stable
     */
    readonly objectLockMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#object_lock_retain_until_date S3ObjectCopy#object_lock_retain_until_date}.
     *
     * @stability stable
     */
    readonly objectLockRetainUntilDate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#request_payer S3ObjectCopy#request_payer}.
     *
     * @stability stable
     */
    readonly requestPayer?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#server_side_encryption S3ObjectCopy#server_side_encryption}.
     *
     * @stability stable
     */
    readonly serverSideEncryption?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#source S3ObjectCopy#source}.
     *
     * @stability stable
     */
    readonly source: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#source_customer_algorithm S3ObjectCopy#source_customer_algorithm}.
     *
     * @stability stable
     */
    readonly sourceCustomerAlgorithm?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#source_customer_key S3ObjectCopy#source_customer_key}.
     *
     * @stability stable
     */
    readonly sourceCustomerKey?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#source_customer_key_md5 S3ObjectCopy#source_customer_key_md5}.
     *
     * @stability stable
     */
    readonly sourceCustomerKeyMd5?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#storage_class S3ObjectCopy#storage_class}.
     *
     * @stability stable
     */
    readonly storageClass?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#tagging_directive S3ObjectCopy#tagging_directive}.
     *
     * @stability stable
     */
    readonly taggingDirective?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#tags S3ObjectCopy#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#tags_all S3ObjectCopy#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#website_redirect S3ObjectCopy#website_redirect}.
     *
     * @stability stable
     */
    readonly websiteRedirect?: string;
    /**
     * grant block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#grant S3ObjectCopy#grant}
     *
     * @stability stable
     */
    readonly grant?: S3ObjectCopyGrant[];
}
/**
 * @stability stable
 */
export interface S3ObjectCopyGrant {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#email S3ObjectCopy#email}.
     *
     * @stability stable
     */
    readonly email?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#id S3ObjectCopy#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#permissions S3ObjectCopy#permissions}.
     *
     * @stability stable
     */
    readonly permissions: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#type S3ObjectCopy#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy#uri S3ObjectCopy#uri}.
     *
     * @stability stable
     */
    readonly uri?: string;
}
export declare function s3ObjectCopyGrantToTerraform(struct?: S3ObjectCopyGrant): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy aws_s3_object_copy}.
 *
 * @stability stable
 */
export declare class S3ObjectCopy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/s3_object_copy aws_s3_object_copy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: S3ObjectCopyConfig);
    private _acl?;
    /**
     * @stability stable
     */
    get acl(): string;
    /**
     * @stability stable
     */
    set acl(value: string);
    /**
     * @stability stable
     */
    resetAcl(): void;
    /**
     * @stability stable
     */
    get aclInput(): string | undefined;
    private _bucket?;
    /**
     * @stability stable
     */
    get bucket(): string;
    /**
     * @stability stable
     */
    set bucket(value: string);
    /**
     * @stability stable
     */
    get bucketInput(): string | undefined;
    private _bucketKeyEnabled?;
    /**
     * @stability stable
     */
    get bucketKeyEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set bucketKeyEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetBucketKeyEnabled(): void;
    /**
     * @stability stable
     */
    get bucketKeyEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _cacheControl?;
    /**
     * @stability stable
     */
    get cacheControl(): string;
    /**
     * @stability stable
     */
    set cacheControl(value: string);
    /**
     * @stability stable
     */
    resetCacheControl(): void;
    /**
     * @stability stable
     */
    get cacheControlInput(): string | undefined;
    private _contentDisposition?;
    /**
     * @stability stable
     */
    get contentDisposition(): string;
    /**
     * @stability stable
     */
    set contentDisposition(value: string);
    /**
     * @stability stable
     */
    resetContentDisposition(): void;
    /**
     * @stability stable
     */
    get contentDispositionInput(): string | undefined;
    private _contentEncoding?;
    /**
     * @stability stable
     */
    get contentEncoding(): string;
    /**
     * @stability stable
     */
    set contentEncoding(value: string);
    /**
     * @stability stable
     */
    resetContentEncoding(): void;
    /**
     * @stability stable
     */
    get contentEncodingInput(): string | undefined;
    private _contentLanguage?;
    /**
     * @stability stable
     */
    get contentLanguage(): string;
    /**
     * @stability stable
     */
    set contentLanguage(value: string);
    /**
     * @stability stable
     */
    resetContentLanguage(): void;
    /**
     * @stability stable
     */
    get contentLanguageInput(): string | undefined;
    private _contentType?;
    /**
     * @stability stable
     */
    get contentType(): string;
    /**
     * @stability stable
     */
    set contentType(value: string);
    /**
     * @stability stable
     */
    resetContentType(): void;
    /**
     * @stability stable
     */
    get contentTypeInput(): string | undefined;
    private _copyIfMatch?;
    /**
     * @stability stable
     */
    get copyIfMatch(): string;
    /**
     * @stability stable
     */
    set copyIfMatch(value: string);
    /**
     * @stability stable
     */
    resetCopyIfMatch(): void;
    /**
     * @stability stable
     */
    get copyIfMatchInput(): string | undefined;
    private _copyIfModifiedSince?;
    /**
     * @stability stable
     */
    get copyIfModifiedSince(): string;
    /**
     * @stability stable
     */
    set copyIfModifiedSince(value: string);
    /**
     * @stability stable
     */
    resetCopyIfModifiedSince(): void;
    /**
     * @stability stable
     */
    get copyIfModifiedSinceInput(): string | undefined;
    private _copyIfNoneMatch?;
    /**
     * @stability stable
     */
    get copyIfNoneMatch(): string;
    /**
     * @stability stable
     */
    set copyIfNoneMatch(value: string);
    /**
     * @stability stable
     */
    resetCopyIfNoneMatch(): void;
    /**
     * @stability stable
     */
    get copyIfNoneMatchInput(): string | undefined;
    private _copyIfUnmodifiedSince?;
    /**
     * @stability stable
     */
    get copyIfUnmodifiedSince(): string;
    /**
     * @stability stable
     */
    set copyIfUnmodifiedSince(value: string);
    /**
     * @stability stable
     */
    resetCopyIfUnmodifiedSince(): void;
    /**
     * @stability stable
     */
    get copyIfUnmodifiedSinceInput(): string | undefined;
    private _customerAlgorithm?;
    /**
     * @stability stable
     */
    get customerAlgorithm(): string;
    /**
     * @stability stable
     */
    set customerAlgorithm(value: string);
    /**
     * @stability stable
     */
    resetCustomerAlgorithm(): void;
    /**
     * @stability stable
     */
    get customerAlgorithmInput(): string | undefined;
    private _customerKey?;
    /**
     * @stability stable
     */
    get customerKey(): string;
    /**
     * @stability stable
     */
    set customerKey(value: string);
    /**
     * @stability stable
     */
    resetCustomerKey(): void;
    /**
     * @stability stable
     */
    get customerKeyInput(): string | undefined;
    private _customerKeyMd5?;
    /**
     * @stability stable
     */
    get customerKeyMd5(): string;
    /**
     * @stability stable
     */
    set customerKeyMd5(value: string);
    /**
     * @stability stable
     */
    resetCustomerKeyMd5(): void;
    /**
     * @stability stable
     */
    get customerKeyMd5Input(): string | undefined;
    /**
     * @stability stable
     */
    get etag(): string;
    private _expectedBucketOwner?;
    /**
     * @stability stable
     */
    get expectedBucketOwner(): string;
    /**
     * @stability stable
     */
    set expectedBucketOwner(value: string);
    /**
     * @stability stable
     */
    resetExpectedBucketOwner(): void;
    /**
     * @stability stable
     */
    get expectedBucketOwnerInput(): string | undefined;
    private _expectedSourceBucketOwner?;
    /**
     * @stability stable
     */
    get expectedSourceBucketOwner(): string;
    /**
     * @stability stable
     */
    set expectedSourceBucketOwner(value: string);
    /**
     * @stability stable
     */
    resetExpectedSourceBucketOwner(): void;
    /**
     * @stability stable
     */
    get expectedSourceBucketOwnerInput(): string | undefined;
    /**
     * @stability stable
     */
    get expiration(): string;
    private _expires?;
    /**
     * @stability stable
     */
    get expires(): string;
    /**
     * @stability stable
     */
    set expires(value: string);
    /**
     * @stability stable
     */
    resetExpires(): void;
    /**
     * @stability stable
     */
    get expiresInput(): string | undefined;
    private _forceDestroy?;
    /**
     * @stability stable
     */
    get forceDestroy(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set forceDestroy(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetForceDestroy(): void;
    /**
     * @stability stable
     */
    get forceDestroyInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _key?;
    /**
     * @stability stable
     */
    get key(): string;
    /**
     * @stability stable
     */
    set key(value: string);
    /**
     * @stability stable
     */
    get keyInput(): string | undefined;
    private _kmsEncryptionContext?;
    /**
     * @stability stable
     */
    get kmsEncryptionContext(): string;
    /**
     * @stability stable
     */
    set kmsEncryptionContext(value: string);
    /**
     * @stability stable
     */
    resetKmsEncryptionContext(): void;
    /**
     * @stability stable
     */
    get kmsEncryptionContextInput(): string | undefined;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get lastModified(): string;
    private _metadata?;
    /**
     * @stability stable
     */
    get metadata(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set metadata(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetMetadata(): void;
    /**
     * @stability stable
     */
    get metadataInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _metadataDirective?;
    /**
     * @stability stable
     */
    get metadataDirective(): string;
    /**
     * @stability stable
     */
    set metadataDirective(value: string);
    /**
     * @stability stable
     */
    resetMetadataDirective(): void;
    /**
     * @stability stable
     */
    get metadataDirectiveInput(): string | undefined;
    private _objectLockLegalHoldStatus?;
    /**
     * @stability stable
     */
    get objectLockLegalHoldStatus(): string;
    /**
     * @stability stable
     */
    set objectLockLegalHoldStatus(value: string);
    /**
     * @stability stable
     */
    resetObjectLockLegalHoldStatus(): void;
    /**
     * @stability stable
     */
    get objectLockLegalHoldStatusInput(): string | undefined;
    private _objectLockMode?;
    /**
     * @stability stable
     */
    get objectLockMode(): string;
    /**
     * @stability stable
     */
    set objectLockMode(value: string);
    /**
     * @stability stable
     */
    resetObjectLockMode(): void;
    /**
     * @stability stable
     */
    get objectLockModeInput(): string | undefined;
    private _objectLockRetainUntilDate?;
    /**
     * @stability stable
     */
    get objectLockRetainUntilDate(): string;
    /**
     * @stability stable
     */
    set objectLockRetainUntilDate(value: string);
    /**
     * @stability stable
     */
    resetObjectLockRetainUntilDate(): void;
    /**
     * @stability stable
     */
    get objectLockRetainUntilDateInput(): string | undefined;
    /**
     * @stability stable
     */
    get requestCharged(): any;
    private _requestPayer?;
    /**
     * @stability stable
     */
    get requestPayer(): string;
    /**
     * @stability stable
     */
    set requestPayer(value: string);
    /**
     * @stability stable
     */
    resetRequestPayer(): void;
    /**
     * @stability stable
     */
    get requestPayerInput(): string | undefined;
    private _serverSideEncryption?;
    /**
     * @stability stable
     */
    get serverSideEncryption(): string;
    /**
     * @stability stable
     */
    set serverSideEncryption(value: string);
    /**
     * @stability stable
     */
    resetServerSideEncryption(): void;
    /**
     * @stability stable
     */
    get serverSideEncryptionInput(): string | undefined;
    private _source?;
    /**
     * @stability stable
     */
    get source(): string;
    /**
     * @stability stable
     */
    set source(value: string);
    /**
     * @stability stable
     */
    get sourceInput(): string | undefined;
    private _sourceCustomerAlgorithm?;
    /**
     * @stability stable
     */
    get sourceCustomerAlgorithm(): string;
    /**
     * @stability stable
     */
    set sourceCustomerAlgorithm(value: string);
    /**
     * @stability stable
     */
    resetSourceCustomerAlgorithm(): void;
    /**
     * @stability stable
     */
    get sourceCustomerAlgorithmInput(): string | undefined;
    private _sourceCustomerKey?;
    /**
     * @stability stable
     */
    get sourceCustomerKey(): string;
    /**
     * @stability stable
     */
    set sourceCustomerKey(value: string);
    /**
     * @stability stable
     */
    resetSourceCustomerKey(): void;
    /**
     * @stability stable
     */
    get sourceCustomerKeyInput(): string | undefined;
    private _sourceCustomerKeyMd5?;
    /**
     * @stability stable
     */
    get sourceCustomerKeyMd5(): string;
    /**
     * @stability stable
     */
    set sourceCustomerKeyMd5(value: string);
    /**
     * @stability stable
     */
    resetSourceCustomerKeyMd5(): void;
    /**
     * @stability stable
     */
    get sourceCustomerKeyMd5Input(): string | undefined;
    /**
     * @stability stable
     */
    get sourceVersionId(): string;
    private _storageClass?;
    /**
     * @stability stable
     */
    get storageClass(): string;
    /**
     * @stability stable
     */
    set storageClass(value: string);
    /**
     * @stability stable
     */
    resetStorageClass(): void;
    /**
     * @stability stable
     */
    get storageClassInput(): string | undefined;
    private _taggingDirective?;
    /**
     * @stability stable
     */
    get taggingDirective(): string;
    /**
     * @stability stable
     */
    set taggingDirective(value: string);
    /**
     * @stability stable
     */
    resetTaggingDirective(): void;
    /**
     * @stability stable
     */
    get taggingDirectiveInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get versionId(): string;
    private _websiteRedirect?;
    /**
     * @stability stable
     */
    get websiteRedirect(): string;
    /**
     * @stability stable
     */
    set websiteRedirect(value: string);
    /**
     * @stability stable
     */
    resetWebsiteRedirect(): void;
    /**
     * @stability stable
     */
    get websiteRedirectInput(): string | undefined;
    private _grant?;
    /**
     * @stability stable
     */
    get grant(): S3ObjectCopyGrant[];
    /**
     * @stability stable
     */
    set grant(value: S3ObjectCopyGrant[]);
    /**
     * @stability stable
     */
    resetGrant(): void;
    /**
     * @stability stable
     */
    get grantInput(): S3ObjectCopyGrant[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
