import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Simple Storage Service.
 *
 * @stability stable
 */
export interface S3ControlObjectLambdaAccessPointConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_object_lambda_access_point#account_id S3ControlObjectLambdaAccessPoint#account_id}.
     *
     * @stability stable
     */
    readonly accountId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_object_lambda_access_point#name S3ControlObjectLambdaAccessPoint#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_object_lambda_access_point#configuration S3ControlObjectLambdaAccessPoint#configuration}
     *
     * @stability stable
     */
    readonly configuration: S3ControlObjectLambdaAccessPointConfiguration;
}
/**
 * @stability stable
 */
export interface S3ControlObjectLambdaAccessPointConfigurationTransformationConfigurationContentTransformationAwsLambda {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_object_lambda_access_point#function_arn S3ControlObjectLambdaAccessPoint#function_arn}.
     *
     * @stability stable
     */
    readonly functionArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_object_lambda_access_point#function_payload S3ControlObjectLambdaAccessPoint#function_payload}.
     *
     * @stability stable
     */
    readonly functionPayload?: string;
}
export declare function s3ControlObjectLambdaAccessPointConfigurationTransformationConfigurationContentTransformationAwsLambdaToTerraform(struct?: S3ControlObjectLambdaAccessPointConfigurationTransformationConfigurationContentTransformationAwsLambdaOutputReference | S3ControlObjectLambdaAccessPointConfigurationTransformationConfigurationContentTransformationAwsLambda): any;
/**
 * @stability stable
 */
export declare class S3ControlObjectLambdaAccessPointConfigurationTransformationConfigurationContentTransformationAwsLambdaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): S3ControlObjectLambdaAccessPointConfigurationTransformationConfigurationContentTransformationAwsLambda | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: S3ControlObjectLambdaAccessPointConfigurationTransformationConfigurationContentTransformationAwsLambda | undefined);
    private _functionArn?;
    /**
     * @stability stable
     */
    get functionArn(): string;
    /**
     * @stability stable
     */
    set functionArn(value: string);
    /**
     * @stability stable
     */
    get functionArnInput(): string | undefined;
    private _functionPayload?;
    /**
     * @stability stable
     */
    get functionPayload(): string;
    /**
     * @stability stable
     */
    set functionPayload(value: string);
    /**
     * @stability stable
     */
    resetFunctionPayload(): void;
    /**
     * @stability stable
     */
    get functionPayloadInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface S3ControlObjectLambdaAccessPointConfigurationTransformationConfigurationContentTransformation {
    /**
     * aws_lambda block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_object_lambda_access_point#aws_lambda S3ControlObjectLambdaAccessPoint#aws_lambda}
     *
     * @stability stable
     */
    readonly awsLambda: S3ControlObjectLambdaAccessPointConfigurationTransformationConfigurationContentTransformationAwsLambda;
}
export declare function s3ControlObjectLambdaAccessPointConfigurationTransformationConfigurationContentTransformationToTerraform(struct?: S3ControlObjectLambdaAccessPointConfigurationTransformationConfigurationContentTransformationOutputReference | S3ControlObjectLambdaAccessPointConfigurationTransformationConfigurationContentTransformation): any;
/**
 * @stability stable
 */
export declare class S3ControlObjectLambdaAccessPointConfigurationTransformationConfigurationContentTransformationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): S3ControlObjectLambdaAccessPointConfigurationTransformationConfigurationContentTransformation | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: S3ControlObjectLambdaAccessPointConfigurationTransformationConfigurationContentTransformation | undefined);
    private _awsLambda;
    /**
     * @stability stable
     */
    get awsLambda(): S3ControlObjectLambdaAccessPointConfigurationTransformationConfigurationContentTransformationAwsLambdaOutputReference;
    /**
     * @stability stable
     */
    putAwsLambda(value: S3ControlObjectLambdaAccessPointConfigurationTransformationConfigurationContentTransformationAwsLambda): void;
    /**
     * @stability stable
     */
    get awsLambdaInput(): S3ControlObjectLambdaAccessPointConfigurationTransformationConfigurationContentTransformationAwsLambda | undefined;
}
/**
 * @stability stable
 */
export interface S3ControlObjectLambdaAccessPointConfigurationTransformationConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_object_lambda_access_point#actions S3ControlObjectLambdaAccessPoint#actions}.
     *
     * @stability stable
     */
    readonly actions: string[];
    /**
     * content_transformation block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_object_lambda_access_point#content_transformation S3ControlObjectLambdaAccessPoint#content_transformation}
     *
     * @stability stable
     */
    readonly contentTransformation: S3ControlObjectLambdaAccessPointConfigurationTransformationConfigurationContentTransformation;
}
export declare function s3ControlObjectLambdaAccessPointConfigurationTransformationConfigurationToTerraform(struct?: S3ControlObjectLambdaAccessPointConfigurationTransformationConfiguration): any;
/**
 * @stability stable
 */
export interface S3ControlObjectLambdaAccessPointConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_object_lambda_access_point#allowed_features S3ControlObjectLambdaAccessPoint#allowed_features}.
     *
     * @stability stable
     */
    readonly allowedFeatures?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_object_lambda_access_point#cloud_watch_metrics_enabled S3ControlObjectLambdaAccessPoint#cloud_watch_metrics_enabled}.
     *
     * @stability stable
     */
    readonly cloudWatchMetricsEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_object_lambda_access_point#supporting_access_point S3ControlObjectLambdaAccessPoint#supporting_access_point}.
     *
     * @stability stable
     */
    readonly supportingAccessPoint: string;
    /**
     * transformation_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/s3control_object_lambda_access_point#transformation_configuration S3ControlObjectLambdaAccessPoint#transformation_configuration}
     *
     * @stability stable
     */
    readonly transformationConfiguration: S3ControlObjectLambdaAccessPointConfigurationTransformationConfiguration[];
}
export declare function s3ControlObjectLambdaAccessPointConfigurationToTerraform(struct?: S3ControlObjectLambdaAccessPointConfigurationOutputReference | S3ControlObjectLambdaAccessPointConfiguration): any;
/**
 * @stability stable
 */
export declare class S3ControlObjectLambdaAccessPointConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): S3ControlObjectLambdaAccessPointConfiguration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: S3ControlObjectLambdaAccessPointConfiguration | undefined);
    private _allowedFeatures?;
    /**
     * @stability stable
     */
    get allowedFeatures(): string[];
    /**
     * @stability stable
     */
    set allowedFeatures(value: string[]);
    /**
     * @stability stable
     */
    resetAllowedFeatures(): void;
    /**
     * @stability stable
     */
    get allowedFeaturesInput(): string[] | undefined;
    private _cloudWatchMetricsEnabled?;
    /**
     * @stability stable
     */
    get cloudWatchMetricsEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set cloudWatchMetricsEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetCloudWatchMetricsEnabled(): void;
    /**
     * @stability stable
     */
    get cloudWatchMetricsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _supportingAccessPoint?;
    /**
     * @stability stable
     */
    get supportingAccessPoint(): string;
    /**
     * @stability stable
     */
    set supportingAccessPoint(value: string);
    /**
     * @stability stable
     */
    get supportingAccessPointInput(): string | undefined;
    private _transformationConfiguration?;
    /**
     * @stability stable
     */
    get transformationConfiguration(): S3ControlObjectLambdaAccessPointConfigurationTransformationConfiguration[];
    /**
     * @stability stable
     */
    set transformationConfiguration(value: S3ControlObjectLambdaAccessPointConfigurationTransformationConfiguration[]);
    /**
     * @stability stable
     */
    get transformationConfigurationInput(): S3ControlObjectLambdaAccessPointConfigurationTransformationConfiguration[] | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/s3control_object_lambda_access_point aws_s3control_object_lambda_access_point}.
 *
 * @stability stable
 */
export declare class S3ControlObjectLambdaAccessPoint extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/s3control_object_lambda_access_point aws_s3control_object_lambda_access_point} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: S3ControlObjectLambdaAccessPointConfig);
    private _accountId?;
    /**
     * @stability stable
     */
    get accountId(): string;
    /**
     * @stability stable
     */
    set accountId(value: string);
    /**
     * @stability stable
     */
    resetAccountId(): void;
    /**
     * @stability stable
     */
    get accountIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _configuration;
    /**
     * @stability stable
     */
    get configuration(): S3ControlObjectLambdaAccessPointConfigurationOutputReference;
    /**
     * @stability stable
     */
    putConfiguration(value: S3ControlObjectLambdaAccessPointConfiguration): void;
    /**
     * @stability stable
     */
    get configurationInput(): S3ControlObjectLambdaAccessPointConfiguration | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
