import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS SageMaker.
 *
 * @stability stable
 */
export interface SagemakerDomainConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#app_network_access_type SagemakerDomain#app_network_access_type}.
     *
     * @stability stable
     */
    readonly appNetworkAccessType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#auth_mode SagemakerDomain#auth_mode}.
     *
     * @stability stable
     */
    readonly authMode: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#domain_name SagemakerDomain#domain_name}.
     *
     * @stability stable
     */
    readonly domainName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#kms_key_id SagemakerDomain#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#subnet_ids SagemakerDomain#subnet_ids}.
     *
     * @stability stable
     */
    readonly subnetIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#tags SagemakerDomain#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#tags_all SagemakerDomain#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#vpc_id SagemakerDomain#vpc_id}.
     *
     * @stability stable
     */
    readonly vpcId: string;
    /**
     * default_user_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#default_user_settings SagemakerDomain#default_user_settings}
     *
     * @stability stable
     */
    readonly defaultUserSettings: SagemakerDomainDefaultUserSettings;
    /**
     * retention_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#retention_policy SagemakerDomain#retention_policy}
     *
     * @stability stable
     */
    readonly retentionPolicy?: SagemakerDomainRetentionPolicy;
}
/**
 * @stability stable
 */
export interface SagemakerDomainDefaultUserSettingsJupyterServerAppSettingsDefaultResourceSpec {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#instance_type SagemakerDomain#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#lifecycle_config_arn SagemakerDomain#lifecycle_config_arn}.
     *
     * @stability stable
     */
    readonly lifecycleConfigArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#sagemaker_image_arn SagemakerDomain#sagemaker_image_arn}.
     *
     * @stability stable
     */
    readonly sagemakerImageArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#sagemaker_image_version_arn SagemakerDomain#sagemaker_image_version_arn}.
     *
     * @stability stable
     */
    readonly sagemakerImageVersionArn?: string;
}
export declare function sagemakerDomainDefaultUserSettingsJupyterServerAppSettingsDefaultResourceSpecToTerraform(struct?: SagemakerDomainDefaultUserSettingsJupyterServerAppSettingsDefaultResourceSpecOutputReference | SagemakerDomainDefaultUserSettingsJupyterServerAppSettingsDefaultResourceSpec): any;
/**
 * @stability stable
 */
export declare class SagemakerDomainDefaultUserSettingsJupyterServerAppSettingsDefaultResourceSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerDomainDefaultUserSettingsJupyterServerAppSettingsDefaultResourceSpec | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerDomainDefaultUserSettingsJupyterServerAppSettingsDefaultResourceSpec | undefined);
    private _instanceType?;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    resetInstanceType(): void;
    /**
     * @stability stable
     */
    get instanceTypeInput(): string | undefined;
    private _lifecycleConfigArn?;
    /**
     * @stability stable
     */
    get lifecycleConfigArn(): string;
    /**
     * @stability stable
     */
    set lifecycleConfigArn(value: string);
    /**
     * @stability stable
     */
    resetLifecycleConfigArn(): void;
    /**
     * @stability stable
     */
    get lifecycleConfigArnInput(): string | undefined;
    private _sagemakerImageArn?;
    /**
     * @stability stable
     */
    get sagemakerImageArn(): string;
    /**
     * @stability stable
     */
    set sagemakerImageArn(value: string);
    /**
     * @stability stable
     */
    resetSagemakerImageArn(): void;
    /**
     * @stability stable
     */
    get sagemakerImageArnInput(): string | undefined;
    private _sagemakerImageVersionArn?;
    /**
     * @stability stable
     */
    get sagemakerImageVersionArn(): string;
    /**
     * @stability stable
     */
    set sagemakerImageVersionArn(value: string);
    /**
     * @stability stable
     */
    resetSagemakerImageVersionArn(): void;
    /**
     * @stability stable
     */
    get sagemakerImageVersionArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerDomainDefaultUserSettingsJupyterServerAppSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#lifecycle_config_arns SagemakerDomain#lifecycle_config_arns}.
     *
     * @stability stable
     */
    readonly lifecycleConfigArns?: string[];
    /**
     * default_resource_spec block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#default_resource_spec SagemakerDomain#default_resource_spec}
     *
     * @stability stable
     */
    readonly defaultResourceSpec?: SagemakerDomainDefaultUserSettingsJupyterServerAppSettingsDefaultResourceSpec;
}
export declare function sagemakerDomainDefaultUserSettingsJupyterServerAppSettingsToTerraform(struct?: SagemakerDomainDefaultUserSettingsJupyterServerAppSettingsOutputReference | SagemakerDomainDefaultUserSettingsJupyterServerAppSettings): any;
/**
 * @stability stable
 */
export declare class SagemakerDomainDefaultUserSettingsJupyterServerAppSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerDomainDefaultUserSettingsJupyterServerAppSettings | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerDomainDefaultUserSettingsJupyterServerAppSettings | undefined);
    private _lifecycleConfigArns?;
    /**
     * @stability stable
     */
    get lifecycleConfigArns(): string[];
    /**
     * @stability stable
     */
    set lifecycleConfigArns(value: string[]);
    /**
     * @stability stable
     */
    resetLifecycleConfigArns(): void;
    /**
     * @stability stable
     */
    get lifecycleConfigArnsInput(): string[] | undefined;
    private _defaultResourceSpec;
    /**
     * @stability stable
     */
    get defaultResourceSpec(): SagemakerDomainDefaultUserSettingsJupyterServerAppSettingsDefaultResourceSpecOutputReference;
    /**
     * @stability stable
     */
    putDefaultResourceSpec(value: SagemakerDomainDefaultUserSettingsJupyterServerAppSettingsDefaultResourceSpec): void;
    /**
     * @stability stable
     */
    resetDefaultResourceSpec(): void;
    /**
     * @stability stable
     */
    get defaultResourceSpecInput(): SagemakerDomainDefaultUserSettingsJupyterServerAppSettingsDefaultResourceSpec | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsCustomImage {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#app_image_config_name SagemakerDomain#app_image_config_name}.
     *
     * @stability stable
     */
    readonly appImageConfigName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#image_name SagemakerDomain#image_name}.
     *
     * @stability stable
     */
    readonly imageName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#image_version_number SagemakerDomain#image_version_number}.
     *
     * @stability stable
     */
    readonly imageVersionNumber?: number;
}
export declare function sagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsCustomImageToTerraform(struct?: SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsCustomImage): any;
/**
 * @stability stable
 */
export interface SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsDefaultResourceSpec {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#instance_type SagemakerDomain#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#lifecycle_config_arn SagemakerDomain#lifecycle_config_arn}.
     *
     * @stability stable
     */
    readonly lifecycleConfigArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#sagemaker_image_arn SagemakerDomain#sagemaker_image_arn}.
     *
     * @stability stable
     */
    readonly sagemakerImageArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#sagemaker_image_version_arn SagemakerDomain#sagemaker_image_version_arn}.
     *
     * @stability stable
     */
    readonly sagemakerImageVersionArn?: string;
}
export declare function sagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsDefaultResourceSpecToTerraform(struct?: SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsDefaultResourceSpecOutputReference | SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsDefaultResourceSpec): any;
/**
 * @stability stable
 */
export declare class SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsDefaultResourceSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsDefaultResourceSpec | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsDefaultResourceSpec | undefined);
    private _instanceType?;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    resetInstanceType(): void;
    /**
     * @stability stable
     */
    get instanceTypeInput(): string | undefined;
    private _lifecycleConfigArn?;
    /**
     * @stability stable
     */
    get lifecycleConfigArn(): string;
    /**
     * @stability stable
     */
    set lifecycleConfigArn(value: string);
    /**
     * @stability stable
     */
    resetLifecycleConfigArn(): void;
    /**
     * @stability stable
     */
    get lifecycleConfigArnInput(): string | undefined;
    private _sagemakerImageArn?;
    /**
     * @stability stable
     */
    get sagemakerImageArn(): string;
    /**
     * @stability stable
     */
    set sagemakerImageArn(value: string);
    /**
     * @stability stable
     */
    resetSagemakerImageArn(): void;
    /**
     * @stability stable
     */
    get sagemakerImageArnInput(): string | undefined;
    private _sagemakerImageVersionArn?;
    /**
     * @stability stable
     */
    get sagemakerImageVersionArn(): string;
    /**
     * @stability stable
     */
    set sagemakerImageVersionArn(value: string);
    /**
     * @stability stable
     */
    resetSagemakerImageVersionArn(): void;
    /**
     * @stability stable
     */
    get sagemakerImageVersionArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerDomainDefaultUserSettingsKernelGatewayAppSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#lifecycle_config_arns SagemakerDomain#lifecycle_config_arns}.
     *
     * @stability stable
     */
    readonly lifecycleConfigArns?: string[];
    /**
     * custom_image block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#custom_image SagemakerDomain#custom_image}
     *
     * @stability stable
     */
    readonly customImage?: SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsCustomImage[];
    /**
     * default_resource_spec block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#default_resource_spec SagemakerDomain#default_resource_spec}
     *
     * @stability stable
     */
    readonly defaultResourceSpec?: SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsDefaultResourceSpec;
}
export declare function sagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsToTerraform(struct?: SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsOutputReference | SagemakerDomainDefaultUserSettingsKernelGatewayAppSettings): any;
/**
 * @stability stable
 */
export declare class SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerDomainDefaultUserSettingsKernelGatewayAppSettings | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerDomainDefaultUserSettingsKernelGatewayAppSettings | undefined);
    private _lifecycleConfigArns?;
    /**
     * @stability stable
     */
    get lifecycleConfigArns(): string[];
    /**
     * @stability stable
     */
    set lifecycleConfigArns(value: string[]);
    /**
     * @stability stable
     */
    resetLifecycleConfigArns(): void;
    /**
     * @stability stable
     */
    get lifecycleConfigArnsInput(): string[] | undefined;
    private _customImage?;
    /**
     * @stability stable
     */
    get customImage(): SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsCustomImage[];
    /**
     * @stability stable
     */
    set customImage(value: SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsCustomImage[]);
    /**
     * @stability stable
     */
    resetCustomImage(): void;
    /**
     * @stability stable
     */
    get customImageInput(): SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsCustomImage[] | undefined;
    private _defaultResourceSpec;
    /**
     * @stability stable
     */
    get defaultResourceSpec(): SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsDefaultResourceSpecOutputReference;
    /**
     * @stability stable
     */
    putDefaultResourceSpec(value: SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsDefaultResourceSpec): void;
    /**
     * @stability stable
     */
    resetDefaultResourceSpec(): void;
    /**
     * @stability stable
     */
    get defaultResourceSpecInput(): SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsDefaultResourceSpec | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerDomainDefaultUserSettingsSharingSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#notebook_output_option SagemakerDomain#notebook_output_option}.
     *
     * @stability stable
     */
    readonly notebookOutputOption?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#s3_kms_key_id SagemakerDomain#s3_kms_key_id}.
     *
     * @stability stable
     */
    readonly s3KmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#s3_output_path SagemakerDomain#s3_output_path}.
     *
     * @stability stable
     */
    readonly s3OutputPath?: string;
}
export declare function sagemakerDomainDefaultUserSettingsSharingSettingsToTerraform(struct?: SagemakerDomainDefaultUserSettingsSharingSettingsOutputReference | SagemakerDomainDefaultUserSettingsSharingSettings): any;
/**
 * @stability stable
 */
export declare class SagemakerDomainDefaultUserSettingsSharingSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerDomainDefaultUserSettingsSharingSettings | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerDomainDefaultUserSettingsSharingSettings | undefined);
    private _notebookOutputOption?;
    /**
     * @stability stable
     */
    get notebookOutputOption(): string;
    /**
     * @stability stable
     */
    set notebookOutputOption(value: string);
    /**
     * @stability stable
     */
    resetNotebookOutputOption(): void;
    /**
     * @stability stable
     */
    get notebookOutputOptionInput(): string | undefined;
    private _s3KmsKeyId?;
    /**
     * @stability stable
     */
    get s3KmsKeyId(): string;
    /**
     * @stability stable
     */
    set s3KmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetS3KmsKeyId(): void;
    /**
     * @stability stable
     */
    get s3KmsKeyIdInput(): string | undefined;
    private _s3OutputPath?;
    /**
     * @stability stable
     */
    get s3OutputPath(): string;
    /**
     * @stability stable
     */
    set s3OutputPath(value: string);
    /**
     * @stability stable
     */
    resetS3OutputPath(): void;
    /**
     * @stability stable
     */
    get s3OutputPathInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerDomainDefaultUserSettingsTensorBoardAppSettingsDefaultResourceSpec {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#instance_type SagemakerDomain#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#lifecycle_config_arn SagemakerDomain#lifecycle_config_arn}.
     *
     * @stability stable
     */
    readonly lifecycleConfigArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#sagemaker_image_arn SagemakerDomain#sagemaker_image_arn}.
     *
     * @stability stable
     */
    readonly sagemakerImageArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#sagemaker_image_version_arn SagemakerDomain#sagemaker_image_version_arn}.
     *
     * @stability stable
     */
    readonly sagemakerImageVersionArn?: string;
}
export declare function sagemakerDomainDefaultUserSettingsTensorBoardAppSettingsDefaultResourceSpecToTerraform(struct?: SagemakerDomainDefaultUserSettingsTensorBoardAppSettingsDefaultResourceSpecOutputReference | SagemakerDomainDefaultUserSettingsTensorBoardAppSettingsDefaultResourceSpec): any;
/**
 * @stability stable
 */
export declare class SagemakerDomainDefaultUserSettingsTensorBoardAppSettingsDefaultResourceSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerDomainDefaultUserSettingsTensorBoardAppSettingsDefaultResourceSpec | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerDomainDefaultUserSettingsTensorBoardAppSettingsDefaultResourceSpec | undefined);
    private _instanceType?;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    resetInstanceType(): void;
    /**
     * @stability stable
     */
    get instanceTypeInput(): string | undefined;
    private _lifecycleConfigArn?;
    /**
     * @stability stable
     */
    get lifecycleConfigArn(): string;
    /**
     * @stability stable
     */
    set lifecycleConfigArn(value: string);
    /**
     * @stability stable
     */
    resetLifecycleConfigArn(): void;
    /**
     * @stability stable
     */
    get lifecycleConfigArnInput(): string | undefined;
    private _sagemakerImageArn?;
    /**
     * @stability stable
     */
    get sagemakerImageArn(): string;
    /**
     * @stability stable
     */
    set sagemakerImageArn(value: string);
    /**
     * @stability stable
     */
    resetSagemakerImageArn(): void;
    /**
     * @stability stable
     */
    get sagemakerImageArnInput(): string | undefined;
    private _sagemakerImageVersionArn?;
    /**
     * @stability stable
     */
    get sagemakerImageVersionArn(): string;
    /**
     * @stability stable
     */
    set sagemakerImageVersionArn(value: string);
    /**
     * @stability stable
     */
    resetSagemakerImageVersionArn(): void;
    /**
     * @stability stable
     */
    get sagemakerImageVersionArnInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerDomainDefaultUserSettingsTensorBoardAppSettings {
    /**
     * default_resource_spec block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#default_resource_spec SagemakerDomain#default_resource_spec}
     *
     * @stability stable
     */
    readonly defaultResourceSpec?: SagemakerDomainDefaultUserSettingsTensorBoardAppSettingsDefaultResourceSpec;
}
export declare function sagemakerDomainDefaultUserSettingsTensorBoardAppSettingsToTerraform(struct?: SagemakerDomainDefaultUserSettingsTensorBoardAppSettingsOutputReference | SagemakerDomainDefaultUserSettingsTensorBoardAppSettings): any;
/**
 * @stability stable
 */
export declare class SagemakerDomainDefaultUserSettingsTensorBoardAppSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerDomainDefaultUserSettingsTensorBoardAppSettings | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerDomainDefaultUserSettingsTensorBoardAppSettings | undefined);
    private _defaultResourceSpec;
    /**
     * @stability stable
     */
    get defaultResourceSpec(): SagemakerDomainDefaultUserSettingsTensorBoardAppSettingsDefaultResourceSpecOutputReference;
    /**
     * @stability stable
     */
    putDefaultResourceSpec(value: SagemakerDomainDefaultUserSettingsTensorBoardAppSettingsDefaultResourceSpec): void;
    /**
     * @stability stable
     */
    resetDefaultResourceSpec(): void;
    /**
     * @stability stable
     */
    get defaultResourceSpecInput(): SagemakerDomainDefaultUserSettingsTensorBoardAppSettingsDefaultResourceSpec | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerDomainDefaultUserSettings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#execution_role SagemakerDomain#execution_role}.
     *
     * @stability stable
     */
    readonly executionRole: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#security_groups SagemakerDomain#security_groups}.
     *
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * jupyter_server_app_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#jupyter_server_app_settings SagemakerDomain#jupyter_server_app_settings}
     *
     * @stability stable
     */
    readonly jupyterServerAppSettings?: SagemakerDomainDefaultUserSettingsJupyterServerAppSettings;
    /**
     * kernel_gateway_app_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#kernel_gateway_app_settings SagemakerDomain#kernel_gateway_app_settings}
     *
     * @stability stable
     */
    readonly kernelGatewayAppSettings?: SagemakerDomainDefaultUserSettingsKernelGatewayAppSettings;
    /**
     * sharing_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#sharing_settings SagemakerDomain#sharing_settings}
     *
     * @stability stable
     */
    readonly sharingSettings?: SagemakerDomainDefaultUserSettingsSharingSettings;
    /**
     * tensor_board_app_settings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#tensor_board_app_settings SagemakerDomain#tensor_board_app_settings}
     *
     * @stability stable
     */
    readonly tensorBoardAppSettings?: SagemakerDomainDefaultUserSettingsTensorBoardAppSettings;
}
export declare function sagemakerDomainDefaultUserSettingsToTerraform(struct?: SagemakerDomainDefaultUserSettingsOutputReference | SagemakerDomainDefaultUserSettings): any;
/**
 * @stability stable
 */
export declare class SagemakerDomainDefaultUserSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerDomainDefaultUserSettings | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerDomainDefaultUserSettings | undefined);
    private _executionRole?;
    /**
     * @stability stable
     */
    get executionRole(): string;
    /**
     * @stability stable
     */
    set executionRole(value: string);
    /**
     * @stability stable
     */
    get executionRoleInput(): string | undefined;
    private _securityGroups?;
    /**
     * @stability stable
     */
    get securityGroups(): string[];
    /**
     * @stability stable
     */
    set securityGroups(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroups(): void;
    /**
     * @stability stable
     */
    get securityGroupsInput(): string[] | undefined;
    private _jupyterServerAppSettings;
    /**
     * @stability stable
     */
    get jupyterServerAppSettings(): SagemakerDomainDefaultUserSettingsJupyterServerAppSettingsOutputReference;
    /**
     * @stability stable
     */
    putJupyterServerAppSettings(value: SagemakerDomainDefaultUserSettingsJupyterServerAppSettings): void;
    /**
     * @stability stable
     */
    resetJupyterServerAppSettings(): void;
    /**
     * @stability stable
     */
    get jupyterServerAppSettingsInput(): SagemakerDomainDefaultUserSettingsJupyterServerAppSettings | undefined;
    private _kernelGatewayAppSettings;
    /**
     * @stability stable
     */
    get kernelGatewayAppSettings(): SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsOutputReference;
    /**
     * @stability stable
     */
    putKernelGatewayAppSettings(value: SagemakerDomainDefaultUserSettingsKernelGatewayAppSettings): void;
    /**
     * @stability stable
     */
    resetKernelGatewayAppSettings(): void;
    /**
     * @stability stable
     */
    get kernelGatewayAppSettingsInput(): SagemakerDomainDefaultUserSettingsKernelGatewayAppSettings | undefined;
    private _sharingSettings;
    /**
     * @stability stable
     */
    get sharingSettings(): SagemakerDomainDefaultUserSettingsSharingSettingsOutputReference;
    /**
     * @stability stable
     */
    putSharingSettings(value: SagemakerDomainDefaultUserSettingsSharingSettings): void;
    /**
     * @stability stable
     */
    resetSharingSettings(): void;
    /**
     * @stability stable
     */
    get sharingSettingsInput(): SagemakerDomainDefaultUserSettingsSharingSettings | undefined;
    private _tensorBoardAppSettings;
    /**
     * @stability stable
     */
    get tensorBoardAppSettings(): SagemakerDomainDefaultUserSettingsTensorBoardAppSettingsOutputReference;
    /**
     * @stability stable
     */
    putTensorBoardAppSettings(value: SagemakerDomainDefaultUserSettingsTensorBoardAppSettings): void;
    /**
     * @stability stable
     */
    resetTensorBoardAppSettings(): void;
    /**
     * @stability stable
     */
    get tensorBoardAppSettingsInput(): SagemakerDomainDefaultUserSettingsTensorBoardAppSettings | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerDomainRetentionPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain#home_efs_file_system SagemakerDomain#home_efs_file_system}.
     *
     * @stability stable
     */
    readonly homeEfsFileSystem?: string;
}
export declare function sagemakerDomainRetentionPolicyToTerraform(struct?: SagemakerDomainRetentionPolicyOutputReference | SagemakerDomainRetentionPolicy): any;
/**
 * @stability stable
 */
export declare class SagemakerDomainRetentionPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerDomainRetentionPolicy | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerDomainRetentionPolicy | undefined);
    private _homeEfsFileSystem?;
    /**
     * @stability stable
     */
    get homeEfsFileSystem(): string;
    /**
     * @stability stable
     */
    set homeEfsFileSystem(value: string);
    /**
     * @stability stable
     */
    resetHomeEfsFileSystem(): void;
    /**
     * @stability stable
     */
    get homeEfsFileSystemInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain aws_sagemaker_domain}.
 *
 * @stability stable
 */
export declare class SagemakerDomain extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_domain aws_sagemaker_domain} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerDomainConfig);
    private _appNetworkAccessType?;
    /**
     * @stability stable
     */
    get appNetworkAccessType(): string;
    /**
     * @stability stable
     */
    set appNetworkAccessType(value: string);
    /**
     * @stability stable
     */
    resetAppNetworkAccessType(): void;
    /**
     * @stability stable
     */
    get appNetworkAccessTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _authMode?;
    /**
     * @stability stable
     */
    get authMode(): string;
    /**
     * @stability stable
     */
    set authMode(value: string);
    /**
     * @stability stable
     */
    get authModeInput(): string | undefined;
    private _domainName?;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    get domainNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get homeEfsFileSystemId(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get singleSignOnManagedApplicationInstanceId(): string;
    private _subnetIds?;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get url(): string;
    private _vpcId?;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    get vpcIdInput(): string | undefined;
    private _defaultUserSettings;
    /**
     * @stability stable
     */
    get defaultUserSettings(): SagemakerDomainDefaultUserSettingsOutputReference;
    /**
     * @stability stable
     */
    putDefaultUserSettings(value: SagemakerDomainDefaultUserSettings): void;
    /**
     * @stability stable
     */
    get defaultUserSettingsInput(): SagemakerDomainDefaultUserSettings | undefined;
    private _retentionPolicy;
    /**
     * @stability stable
     */
    get retentionPolicy(): SagemakerDomainRetentionPolicyOutputReference;
    /**
     * @stability stable
     */
    putRetentionPolicy(value: SagemakerDomainRetentionPolicy): void;
    /**
     * @stability stable
     */
    resetRetentionPolicy(): void;
    /**
     * @stability stable
     */
    get retentionPolicyInput(): SagemakerDomainRetentionPolicy | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
