import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS SageMaker.
 *
 * @stability stable
 */
export interface SagemakerFlowDefinitionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#flow_definition_name SagemakerFlowDefinition#flow_definition_name}.
     *
     * @stability stable
     */
    readonly flowDefinitionName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#role_arn SagemakerFlowDefinition#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#tags SagemakerFlowDefinition#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#tags_all SagemakerFlowDefinition#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * human_loop_activation_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#human_loop_activation_config SagemakerFlowDefinition#human_loop_activation_config}
     *
     * @stability stable
     */
    readonly humanLoopActivationConfig?: SagemakerFlowDefinitionHumanLoopActivationConfig;
    /**
     * human_loop_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#human_loop_config SagemakerFlowDefinition#human_loop_config}
     *
     * @stability stable
     */
    readonly humanLoopConfig: SagemakerFlowDefinitionHumanLoopConfig;
    /**
     * human_loop_request_source block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#human_loop_request_source SagemakerFlowDefinition#human_loop_request_source}
     *
     * @stability stable
     */
    readonly humanLoopRequestSource?: SagemakerFlowDefinitionHumanLoopRequestSource;
    /**
     * output_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#output_config SagemakerFlowDefinition#output_config}
     *
     * @stability stable
     */
    readonly outputConfig: SagemakerFlowDefinitionOutputConfig;
}
/**
 * @stability stable
 */
export interface SagemakerFlowDefinitionHumanLoopActivationConfigHumanLoopActivationConditionsConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#human_loop_activation_conditions SagemakerFlowDefinition#human_loop_activation_conditions}.
     *
     * @stability stable
     */
    readonly humanLoopActivationConditions: string;
}
export declare function sagemakerFlowDefinitionHumanLoopActivationConfigHumanLoopActivationConditionsConfigToTerraform(struct?: SagemakerFlowDefinitionHumanLoopActivationConfigHumanLoopActivationConditionsConfigOutputReference | SagemakerFlowDefinitionHumanLoopActivationConfigHumanLoopActivationConditionsConfig): any;
/**
 * @stability stable
 */
export declare class SagemakerFlowDefinitionHumanLoopActivationConfigHumanLoopActivationConditionsConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerFlowDefinitionHumanLoopActivationConfigHumanLoopActivationConditionsConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerFlowDefinitionHumanLoopActivationConfigHumanLoopActivationConditionsConfig | undefined);
    private _humanLoopActivationConditions?;
    /**
     * @stability stable
     */
    get humanLoopActivationConditions(): string;
    /**
     * @stability stable
     */
    set humanLoopActivationConditions(value: string);
    /**
     * @stability stable
     */
    get humanLoopActivationConditionsInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerFlowDefinitionHumanLoopActivationConfig {
    /**
     * human_loop_activation_conditions_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#human_loop_activation_conditions_config SagemakerFlowDefinition#human_loop_activation_conditions_config}
     *
     * @stability stable
     */
    readonly humanLoopActivationConditionsConfig?: SagemakerFlowDefinitionHumanLoopActivationConfigHumanLoopActivationConditionsConfig;
}
export declare function sagemakerFlowDefinitionHumanLoopActivationConfigToTerraform(struct?: SagemakerFlowDefinitionHumanLoopActivationConfigOutputReference | SagemakerFlowDefinitionHumanLoopActivationConfig): any;
/**
 * @stability stable
 */
export declare class SagemakerFlowDefinitionHumanLoopActivationConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerFlowDefinitionHumanLoopActivationConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerFlowDefinitionHumanLoopActivationConfig | undefined);
    private _humanLoopActivationConditionsConfig;
    /**
     * @stability stable
     */
    get humanLoopActivationConditionsConfig(): SagemakerFlowDefinitionHumanLoopActivationConfigHumanLoopActivationConditionsConfigOutputReference;
    /**
     * @stability stable
     */
    putHumanLoopActivationConditionsConfig(value: SagemakerFlowDefinitionHumanLoopActivationConfigHumanLoopActivationConditionsConfig): void;
    /**
     * @stability stable
     */
    resetHumanLoopActivationConditionsConfig(): void;
    /**
     * @stability stable
     */
    get humanLoopActivationConditionsConfigInput(): SagemakerFlowDefinitionHumanLoopActivationConfigHumanLoopActivationConditionsConfig | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPriceAmountInUsd {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#cents SagemakerFlowDefinition#cents}.
     *
     * @stability stable
     */
    readonly cents?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#dollars SagemakerFlowDefinition#dollars}.
     *
     * @stability stable
     */
    readonly dollars?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#tenth_fractions_of_a_cent SagemakerFlowDefinition#tenth_fractions_of_a_cent}.
     *
     * @stability stable
     */
    readonly tenthFractionsOfACent?: number;
}
export declare function sagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPriceAmountInUsdToTerraform(struct?: SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPriceAmountInUsdOutputReference | SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPriceAmountInUsd): any;
/**
 * @stability stable
 */
export declare class SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPriceAmountInUsdOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPriceAmountInUsd | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPriceAmountInUsd | undefined);
    private _cents?;
    /**
     * @stability stable
     */
    get cents(): number;
    /**
     * @stability stable
     */
    set cents(value: number);
    /**
     * @stability stable
     */
    resetCents(): void;
    /**
     * @stability stable
     */
    get centsInput(): number | undefined;
    private _dollars?;
    /**
     * @stability stable
     */
    get dollars(): number;
    /**
     * @stability stable
     */
    set dollars(value: number);
    /**
     * @stability stable
     */
    resetDollars(): void;
    /**
     * @stability stable
     */
    get dollarsInput(): number | undefined;
    private _tenthFractionsOfACent?;
    /**
     * @stability stable
     */
    get tenthFractionsOfACent(): number;
    /**
     * @stability stable
     */
    set tenthFractionsOfACent(value: number);
    /**
     * @stability stable
     */
    resetTenthFractionsOfACent(): void;
    /**
     * @stability stable
     */
    get tenthFractionsOfACentInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPrice {
    /**
     * amount_in_usd block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#amount_in_usd SagemakerFlowDefinition#amount_in_usd}
     *
     * @stability stable
     */
    readonly amountInUsd?: SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPriceAmountInUsd;
}
export declare function sagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPriceToTerraform(struct?: SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPriceOutputReference | SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPrice): any;
/**
 * @stability stable
 */
export declare class SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPriceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPrice | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPrice | undefined);
    private _amountInUsd;
    /**
     * @stability stable
     */
    get amountInUsd(): SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPriceAmountInUsdOutputReference;
    /**
     * @stability stable
     */
    putAmountInUsd(value: SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPriceAmountInUsd): void;
    /**
     * @stability stable
     */
    resetAmountInUsd(): void;
    /**
     * @stability stable
     */
    get amountInUsdInput(): SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPriceAmountInUsd | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerFlowDefinitionHumanLoopConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#human_task_ui_arn SagemakerFlowDefinition#human_task_ui_arn}.
     *
     * @stability stable
     */
    readonly humanTaskUiArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#task_availability_lifetime_in_seconds SagemakerFlowDefinition#task_availability_lifetime_in_seconds}.
     *
     * @stability stable
     */
    readonly taskAvailabilityLifetimeInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#task_count SagemakerFlowDefinition#task_count}.
     *
     * @stability stable
     */
    readonly taskCount: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#task_description SagemakerFlowDefinition#task_description}.
     *
     * @stability stable
     */
    readonly taskDescription: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#task_keywords SagemakerFlowDefinition#task_keywords}.
     *
     * @stability stable
     */
    readonly taskKeywords?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#task_time_limit_in_seconds SagemakerFlowDefinition#task_time_limit_in_seconds}.
     *
     * @stability stable
     */
    readonly taskTimeLimitInSeconds?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#task_title SagemakerFlowDefinition#task_title}.
     *
     * @stability stable
     */
    readonly taskTitle: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#workteam_arn SagemakerFlowDefinition#workteam_arn}.
     *
     * @stability stable
     */
    readonly workteamArn: string;
    /**
     * public_workforce_task_price block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#public_workforce_task_price SagemakerFlowDefinition#public_workforce_task_price}
     *
     * @stability stable
     */
    readonly publicWorkforceTaskPrice?: SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPrice;
}
export declare function sagemakerFlowDefinitionHumanLoopConfigToTerraform(struct?: SagemakerFlowDefinitionHumanLoopConfigOutputReference | SagemakerFlowDefinitionHumanLoopConfig): any;
/**
 * @stability stable
 */
export declare class SagemakerFlowDefinitionHumanLoopConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerFlowDefinitionHumanLoopConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerFlowDefinitionHumanLoopConfig | undefined);
    private _humanTaskUiArn?;
    /**
     * @stability stable
     */
    get humanTaskUiArn(): string;
    /**
     * @stability stable
     */
    set humanTaskUiArn(value: string);
    /**
     * @stability stable
     */
    get humanTaskUiArnInput(): string | undefined;
    private _taskAvailabilityLifetimeInSeconds?;
    /**
     * @stability stable
     */
    get taskAvailabilityLifetimeInSeconds(): number;
    /**
     * @stability stable
     */
    set taskAvailabilityLifetimeInSeconds(value: number);
    /**
     * @stability stable
     */
    resetTaskAvailabilityLifetimeInSeconds(): void;
    /**
     * @stability stable
     */
    get taskAvailabilityLifetimeInSecondsInput(): number | undefined;
    private _taskCount?;
    /**
     * @stability stable
     */
    get taskCount(): number;
    /**
     * @stability stable
     */
    set taskCount(value: number);
    /**
     * @stability stable
     */
    get taskCountInput(): number | undefined;
    private _taskDescription?;
    /**
     * @stability stable
     */
    get taskDescription(): string;
    /**
     * @stability stable
     */
    set taskDescription(value: string);
    /**
     * @stability stable
     */
    get taskDescriptionInput(): string | undefined;
    private _taskKeywords?;
    /**
     * @stability stable
     */
    get taskKeywords(): string[];
    /**
     * @stability stable
     */
    set taskKeywords(value: string[]);
    /**
     * @stability stable
     */
    resetTaskKeywords(): void;
    /**
     * @stability stable
     */
    get taskKeywordsInput(): string[] | undefined;
    private _taskTimeLimitInSeconds?;
    /**
     * @stability stable
     */
    get taskTimeLimitInSeconds(): number;
    /**
     * @stability stable
     */
    set taskTimeLimitInSeconds(value: number);
    /**
     * @stability stable
     */
    resetTaskTimeLimitInSeconds(): void;
    /**
     * @stability stable
     */
    get taskTimeLimitInSecondsInput(): number | undefined;
    private _taskTitle?;
    /**
     * @stability stable
     */
    get taskTitle(): string;
    /**
     * @stability stable
     */
    set taskTitle(value: string);
    /**
     * @stability stable
     */
    get taskTitleInput(): string | undefined;
    private _workteamArn?;
    /**
     * @stability stable
     */
    get workteamArn(): string;
    /**
     * @stability stable
     */
    set workteamArn(value: string);
    /**
     * @stability stable
     */
    get workteamArnInput(): string | undefined;
    private _publicWorkforceTaskPrice;
    /**
     * @stability stable
     */
    get publicWorkforceTaskPrice(): SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPriceOutputReference;
    /**
     * @stability stable
     */
    putPublicWorkforceTaskPrice(value: SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPrice): void;
    /**
     * @stability stable
     */
    resetPublicWorkforceTaskPrice(): void;
    /**
     * @stability stable
     */
    get publicWorkforceTaskPriceInput(): SagemakerFlowDefinitionHumanLoopConfigPublicWorkforceTaskPrice | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerFlowDefinitionHumanLoopRequestSource {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#aws_managed_human_loop_request_source SagemakerFlowDefinition#aws_managed_human_loop_request_source}.
     *
     * @stability stable
     */
    readonly awsManagedHumanLoopRequestSource: string;
}
export declare function sagemakerFlowDefinitionHumanLoopRequestSourceToTerraform(struct?: SagemakerFlowDefinitionHumanLoopRequestSourceOutputReference | SagemakerFlowDefinitionHumanLoopRequestSource): any;
/**
 * @stability stable
 */
export declare class SagemakerFlowDefinitionHumanLoopRequestSourceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerFlowDefinitionHumanLoopRequestSource | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerFlowDefinitionHumanLoopRequestSource | undefined);
    private _awsManagedHumanLoopRequestSource?;
    /**
     * @stability stable
     */
    get awsManagedHumanLoopRequestSource(): string;
    /**
     * @stability stable
     */
    set awsManagedHumanLoopRequestSource(value: string);
    /**
     * @stability stable
     */
    get awsManagedHumanLoopRequestSourceInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface SagemakerFlowDefinitionOutputConfig {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#kms_key_id SagemakerFlowDefinition#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition#s3_output_path SagemakerFlowDefinition#s3_output_path}.
     *
     * @stability stable
     */
    readonly s3OutputPath: string;
}
export declare function sagemakerFlowDefinitionOutputConfigToTerraform(struct?: SagemakerFlowDefinitionOutputConfigOutputReference | SagemakerFlowDefinitionOutputConfig): any;
/**
 * @stability stable
 */
export declare class SagemakerFlowDefinitionOutputConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SagemakerFlowDefinitionOutputConfig | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SagemakerFlowDefinitionOutputConfig | undefined);
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    private _s3OutputPath?;
    /**
     * @stability stable
     */
    get s3OutputPath(): string;
    /**
     * @stability stable
     */
    set s3OutputPath(value: string);
    /**
     * @stability stable
     */
    get s3OutputPathInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition aws_sagemaker_flow_definition}.
 *
 * @stability stable
 */
export declare class SagemakerFlowDefinition extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_flow_definition aws_sagemaker_flow_definition} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerFlowDefinitionConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _flowDefinitionName?;
    /**
     * @stability stable
     */
    get flowDefinitionName(): string;
    /**
     * @stability stable
     */
    set flowDefinitionName(value: string);
    /**
     * @stability stable
     */
    get flowDefinitionNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _humanLoopActivationConfig;
    /**
     * @stability stable
     */
    get humanLoopActivationConfig(): SagemakerFlowDefinitionHumanLoopActivationConfigOutputReference;
    /**
     * @stability stable
     */
    putHumanLoopActivationConfig(value: SagemakerFlowDefinitionHumanLoopActivationConfig): void;
    /**
     * @stability stable
     */
    resetHumanLoopActivationConfig(): void;
    /**
     * @stability stable
     */
    get humanLoopActivationConfigInput(): SagemakerFlowDefinitionHumanLoopActivationConfig | undefined;
    private _humanLoopConfig;
    /**
     * @stability stable
     */
    get humanLoopConfig(): SagemakerFlowDefinitionHumanLoopConfigOutputReference;
    /**
     * @stability stable
     */
    putHumanLoopConfig(value: SagemakerFlowDefinitionHumanLoopConfig): void;
    /**
     * @stability stable
     */
    get humanLoopConfigInput(): SagemakerFlowDefinitionHumanLoopConfig | undefined;
    private _humanLoopRequestSource;
    /**
     * @stability stable
     */
    get humanLoopRequestSource(): SagemakerFlowDefinitionHumanLoopRequestSourceOutputReference;
    /**
     * @stability stable
     */
    putHumanLoopRequestSource(value: SagemakerFlowDefinitionHumanLoopRequestSource): void;
    /**
     * @stability stable
     */
    resetHumanLoopRequestSource(): void;
    /**
     * @stability stable
     */
    get humanLoopRequestSourceInput(): SagemakerFlowDefinitionHumanLoopRequestSource | undefined;
    private _outputConfig;
    /**
     * @stability stable
     */
    get outputConfig(): SagemakerFlowDefinitionOutputConfigOutputReference;
    /**
     * @stability stable
     */
    putOutputConfig(value: SagemakerFlowDefinitionOutputConfig): void;
    /**
     * @stability stable
     */
    get outputConfigInput(): SagemakerFlowDefinitionOutputConfig | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
