import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS SageMaker.
 *
 * @stability stable
 */
export interface SagemakerModelPackageGroupPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_model_package_group_policy#model_package_group_name SagemakerModelPackageGroupPolicy#model_package_group_name}.
     *
     * @stability stable
     */
    readonly modelPackageGroupName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_model_package_group_policy#resource_policy SagemakerModelPackageGroupPolicy#resource_policy}.
     *
     * @stability stable
     */
    readonly resourcePolicy: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_model_package_group_policy aws_sagemaker_model_package_group_policy}.
 *
 * @stability stable
 */
export declare class SagemakerModelPackageGroupPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sagemaker_model_package_group_policy aws_sagemaker_model_package_group_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerModelPackageGroupPolicyConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _modelPackageGroupName?;
    /**
     * @stability stable
     */
    get modelPackageGroupName(): string;
    /**
     * @stability stable
     */
    set modelPackageGroupName(value: string);
    /**
     * @stability stable
     */
    get modelPackageGroupNameInput(): string | undefined;
    private _resourcePolicy?;
    /**
     * @stability stable
     */
    get resourcePolicy(): string;
    /**
     * @stability stable
     */
    set resourcePolicy(value: string);
    /**
     * @stability stable
     */
    get resourcePolicyInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
