import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Security Hub.
 *
 * @stability stable
 */
export interface SecurityhubFindingAggregatorConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_finding_aggregator#linking_mode SecurityhubFindingAggregator#linking_mode}.
     *
     * @stability stable
     */
    readonly linkingMode: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_finding_aggregator#specified_regions SecurityhubFindingAggregator#specified_regions}.
     *
     * @stability stable
     */
    readonly specifiedRegions?: string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/securityhub_finding_aggregator aws_securityhub_finding_aggregator}.
 *
 * @stability stable
 */
export declare class SecurityhubFindingAggregator extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/securityhub_finding_aggregator aws_securityhub_finding_aggregator} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SecurityhubFindingAggregatorConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _linkingMode?;
    /**
     * @stability stable
     */
    get linkingMode(): string;
    /**
     * @stability stable
     */
    set linkingMode(value: string);
    /**
     * @stability stable
     */
    get linkingModeInput(): string | undefined;
    private _specifiedRegions?;
    /**
     * @stability stable
     */
    get specifiedRegions(): string[];
    /**
     * @stability stable
     */
    set specifiedRegions(value: string[]);
    /**
     * @stability stable
     */
    resetSpecifiedRegions(): void;
    /**
     * @stability stable
     */
    get specifiedRegionsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
