import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Security Hub.
 *
 * @stability stable
 */
export interface SecurityhubInsightConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#group_by_attribute SecurityhubInsight#group_by_attribute}.
     *
     * @stability stable
     */
    readonly groupByAttribute: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#name SecurityhubInsight#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * filters block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#filters SecurityhubInsight#filters}
     *
     * @stability stable
     */
    readonly filters: SecurityhubInsightFilters;
}
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersAwsAccountId {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersAwsAccountIdToTerraform(struct?: SecurityhubInsightFiltersAwsAccountId): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersCompanyName {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersCompanyNameToTerraform(struct?: SecurityhubInsightFiltersCompanyName): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersComplianceStatus {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersComplianceStatusToTerraform(struct?: SecurityhubInsightFiltersComplianceStatus): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersConfidence {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#eq SecurityhubInsight#eq}.
     *
     * @stability stable
     */
    readonly eq?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#gte SecurityhubInsight#gte}.
     *
     * @stability stable
     */
    readonly gte?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#lte SecurityhubInsight#lte}.
     *
     * @stability stable
     */
    readonly lte?: string;
}
export declare function securityhubInsightFiltersConfidenceToTerraform(struct?: SecurityhubInsightFiltersConfidence): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersCreatedAtDateRange {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#unit SecurityhubInsight#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function securityhubInsightFiltersCreatedAtDateRangeToTerraform(struct?: SecurityhubInsightFiltersCreatedAtDateRangeOutputReference | SecurityhubInsightFiltersCreatedAtDateRange): any;
/**
 * @stability stable
 */
export declare class SecurityhubInsightFiltersCreatedAtDateRangeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SecurityhubInsightFiltersCreatedAtDateRange | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SecurityhubInsightFiltersCreatedAtDateRange | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersCreatedAt {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#end SecurityhubInsight#end}.
     *
     * @stability stable
     */
    readonly end?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#start SecurityhubInsight#start}.
     *
     * @stability stable
     */
    readonly start?: string;
    /**
     * date_range block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#date_range SecurityhubInsight#date_range}
     *
     * @stability stable
     */
    readonly dateRange?: SecurityhubInsightFiltersCreatedAtDateRange;
}
export declare function securityhubInsightFiltersCreatedAtToTerraform(struct?: SecurityhubInsightFiltersCreatedAt): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersCriticality {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#eq SecurityhubInsight#eq}.
     *
     * @stability stable
     */
    readonly eq?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#gte SecurityhubInsight#gte}.
     *
     * @stability stable
     */
    readonly gte?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#lte SecurityhubInsight#lte}.
     *
     * @stability stable
     */
    readonly lte?: string;
}
export declare function securityhubInsightFiltersCriticalityToTerraform(struct?: SecurityhubInsightFiltersCriticality): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersDescription {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersDescriptionToTerraform(struct?: SecurityhubInsightFiltersDescription): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersFindingProviderFieldsConfidence {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#eq SecurityhubInsight#eq}.
     *
     * @stability stable
     */
    readonly eq?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#gte SecurityhubInsight#gte}.
     *
     * @stability stable
     */
    readonly gte?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#lte SecurityhubInsight#lte}.
     *
     * @stability stable
     */
    readonly lte?: string;
}
export declare function securityhubInsightFiltersFindingProviderFieldsConfidenceToTerraform(struct?: SecurityhubInsightFiltersFindingProviderFieldsConfidence): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersFindingProviderFieldsCriticality {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#eq SecurityhubInsight#eq}.
     *
     * @stability stable
     */
    readonly eq?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#gte SecurityhubInsight#gte}.
     *
     * @stability stable
     */
    readonly gte?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#lte SecurityhubInsight#lte}.
     *
     * @stability stable
     */
    readonly lte?: string;
}
export declare function securityhubInsightFiltersFindingProviderFieldsCriticalityToTerraform(struct?: SecurityhubInsightFiltersFindingProviderFieldsCriticality): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersFindingProviderFieldsRelatedFindingsId {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersFindingProviderFieldsRelatedFindingsIdToTerraform(struct?: SecurityhubInsightFiltersFindingProviderFieldsRelatedFindingsId): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersFindingProviderFieldsRelatedFindingsProductArn {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersFindingProviderFieldsRelatedFindingsProductArnToTerraform(struct?: SecurityhubInsightFiltersFindingProviderFieldsRelatedFindingsProductArn): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersFindingProviderFieldsSeverityLabel {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersFindingProviderFieldsSeverityLabelToTerraform(struct?: SecurityhubInsightFiltersFindingProviderFieldsSeverityLabel): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersFindingProviderFieldsSeverityOriginal {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersFindingProviderFieldsSeverityOriginalToTerraform(struct?: SecurityhubInsightFiltersFindingProviderFieldsSeverityOriginal): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersFindingProviderFieldsTypes {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersFindingProviderFieldsTypesToTerraform(struct?: SecurityhubInsightFiltersFindingProviderFieldsTypes): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersFirstObservedAtDateRange {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#unit SecurityhubInsight#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function securityhubInsightFiltersFirstObservedAtDateRangeToTerraform(struct?: SecurityhubInsightFiltersFirstObservedAtDateRangeOutputReference | SecurityhubInsightFiltersFirstObservedAtDateRange): any;
/**
 * @stability stable
 */
export declare class SecurityhubInsightFiltersFirstObservedAtDateRangeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SecurityhubInsightFiltersFirstObservedAtDateRange | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SecurityhubInsightFiltersFirstObservedAtDateRange | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersFirstObservedAt {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#end SecurityhubInsight#end}.
     *
     * @stability stable
     */
    readonly end?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#start SecurityhubInsight#start}.
     *
     * @stability stable
     */
    readonly start?: string;
    /**
     * date_range block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#date_range SecurityhubInsight#date_range}
     *
     * @stability stable
     */
    readonly dateRange?: SecurityhubInsightFiltersFirstObservedAtDateRange;
}
export declare function securityhubInsightFiltersFirstObservedAtToTerraform(struct?: SecurityhubInsightFiltersFirstObservedAt): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersGeneratorId {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersGeneratorIdToTerraform(struct?: SecurityhubInsightFiltersGeneratorId): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersId {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersIdToTerraform(struct?: SecurityhubInsightFiltersId): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersKeyword {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersKeywordToTerraform(struct?: SecurityhubInsightFiltersKeyword): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersLastObservedAtDateRange {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#unit SecurityhubInsight#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function securityhubInsightFiltersLastObservedAtDateRangeToTerraform(struct?: SecurityhubInsightFiltersLastObservedAtDateRangeOutputReference | SecurityhubInsightFiltersLastObservedAtDateRange): any;
/**
 * @stability stable
 */
export declare class SecurityhubInsightFiltersLastObservedAtDateRangeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SecurityhubInsightFiltersLastObservedAtDateRange | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SecurityhubInsightFiltersLastObservedAtDateRange | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersLastObservedAt {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#end SecurityhubInsight#end}.
     *
     * @stability stable
     */
    readonly end?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#start SecurityhubInsight#start}.
     *
     * @stability stable
     */
    readonly start?: string;
    /**
     * date_range block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#date_range SecurityhubInsight#date_range}
     *
     * @stability stable
     */
    readonly dateRange?: SecurityhubInsightFiltersLastObservedAtDateRange;
}
export declare function securityhubInsightFiltersLastObservedAtToTerraform(struct?: SecurityhubInsightFiltersLastObservedAt): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersMalwareName {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersMalwareNameToTerraform(struct?: SecurityhubInsightFiltersMalwareName): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersMalwarePath {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersMalwarePathToTerraform(struct?: SecurityhubInsightFiltersMalwarePath): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersMalwareState {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersMalwareStateToTerraform(struct?: SecurityhubInsightFiltersMalwareState): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersMalwareType {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersMalwareTypeToTerraform(struct?: SecurityhubInsightFiltersMalwareType): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersNetworkDestinationDomain {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersNetworkDestinationDomainToTerraform(struct?: SecurityhubInsightFiltersNetworkDestinationDomain): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersNetworkDestinationIpv4 {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#cidr SecurityhubInsight#cidr}.
     *
     * @stability stable
     */
    readonly cidr: string;
}
export declare function securityhubInsightFiltersNetworkDestinationIpv4ToTerraform(struct?: SecurityhubInsightFiltersNetworkDestinationIpv4): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersNetworkDestinationIpv6 {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#cidr SecurityhubInsight#cidr}.
     *
     * @stability stable
     */
    readonly cidr: string;
}
export declare function securityhubInsightFiltersNetworkDestinationIpv6ToTerraform(struct?: SecurityhubInsightFiltersNetworkDestinationIpv6): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersNetworkDestinationPort {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#eq SecurityhubInsight#eq}.
     *
     * @stability stable
     */
    readonly eq?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#gte SecurityhubInsight#gte}.
     *
     * @stability stable
     */
    readonly gte?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#lte SecurityhubInsight#lte}.
     *
     * @stability stable
     */
    readonly lte?: string;
}
export declare function securityhubInsightFiltersNetworkDestinationPortToTerraform(struct?: SecurityhubInsightFiltersNetworkDestinationPort): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersNetworkDirection {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersNetworkDirectionToTerraform(struct?: SecurityhubInsightFiltersNetworkDirection): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersNetworkProtocol {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersNetworkProtocolToTerraform(struct?: SecurityhubInsightFiltersNetworkProtocol): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersNetworkSourceDomain {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersNetworkSourceDomainToTerraform(struct?: SecurityhubInsightFiltersNetworkSourceDomain): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersNetworkSourceIpv4 {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#cidr SecurityhubInsight#cidr}.
     *
     * @stability stable
     */
    readonly cidr: string;
}
export declare function securityhubInsightFiltersNetworkSourceIpv4ToTerraform(struct?: SecurityhubInsightFiltersNetworkSourceIpv4): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersNetworkSourceIpv6 {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#cidr SecurityhubInsight#cidr}.
     *
     * @stability stable
     */
    readonly cidr: string;
}
export declare function securityhubInsightFiltersNetworkSourceIpv6ToTerraform(struct?: SecurityhubInsightFiltersNetworkSourceIpv6): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersNetworkSourceMac {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersNetworkSourceMacToTerraform(struct?: SecurityhubInsightFiltersNetworkSourceMac): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersNetworkSourcePort {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#eq SecurityhubInsight#eq}.
     *
     * @stability stable
     */
    readonly eq?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#gte SecurityhubInsight#gte}.
     *
     * @stability stable
     */
    readonly gte?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#lte SecurityhubInsight#lte}.
     *
     * @stability stable
     */
    readonly lte?: string;
}
export declare function securityhubInsightFiltersNetworkSourcePortToTerraform(struct?: SecurityhubInsightFiltersNetworkSourcePort): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersNoteText {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersNoteTextToTerraform(struct?: SecurityhubInsightFiltersNoteText): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersNoteUpdatedAtDateRange {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#unit SecurityhubInsight#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function securityhubInsightFiltersNoteUpdatedAtDateRangeToTerraform(struct?: SecurityhubInsightFiltersNoteUpdatedAtDateRangeOutputReference | SecurityhubInsightFiltersNoteUpdatedAtDateRange): any;
/**
 * @stability stable
 */
export declare class SecurityhubInsightFiltersNoteUpdatedAtDateRangeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SecurityhubInsightFiltersNoteUpdatedAtDateRange | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SecurityhubInsightFiltersNoteUpdatedAtDateRange | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersNoteUpdatedAt {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#end SecurityhubInsight#end}.
     *
     * @stability stable
     */
    readonly end?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#start SecurityhubInsight#start}.
     *
     * @stability stable
     */
    readonly start?: string;
    /**
     * date_range block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#date_range SecurityhubInsight#date_range}
     *
     * @stability stable
     */
    readonly dateRange?: SecurityhubInsightFiltersNoteUpdatedAtDateRange;
}
export declare function securityhubInsightFiltersNoteUpdatedAtToTerraform(struct?: SecurityhubInsightFiltersNoteUpdatedAt): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersNoteUpdatedBy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersNoteUpdatedByToTerraform(struct?: SecurityhubInsightFiltersNoteUpdatedBy): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersProcessLaunchedAtDateRange {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#unit SecurityhubInsight#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function securityhubInsightFiltersProcessLaunchedAtDateRangeToTerraform(struct?: SecurityhubInsightFiltersProcessLaunchedAtDateRangeOutputReference | SecurityhubInsightFiltersProcessLaunchedAtDateRange): any;
/**
 * @stability stable
 */
export declare class SecurityhubInsightFiltersProcessLaunchedAtDateRangeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SecurityhubInsightFiltersProcessLaunchedAtDateRange | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SecurityhubInsightFiltersProcessLaunchedAtDateRange | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersProcessLaunchedAt {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#end SecurityhubInsight#end}.
     *
     * @stability stable
     */
    readonly end?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#start SecurityhubInsight#start}.
     *
     * @stability stable
     */
    readonly start?: string;
    /**
     * date_range block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#date_range SecurityhubInsight#date_range}
     *
     * @stability stable
     */
    readonly dateRange?: SecurityhubInsightFiltersProcessLaunchedAtDateRange;
}
export declare function securityhubInsightFiltersProcessLaunchedAtToTerraform(struct?: SecurityhubInsightFiltersProcessLaunchedAt): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersProcessName {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersProcessNameToTerraform(struct?: SecurityhubInsightFiltersProcessName): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersProcessParentPid {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#eq SecurityhubInsight#eq}.
     *
     * @stability stable
     */
    readonly eq?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#gte SecurityhubInsight#gte}.
     *
     * @stability stable
     */
    readonly gte?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#lte SecurityhubInsight#lte}.
     *
     * @stability stable
     */
    readonly lte?: string;
}
export declare function securityhubInsightFiltersProcessParentPidToTerraform(struct?: SecurityhubInsightFiltersProcessParentPid): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersProcessPath {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersProcessPathToTerraform(struct?: SecurityhubInsightFiltersProcessPath): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersProcessPid {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#eq SecurityhubInsight#eq}.
     *
     * @stability stable
     */
    readonly eq?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#gte SecurityhubInsight#gte}.
     *
     * @stability stable
     */
    readonly gte?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#lte SecurityhubInsight#lte}.
     *
     * @stability stable
     */
    readonly lte?: string;
}
export declare function securityhubInsightFiltersProcessPidToTerraform(struct?: SecurityhubInsightFiltersProcessPid): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersProcessTerminatedAtDateRange {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#unit SecurityhubInsight#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function securityhubInsightFiltersProcessTerminatedAtDateRangeToTerraform(struct?: SecurityhubInsightFiltersProcessTerminatedAtDateRangeOutputReference | SecurityhubInsightFiltersProcessTerminatedAtDateRange): any;
/**
 * @stability stable
 */
export declare class SecurityhubInsightFiltersProcessTerminatedAtDateRangeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SecurityhubInsightFiltersProcessTerminatedAtDateRange | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SecurityhubInsightFiltersProcessTerminatedAtDateRange | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersProcessTerminatedAt {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#end SecurityhubInsight#end}.
     *
     * @stability stable
     */
    readonly end?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#start SecurityhubInsight#start}.
     *
     * @stability stable
     */
    readonly start?: string;
    /**
     * date_range block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#date_range SecurityhubInsight#date_range}
     *
     * @stability stable
     */
    readonly dateRange?: SecurityhubInsightFiltersProcessTerminatedAtDateRange;
}
export declare function securityhubInsightFiltersProcessTerminatedAtToTerraform(struct?: SecurityhubInsightFiltersProcessTerminatedAt): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersProductArn {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersProductArnToTerraform(struct?: SecurityhubInsightFiltersProductArn): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersProductFields {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#key SecurityhubInsight#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersProductFieldsToTerraform(struct?: SecurityhubInsightFiltersProductFields): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersProductName {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersProductNameToTerraform(struct?: SecurityhubInsightFiltersProductName): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersRecommendationText {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersRecommendationTextToTerraform(struct?: SecurityhubInsightFiltersRecommendationText): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersRecordState {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersRecordStateToTerraform(struct?: SecurityhubInsightFiltersRecordState): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersRelatedFindingsId {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersRelatedFindingsIdToTerraform(struct?: SecurityhubInsightFiltersRelatedFindingsId): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersRelatedFindingsProductArn {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersRelatedFindingsProductArnToTerraform(struct?: SecurityhubInsightFiltersRelatedFindingsProductArn): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceAwsEc2InstanceIamInstanceProfileArn {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersResourceAwsEc2InstanceIamInstanceProfileArnToTerraform(struct?: SecurityhubInsightFiltersResourceAwsEc2InstanceIamInstanceProfileArn): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceAwsEc2InstanceImageId {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersResourceAwsEc2InstanceImageIdToTerraform(struct?: SecurityhubInsightFiltersResourceAwsEc2InstanceImageId): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceAwsEc2InstanceIpv4Addresses {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#cidr SecurityhubInsight#cidr}.
     *
     * @stability stable
     */
    readonly cidr: string;
}
export declare function securityhubInsightFiltersResourceAwsEc2InstanceIpv4AddressesToTerraform(struct?: SecurityhubInsightFiltersResourceAwsEc2InstanceIpv4Addresses): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceAwsEc2InstanceIpv6Addresses {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#cidr SecurityhubInsight#cidr}.
     *
     * @stability stable
     */
    readonly cidr: string;
}
export declare function securityhubInsightFiltersResourceAwsEc2InstanceIpv6AddressesToTerraform(struct?: SecurityhubInsightFiltersResourceAwsEc2InstanceIpv6Addresses): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceAwsEc2InstanceKeyName {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersResourceAwsEc2InstanceKeyNameToTerraform(struct?: SecurityhubInsightFiltersResourceAwsEc2InstanceKeyName): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceAwsEc2InstanceLaunchedAtDateRange {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#unit SecurityhubInsight#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function securityhubInsightFiltersResourceAwsEc2InstanceLaunchedAtDateRangeToTerraform(struct?: SecurityhubInsightFiltersResourceAwsEc2InstanceLaunchedAtDateRangeOutputReference | SecurityhubInsightFiltersResourceAwsEc2InstanceLaunchedAtDateRange): any;
/**
 * @stability stable
 */
export declare class SecurityhubInsightFiltersResourceAwsEc2InstanceLaunchedAtDateRangeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SecurityhubInsightFiltersResourceAwsEc2InstanceLaunchedAtDateRange | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SecurityhubInsightFiltersResourceAwsEc2InstanceLaunchedAtDateRange | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceAwsEc2InstanceLaunchedAt {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#end SecurityhubInsight#end}.
     *
     * @stability stable
     */
    readonly end?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#start SecurityhubInsight#start}.
     *
     * @stability stable
     */
    readonly start?: string;
    /**
     * date_range block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#date_range SecurityhubInsight#date_range}
     *
     * @stability stable
     */
    readonly dateRange?: SecurityhubInsightFiltersResourceAwsEc2InstanceLaunchedAtDateRange;
}
export declare function securityhubInsightFiltersResourceAwsEc2InstanceLaunchedAtToTerraform(struct?: SecurityhubInsightFiltersResourceAwsEc2InstanceLaunchedAt): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceAwsEc2InstanceSubnetId {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersResourceAwsEc2InstanceSubnetIdToTerraform(struct?: SecurityhubInsightFiltersResourceAwsEc2InstanceSubnetId): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceAwsEc2InstanceType {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersResourceAwsEc2InstanceTypeToTerraform(struct?: SecurityhubInsightFiltersResourceAwsEc2InstanceType): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceAwsEc2InstanceVpcId {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersResourceAwsEc2InstanceVpcIdToTerraform(struct?: SecurityhubInsightFiltersResourceAwsEc2InstanceVpcId): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceAwsIamAccessKeyCreatedAtDateRange {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#unit SecurityhubInsight#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function securityhubInsightFiltersResourceAwsIamAccessKeyCreatedAtDateRangeToTerraform(struct?: SecurityhubInsightFiltersResourceAwsIamAccessKeyCreatedAtDateRangeOutputReference | SecurityhubInsightFiltersResourceAwsIamAccessKeyCreatedAtDateRange): any;
/**
 * @stability stable
 */
export declare class SecurityhubInsightFiltersResourceAwsIamAccessKeyCreatedAtDateRangeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SecurityhubInsightFiltersResourceAwsIamAccessKeyCreatedAtDateRange | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SecurityhubInsightFiltersResourceAwsIamAccessKeyCreatedAtDateRange | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceAwsIamAccessKeyCreatedAt {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#end SecurityhubInsight#end}.
     *
     * @stability stable
     */
    readonly end?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#start SecurityhubInsight#start}.
     *
     * @stability stable
     */
    readonly start?: string;
    /**
     * date_range block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#date_range SecurityhubInsight#date_range}
     *
     * @stability stable
     */
    readonly dateRange?: SecurityhubInsightFiltersResourceAwsIamAccessKeyCreatedAtDateRange;
}
export declare function securityhubInsightFiltersResourceAwsIamAccessKeyCreatedAtToTerraform(struct?: SecurityhubInsightFiltersResourceAwsIamAccessKeyCreatedAt): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceAwsIamAccessKeyStatus {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersResourceAwsIamAccessKeyStatusToTerraform(struct?: SecurityhubInsightFiltersResourceAwsIamAccessKeyStatus): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceAwsIamAccessKeyUserName {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersResourceAwsIamAccessKeyUserNameToTerraform(struct?: SecurityhubInsightFiltersResourceAwsIamAccessKeyUserName): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceAwsS3BucketOwnerId {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersResourceAwsS3BucketOwnerIdToTerraform(struct?: SecurityhubInsightFiltersResourceAwsS3BucketOwnerId): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceAwsS3BucketOwnerName {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersResourceAwsS3BucketOwnerNameToTerraform(struct?: SecurityhubInsightFiltersResourceAwsS3BucketOwnerName): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceContainerImageId {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersResourceContainerImageIdToTerraform(struct?: SecurityhubInsightFiltersResourceContainerImageId): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceContainerImageName {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersResourceContainerImageNameToTerraform(struct?: SecurityhubInsightFiltersResourceContainerImageName): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceContainerLaunchedAtDateRange {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#unit SecurityhubInsight#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function securityhubInsightFiltersResourceContainerLaunchedAtDateRangeToTerraform(struct?: SecurityhubInsightFiltersResourceContainerLaunchedAtDateRangeOutputReference | SecurityhubInsightFiltersResourceContainerLaunchedAtDateRange): any;
/**
 * @stability stable
 */
export declare class SecurityhubInsightFiltersResourceContainerLaunchedAtDateRangeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SecurityhubInsightFiltersResourceContainerLaunchedAtDateRange | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SecurityhubInsightFiltersResourceContainerLaunchedAtDateRange | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceContainerLaunchedAt {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#end SecurityhubInsight#end}.
     *
     * @stability stable
     */
    readonly end?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#start SecurityhubInsight#start}.
     *
     * @stability stable
     */
    readonly start?: string;
    /**
     * date_range block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#date_range SecurityhubInsight#date_range}
     *
     * @stability stable
     */
    readonly dateRange?: SecurityhubInsightFiltersResourceContainerLaunchedAtDateRange;
}
export declare function securityhubInsightFiltersResourceContainerLaunchedAtToTerraform(struct?: SecurityhubInsightFiltersResourceContainerLaunchedAt): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceContainerName {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersResourceContainerNameToTerraform(struct?: SecurityhubInsightFiltersResourceContainerName): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceDetailsOther {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#key SecurityhubInsight#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersResourceDetailsOtherToTerraform(struct?: SecurityhubInsightFiltersResourceDetailsOther): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceId {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersResourceIdToTerraform(struct?: SecurityhubInsightFiltersResourceId): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourcePartition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersResourcePartitionToTerraform(struct?: SecurityhubInsightFiltersResourcePartition): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceRegion {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersResourceRegionToTerraform(struct?: SecurityhubInsightFiltersResourceRegion): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceTags {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#key SecurityhubInsight#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersResourceTagsToTerraform(struct?: SecurityhubInsightFiltersResourceTags): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersResourceType {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersResourceTypeToTerraform(struct?: SecurityhubInsightFiltersResourceType): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersSeverityLabel {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersSeverityLabelToTerraform(struct?: SecurityhubInsightFiltersSeverityLabel): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersSourceUrl {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersSourceUrlToTerraform(struct?: SecurityhubInsightFiltersSourceUrl): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersThreatIntelIndicatorCategory {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersThreatIntelIndicatorCategoryToTerraform(struct?: SecurityhubInsightFiltersThreatIntelIndicatorCategory): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersThreatIntelIndicatorLastObservedAtDateRange {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#unit SecurityhubInsight#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function securityhubInsightFiltersThreatIntelIndicatorLastObservedAtDateRangeToTerraform(struct?: SecurityhubInsightFiltersThreatIntelIndicatorLastObservedAtDateRangeOutputReference | SecurityhubInsightFiltersThreatIntelIndicatorLastObservedAtDateRange): any;
/**
 * @stability stable
 */
export declare class SecurityhubInsightFiltersThreatIntelIndicatorLastObservedAtDateRangeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SecurityhubInsightFiltersThreatIntelIndicatorLastObservedAtDateRange | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SecurityhubInsightFiltersThreatIntelIndicatorLastObservedAtDateRange | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersThreatIntelIndicatorLastObservedAt {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#end SecurityhubInsight#end}.
     *
     * @stability stable
     */
    readonly end?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#start SecurityhubInsight#start}.
     *
     * @stability stable
     */
    readonly start?: string;
    /**
     * date_range block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#date_range SecurityhubInsight#date_range}
     *
     * @stability stable
     */
    readonly dateRange?: SecurityhubInsightFiltersThreatIntelIndicatorLastObservedAtDateRange;
}
export declare function securityhubInsightFiltersThreatIntelIndicatorLastObservedAtToTerraform(struct?: SecurityhubInsightFiltersThreatIntelIndicatorLastObservedAt): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersThreatIntelIndicatorSource {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersThreatIntelIndicatorSourceToTerraform(struct?: SecurityhubInsightFiltersThreatIntelIndicatorSource): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersThreatIntelIndicatorSourceUrl {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersThreatIntelIndicatorSourceUrlToTerraform(struct?: SecurityhubInsightFiltersThreatIntelIndicatorSourceUrl): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersThreatIntelIndicatorType {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersThreatIntelIndicatorTypeToTerraform(struct?: SecurityhubInsightFiltersThreatIntelIndicatorType): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersThreatIntelIndicatorValue {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersThreatIntelIndicatorValueToTerraform(struct?: SecurityhubInsightFiltersThreatIntelIndicatorValue): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersTitle {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersTitleToTerraform(struct?: SecurityhubInsightFiltersTitle): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersType {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersTypeToTerraform(struct?: SecurityhubInsightFiltersType): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersUpdatedAtDateRange {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#unit SecurityhubInsight#unit}.
     *
     * @stability stable
     */
    readonly unit: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: number;
}
export declare function securityhubInsightFiltersUpdatedAtDateRangeToTerraform(struct?: SecurityhubInsightFiltersUpdatedAtDateRangeOutputReference | SecurityhubInsightFiltersUpdatedAtDateRange): any;
/**
 * @stability stable
 */
export declare class SecurityhubInsightFiltersUpdatedAtDateRangeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SecurityhubInsightFiltersUpdatedAtDateRange | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SecurityhubInsightFiltersUpdatedAtDateRange | undefined);
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _value?;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    set value(value: number);
    /**
     * @stability stable
     */
    get valueInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersUpdatedAt {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#end SecurityhubInsight#end}.
     *
     * @stability stable
     */
    readonly end?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#start SecurityhubInsight#start}.
     *
     * @stability stable
     */
    readonly start?: string;
    /**
     * date_range block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#date_range SecurityhubInsight#date_range}
     *
     * @stability stable
     */
    readonly dateRange?: SecurityhubInsightFiltersUpdatedAtDateRange;
}
export declare function securityhubInsightFiltersUpdatedAtToTerraform(struct?: SecurityhubInsightFiltersUpdatedAt): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersUserDefinedValues {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#key SecurityhubInsight#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersUserDefinedValuesToTerraform(struct?: SecurityhubInsightFiltersUserDefinedValues): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersVerificationState {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersVerificationStateToTerraform(struct?: SecurityhubInsightFiltersVerificationState): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFiltersWorkflowStatus {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#comparison SecurityhubInsight#comparison}.
     *
     * @stability stable
     */
    readonly comparison: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#value SecurityhubInsight#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function securityhubInsightFiltersWorkflowStatusToTerraform(struct?: SecurityhubInsightFiltersWorkflowStatus): any;
/**
 * @stability stable
 */
export interface SecurityhubInsightFilters {
    /**
     * aws_account_id block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#aws_account_id SecurityhubInsight#aws_account_id}
     *
     * @stability stable
     */
    readonly awsAccountId?: SecurityhubInsightFiltersAwsAccountId[];
    /**
     * company_name block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#company_name SecurityhubInsight#company_name}
     *
     * @stability stable
     */
    readonly companyName?: SecurityhubInsightFiltersCompanyName[];
    /**
     * compliance_status block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#compliance_status SecurityhubInsight#compliance_status}
     *
     * @stability stable
     */
    readonly complianceStatus?: SecurityhubInsightFiltersComplianceStatus[];
    /**
     * confidence block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#confidence SecurityhubInsight#confidence}
     *
     * @stability stable
     */
    readonly confidence?: SecurityhubInsightFiltersConfidence[];
    /**
     * created_at block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#created_at SecurityhubInsight#created_at}
     *
     * @stability stable
     */
    readonly createdAt?: SecurityhubInsightFiltersCreatedAt[];
    /**
     * criticality block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#criticality SecurityhubInsight#criticality}
     *
     * @stability stable
     */
    readonly criticality?: SecurityhubInsightFiltersCriticality[];
    /**
     * description block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#description SecurityhubInsight#description}
     *
     * @stability stable
     */
    readonly description?: SecurityhubInsightFiltersDescription[];
    /**
     * finding_provider_fields_confidence block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#finding_provider_fields_confidence SecurityhubInsight#finding_provider_fields_confidence}
     *
     * @stability stable
     */
    readonly findingProviderFieldsConfidence?: SecurityhubInsightFiltersFindingProviderFieldsConfidence[];
    /**
     * finding_provider_fields_criticality block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#finding_provider_fields_criticality SecurityhubInsight#finding_provider_fields_criticality}
     *
     * @stability stable
     */
    readonly findingProviderFieldsCriticality?: SecurityhubInsightFiltersFindingProviderFieldsCriticality[];
    /**
     * finding_provider_fields_related_findings_id block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#finding_provider_fields_related_findings_id SecurityhubInsight#finding_provider_fields_related_findings_id}
     *
     * @stability stable
     */
    readonly findingProviderFieldsRelatedFindingsId?: SecurityhubInsightFiltersFindingProviderFieldsRelatedFindingsId[];
    /**
     * finding_provider_fields_related_findings_product_arn block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#finding_provider_fields_related_findings_product_arn SecurityhubInsight#finding_provider_fields_related_findings_product_arn}
     *
     * @stability stable
     */
    readonly findingProviderFieldsRelatedFindingsProductArn?: SecurityhubInsightFiltersFindingProviderFieldsRelatedFindingsProductArn[];
    /**
     * finding_provider_fields_severity_label block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#finding_provider_fields_severity_label SecurityhubInsight#finding_provider_fields_severity_label}
     *
     * @stability stable
     */
    readonly findingProviderFieldsSeverityLabel?: SecurityhubInsightFiltersFindingProviderFieldsSeverityLabel[];
    /**
     * finding_provider_fields_severity_original block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#finding_provider_fields_severity_original SecurityhubInsight#finding_provider_fields_severity_original}
     *
     * @stability stable
     */
    readonly findingProviderFieldsSeverityOriginal?: SecurityhubInsightFiltersFindingProviderFieldsSeverityOriginal[];
    /**
     * finding_provider_fields_types block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#finding_provider_fields_types SecurityhubInsight#finding_provider_fields_types}
     *
     * @stability stable
     */
    readonly findingProviderFieldsTypes?: SecurityhubInsightFiltersFindingProviderFieldsTypes[];
    /**
     * first_observed_at block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#first_observed_at SecurityhubInsight#first_observed_at}
     *
     * @stability stable
     */
    readonly firstObservedAt?: SecurityhubInsightFiltersFirstObservedAt[];
    /**
     * generator_id block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#generator_id SecurityhubInsight#generator_id}
     *
     * @stability stable
     */
    readonly generatorId?: SecurityhubInsightFiltersGeneratorId[];
    /**
     * id block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#id SecurityhubInsight#id}
     *
     * @stability stable
     */
    readonly id?: SecurityhubInsightFiltersId[];
    /**
     * keyword block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#keyword SecurityhubInsight#keyword}
     *
     * @stability stable
     */
    readonly keyword?: SecurityhubInsightFiltersKeyword[];
    /**
     * last_observed_at block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#last_observed_at SecurityhubInsight#last_observed_at}
     *
     * @stability stable
     */
    readonly lastObservedAt?: SecurityhubInsightFiltersLastObservedAt[];
    /**
     * malware_name block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#malware_name SecurityhubInsight#malware_name}
     *
     * @stability stable
     */
    readonly malwareName?: SecurityhubInsightFiltersMalwareName[];
    /**
     * malware_path block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#malware_path SecurityhubInsight#malware_path}
     *
     * @stability stable
     */
    readonly malwarePath?: SecurityhubInsightFiltersMalwarePath[];
    /**
     * malware_state block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#malware_state SecurityhubInsight#malware_state}
     *
     * @stability stable
     */
    readonly malwareState?: SecurityhubInsightFiltersMalwareState[];
    /**
     * malware_type block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#malware_type SecurityhubInsight#malware_type}
     *
     * @stability stable
     */
    readonly malwareType?: SecurityhubInsightFiltersMalwareType[];
    /**
     * network_destination_domain block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#network_destination_domain SecurityhubInsight#network_destination_domain}
     *
     * @stability stable
     */
    readonly networkDestinationDomain?: SecurityhubInsightFiltersNetworkDestinationDomain[];
    /**
     * network_destination_ipv4 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#network_destination_ipv4 SecurityhubInsight#network_destination_ipv4}
     *
     * @stability stable
     */
    readonly networkDestinationIpv4?: SecurityhubInsightFiltersNetworkDestinationIpv4[];
    /**
     * network_destination_ipv6 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#network_destination_ipv6 SecurityhubInsight#network_destination_ipv6}
     *
     * @stability stable
     */
    readonly networkDestinationIpv6?: SecurityhubInsightFiltersNetworkDestinationIpv6[];
    /**
     * network_destination_port block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#network_destination_port SecurityhubInsight#network_destination_port}
     *
     * @stability stable
     */
    readonly networkDestinationPort?: SecurityhubInsightFiltersNetworkDestinationPort[];
    /**
     * network_direction block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#network_direction SecurityhubInsight#network_direction}
     *
     * @stability stable
     */
    readonly networkDirection?: SecurityhubInsightFiltersNetworkDirection[];
    /**
     * network_protocol block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#network_protocol SecurityhubInsight#network_protocol}
     *
     * @stability stable
     */
    readonly networkProtocol?: SecurityhubInsightFiltersNetworkProtocol[];
    /**
     * network_source_domain block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#network_source_domain SecurityhubInsight#network_source_domain}
     *
     * @stability stable
     */
    readonly networkSourceDomain?: SecurityhubInsightFiltersNetworkSourceDomain[];
    /**
     * network_source_ipv4 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#network_source_ipv4 SecurityhubInsight#network_source_ipv4}
     *
     * @stability stable
     */
    readonly networkSourceIpv4?: SecurityhubInsightFiltersNetworkSourceIpv4[];
    /**
     * network_source_ipv6 block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#network_source_ipv6 SecurityhubInsight#network_source_ipv6}
     *
     * @stability stable
     */
    readonly networkSourceIpv6?: SecurityhubInsightFiltersNetworkSourceIpv6[];
    /**
     * network_source_mac block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#network_source_mac SecurityhubInsight#network_source_mac}
     *
     * @stability stable
     */
    readonly networkSourceMac?: SecurityhubInsightFiltersNetworkSourceMac[];
    /**
     * network_source_port block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#network_source_port SecurityhubInsight#network_source_port}
     *
     * @stability stable
     */
    readonly networkSourcePort?: SecurityhubInsightFiltersNetworkSourcePort[];
    /**
     * note_text block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#note_text SecurityhubInsight#note_text}
     *
     * @stability stable
     */
    readonly noteText?: SecurityhubInsightFiltersNoteText[];
    /**
     * note_updated_at block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#note_updated_at SecurityhubInsight#note_updated_at}
     *
     * @stability stable
     */
    readonly noteUpdatedAt?: SecurityhubInsightFiltersNoteUpdatedAt[];
    /**
     * note_updated_by block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#note_updated_by SecurityhubInsight#note_updated_by}
     *
     * @stability stable
     */
    readonly noteUpdatedBy?: SecurityhubInsightFiltersNoteUpdatedBy[];
    /**
     * process_launched_at block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#process_launched_at SecurityhubInsight#process_launched_at}
     *
     * @stability stable
     */
    readonly processLaunchedAt?: SecurityhubInsightFiltersProcessLaunchedAt[];
    /**
     * process_name block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#process_name SecurityhubInsight#process_name}
     *
     * @stability stable
     */
    readonly processName?: SecurityhubInsightFiltersProcessName[];
    /**
     * process_parent_pid block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#process_parent_pid SecurityhubInsight#process_parent_pid}
     *
     * @stability stable
     */
    readonly processParentPid?: SecurityhubInsightFiltersProcessParentPid[];
    /**
     * process_path block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#process_path SecurityhubInsight#process_path}
     *
     * @stability stable
     */
    readonly processPath?: SecurityhubInsightFiltersProcessPath[];
    /**
     * process_pid block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#process_pid SecurityhubInsight#process_pid}
     *
     * @stability stable
     */
    readonly processPid?: SecurityhubInsightFiltersProcessPid[];
    /**
     * process_terminated_at block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#process_terminated_at SecurityhubInsight#process_terminated_at}
     *
     * @stability stable
     */
    readonly processTerminatedAt?: SecurityhubInsightFiltersProcessTerminatedAt[];
    /**
     * product_arn block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#product_arn SecurityhubInsight#product_arn}
     *
     * @stability stable
     */
    readonly productArn?: SecurityhubInsightFiltersProductArn[];
    /**
     * product_fields block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#product_fields SecurityhubInsight#product_fields}
     *
     * @stability stable
     */
    readonly productFields?: SecurityhubInsightFiltersProductFields[];
    /**
     * product_name block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#product_name SecurityhubInsight#product_name}
     *
     * @stability stable
     */
    readonly productName?: SecurityhubInsightFiltersProductName[];
    /**
     * recommendation_text block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#recommendation_text SecurityhubInsight#recommendation_text}
     *
     * @stability stable
     */
    readonly recommendationText?: SecurityhubInsightFiltersRecommendationText[];
    /**
     * record_state block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#record_state SecurityhubInsight#record_state}
     *
     * @stability stable
     */
    readonly recordState?: SecurityhubInsightFiltersRecordState[];
    /**
     * related_findings_id block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#related_findings_id SecurityhubInsight#related_findings_id}
     *
     * @stability stable
     */
    readonly relatedFindingsId?: SecurityhubInsightFiltersRelatedFindingsId[];
    /**
     * related_findings_product_arn block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#related_findings_product_arn SecurityhubInsight#related_findings_product_arn}
     *
     * @stability stable
     */
    readonly relatedFindingsProductArn?: SecurityhubInsightFiltersRelatedFindingsProductArn[];
    /**
     * resource_aws_ec2_instance_iam_instance_profile_arn block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_aws_ec2_instance_iam_instance_profile_arn SecurityhubInsight#resource_aws_ec2_instance_iam_instance_profile_arn}
     *
     * @stability stable
     */
    readonly resourceAwsEc2InstanceIamInstanceProfileArn?: SecurityhubInsightFiltersResourceAwsEc2InstanceIamInstanceProfileArn[];
    /**
     * resource_aws_ec2_instance_image_id block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_aws_ec2_instance_image_id SecurityhubInsight#resource_aws_ec2_instance_image_id}
     *
     * @stability stable
     */
    readonly resourceAwsEc2InstanceImageId?: SecurityhubInsightFiltersResourceAwsEc2InstanceImageId[];
    /**
     * resource_aws_ec2_instance_ipv4_addresses block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_aws_ec2_instance_ipv4_addresses SecurityhubInsight#resource_aws_ec2_instance_ipv4_addresses}
     *
     * @stability stable
     */
    readonly resourceAwsEc2InstanceIpv4Addresses?: SecurityhubInsightFiltersResourceAwsEc2InstanceIpv4Addresses[];
    /**
     * resource_aws_ec2_instance_ipv6_addresses block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_aws_ec2_instance_ipv6_addresses SecurityhubInsight#resource_aws_ec2_instance_ipv6_addresses}
     *
     * @stability stable
     */
    readonly resourceAwsEc2InstanceIpv6Addresses?: SecurityhubInsightFiltersResourceAwsEc2InstanceIpv6Addresses[];
    /**
     * resource_aws_ec2_instance_key_name block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_aws_ec2_instance_key_name SecurityhubInsight#resource_aws_ec2_instance_key_name}
     *
     * @stability stable
     */
    readonly resourceAwsEc2InstanceKeyName?: SecurityhubInsightFiltersResourceAwsEc2InstanceKeyName[];
    /**
     * resource_aws_ec2_instance_launched_at block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_aws_ec2_instance_launched_at SecurityhubInsight#resource_aws_ec2_instance_launched_at}
     *
     * @stability stable
     */
    readonly resourceAwsEc2InstanceLaunchedAt?: SecurityhubInsightFiltersResourceAwsEc2InstanceLaunchedAt[];
    /**
     * resource_aws_ec2_instance_subnet_id block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_aws_ec2_instance_subnet_id SecurityhubInsight#resource_aws_ec2_instance_subnet_id}
     *
     * @stability stable
     */
    readonly resourceAwsEc2InstanceSubnetId?: SecurityhubInsightFiltersResourceAwsEc2InstanceSubnetId[];
    /**
     * resource_aws_ec2_instance_type block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_aws_ec2_instance_type SecurityhubInsight#resource_aws_ec2_instance_type}
     *
     * @stability stable
     */
    readonly resourceAwsEc2InstanceType?: SecurityhubInsightFiltersResourceAwsEc2InstanceType[];
    /**
     * resource_aws_ec2_instance_vpc_id block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_aws_ec2_instance_vpc_id SecurityhubInsight#resource_aws_ec2_instance_vpc_id}
     *
     * @stability stable
     */
    readonly resourceAwsEc2InstanceVpcId?: SecurityhubInsightFiltersResourceAwsEc2InstanceVpcId[];
    /**
     * resource_aws_iam_access_key_created_at block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_aws_iam_access_key_created_at SecurityhubInsight#resource_aws_iam_access_key_created_at}
     *
     * @stability stable
     */
    readonly resourceAwsIamAccessKeyCreatedAt?: SecurityhubInsightFiltersResourceAwsIamAccessKeyCreatedAt[];
    /**
     * resource_aws_iam_access_key_status block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_aws_iam_access_key_status SecurityhubInsight#resource_aws_iam_access_key_status}
     *
     * @stability stable
     */
    readonly resourceAwsIamAccessKeyStatus?: SecurityhubInsightFiltersResourceAwsIamAccessKeyStatus[];
    /**
     * resource_aws_iam_access_key_user_name block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_aws_iam_access_key_user_name SecurityhubInsight#resource_aws_iam_access_key_user_name}
     *
     * @stability stable
     */
    readonly resourceAwsIamAccessKeyUserName?: SecurityhubInsightFiltersResourceAwsIamAccessKeyUserName[];
    /**
     * resource_aws_s3_bucket_owner_id block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_aws_s3_bucket_owner_id SecurityhubInsight#resource_aws_s3_bucket_owner_id}
     *
     * @stability stable
     */
    readonly resourceAwsS3BucketOwnerId?: SecurityhubInsightFiltersResourceAwsS3BucketOwnerId[];
    /**
     * resource_aws_s3_bucket_owner_name block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_aws_s3_bucket_owner_name SecurityhubInsight#resource_aws_s3_bucket_owner_name}
     *
     * @stability stable
     */
    readonly resourceAwsS3BucketOwnerName?: SecurityhubInsightFiltersResourceAwsS3BucketOwnerName[];
    /**
     * resource_container_image_id block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_container_image_id SecurityhubInsight#resource_container_image_id}
     *
     * @stability stable
     */
    readonly resourceContainerImageId?: SecurityhubInsightFiltersResourceContainerImageId[];
    /**
     * resource_container_image_name block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_container_image_name SecurityhubInsight#resource_container_image_name}
     *
     * @stability stable
     */
    readonly resourceContainerImageName?: SecurityhubInsightFiltersResourceContainerImageName[];
    /**
     * resource_container_launched_at block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_container_launched_at SecurityhubInsight#resource_container_launched_at}
     *
     * @stability stable
     */
    readonly resourceContainerLaunchedAt?: SecurityhubInsightFiltersResourceContainerLaunchedAt[];
    /**
     * resource_container_name block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_container_name SecurityhubInsight#resource_container_name}
     *
     * @stability stable
     */
    readonly resourceContainerName?: SecurityhubInsightFiltersResourceContainerName[];
    /**
     * resource_details_other block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_details_other SecurityhubInsight#resource_details_other}
     *
     * @stability stable
     */
    readonly resourceDetailsOther?: SecurityhubInsightFiltersResourceDetailsOther[];
    /**
     * resource_id block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_id SecurityhubInsight#resource_id}
     *
     * @stability stable
     */
    readonly resourceId?: SecurityhubInsightFiltersResourceId[];
    /**
     * resource_partition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_partition SecurityhubInsight#resource_partition}
     *
     * @stability stable
     */
    readonly resourcePartition?: SecurityhubInsightFiltersResourcePartition[];
    /**
     * resource_region block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_region SecurityhubInsight#resource_region}
     *
     * @stability stable
     */
    readonly resourceRegion?: SecurityhubInsightFiltersResourceRegion[];
    /**
     * resource_tags block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_tags SecurityhubInsight#resource_tags}
     *
     * @stability stable
     */
    readonly resourceTags?: SecurityhubInsightFiltersResourceTags[];
    /**
     * resource_type block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#resource_type SecurityhubInsight#resource_type}
     *
     * @stability stable
     */
    readonly resourceType?: SecurityhubInsightFiltersResourceType[];
    /**
     * severity_label block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#severity_label SecurityhubInsight#severity_label}
     *
     * @stability stable
     */
    readonly severityLabel?: SecurityhubInsightFiltersSeverityLabel[];
    /**
     * source_url block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#source_url SecurityhubInsight#source_url}
     *
     * @stability stable
     */
    readonly sourceUrl?: SecurityhubInsightFiltersSourceUrl[];
    /**
     * threat_intel_indicator_category block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#threat_intel_indicator_category SecurityhubInsight#threat_intel_indicator_category}
     *
     * @stability stable
     */
    readonly threatIntelIndicatorCategory?: SecurityhubInsightFiltersThreatIntelIndicatorCategory[];
    /**
     * threat_intel_indicator_last_observed_at block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#threat_intel_indicator_last_observed_at SecurityhubInsight#threat_intel_indicator_last_observed_at}
     *
     * @stability stable
     */
    readonly threatIntelIndicatorLastObservedAt?: SecurityhubInsightFiltersThreatIntelIndicatorLastObservedAt[];
    /**
     * threat_intel_indicator_source block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#threat_intel_indicator_source SecurityhubInsight#threat_intel_indicator_source}
     *
     * @stability stable
     */
    readonly threatIntelIndicatorSource?: SecurityhubInsightFiltersThreatIntelIndicatorSource[];
    /**
     * threat_intel_indicator_source_url block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#threat_intel_indicator_source_url SecurityhubInsight#threat_intel_indicator_source_url}
     *
     * @stability stable
     */
    readonly threatIntelIndicatorSourceUrl?: SecurityhubInsightFiltersThreatIntelIndicatorSourceUrl[];
    /**
     * threat_intel_indicator_type block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#threat_intel_indicator_type SecurityhubInsight#threat_intel_indicator_type}
     *
     * @stability stable
     */
    readonly threatIntelIndicatorType?: SecurityhubInsightFiltersThreatIntelIndicatorType[];
    /**
     * threat_intel_indicator_value block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#threat_intel_indicator_value SecurityhubInsight#threat_intel_indicator_value}
     *
     * @stability stable
     */
    readonly threatIntelIndicatorValue?: SecurityhubInsightFiltersThreatIntelIndicatorValue[];
    /**
     * title block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#title SecurityhubInsight#title}
     *
     * @stability stable
     */
    readonly title?: SecurityhubInsightFiltersTitle[];
    /**
     * type block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#type SecurityhubInsight#type}
     *
     * @stability stable
     */
    readonly type?: SecurityhubInsightFiltersType[];
    /**
     * updated_at block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#updated_at SecurityhubInsight#updated_at}
     *
     * @stability stable
     */
    readonly updatedAt?: SecurityhubInsightFiltersUpdatedAt[];
    /**
     * user_defined_values block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#user_defined_values SecurityhubInsight#user_defined_values}
     *
     * @stability stable
     */
    readonly userDefinedValues?: SecurityhubInsightFiltersUserDefinedValues[];
    /**
     * verification_state block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#verification_state SecurityhubInsight#verification_state}
     *
     * @stability stable
     */
    readonly verificationState?: SecurityhubInsightFiltersVerificationState[];
    /**
     * workflow_status block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight#workflow_status SecurityhubInsight#workflow_status}
     *
     * @stability stable
     */
    readonly workflowStatus?: SecurityhubInsightFiltersWorkflowStatus[];
}
export declare function securityhubInsightFiltersToTerraform(struct?: SecurityhubInsightFiltersOutputReference | SecurityhubInsightFilters): any;
/**
 * @stability stable
 */
export declare class SecurityhubInsightFiltersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): SecurityhubInsightFilters | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: SecurityhubInsightFilters | undefined);
    private _awsAccountId?;
    /**
     * @stability stable
     */
    get awsAccountId(): SecurityhubInsightFiltersAwsAccountId[];
    /**
     * @stability stable
     */
    set awsAccountId(value: SecurityhubInsightFiltersAwsAccountId[]);
    /**
     * @stability stable
     */
    resetAwsAccountId(): void;
    /**
     * @stability stable
     */
    get awsAccountIdInput(): SecurityhubInsightFiltersAwsAccountId[] | undefined;
    private _companyName?;
    /**
     * @stability stable
     */
    get companyName(): SecurityhubInsightFiltersCompanyName[];
    /**
     * @stability stable
     */
    set companyName(value: SecurityhubInsightFiltersCompanyName[]);
    /**
     * @stability stable
     */
    resetCompanyName(): void;
    /**
     * @stability stable
     */
    get companyNameInput(): SecurityhubInsightFiltersCompanyName[] | undefined;
    private _complianceStatus?;
    /**
     * @stability stable
     */
    get complianceStatus(): SecurityhubInsightFiltersComplianceStatus[];
    /**
     * @stability stable
     */
    set complianceStatus(value: SecurityhubInsightFiltersComplianceStatus[]);
    /**
     * @stability stable
     */
    resetComplianceStatus(): void;
    /**
     * @stability stable
     */
    get complianceStatusInput(): SecurityhubInsightFiltersComplianceStatus[] | undefined;
    private _confidence?;
    /**
     * @stability stable
     */
    get confidence(): SecurityhubInsightFiltersConfidence[];
    /**
     * @stability stable
     */
    set confidence(value: SecurityhubInsightFiltersConfidence[]);
    /**
     * @stability stable
     */
    resetConfidence(): void;
    /**
     * @stability stable
     */
    get confidenceInput(): SecurityhubInsightFiltersConfidence[] | undefined;
    private _createdAt?;
    /**
     * @stability stable
     */
    get createdAt(): SecurityhubInsightFiltersCreatedAt[];
    /**
     * @stability stable
     */
    set createdAt(value: SecurityhubInsightFiltersCreatedAt[]);
    /**
     * @stability stable
     */
    resetCreatedAt(): void;
    /**
     * @stability stable
     */
    get createdAtInput(): SecurityhubInsightFiltersCreatedAt[] | undefined;
    private _criticality?;
    /**
     * @stability stable
     */
    get criticality(): SecurityhubInsightFiltersCriticality[];
    /**
     * @stability stable
     */
    set criticality(value: SecurityhubInsightFiltersCriticality[]);
    /**
     * @stability stable
     */
    resetCriticality(): void;
    /**
     * @stability stable
     */
    get criticalityInput(): SecurityhubInsightFiltersCriticality[] | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): SecurityhubInsightFiltersDescription[];
    /**
     * @stability stable
     */
    set description(value: SecurityhubInsightFiltersDescription[]);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): SecurityhubInsightFiltersDescription[] | undefined;
    private _findingProviderFieldsConfidence?;
    /**
     * @stability stable
     */
    get findingProviderFieldsConfidence(): SecurityhubInsightFiltersFindingProviderFieldsConfidence[];
    /**
     * @stability stable
     */
    set findingProviderFieldsConfidence(value: SecurityhubInsightFiltersFindingProviderFieldsConfidence[]);
    /**
     * @stability stable
     */
    resetFindingProviderFieldsConfidence(): void;
    /**
     * @stability stable
     */
    get findingProviderFieldsConfidenceInput(): SecurityhubInsightFiltersFindingProviderFieldsConfidence[] | undefined;
    private _findingProviderFieldsCriticality?;
    /**
     * @stability stable
     */
    get findingProviderFieldsCriticality(): SecurityhubInsightFiltersFindingProviderFieldsCriticality[];
    /**
     * @stability stable
     */
    set findingProviderFieldsCriticality(value: SecurityhubInsightFiltersFindingProviderFieldsCriticality[]);
    /**
     * @stability stable
     */
    resetFindingProviderFieldsCriticality(): void;
    /**
     * @stability stable
     */
    get findingProviderFieldsCriticalityInput(): SecurityhubInsightFiltersFindingProviderFieldsCriticality[] | undefined;
    private _findingProviderFieldsRelatedFindingsId?;
    /**
     * @stability stable
     */
    get findingProviderFieldsRelatedFindingsId(): SecurityhubInsightFiltersFindingProviderFieldsRelatedFindingsId[];
    /**
     * @stability stable
     */
    set findingProviderFieldsRelatedFindingsId(value: SecurityhubInsightFiltersFindingProviderFieldsRelatedFindingsId[]);
    /**
     * @stability stable
     */
    resetFindingProviderFieldsRelatedFindingsId(): void;
    /**
     * @stability stable
     */
    get findingProviderFieldsRelatedFindingsIdInput(): SecurityhubInsightFiltersFindingProviderFieldsRelatedFindingsId[] | undefined;
    private _findingProviderFieldsRelatedFindingsProductArn?;
    /**
     * @stability stable
     */
    get findingProviderFieldsRelatedFindingsProductArn(): SecurityhubInsightFiltersFindingProviderFieldsRelatedFindingsProductArn[];
    /**
     * @stability stable
     */
    set findingProviderFieldsRelatedFindingsProductArn(value: SecurityhubInsightFiltersFindingProviderFieldsRelatedFindingsProductArn[]);
    /**
     * @stability stable
     */
    resetFindingProviderFieldsRelatedFindingsProductArn(): void;
    /**
     * @stability stable
     */
    get findingProviderFieldsRelatedFindingsProductArnInput(): SecurityhubInsightFiltersFindingProviderFieldsRelatedFindingsProductArn[] | undefined;
    private _findingProviderFieldsSeverityLabel?;
    /**
     * @stability stable
     */
    get findingProviderFieldsSeverityLabel(): SecurityhubInsightFiltersFindingProviderFieldsSeverityLabel[];
    /**
     * @stability stable
     */
    set findingProviderFieldsSeverityLabel(value: SecurityhubInsightFiltersFindingProviderFieldsSeverityLabel[]);
    /**
     * @stability stable
     */
    resetFindingProviderFieldsSeverityLabel(): void;
    /**
     * @stability stable
     */
    get findingProviderFieldsSeverityLabelInput(): SecurityhubInsightFiltersFindingProviderFieldsSeverityLabel[] | undefined;
    private _findingProviderFieldsSeverityOriginal?;
    /**
     * @stability stable
     */
    get findingProviderFieldsSeverityOriginal(): SecurityhubInsightFiltersFindingProviderFieldsSeverityOriginal[];
    /**
     * @stability stable
     */
    set findingProviderFieldsSeverityOriginal(value: SecurityhubInsightFiltersFindingProviderFieldsSeverityOriginal[]);
    /**
     * @stability stable
     */
    resetFindingProviderFieldsSeverityOriginal(): void;
    /**
     * @stability stable
     */
    get findingProviderFieldsSeverityOriginalInput(): SecurityhubInsightFiltersFindingProviderFieldsSeverityOriginal[] | undefined;
    private _findingProviderFieldsTypes?;
    /**
     * @stability stable
     */
    get findingProviderFieldsTypes(): SecurityhubInsightFiltersFindingProviderFieldsTypes[];
    /**
     * @stability stable
     */
    set findingProviderFieldsTypes(value: SecurityhubInsightFiltersFindingProviderFieldsTypes[]);
    /**
     * @stability stable
     */
    resetFindingProviderFieldsTypes(): void;
    /**
     * @stability stable
     */
    get findingProviderFieldsTypesInput(): SecurityhubInsightFiltersFindingProviderFieldsTypes[] | undefined;
    private _firstObservedAt?;
    /**
     * @stability stable
     */
    get firstObservedAt(): SecurityhubInsightFiltersFirstObservedAt[];
    /**
     * @stability stable
     */
    set firstObservedAt(value: SecurityhubInsightFiltersFirstObservedAt[]);
    /**
     * @stability stable
     */
    resetFirstObservedAt(): void;
    /**
     * @stability stable
     */
    get firstObservedAtInput(): SecurityhubInsightFiltersFirstObservedAt[] | undefined;
    private _generatorId?;
    /**
     * @stability stable
     */
    get generatorId(): SecurityhubInsightFiltersGeneratorId[];
    /**
     * @stability stable
     */
    set generatorId(value: SecurityhubInsightFiltersGeneratorId[]);
    /**
     * @stability stable
     */
    resetGeneratorId(): void;
    /**
     * @stability stable
     */
    get generatorIdInput(): SecurityhubInsightFiltersGeneratorId[] | undefined;
    private _id?;
    /**
     * @stability stable
     */
    get id(): SecurityhubInsightFiltersId[];
    /**
     * @stability stable
     */
    set id(value: SecurityhubInsightFiltersId[]);
    /**
     * @stability stable
     */
    resetId(): void;
    /**
     * @stability stable
     */
    get idInput(): SecurityhubInsightFiltersId[] | undefined;
    private _keyword?;
    /**
     * @stability stable
     */
    get keyword(): SecurityhubInsightFiltersKeyword[];
    /**
     * @stability stable
     */
    set keyword(value: SecurityhubInsightFiltersKeyword[]);
    /**
     * @stability stable
     */
    resetKeyword(): void;
    /**
     * @stability stable
     */
    get keywordInput(): SecurityhubInsightFiltersKeyword[] | undefined;
    private _lastObservedAt?;
    /**
     * @stability stable
     */
    get lastObservedAt(): SecurityhubInsightFiltersLastObservedAt[];
    /**
     * @stability stable
     */
    set lastObservedAt(value: SecurityhubInsightFiltersLastObservedAt[]);
    /**
     * @stability stable
     */
    resetLastObservedAt(): void;
    /**
     * @stability stable
     */
    get lastObservedAtInput(): SecurityhubInsightFiltersLastObservedAt[] | undefined;
    private _malwareName?;
    /**
     * @stability stable
     */
    get malwareName(): SecurityhubInsightFiltersMalwareName[];
    /**
     * @stability stable
     */
    set malwareName(value: SecurityhubInsightFiltersMalwareName[]);
    /**
     * @stability stable
     */
    resetMalwareName(): void;
    /**
     * @stability stable
     */
    get malwareNameInput(): SecurityhubInsightFiltersMalwareName[] | undefined;
    private _malwarePath?;
    /**
     * @stability stable
     */
    get malwarePath(): SecurityhubInsightFiltersMalwarePath[];
    /**
     * @stability stable
     */
    set malwarePath(value: SecurityhubInsightFiltersMalwarePath[]);
    /**
     * @stability stable
     */
    resetMalwarePath(): void;
    /**
     * @stability stable
     */
    get malwarePathInput(): SecurityhubInsightFiltersMalwarePath[] | undefined;
    private _malwareState?;
    /**
     * @stability stable
     */
    get malwareState(): SecurityhubInsightFiltersMalwareState[];
    /**
     * @stability stable
     */
    set malwareState(value: SecurityhubInsightFiltersMalwareState[]);
    /**
     * @stability stable
     */
    resetMalwareState(): void;
    /**
     * @stability stable
     */
    get malwareStateInput(): SecurityhubInsightFiltersMalwareState[] | undefined;
    private _malwareType?;
    /**
     * @stability stable
     */
    get malwareType(): SecurityhubInsightFiltersMalwareType[];
    /**
     * @stability stable
     */
    set malwareType(value: SecurityhubInsightFiltersMalwareType[]);
    /**
     * @stability stable
     */
    resetMalwareType(): void;
    /**
     * @stability stable
     */
    get malwareTypeInput(): SecurityhubInsightFiltersMalwareType[] | undefined;
    private _networkDestinationDomain?;
    /**
     * @stability stable
     */
    get networkDestinationDomain(): SecurityhubInsightFiltersNetworkDestinationDomain[];
    /**
     * @stability stable
     */
    set networkDestinationDomain(value: SecurityhubInsightFiltersNetworkDestinationDomain[]);
    /**
     * @stability stable
     */
    resetNetworkDestinationDomain(): void;
    /**
     * @stability stable
     */
    get networkDestinationDomainInput(): SecurityhubInsightFiltersNetworkDestinationDomain[] | undefined;
    private _networkDestinationIpv4?;
    /**
     * @stability stable
     */
    get networkDestinationIpv4(): SecurityhubInsightFiltersNetworkDestinationIpv4[];
    /**
     * @stability stable
     */
    set networkDestinationIpv4(value: SecurityhubInsightFiltersNetworkDestinationIpv4[]);
    /**
     * @stability stable
     */
    resetNetworkDestinationIpv4(): void;
    /**
     * @stability stable
     */
    get networkDestinationIpv4Input(): SecurityhubInsightFiltersNetworkDestinationIpv4[] | undefined;
    private _networkDestinationIpv6?;
    /**
     * @stability stable
     */
    get networkDestinationIpv6(): SecurityhubInsightFiltersNetworkDestinationIpv6[];
    /**
     * @stability stable
     */
    set networkDestinationIpv6(value: SecurityhubInsightFiltersNetworkDestinationIpv6[]);
    /**
     * @stability stable
     */
    resetNetworkDestinationIpv6(): void;
    /**
     * @stability stable
     */
    get networkDestinationIpv6Input(): SecurityhubInsightFiltersNetworkDestinationIpv6[] | undefined;
    private _networkDestinationPort?;
    /**
     * @stability stable
     */
    get networkDestinationPort(): SecurityhubInsightFiltersNetworkDestinationPort[];
    /**
     * @stability stable
     */
    set networkDestinationPort(value: SecurityhubInsightFiltersNetworkDestinationPort[]);
    /**
     * @stability stable
     */
    resetNetworkDestinationPort(): void;
    /**
     * @stability stable
     */
    get networkDestinationPortInput(): SecurityhubInsightFiltersNetworkDestinationPort[] | undefined;
    private _networkDirection?;
    /**
     * @stability stable
     */
    get networkDirection(): SecurityhubInsightFiltersNetworkDirection[];
    /**
     * @stability stable
     */
    set networkDirection(value: SecurityhubInsightFiltersNetworkDirection[]);
    /**
     * @stability stable
     */
    resetNetworkDirection(): void;
    /**
     * @stability stable
     */
    get networkDirectionInput(): SecurityhubInsightFiltersNetworkDirection[] | undefined;
    private _networkProtocol?;
    /**
     * @stability stable
     */
    get networkProtocol(): SecurityhubInsightFiltersNetworkProtocol[];
    /**
     * @stability stable
     */
    set networkProtocol(value: SecurityhubInsightFiltersNetworkProtocol[]);
    /**
     * @stability stable
     */
    resetNetworkProtocol(): void;
    /**
     * @stability stable
     */
    get networkProtocolInput(): SecurityhubInsightFiltersNetworkProtocol[] | undefined;
    private _networkSourceDomain?;
    /**
     * @stability stable
     */
    get networkSourceDomain(): SecurityhubInsightFiltersNetworkSourceDomain[];
    /**
     * @stability stable
     */
    set networkSourceDomain(value: SecurityhubInsightFiltersNetworkSourceDomain[]);
    /**
     * @stability stable
     */
    resetNetworkSourceDomain(): void;
    /**
     * @stability stable
     */
    get networkSourceDomainInput(): SecurityhubInsightFiltersNetworkSourceDomain[] | undefined;
    private _networkSourceIpv4?;
    /**
     * @stability stable
     */
    get networkSourceIpv4(): SecurityhubInsightFiltersNetworkSourceIpv4[];
    /**
     * @stability stable
     */
    set networkSourceIpv4(value: SecurityhubInsightFiltersNetworkSourceIpv4[]);
    /**
     * @stability stable
     */
    resetNetworkSourceIpv4(): void;
    /**
     * @stability stable
     */
    get networkSourceIpv4Input(): SecurityhubInsightFiltersNetworkSourceIpv4[] | undefined;
    private _networkSourceIpv6?;
    /**
     * @stability stable
     */
    get networkSourceIpv6(): SecurityhubInsightFiltersNetworkSourceIpv6[];
    /**
     * @stability stable
     */
    set networkSourceIpv6(value: SecurityhubInsightFiltersNetworkSourceIpv6[]);
    /**
     * @stability stable
     */
    resetNetworkSourceIpv6(): void;
    /**
     * @stability stable
     */
    get networkSourceIpv6Input(): SecurityhubInsightFiltersNetworkSourceIpv6[] | undefined;
    private _networkSourceMac?;
    /**
     * @stability stable
     */
    get networkSourceMac(): SecurityhubInsightFiltersNetworkSourceMac[];
    /**
     * @stability stable
     */
    set networkSourceMac(value: SecurityhubInsightFiltersNetworkSourceMac[]);
    /**
     * @stability stable
     */
    resetNetworkSourceMac(): void;
    /**
     * @stability stable
     */
    get networkSourceMacInput(): SecurityhubInsightFiltersNetworkSourceMac[] | undefined;
    private _networkSourcePort?;
    /**
     * @stability stable
     */
    get networkSourcePort(): SecurityhubInsightFiltersNetworkSourcePort[];
    /**
     * @stability stable
     */
    set networkSourcePort(value: SecurityhubInsightFiltersNetworkSourcePort[]);
    /**
     * @stability stable
     */
    resetNetworkSourcePort(): void;
    /**
     * @stability stable
     */
    get networkSourcePortInput(): SecurityhubInsightFiltersNetworkSourcePort[] | undefined;
    private _noteText?;
    /**
     * @stability stable
     */
    get noteText(): SecurityhubInsightFiltersNoteText[];
    /**
     * @stability stable
     */
    set noteText(value: SecurityhubInsightFiltersNoteText[]);
    /**
     * @stability stable
     */
    resetNoteText(): void;
    /**
     * @stability stable
     */
    get noteTextInput(): SecurityhubInsightFiltersNoteText[] | undefined;
    private _noteUpdatedAt?;
    /**
     * @stability stable
     */
    get noteUpdatedAt(): SecurityhubInsightFiltersNoteUpdatedAt[];
    /**
     * @stability stable
     */
    set noteUpdatedAt(value: SecurityhubInsightFiltersNoteUpdatedAt[]);
    /**
     * @stability stable
     */
    resetNoteUpdatedAt(): void;
    /**
     * @stability stable
     */
    get noteUpdatedAtInput(): SecurityhubInsightFiltersNoteUpdatedAt[] | undefined;
    private _noteUpdatedBy?;
    /**
     * @stability stable
     */
    get noteUpdatedBy(): SecurityhubInsightFiltersNoteUpdatedBy[];
    /**
     * @stability stable
     */
    set noteUpdatedBy(value: SecurityhubInsightFiltersNoteUpdatedBy[]);
    /**
     * @stability stable
     */
    resetNoteUpdatedBy(): void;
    /**
     * @stability stable
     */
    get noteUpdatedByInput(): SecurityhubInsightFiltersNoteUpdatedBy[] | undefined;
    private _processLaunchedAt?;
    /**
     * @stability stable
     */
    get processLaunchedAt(): SecurityhubInsightFiltersProcessLaunchedAt[];
    /**
     * @stability stable
     */
    set processLaunchedAt(value: SecurityhubInsightFiltersProcessLaunchedAt[]);
    /**
     * @stability stable
     */
    resetProcessLaunchedAt(): void;
    /**
     * @stability stable
     */
    get processLaunchedAtInput(): SecurityhubInsightFiltersProcessLaunchedAt[] | undefined;
    private _processName?;
    /**
     * @stability stable
     */
    get processName(): SecurityhubInsightFiltersProcessName[];
    /**
     * @stability stable
     */
    set processName(value: SecurityhubInsightFiltersProcessName[]);
    /**
     * @stability stable
     */
    resetProcessName(): void;
    /**
     * @stability stable
     */
    get processNameInput(): SecurityhubInsightFiltersProcessName[] | undefined;
    private _processParentPid?;
    /**
     * @stability stable
     */
    get processParentPid(): SecurityhubInsightFiltersProcessParentPid[];
    /**
     * @stability stable
     */
    set processParentPid(value: SecurityhubInsightFiltersProcessParentPid[]);
    /**
     * @stability stable
     */
    resetProcessParentPid(): void;
    /**
     * @stability stable
     */
    get processParentPidInput(): SecurityhubInsightFiltersProcessParentPid[] | undefined;
    private _processPath?;
    /**
     * @stability stable
     */
    get processPath(): SecurityhubInsightFiltersProcessPath[];
    /**
     * @stability stable
     */
    set processPath(value: SecurityhubInsightFiltersProcessPath[]);
    /**
     * @stability stable
     */
    resetProcessPath(): void;
    /**
     * @stability stable
     */
    get processPathInput(): SecurityhubInsightFiltersProcessPath[] | undefined;
    private _processPid?;
    /**
     * @stability stable
     */
    get processPid(): SecurityhubInsightFiltersProcessPid[];
    /**
     * @stability stable
     */
    set processPid(value: SecurityhubInsightFiltersProcessPid[]);
    /**
     * @stability stable
     */
    resetProcessPid(): void;
    /**
     * @stability stable
     */
    get processPidInput(): SecurityhubInsightFiltersProcessPid[] | undefined;
    private _processTerminatedAt?;
    /**
     * @stability stable
     */
    get processTerminatedAt(): SecurityhubInsightFiltersProcessTerminatedAt[];
    /**
     * @stability stable
     */
    set processTerminatedAt(value: SecurityhubInsightFiltersProcessTerminatedAt[]);
    /**
     * @stability stable
     */
    resetProcessTerminatedAt(): void;
    /**
     * @stability stable
     */
    get processTerminatedAtInput(): SecurityhubInsightFiltersProcessTerminatedAt[] | undefined;
    private _productArn?;
    /**
     * @stability stable
     */
    get productArn(): SecurityhubInsightFiltersProductArn[];
    /**
     * @stability stable
     */
    set productArn(value: SecurityhubInsightFiltersProductArn[]);
    /**
     * @stability stable
     */
    resetProductArn(): void;
    /**
     * @stability stable
     */
    get productArnInput(): SecurityhubInsightFiltersProductArn[] | undefined;
    private _productFields?;
    /**
     * @stability stable
     */
    get productFields(): SecurityhubInsightFiltersProductFields[];
    /**
     * @stability stable
     */
    set productFields(value: SecurityhubInsightFiltersProductFields[]);
    /**
     * @stability stable
     */
    resetProductFields(): void;
    /**
     * @stability stable
     */
    get productFieldsInput(): SecurityhubInsightFiltersProductFields[] | undefined;
    private _productName?;
    /**
     * @stability stable
     */
    get productName(): SecurityhubInsightFiltersProductName[];
    /**
     * @stability stable
     */
    set productName(value: SecurityhubInsightFiltersProductName[]);
    /**
     * @stability stable
     */
    resetProductName(): void;
    /**
     * @stability stable
     */
    get productNameInput(): SecurityhubInsightFiltersProductName[] | undefined;
    private _recommendationText?;
    /**
     * @stability stable
     */
    get recommendationText(): SecurityhubInsightFiltersRecommendationText[];
    /**
     * @stability stable
     */
    set recommendationText(value: SecurityhubInsightFiltersRecommendationText[]);
    /**
     * @stability stable
     */
    resetRecommendationText(): void;
    /**
     * @stability stable
     */
    get recommendationTextInput(): SecurityhubInsightFiltersRecommendationText[] | undefined;
    private _recordState?;
    /**
     * @stability stable
     */
    get recordState(): SecurityhubInsightFiltersRecordState[];
    /**
     * @stability stable
     */
    set recordState(value: SecurityhubInsightFiltersRecordState[]);
    /**
     * @stability stable
     */
    resetRecordState(): void;
    /**
     * @stability stable
     */
    get recordStateInput(): SecurityhubInsightFiltersRecordState[] | undefined;
    private _relatedFindingsId?;
    /**
     * @stability stable
     */
    get relatedFindingsId(): SecurityhubInsightFiltersRelatedFindingsId[];
    /**
     * @stability stable
     */
    set relatedFindingsId(value: SecurityhubInsightFiltersRelatedFindingsId[]);
    /**
     * @stability stable
     */
    resetRelatedFindingsId(): void;
    /**
     * @stability stable
     */
    get relatedFindingsIdInput(): SecurityhubInsightFiltersRelatedFindingsId[] | undefined;
    private _relatedFindingsProductArn?;
    /**
     * @stability stable
     */
    get relatedFindingsProductArn(): SecurityhubInsightFiltersRelatedFindingsProductArn[];
    /**
     * @stability stable
     */
    set relatedFindingsProductArn(value: SecurityhubInsightFiltersRelatedFindingsProductArn[]);
    /**
     * @stability stable
     */
    resetRelatedFindingsProductArn(): void;
    /**
     * @stability stable
     */
    get relatedFindingsProductArnInput(): SecurityhubInsightFiltersRelatedFindingsProductArn[] | undefined;
    private _resourceAwsEc2InstanceIamInstanceProfileArn?;
    /**
     * @stability stable
     */
    get resourceAwsEc2InstanceIamInstanceProfileArn(): SecurityhubInsightFiltersResourceAwsEc2InstanceIamInstanceProfileArn[];
    /**
     * @stability stable
     */
    set resourceAwsEc2InstanceIamInstanceProfileArn(value: SecurityhubInsightFiltersResourceAwsEc2InstanceIamInstanceProfileArn[]);
    /**
     * @stability stable
     */
    resetResourceAwsEc2InstanceIamInstanceProfileArn(): void;
    /**
     * @stability stable
     */
    get resourceAwsEc2InstanceIamInstanceProfileArnInput(): SecurityhubInsightFiltersResourceAwsEc2InstanceIamInstanceProfileArn[] | undefined;
    private _resourceAwsEc2InstanceImageId?;
    /**
     * @stability stable
     */
    get resourceAwsEc2InstanceImageId(): SecurityhubInsightFiltersResourceAwsEc2InstanceImageId[];
    /**
     * @stability stable
     */
    set resourceAwsEc2InstanceImageId(value: SecurityhubInsightFiltersResourceAwsEc2InstanceImageId[]);
    /**
     * @stability stable
     */
    resetResourceAwsEc2InstanceImageId(): void;
    /**
     * @stability stable
     */
    get resourceAwsEc2InstanceImageIdInput(): SecurityhubInsightFiltersResourceAwsEc2InstanceImageId[] | undefined;
    private _resourceAwsEc2InstanceIpv4Addresses?;
    /**
     * @stability stable
     */
    get resourceAwsEc2InstanceIpv4Addresses(): SecurityhubInsightFiltersResourceAwsEc2InstanceIpv4Addresses[];
    /**
     * @stability stable
     */
    set resourceAwsEc2InstanceIpv4Addresses(value: SecurityhubInsightFiltersResourceAwsEc2InstanceIpv4Addresses[]);
    /**
     * @stability stable
     */
    resetResourceAwsEc2InstanceIpv4Addresses(): void;
    /**
     * @stability stable
     */
    get resourceAwsEc2InstanceIpv4AddressesInput(): SecurityhubInsightFiltersResourceAwsEc2InstanceIpv4Addresses[] | undefined;
    private _resourceAwsEc2InstanceIpv6Addresses?;
    /**
     * @stability stable
     */
    get resourceAwsEc2InstanceIpv6Addresses(): SecurityhubInsightFiltersResourceAwsEc2InstanceIpv6Addresses[];
    /**
     * @stability stable
     */
    set resourceAwsEc2InstanceIpv6Addresses(value: SecurityhubInsightFiltersResourceAwsEc2InstanceIpv6Addresses[]);
    /**
     * @stability stable
     */
    resetResourceAwsEc2InstanceIpv6Addresses(): void;
    /**
     * @stability stable
     */
    get resourceAwsEc2InstanceIpv6AddressesInput(): SecurityhubInsightFiltersResourceAwsEc2InstanceIpv6Addresses[] | undefined;
    private _resourceAwsEc2InstanceKeyName?;
    /**
     * @stability stable
     */
    get resourceAwsEc2InstanceKeyName(): SecurityhubInsightFiltersResourceAwsEc2InstanceKeyName[];
    /**
     * @stability stable
     */
    set resourceAwsEc2InstanceKeyName(value: SecurityhubInsightFiltersResourceAwsEc2InstanceKeyName[]);
    /**
     * @stability stable
     */
    resetResourceAwsEc2InstanceKeyName(): void;
    /**
     * @stability stable
     */
    get resourceAwsEc2InstanceKeyNameInput(): SecurityhubInsightFiltersResourceAwsEc2InstanceKeyName[] | undefined;
    private _resourceAwsEc2InstanceLaunchedAt?;
    /**
     * @stability stable
     */
    get resourceAwsEc2InstanceLaunchedAt(): SecurityhubInsightFiltersResourceAwsEc2InstanceLaunchedAt[];
    /**
     * @stability stable
     */
    set resourceAwsEc2InstanceLaunchedAt(value: SecurityhubInsightFiltersResourceAwsEc2InstanceLaunchedAt[]);
    /**
     * @stability stable
     */
    resetResourceAwsEc2InstanceLaunchedAt(): void;
    /**
     * @stability stable
     */
    get resourceAwsEc2InstanceLaunchedAtInput(): SecurityhubInsightFiltersResourceAwsEc2InstanceLaunchedAt[] | undefined;
    private _resourceAwsEc2InstanceSubnetId?;
    /**
     * @stability stable
     */
    get resourceAwsEc2InstanceSubnetId(): SecurityhubInsightFiltersResourceAwsEc2InstanceSubnetId[];
    /**
     * @stability stable
     */
    set resourceAwsEc2InstanceSubnetId(value: SecurityhubInsightFiltersResourceAwsEc2InstanceSubnetId[]);
    /**
     * @stability stable
     */
    resetResourceAwsEc2InstanceSubnetId(): void;
    /**
     * @stability stable
     */
    get resourceAwsEc2InstanceSubnetIdInput(): SecurityhubInsightFiltersResourceAwsEc2InstanceSubnetId[] | undefined;
    private _resourceAwsEc2InstanceType?;
    /**
     * @stability stable
     */
    get resourceAwsEc2InstanceType(): SecurityhubInsightFiltersResourceAwsEc2InstanceType[];
    /**
     * @stability stable
     */
    set resourceAwsEc2InstanceType(value: SecurityhubInsightFiltersResourceAwsEc2InstanceType[]);
    /**
     * @stability stable
     */
    resetResourceAwsEc2InstanceType(): void;
    /**
     * @stability stable
     */
    get resourceAwsEc2InstanceTypeInput(): SecurityhubInsightFiltersResourceAwsEc2InstanceType[] | undefined;
    private _resourceAwsEc2InstanceVpcId?;
    /**
     * @stability stable
     */
    get resourceAwsEc2InstanceVpcId(): SecurityhubInsightFiltersResourceAwsEc2InstanceVpcId[];
    /**
     * @stability stable
     */
    set resourceAwsEc2InstanceVpcId(value: SecurityhubInsightFiltersResourceAwsEc2InstanceVpcId[]);
    /**
     * @stability stable
     */
    resetResourceAwsEc2InstanceVpcId(): void;
    /**
     * @stability stable
     */
    get resourceAwsEc2InstanceVpcIdInput(): SecurityhubInsightFiltersResourceAwsEc2InstanceVpcId[] | undefined;
    private _resourceAwsIamAccessKeyCreatedAt?;
    /**
     * @stability stable
     */
    get resourceAwsIamAccessKeyCreatedAt(): SecurityhubInsightFiltersResourceAwsIamAccessKeyCreatedAt[];
    /**
     * @stability stable
     */
    set resourceAwsIamAccessKeyCreatedAt(value: SecurityhubInsightFiltersResourceAwsIamAccessKeyCreatedAt[]);
    /**
     * @stability stable
     */
    resetResourceAwsIamAccessKeyCreatedAt(): void;
    /**
     * @stability stable
     */
    get resourceAwsIamAccessKeyCreatedAtInput(): SecurityhubInsightFiltersResourceAwsIamAccessKeyCreatedAt[] | undefined;
    private _resourceAwsIamAccessKeyStatus?;
    /**
     * @stability stable
     */
    get resourceAwsIamAccessKeyStatus(): SecurityhubInsightFiltersResourceAwsIamAccessKeyStatus[];
    /**
     * @stability stable
     */
    set resourceAwsIamAccessKeyStatus(value: SecurityhubInsightFiltersResourceAwsIamAccessKeyStatus[]);
    /**
     * @stability stable
     */
    resetResourceAwsIamAccessKeyStatus(): void;
    /**
     * @stability stable
     */
    get resourceAwsIamAccessKeyStatusInput(): SecurityhubInsightFiltersResourceAwsIamAccessKeyStatus[] | undefined;
    private _resourceAwsIamAccessKeyUserName?;
    /**
     * @stability stable
     */
    get resourceAwsIamAccessKeyUserName(): SecurityhubInsightFiltersResourceAwsIamAccessKeyUserName[];
    /**
     * @stability stable
     */
    set resourceAwsIamAccessKeyUserName(value: SecurityhubInsightFiltersResourceAwsIamAccessKeyUserName[]);
    /**
     * @stability stable
     */
    resetResourceAwsIamAccessKeyUserName(): void;
    /**
     * @stability stable
     */
    get resourceAwsIamAccessKeyUserNameInput(): SecurityhubInsightFiltersResourceAwsIamAccessKeyUserName[] | undefined;
    private _resourceAwsS3BucketOwnerId?;
    /**
     * @stability stable
     */
    get resourceAwsS3BucketOwnerId(): SecurityhubInsightFiltersResourceAwsS3BucketOwnerId[];
    /**
     * @stability stable
     */
    set resourceAwsS3BucketOwnerId(value: SecurityhubInsightFiltersResourceAwsS3BucketOwnerId[]);
    /**
     * @stability stable
     */
    resetResourceAwsS3BucketOwnerId(): void;
    /**
     * @stability stable
     */
    get resourceAwsS3BucketOwnerIdInput(): SecurityhubInsightFiltersResourceAwsS3BucketOwnerId[] | undefined;
    private _resourceAwsS3BucketOwnerName?;
    /**
     * @stability stable
     */
    get resourceAwsS3BucketOwnerName(): SecurityhubInsightFiltersResourceAwsS3BucketOwnerName[];
    /**
     * @stability stable
     */
    set resourceAwsS3BucketOwnerName(value: SecurityhubInsightFiltersResourceAwsS3BucketOwnerName[]);
    /**
     * @stability stable
     */
    resetResourceAwsS3BucketOwnerName(): void;
    /**
     * @stability stable
     */
    get resourceAwsS3BucketOwnerNameInput(): SecurityhubInsightFiltersResourceAwsS3BucketOwnerName[] | undefined;
    private _resourceContainerImageId?;
    /**
     * @stability stable
     */
    get resourceContainerImageId(): SecurityhubInsightFiltersResourceContainerImageId[];
    /**
     * @stability stable
     */
    set resourceContainerImageId(value: SecurityhubInsightFiltersResourceContainerImageId[]);
    /**
     * @stability stable
     */
    resetResourceContainerImageId(): void;
    /**
     * @stability stable
     */
    get resourceContainerImageIdInput(): SecurityhubInsightFiltersResourceContainerImageId[] | undefined;
    private _resourceContainerImageName?;
    /**
     * @stability stable
     */
    get resourceContainerImageName(): SecurityhubInsightFiltersResourceContainerImageName[];
    /**
     * @stability stable
     */
    set resourceContainerImageName(value: SecurityhubInsightFiltersResourceContainerImageName[]);
    /**
     * @stability stable
     */
    resetResourceContainerImageName(): void;
    /**
     * @stability stable
     */
    get resourceContainerImageNameInput(): SecurityhubInsightFiltersResourceContainerImageName[] | undefined;
    private _resourceContainerLaunchedAt?;
    /**
     * @stability stable
     */
    get resourceContainerLaunchedAt(): SecurityhubInsightFiltersResourceContainerLaunchedAt[];
    /**
     * @stability stable
     */
    set resourceContainerLaunchedAt(value: SecurityhubInsightFiltersResourceContainerLaunchedAt[]);
    /**
     * @stability stable
     */
    resetResourceContainerLaunchedAt(): void;
    /**
     * @stability stable
     */
    get resourceContainerLaunchedAtInput(): SecurityhubInsightFiltersResourceContainerLaunchedAt[] | undefined;
    private _resourceContainerName?;
    /**
     * @stability stable
     */
    get resourceContainerName(): SecurityhubInsightFiltersResourceContainerName[];
    /**
     * @stability stable
     */
    set resourceContainerName(value: SecurityhubInsightFiltersResourceContainerName[]);
    /**
     * @stability stable
     */
    resetResourceContainerName(): void;
    /**
     * @stability stable
     */
    get resourceContainerNameInput(): SecurityhubInsightFiltersResourceContainerName[] | undefined;
    private _resourceDetailsOther?;
    /**
     * @stability stable
     */
    get resourceDetailsOther(): SecurityhubInsightFiltersResourceDetailsOther[];
    /**
     * @stability stable
     */
    set resourceDetailsOther(value: SecurityhubInsightFiltersResourceDetailsOther[]);
    /**
     * @stability stable
     */
    resetResourceDetailsOther(): void;
    /**
     * @stability stable
     */
    get resourceDetailsOtherInput(): SecurityhubInsightFiltersResourceDetailsOther[] | undefined;
    private _resourceId?;
    /**
     * @stability stable
     */
    get resourceId(): SecurityhubInsightFiltersResourceId[];
    /**
     * @stability stable
     */
    set resourceId(value: SecurityhubInsightFiltersResourceId[]);
    /**
     * @stability stable
     */
    resetResourceId(): void;
    /**
     * @stability stable
     */
    get resourceIdInput(): SecurityhubInsightFiltersResourceId[] | undefined;
    private _resourcePartition?;
    /**
     * @stability stable
     */
    get resourcePartition(): SecurityhubInsightFiltersResourcePartition[];
    /**
     * @stability stable
     */
    set resourcePartition(value: SecurityhubInsightFiltersResourcePartition[]);
    /**
     * @stability stable
     */
    resetResourcePartition(): void;
    /**
     * @stability stable
     */
    get resourcePartitionInput(): SecurityhubInsightFiltersResourcePartition[] | undefined;
    private _resourceRegion?;
    /**
     * @stability stable
     */
    get resourceRegion(): SecurityhubInsightFiltersResourceRegion[];
    /**
     * @stability stable
     */
    set resourceRegion(value: SecurityhubInsightFiltersResourceRegion[]);
    /**
     * @stability stable
     */
    resetResourceRegion(): void;
    /**
     * @stability stable
     */
    get resourceRegionInput(): SecurityhubInsightFiltersResourceRegion[] | undefined;
    private _resourceTags?;
    /**
     * @stability stable
     */
    get resourceTags(): SecurityhubInsightFiltersResourceTags[];
    /**
     * @stability stable
     */
    set resourceTags(value: SecurityhubInsightFiltersResourceTags[]);
    /**
     * @stability stable
     */
    resetResourceTags(): void;
    /**
     * @stability stable
     */
    get resourceTagsInput(): SecurityhubInsightFiltersResourceTags[] | undefined;
    private _resourceType?;
    /**
     * @stability stable
     */
    get resourceType(): SecurityhubInsightFiltersResourceType[];
    /**
     * @stability stable
     */
    set resourceType(value: SecurityhubInsightFiltersResourceType[]);
    /**
     * @stability stable
     */
    resetResourceType(): void;
    /**
     * @stability stable
     */
    get resourceTypeInput(): SecurityhubInsightFiltersResourceType[] | undefined;
    private _severityLabel?;
    /**
     * @stability stable
     */
    get severityLabel(): SecurityhubInsightFiltersSeverityLabel[];
    /**
     * @stability stable
     */
    set severityLabel(value: SecurityhubInsightFiltersSeverityLabel[]);
    /**
     * @stability stable
     */
    resetSeverityLabel(): void;
    /**
     * @stability stable
     */
    get severityLabelInput(): SecurityhubInsightFiltersSeverityLabel[] | undefined;
    private _sourceUrl?;
    /**
     * @stability stable
     */
    get sourceUrl(): SecurityhubInsightFiltersSourceUrl[];
    /**
     * @stability stable
     */
    set sourceUrl(value: SecurityhubInsightFiltersSourceUrl[]);
    /**
     * @stability stable
     */
    resetSourceUrl(): void;
    /**
     * @stability stable
     */
    get sourceUrlInput(): SecurityhubInsightFiltersSourceUrl[] | undefined;
    private _threatIntelIndicatorCategory?;
    /**
     * @stability stable
     */
    get threatIntelIndicatorCategory(): SecurityhubInsightFiltersThreatIntelIndicatorCategory[];
    /**
     * @stability stable
     */
    set threatIntelIndicatorCategory(value: SecurityhubInsightFiltersThreatIntelIndicatorCategory[]);
    /**
     * @stability stable
     */
    resetThreatIntelIndicatorCategory(): void;
    /**
     * @stability stable
     */
    get threatIntelIndicatorCategoryInput(): SecurityhubInsightFiltersThreatIntelIndicatorCategory[] | undefined;
    private _threatIntelIndicatorLastObservedAt?;
    /**
     * @stability stable
     */
    get threatIntelIndicatorLastObservedAt(): SecurityhubInsightFiltersThreatIntelIndicatorLastObservedAt[];
    /**
     * @stability stable
     */
    set threatIntelIndicatorLastObservedAt(value: SecurityhubInsightFiltersThreatIntelIndicatorLastObservedAt[]);
    /**
     * @stability stable
     */
    resetThreatIntelIndicatorLastObservedAt(): void;
    /**
     * @stability stable
     */
    get threatIntelIndicatorLastObservedAtInput(): SecurityhubInsightFiltersThreatIntelIndicatorLastObservedAt[] | undefined;
    private _threatIntelIndicatorSource?;
    /**
     * @stability stable
     */
    get threatIntelIndicatorSource(): SecurityhubInsightFiltersThreatIntelIndicatorSource[];
    /**
     * @stability stable
     */
    set threatIntelIndicatorSource(value: SecurityhubInsightFiltersThreatIntelIndicatorSource[]);
    /**
     * @stability stable
     */
    resetThreatIntelIndicatorSource(): void;
    /**
     * @stability stable
     */
    get threatIntelIndicatorSourceInput(): SecurityhubInsightFiltersThreatIntelIndicatorSource[] | undefined;
    private _threatIntelIndicatorSourceUrl?;
    /**
     * @stability stable
     */
    get threatIntelIndicatorSourceUrl(): SecurityhubInsightFiltersThreatIntelIndicatorSourceUrl[];
    /**
     * @stability stable
     */
    set threatIntelIndicatorSourceUrl(value: SecurityhubInsightFiltersThreatIntelIndicatorSourceUrl[]);
    /**
     * @stability stable
     */
    resetThreatIntelIndicatorSourceUrl(): void;
    /**
     * @stability stable
     */
    get threatIntelIndicatorSourceUrlInput(): SecurityhubInsightFiltersThreatIntelIndicatorSourceUrl[] | undefined;
    private _threatIntelIndicatorType?;
    /**
     * @stability stable
     */
    get threatIntelIndicatorType(): SecurityhubInsightFiltersThreatIntelIndicatorType[];
    /**
     * @stability stable
     */
    set threatIntelIndicatorType(value: SecurityhubInsightFiltersThreatIntelIndicatorType[]);
    /**
     * @stability stable
     */
    resetThreatIntelIndicatorType(): void;
    /**
     * @stability stable
     */
    get threatIntelIndicatorTypeInput(): SecurityhubInsightFiltersThreatIntelIndicatorType[] | undefined;
    private _threatIntelIndicatorValue?;
    /**
     * @stability stable
     */
    get threatIntelIndicatorValue(): SecurityhubInsightFiltersThreatIntelIndicatorValue[];
    /**
     * @stability stable
     */
    set threatIntelIndicatorValue(value: SecurityhubInsightFiltersThreatIntelIndicatorValue[]);
    /**
     * @stability stable
     */
    resetThreatIntelIndicatorValue(): void;
    /**
     * @stability stable
     */
    get threatIntelIndicatorValueInput(): SecurityhubInsightFiltersThreatIntelIndicatorValue[] | undefined;
    private _title?;
    /**
     * @stability stable
     */
    get title(): SecurityhubInsightFiltersTitle[];
    /**
     * @stability stable
     */
    set title(value: SecurityhubInsightFiltersTitle[]);
    /**
     * @stability stable
     */
    resetTitle(): void;
    /**
     * @stability stable
     */
    get titleInput(): SecurityhubInsightFiltersTitle[] | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): SecurityhubInsightFiltersType[];
    /**
     * @stability stable
     */
    set type(value: SecurityhubInsightFiltersType[]);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): SecurityhubInsightFiltersType[] | undefined;
    private _updatedAt?;
    /**
     * @stability stable
     */
    get updatedAt(): SecurityhubInsightFiltersUpdatedAt[];
    /**
     * @stability stable
     */
    set updatedAt(value: SecurityhubInsightFiltersUpdatedAt[]);
    /**
     * @stability stable
     */
    resetUpdatedAt(): void;
    /**
     * @stability stable
     */
    get updatedAtInput(): SecurityhubInsightFiltersUpdatedAt[] | undefined;
    private _userDefinedValues?;
    /**
     * @stability stable
     */
    get userDefinedValues(): SecurityhubInsightFiltersUserDefinedValues[];
    /**
     * @stability stable
     */
    set userDefinedValues(value: SecurityhubInsightFiltersUserDefinedValues[]);
    /**
     * @stability stable
     */
    resetUserDefinedValues(): void;
    /**
     * @stability stable
     */
    get userDefinedValuesInput(): SecurityhubInsightFiltersUserDefinedValues[] | undefined;
    private _verificationState?;
    /**
     * @stability stable
     */
    get verificationState(): SecurityhubInsightFiltersVerificationState[];
    /**
     * @stability stable
     */
    set verificationState(value: SecurityhubInsightFiltersVerificationState[]);
    /**
     * @stability stable
     */
    resetVerificationState(): void;
    /**
     * @stability stable
     */
    get verificationStateInput(): SecurityhubInsightFiltersVerificationState[] | undefined;
    private _workflowStatus?;
    /**
     * @stability stable
     */
    get workflowStatus(): SecurityhubInsightFiltersWorkflowStatus[];
    /**
     * @stability stable
     */
    set workflowStatus(value: SecurityhubInsightFiltersWorkflowStatus[]);
    /**
     * @stability stable
     */
    resetWorkflowStatus(): void;
    /**
     * @stability stable
     */
    get workflowStatusInput(): SecurityhubInsightFiltersWorkflowStatus[] | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight aws_securityhub_insight}.
 *
 * @stability stable
 */
export declare class SecurityhubInsight extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/securityhub_insight aws_securityhub_insight} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SecurityhubInsightConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _groupByAttribute?;
    /**
     * @stability stable
     */
    get groupByAttribute(): string;
    /**
     * @stability stable
     */
    set groupByAttribute(value: string);
    /**
     * @stability stable
     */
    get groupByAttributeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _filters;
    /**
     * @stability stable
     */
    get filters(): SecurityhubInsightFiltersOutputReference;
    /**
     * @stability stable
     */
    putFilters(value: SecurityhubInsightFilters): void;
    /**
     * @stability stable
     */
    get filtersInput(): SecurityhubInsightFilters | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
