import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Service Catalog.
 *
 * @stability stable
 */
export interface ServicecatalogProvisionedProductConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#accept_language ServicecatalogProvisionedProduct#accept_language}.
     *
     * @stability stable
     */
    readonly acceptLanguage?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#ignore_errors ServicecatalogProvisionedProduct#ignore_errors}.
     *
     * @stability stable
     */
    readonly ignoreErrors?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#name ServicecatalogProvisionedProduct#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#notification_arns ServicecatalogProvisionedProduct#notification_arns}.
     *
     * @stability stable
     */
    readonly notificationArns?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#path_id ServicecatalogProvisionedProduct#path_id}.
     *
     * @stability stable
     */
    readonly pathId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#path_name ServicecatalogProvisionedProduct#path_name}.
     *
     * @stability stable
     */
    readonly pathName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#product_id ServicecatalogProvisionedProduct#product_id}.
     *
     * @stability stable
     */
    readonly productId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#product_name ServicecatalogProvisionedProduct#product_name}.
     *
     * @stability stable
     */
    readonly productName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#provisioning_artifact_id ServicecatalogProvisionedProduct#provisioning_artifact_id}.
     *
     * @stability stable
     */
    readonly provisioningArtifactId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#provisioning_artifact_name ServicecatalogProvisionedProduct#provisioning_artifact_name}.
     *
     * @stability stable
     */
    readonly provisioningArtifactName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#retain_physical_resources ServicecatalogProvisionedProduct#retain_physical_resources}.
     *
     * @stability stable
     */
    readonly retainPhysicalResources?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#tags ServicecatalogProvisionedProduct#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#tags_all ServicecatalogProvisionedProduct#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * provisioning_parameters block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#provisioning_parameters ServicecatalogProvisionedProduct#provisioning_parameters}
     *
     * @stability stable
     */
    readonly provisioningParameters?: ServicecatalogProvisionedProductProvisioningParameters[];
    /**
     * stack_set_provisioning_preferences block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#stack_set_provisioning_preferences ServicecatalogProvisionedProduct#stack_set_provisioning_preferences}
     *
     * @stability stable
     */
    readonly stackSetProvisioningPreferences?: ServicecatalogProvisionedProductStackSetProvisioningPreferences;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#timeouts ServicecatalogProvisionedProduct#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: ServicecatalogProvisionedProductTimeouts;
}
/**
 * @stability stable
 */
export interface ServicecatalogProvisionedProductProvisioningParameters {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#key ServicecatalogProvisionedProduct#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#use_previous_value ServicecatalogProvisionedProduct#use_previous_value}.
     *
     * @stability stable
     */
    readonly usePreviousValue?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#value ServicecatalogProvisionedProduct#value}.
     *
     * @stability stable
     */
    readonly value?: string;
}
export declare function servicecatalogProvisionedProductProvisioningParametersToTerraform(struct?: ServicecatalogProvisionedProductProvisioningParameters): any;
/**
 * @stability stable
 */
export interface ServicecatalogProvisionedProductStackSetProvisioningPreferences {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#accounts ServicecatalogProvisionedProduct#accounts}.
     *
     * @stability stable
     */
    readonly accounts?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#failure_tolerance_count ServicecatalogProvisionedProduct#failure_tolerance_count}.
     *
     * @stability stable
     */
    readonly failureToleranceCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#failure_tolerance_percentage ServicecatalogProvisionedProduct#failure_tolerance_percentage}.
     *
     * @stability stable
     */
    readonly failureTolerancePercentage?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#max_concurrency_count ServicecatalogProvisionedProduct#max_concurrency_count}.
     *
     * @stability stable
     */
    readonly maxConcurrencyCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#max_concurrency_percentage ServicecatalogProvisionedProduct#max_concurrency_percentage}.
     *
     * @stability stable
     */
    readonly maxConcurrencyPercentage?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#regions ServicecatalogProvisionedProduct#regions}.
     *
     * @stability stable
     */
    readonly regions?: string[];
}
export declare function servicecatalogProvisionedProductStackSetProvisioningPreferencesToTerraform(struct?: ServicecatalogProvisionedProductStackSetProvisioningPreferencesOutputReference | ServicecatalogProvisionedProductStackSetProvisioningPreferences): any;
/**
 * @stability stable
 */
export declare class ServicecatalogProvisionedProductStackSetProvisioningPreferencesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): ServicecatalogProvisionedProductStackSetProvisioningPreferences | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: ServicecatalogProvisionedProductStackSetProvisioningPreferences | undefined);
    private _accounts?;
    /**
     * @stability stable
     */
    get accounts(): string[];
    /**
     * @stability stable
     */
    set accounts(value: string[]);
    /**
     * @stability stable
     */
    resetAccounts(): void;
    /**
     * @stability stable
     */
    get accountsInput(): string[] | undefined;
    private _failureToleranceCount?;
    /**
     * @stability stable
     */
    get failureToleranceCount(): number;
    /**
     * @stability stable
     */
    set failureToleranceCount(value: number);
    /**
     * @stability stable
     */
    resetFailureToleranceCount(): void;
    /**
     * @stability stable
     */
    get failureToleranceCountInput(): number | undefined;
    private _failureTolerancePercentage?;
    /**
     * @stability stable
     */
    get failureTolerancePercentage(): number;
    /**
     * @stability stable
     */
    set failureTolerancePercentage(value: number);
    /**
     * @stability stable
     */
    resetFailureTolerancePercentage(): void;
    /**
     * @stability stable
     */
    get failureTolerancePercentageInput(): number | undefined;
    private _maxConcurrencyCount?;
    /**
     * @stability stable
     */
    get maxConcurrencyCount(): number;
    /**
     * @stability stable
     */
    set maxConcurrencyCount(value: number);
    /**
     * @stability stable
     */
    resetMaxConcurrencyCount(): void;
    /**
     * @stability stable
     */
    get maxConcurrencyCountInput(): number | undefined;
    private _maxConcurrencyPercentage?;
    /**
     * @stability stable
     */
    get maxConcurrencyPercentage(): number;
    /**
     * @stability stable
     */
    set maxConcurrencyPercentage(value: number);
    /**
     * @stability stable
     */
    resetMaxConcurrencyPercentage(): void;
    /**
     * @stability stable
     */
    get maxConcurrencyPercentageInput(): number | undefined;
    private _regions?;
    /**
     * @stability stable
     */
    get regions(): string[];
    /**
     * @stability stable
     */
    set regions(value: string[]);
    /**
     * @stability stable
     */
    resetRegions(): void;
    /**
     * @stability stable
     */
    get regionsInput(): string[] | undefined;
}
/**
 * @stability stable
 */
export interface ServicecatalogProvisionedProductTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#create ServicecatalogProvisionedProduct#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#delete ServicecatalogProvisionedProduct#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product#update ServicecatalogProvisionedProduct#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function servicecatalogProvisionedProductTimeoutsToTerraform(struct?: ServicecatalogProvisionedProductTimeoutsOutputReference | ServicecatalogProvisionedProductTimeouts): any;
/**
 * @stability stable
 */
export declare class ServicecatalogProvisionedProductTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): ServicecatalogProvisionedProductTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: ServicecatalogProvisionedProductTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product aws_servicecatalog_provisioned_product}.
 *
 * @stability stable
 */
export declare class ServicecatalogProvisionedProduct extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/servicecatalog_provisioned_product aws_servicecatalog_provisioned_product} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ServicecatalogProvisionedProductConfig);
    private _acceptLanguage?;
    /**
     * @stability stable
     */
    get acceptLanguage(): string;
    /**
     * @stability stable
     */
    set acceptLanguage(value: string);
    /**
     * @stability stable
     */
    resetAcceptLanguage(): void;
    /**
     * @stability stable
     */
    get acceptLanguageInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get cloudwatchDashboardNames(): string[];
    /**
     * @stability stable
     */
    get createdTime(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _ignoreErrors?;
    /**
     * @stability stable
     */
    get ignoreErrors(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set ignoreErrors(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetIgnoreErrors(): void;
    /**
     * @stability stable
     */
    get ignoreErrorsInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get lastProvisioningRecordId(): string;
    /**
     * @stability stable
     */
    get lastRecordId(): string;
    /**
     * @stability stable
     */
    get lastSuccessfulProvisioningRecordId(): string;
    /**
     * @stability stable
     */
    get launchRoleArn(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _notificationArns?;
    /**
     * @stability stable
     */
    get notificationArns(): string[];
    /**
     * @stability stable
     */
    set notificationArns(value: string[]);
    /**
     * @stability stable
     */
    resetNotificationArns(): void;
    /**
     * @stability stable
     */
    get notificationArnsInput(): string[] | undefined;
    private _pathId?;
    /**
     * @stability stable
     */
    get pathId(): string;
    /**
     * @stability stable
     */
    set pathId(value: string);
    /**
     * @stability stable
     */
    resetPathId(): void;
    /**
     * @stability stable
     */
    get pathIdInput(): string | undefined;
    private _pathName?;
    /**
     * @stability stable
     */
    get pathName(): string;
    /**
     * @stability stable
     */
    set pathName(value: string);
    /**
     * @stability stable
     */
    resetPathName(): void;
    /**
     * @stability stable
     */
    get pathNameInput(): string | undefined;
    private _productId?;
    /**
     * @stability stable
     */
    get productId(): string;
    /**
     * @stability stable
     */
    set productId(value: string);
    /**
     * @stability stable
     */
    resetProductId(): void;
    /**
     * @stability stable
     */
    get productIdInput(): string | undefined;
    private _productName?;
    /**
     * @stability stable
     */
    get productName(): string;
    /**
     * @stability stable
     */
    set productName(value: string);
    /**
     * @stability stable
     */
    resetProductName(): void;
    /**
     * @stability stable
     */
    get productNameInput(): string | undefined;
    private _provisioningArtifactId?;
    /**
     * @stability stable
     */
    get provisioningArtifactId(): string;
    /**
     * @stability stable
     */
    set provisioningArtifactId(value: string);
    /**
     * @stability stable
     */
    resetProvisioningArtifactId(): void;
    /**
     * @stability stable
     */
    get provisioningArtifactIdInput(): string | undefined;
    private _provisioningArtifactName?;
    /**
     * @stability stable
     */
    get provisioningArtifactName(): string;
    /**
     * @stability stable
     */
    set provisioningArtifactName(value: string);
    /**
     * @stability stable
     */
    resetProvisioningArtifactName(): void;
    /**
     * @stability stable
     */
    get provisioningArtifactNameInput(): string | undefined;
    private _retainPhysicalResources?;
    /**
     * @stability stable
     */
    get retainPhysicalResources(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set retainPhysicalResources(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetRetainPhysicalResources(): void;
    /**
     * @stability stable
     */
    get retainPhysicalResourcesInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    get statusMessage(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get type(): string;
    private _provisioningParameters?;
    /**
     * @stability stable
     */
    get provisioningParameters(): ServicecatalogProvisionedProductProvisioningParameters[];
    /**
     * @stability stable
     */
    set provisioningParameters(value: ServicecatalogProvisionedProductProvisioningParameters[]);
    /**
     * @stability stable
     */
    resetProvisioningParameters(): void;
    /**
     * @stability stable
     */
    get provisioningParametersInput(): ServicecatalogProvisionedProductProvisioningParameters[] | undefined;
    private _stackSetProvisioningPreferences;
    /**
     * @stability stable
     */
    get stackSetProvisioningPreferences(): ServicecatalogProvisionedProductStackSetProvisioningPreferencesOutputReference;
    /**
     * @stability stable
     */
    putStackSetProvisioningPreferences(value: ServicecatalogProvisionedProductStackSetProvisioningPreferences): void;
    /**
     * @stability stable
     */
    resetStackSetProvisioningPreferences(): void;
    /**
     * @stability stable
     */
    get stackSetProvisioningPreferencesInput(): ServicecatalogProvisionedProductStackSetProvisioningPreferences | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): ServicecatalogProvisionedProductTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: ServicecatalogProvisionedProductTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): ServicecatalogProvisionedProductTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
