import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Service Quotas.
 *
 * @stability stable
 */
export interface DataAwsServicequotasServiceQuotaConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicequotas_service_quota#quota_code DataAwsServicequotasServiceQuota#quota_code}.
     *
     * @stability stable
     */
    readonly quotaCode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicequotas_service_quota#quota_name DataAwsServicequotasServiceQuota#quota_name}.
     *
     * @stability stable
     */
    readonly quotaName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/servicequotas_service_quota#service_code DataAwsServicequotasServiceQuota#service_code}.
     *
     * @stability stable
     */
    readonly serviceCode: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/servicequotas_service_quota aws_servicequotas_service_quota}.
 *
 * @stability stable
 */
export declare class DataAwsServicequotasServiceQuota extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/servicequotas_service_quota aws_servicequotas_service_quota} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsServicequotasServiceQuotaConfig);
    /**
     * @stability stable
     */
    get adjustable(): any;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get defaultValue(): number;
    /**
     * @stability stable
     */
    get globalQuota(): any;
    /**
     * @stability stable
     */
    get id(): string;
    private _quotaCode?;
    /**
     * @stability stable
     */
    get quotaCode(): string;
    /**
     * @stability stable
     */
    set quotaCode(value: string);
    /**
     * @stability stable
     */
    resetQuotaCode(): void;
    /**
     * @stability stable
     */
    get quotaCodeInput(): string | undefined;
    private _quotaName?;
    /**
     * @stability stable
     */
    get quotaName(): string;
    /**
     * @stability stable
     */
    set quotaName(value: string);
    /**
     * @stability stable
     */
    resetQuotaName(): void;
    /**
     * @stability stable
     */
    get quotaNameInput(): string | undefined;
    private _serviceCode?;
    /**
     * @stability stable
     */
    get serviceCode(): string;
    /**
     * @stability stable
     */
    set serviceCode(value: string);
    /**
     * @stability stable
     */
    get serviceCodeInput(): string | undefined;
    /**
     * @stability stable
     */
    get serviceName(): string;
    /**
     * @stability stable
     */
    get value(): number;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
