import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Signer.
 *
 * @stability stable
 */
export interface DataAwsSignerSigningJobConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/signer_signing_job#job_id DataAwsSignerSigningJob#job_id}.
     *
     * @stability stable
     */
    readonly jobId: string;
}
/**
 * @stability stable
 */
export declare class DataAwsSignerSigningJobRevocationRecord extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get reason(): string;
    /**
     * @stability stable
     */
    get revokedAt(): string;
    /**
     * @stability stable
     */
    get revokedBy(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsSignerSigningJobSignedObjectS3 extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get bucket(): string;
    /**
     * @stability stable
     */
    get key(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsSignerSigningJobSignedObject extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get s3(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsSignerSigningJobSourceS3 extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get bucket(): string;
    /**
     * @stability stable
     */
    get key(): string;
    /**
     * @stability stable
     */
    get version(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsSignerSigningJobSource extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get s3(): any;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/signer_signing_job aws_signer_signing_job}.
 *
 * @stability stable
 */
export declare class DataAwsSignerSigningJob extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/signer_signing_job aws_signer_signing_job} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsSignerSigningJobConfig);
    /**
     * @stability stable
     */
    get completedAt(): string;
    /**
     * @stability stable
     */
    get createdAt(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _jobId?;
    /**
     * @stability stable
     */
    get jobId(): string;
    /**
     * @stability stable
     */
    set jobId(value: string);
    /**
     * @stability stable
     */
    get jobIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get jobInvoker(): string;
    /**
     * @stability stable
     */
    get jobOwner(): string;
    /**
     * @stability stable
     */
    get platformDisplayName(): string;
    /**
     * @stability stable
     */
    get platformId(): string;
    /**
     * @stability stable
     */
    get profileName(): string;
    /**
     * @stability stable
     */
    get profileVersion(): string;
    /**
     * @stability stable
     */
    get requestedBy(): string;
    /**
     * @stability stable
     */
    revocationRecord(index: string): DataAwsSignerSigningJobRevocationRecord;
    /**
     * @stability stable
     */
    get signatureExpiresAt(): string;
    /**
     * @stability stable
     */
    signedObject(index: string): DataAwsSignerSigningJobSignedObject;
    /**
     * @stability stable
     */
    source(index: string): DataAwsSignerSigningJobSource;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    get statusReason(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
