import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Simple Notification Service.
 *
 * @stability stable
 */
export interface SnsTopicConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#application_failure_feedback_role_arn SnsTopic#application_failure_feedback_role_arn}.
     *
     * @stability stable
     */
    readonly applicationFailureFeedbackRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#application_success_feedback_role_arn SnsTopic#application_success_feedback_role_arn}.
     *
     * @stability stable
     */
    readonly applicationSuccessFeedbackRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#application_success_feedback_sample_rate SnsTopic#application_success_feedback_sample_rate}.
     *
     * @stability stable
     */
    readonly applicationSuccessFeedbackSampleRate?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#content_based_deduplication SnsTopic#content_based_deduplication}.
     *
     * @stability stable
     */
    readonly contentBasedDeduplication?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#delivery_policy SnsTopic#delivery_policy}.
     *
     * @stability stable
     */
    readonly deliveryPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#display_name SnsTopic#display_name}.
     *
     * @stability stable
     */
    readonly displayName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#fifo_topic SnsTopic#fifo_topic}.
     *
     * @stability stable
     */
    readonly fifoTopic?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#firehose_failure_feedback_role_arn SnsTopic#firehose_failure_feedback_role_arn}.
     *
     * @stability stable
     */
    readonly firehoseFailureFeedbackRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#firehose_success_feedback_role_arn SnsTopic#firehose_success_feedback_role_arn}.
     *
     * @stability stable
     */
    readonly firehoseSuccessFeedbackRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#firehose_success_feedback_sample_rate SnsTopic#firehose_success_feedback_sample_rate}.
     *
     * @stability stable
     */
    readonly firehoseSuccessFeedbackSampleRate?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#http_failure_feedback_role_arn SnsTopic#http_failure_feedback_role_arn}.
     *
     * @stability stable
     */
    readonly httpFailureFeedbackRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#http_success_feedback_role_arn SnsTopic#http_success_feedback_role_arn}.
     *
     * @stability stable
     */
    readonly httpSuccessFeedbackRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#http_success_feedback_sample_rate SnsTopic#http_success_feedback_sample_rate}.
     *
     * @stability stable
     */
    readonly httpSuccessFeedbackSampleRate?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#kms_master_key_id SnsTopic#kms_master_key_id}.
     *
     * @stability stable
     */
    readonly kmsMasterKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#lambda_failure_feedback_role_arn SnsTopic#lambda_failure_feedback_role_arn}.
     *
     * @stability stable
     */
    readonly lambdaFailureFeedbackRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#lambda_success_feedback_role_arn SnsTopic#lambda_success_feedback_role_arn}.
     *
     * @stability stable
     */
    readonly lambdaSuccessFeedbackRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#lambda_success_feedback_sample_rate SnsTopic#lambda_success_feedback_sample_rate}.
     *
     * @stability stable
     */
    readonly lambdaSuccessFeedbackSampleRate?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#name SnsTopic#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#name_prefix SnsTopic#name_prefix}.
     *
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#policy SnsTopic#policy}.
     *
     * @stability stable
     */
    readonly policy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#sqs_failure_feedback_role_arn SnsTopic#sqs_failure_feedback_role_arn}.
     *
     * @stability stable
     */
    readonly sqsFailureFeedbackRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#sqs_success_feedback_role_arn SnsTopic#sqs_success_feedback_role_arn}.
     *
     * @stability stable
     */
    readonly sqsSuccessFeedbackRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#sqs_success_feedback_sample_rate SnsTopic#sqs_success_feedback_sample_rate}.
     *
     * @stability stable
     */
    readonly sqsSuccessFeedbackSampleRate?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#tags SnsTopic#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_topic#tags_all SnsTopic#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sns_topic aws_sns_topic}.
 *
 * @stability stable
 */
export declare class SnsTopic extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sns_topic aws_sns_topic} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: SnsTopicConfig);
    private _applicationFailureFeedbackRoleArn?;
    /**
     * @stability stable
     */
    get applicationFailureFeedbackRoleArn(): string;
    /**
     * @stability stable
     */
    set applicationFailureFeedbackRoleArn(value: string);
    /**
     * @stability stable
     */
    resetApplicationFailureFeedbackRoleArn(): void;
    /**
     * @stability stable
     */
    get applicationFailureFeedbackRoleArnInput(): string | undefined;
    private _applicationSuccessFeedbackRoleArn?;
    /**
     * @stability stable
     */
    get applicationSuccessFeedbackRoleArn(): string;
    /**
     * @stability stable
     */
    set applicationSuccessFeedbackRoleArn(value: string);
    /**
     * @stability stable
     */
    resetApplicationSuccessFeedbackRoleArn(): void;
    /**
     * @stability stable
     */
    get applicationSuccessFeedbackRoleArnInput(): string | undefined;
    private _applicationSuccessFeedbackSampleRate?;
    /**
     * @stability stable
     */
    get applicationSuccessFeedbackSampleRate(): number;
    /**
     * @stability stable
     */
    set applicationSuccessFeedbackSampleRate(value: number);
    /**
     * @stability stable
     */
    resetApplicationSuccessFeedbackSampleRate(): void;
    /**
     * @stability stable
     */
    get applicationSuccessFeedbackSampleRateInput(): number | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _contentBasedDeduplication?;
    /**
     * @stability stable
     */
    get contentBasedDeduplication(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set contentBasedDeduplication(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetContentBasedDeduplication(): void;
    /**
     * @stability stable
     */
    get contentBasedDeduplicationInput(): boolean | cdktf.IResolvable | undefined;
    private _deliveryPolicy?;
    /**
     * @stability stable
     */
    get deliveryPolicy(): string;
    /**
     * @stability stable
     */
    set deliveryPolicy(value: string);
    /**
     * @stability stable
     */
    resetDeliveryPolicy(): void;
    /**
     * @stability stable
     */
    get deliveryPolicyInput(): string | undefined;
    private _displayName?;
    /**
     * @stability stable
     */
    get displayName(): string;
    /**
     * @stability stable
     */
    set displayName(value: string);
    /**
     * @stability stable
     */
    resetDisplayName(): void;
    /**
     * @stability stable
     */
    get displayNameInput(): string | undefined;
    private _fifoTopic?;
    /**
     * @stability stable
     */
    get fifoTopic(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set fifoTopic(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetFifoTopic(): void;
    /**
     * @stability stable
     */
    get fifoTopicInput(): boolean | cdktf.IResolvable | undefined;
    private _firehoseFailureFeedbackRoleArn?;
    /**
     * @stability stable
     */
    get firehoseFailureFeedbackRoleArn(): string;
    /**
     * @stability stable
     */
    set firehoseFailureFeedbackRoleArn(value: string);
    /**
     * @stability stable
     */
    resetFirehoseFailureFeedbackRoleArn(): void;
    /**
     * @stability stable
     */
    get firehoseFailureFeedbackRoleArnInput(): string | undefined;
    private _firehoseSuccessFeedbackRoleArn?;
    /**
     * @stability stable
     */
    get firehoseSuccessFeedbackRoleArn(): string;
    /**
     * @stability stable
     */
    set firehoseSuccessFeedbackRoleArn(value: string);
    /**
     * @stability stable
     */
    resetFirehoseSuccessFeedbackRoleArn(): void;
    /**
     * @stability stable
     */
    get firehoseSuccessFeedbackRoleArnInput(): string | undefined;
    private _firehoseSuccessFeedbackSampleRate?;
    /**
     * @stability stable
     */
    get firehoseSuccessFeedbackSampleRate(): number;
    /**
     * @stability stable
     */
    set firehoseSuccessFeedbackSampleRate(value: number);
    /**
     * @stability stable
     */
    resetFirehoseSuccessFeedbackSampleRate(): void;
    /**
     * @stability stable
     */
    get firehoseSuccessFeedbackSampleRateInput(): number | undefined;
    private _httpFailureFeedbackRoleArn?;
    /**
     * @stability stable
     */
    get httpFailureFeedbackRoleArn(): string;
    /**
     * @stability stable
     */
    set httpFailureFeedbackRoleArn(value: string);
    /**
     * @stability stable
     */
    resetHttpFailureFeedbackRoleArn(): void;
    /**
     * @stability stable
     */
    get httpFailureFeedbackRoleArnInput(): string | undefined;
    private _httpSuccessFeedbackRoleArn?;
    /**
     * @stability stable
     */
    get httpSuccessFeedbackRoleArn(): string;
    /**
     * @stability stable
     */
    set httpSuccessFeedbackRoleArn(value: string);
    /**
     * @stability stable
     */
    resetHttpSuccessFeedbackRoleArn(): void;
    /**
     * @stability stable
     */
    get httpSuccessFeedbackRoleArnInput(): string | undefined;
    private _httpSuccessFeedbackSampleRate?;
    /**
     * @stability stable
     */
    get httpSuccessFeedbackSampleRate(): number;
    /**
     * @stability stable
     */
    set httpSuccessFeedbackSampleRate(value: number);
    /**
     * @stability stable
     */
    resetHttpSuccessFeedbackSampleRate(): void;
    /**
     * @stability stable
     */
    get httpSuccessFeedbackSampleRateInput(): number | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsMasterKeyId?;
    /**
     * @stability stable
     */
    get kmsMasterKeyId(): string;
    /**
     * @stability stable
     */
    set kmsMasterKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsMasterKeyId(): void;
    /**
     * @stability stable
     */
    get kmsMasterKeyIdInput(): string | undefined;
    private _lambdaFailureFeedbackRoleArn?;
    /**
     * @stability stable
     */
    get lambdaFailureFeedbackRoleArn(): string;
    /**
     * @stability stable
     */
    set lambdaFailureFeedbackRoleArn(value: string);
    /**
     * @stability stable
     */
    resetLambdaFailureFeedbackRoleArn(): void;
    /**
     * @stability stable
     */
    get lambdaFailureFeedbackRoleArnInput(): string | undefined;
    private _lambdaSuccessFeedbackRoleArn?;
    /**
     * @stability stable
     */
    get lambdaSuccessFeedbackRoleArn(): string;
    /**
     * @stability stable
     */
    set lambdaSuccessFeedbackRoleArn(value: string);
    /**
     * @stability stable
     */
    resetLambdaSuccessFeedbackRoleArn(): void;
    /**
     * @stability stable
     */
    get lambdaSuccessFeedbackRoleArnInput(): string | undefined;
    private _lambdaSuccessFeedbackSampleRate?;
    /**
     * @stability stable
     */
    get lambdaSuccessFeedbackSampleRate(): number;
    /**
     * @stability stable
     */
    set lambdaSuccessFeedbackSampleRate(value: number);
    /**
     * @stability stable
     */
    resetLambdaSuccessFeedbackSampleRate(): void;
    /**
     * @stability stable
     */
    get lambdaSuccessFeedbackSampleRateInput(): number | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    /**
     * @stability stable
     */
    get owner(): string;
    private _policy?;
    /**
     * @stability stable
     */
    get policy(): string;
    /**
     * @stability stable
     */
    set policy(value: string);
    /**
     * @stability stable
     */
    resetPolicy(): void;
    /**
     * @stability stable
     */
    get policyInput(): string | undefined;
    private _sqsFailureFeedbackRoleArn?;
    /**
     * @stability stable
     */
    get sqsFailureFeedbackRoleArn(): string;
    /**
     * @stability stable
     */
    set sqsFailureFeedbackRoleArn(value: string);
    /**
     * @stability stable
     */
    resetSqsFailureFeedbackRoleArn(): void;
    /**
     * @stability stable
     */
    get sqsFailureFeedbackRoleArnInput(): string | undefined;
    private _sqsSuccessFeedbackRoleArn?;
    /**
     * @stability stable
     */
    get sqsSuccessFeedbackRoleArn(): string;
    /**
     * @stability stable
     */
    set sqsSuccessFeedbackRoleArn(value: string);
    /**
     * @stability stable
     */
    resetSqsSuccessFeedbackRoleArn(): void;
    /**
     * @stability stable
     */
    get sqsSuccessFeedbackRoleArnInput(): string | undefined;
    private _sqsSuccessFeedbackSampleRate?;
    /**
     * @stability stable
     */
    get sqsSuccessFeedbackSampleRate(): number;
    /**
     * @stability stable
     */
    set sqsSuccessFeedbackSampleRate(value: number);
    /**
     * @stability stable
     */
    resetSqsSuccessFeedbackSampleRate(): void;
    /**
     * @stability stable
     */
    get sqsSuccessFeedbackSampleRateInput(): number | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
