import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS SSO Admin.
 *
 * @stability stable
 */
export interface SsoadminManagedPolicyAttachmentConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_managed_policy_attachment#instance_arn SsoadminManagedPolicyAttachment#instance_arn}.
     *
     * @stability stable
     */
    readonly instanceArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_managed_policy_attachment#managed_policy_arn SsoadminManagedPolicyAttachment#managed_policy_arn}.
     *
     * @stability stable
     */
    readonly managedPolicyArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_managed_policy_attachment#permission_set_arn SsoadminManagedPolicyAttachment#permission_set_arn}.
     *
     * @stability stable
     */
    readonly permissionSetArn: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_managed_policy_attachment aws_ssoadmin_managed_policy_attachment}.
 *
 * @stability stable
 */
export declare class SsoadminManagedPolicyAttachment extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ssoadmin_managed_policy_attachment aws_ssoadmin_managed_policy_attachment} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SsoadminManagedPolicyAttachmentConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceArn?;
    /**
     * @stability stable
     */
    get instanceArn(): string;
    /**
     * @stability stable
     */
    set instanceArn(value: string);
    /**
     * @stability stable
     */
    get instanceArnInput(): string | undefined;
    private _managedPolicyArn?;
    /**
     * @stability stable
     */
    get managedPolicyArn(): string;
    /**
     * @stability stable
     */
    set managedPolicyArn(value: string);
    /**
     * @stability stable
     */
    get managedPolicyArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get managedPolicyName(): string;
    private _permissionSetArn?;
    /**
     * @stability stable
     */
    get permissionSetArn(): string;
    /**
     * @stability stable
     */
    set permissionSetArn(value: string);
    /**
     * @stability stable
     */
    get permissionSetArnInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
