import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Storage Gateway.
 *
 * @stability stable
 */
export interface StoragegatewaySmbFileShareConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#access_based_enumeration StoragegatewaySmbFileShare#access_based_enumeration}.
     *
     * @stability stable
     */
    readonly accessBasedEnumeration?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#admin_user_list StoragegatewaySmbFileShare#admin_user_list}.
     *
     * @stability stable
     */
    readonly adminUserList?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#audit_destination_arn StoragegatewaySmbFileShare#audit_destination_arn}.
     *
     * @stability stable
     */
    readonly auditDestinationArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#authentication StoragegatewaySmbFileShare#authentication}.
     *
     * @stability stable
     */
    readonly authentication?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#bucket_region StoragegatewaySmbFileShare#bucket_region}.
     *
     * @stability stable
     */
    readonly bucketRegion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#case_sensitivity StoragegatewaySmbFileShare#case_sensitivity}.
     *
     * @stability stable
     */
    readonly caseSensitivity?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#default_storage_class StoragegatewaySmbFileShare#default_storage_class}.
     *
     * @stability stable
     */
    readonly defaultStorageClass?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#file_share_name StoragegatewaySmbFileShare#file_share_name}.
     *
     * @stability stable
     */
    readonly fileShareName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#gateway_arn StoragegatewaySmbFileShare#gateway_arn}.
     *
     * @stability stable
     */
    readonly gatewayArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#guess_mime_type_enabled StoragegatewaySmbFileShare#guess_mime_type_enabled}.
     *
     * @stability stable
     */
    readonly guessMimeTypeEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#invalid_user_list StoragegatewaySmbFileShare#invalid_user_list}.
     *
     * @stability stable
     */
    readonly invalidUserList?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#kms_encrypted StoragegatewaySmbFileShare#kms_encrypted}.
     *
     * @stability stable
     */
    readonly kmsEncrypted?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#kms_key_arn StoragegatewaySmbFileShare#kms_key_arn}.
     *
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#location_arn StoragegatewaySmbFileShare#location_arn}.
     *
     * @stability stable
     */
    readonly locationArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#notification_policy StoragegatewaySmbFileShare#notification_policy}.
     *
     * @stability stable
     */
    readonly notificationPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#object_acl StoragegatewaySmbFileShare#object_acl}.
     *
     * @stability stable
     */
    readonly objectAcl?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#oplocks_enabled StoragegatewaySmbFileShare#oplocks_enabled}.
     *
     * @stability stable
     */
    readonly oplocksEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#read_only StoragegatewaySmbFileShare#read_only}.
     *
     * @stability stable
     */
    readonly readOnly?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#requester_pays StoragegatewaySmbFileShare#requester_pays}.
     *
     * @stability stable
     */
    readonly requesterPays?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#role_arn StoragegatewaySmbFileShare#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#smb_acl_enabled StoragegatewaySmbFileShare#smb_acl_enabled}.
     *
     * @stability stable
     */
    readonly smbAclEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#tags StoragegatewaySmbFileShare#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#tags_all StoragegatewaySmbFileShare#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#valid_user_list StoragegatewaySmbFileShare#valid_user_list}.
     *
     * @stability stable
     */
    readonly validUserList?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#vpc_endpoint_dns_name StoragegatewaySmbFileShare#vpc_endpoint_dns_name}.
     *
     * @stability stable
     */
    readonly vpcEndpointDnsName?: string;
    /**
     * cache_attributes block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#cache_attributes StoragegatewaySmbFileShare#cache_attributes}
     *
     * @stability stable
     */
    readonly cacheAttributes?: StoragegatewaySmbFileShareCacheAttributes;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#timeouts StoragegatewaySmbFileShare#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: StoragegatewaySmbFileShareTimeouts;
}
/**
 * @stability stable
 */
export interface StoragegatewaySmbFileShareCacheAttributes {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#cache_stale_timeout_in_seconds StoragegatewaySmbFileShare#cache_stale_timeout_in_seconds}.
     *
     * @stability stable
     */
    readonly cacheStaleTimeoutInSeconds?: number;
}
export declare function storagegatewaySmbFileShareCacheAttributesToTerraform(struct?: StoragegatewaySmbFileShareCacheAttributesOutputReference | StoragegatewaySmbFileShareCacheAttributes): any;
/**
 * @stability stable
 */
export declare class StoragegatewaySmbFileShareCacheAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): StoragegatewaySmbFileShareCacheAttributes | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: StoragegatewaySmbFileShareCacheAttributes | undefined);
    private _cacheStaleTimeoutInSeconds?;
    /**
     * @stability stable
     */
    get cacheStaleTimeoutInSeconds(): number;
    /**
     * @stability stable
     */
    set cacheStaleTimeoutInSeconds(value: number);
    /**
     * @stability stable
     */
    resetCacheStaleTimeoutInSeconds(): void;
    /**
     * @stability stable
     */
    get cacheStaleTimeoutInSecondsInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface StoragegatewaySmbFileShareTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#create StoragegatewaySmbFileShare#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#delete StoragegatewaySmbFileShare#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share#update StoragegatewaySmbFileShare#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function storagegatewaySmbFileShareTimeoutsToTerraform(struct?: StoragegatewaySmbFileShareTimeoutsOutputReference | StoragegatewaySmbFileShareTimeouts): any;
/**
 * @stability stable
 */
export declare class StoragegatewaySmbFileShareTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): StoragegatewaySmbFileShareTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: StoragegatewaySmbFileShareTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share aws_storagegateway_smb_file_share}.
 *
 * @stability stable
 */
export declare class StoragegatewaySmbFileShare extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share aws_storagegateway_smb_file_share} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: StoragegatewaySmbFileShareConfig);
    private _accessBasedEnumeration?;
    /**
     * @stability stable
     */
    get accessBasedEnumeration(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set accessBasedEnumeration(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAccessBasedEnumeration(): void;
    /**
     * @stability stable
     */
    get accessBasedEnumerationInput(): boolean | cdktf.IResolvable | undefined;
    private _adminUserList?;
    /**
     * @stability stable
     */
    get adminUserList(): string[];
    /**
     * @stability stable
     */
    set adminUserList(value: string[]);
    /**
     * @stability stable
     */
    resetAdminUserList(): void;
    /**
     * @stability stable
     */
    get adminUserListInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _auditDestinationArn?;
    /**
     * @stability stable
     */
    get auditDestinationArn(): string;
    /**
     * @stability stable
     */
    set auditDestinationArn(value: string);
    /**
     * @stability stable
     */
    resetAuditDestinationArn(): void;
    /**
     * @stability stable
     */
    get auditDestinationArnInput(): string | undefined;
    private _authentication?;
    /**
     * @stability stable
     */
    get authentication(): string;
    /**
     * @stability stable
     */
    set authentication(value: string);
    /**
     * @stability stable
     */
    resetAuthentication(): void;
    /**
     * @stability stable
     */
    get authenticationInput(): string | undefined;
    private _bucketRegion?;
    /**
     * @stability stable
     */
    get bucketRegion(): string;
    /**
     * @stability stable
     */
    set bucketRegion(value: string);
    /**
     * @stability stable
     */
    resetBucketRegion(): void;
    /**
     * @stability stable
     */
    get bucketRegionInput(): string | undefined;
    private _caseSensitivity?;
    /**
     * @stability stable
     */
    get caseSensitivity(): string;
    /**
     * @stability stable
     */
    set caseSensitivity(value: string);
    /**
     * @stability stable
     */
    resetCaseSensitivity(): void;
    /**
     * @stability stable
     */
    get caseSensitivityInput(): string | undefined;
    private _defaultStorageClass?;
    /**
     * @stability stable
     */
    get defaultStorageClass(): string;
    /**
     * @stability stable
     */
    set defaultStorageClass(value: string);
    /**
     * @stability stable
     */
    resetDefaultStorageClass(): void;
    /**
     * @stability stable
     */
    get defaultStorageClassInput(): string | undefined;
    private _fileShareName?;
    /**
     * @stability stable
     */
    get fileShareName(): string;
    /**
     * @stability stable
     */
    set fileShareName(value: string);
    /**
     * @stability stable
     */
    resetFileShareName(): void;
    /**
     * @stability stable
     */
    get fileShareNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get fileshareId(): string;
    private _gatewayArn?;
    /**
     * @stability stable
     */
    get gatewayArn(): string;
    /**
     * @stability stable
     */
    set gatewayArn(value: string);
    /**
     * @stability stable
     */
    get gatewayArnInput(): string | undefined;
    private _guessMimeTypeEnabled?;
    /**
     * @stability stable
     */
    get guessMimeTypeEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set guessMimeTypeEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetGuessMimeTypeEnabled(): void;
    /**
     * @stability stable
     */
    get guessMimeTypeEnabledInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _invalidUserList?;
    /**
     * @stability stable
     */
    get invalidUserList(): string[];
    /**
     * @stability stable
     */
    set invalidUserList(value: string[]);
    /**
     * @stability stable
     */
    resetInvalidUserList(): void;
    /**
     * @stability stable
     */
    get invalidUserListInput(): string[] | undefined;
    private _kmsEncrypted?;
    /**
     * @stability stable
     */
    get kmsEncrypted(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set kmsEncrypted(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetKmsEncrypted(): void;
    /**
     * @stability stable
     */
    get kmsEncryptedInput(): boolean | cdktf.IResolvable | undefined;
    private _kmsKeyArn?;
    /**
     * @stability stable
     */
    get kmsKeyArn(): string;
    /**
     * @stability stable
     */
    set kmsKeyArn(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyArn(): void;
    /**
     * @stability stable
     */
    get kmsKeyArnInput(): string | undefined;
    private _locationArn?;
    /**
     * @stability stable
     */
    get locationArn(): string;
    /**
     * @stability stable
     */
    set locationArn(value: string);
    /**
     * @stability stable
     */
    get locationArnInput(): string | undefined;
    private _notificationPolicy?;
    /**
     * @stability stable
     */
    get notificationPolicy(): string;
    /**
     * @stability stable
     */
    set notificationPolicy(value: string);
    /**
     * @stability stable
     */
    resetNotificationPolicy(): void;
    /**
     * @stability stable
     */
    get notificationPolicyInput(): string | undefined;
    private _objectAcl?;
    /**
     * @stability stable
     */
    get objectAcl(): string;
    /**
     * @stability stable
     */
    set objectAcl(value: string);
    /**
     * @stability stable
     */
    resetObjectAcl(): void;
    /**
     * @stability stable
     */
    get objectAclInput(): string | undefined;
    private _oplocksEnabled?;
    /**
     * @stability stable
     */
    get oplocksEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set oplocksEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetOplocksEnabled(): void;
    /**
     * @stability stable
     */
    get oplocksEnabledInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get path(): string;
    private _readOnly?;
    /**
     * @stability stable
     */
    get readOnly(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set readOnly(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetReadOnly(): void;
    /**
     * @stability stable
     */
    get readOnlyInput(): boolean | cdktf.IResolvable | undefined;
    private _requesterPays?;
    /**
     * @stability stable
     */
    get requesterPays(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set requesterPays(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetRequesterPays(): void;
    /**
     * @stability stable
     */
    get requesterPaysInput(): boolean | cdktf.IResolvable | undefined;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    private _smbAclEnabled?;
    /**
     * @stability stable
     */
    get smbAclEnabled(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set smbAclEnabled(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetSmbAclEnabled(): void;
    /**
     * @stability stable
     */
    get smbAclEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _validUserList?;
    /**
     * @stability stable
     */
    get validUserList(): string[];
    /**
     * @stability stable
     */
    set validUserList(value: string[]);
    /**
     * @stability stable
     */
    resetValidUserList(): void;
    /**
     * @stability stable
     */
    get validUserListInput(): string[] | undefined;
    private _vpcEndpointDnsName?;
    /**
     * @stability stable
     */
    get vpcEndpointDnsName(): string;
    /**
     * @stability stable
     */
    set vpcEndpointDnsName(value: string);
    /**
     * @stability stable
     */
    resetVpcEndpointDnsName(): void;
    /**
     * @stability stable
     */
    get vpcEndpointDnsNameInput(): string | undefined;
    private _cacheAttributes;
    /**
     * @stability stable
     */
    get cacheAttributes(): StoragegatewaySmbFileShareCacheAttributesOutputReference;
    /**
     * @stability stable
     */
    putCacheAttributes(value: StoragegatewaySmbFileShareCacheAttributes): void;
    /**
     * @stability stable
     */
    resetCacheAttributes(): void;
    /**
     * @stability stable
     */
    get cacheAttributesInput(): StoragegatewaySmbFileShareCacheAttributes | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): StoragegatewaySmbFileShareTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: StoragegatewaySmbFileShareTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): StoragegatewaySmbFileShareTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
