import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS Timestream Write.
 *
 * @stability stable
 */
export interface TimestreamwriteTableConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/timestreamwrite_table#database_name TimestreamwriteTable#database_name}.
     *
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/timestreamwrite_table#table_name TimestreamwriteTable#table_name}.
     *
     * @stability stable
     */
    readonly tableName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/timestreamwrite_table#tags TimestreamwriteTable#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/timestreamwrite_table#tags_all TimestreamwriteTable#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * magnetic_store_write_properties block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/timestreamwrite_table#magnetic_store_write_properties TimestreamwriteTable#magnetic_store_write_properties}
     *
     * @stability stable
     */
    readonly magneticStoreWriteProperties?: TimestreamwriteTableMagneticStoreWriteProperties;
    /**
     * retention_properties block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/timestreamwrite_table#retention_properties TimestreamwriteTable#retention_properties}
     *
     * @stability stable
     */
    readonly retentionProperties?: TimestreamwriteTableRetentionProperties;
}
/**
 * @stability stable
 */
export interface TimestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocationS3Configuration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/timestreamwrite_table#bucket_name TimestreamwriteTable#bucket_name}.
     *
     * @stability stable
     */
    readonly bucketName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/timestreamwrite_table#encryption_option TimestreamwriteTable#encryption_option}.
     *
     * @stability stable
     */
    readonly encryptionOption?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/timestreamwrite_table#kms_key_id TimestreamwriteTable#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/timestreamwrite_table#object_key_prefix TimestreamwriteTable#object_key_prefix}.
     *
     * @stability stable
     */
    readonly objectKeyPrefix?: string;
}
export declare function timestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocationS3ConfigurationToTerraform(struct?: TimestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocationS3ConfigurationOutputReference | TimestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocationS3Configuration): any;
/**
 * @stability stable
 */
export declare class TimestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocationS3ConfigurationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): TimestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocationS3Configuration | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: TimestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocationS3Configuration | undefined);
    private _bucketName?;
    /**
     * @stability stable
     */
    get bucketName(): string;
    /**
     * @stability stable
     */
    set bucketName(value: string);
    /**
     * @stability stable
     */
    resetBucketName(): void;
    /**
     * @stability stable
     */
    get bucketNameInput(): string | undefined;
    private _encryptionOption?;
    /**
     * @stability stable
     */
    get encryptionOption(): string;
    /**
     * @stability stable
     */
    set encryptionOption(value: string);
    /**
     * @stability stable
     */
    resetEncryptionOption(): void;
    /**
     * @stability stable
     */
    get encryptionOptionInput(): string | undefined;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    private _objectKeyPrefix?;
    /**
     * @stability stable
     */
    get objectKeyPrefix(): string;
    /**
     * @stability stable
     */
    set objectKeyPrefix(value: string);
    /**
     * @stability stable
     */
    resetObjectKeyPrefix(): void;
    /**
     * @stability stable
     */
    get objectKeyPrefixInput(): string | undefined;
}
/**
 * @stability stable
 */
export interface TimestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocation {
    /**
     * s3_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/timestreamwrite_table#s3_configuration TimestreamwriteTable#s3_configuration}
     *
     * @stability stable
     */
    readonly s3Configuration?: TimestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocationS3Configuration;
}
export declare function timestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocationToTerraform(struct?: TimestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocationOutputReference | TimestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocation): any;
/**
 * @stability stable
 */
export declare class TimestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): TimestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocation | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: TimestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocation | undefined);
    private _s3Configuration;
    /**
     * @stability stable
     */
    get s3Configuration(): TimestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocationS3ConfigurationOutputReference;
    /**
     * @stability stable
     */
    putS3Configuration(value: TimestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocationS3Configuration): void;
    /**
     * @stability stable
     */
    resetS3Configuration(): void;
    /**
     * @stability stable
     */
    get s3ConfigurationInput(): TimestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocationS3Configuration | undefined;
}
/**
 * @stability stable
 */
export interface TimestreamwriteTableMagneticStoreWriteProperties {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/timestreamwrite_table#enable_magnetic_store_writes TimestreamwriteTable#enable_magnetic_store_writes}.
     *
     * @stability stable
     */
    readonly enableMagneticStoreWrites?: boolean | cdktf.IResolvable;
    /**
     * magnetic_store_rejected_data_location block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/timestreamwrite_table#magnetic_store_rejected_data_location TimestreamwriteTable#magnetic_store_rejected_data_location}
     *
     * @stability stable
     */
    readonly magneticStoreRejectedDataLocation?: TimestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocation;
}
export declare function timestreamwriteTableMagneticStoreWritePropertiesToTerraform(struct?: TimestreamwriteTableMagneticStoreWritePropertiesOutputReference | TimestreamwriteTableMagneticStoreWriteProperties): any;
/**
 * @stability stable
 */
export declare class TimestreamwriteTableMagneticStoreWritePropertiesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): TimestreamwriteTableMagneticStoreWriteProperties | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: TimestreamwriteTableMagneticStoreWriteProperties | undefined);
    private _enableMagneticStoreWrites?;
    /**
     * @stability stable
     */
    get enableMagneticStoreWrites(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set enableMagneticStoreWrites(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEnableMagneticStoreWrites(): void;
    /**
     * @stability stable
     */
    get enableMagneticStoreWritesInput(): boolean | cdktf.IResolvable | undefined;
    private _magneticStoreRejectedDataLocation;
    /**
     * @stability stable
     */
    get magneticStoreRejectedDataLocation(): TimestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocationOutputReference;
    /**
     * @stability stable
     */
    putMagneticStoreRejectedDataLocation(value: TimestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocation): void;
    /**
     * @stability stable
     */
    resetMagneticStoreRejectedDataLocation(): void;
    /**
     * @stability stable
     */
    get magneticStoreRejectedDataLocationInput(): TimestreamwriteTableMagneticStoreWritePropertiesMagneticStoreRejectedDataLocation | undefined;
}
/**
 * @stability stable
 */
export interface TimestreamwriteTableRetentionProperties {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/timestreamwrite_table#magnetic_store_retention_period_in_days TimestreamwriteTable#magnetic_store_retention_period_in_days}.
     *
     * @stability stable
     */
    readonly magneticStoreRetentionPeriodInDays: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/timestreamwrite_table#memory_store_retention_period_in_hours TimestreamwriteTable#memory_store_retention_period_in_hours}.
     *
     * @stability stable
     */
    readonly memoryStoreRetentionPeriodInHours: number;
}
export declare function timestreamwriteTableRetentionPropertiesToTerraform(struct?: TimestreamwriteTableRetentionPropertiesOutputReference | TimestreamwriteTableRetentionProperties): any;
/**
 * @stability stable
 */
export declare class TimestreamwriteTableRetentionPropertiesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): TimestreamwriteTableRetentionProperties | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: TimestreamwriteTableRetentionProperties | undefined);
    private _magneticStoreRetentionPeriodInDays?;
    /**
     * @stability stable
     */
    get magneticStoreRetentionPeriodInDays(): number;
    /**
     * @stability stable
     */
    set magneticStoreRetentionPeriodInDays(value: number);
    /**
     * @stability stable
     */
    get magneticStoreRetentionPeriodInDaysInput(): number | undefined;
    private _memoryStoreRetentionPeriodInHours?;
    /**
     * @stability stable
     */
    get memoryStoreRetentionPeriodInHours(): number;
    /**
     * @stability stable
     */
    set memoryStoreRetentionPeriodInHours(value: number);
    /**
     * @stability stable
     */
    get memoryStoreRetentionPeriodInHoursInput(): number | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/timestreamwrite_table aws_timestreamwrite_table}.
 *
 * @stability stable
 */
export declare class TimestreamwriteTable extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/timestreamwrite_table aws_timestreamwrite_table} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: TimestreamwriteTableConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _databaseName?;
    /**
     * @stability stable
     */
    get databaseName(): string;
    /**
     * @stability stable
     */
    set databaseName(value: string);
    /**
     * @stability stable
     */
    get databaseNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _tableName?;
    /**
     * @stability stable
     */
    get tableName(): string;
    /**
     * @stability stable
     */
    set tableName(value: string);
    /**
     * @stability stable
     */
    get tableNameInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _magneticStoreWriteProperties;
    /**
     * @stability stable
     */
    get magneticStoreWriteProperties(): TimestreamwriteTableMagneticStoreWritePropertiesOutputReference;
    /**
     * @stability stable
     */
    putMagneticStoreWriteProperties(value: TimestreamwriteTableMagneticStoreWriteProperties): void;
    /**
     * @stability stable
     */
    resetMagneticStoreWriteProperties(): void;
    /**
     * @stability stable
     */
    get magneticStoreWritePropertiesInput(): TimestreamwriteTableMagneticStoreWriteProperties | undefined;
    private _retentionProperties;
    /**
     * @stability stable
     */
    get retentionProperties(): TimestreamwriteTableRetentionPropertiesOutputReference;
    /**
     * @stability stable
     */
    putRetentionProperties(value: TimestreamwriteTableRetentionProperties): void;
    /**
     * @stability stable
     */
    resetRetentionProperties(): void;
    /**
     * @stability stable
     */
    get retentionPropertiesInput(): TimestreamwriteTableRetentionProperties | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
