import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS VPC.
 *
 * @stability stable
 */
export interface DataAwsVpcPeeringConnectionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/vpc_peering_connection#cidr_block DataAwsVpcPeeringConnection#cidr_block}.
     *
     * @stability stable
     */
    readonly cidrBlock?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/vpc_peering_connection#owner_id DataAwsVpcPeeringConnection#owner_id}.
     *
     * @stability stable
     */
    readonly ownerId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/vpc_peering_connection#peer_cidr_block DataAwsVpcPeeringConnection#peer_cidr_block}.
     *
     * @stability stable
     */
    readonly peerCidrBlock?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/vpc_peering_connection#peer_owner_id DataAwsVpcPeeringConnection#peer_owner_id}.
     *
     * @stability stable
     */
    readonly peerOwnerId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/vpc_peering_connection#peer_region DataAwsVpcPeeringConnection#peer_region}.
     *
     * @stability stable
     */
    readonly peerRegion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/vpc_peering_connection#peer_vpc_id DataAwsVpcPeeringConnection#peer_vpc_id}.
     *
     * @stability stable
     */
    readonly peerVpcId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/vpc_peering_connection#region DataAwsVpcPeeringConnection#region}.
     *
     * @stability stable
     */
    readonly region?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/vpc_peering_connection#status DataAwsVpcPeeringConnection#status}.
     *
     * @stability stable
     */
    readonly status?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/vpc_peering_connection#tags DataAwsVpcPeeringConnection#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/vpc_peering_connection#vpc_id DataAwsVpcPeeringConnection#vpc_id}.
     *
     * @stability stable
     */
    readonly vpcId?: string;
    /**
     * filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/vpc_peering_connection#filter DataAwsVpcPeeringConnection#filter}
     *
     * @stability stable
     */
    readonly filter?: DataAwsVpcPeeringConnectionFilter[];
}
/**
 * @stability stable
 */
export declare class DataAwsVpcPeeringConnectionCidrBlockSet extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get cidrBlock(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsVpcPeeringConnectionPeerCidrBlockSet extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get cidrBlock(): string;
}
/**
 * @stability stable
 */
export interface DataAwsVpcPeeringConnectionFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/vpc_peering_connection#name DataAwsVpcPeeringConnection#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/vpc_peering_connection#values DataAwsVpcPeeringConnection#values}.
     *
     * @stability stable
     */
    readonly values: string[];
}
export declare function dataAwsVpcPeeringConnectionFilterToTerraform(struct?: DataAwsVpcPeeringConnectionFilter): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/vpc_peering_connection aws_vpc_peering_connection}.
 *
 * @stability stable
 */
export declare class DataAwsVpcPeeringConnection extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/vpc_peering_connection aws_vpc_peering_connection} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsVpcPeeringConnectionConfig);
    /**
     * @stability stable
     */
    accepter(key: string): boolean;
    private _cidrBlock?;
    /**
     * @stability stable
     */
    get cidrBlock(): string;
    /**
     * @stability stable
     */
    set cidrBlock(value: string);
    /**
     * @stability stable
     */
    resetCidrBlock(): void;
    /**
     * @stability stable
     */
    get cidrBlockInput(): string | undefined;
    /**
     * @stability stable
     */
    cidrBlockSet(index: string): DataAwsVpcPeeringConnectionCidrBlockSet;
    /**
     * @stability stable
     */
    get id(): string;
    private _ownerId?;
    /**
     * @stability stable
     */
    get ownerId(): string;
    /**
     * @stability stable
     */
    set ownerId(value: string);
    /**
     * @stability stable
     */
    resetOwnerId(): void;
    /**
     * @stability stable
     */
    get ownerIdInput(): string | undefined;
    private _peerCidrBlock?;
    /**
     * @stability stable
     */
    get peerCidrBlock(): string;
    /**
     * @stability stable
     */
    set peerCidrBlock(value: string);
    /**
     * @stability stable
     */
    resetPeerCidrBlock(): void;
    /**
     * @stability stable
     */
    get peerCidrBlockInput(): string | undefined;
    /**
     * @stability stable
     */
    peerCidrBlockSet(index: string): DataAwsVpcPeeringConnectionPeerCidrBlockSet;
    private _peerOwnerId?;
    /**
     * @stability stable
     */
    get peerOwnerId(): string;
    /**
     * @stability stable
     */
    set peerOwnerId(value: string);
    /**
     * @stability stable
     */
    resetPeerOwnerId(): void;
    /**
     * @stability stable
     */
    get peerOwnerIdInput(): string | undefined;
    private _peerRegion?;
    /**
     * @stability stable
     */
    get peerRegion(): string;
    /**
     * @stability stable
     */
    set peerRegion(value: string);
    /**
     * @stability stable
     */
    resetPeerRegion(): void;
    /**
     * @stability stable
     */
    get peerRegionInput(): string | undefined;
    private _peerVpcId?;
    /**
     * @stability stable
     */
    get peerVpcId(): string;
    /**
     * @stability stable
     */
    set peerVpcId(value: string);
    /**
     * @stability stable
     */
    resetPeerVpcId(): void;
    /**
     * @stability stable
     */
    get peerVpcIdInput(): string | undefined;
    private _region?;
    /**
     * @stability stable
     */
    get region(): string;
    /**
     * @stability stable
     */
    set region(value: string);
    /**
     * @stability stable
     */
    resetRegion(): void;
    /**
     * @stability stable
     */
    get regionInput(): string | undefined;
    /**
     * @stability stable
     */
    requester(key: string): boolean;
    private _status?;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    set status(value: string);
    /**
     * @stability stable
     */
    resetStatus(): void;
    /**
     * @stability stable
     */
    get statusInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _vpcId?;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    resetVpcId(): void;
    /**
     * @stability stable
     */
    get vpcIdInput(): string | undefined;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsVpcPeeringConnectionFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsVpcPeeringConnectionFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsVpcPeeringConnectionFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
