import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS VPC.
 *
 * @stability stable
 */
export interface NetworkAclRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/network_acl_rule#cidr_block NetworkAclRule#cidr_block}.
     *
     * @stability stable
     */
    readonly cidrBlock?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/network_acl_rule#egress NetworkAclRule#egress}.
     *
     * @stability stable
     */
    readonly egress?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/network_acl_rule#from_port NetworkAclRule#from_port}.
     *
     * @stability stable
     */
    readonly fromPort?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/network_acl_rule#icmp_code NetworkAclRule#icmp_code}.
     *
     * @stability stable
     */
    readonly icmpCode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/network_acl_rule#icmp_type NetworkAclRule#icmp_type}.
     *
     * @stability stable
     */
    readonly icmpType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/network_acl_rule#ipv6_cidr_block NetworkAclRule#ipv6_cidr_block}.
     *
     * @stability stable
     */
    readonly ipv6CidrBlock?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/network_acl_rule#network_acl_id NetworkAclRule#network_acl_id}.
     *
     * @stability stable
     */
    readonly networkAclId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/network_acl_rule#protocol NetworkAclRule#protocol}.
     *
     * @stability stable
     */
    readonly protocol: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/network_acl_rule#rule_action NetworkAclRule#rule_action}.
     *
     * @stability stable
     */
    readonly ruleAction: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/network_acl_rule#rule_number NetworkAclRule#rule_number}.
     *
     * @stability stable
     */
    readonly ruleNumber: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/network_acl_rule#to_port NetworkAclRule#to_port}.
     *
     * @stability stable
     */
    readonly toPort?: number;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/network_acl_rule aws_network_acl_rule}.
 *
 * @stability stable
 */
export declare class NetworkAclRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/network_acl_rule aws_network_acl_rule} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: NetworkAclRuleConfig);
    private _cidrBlock?;
    /**
     * @stability stable
     */
    get cidrBlock(): string;
    /**
     * @stability stable
     */
    set cidrBlock(value: string);
    /**
     * @stability stable
     */
    resetCidrBlock(): void;
    /**
     * @stability stable
     */
    get cidrBlockInput(): string | undefined;
    private _egress?;
    /**
     * @stability stable
     */
    get egress(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set egress(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetEgress(): void;
    /**
     * @stability stable
     */
    get egressInput(): boolean | cdktf.IResolvable | undefined;
    private _fromPort?;
    /**
     * @stability stable
     */
    get fromPort(): number;
    /**
     * @stability stable
     */
    set fromPort(value: number);
    /**
     * @stability stable
     */
    resetFromPort(): void;
    /**
     * @stability stable
     */
    get fromPortInput(): number | undefined;
    private _icmpCode?;
    /**
     * @stability stable
     */
    get icmpCode(): string;
    /**
     * @stability stable
     */
    set icmpCode(value: string);
    /**
     * @stability stable
     */
    resetIcmpCode(): void;
    /**
     * @stability stable
     */
    get icmpCodeInput(): string | undefined;
    private _icmpType?;
    /**
     * @stability stable
     */
    get icmpType(): string;
    /**
     * @stability stable
     */
    set icmpType(value: string);
    /**
     * @stability stable
     */
    resetIcmpType(): void;
    /**
     * @stability stable
     */
    get icmpTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _ipv6CidrBlock?;
    /**
     * @stability stable
     */
    get ipv6CidrBlock(): string;
    /**
     * @stability stable
     */
    set ipv6CidrBlock(value: string);
    /**
     * @stability stable
     */
    resetIpv6CidrBlock(): void;
    /**
     * @stability stable
     */
    get ipv6CidrBlockInput(): string | undefined;
    private _networkAclId?;
    /**
     * @stability stable
     */
    get networkAclId(): string;
    /**
     * @stability stable
     */
    set networkAclId(value: string);
    /**
     * @stability stable
     */
    get networkAclIdInput(): string | undefined;
    private _protocol?;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    set protocol(value: string);
    /**
     * @stability stable
     */
    get protocolInput(): string | undefined;
    private _ruleAction?;
    /**
     * @stability stable
     */
    get ruleAction(): string;
    /**
     * @stability stable
     */
    set ruleAction(value: string);
    /**
     * @stability stable
     */
    get ruleActionInput(): string | undefined;
    private _ruleNumber?;
    /**
     * @stability stable
     */
    get ruleNumber(): number;
    /**
     * @stability stable
     */
    set ruleNumber(value: number);
    /**
     * @stability stable
     */
    get ruleNumberInput(): number | undefined;
    private _toPort?;
    /**
     * @stability stable
     */
    get toPort(): number;
    /**
     * @stability stable
     */
    set toPort(value: number);
    /**
     * @stability stable
     */
    resetToPort(): void;
    /**
     * @stability stable
     */
    get toPortInput(): number | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
