import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS VPC.
 *
 * @stability stable
 */
export interface VpcDhcpOptionsConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_dhcp_options#domain_name VpcDhcpOptions#domain_name}.
     *
     * @stability stable
     */
    readonly domainName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_dhcp_options#domain_name_servers VpcDhcpOptions#domain_name_servers}.
     *
     * @stability stable
     */
    readonly domainNameServers?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_dhcp_options#netbios_name_servers VpcDhcpOptions#netbios_name_servers}.
     *
     * @stability stable
     */
    readonly netbiosNameServers?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_dhcp_options#netbios_node_type VpcDhcpOptions#netbios_node_type}.
     *
     * @stability stable
     */
    readonly netbiosNodeType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_dhcp_options#ntp_servers VpcDhcpOptions#ntp_servers}.
     *
     * @stability stable
     */
    readonly ntpServers?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_dhcp_options#tags VpcDhcpOptions#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_dhcp_options#tags_all VpcDhcpOptions#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/vpc_dhcp_options aws_vpc_dhcp_options}.
 *
 * @stability stable
 */
export declare class VpcDhcpOptions extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/vpc_dhcp_options aws_vpc_dhcp_options} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: VpcDhcpOptionsConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _domainName?;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    resetDomainName(): void;
    /**
     * @stability stable
     */
    get domainNameInput(): string | undefined;
    private _domainNameServers?;
    /**
     * @stability stable
     */
    get domainNameServers(): string[];
    /**
     * @stability stable
     */
    set domainNameServers(value: string[]);
    /**
     * @stability stable
     */
    resetDomainNameServers(): void;
    /**
     * @stability stable
     */
    get domainNameServersInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _netbiosNameServers?;
    /**
     * @stability stable
     */
    get netbiosNameServers(): string[];
    /**
     * @stability stable
     */
    set netbiosNameServers(value: string[]);
    /**
     * @stability stable
     */
    resetNetbiosNameServers(): void;
    /**
     * @stability stable
     */
    get netbiosNameServersInput(): string[] | undefined;
    private _netbiosNodeType?;
    /**
     * @stability stable
     */
    get netbiosNodeType(): string;
    /**
     * @stability stable
     */
    set netbiosNodeType(value: string);
    /**
     * @stability stable
     */
    resetNetbiosNodeType(): void;
    /**
     * @stability stable
     */
    get netbiosNodeTypeInput(): string | undefined;
    private _ntpServers?;
    /**
     * @stability stable
     */
    get ntpServers(): string[];
    /**
     * @stability stable
     */
    set ntpServers(value: string[]);
    /**
     * @stability stable
     */
    resetNtpServers(): void;
    /**
     * @stability stable
     */
    get ntpServersInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
