import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS VPC.
 *
 * @stability stable
 */
export interface VpcEndpointConnectionAccepterConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_endpoint_connection_accepter#vpc_endpoint_id VpcEndpointConnectionAccepter#vpc_endpoint_id}.
     *
     * @stability stable
     */
    readonly vpcEndpointId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_endpoint_connection_accepter#vpc_endpoint_service_id VpcEndpointConnectionAccepter#vpc_endpoint_service_id}.
     *
     * @stability stable
     */
    readonly vpcEndpointServiceId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/vpc_endpoint_connection_accepter aws_vpc_endpoint_connection_accepter}.
 *
 * @stability stable
 */
export declare class VpcEndpointConnectionAccepter extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/vpc_endpoint_connection_accepter aws_vpc_endpoint_connection_accepter} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VpcEndpointConnectionAccepterConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _vpcEndpointId?;
    /**
     * @stability stable
     */
    get vpcEndpointId(): string;
    /**
     * @stability stable
     */
    set vpcEndpointId(value: string);
    /**
     * @stability stable
     */
    get vpcEndpointIdInput(): string | undefined;
    private _vpcEndpointServiceId?;
    /**
     * @stability stable
     */
    get vpcEndpointServiceId(): string;
    /**
     * @stability stable
     */
    set vpcEndpointServiceId(value: string);
    /**
     * @stability stable
     */
    get vpcEndpointServiceIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get vpcEndpointState(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
