import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS VPC.
 *
 * @stability stable
 */
export interface VpcIpamPoolConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_pool#address_family VpcIpamPool#address_family}.
     *
     * @stability stable
     */
    readonly addressFamily: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_pool#allocation_default_netmask_length VpcIpamPool#allocation_default_netmask_length}.
     *
     * @stability stable
     */
    readonly allocationDefaultNetmaskLength?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_pool#allocation_max_netmask_length VpcIpamPool#allocation_max_netmask_length}.
     *
     * @stability stable
     */
    readonly allocationMaxNetmaskLength?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_pool#allocation_min_netmask_length VpcIpamPool#allocation_min_netmask_length}.
     *
     * @stability stable
     */
    readonly allocationMinNetmaskLength?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_pool#allocation_resource_tags VpcIpamPool#allocation_resource_tags}.
     *
     * @stability stable
     */
    readonly allocationResourceTags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_pool#auto_import VpcIpamPool#auto_import}.
     *
     * @stability stable
     */
    readonly autoImport?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_pool#aws_service VpcIpamPool#aws_service}.
     *
     * @stability stable
     */
    readonly awsService?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_pool#description VpcIpamPool#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_pool#ipam_scope_id VpcIpamPool#ipam_scope_id}.
     *
     * @stability stable
     */
    readonly ipamScopeId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_pool#locale VpcIpamPool#locale}.
     *
     * @stability stable
     */
    readonly locale?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_pool#publicly_advertisable VpcIpamPool#publicly_advertisable}.
     *
     * @stability stable
     */
    readonly publiclyAdvertisable?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_pool#source_ipam_pool_id VpcIpamPool#source_ipam_pool_id}.
     *
     * @stability stable
     */
    readonly sourceIpamPoolId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_pool#tags VpcIpamPool#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_pool#tags_all VpcIpamPool#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_pool aws_vpc_ipam_pool}.
 *
 * @stability stable
 */
export declare class VpcIpamPool extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_pool aws_vpc_ipam_pool} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VpcIpamPoolConfig);
    private _addressFamily?;
    /**
     * @stability stable
     */
    get addressFamily(): string;
    /**
     * @stability stable
     */
    set addressFamily(value: string);
    /**
     * @stability stable
     */
    get addressFamilyInput(): string | undefined;
    private _allocationDefaultNetmaskLength?;
    /**
     * @stability stable
     */
    get allocationDefaultNetmaskLength(): number;
    /**
     * @stability stable
     */
    set allocationDefaultNetmaskLength(value: number);
    /**
     * @stability stable
     */
    resetAllocationDefaultNetmaskLength(): void;
    /**
     * @stability stable
     */
    get allocationDefaultNetmaskLengthInput(): number | undefined;
    private _allocationMaxNetmaskLength?;
    /**
     * @stability stable
     */
    get allocationMaxNetmaskLength(): number;
    /**
     * @stability stable
     */
    set allocationMaxNetmaskLength(value: number);
    /**
     * @stability stable
     */
    resetAllocationMaxNetmaskLength(): void;
    /**
     * @stability stable
     */
    get allocationMaxNetmaskLengthInput(): number | undefined;
    private _allocationMinNetmaskLength?;
    /**
     * @stability stable
     */
    get allocationMinNetmaskLength(): number;
    /**
     * @stability stable
     */
    set allocationMinNetmaskLength(value: number);
    /**
     * @stability stable
     */
    resetAllocationMinNetmaskLength(): void;
    /**
     * @stability stable
     */
    get allocationMinNetmaskLengthInput(): number | undefined;
    private _allocationResourceTags?;
    /**
     * @stability stable
     */
    get allocationResourceTags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set allocationResourceTags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAllocationResourceTags(): void;
    /**
     * @stability stable
     */
    get allocationResourceTagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoImport?;
    /**
     * @stability stable
     */
    get autoImport(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set autoImport(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAutoImport(): void;
    /**
     * @stability stable
     */
    get autoImportInput(): boolean | cdktf.IResolvable | undefined;
    private _awsService?;
    /**
     * @stability stable
     */
    get awsService(): string;
    /**
     * @stability stable
     */
    set awsService(value: string);
    /**
     * @stability stable
     */
    resetAwsService(): void;
    /**
     * @stability stable
     */
    get awsServiceInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _ipamScopeId?;
    /**
     * @stability stable
     */
    get ipamScopeId(): string;
    /**
     * @stability stable
     */
    set ipamScopeId(value: string);
    /**
     * @stability stable
     */
    get ipamScopeIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get ipamScopeType(): string;
    private _locale?;
    /**
     * @stability stable
     */
    get locale(): string;
    /**
     * @stability stable
     */
    set locale(value: string);
    /**
     * @stability stable
     */
    resetLocale(): void;
    /**
     * @stability stable
     */
    get localeInput(): string | undefined;
    /**
     * @stability stable
     */
    get poolDepth(): number;
    private _publiclyAdvertisable?;
    /**
     * @stability stable
     */
    get publiclyAdvertisable(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set publiclyAdvertisable(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetPubliclyAdvertisable(): void;
    /**
     * @stability stable
     */
    get publiclyAdvertisableInput(): boolean | cdktf.IResolvable | undefined;
    private _sourceIpamPoolId?;
    /**
     * @stability stable
     */
    get sourceIpamPoolId(): string;
    /**
     * @stability stable
     */
    set sourceIpamPoolId(value: string);
    /**
     * @stability stable
     */
    resetSourceIpamPoolId(): void;
    /**
     * @stability stable
     */
    get sourceIpamPoolIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get state(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
