import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS VPC.
 *
 * @stability stable
 */
export interface VpcIpamPreviewNextCidrConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_preview_next_cidr#disallowed_cidrs VpcIpamPreviewNextCidr#disallowed_cidrs}.
     *
     * @stability stable
     */
    readonly disallowedCidrs?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_preview_next_cidr#ipam_pool_id VpcIpamPreviewNextCidr#ipam_pool_id}.
     *
     * @stability stable
     */
    readonly ipamPoolId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_preview_next_cidr#netmask_length VpcIpamPreviewNextCidr#netmask_length}.
     *
     * @stability stable
     */
    readonly netmaskLength?: number;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_preview_next_cidr aws_vpc_ipam_preview_next_cidr}.
 *
 * @stability stable
 */
export declare class VpcIpamPreviewNextCidr extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/vpc_ipam_preview_next_cidr aws_vpc_ipam_preview_next_cidr} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VpcIpamPreviewNextCidrConfig);
    /**
     * @stability stable
     */
    get cidr(): string;
    private _disallowedCidrs?;
    /**
     * @stability stable
     */
    get disallowedCidrs(): string[];
    /**
     * @stability stable
     */
    set disallowedCidrs(value: string[]);
    /**
     * @stability stable
     */
    resetDisallowedCidrs(): void;
    /**
     * @stability stable
     */
    get disallowedCidrsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _ipamPoolId?;
    /**
     * @stability stable
     */
    get ipamPoolId(): string;
    /**
     * @stability stable
     */
    set ipamPoolId(value: string);
    /**
     * @stability stable
     */
    get ipamPoolIdInput(): string | undefined;
    private _netmaskLength?;
    /**
     * @stability stable
     */
    get netmaskLength(): number;
    /**
     * @stability stable
     */
    set netmaskLength(value: number);
    /**
     * @stability stable
     */
    resetNetmaskLength(): void;
    /**
     * @stability stable
     */
    get netmaskLengthInput(): number | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
