import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS VPC.
 *
 * @stability stable
 */
export interface VpcPeeringConnectionConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection#auto_accept VpcPeeringConnection#auto_accept}.
     *
     * @stability stable
     */
    readonly autoAccept?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection#peer_owner_id VpcPeeringConnection#peer_owner_id}.
     *
     * @stability stable
     */
    readonly peerOwnerId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection#peer_region VpcPeeringConnection#peer_region}.
     *
     * @stability stable
     */
    readonly peerRegion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection#peer_vpc_id VpcPeeringConnection#peer_vpc_id}.
     *
     * @stability stable
     */
    readonly peerVpcId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection#tags VpcPeeringConnection#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection#tags_all VpcPeeringConnection#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection#vpc_id VpcPeeringConnection#vpc_id}.
     *
     * @stability stable
     */
    readonly vpcId: string;
    /**
     * accepter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection#accepter VpcPeeringConnection#accepter}
     *
     * @stability stable
     */
    readonly accepter?: VpcPeeringConnectionAccepter;
    /**
     * requester block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection#requester VpcPeeringConnection#requester}
     *
     * @stability stable
     */
    readonly requester?: VpcPeeringConnectionRequester;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection#timeouts VpcPeeringConnection#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: VpcPeeringConnectionTimeouts;
}
/**
 * @stability stable
 */
export interface VpcPeeringConnectionAccepter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection#allow_classic_link_to_remote_vpc VpcPeeringConnection#allow_classic_link_to_remote_vpc}.
     *
     * @stability stable
     */
    readonly allowClassicLinkToRemoteVpc?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection#allow_remote_vpc_dns_resolution VpcPeeringConnection#allow_remote_vpc_dns_resolution}.
     *
     * @stability stable
     */
    readonly allowRemoteVpcDnsResolution?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection#allow_vpc_to_remote_classic_link VpcPeeringConnection#allow_vpc_to_remote_classic_link}.
     *
     * @stability stable
     */
    readonly allowVpcToRemoteClassicLink?: boolean | cdktf.IResolvable;
}
export declare function vpcPeeringConnectionAccepterToTerraform(struct?: VpcPeeringConnectionAccepterOutputReference | VpcPeeringConnectionAccepter): any;
/**
 * @stability stable
 */
export declare class VpcPeeringConnectionAccepterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): VpcPeeringConnectionAccepter | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: VpcPeeringConnectionAccepter | undefined);
    private _allowClassicLinkToRemoteVpc?;
    /**
     * @stability stable
     */
    get allowClassicLinkToRemoteVpc(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set allowClassicLinkToRemoteVpc(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAllowClassicLinkToRemoteVpc(): void;
    /**
     * @stability stable
     */
    get allowClassicLinkToRemoteVpcInput(): boolean | cdktf.IResolvable | undefined;
    private _allowRemoteVpcDnsResolution?;
    /**
     * @stability stable
     */
    get allowRemoteVpcDnsResolution(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set allowRemoteVpcDnsResolution(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAllowRemoteVpcDnsResolution(): void;
    /**
     * @stability stable
     */
    get allowRemoteVpcDnsResolutionInput(): boolean | cdktf.IResolvable | undefined;
    private _allowVpcToRemoteClassicLink?;
    /**
     * @stability stable
     */
    get allowVpcToRemoteClassicLink(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set allowVpcToRemoteClassicLink(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAllowVpcToRemoteClassicLink(): void;
    /**
     * @stability stable
     */
    get allowVpcToRemoteClassicLinkInput(): boolean | cdktf.IResolvable | undefined;
}
/**
 * @stability stable
 */
export interface VpcPeeringConnectionRequester {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection#allow_classic_link_to_remote_vpc VpcPeeringConnection#allow_classic_link_to_remote_vpc}.
     *
     * @stability stable
     */
    readonly allowClassicLinkToRemoteVpc?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection#allow_remote_vpc_dns_resolution VpcPeeringConnection#allow_remote_vpc_dns_resolution}.
     *
     * @stability stable
     */
    readonly allowRemoteVpcDnsResolution?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection#allow_vpc_to_remote_classic_link VpcPeeringConnection#allow_vpc_to_remote_classic_link}.
     *
     * @stability stable
     */
    readonly allowVpcToRemoteClassicLink?: boolean | cdktf.IResolvable;
}
export declare function vpcPeeringConnectionRequesterToTerraform(struct?: VpcPeeringConnectionRequesterOutputReference | VpcPeeringConnectionRequester): any;
/**
 * @stability stable
 */
export declare class VpcPeeringConnectionRequesterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): VpcPeeringConnectionRequester | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: VpcPeeringConnectionRequester | undefined);
    private _allowClassicLinkToRemoteVpc?;
    /**
     * @stability stable
     */
    get allowClassicLinkToRemoteVpc(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set allowClassicLinkToRemoteVpc(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAllowClassicLinkToRemoteVpc(): void;
    /**
     * @stability stable
     */
    get allowClassicLinkToRemoteVpcInput(): boolean | cdktf.IResolvable | undefined;
    private _allowRemoteVpcDnsResolution?;
    /**
     * @stability stable
     */
    get allowRemoteVpcDnsResolution(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set allowRemoteVpcDnsResolution(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAllowRemoteVpcDnsResolution(): void;
    /**
     * @stability stable
     */
    get allowRemoteVpcDnsResolutionInput(): boolean | cdktf.IResolvable | undefined;
    private _allowVpcToRemoteClassicLink?;
    /**
     * @stability stable
     */
    get allowVpcToRemoteClassicLink(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set allowVpcToRemoteClassicLink(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAllowVpcToRemoteClassicLink(): void;
    /**
     * @stability stable
     */
    get allowVpcToRemoteClassicLinkInput(): boolean | cdktf.IResolvable | undefined;
}
/**
 * @stability stable
 */
export interface VpcPeeringConnectionTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection#create VpcPeeringConnection#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection#delete VpcPeeringConnection#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection#update VpcPeeringConnection#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function vpcPeeringConnectionTimeoutsToTerraform(struct?: VpcPeeringConnectionTimeoutsOutputReference | VpcPeeringConnectionTimeouts): any;
/**
 * @stability stable
 */
export declare class VpcPeeringConnectionTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.ITerraformResource, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): VpcPeeringConnectionTimeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: VpcPeeringConnectionTimeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection aws_vpc_peering_connection}.
 *
 * @stability stable
 */
export declare class VpcPeeringConnection extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/vpc_peering_connection aws_vpc_peering_connection} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VpcPeeringConnectionConfig);
    /**
     * @stability stable
     */
    get acceptStatus(): string;
    private _autoAccept?;
    /**
     * @stability stable
     */
    get autoAccept(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set autoAccept(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetAutoAccept(): void;
    /**
     * @stability stable
     */
    get autoAcceptInput(): boolean | cdktf.IResolvable | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _peerOwnerId?;
    /**
     * @stability stable
     */
    get peerOwnerId(): string;
    /**
     * @stability stable
     */
    set peerOwnerId(value: string);
    /**
     * @stability stable
     */
    resetPeerOwnerId(): void;
    /**
     * @stability stable
     */
    get peerOwnerIdInput(): string | undefined;
    private _peerRegion?;
    /**
     * @stability stable
     */
    get peerRegion(): string;
    /**
     * @stability stable
     */
    set peerRegion(value: string);
    /**
     * @stability stable
     */
    resetPeerRegion(): void;
    /**
     * @stability stable
     */
    get peerRegionInput(): string | undefined;
    private _peerVpcId?;
    /**
     * @stability stable
     */
    get peerVpcId(): string;
    /**
     * @stability stable
     */
    set peerVpcId(value: string);
    /**
     * @stability stable
     */
    get peerVpcIdInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    } | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    } | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): cdktf.IResolvable | {
        [key: string]: string;
    } | undefined;
    private _vpcId?;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    get vpcIdInput(): string | undefined;
    private _accepter;
    /**
     * @stability stable
     */
    get accepter(): VpcPeeringConnectionAccepterOutputReference;
    /**
     * @stability stable
     */
    putAccepter(value: VpcPeeringConnectionAccepter): void;
    /**
     * @stability stable
     */
    resetAccepter(): void;
    /**
     * @stability stable
     */
    get accepterInput(): VpcPeeringConnectionAccepter | undefined;
    private _requester;
    /**
     * @stability stable
     */
    get requester(): VpcPeeringConnectionRequesterOutputReference;
    /**
     * @stability stable
     */
    putRequester(value: VpcPeeringConnectionRequester): void;
    /**
     * @stability stable
     */
    resetRequester(): void;
    /**
     * @stability stable
     */
    get requesterInput(): VpcPeeringConnectionRequester | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): VpcPeeringConnectionTimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: VpcPeeringConnectionTimeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): VpcPeeringConnectionTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
