import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS WAF.
 *
 * @stability stable
 */
export interface WafGeoMatchSetConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/waf_geo_match_set#name WafGeoMatchSet#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * geo_match_constraint block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/waf_geo_match_set#geo_match_constraint WafGeoMatchSet#geo_match_constraint}
     *
     * @stability stable
     */
    readonly geoMatchConstraint?: WafGeoMatchSetGeoMatchConstraint[];
}
/**
 * @stability stable
 */
export interface WafGeoMatchSetGeoMatchConstraint {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/waf_geo_match_set#type WafGeoMatchSet#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/waf_geo_match_set#value WafGeoMatchSet#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function wafGeoMatchSetGeoMatchConstraintToTerraform(struct?: WafGeoMatchSetGeoMatchConstraint): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/waf_geo_match_set aws_waf_geo_match_set}.
 *
 * @stability stable
 */
export declare class WafGeoMatchSet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/waf_geo_match_set aws_waf_geo_match_set} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WafGeoMatchSetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _geoMatchConstraint?;
    /**
     * @stability stable
     */
    get geoMatchConstraint(): WafGeoMatchSetGeoMatchConstraint[];
    /**
     * @stability stable
     */
    set geoMatchConstraint(value: WafGeoMatchSetGeoMatchConstraint[]);
    /**
     * @stability stable
     */
    resetGeoMatchConstraint(): void;
    /**
     * @stability stable
     */
    get geoMatchConstraintInput(): WafGeoMatchSetGeoMatchConstraint[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
