import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * AWS WAF.
 *
 * @stability stable
 */
export interface WafIpsetConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/waf_ipset#name WafIpset#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * ip_set_descriptors block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/waf_ipset#ip_set_descriptors WafIpset#ip_set_descriptors}
     *
     * @stability stable
     */
    readonly ipSetDescriptors?: WafIpsetIpSetDescriptors[];
}
/**
 * @stability stable
 */
export interface WafIpsetIpSetDescriptors {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/waf_ipset#type WafIpset#type}.
     *
     * @stability stable
     */
    readonly type: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/waf_ipset#value WafIpset#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
export declare function wafIpsetIpSetDescriptorsToTerraform(struct?: WafIpsetIpSetDescriptors): any;
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/waf_ipset aws_waf_ipset}.
 *
 * @stability stable
 */
export declare class WafIpset extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/waf_ipset aws_waf_ipset} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WafIpsetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _ipSetDescriptors?;
    /**
     * @stability stable
     */
    get ipSetDescriptors(): WafIpsetIpSetDescriptors[];
    /**
     * @stability stable
     */
    set ipSetDescriptors(value: WafIpsetIpSetDescriptors[]);
    /**
     * @stability stable
     */
    resetIpSetDescriptors(): void;
    /**
     * @stability stable
     */
    get ipSetDescriptorsInput(): WafIpsetIpSetDescriptors[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
